/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Y=function($){for(var t=[],m=0,O=$.length;m<O;m++)t[m]=J[$[m]];return t};define(J[57],Y([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(O,I){if(!O)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=m}),define(J[44],Y([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function m(T){return(C,f,g)=>{let w=null,E=null;if(typeof g.value=="function"?(w="value",E=g.value):typeof g.get=="function"&&(w="get",E=g.get),!E)throw new Error("not supported");g[w]=T(E,f)}}t.createDecorator=m;function O(T,C,f){let g=null,w=null;if(typeof f.value=="function"?(g="value",w=f.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(g="get",w=f.get),!w)throw new Error("not supported");const E=`$memoize$${C}`;f[g]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,b)}),this[E]}}t.memoize=O;function I(T,C,f){return m((g,w)=>{const E=`$debounce$${w}`,b=`$debounce$result$${w}`;return function(...A){this[b]||(this[b]=f?f():void 0),clearTimeout(this[E]),C&&(this[b]=C(this[b],...A),A=[this[b]]),this[E]=setTimeout(()=>{g.apply(this,A),this[b]=f?f():void 0},T)}})}t.debounce=I;function R(T,C,f){return m((g,w)=>{const E=`$throttle$timer$${w}`,b=`$throttle$result$${w}`,A=`$throttle$lastRun$${w}`,c=`$throttle$pending$${w}`;return function(...h){if(this[b]||(this[b]=f?f():void 0),(this[A]===null||this[A]===void 0)&&(this[A]=-Number.MAX_VALUE),C&&(this[b]=C(this[b],...h)),this[c])return;const S=this[A]+T;S<=Date.now()?(this[A]=Date.now(),g.apply(this,[this[b]]),this[b]=f?f():void 0):(this[c]=!0,this[E]=setTimeout(()=>{this[c]=!1,this[A]=Date.now(),g.apply(this,[this[b]]),this[b]=f?f():void 0},S-Date.now()))}})}t.throttle=R}),define(J[22],Y([0,1,12]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function O(U,l=0){return U[U.length-(1+l)]}t.tail=O;function I(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.tail2=I;function R(U,l,a=(d,y)=>d===y){if(U===l)return!0;if(!U||!l||U.length!==l.length)return!1;for(let d=0,y=U.length;d<y;d++)if(!a(U[d],l[d]))return!1;return!0}t.equals=R;function T(U,l,a){let d=0,y=U.length-1;for(;d<=y;){const k=(d+y)/2|0,N=a(U[k],l);if(N<0)d=k+1;else if(N>0)y=k-1;else return k}return-(d+1)}t.binarySearch=T;function C(U,l){let a=0,d=U.length;if(d===0)return 0;for(;a<d;){const y=Math.floor((a+d)/2);l(U[y])?d=y:a=y+1}return a}t.findFirstInSorted=C;function f(U,l,a){if(U=U|0,U>=l.length)throw new TypeError("invalid index");let d=l[Math.floor(l.length*Math.random())],y=[],k=[],N=[];for(let x of l){const B=a(x,d);B<0?y.push(x):B>0?k.push(x):N.push(x)}return U<y.length?f(U,y,a):U<y.length+N.length?N[0]:f(U-(y.length+N.length),k,a)}t.quickSelect=f;function g(U,l){const a=[];let d;for(const y of U.slice(0).sort(l))!d||l(d[0],y)!==0?(d=[y],a.push(d)):d.push(y);return a}t.groupBy=g;function w(U,l,a){const d=[];function y(x,B,W){if(B===0&&W.length===0)return;const _=d[d.length-1];_&&_.start+_.deleteCount===x?(_.deleteCount+=B,_.toInsert.push(...W)):d.push({start:x,deleteCount:B,toInsert:W})}let k=0,N=0;for(;;){if(k===U.length){y(k,0,l.slice(N));break}if(N===l.length){y(k,U.length-k,[]);break}const x=U[k],B=l[N],W=a(x,B);W===0?(k+=1,N+=1):W<0?(y(k,1,[]),k+=1):W>0&&(y(k,0,[B]),N+=1)}return d}t.sortedDiff=w;function E(U,l,a){const d=w(U,l,a),y=[],k=[];for(const N of d)y.push(...U.slice(N.start,N.start+N.deleteCount)),k.push(...N.toInsert);return{removed:y,added:k}}t.delta=E;function b(U,l,a){if(a===0)return[];const d=U.slice(0,a).sort(l);return c(U,l,d,a,U.length),d}t.top=b;function A(U,l,a,d,y){return a===0?Promise.resolve([]):new Promise((k,N)=>{(async()=>{const x=U.length,B=U.slice(0,a).sort(l);for(let W=a,_=Math.min(a+d,x);W<x;W=_,_=Math.min(_+d,x)){if(W>a&&await new Promise(K=>setTimeout(K)),y&&y.isCancellationRequested)throw m.canceled();c(U,l,B,W,_)}return B})().then(k,N)})}t.topAsync=A;function c(U,l,a,d,y){for(const k=a.length;d<y;d++){const N=U[d];if(l(N,a[k-1])<0){a.pop();const x=C(a,B=>l(N,B)<0);a.splice(x,0,N)}}}function h(U){return U.filter(l=>!!l)}t.coalesce=h;function S(U){let l=0;for(let a=0;a<U.length;a++)U[a]&&(U[l]=U[a],l+=1);U.length=l}t.coalesceInPlace=S;function L(U,l,a){U.splice(a,0,U.splice(l,1)[0])}t.move=L;function D(U){return!Array.isArray(U)||U.length===0}t.isFalsyOrEmpty=D;function p(U){return Array.isArray(U)&&U.length>0}t.isNonEmptyArray=p;function r(U,l){if(!l)return U.filter((d,y)=>U.indexOf(d)===y);const a=Object.create(null);return U.filter(d=>{const y=l(d);return a[y]?!1:(a[y]=!0,!0)})}t.distinct=r;function o(U){const l=new Set;return U.filter(a=>l.has(a)?!1:(l.add(a),!0))}t.distinctES6=o;function e(U){const l=Object.create(null);return a=>{const d=U(a);return l[d]?!1:(l[d]=!0,!0)}}t.uniqueFilter=e;function i(U,l){for(let a=U.length-1;a>=0;a--){const d=U[a];if(l(d))return a}return-1}t.lastIndex=i;function n(U,l){return U.length>0?U[0]:l}t.firstOrDefault=n;function s(U,l,a=(d,y)=>d===y){let d=0;for(let y=0,k=Math.min(U.length,l.length);y<k&&a(U[y],l[y]);y++)d++;return d}t.commonPrefixLength=s;function u(U){return[].concat(...U)}t.flatten=u;function v(U,l){let a=typeof l=="number"?U:0;typeof l=="number"?a=U:(a=0,l=U);const d=[];if(a<=l)for(let y=a;y<l;y++)d.push(y);else for(let y=a;y>l;y--)d.push(y);return d}t.range=v;function P(U,l,a){return U.reduce((d,y)=>(d[l(y)]=a?a(y):y,d),Object.create(null))}t.index=P;function z(U,l){return U.push(l),()=>F(U,l)}t.insert=z;function F(U,l){const a=U.indexOf(l);if(a>-1)return U.splice(a,1),l}t.remove=F;function M(U,l,a){const d=U.slice(0,l),y=U.slice(l);return d.concat(a,y)}t.arrayInsert=M;function j(U,l){let a;if(typeof l=="number"){let d=l;a=()=>{const y=Math.sin(d++)*179426549;return y-Math.floor(y)}}else a=Math.random;for(let d=U.length-1;d>0;d-=1){const y=Math.floor(a()*(d+1)),k=U[d];U[d]=U[y],U[y]=k}}t.shuffle=j;function q(U,l){const a=U.indexOf(l);a>-1&&(U.splice(a,1),U.unshift(l))}t.pushToStart=q;function X(U,l){const a=U.indexOf(l);a>-1&&(U.splice(a,1),U.push(l))}t.pushToEnd=X;function ee(U,l){return Array.isArray(U)?U.map(l):l(U)}t.mapArrayOrNot=ee;function ie(U){return Array.isArray(U)?U:[U]}t.asArray=ie;function Q(U){return U[Math.floor(Math.random()*U.length)]}t.getRandomElement=Q;function oe(U,l){for(const a of U){const d=l(a);if(d!==void 0)return d}}t.mapFind=oe;function se(U,l){let a=Number.MAX_SAFE_INTEGER,d=0;return U.forEach((y,k)=>{const N=l(y);N<a&&(a=N,d=k)}),d}t.minIndex=se;function re(U,l){let a=Number.MIN_SAFE_INTEGER,d=0;return U.forEach((y,k)=>{const N=l(y);N>a&&(a=N,d=k)}),d}t.maxIndex=re}),define(J[58],Y([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var O;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(O=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,s=e.length,u="",v=0,P=16,z=0;function F(Q){let oe=0,se=0;for(;oe<Q;){const re=e.charCodeAt(n);if(re>=48&&re<=57)se=se*16+re-48;else if(re>=65&&re<=70)se=se*16+re-65+10;else if(re>=97&&re<=102)se=se*16+re-97+10;else break;n++,oe++}return oe<Q&&(se=-1),se}function M(Q){n=Q,u="",v=0,P=16,z=0}function j(){const Q=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&g(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&g(e.charCodeAt(n)))for(n++;n<e.length&&g(e.charCodeAt(n));)n++;else return z=3,e.substring(Q,n);let oe=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&g(e.charCodeAt(n))){for(n++;n<e.length&&g(e.charCodeAt(n));)n++;oe=n}else z=3;return e.substring(Q,oe)}function q(){let Q="",oe=n;for(;;){if(n>=s){Q+=e.substring(oe,n),z=2;break}const se=e.charCodeAt(n);if(se===34){Q+=e.substring(oe,n),n++;break}if(se===92){if(Q+=e.substring(oe,n),n++,n>=s){z=2;break}switch(e.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const U=F(4);U>=0?Q+=String.fromCharCode(U):z=4;break;default:z=5}oe=n;continue}if(se>=0&&se<=31)if(f(se)){Q+=e.substring(oe,n),z=2;break}else z=6;n++}return Q}function X(){if(u="",z=0,v=n,n>=s)return v=s,P=17;let Q=e.charCodeAt(n);if(C(Q)){do n++,u+=String.fromCharCode(Q),Q=e.charCodeAt(n);while(C(Q));return P=15}if(f(Q))return n++,u+=String.fromCharCode(Q),Q===13&&e.charCodeAt(n)===10&&(n++,u+=`
`),P=14;switch(Q){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,u=q(),P=10;case 47:const oe=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!f(e.charCodeAt(n));)n++;return u=e.substring(oe,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const se=s-1;let re=!1;for(;n<se;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,re=!0;break}n++}return re||(n++,z=1),u=e.substring(oe,n),P=13}return u+=String.fromCharCode(Q),n++,P=16;case 45:if(u+=String.fromCharCode(Q),n++,n===s||!g(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=j(),P=11;default:for(;n<s&&ee(Q);)n++,Q=e.charCodeAt(n);if(v!==n){switch(u=e.substring(v,n),u){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return u+=String.fromCharCode(Q),n++,P=16}}function ee(Q){if(C(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let Q;do Q=X();while(Q>=12&&Q<=15);return Q}return{setPosition:M,getPosition:()=>n,scan:i?ie:X,getToken:()=>P,getTokenValue:()=>u,getTokenOffset:()=>v,getTokenLength:()=>n-v,getTokenError:()=>z}}t.createScanner=T;function C(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function f(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var w;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(w||(w={}));function E(e,i){const n=[],s=new Object;let u;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function z(F,M,j,q){v.value=F,v.offset=M,v.length=j,v.type=q,v.colonOffset=void 0,u=v}try{p(e,{onObjectBegin:(F,M)=>{if(i<=F)throw s;u=void 0,P=i>F,n.push("")},onObjectProperty:(F,M,j)=>{if(i<M||(z(F,M,j,"property"),n[n.length-1]=F,i<=M+j))throw s},onObjectEnd:(F,M)=>{if(i<=F)throw s;u=void 0,n.pop()},onArrayBegin:(F,M)=>{if(i<=F)throw s;u=void 0,n.push(0)},onArrayEnd:(F,M)=>{if(i<=F)throw s;u=void 0,n.pop()},onLiteralValue:(F,M,j)=>{if(i<M||(z(F,M,j,o(F)),i<=M+j))throw s},onSeparator:(F,M,j)=>{if(i<=M)throw s;if(F===":"&&u&&u.type==="property")u.colonOffset=M,P=!1,u=void 0;else if(F===","){const q=n[n.length-1];typeof q=="number"?n[n.length-1]=q+1:(P=!0,n[n.length-1]=""),u=void 0}}})}catch(F){if(F!==s)throw F}return{path:n,previousNode:u,isAtPropertyKey:P,matches:F=>{let M=0;for(let j=0;M<F.length&&j<n.length;j++)if(F[M]===n[j]||F[M]==="*")M++;else if(F[M]!=="**")return!1;return M===F.length}}}t.getLocation=E;function b(e,i=[],n=R.DEFAULT){let s=null,u=[];const v=[];function P(F){Array.isArray(u)?u.push(F):s!==null&&(u[s]=F)}return p(e,{onObjectBegin:()=>{const F={};P(F),v.push(u),u=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const F=[];P(F),v.push(u),u=F,s=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:P,onError:(F,M,j)=>{i.push({error:F,offset:M,length:j})}},n),u[0]}t.parse=b;function A(e,i=[],n=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(F){s.type==="property"&&(s.length=F-s.offset,s=s.parent)}function v(F){return s.children.push(F),F}p(e,{onObjectBegin:F=>{s=v({type:"object",offset:F,length:-1,parent:s,children:[]})},onObjectProperty:(F,M,j)=>{s=v({type:"property",offset:M,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:F,offset:M,length:j,parent:s})},onObjectEnd:(F,M)=>{s.length=F+M-s.offset,s=s.parent,u(F+M)},onArrayBegin:(F,M)=>{s=v({type:"array",offset:F,length:-1,parent:s,children:[]})},onArrayEnd:(F,M)=>{s.length=F+M-s.offset,s=s.parent,u(F+M)},onLiteralValue:(F,M,j)=>{v({type:o(F),offset:M,length:j,parent:s,value:F}),u(M+j)},onSeparator:(F,M,j)=>{s.type==="property"&&(F===":"?s.colonOffset=M:F===","&&u(M))},onError:(F,M,j)=>{i.push({error:F,offset:M,length:j})}},n);const z=s.children[0];return z&&delete z.parent,z}t.parseTree=A;function c(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const v of n.children)if(Array.isArray(v.children)&&v.children[0].value===s){n=v.children[1],u=!0;break}if(!u)return}else{const u=s;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}t.findNodeAtLocation=c;function h(e){if(!e.parent||!e.parent.children)return[];const i=h(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=h;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=S(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function L(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=L;function D(e,i,n=!1){if(L(e,i,n)){const s=e.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=i;u++){const v=D(s[u],i,n);if(v)return v}return e}}t.findNodeAtOffset=D;function p(e,i,n=R.DEFAULT){const s=T(e,!1);function u(N){return N?()=>N(s.getTokenOffset(),s.getTokenLength()):()=>!0}function v(N){return N?x=>N(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const P=u(i.onObjectBegin),z=v(i.onObjectProperty),F=u(i.onObjectEnd),M=u(i.onArrayBegin),j=u(i.onArrayEnd),q=v(i.onLiteralValue),X=v(i.onSeparator),ee=u(i.onComment),ie=v(i.onError),Q=n&&n.disallowComments,oe=n&&n.allowTrailingComma;function se(){for(;;){const N=s.scan();switch(s.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Q||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(N){case 12:case 13:Q?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return N}}}function re(N,x=[],B=[]){if(ie(N),x.length+B.length>0){let W=s.getToken();for(;W!==17;){if(x.indexOf(W)!==-1){se();break}else if(B.indexOf(W)!==-1)break;W=se()}}}function U(N){const x=s.getTokenValue();return N?q(x):z(x),se(),!0}function l(){switch(s.getToken()){case 11:let N=0;try{N=JSON.parse(s.getTokenValue()),typeof N!="number"&&(re(2),N=0)}catch(x){re(2)}q(N);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return se(),!0}function a(){return s.getToken()!==10?(re(3,[],[2,5]),!1):(U(!1),s.getToken()===6?(X(":"),se(),k()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function d(){P(),se();let N=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(N||re(4,[],[]),X(","),se(),s.getToken()===2&&oe)break}else N&&re(6,[],[]);a()||re(4,[],[2,5]),N=!0}return F(),s.getToken()!==2?re(7,[2],[]):se(),!0}function y(){M(),se();let N=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(N||re(4,[],[]),X(","),se(),s.getToken()===4&&oe)break}else N&&re(6,[],[]);k()||re(4,[],[4,5]),N=!0}return j(),s.getToken()!==4?re(8,[4],[]):se(),!0}function k(){switch(s.getToken()){case 3:return y();case 1:return d();case 10:return U(!0);default:return l()}}return se(),s.getToken()===17?n.allowEmptyContent?!0:(re(4,[],[]),!1):k()?(s.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}t.visit=p;function r(e,i){let n=T(e),s=[],u,v=0,P;do switch(P=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:v!==P&&s.push(e.substring(v,P)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),v=n.getPosition();break}while(u!==17);return s.join("")}t.stripComments=r;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function $(I){const R=[];typeof I=="number"&&R.push("code/timeOrigin",I);function T(f){R.push(f,Date.now())}function C(){const f=[];for(let g=0;g<R.length;g+=2)f.push({name:R[g],startTime:R[g+1]});return f}return{mark:T,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(I+T.startTime)});return R}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=m(O))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var O in m)(typeof exports=="object"?exports:$)[O]=m[O]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function m(O){if(t[O])return t[O].exports;var I=t[O]={i:O,l:!1,exports:{}};return $[O].call(I.exports,I,I.exports,m),I.l=!0,I.exports}return m.m=$,m.c=t,m.d=function(O,I,R){m.o(O,I)||Object.defineProperty(O,I,{enumerable:!0,get:R})},m.r=function(O){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},m.t=function(O,I){if(1&I&&(O=m(O)),8&I||4&I&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(m.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&I&&typeof O!="string")for(var T in O)m.d(R,T,function(C){return O[C]}.bind(null,T));return R},m.n=function(O){var I=O&&O.__esModule?function(){return O.default}:function(){return O};return m.d(I,"a",I),I},m.o=function(O,I){return Object.prototype.hasOwnProperty.call(O,I)},m.p="",m(m.s=0)}([function($,t,m){(function(O){var I;t=$.exports=B,I=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],f=t.src=[],g=0,w=g++;f[w]="0|[1-9]\\d*";var E=g++;f[E]="[0-9]+";var b=g++;f[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var A=g++;f[A]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var c=g++;f[c]="("+f[E]+")\\.("+f[E]+")\\.("+f[E]+")";var h=g++;f[h]="(?:"+f[w]+"|"+f[b]+")";var S=g++;f[S]="(?:"+f[E]+"|"+f[b]+")";var L=g++;f[L]="(?:-("+f[h]+"(?:\\."+f[h]+")*))";var D=g++;f[D]="(?:-?("+f[S]+"(?:\\."+f[S]+")*))";var p=g++;f[p]="[0-9A-Za-z-]+";var r=g++;f[r]="(?:\\+("+f[p]+"(?:\\."+f[p]+")*))";var o=g++,e="v?"+f[A]+f[L]+"?"+f[r]+"?";f[o]="^"+e+"$";var i="[v=\\s]*"+f[c]+f[D]+"?"+f[r]+"?",n=g++;f[n]="^"+i+"$";var s=g++;f[s]="((?:<|>)?=?)";var u=g++;f[u]=f[E]+"|x|X|\\*";var v=g++;f[v]=f[w]+"|x|X|\\*";var P=g++;f[P]="[v=\\s]*("+f[v]+")(?:\\.("+f[v]+")(?:\\.("+f[v]+")(?:"+f[L]+")?"+f[r]+"?)?)?";var z=g++;f[z]="[v=\\s]*("+f[u]+")(?:\\.("+f[u]+")(?:\\.("+f[u]+")(?:"+f[D]+")?"+f[r]+"?)?)?";var F=g++;f[F]="^"+f[s]+"\\s*"+f[P]+"$";var M=g++;f[M]="^"+f[s]+"\\s*"+f[z]+"$";var j=g++;f[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=g++;f[q]="(?:~>?)";var X=g++;f[X]="(\\s*)"+f[q]+"\\s+",C[X]=new RegExp(f[X],"g");var ee=g++;f[ee]="^"+f[q]+f[P]+"$";var ie=g++;f[ie]="^"+f[q]+f[z]+"$";var Q=g++;f[Q]="(?:\\^)";var oe=g++;f[oe]="(\\s*)"+f[Q]+"\\s+",C[oe]=new RegExp(f[oe],"g");var se=g++;f[se]="^"+f[Q]+f[P]+"$";var re=g++;f[re]="^"+f[Q]+f[z]+"$";var U=g++;f[U]="^"+f[s]+"\\s*("+i+")$|^$";var l=g++;f[l]="^"+f[s]+"\\s*("+e+")$|^$";var a=g++;f[a]="(\\s*)"+f[s]+"\\s*("+i+"|"+f[P]+")",C[a]=new RegExp(f[a],"g");var d=g++;f[d]="^\\s*("+f[P]+")\\s+-\\s+("+f[P]+")\\s*$";var y=g++;f[y]="^\\s*("+f[z]+")\\s+-\\s+("+f[z]+")\\s*$";var k=g++;f[k]="(<|>)?=?\\s*\\*";for(var N=0;N<35;N++)I(N,f[N]),C[N]||(C[N]=new RegExp(f[N]));function x(V,G){if(V instanceof B)return V;if(typeof V!="string"||V.length>R||!(G?C[n]:C[o]).test(V))return null;try{return new B(V,G)}catch(H){return null}}function B(V,G){if(V instanceof B){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof B))return new B(V,G);I("SemVer",V,G),this.loose=G;var H=V.trim().match(G?C[n]:C[o]);if(!H)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var le=+ne;if(le>=0&&le<T)return le}return ne}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=x,t.valid=function(V,G){var H=x(V,G);return H?H.version:null},t.clean=function(V,G){var H=x(V.trim().replace(/^[=v]+/,""),G);return H?H.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(V){return I("SemVer.compare",this.version,this.loose,V),V instanceof B||(V=new B(V,this.loose)),this.compareMain(V)||this.comparePre(V)},B.prototype.compareMain=function(V){return V instanceof B||(V=new B(V,this.loose)),_(this.major,V.major)||_(this.minor,V.minor)||_(this.patch,V.patch)},B.prototype.comparePre=function(V){if(V instanceof B||(V=new B(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ne=V.prerelease[G];if(I("prerelease compare",G,H,ne),H===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(H===void 0)return-1;if(H!==ne)return _(H,ne)}while(++G)},B.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,H,ne){typeof H=="string"&&(ne=H,H=void 0);try{return new B(V,H).inc(G,ne).version}catch(le){return null}},t.diff=function(V,G){if(ae(V,G))return null;var H=x(V),ne=x(G);if(H.prerelease.length||ne.prerelease.length){for(var le in H)if((le==="major"||le==="minor"||le==="patch")&&H[le]!==ne[le])return"pre"+le;return"prerelease"}for(var le in H)if((le==="major"||le==="minor"||le==="patch")&&H[le]!==ne[le])return le},t.compareIdentifiers=_;var W=/^[0-9]+$/;function _(V,G){var H=W.test(V),ne=W.test(G);return H&&ne&&(V=+V,G=+G),H&&!ne?-1:ne&&!H?1:V<G?-1:V>G?1:0}function K(V,G,H){return new B(V,H).compare(new B(G,H))}function Z(V,G,H){return K(V,G,H)>0}function te(V,G,H){return K(V,G,H)<0}function ae(V,G,H){return K(V,G,H)===0}function me(V,G,H){return K(V,G,H)!==0}function ve(V,G,H){return K(V,G,H)>=0}function Oe(V,G,H){return K(V,G,H)<=0}function Te(V,G,H,ne){var le;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof H=="object"&&(H=H.version),le=V===H;break;case"!==":typeof V=="object"&&(V=V.version),typeof H=="object"&&(H=H.version),le=V!==H;break;case"":case"=":case"==":le=ae(V,H,ne);break;case"!=":le=me(V,H,ne);break;case">":le=Z(V,H,ne);break;case">=":le=ve(V,H,ne);break;case"<":le=te(V,H,ne);break;case"<=":le=Oe(V,H,ne);break;default:throw new TypeError("Invalid operator: "+G)}return le}function Se(V,G){if(V instanceof Se){if(V.loose===G)return V;V=V.value}if(!(this instanceof Se))return new Se(V,G);I("comparator",V,G),this.loose=G,this.parse(V),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(V,G){return _(G,V)},t.major=function(V,G){return new B(V,G).major},t.minor=function(V,G){return new B(V,G).minor},t.patch=function(V,G){return new B(V,G).patch},t.compare=K,t.compareLoose=function(V,G){return K(V,G,!0)},t.rcompare=function(V,G,H){return K(G,V,H)},t.sort=function(V,G){return V.sort(function(H,ne){return t.compare(H,ne,G)})},t.rsort=function(V,G){return V.sort(function(H,ne){return t.rcompare(H,ne,G)})},t.gt=Z,t.lt=te,t.eq=ae,t.neq=me,t.gte=ve,t.lte=Oe,t.cmp=Te,t.Comparator=Se;var Ae={};function ye(V,G){if(V instanceof ye)return V.loose===G?V:new ye(V.raw,G);if(V instanceof Se)return new ye(V.value,G);if(!(this instanceof ye))return new ye(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Le(V){return!V||V.toLowerCase()==="x"||V==="*"}function je(V,G,H,ne,le,be,de,Re,Ee,De,ke,we,Pe){return((G=Le(H)?"":Le(ne)?">="+H+".0.0":Le(le)?">="+H+"."+ne+".0":">="+G)+" "+(Re=Le(Ee)?"":Le(De)?"<"+(+Ee+1)+".0.0":Le(ke)?"<"+Ee+"."+(+De+1)+".0":we?"<="+Ee+"."+De+"."+ke+"-"+we:"<="+Re)).trim()}function Be(V,G){for(var H=0;H<V.length;H++)if(!V[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<V.length;H++)if(I(V[H].semver),V[H].semver!==Ae&&V[H].semver.prerelease.length>0){var ne=V[H].semver;if(ne.major===G.major&&ne.minor===G.minor&&ne.patch===G.patch)return!0}return!1}return!0}function ze(V,G,H){try{G=new ye(G,H)}catch(ne){return!1}return G.test(V)}function xe(V,G,H,ne){var le,be,de,Re,Ee;switch(V=new B(V,ne),G=new ye(G,ne),H){case">":le=Z,be=Oe,de=te,Re=">",Ee=">=";break;case"<":le=te,be=ve,de=Z,Re="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(V,G,ne))return!1;for(var De=0;De<G.set.length;++De){var ke=G.set[De],we=null,Pe=null;if(ke.forEach(function(Ce){Ce.semver===Ae&&(Ce=new Se(">=0.0.0")),we=we||Ce,Pe=Pe||Ce,le(Ce.semver,we.semver,ne)?we=Ce:de(Ce.semver,Pe.semver,ne)&&(Pe=Ce)}),we.operator===Re||we.operator===Ee||(!Pe.operator||Pe.operator===Re)&&be(V,Pe.semver)||Pe.operator===Ee&&de(V,Pe.semver))return!1}return!0}Se.prototype.parse=function(V){var G=this.loose?C[U]:C[l],H=V.match(G);if(!H)throw new TypeError("Invalid comparator: "+V);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new B(H[2],this.loose):this.semver=Ae},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(V){return I("Comparator.test",V,this.loose),this.semver===Ae||(typeof V=="string"&&(V=new B(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(V,G){if(!(V instanceof Se))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new ye(V.value,G),ze(this.value,H,G);if(V.operator==="")return H=new ye(this.value,G),ze(V.semver,H,G);var ne=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),le=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),be=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Re=Te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ee=Te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ne||le||be&&de||Re||Ee},t.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),I("range",V,G);var H=G?C[y]:C[d];V=V.replace(H,je),I("hyphen replace",V),V=V.replace(C[a],"$1$2$3"),I("comparator trim",V,C[a]),V=(V=(V=V.replace(C[X],"$1~")).replace(C[oe],"$1^")).split(/\s+/).join(" ");var ne=G?C[U]:C[l],le=V.split(" ").map(function(be){return function(de,Re){return I("comp",de),de=function(Ee,De){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Pe){I("caret",we,Pe);var Ce=Pe?C[re]:C[se];return we.replace(Ce,function(Fe,ce,he,ge,pe){var Ie;return I("caret",we,Fe,ce,he,ge,pe),Le(ce)?Ie="":Le(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Le(ge)?Ie=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":pe?(I("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+pe+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+pe+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+pe+" <"+(+ce+1)+".0.0"):(I("no pr"),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+" <"+(+ce+1)+".0.0"),I("caret return",Ie),Ie})}(ke,De)}).join(" ")}(de,Re),I("caret",de),de=function(Ee,De){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Pe){var Ce=Pe?C[ie]:C[ee];return we.replace(Ce,function(Fe,ce,he,ge,pe){var Ie;return I("tilde",we,Fe,ce,he,ge,pe),Le(ce)?Ie="":Le(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Le(ge)?Ie=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":pe?(I("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ie=">="+ce+"."+he+"."+ge+pe+" <"+ce+"."+(+he+1)+".0"):Ie=">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0",I("tilde return",Ie),Ie})}(ke,De)}).join(" ")}(de,Re),I("tildes",de),de=function(Ee,De){return I("replaceXRanges",Ee,De),Ee.split(/\s+/).map(function(ke){return function(we,Pe){we=we.trim();var Ce=Pe?C[M]:C[F];return we.replace(Ce,function(Fe,ce,he,ge,pe,Ie){I("xRange",we,Fe,ce,he,ge,pe,Ie);var Ve=Le(he),Me=Ve||Le(ge),Ue=Me||Le(pe);return ce==="="&&Ue&&(ce=""),Ve?Fe=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ue?(Me&&(ge=0),Ue&&(pe=0),ce===">"?(ce=">=",Me?(he=+he+1,ge=0,pe=0):Ue&&(ge=+ge+1,pe=0)):ce==="<="&&(ce="<",Me?he=+he+1:ge=+ge+1),Fe=ce+he+"."+ge+"."+pe):Me?Fe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Fe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),I("xRange return",Fe),Fe})}(ke,De)}).join(" ")}(de,Re),I("xrange",de),de=function(Ee,De){return I("replaceStars",Ee,De),Ee.trim().replace(C[k],"")}(de,Re),I("stars",de),de}(be,G)}).join(" ").split(/\s+/);return this.loose&&(le=le.filter(function(be){return!!be.match(ne)})),le=le.map(function(be){return new Se(be,G)})},ye.prototype.intersects=function(V,G){if(!(V instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ne){return V.set.some(function(le){return le.every(function(be){return ne.intersects(be,G)})})})})},t.toComparators=function(V,G){return new ye(V,G).set.map(function(H){return H.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new B(V,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],V))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(V,G,H){var ne=null,le=null;try{var be=new ye(G,H)}catch(de){return null}return V.forEach(function(de){be.test(de)&&(ne&&le.compare(de)!==-1||(le=new B(ne=de,H)))}),ne},t.minSatisfying=function(V,G,H){var ne=null,le=null;try{var be=new ye(G,H)}catch(de){return null}return V.forEach(function(de){be.test(de)&&(ne&&le.compare(de)!==1||(le=new B(ne=de,H)))}),ne},t.validRange=function(V,G){try{return new ye(V,G).range||"*"}catch(H){return null}},t.ltr=function(V,G,H){return xe(V,G,"<",H)},t.gtr=function(V,G,H){return xe(V,G,">",H)},t.outside=xe,t.prerelease=function(V,G){var H=x(V,G);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(V,G,H){return V=new ye(V,H),G=new ye(G,H),V.intersects(G)},t.coerce=function(V){if(V instanceof B)return V;if(typeof V!="string")return null;var G=V.match(C[j]);return G==null?null:x((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,m(1))},function($,t){var m,O,I=$.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function C(S){if(m===setTimeout)return setTimeout(S,0);if((m===R||!m)&&setTimeout)return m=setTimeout,setTimeout(S,0);try{return m(S,0)}catch(L){try{return m.call(null,S,0)}catch(D){return m.call(this,S,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:R}catch(S){m=R}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch(S){O=T}})();var f,g=[],w=!1,E=-1;function b(){w&&f&&(w=!1,f.length?g=f.concat(g):E=-1,g.length&&A())}function A(){if(!w){var S=C(b);w=!0;for(var L=g.length;L;){for(f=g,g=[];++E<L;)f&&f[E].run();E=-1,L=g.length}f=null,w=!1,function(D){if(O===clearTimeout)return clearTimeout(D);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(D);try{O(D)}catch(p){try{return O.call(null,D)}catch(r){return O.call(this,D)}}}(S)}}function c(S,L){this.fun=S,this.array=L}function h(){}I.nextTick=function(S){var L=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)L[D-1]=arguments[D];g.push(new c(S,L)),g.length!==1||w||C(A)},c.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=h,I.addListener=h,I.once=h,I.off=h,I.removeListener=h,I.removeAllListeners=h,I.emit=h,I.prependListener=h,I.prependOnceListener=h,I.listeners=function(S){return[]},I.binding=function(S){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(S){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(J[34],Y([0,1,12,2]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(p){const r=p;return r?[r.on,r.pause,r.resume,r.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=I;function R(p){const r=p;return r?I(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=R;function T(p,r){return new C(p,r)}t.newWriteableStream=T;class C{constructor(r,o){this.reducer=r,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(o=>o(r))}emitError(r){this.listeners.error.length===0?m.onUnexpectedError(r):this.listeners.error.slice(0).forEach(o=>o(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,o){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(r,o){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(o);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(p,r){const o=[];let e;for(;(e=p.read())!==null;)o.push(e);return r(o)}t.consumeReadable=f;function g(p,r,o){const e=[];let i;for(;(i=p.read())!==null&&e.length<o;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return p.read()}}}t.peekReadable=g;function w(p,r){return new Promise((o,e)=>{const i=[];E(p,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):o(void 0)},onEnd:()=>{o(r?r(i):void 0)}})})}t.consumeStream=w;function E(p,r){p.on("error",o=>r.onError(o)),p.on("end",()=>r.onEnd()),p.on("data",o=>r.onData(o))}t.listenStream=E;function b(p,r){return new Promise((o,e)=>{const i=new O.DisposableStore,n=[],s=P=>{if(n.push(P),n.length>r)return i.dispose(),p.pause(),o({stream:p,buffer:n,ended:!1})},u=P=>e(P),v=()=>o({stream:p,buffer:n,ended:!0});i.add(O.toDisposable(()=>p.removeListener("error",u))),p.on("error",u),i.add(O.toDisposable(()=>p.removeListener("end",v))),p.on("end",v),i.add(O.toDisposable(()=>p.removeListener("data",s))),p.on("data",s)})}t.peekStream=b;function A(p,r){const o=T(r);return o.end(p),o}t.toStream=A;function c(){const p=T(()=>{throw new Error("not supported")});return p.end(),p}t.emptyStream=c;function h(p){let r=!1;return{read:()=>r?null:(r=!0,p)}}t.toReadable=h;function S(p,r,o){const e=T(o);return E(p,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=S;function L(p,r,o){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?o([p,i]):p)}}}t.prefixedReadable=L;function D(p,r,o){let e=!1;const i=T(o);return E(r,{onData:n=>e?i.write(n):(e=!0,i.write(o([p,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(p)),i.end()}}),i}t.prefixedStream=D}),define(J[16],Y([0,1,19,34]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let C,f;class g{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return I?new g(Buffer.allocUnsafe(P)):new g(new Uint8Array(P))}static wrap(P){return I&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new g(P)}static fromString(P,z){return!(z?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(P)):R?(C||(C=new TextEncoder),new g(C.encode(P))):new g(m.encodeUTF8(P))}static concat(P,z){if(typeof z=="undefined"){z=0;for(let j=0,q=P.length;j<q;j++)z+=P[j].byteLength}const F=g.alloc(z);let M=0;for(let j=0,q=P.length;j<q;j++){const X=P[j];F.set(X,M),M+=X.byteLength}return F}toString(){return I?this.buffer.toString():T?(f||(f=new TextDecoder),f.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(P,z){return new g(this.buffer.subarray(P,z))}set(P,z){P instanceof g?this.buffer.set(P.buffer,z):this.buffer.set(P,z)}readUInt32BE(P){return b(this.buffer,P)}writeUInt32BE(P,z){A(this.buffer,P,z)}readUInt32LE(P){return c(this.buffer,P)}writeUInt32LE(P,z){h(this.buffer,P,z)}readUInt8(P){return S(this.buffer,P)}writeUInt8(P,z){L(this.buffer,P,z)}}t.VSBuffer=g;function w(v,P){return v[P+0]<<0>>>0|v[P+1]<<8>>>0}t.readUInt16LE=w;function E(v,P,z){v[z+0]=P&255,P=P>>>8,v[z+1]=P&255}t.writeUInt16LE=E;function b(v,P){return v[P]*2**24+v[P+1]*2**16+v[P+2]*2**8+v[P+3]}t.readUInt32BE=b;function A(v,P,z){v[z+3]=P,P=P>>>8,v[z+2]=P,P=P>>>8,v[z+1]=P,P=P>>>8,v[z]=P}t.writeUInt32BE=A;function c(v,P){return v[P+0]<<0>>>0|v[P+1]<<8>>>0|v[P+2]<<16>>>0|v[P+3]<<24>>>0}t.readUInt32LE=c;function h(v,P,z){v[z+0]=P&255,P=P>>>8,v[z+1]=P&255,P=P>>>8,v[z+2]=P&255,P=P>>>8,v[z+3]=P&255}t.writeUInt32LE=h;function S(v,P){return v[P]}t.readUInt8=S;function L(v,P,z){v[z]=P}t.writeUInt8=L;function D(v){return O.consumeReadable(v,P=>g.concat(P))}t.readableToBuffer=D;function p(v){return O.toReadable(v)}t.bufferToReadable=p;function r(v){return O.consumeStream(v,P=>g.concat(P))}t.streamToBuffer=r;async function o(v){return v.ended?g.concat(v.buffer):g.concat([...v.buffer,await r(v.stream)])}t.bufferedStreamToBuffer=o;function e(v){return O.toStream(v,P=>g.concat(P))}t.bufferToStream=e;function i(v){return O.transform(v,{data:P=>typeof P=="string"?g.fromString(P):g.wrap(P)},P=>g.concat(P))}t.streamToBufferReadableStream=i;function n(v){return O.newWriteableStream(P=>g.concat(P),v)}t.newWriteableBufferStream=n;function s(v,P){return O.prefixedReadable(v,P,z=>g.concat(z))}t.prefixedBufferReadable=s;function u(v,P){return O.prefixedStream(v,P,z=>g.concat(z))}t.prefixedBufferStream=u}),define(J[20],Y([0,1,13]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const S=Array.isArray(h)?[]:{};return Object.keys(h).forEach(L=>{h[L]&&typeof h[L]=="object"?S[L]=O(h[L]):S[L]=h[L]}),S}t.deepClone=O;function I(h){if(!h||typeof h!="object")return h;const S=[h];for(;S.length>0;){const L=S.shift();Object.freeze(L);for(const D in L)if(R.call(L,D)){const p=L[D];typeof p=="object"&&!Object.isFrozen(p)&&S.push(p)}}return h}t.deepFreeze=I;const R=Object.prototype.hasOwnProperty;function T(h,S){return C(h,S,new Set)}t.cloneAndChange=T;function C(h,S,L){if(m.isUndefinedOrNull(h))return h;const D=S(h);if(typeof D!="undefined")return D;if(m.isArray(h)){const p=[];for(const r of h)p.push(C(r,S,L));return p}if(m.isObject(h)){if(L.has(h))throw new Error("Cannot clone recursive data-structure");L.add(h);const p={};for(let r in h)R.call(h,r)&&(p[r]=C(h[r],S,L));return L.delete(h),p}return h}function f(h,S,L=!0){return m.isObject(h)?(m.isObject(S)&&Object.keys(S).forEach(D=>{D in h?L&&(m.isObject(h[D])&&m.isObject(S[D])?f(h[D],S[D],L):h[D]=S[D]):h[D]=S[D]}),h):S}t.mixin=f;function g(h,S){if(h===S)return!0;if(h==null||S===null||S===void 0||typeof h!=typeof S||typeof h!="object"||Array.isArray(h)!==Array.isArray(S))return!1;let L,D;if(Array.isArray(h)){if(h.length!==S.length)return!1;for(L=0;L<h.length;L++)if(!g(h[L],S[L]))return!1}else{const p=[];for(D in h)p.push(D);p.sort();const r=[];for(D in S)r.push(D);if(r.sort(),!g(p,r))return!1;for(L=0;L<p.length;L++)if(!g(h[p[L]],S[p[L]]))return!1}return!0}t.equals=g;function w(h){const S=new Set;return JSON.stringify(h,(L,D)=>{if(m.isObject(D)||Array.isArray(D)){if(S.has(D))return"[Circular]";S.add(D)}return D})}t.safeStringify=w;function E(h,S,L){const D=S(h);return typeof D=="undefined"?L:D}t.getOrDefault=E;function b(h,S){const L=Object.create(null);return!h||!S||Object.keys(S).forEach(p=>{const r=h[p],o=S[p];g(r,o)||(L[p]=o)}),L}t.distinct=b;function A(h,S){const L=S.toLowerCase(),D=Object.keys(h).find(p=>p.toLowerCase()===L);return D?h[D]:h[S]}t.getCaseInsensitive=A;function c(h,S){const L=Object.create(null);for(const D of Object.keys(h))S(D,h[D])&&(L[D]=h[D]);return L}t.filter=c}),define(J[59],Y([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function O(g){const w=g;return w&&typeof w.type=="string"&&typeof w.severity=="string"}t.isRemoteConsoleLog=O;function I(g){const w=[];let E;try{const b=JSON.parse(g.arguments),A=b[b.length-1];A&&A.__$stack&&(b.pop(),E=A.__$stack),w.push(...b)}catch(b){w.push("Unable to log remote console arguments",g.arguments)}return{args:w,stack:E}}t.parse=I;function R(g){if(typeof g!="string")return R(I(g).stack);const w=g;if(w){const E=T(w),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:m.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}t.getFirstFrame=R;function T(g){if(!g)return g;const w=g.indexOf(`
`);return w===-1?g:g.substring(0,w)}function C(g,w){const{args:E,stack:b}=I(g),A=typeof E[0]=="string"&&E.length===1;let c=T(b);c&&(c=`(${c.trim()})`);let h=[];if(typeof E[0]=="string"?c&&A?h=[`%c[${w}] %c${E[0]} %c${c}`,f("blue"),f(""),f("grey")]:h=[`%c[${w}] %c${E[0]}`,f("blue"),f(""),...E.slice(1)]:h=[`%c[${w}]%`,f("blue"),...E],c&&!A&&h.push(c),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,h)}t.log=C;function f(g){return`color: ${g}`}}),define(J[60],Y([0,1,16,19,7]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(w){return JSON.stringify(w,f)}t.stringify=R;function T(w){let E=JSON.parse(w);return E=g(E),E}t.parse=T;var C;(function(w){w[w.Uri=1]="Uri",w[w.Regexp=2]="Regexp",w[w.ScmResource=3]="ScmResource",w[w.ScmResourceGroup=4]="ScmResourceGroup",w[w.ScmProvider=5]="ScmProvider",w[w.CommentController=6]="CommentController",w[w.CommentThread=7]="CommentThread",w[w.CommentThreadReply=8]="CommentThreadReply",w[w.CommentNode=9]="CommentNode",w[w.CommentThreadNode=10]="CommentThreadNode",w[w.TimelineActionContext=11]="TimelineActionContext",w[w.NotebookCellActionContext=12]="NotebookCellActionContext",w[w.TestItemContext=13]="TestItemContext"})(C=t.MarshalledId||(t.MarshalledId={}));function f(w,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:O.regExpFlags(E)}:E}function g(w,E=0){if(!w||E>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return I.URI.revive(w);case 2:return new RegExp(w.source,w.flags)}if(w instanceof m.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let b=0;b<w.length;++b)w[b]=g(w[b],E+1);else for(const b in w)Object.hasOwnProperty.call(w,b)&&(w[b]=g(w[b],E+1))}return w}t.revive=g}),define(J[61],Y([0,1,19,35,3,45,4]),function($,t,m,O,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function C(){return Object.create(null)}t.getEmptyExpression=C;const f="**",g="/",w="[/\\\\]",E="[^/\\\\]",b=/\//g;function A(a){switch(a){case 0:return"";case 1:return`${E}*?`;default:return`(?:${w}|${E}+${w}|${w}${E}+)*?`}}function c(a,d){if(!a)return[];const y=[];let k=!1,N=!1,x="";for(const B of a){switch(B){case d:if(!k&&!N){y.push(x),x="";continue}break;case"{":k=!0;break;case"}":k=!1;break;case"[":N=!0;break;case"]":N=!1;break}x+=B}return x&&y.push(x),y}t.splitGlobAware=c;function h(a){if(!a)return"";let d="";const y=c(a,g);if(y.every(k=>k===f))d=".*";else{let k=!1;y.forEach((N,x)=>{if(N===f){k||(d+=A(2),k=!0);return}let B=!1,W="",_=!1,K="";for(const Z of N){if(Z!=="}"&&B){W+=Z;continue}if(_&&(Z!=="]"||!K)){let te;Z==="-"?te=Z:(Z==="^"||Z==="!")&&!K?te="^":Z===g?te="":te=m.escapeRegExpCharacters(Z),K+=te;continue}switch(Z){case"{":B=!0;continue;case"[":_=!0;continue;case"}":d+=`(?:${c(W,",").map(me=>h(me)).join("|")})`,B=!1,W="";break;case"]":d+="["+K+"]",_=!1,K="";break;case"?":d+=E;continue;case"*":d+=A(1);continue;default:d+=m.escapeRegExpCharacters(Z)}}x<y.length-1&&(y[x+1]!==f||x+2<y.length)&&(d+=w),k=!1})}return d}const S=/^\*\*\/\*\.[\w\.-]+$/,L=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new R.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(a,d){if(!a)return n;let y;typeof a!="string"?y=a.pattern:y=a,y=y.trim();const k=`${y}_${!!d.trimForExclusions}`;let N=e.get(k);if(N)return u(N,a);let x;if(S.test(y)){const B=y.substr(4);N=function(W,_){return typeof W=="string"&&W.endsWith(B)?y:null}}else(x=L.exec(v(y,d)))?N=P(x[1],y):(d.trimForExclusions?p:D).test(y)?N=z(y,d):(x=r.exec(v(y,d)))?N=F(x[1].substr(1),y,!0):(x=o.exec(v(y,d)))?N=F(x[1],y,!1):N=M(y);return e.set(k,N),u(N,a)}function u(a,d){return typeof d=="string"?a:function(y,k){return O.isEqualOrParent(y,d.base)?a(I.relative(d.base,y),k):null}}function v(a,d){return d.trimForExclusions&&a.endsWith("/**")?a.substr(0,a.length-2):a}function P(a,d){const y=`/${a}`,k=`\\${a}`,N=function(B,W){return typeof B!="string"?null:W?W===a?d:null:B===a||B.endsWith(y)||B.endsWith(k)?d:null},x=[a];return N.basenames=x,N.patterns=[d],N.allBasenames=x,N}function z(a,d){const y=l(a.slice(1,-1).split(",").map(W=>s(W,d)).filter(W=>W!==n),a),k=y.length;if(!k)return n;if(k===1)return y[0];const N=function(W,_){for(let K=0,Z=y.length;K<Z;K++)if(y[K](W,_))return a;return null},x=y.find(W=>!!W.allBasenames);x&&(N.allBasenames=x.allBasenames);const B=y.reduce((W,_)=>_.allPaths?W.concat(_.allPaths):W,[]);return B.length&&(N.allPaths=B),N}function F(a,d,y){const k=I.sep===I.posix.sep,N=k?a:a.replace(b,I.sep),x=I.sep+N,B=I.posix.sep+a,W=y?function(_,K){return typeof _=="string"&&(_===N||_.endsWith(x)||!k&&(_===a||_.endsWith(B)))?d:null}:function(_,K){return typeof _=="string"&&(_===N||!k&&_===a)?d:null};return W.allPaths=[(y?"*/":"./")+a],W}function M(a){try{const d=new RegExp(`^${h(a)}$`);return function(y){return d.lastIndex=0,typeof y=="string"&&d.test(y)?a:null}}catch(d){return n}}function j(a,d,y){return!a||typeof d!="string"?!1:q(a)(d,void 0,y)}t.match=j;function q(a,d={}){if(!a)return i;if(typeof a=="string"||Q(a)){const y=s(a,d);if(y===n)return i;const k=function(N,x){return!!y(N,x)};return y.allBasenames&&(k.allBasenames=y.allBasenames),y.allPaths&&(k.allPaths=y.allPaths),k}return re(a,d)}t.parse=q;function X(a){if(!a)return;let d;return y=>(d||(d=(a()||Promise.resolve([])).then(k=>k?ie(k):{})),d.then(k=>!!k[y]))}t.hasSiblingPromiseFn=X;function ee(a){if(!a)return;let d;return y=>{if(!d){const k=a();d=k?ie(k):{}}return!!d[y]}}t.hasSiblingFn=ee;function ie(a){const d={};for(const y of a)d[y]=!0;return d}function Q(a){const d=a;return d&&typeof d.base=="string"&&typeof d.pattern=="string"}t.isRelativePattern=Q;function oe(a){return a.allBasenames||[]}t.getBasenameTerms=oe;function se(a){return a.allPaths||[]}t.getPathTerms=se;function re(a,d){const y=l(Object.getOwnPropertyNames(a).map(W=>U(W,a[W],d)).filter(W=>W!==n)),k=y.length;if(!k)return n;if(!y.some(W=>!!W.requiresSiblings)){if(k===1)return y[0];const W=function(Z,te){for(let ae=0,me=y.length;ae<me;ae++){const ve=y[ae](Z,te);if(ve)return ve}return null},_=y.find(Z=>!!Z.allBasenames);_&&(W.allBasenames=_.allBasenames);const K=y.reduce((Z,te)=>te.allPaths?Z.concat(te.allPaths):Z,[]);return K.length&&(W.allPaths=K),W}const N=function(W,_,K){let Z;for(let te=0,ae=y.length;te<ae;te++){const me=y[te];me.requiresSiblings&&K&&(_||(_=I.basename(W)),Z||(Z=_.substr(0,_.length-I.extname(W).length)));const ve=me(W,_,Z,K);if(ve)return ve}return null},x=y.find(W=>!!W.allBasenames);x&&(N.allBasenames=x.allBasenames);const B=y.reduce((W,_)=>_.allPaths?W.concat(_.allPaths):W,[]);return B.length&&(N.allPaths=B),N}function U(a,d,y){if(d===!1)return n;const k=s(a,y);if(k===n)return n;if(typeof d=="boolean")return k;if(d){const N=d.when;if(typeof N=="string"){const x=(B,W,_,K)=>{if(!K||!k(B,W))return null;const Z=N.replace("$(basename)",_),te=K(Z);return T.isThenable(te)?te.then(ae=>ae?a:null):te?a:null};return x.requiresSiblings=!0,x}}return k}function l(a,d){const y=a.filter(W=>!!W.basenames);if(y.length<2)return a;const k=y.reduce((W,_)=>{const K=_.basenames;return K?W.concat(K):W},[]);let N;if(d){N=[];for(let W=0,_=k.length;W<_;W++)N.push(d)}else N=y.reduce((W,_)=>{const K=_.patterns;return K?W.concat(K):W},[]);const x=function(W,_){if(typeof W!="string")return null;if(!_){let Z;for(Z=W.length;Z>0;Z--){const te=W.charCodeAt(Z-1);if(te===47||te===92)break}_=W.substr(Z)}const K=k.indexOf(_);return K!==-1?N[K]:null};x.basenames=k,x.patterns=N,x.allBasenames=k;const B=a.filter(W=>!W.basenames);return B.push(x),B}}),define(J[62],Y([0,1,7,3,19,8,14,17,35]),function($,t,m,O,I,R,T,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(s,u,v){if(typeof s=="string"&&(s=m.URI.file(s)),v){const z=v.getWorkspaceFolder(s);if(z){const F=v.getWorkspace().folders.length>1;let M;if(C.isEqual(z.uri,s)?M="":M=C.relativePath(z.uri,s),F){const j=z.name?z.name:C.basename(z.uri);M=M?j+" \u2022 "+M:j}return M}}if(s.scheme!==R.Schemas.file&&s.scheme!==R.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(f.hasDriveLetter(s.fsPath))return O.normalize(E(s.fsPath));let P=O.normalize(s.fsPath);return!T.isWindows&&u?.userHome&&(P=A(P,u.userHome.fsPath)),P}t.getPathLabel=g;function w(s){if(!s)return;typeof s=="string"&&(s=m.URI.file(s));const u=C.basename(s)||(s.scheme===R.Schemas.file?s.fsPath:s.path);return T.isWindows&&f.isRootOrDriveLetter(u)?E(u):u}t.getBaseLabel=w;function E(s){return f.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=E;let b=Object.create(null);function A(s,u){if(T.isWindows||!s||!u)return s;let v=b.original===u?b.normalized:void 0;return v||(v=`${I.rtrim(u,O.posix.sep)}${O.posix.sep}`,b={original:u,normalized:v}),(T.isLinux?s.startsWith(v):I.startsWithIgnoreCase(s,v))&&(s=`~/${s.substr(v.length)}`),s}t.tildify=A;function c(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}t.untildify=c;const h="\u2026",S="\\\\",L="~";function D(s,u=O.sep){const v=new Array(s.length);let P=!1;for(let z=0;z<s.length;z++){let F=s[z];if(F===""){v[z]=`.${u}`;continue}if(!F){v[z]=F;continue}P=!0;let M="";F.indexOf(S)===0?(M=F.substr(0,F.indexOf(S)+S.length),F=F.substr(F.indexOf(S)+S.length)):F.indexOf(u)===0?(M=F.substr(0,F.indexOf(u)+u.length),F=F.substr(F.indexOf(u)+u.length)):F.indexOf(L)===0&&(M=F.substr(0,F.indexOf(L)+L.length),F=F.substr(F.indexOf(L)+L.length));const j=F.split(u);for(let q=1;P&&q<=j.length;q++)for(let X=j.length-q;P&&X>=0;X--){P=!1;let ee=j.slice(X,X+q).join(u);for(let ie=0;!P&&ie<s.length;ie++)if(ie!==z&&s[ie]&&s[ie].indexOf(ee)>-1){const Q=X+q===j.length,oe=X>0&&s[ie].indexOf(u)>-1?u+ee:ee,se=s[ie].endsWith(oe);P=!Q||se}if(!P){let ie="";(j[0].endsWith(":")||M!=="")&&(X===1&&(X=0,q++,ee=j[0]+u+ee),X>0&&(ie=j[0]+u),ie=M+ie),X>0&&(ie=ie+h+u),ie=ie+ee,X+q<j.length&&(ie=ie+u+h),v[z]=ie}}P&&(v[z]=F)}return v}t.shorten=D;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function r(s,u=Object.create(null)){const v=[];let P=!1,z="";for(const F of s)if(F==="$"||P&&F==="{")z&&v.push({value:z,type:p.TEXT}),z="",P=!0;else if(F==="}"&&P){const M=u[z];if(typeof M=="string")M.length&&v.push({value:M,type:p.VARIABLE});else if(M){const j=v[v.length-1];(!j||j.type!==p.SEPARATOR)&&v.push({value:M.label,type:p.SEPARATOR})}z="",P=!1}else z+=F;return z&&!P&&v.push({value:z,type:p.TEXT}),v.filter((F,M)=>{if(F.type===p.SEPARATOR){const j=v[M-1],q=v[M+1];return[j,q].every(X=>X&&(X.type===p.VARIABLE||X.type===p.TEXT)&&X.value.length>0)}return!0}).map(F=>F.value).join("")}t.template=r;function o(s,u){return T.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):s.replace(/&&|&/g,v=>v==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(s,u){return T.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):T.isWindows?s.replace(/&&|&/g,v=>v==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const u=s.indexOf("/")!==-1?O.posix:O.win32,v=u.basename(s),P=u.dirname(s);return v.length?{name:v,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(J[46],Y([0,1,124]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class O{constructor(R="utf8"){this.stringDecoder=new m.StringDecoder(R),this.remaining=null}write(R){const T=[],C=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(C.length<1)return T;let f=0,g,w=f;for(;w<C.length;)if(g=C.charCodeAt(w),g===13||g===10){if(T.push(C.substring(f,w)),w++,w<C.length){const E=g;g=C.charCodeAt(w),(E===13&&g===10||E===10&&g===13)&&w++}f=w}else w++;return this.remaining=f<C.length?C.substr(f):null,T}end(){return this.remaining}}t.LineDecoder=O}),define(J[63],Y([0,1,36,19,3,9]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(w){const E=I.dirname(w);if(w===E)return w;const b=(I.basename(w)||w).toLowerCase();try{const c=R.readdirSync(E).filter(h=>h.toLowerCase()===b);if(c.length===1){const h=T(E);if(h)return I.join(h,c[0])}else if(c.length>1){const h=c.indexOf(b);if(h>=0){const S=T(E);if(S)return I.join(S,c[h])}}}catch(A){}return null}t.realcaseSync=T;async function C(w){try{return await R.Promises.realpath(w)}catch(E){const b=g(w);return await R.Promises.access(b,m.constants.R_OK),b}}t.realpath=C;function f(w){try{return m.realpathSync(w)}catch(E){const b=g(w);return m.accessSync(b,m.constants.R_OK),b}}t.realpathSync=f;function g(w){return O.rtrim(I.normalize(w),I.sep)}}),define(J[64],Y([0,1,9,31,3]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var f;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(f||(f={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class E{constructor(o,e,i){this.exePath=o,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:r=!1}={}){return r?g===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function A({useAlternateBitness:r=!1,findPreview:o=!1}={}){const e=b({useAlternateBitness:r});if(!e)return null;const i=I.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const P of await m.Promises.readdir(i)){let z=-1;if(o){const M=P.indexOf("-");if(M<0)continue;const j=P.substring(0,M);if(!R.test(j)||P.substring(M+1)!=="preview")continue;z=parseInt(j,10)}else{if(!R.test(P))continue;z=parseInt(P,10)}if(z<=n)continue;const F=I.join(i,P,"pwsh.exe");!await m.SymlinkSupport.existsFile(F)||(s=F,n=z)}if(!s)return null;const u=e.includes("x86")?" (x86)":"",v=o?" Preview":"";return new E(s,`PowerShell${v}${u}`,!0)}async function c({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const o=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await m.Promises.readdir(o))if(e.test(n)){const s=I.join(o,n,"pwsh.exe");return new E(s,i)}return null}function h(){const r=I.join(O.homedir(),".dotnet","tools","pwsh.exe");return new E(r,".NET Core PowerShell Global Tool")}function S(){const r=I.join(process.env.windir,g===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(r,"Windows PowerShell",!0)}async function*L(){let r=await A();r&&(yield r),r=await A({useAlternateBitness:!0}),r&&(yield r),r=await c(),r&&(yield r),r=h(),r&&(yield r),r=await A({findPreview:!0}),r&&(yield r),r=await c({findPreview:!0}),r&&(yield r),r=await A({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=S(),r&&(yield r)}async function*D(){for await(const r of L())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=D;async function p(){for await(const r of D())return r;return null}t.getFirstAvailablePowerShellInstallation=p}),define(J[65],Y([0,1,3,36,14,125,2,9]),function($,t,m,O,I,R,T,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function f(E,b,A){return w({path:E,isDirectory:!1},b,A)}t.watchFile=f;function g(E,b,A){return w({path:E,isDirectory:!0},b,A)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function w(E,b,A){const c=m.basename(E.path),h=new Map;let S=!1,L=[T.toDisposable(()=>{h.forEach(D=>T.dispose(D)),h.clear()})];try{const D=O.watch(E.path);L.push(T.toDisposable(()=>{D.removeAllListeners(),D.close()}));const p=new Set;E.isDirectory&&C.Promises.readdir(E.path).then(r=>r.forEach(o=>p.add(o))),D.on("error",(r,o)=>{S||A(`Failed to watch ${E.path} for changes using fs.watch() (${r}, ${o})`)}),D.on("change",(r,o)=>{if(S)return;let e="";if(o&&(e=o.toString(),I.isMacintosh&&(e=R.normalizeNFC(e))),!e||r!=="change"&&r!=="rename")return;const i=E.isDirectory?m.join(E.path,e):E.path;if(E.isDirectory)if(r==="rename"){const n=h.get(i);n&&T.dispose(n);const s=setTimeout(async()=>{h.delete(i);const u=await C.Promises.exists(i);if(S)return;let v;u?p.has(e)?v="changed":(v="added",p.add(e)):(p.delete(e),v="deleted"),b(v,i)},t.CHANGE_BUFFER_DELAY);h.set(i,T.toDisposable(()=>clearTimeout(s)))}else{let n;p.has(e)?n="changed":(n="added",p.add(e)),b(n,i)}else if(r==="rename"||e!==c){const n=setTimeout(async()=>{const s=await C.Promises.exists(i);S||(s?(b("changed",i),L=[w(E,b,A)]):b("deleted",i))},t.CHANGE_BUFFER_DELAY);T.dispose(L),L=[T.toDisposable(()=>clearTimeout(n))]}else b("changed",i)})}catch(D){C.Promises.exists(E.path).then(p=>{p&&!S&&A(`Failed to watch ${E.path} for changes using fs.watch() (${D.toString()})`)})}return T.toDisposable(()=>{S=!0,L=T.dispose(L)})}});var ue=this&&this.__decorate||function($,t,m,O){var I=arguments.length,R=I<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,m):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($,t,m,O);else for(var C=$.length-1;C>=0;C--)(T=$[C])&&(R=(I<3?T(R):I>3?T(t,m,R):T(t,m))||R);return I>3&&R&&Object.defineProperty(t,m,R),R};define(J[37],Y([0,1,10,2,4,26,12,16,22,13,60,19,44]),function($,t,m,O,I,R,T,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var A;(function(l){l[l.Promise=100]="Promise",l[l.PromiseCancel=101]="PromiseCancel",l[l.EventListen=102]="EventListen",l[l.EventDispose=103]="EventDispose"})(A=t.RequestType||(t.RequestType={}));function c(l){switch(l){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(l){l[l.Initialize=200]="Initialize",l[l.PromiseSuccess=201]="PromiseSuccess",l[l.PromiseError=202]="PromiseError",l[l.PromiseErrorObj=203]="PromiseErrorObj",l[l.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function S(l){switch(l){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var L;(function(l){l[l.Uninitialized=0]="Uninitialized",l[l.Idle=1]="Idle"})(L||(L={}));class D{constructor(a){this.buffer=a,this.pos=0}read(a){const d=this.buffer.slice(this.pos,this.pos+a);return this.pos+=d.byteLength,d}}class p{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(a){this.buffers.push(a)}}var r;(function(l){l[l.Undefined=0]="Undefined",l[l.String=1]="String",l[l.Buffer=2]="Buffer",l[l.VSBuffer=3]="VSBuffer",l[l.Array=4]="Array",l[l.Object=5]="Object"})(r||(r={}));function o(l){const a=C.VSBuffer.alloc(4);return a.writeUInt32BE(l,0),a}function e(l){return l.read(4).readUInt32BE(0)}function i(l){const a=C.VSBuffer.alloc(1);return a.writeUInt8(l,0),a}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},s=typeof Buffer!="undefined";function u(l,a){if(typeof a=="undefined")l.write(n.Undefined);else if(typeof a=="string"){const d=C.VSBuffer.fromString(a);l.write(n.String),l.write(o(d.byteLength)),l.write(d)}else if(s&&Buffer.isBuffer(a)){const d=C.VSBuffer.wrap(a);l.write(n.Buffer),l.write(o(d.byteLength)),l.write(d)}else if(a instanceof C.VSBuffer)l.write(n.VSBuffer),l.write(o(a.byteLength)),l.write(a);else if(Array.isArray(a)){l.write(n.Array),l.write(o(a.length));for(const d of a)u(l,d)}else{const d=C.VSBuffer.fromString(JSON.stringify(a));l.write(n.Object),l.write(o(d.byteLength)),l.write(d)}}function v(l){switch(l.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return l.read(e(l)).toString();case r.Buffer:return l.read(e(l)).buffer;case r.VSBuffer:return l.read(e(l));case r.Array:{const d=e(l),y=[];for(let k=0;k<d;k++)y.push(v(l));return y}case r.Object:return JSON.parse(l.read(e(l)).toString())}}class P{constructor(a,d,y=null,k=1e3){this.protocol=a,this.ctx=d,this.logger=y,this.timeoutDelay=k,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(a,d){this.channels.set(a,d),setTimeout(()=>this.flushPendingRequests(a),0)}sendResponse(a){switch(a.type){case 200:{const d=this.send([a.type]);this.logger&&this.logger.logOutgoing(d,0,1,S(a.type));return}case 201:case 202:case 204:case 203:{const d=this.send([a.type,a.id],a.data);this.logger&&this.logger.logOutgoing(d,a.id,1,S(a.type),a.data);return}}}send(a,d=void 0){const y=new p;return u(y,a),u(y,d),this.sendBuffer(y.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(d){return 0}}onRawMessage(a){const d=new D(a),y=v(d),k=v(d),N=y[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(a.byteLength,y[1],1,`${c(N)}: ${y[2]}.${y[3]}`,k),this.onPromise({type:N,id:y[1],channelName:y[2],name:y[3],arg:k});case 102:return this.logger&&this.logger.logIncoming(a.byteLength,y[1],1,`${c(N)}: ${y[2]}.${y[3]}`,k),this.onEventListen({type:N,id:y[1],channelName:y[2],name:y[3],arg:k});case 101:return this.logger&&this.logger.logIncoming(a.byteLength,y[1],1,`${c(N)}`),this.disposeActiveRequest({type:N,id:y[1]});case 103:return this.logger&&this.logger.logIncoming(a.byteLength,y[1],1,`${c(N)}`),this.disposeActiveRequest({type:N,id:y[1]})}}onPromise(a){const d=this.channels.get(a.channelName);if(!d){this.collectPendingRequest(a);return}const y=new R.CancellationTokenSource;let k;try{k=d.call(this.ctx,a.name,a.arg,y.token)}catch(B){k=Promise.reject(B)}const N=a.id;k.then(B=>{this.sendResponse({id:N,data:B,type:201}),this.activeRequests.delete(a.id)},B=>{B instanceof Error?this.sendResponse({id:N,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:N,data:B,type:203}),this.activeRequests.delete(a.id)});const x=O.toDisposable(()=>y.cancel());this.activeRequests.set(a.id,x)}onEventListen(a){const d=this.channels.get(a.channelName);if(!d){this.collectPendingRequest(a);return}const y=a.id,N=d.listen(this.ctx,a.name,a.arg)(x=>this.sendResponse({id:y,data:x,type:204}));this.activeRequests.set(a.id,N)}disposeActiveRequest(a){const d=this.activeRequests.get(a.id);d&&(d.dispose(),this.activeRequests.delete(a.id))}collectPendingRequest(a){let d=this.pendingRequests.get(a.channelName);d||(d=[],this.pendingRequests.set(a.channelName,d));const y=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===100&&this.sendResponse({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);d.push({request:a,timeoutTimer:y})}flushPendingRequests(a){const d=this.pendingRequests.get(a);if(d){for(const y of d)switch(clearTimeout(y.timeoutTimer),y.request.type){case 100:this.onPromise(y.request);break;case 102:this.onEventListen(y.request);break}this.pendingRequests.delete(a)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var z;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(z=t.RequestInitiator||(t.RequestInitiator={}));class F{constructor(a,d=null){this.protocol=a,this.isDisposed=!1,this.state=L.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(y=>this.onBuffer(y)),this.logger=d}getChannel(a){const d=this;return{call(y,k,N){return d.isDisposed?Promise.reject(T.canceled()):d.requestPromise(a,y,k,N)},listen(y,k){return d.isDisposed?Promise.reject(T.canceled()):d.requestEvent(a,y,k)}}}requestPromise(a,d,y,k=R.CancellationToken.None){const N=this.lastRequestId++,B={id:N,type:100,channelName:a,name:d,arg:y};if(k.isCancellationRequested)return Promise.reject(T.canceled());let W;return new Promise((K,Z)=>{if(k.isCancellationRequested)return Z(T.canceled());const te=()=>{const Oe=Te=>{switch(Te.type){case 201:this.handlers.delete(N),K(Te.data);break;case 202:this.handlers.delete(N);const Se=new Error(Te.data.message);Se.stack=Te.data.stack,Se.name=Te.data.name,Z(Se);break;case 203:this.handlers.delete(N),Z(Te.data);break}};this.handlers.set(N,Oe),this.sendRequest(B)};let ae=null;this.state===L.Idle?te():(ae=I.createCancelablePromise(Oe=>this.whenInitialized()),ae.then(()=>{ae=null,te()}));const me=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:N,type:101}),Z(T.canceled())},ve=k.onCancellationRequested(me);W=O.combinedDisposable(O.toDisposable(me),ve),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(a,d,y){const k=this.lastRequestId++,x={id:k,type:102,channelName:a,name:d,arg:y};let B=null;const W=new m.Emitter({onFirstListenerAdd:()=>{B=I.createCancelablePromise(K=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(W),this.sendRequest(x)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(W),this.sendRequest({id:k,type:103}))}}),_=K=>W.fire(K.data);return this.handlers.set(k,_),W.event}sendRequest(a){switch(a.type){case 100:case 102:{const d=this.send([a.type,a.id,a.channelName,a.name],a.arg);this.logger&&this.logger.logOutgoing(d,a.id,0,`${c(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case 101:case 103:{const d=this.send([a.type,a.id]);this.logger&&this.logger.logOutgoing(d,a.id,0,c(a.type));return}}}send(a,d=void 0){const y=new p;return u(y,a),u(y,d),this.sendBuffer(y.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(d){return 0}}onBuffer(a){const d=new D(a),y=v(d),k=v(d),N=y[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(a.byteLength,0,0,S(N)),this.onResponse({type:y[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(a.byteLength,y[1],0,S(N),k),this.onResponse({type:y[0],id:y[1],data:k})}}onResponse(a){if(a.type===200){this.state=L.Idle,this._onDidInitialize.fire();return}const d=this.handlers.get(a.id);d&&d(a)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===L.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}ue([b.memoize],F.prototype,"onDidInitializePromise",null),t.ChannelClient=F;class M{constructor(a){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,a(({protocol:d,onDidClientDisconnect:y})=>{m.Event.once(d.onMessage)(N=>{const x=new D(N),B=v(x),W=new P(d,B),_=new F(d);this.channels.forEach((Z,te)=>W.registerChannel(te,Z));const K={channelServer:W,channelClient:_,ctx:B};this._connections.add(K),this._onDidAddConnection.fire(K),y(()=>{W.dispose(),_.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const a=[];return this._connections.forEach(d=>a.push(d)),a}getChannel(a,d){const y=this;return{call(k,N,x){let B;if(g.isFunction(d)){let _=f.getRandomElement(y.connections.filter(d));B=_?Promise.resolve(_):m.Event.toPromise(m.Event.filter(y.onDidAddConnection,d))}else B=d.routeCall(y,k,N);const W=B.then(_=>_.channelClient.getChannel(a));return q(W).call(k,N,x)},listen(k,N){if(g.isFunction(d))return y.getMulticastEvent(a,d,k,N);const x=d.routeEvent(y,k,N).then(B=>B.channelClient.getChannel(a));return q(x).listen(k,N)}}}getMulticastEvent(a,d,y,k){const N=this;let x=new O.DisposableStore;const B=new m.Emitter({onFirstListenerAdd:()=>{x=new O.DisposableStore;const W=new m.EventMultiplexer,_=new Map,K=te=>{const me=te.channelClient.getChannel(a).listen(y,k),ve=W.add(me);_.set(te,ve)},Z=te=>{const ae=_.get(te);!ae||(ae.dispose(),_.delete(te))};N.connections.filter(d).forEach(K),m.Event.filter(N.onDidAddConnection,d)(K,void 0,x),N.onDidRemoveConnection(Z,void 0,x),W.event(B.fire,B,x),x.add(W)},onLastListenerRemove:()=>{x.dispose()}});return B.event}registerChannel(a,d){this.channels.set(a,d),this._connections.forEach(y=>{y.channelServer.registerChannel(a,d)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=M;class j{constructor(a,d,y=null){const k=new p;u(k,d),a.send(k.buffer),this.channelClient=new F(a,y),this.channelServer=new P(a,d,y)}getChannel(a){return this.channelClient.getChannel(a)}registerChannel(a,d){this.channelServer.registerChannel(a,d)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=j;function q(l){return{call(a,d,y){return l.then(k=>k.call(a,d,y))},listen(a,d){const y=new m.Relay;return l.then(k=>y.input=k.listen(a,d)),y.event}}}t.getDelayedChannel=q;function X(l){let a=!1;return{call(d,y,k){return a?l.call(d,y,k):I.timeout(0).then(()=>a=!0).then(()=>l.call(d,y,k))},listen(d,y){if(a)return l.listen(d,y);const k=new m.Relay;return I.timeout(0).then(()=>a=!0).then(()=>k.input=l.listen(d,y)),k.event}}}t.getNextTickChannel=X;class ee{constructor(a){this.fn=a}routeCall(a){return this.route(a)}routeEvent(a){return this.route(a)}async route(a){for(const d of a.connections)if(await Promise.resolve(this.fn(d.ctx)))return Promise.resolve(d);return await m.Event.toPromise(a.onDidAddConnection),await this.route(a)}}t.StaticRouter=ee;var ie;(function(l){function a(k,N){const x=k,B=N&&N.disableMarshalling,W=new Map;for(const _ in x)y(_)&&W.set(_,m.Event.buffer(x[_],!0));return new class{listen(_,K){const Z=W.get(K);if(Z)return Z;throw new Error(`Event not found: ${K}`)}call(_,K,Z){const te=x[K];if(typeof te=="function"){if(!B&&Array.isArray(Z))for(let ae=0;ae<Z.length;ae++)Z[ae]=w.revive(Z[ae]);return te.apply(x,Z)}throw new Error(`Method not found: ${K}`)}}}l.fromService=a;function d(k,N){const x=N&&N.disableMarshalling;return new Proxy({},{get(B,W){if(typeof W=="string")return N?.properties?.has(W)?N.properties.get(W):y(W)?k.listen(W):async function(..._){let K;N&&!g.isUndefinedOrNull(N.context)?K=[N.context,..._]:K=_;const Z=await k.call(W,K);return x?Z:w.revive(Z)};throw new Error(`Property not found: ${String(W)}`)}})}l.toService=d;function y(k){return k[0]==="o"&&k[1]==="n"&&E.isUpperAsciiLetter(k.charCodeAt(2))}})(ie=t.ProxyChannel||(t.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(l){if(Array.isArray(l))return l;if(l&&typeof l=="object"&&typeof l.toString=="function"){let a=l.toString();if(a!=="[object Object]")return a}return l}function se(l){return Array.isArray(l)?l.map(oe):oe(l)}function re(l,a,d,y,k,N,x){x=se(x);const B=Q[k],W=B[y%B.length];let _=[`%c[${l}]%c[${String(a).padStart(7," ")}]%c[len: ${String(d).padStart(5," ")}]%c${String(y).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(N)?(_=_.concat(x),_.push(")")):_.push(x),console.log.apply(console,_)}t.logWithColors=re;class U{constructor(a,d){this._outgoingPrefix=a,this._incomingPrefix=d,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(a,d,y,k,N){this._totalOutgoing+=a,re(this._outgoingPrefix,this._totalOutgoing,a,d,y,k,N)}logIncoming(a,d,y,k,N){this._totalIncoming+=a,re(this._incomingPrefix,this._totalIncoming,a,d,y,k,N)}}t.IPCLogger=U}),define(J[66],Y([0,1,2,10,4,13]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var C;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(C||(C={}));class f extends m.Disposable{constructor(E,b=Object.create(null)){super();this.database=E,this.options=b,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((b,A)=>this.accept(A,b)),E.deleted?.forEach(b=>this.accept(b,void 0))}accept(E,b){if(this.state===C.Closed)return;let A=!1;R.isUndefinedOrNull(b)?A=this.cache.delete(E):this.cache.get(E)!==b&&(this.cache.set(E,b),A=!0),A&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,b){const A=this.cache.get(E);return R.isUndefinedOrNull(A)?b:A}getBoolean(E,b){const A=this.get(E);return R.isUndefinedOrNull(A)?b:A==="true"}getNumber(E,b){const A=this.get(E);return R.isUndefinedOrNull(A)?b:parseInt(A,10)}async set(E,b){if(this.state===C.Closed)return;if(R.isUndefinedOrNull(b))return this.delete(E);const A=String(b);if(this.cache.get(E)!==A)return this.cache.set(E,A),this.pendingInserts.set(E,A),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===C.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((b,A)=>this.items.set(A,b)),E.delete&&E.delete.forEach(b=>this.items.delete(b))}async close(){}}t.InMemoryStorageDatabase=g}),define(J[67],Y([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const O=60,I=O*60,R=I*24,T=R*7,C=R*30,f=R*365;function g(E,b){typeof E!="number"&&(E=E.getTime());const A=Math.round((new Date().getTime()-E)/1e3);if(A<-30)return m.localize(0,null,g(new Date().getTime()+A*1e3,!1));if(A<30)return m.localize(1,null);let c;return A<O?(c=A,b?c===1?m.localize(2,null,c):m.localize(3,null,c):c===1?m.localize(4,null,c):m.localize(5,null,c)):A<I?(c=Math.floor(A/O),b?c===1?m.localize(6,null,c):m.localize(7,null,c):c===1?m.localize(8,null,c):m.localize(9,null,c)):A<R?(c=Math.floor(A/I),b?c===1?m.localize(10,null,c):m.localize(11,null,c):c===1?m.localize(12,null,c):m.localize(13,null,c)):A<T?(c=Math.floor(A/R),b?c===1?m.localize(14,null,c):m.localize(15,null,c):c===1?m.localize(16,null,c):m.localize(17,null,c)):A<C?(c=Math.floor(A/T),b?c===1?m.localize(18,null,c):m.localize(19,null,c):c===1?m.localize(20,null,c):m.localize(21,null,c)):A<f?(c=Math.floor(A/C),b?c===1?m.localize(22,null,c):m.localize(23,null,c):c===1?m.localize(24,null,c):m.localize(25,null,c)):(c=Math.floor(A/f),b?c===1?m.localize(26,null,c):m.localize(27,null,c):c===1?m.localize(28,null,c):m.localize(29,null,c))}t.fromNow=g;function w(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=w}),define(J[69],Y([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,69,13,22]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(g,w){return w&&(g.stack||g.stacktrace)?m.localize(0,null,C(g),T(g.stack)||T(g.stacktrace)):C(g)}function T(g){return Array.isArray(g)?g.join(`
`):g}function C(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?m.localize(1,null,g.message):g.message||m.localize(2,null)}function f(g=null,w=!1){if(!g)return m.localize(3,null);if(Array.isArray(g)){const E=I.coalesce(g),b=f(E[0],w);return E.length>1?m.localize(4,null,b,E.length):b}if(O.isString(g))return g;if(g.detail){const E=g.detail;if(E.error)return R(E.error,w);if(E.exception)return R(E.exception,w)}return g.stack?R(g,w):g.message?g.message:m.localize(5,null)}t.toErrorMessage=f}),define(J[70],Y([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(J[47],Y([0,1,3,9,32,70,33,13,20,35,14,46,8]),function($,t,m,O,I,R,T,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function A(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(r,o){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=I.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,u)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?A(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{I.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,s,u)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function h(r=T.env){return r.comspec||"cmd.exe"}t.getWindowsShell=h;class S{constructor(o,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=n;else{const s=o;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(T.env).forEach(u=>{s[u]=T.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(m.sep);return e!==-1&&(o=o.substring(e+1)),S.WellKnowCommands[o]?o:"other"}start(o){return w.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(T.cwd()))?Promise.reject(new Error(R.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((u,v)=>{i=u,n=v});if(e){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=I.exec(u,this.options,(v,P,z)=>{this.childProcess=null;const F=v;F&&F.killed?n({killed:this.terminateRequested,stdout:P.toString(),stderr:z.toString()}):this.handleExec(i,o,v,P,z)})}else{let u=null;const v=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,i,o,n);const z={terminated:this.terminateRequested};C.isNumber(P)&&(z.cmdCode=P),i(z)};if(this.shell&&w.isWindows){const P=f.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let z=!1,F=!1;const M=[];let j=this.ensureQuotes(this.cmd);M.push(j.value),z=j.quoted,this.args&&this.args.forEach(X=>{j=this.ensureQuotes(X),M.push(j.value),F=F&&j.quoted});const q=["/s","/c"];z?F?q.push('"'+M.join(" ")+'"'):M.length>1?q.push('"'+M[0]+'" '+M.slice(1).join(" ")):q.push('"'+M[0]+'"'):q.push(M.join(" ")),u=I.spawn(h(),q,P)}else this.cmd&&(u=I.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",P=>{this.childProcess=null,n({terminated:this.terminateRequested,error:P})}),u.pid&&(this.childProcess.on("close",v),this.handleSpawn(u,i,o,n,!0)))}return s})}handleClose(o,e,i,n){}ensureQuotes(o){return S.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,c(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!w.isWindows)return o(!1);const e=I.spawn(h(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class L extends S{constructor(o,e,i,n){super(o,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,n,s){[n,s].forEach((u,v)=>{const P=new E.LineDecoder;P.write(u).forEach(M=>{e({line:M,source:v===0?0:1})});const F=P.end();F&&e({line:F,source:v===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,n,s){const u=new E.LineDecoder,v=new E.LineDecoder;o.stdout.on("data",P=>{u.write(P).forEach(F=>i({line:F,source:0}))}),o.stderr.on("data",P=>{v.write(P).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=v}handleClose(o,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}t.LineProcess=L;function D(r){let o=[],e=!1;const i=function(n){if(e){o.push(n);return}(!r.send(n,u=>{if(u&&console.error(u),e=!1,o.length>0){const v=o.slice(0);o=[],v.forEach(P=>i(P))}})||w.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=D;var p;(function(r){async function o(e,i,n){if(m.isAbsolute(e))return e;if(i===void 0&&(i=T.cwd()),m.dirname(e)!=="."||(n===void 0&&C.isString(T.env.PATH)&&(n=T.env.PATH.split(m.delimiter)),n===void 0||n.length===0))return m.join(i,e);async function u(v){return await O.Promises.exists(v)?!(await O.Promises.stat(v)).isDirectory():!1}for(let v of n){let P;if(m.isAbsolute(v)?P=m.join(v,e):P=m.join(i,v,e),await u(P))return P;let z=P+".com";if(await u(z)||(z=P+".exe",await u(z)))return z}return m.join(i,e)}r.findExecutable=o})(p=t.win32||(t.win32={}))}),define(J[71],Y([0,1,31,14,64,47]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(A,c){return A===1?O.isWindows?E():R.getWindowsShell(c):g(A,c)}t.getSystemShell=T;function C(A,c){return A===1?O.isWindows?b(c):R.getWindowsShell(c):g(A,c)}t.getSystemShellSync=C;let f=null;function g(A,c){if(O.isLinux&&A===2||O.isMacintosh&&A===3)return"/bin/bash";if(!f){let h;if(O.isWindows)h="/bin/bash";else{if(h=c.SHELL,!h)try{h=m.userInfo().shell}catch(S){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}f=h}return f}let w=null;async function E(){return w||(w=(await I.getFirstAvailablePowerShellInstallation()).exePath),w}function b(A){if(w)return w;const c=O.isWindows&&parseFloat(m.release())>=10,h=A.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${A.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?S:R.getWindowsShell(A)}}),define(J[48],Y([0,1,32,2,4,20,10,47,37,59,26,12,16,14]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends f.ChannelServer{constructor(L){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(p){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",D=>b.VSBuffer.wrap(Buffer.from(D,"base64")))},L);process.once("disconnect",()=>this.dispose())}}t.Server=c;class h{constructor(L,D){this.modulePath=L,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new I.Delayer(p),this.child=null,this._client=null}getChannel(L){const D=this;return{call(p,r,o){return D.requestPromise(L,p,r,o)},listen(p,r){return D.requestEvent(L,p,r)}}}requestPromise(L,D,p,r=w.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(L),e=I.createCancelablePromise(s=>o.call(D,p,s)),i=r.onCancellationRequested(()=>e.cancel()),n=O.toDisposable(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(L,D,p){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let r;const o=new T.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(L).listen(D,p)(o.fire,o),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const L=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env={...R.deepClone(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(D.env={...D.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),A.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,L,D);const p=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(g.isRemoteConsoleLog(u)){g.log(u,`IPC Library: ${this.options.serverName}`);return}p.fire(b.VSBuffer.wrap(Buffer.from(u,"base64")))});const o=this.options.useQueue?C.createQueuedSender(this.child):this.child,e=u=>this.child&&this.child.connected&&o.send(u.buffer.toString("base64")),i=p.event,n={send:e,onMessage:i};this._client=new f.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,v)=>{process.removeListener("exit",s),this.activeRequests.forEach(P=>O.dispose(P)),this.activeRequests.clear(),u!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+v),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:v})})}return this._client}getCachedChannel(L){let D=this.channels.get(L);return D||(D=this.client.getChannel(L),this.channels.set(L,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=h}),define(J[72],Y([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(J[73],Y([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[75],Y([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[76],Y([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[77],Y([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[78],Y([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[79],Y([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[80],Y([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(J[81],Y([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(J[82],Y([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[83],Y([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(J[84],Y([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[85],Y([0,1,3,17,44,68,8,7,33]),function($,t,m,O,I,R,T,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(c,h,S){this._args=c,this.paths=h,this.productService=S}get appRoot(){return m.dirname(T.FileAccess.asFileUri("",$).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return O.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return O.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=R.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return O.joinPath(C.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return O.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return O.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=f.env.VSCODE_PORTABLE;return c?C.URI.file(m.join(c,"argv.json")):O.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return O.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?m.resolve(c):m.normalize(m.join(T.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?m.resolve(c):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return m.resolve(c);const h=f.env.VSCODE_EXTENSIONS;if(h)return h;const S=f.env.VSCODE_PORTABLE;return S?m.join(S,"extensions"):O.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(h=>/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file(m.normalize(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file(m.normalize(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return O.joinPath(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([I.memoize],g.prototype,"appRoot",null),ue([I.memoize],g.prototype,"userHome",null),ue([I.memoize],g.prototype,"userDataPath",null),ue([I.memoize],g.prototype,"appSettingsHome",null),ue([I.memoize],g.prototype,"tmpDir",null),ue([I.memoize],g.prototype,"userRoamingDataHome",null),ue([I.memoize],g.prototype,"settingsResource",null),ue([I.memoize],g.prototype,"userDataSyncHome",null),ue([I.memoize],g.prototype,"userDataSyncLogResource",null),ue([I.memoize],g.prototype,"sync",null),ue([I.memoize],g.prototype,"machineSettingsResource",null),ue([I.memoize],g.prototype,"globalStorageHome",null),ue([I.memoize],g.prototype,"workspaceStorageHome",null),ue([I.memoize],g.prototype,"keybindingsResource",null),ue([I.memoize],g.prototype,"keyboardLayoutResource",null),ue([I.memoize],g.prototype,"argvResource",null),ue([I.memoize],g.prototype,"snippetsHome",null),ue([I.memoize],g.prototype,"isExtensionDevelopment",null),ue([I.memoize],g.prototype,"untitledWorkspacesHome",null),ue([I.memoize],g.prototype,"installSourcePath",null),ue([I.memoize],g.prototype,"builtinExtensionsPath",null),ue([I.memoize],g.prototype,"extensionsPath",null),ue([I.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ue([I.memoize],g.prototype,"extensionDevelopmentKind",null),ue([I.memoize],g.prototype,"extensionTestsLocationURI",null),ue([I.memoize],g.prototype,"debugExtensionHost",null),ue([I.memoize],g.prototype,"serviceMachineIdResource",null),ue([I.memoize],g.prototype,"telemetryLogResource",null),ue([I.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function w(A,c){return b(A["inspect-extensions"],A["inspect-brk-extensions"],5870,c,A.debugId)}t.parseExtensionHostPort=w;function E(A,c){return b(A["inspect-search"],A["inspect-brk-search"],5876,c)}t.parseSearchPort=E;function b(A,c,h,S,L){const p=Number(c||A)||(S?null:h),r=p?Boolean(!!c):!1;return{port:p,break:r,debugId:L}}}),function(){"use strict";function $(t,m,O,I){function R(C){const f=T(C),g=[f];return t.isAbsolute(f)||g.unshift(I),t.resolve(...g)}function T(C){const f=process.env.VSCODE_PORTABLE;if(f)return t.join(f,"user-data");const g=C["user-data-dir"];if(g)return g;let w=process.env.VSCODE_APPDATA;if(!w)switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=t.join(E,"AppData","Roaming")}break;case"darwin":w=t.join(m.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(w,O)}return{getUserDataPath:R}}if(typeof define=="function")define(J[86],Y([0,87,31,8,17,33]),function(t,m,O,I,R,T){const C=R.dirname(I.FileAccess.asFileUri("",t)),f=t.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return $(m,O,f.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),O=require("os");module.exports=$(m,O,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[88],Y([0,1,31,86,85]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends I.AbstractNativeEnvironmentService{constructor(C,f){super(C,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:O.getUserDataPath(C)},f)}}t.NativeEnvironmentService=R}),define(J[89],Y([0,1,20]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const O=/^%([\w\d.-]+)%$/i;function I(R,T){const C=f=>{if(typeof f!="string")return;const g=O.exec(f);if(!g)return;const w=T[g[1]]??f;return typeof w=="string"?w:typeof w.message=="string"?w.message:f};return m.cloneAndChange(R,C)}t.localizeManifest=I}),define(J[49],Y([0,1,79]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function R(b){return b=b.trim(),b==="*"||O.test(b)}t.isValidVersionStr=R;function T(b){if(!R(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let A=b.match(O);return A?{hasCaret:A[1]==="^",hasGreaterEquals:A[1]===">=",majorBase:A[2]==="x"?0:parseInt(A[2],10),majorMustEqual:A[2]!=="x",minorBase:A[4]==="x"?0:parseInt(A[4],10),minorMustEqual:A[4]!=="x",patchBase:A[6]==="x"?0:parseInt(A[6],10),patchMustEqual:A[6]!=="x",preRelease:A[8]||null}:null}t.parseVersion=T;function C(b){if(!b)return null;let A=b.majorBase,c=b.majorMustEqual,h=b.minorBase,S=b.minorMustEqual,L=b.patchBase,D=b.patchMustEqual;b.hasCaret&&(A===0||(S=!1),D=!1);let p=0;if(b.preRelease){const r=I.exec(b.preRelease);if(r){const[,o,e,i]=r;p=Date.UTC(Number(o),Number(e)-1,Number(i))}}return{majorBase:A,majorMustEqual:c,minorBase:h,minorMustEqual:S,patchBase:L,patchMustEqual:D,isMinimum:b.hasGreaterEquals,notBefore:p}}t.normalizeVersion=C;function f(b,A,c){let h;typeof b=="string"?h=C(T(b)):h=b;let S;A instanceof Date?S=A.getTime():typeof A=="string"&&(S=new Date(A).getTime());let L;if(typeof c=="string"?L=C(T(c)):L=c,!h||!L)return!1;let D=h.majorBase,p=h.minorBase,r=h.patchBase,o=L.majorBase,e=L.minorBase,i=L.patchBase,n=L.notBefore,s=L.majorMustEqual,u=L.minorMustEqual,v=L.patchMustEqual;return L.isMinimum?D>o?!0:D<o?!1:p>e?!0:p<e||S&&S<n?!1:r>=i:(D===1&&o===0&&(!s||!u||!v)&&(o=1,e=0,i=0,s=!0,u=!1,v=!1),D<o?!1:D>o?!s:p<e?!1:p>e?!u:r<i?!1:r>i?!v:!(S&&S<n))}t.isValidVersion=f;function g(b,A,c,h){return c.isBuiltin||typeof c.main=="undefined"?!0:E(b,A,c.engines.vscode,h)}t.isValidExtensionVersion=g;function w(b,A,c){return b==="*"||E(A,c,b)}t.isEngineValid=w;function E(b,A,c,h=[]){let S=C(T(c));if(!S)return h.push(m.localize(0,null,c)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return h.push(m.localize(1,null,c)),!1}else if(!S.majorMustEqual)return h.push(m.localize(2,null,c)),!1;return f(b,A,S)?!0:(h.push(m.localize(3,null,b,c)),!1)}}),define(J[90],Y([0,1,37,48,2,8]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends I.Disposable{constructor(f,g,w,E){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new O.Client(R.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(J[91],Y([0,1,37,48,2,8]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends I.Disposable{constructor(f,g,w,E,b={}){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=E,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new O.Client(R.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(J[92],Y([0,1,32,46,61,8]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(f,g,w,E,b){this.watchedFolder=f,this.eventCallback=w,this.logCallback=E,this.verboseLogging=b,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(A=>I.parse(A)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=m.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,f);const g=new O.LineDecoder;this.handle.stdout.on("data",w=>{const E=[];for(const b of g.write(w)){const A=b.split("|");if(A.length===2){const c=Number(A[0]),h=A[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(S=>S(h))){this.verboseLogging&&this.log(h);continue}E.push({type:T.changeTypeMap[c],path:h})}else this.log(A[1])}}E.length>0&&this.eventCallback(E)}),this.handle.on("error",w=>this.onError(w)),this.handle.stderr.on("data",w=>this.onError(w)),this.handle.on("exit",(w,E)=>this.onExit(w,E))}onError(f){this.error("process error: "+f.toString())}onExit(f,g){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${g})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(J[93],Y([0,1,92,3,19]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R{constructor(C,f,g,w){this.onDidFilesChange=f,this.onLogMessage=g,this.verboseLogging=w,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=I.rtrim(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=R}),define(J[50],Y([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class m{constructor(R,T=[],C=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=m;const O=(I,...R)=>new m(I,R);t.createSyncDescriptor=O}),define(J[94],Y([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=m;class O{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const C=this.lookupOrInsertNode(R),f=this.lookupOrInsertNode(T);C.outgoing.set(this._hashFn(T),f),f.incoming.set(this._hashFn(R),C)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(let C of this._nodes.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let C=this._nodes.get(T);return C||(C=new m(R),this._nodes.set(T,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[T,C]of this._nodes)R.push(`${T}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,T]of this._nodes){const C=new Set([R]),f=this._findCycle(T,C);if(f)return f}}_findCycle(R,T){for(let[C,f]of R.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const g=this._findCycle(f,T);if(g)return g;T.delete(C)}}}t.Graph=O}),define(J[95],Y([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=m.createDecorator("downloadService")}),define(J[21],Y([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=m.createDecorator("environmentService"),t.INativeEnvironmentService=m.refineServiceDecorator(t.IEnvironmentService)}),define(J[23],Y([0,1,74,11,8]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function R(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}t.isIExtensionIdentifier=R;var T;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=5]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var C;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(C=t.SortOrder||(t.SortOrder={}));var f;(function(E){E.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var g;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(g=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=O.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(b,A){super(b);this.code=A,this.name=A}}t.ExtensionManagementError=w,t.IExtensionManagementService=O.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=O.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=O.createDecorator("IExtensionTipsService"),t.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=m.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=m.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=O.createDecorator("IExtensionManagementCLIService")}),define(J[38],Y([0,1,19,11]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkpaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}t.getWorkpaceSupportTypeMessage=I;function R(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,b){if(typeof E=="undefined"||E===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof E=="string"||typeof b=="string"){let A=typeof E=="string"?E:E.value,c=typeof b=="string"?b:b.value;return m.equalsIgnoreCase(A,c)}return E._lower===b._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}t.ExtensionIdentifier=C;function f(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}t.isLanguagePackExtension=f;function g(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=O.createDecorator("IBuiltinExtensionsScannerService")}),define(J[24],Y([0,1,19,38]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:m.compareIgnoreCase(c.id,h.id)===0}t.areSameExtensions=I;class R{constructor(h,S){this.version=S,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof R?I(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=R;function T(c,h){return`${c}.${h}`}t.getExtensionId=T;function C(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=C;function f(c,h){return C(T(c,h))}t.getGalleryExtensionId=f;function g(c,h){const S=[],L=D=>{for(const p of S)if(p.some(r=>I(h(r),h(D))))return p;return null};for(const D of c){const p=L(D);p?p.push(D):S.push([D])}return S}t.groupByExtension=g;function w(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=w;function E(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=E,t.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function b(c){const h=new Set;for(const S of c)S.malicious&&h.add(S.id.id);return h}t.getMaliciousExtensionsSet=b;function A(c,h){const S=[],L=h.manifest.extensionDependencies?.slice(0)??[];for(;L.length;){const D=L.shift();if(D&&S.every(p=>!I(p.identifier,{id:D}))){const p=c.filter(r=>I(r.identifier,{id:D}));p.length===1&&(S.push(p[0]),L.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}t.getExtensionDependencies=A});var fe=this&&this.__param||function($,t){return function(m,O){t(m,O,$)}};define(J[96],Y([0,1,75,12,7,39,23,24,38,62,26,8]),function($,t,m,O,I,R,T,C,f,g,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const b=D=>m.localize(0,null,D),A=m.localize(1,null,"ms-dotnettools.csharp");function c(D,p){return p?`${D.publisher}.${D.name}@${D.version}`:`${D.publisher}.${D.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(D){const p=h.exec(D);return p&&p[1]?[C.adoptToGalleryExtensionId(p[1]),p[2]]:[C.adoptToGalleryExtensionId(D),void 0]}t.getIdAndVersion=S;let L=class{constructor(p,r){this.extensionManagementService=p,this.extensionGalleryService=r}get location(){}async listExtensions(p,r,o=console){let e=await this.extensionManagementService.getInstalled(1);const i=f.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(v=>v.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){o.log("Possible Categories: "),i.forEach(s=>{o.log(s)});return}this.location&&o.log(m.localize(2,null,this.location)),e=e.sort((s,u)=>s.identifier.id.localeCompare(u.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,o.log(c(s.manifest,p)))}async installExtensions(p,r,o,e,i=console){const n=[],s=[];p.length&&i.log(this.location?m.localize(3,null,this.location):m.localize(4,null));const u=await this.extensionManagementService.getInstalled(1),v=(F,M)=>{const j=u.find(q=>C.areSameExtensions(q.identifier,{id:F}));if(j){if(!M&&!e)return i.log(m.localize(5,null,F,j.manifest.version,F)),!1;if(M&&j.manifest.version===M)return i.log(m.localize(6,null,`${F}@${M}`)),!1}return!0},P=[],z=[];for(const F of p)if(F instanceof I.URI)P.push(F);else{const[M,j]=S(F);v(M,j)&&z.push({id:M,version:j,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const F of r){const[M,j]=S(F);v(M,j)&&z.push({id:M,version:j,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async F=>{try{const M=await this.installVSIX(F,{isBuiltin:!1,isMachineScoped:o},e,i);M&&s.push(M)}catch(M){i.error(M.message||M.stack||M),n.push(F.toString())}})),z.length){const F=await this.getGalleryExtensions(z);await Promise.all(z.map(async M=>{const j=F.get(M.id.toLowerCase());if(j)try{const q=await this.installFromGallery(M,j,u,e,i);q&&s.push(q)}catch(q){i.error(q.message||q.stack||q),n.push(M.id)}else i.error(`${b(M.version?`${M.id}@${M.version}`:M.id)}
${A}`),n.push(M.id)}))}if(n.length)throw new Error(m.localize(7,null,n.join(", ")))}async installVSIX(p,r,o,e){const i=await this.extensionManagementService.getManifest(p);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,o,e))try{return await this.extensionManagementService.install(p,r),e.log(m.localize(8,null,g.getBaseLabel(p))),i}catch(s){if(O.isPromiseCanceledError(s))return e.log(m.localize(9,null,g.getBaseLabel(p))),null;throw s}return null}async getGalleryExtensions(p){const r=p.filter(({version:i})=>i===void 0).map(({id:i})=>i),o=p.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,w.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(o.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:p,version:r,installOptions:o},e,i,n,s){const u=await this.extensionGalleryService.getManifest(e,w.CancellationToken.None);if(u&&!this.validateExtensionKind(u,s))return null;const v=i.find(P=>C.areSameExtensions(P.identifier,e.identifier));if(v){if(e.version===v.manifest.version)return s.log(m.localize(10,null,r?`${p}@${r}`:p)),null;s.log(m.localize(11,null,p,e.version))}try{return o.isBuiltin?s.log(r?m.localize(12,null,p,r):m.localize(13,null,p)):s.log(r?m.localize(14,null,p,r):m.localize(15,null,p)),await this.extensionManagementService.installFromGallery(e,o),s.log(m.localize(16,null,p,e.version)),u}catch(P){if(O.isPromiseCanceledError(P))return s.log(m.localize(17,null,p)),null;throw P}}validateExtensionKind(p,r){return!0}async validateVSIX(p,r,o){const e={id:C.getGalleryExtensionId(p.publisher,p.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>C.areSameExtensions(e,s.identifier)&&R.gt(s.manifest.version,p.version));return n&&!r?(o.log(m.localize(18,null,n.identifier.id,n.manifest.version,p.version)),!1):this.validateExtensionKind(p,o)}async uninstallExtensions(p,r,o=console){const e=async n=>{if(n instanceof I.URI){const s=await this.extensionManagementService.getManifest(n);return c(s)}return n},i=[];for(const n of p){const s=await e(n),v=(await this.extensionManagementService.getInstalled()).filter(P=>C.areSameExtensions(P.identifier,{id:s}));if(!v.length)throw new Error(`${this.notInstalled(s)}
${A}`);if(v.some(P=>P.type===0)){o.log(m.localize(19,null,s));return}if(!r&&v.some(P=>P.isBuiltin)){o.log(m.localize(20,null,s));return}o.log(m.localize(21,null,s));for(const P of v)await this.extensionManagementService.uninstall(P),i.push(P);this.location?o.log(m.localize(22,null,s,this.location)):o.log(m.localize(23,null,s))}}async locateExtension(p,r=console){const o=await this.extensionManagementService.getInstalled();p.forEach(e=>{o.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===E.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(p){return this.location?m.localize(24,null,p,this.location):m.localize(25,null,p)}};L=ue([fe(0,T.IExtensionManagementService),fe(1,T.IExtensionGalleryService)],L),t.ExtensionManagementCLIService=L}),define(J[97],Y([0,1,2,3,38,9]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends m.Disposable{constructor(f,g){super();this.environmentService=f,this.extensionsManifestCache=O.join(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(w=>this.onDidInstallExtension(w))),this._register(g.onDidUninstallExtension(w=>this.onDidUnInstallExtension(w)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(J[98],Y([0,1,87,32,29,14,126,28,71,26,12]),function($,t,m,O,I,R,T,C,f,g,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function E(c,h,S){return h["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):T.isLaunchedFromCli(S)&&!h["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(T.isLaunchedFromCli(S)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async L=>{const D=new g.CancellationTokenSource,p=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),D.dispose(!0),L({})},1e4);try{const r=await A(c,D.token);L(r)}catch(r){w.isPromiseCanceledError(r)||c.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),L({})}finally{clearTimeout(p),D.dispose()}})),b)}t.resolveShellEnv=E;let b;async function A(c,h){const S=new Promise(async(L,D)=>{const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",r);const o=I.generateUuid().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",i);const n=await f.getSystemShell(R.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),h.isCancellationRequested)return D(w.canceled);const s=m.basename(n);let u,v;/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,v=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,v=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),u);const P=O.spawn(n,[...v,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});h.onCancellationRequested(()=>(P.kill(),D(w.canceled))),P.on("error",M=>{c.error("getUnixShellEnvironment#errorChildProcess",C.toErrorMessage(M)),L({})});const z=[];P.stdout.on("data",M=>z.push(M));const F=[];P.stderr.on("data",M=>F.push(M)),P.on("close",(M,j)=>{const q=Buffer.concat(z).toString("utf8");c.trace("getUnixShellEnvironment#raw",q);const X=Buffer.concat(F).toString("utf8");if(X.trim()&&c.trace("getUnixShellEnvironment#stderr",X),M||j)return D(new Error(`Failed to get environment (code ${M}, signal ${j})`));const ee=e.exec(q),ie=ee?ee[1]:"{}";try{const Q=JSON.parse(ie);p?Q.ELECTRON_RUN_AS_NODE=p:delete Q.ELECTRON_RUN_AS_NODE,r?Q.ELECTRON_NO_ATTACH_CONSOLE=r:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Q),L(Q)}catch(Q){c.error("getUnixShellEnvironment#errorCaught",C.toErrorMessage(Q)),D(Q)}})});try{return await S}catch(L){return c.error("getUnixShellEnvironment#error",C.toErrorMessage(L)),{}}}}),define(J[51],Y([0,1,7,18,14]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function R(f){return f.map(g=>({type:g.type,resource:m.URI.file(g.path)}))}t.toFileChanges=R;function T(f){const g=new C;for(const w of f)g.processEvent(w);return g.normalize()}t.normalizeFileChanges=T;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const w=this.mapPathToChange.get(g.path);if(w){const E=w.type,b=g.type;E===1&&b===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(w),1)):E===2&&b===1?w.type=0:E===1&&b===0||(w.type=b)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],w=[];return this.normalized.filter(E=>E.type!==2?(g.push(E),!1):!0).sort((E,b)=>E.path.length-b.path.length).filter(E=>w.some(b=>O.isParent(E.path,b,!I.isLinux))?!1:(w.push(E.path),!0)).concat(g)}}}),define(J[99],Y([0,1,51,2,9,63,65,4,3]),function($,t,m,O,I,R,T,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends O.Disposable{constructor(E,b,A,c){super();this.path=E,this.onDidFilesChange=b,this.onLogMessage=A,this.verboseLogging=c,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:b}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let A=this.path;if(b)try{A=await R.realpath(A)}catch(c){if(this.onError(c),b.dangling)return}E.isDirectory()?this._register(T.watchFolder(A,(c,h)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:f.join(this.path,f.basename(h))})},c=>this.onError(c))):this._register(T.watchFile(A,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const A=m.normalizeFileChanges(b);if(this.verboseLogging)for(const c of A)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);A.length>0&&this.onDidFilesChange(A)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(J[52],Y([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...I){this._entries=new Map;for(let[R,T]of I)this.set(R,T)}set(I,R){const T=this._entries.get(I);return this._entries.set(I,R),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=m}),define(J[100],Y([0,1,12,94,50,11,52,4]),function($,t,m,O,I,R,T,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const f=!1;class g extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class w{constructor(c=new T.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=h,this._parent=S,this._services.set(R.IInstantiationService,this)}createChild(c){return new w(c,this._strict,this)}invokeFunction(c,...h){let S=b.traceInvocation(c),L=!1;try{return c({get:(p,r)=>{if(L)throw m.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(p,S);if(!o&&r!==R.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return o}},...h)}finally{L=!0,S.stop()}}createInstance(c,...h){let S,L;return c instanceof I.SyncDescriptor?(S=b.traceCreation(c.ctor),L=this._createInstance(c.ctor,c.staticArguments.concat(h),S)):(S=b.traceCreation(c),L=this._createInstance(c,h,S)),S.stop(),L}_createInstance(c,h=[],S){let L=R._util.getServiceDependencies(c).sort((r,o)=>r.index-o.index),D=[];for(const r of L){let o=this._getOrCreateServiceInstance(r.id,S);if(!o&&this._strict&&!r.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`);D.push(o)}let p=L.length>0?L[0].index:h.length;if(h.length!==p){console.warn(`[createInstance] First service dependency of ${c.name} at position ${p+1} conflicts with ${h.length} static arguments`);let r=p-h.length;r>0?h=h.concat(new Array(r)):h=h.slice(0,p)}return new c(...[...h,...D])}_setServiceInstance(c,h){if(this._services.get(c)instanceof I.SyncDescriptor)this._services.set(c,h);else if(this._parent)this._parent._setServiceInstance(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let h=this._services.get(c);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):h}_getOrCreateServiceInstance(c,h){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,h.branch(c,!0)):(h.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,h,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,h,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,h,S){const L=new O.Graph(r=>r.id.toString());let D=0;const p=[{id:c,desc:h,_trace:S}];for(;p.length;){const r=p.pop();if(L.lookupOrInsertNode(r),D++>1e3)throw new g(L);for(let o of R._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const i={id:o.id,desc:e,_trace:r._trace.branch(o.id,!0)};L.insertEdge(r,i),p.push(i)}}}for(;;){const r=L.roots();if(r.length===0){if(!L.isEmpty())throw new g(L);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}L.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,h,S=[],L,D){if(this._services.get(c)instanceof I.SyncDescriptor)return this._createServiceInstance(h,S,L,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,h,S,L,D);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(c,h=[],S,L){if(S){const D=new C.IdleValue(()=>this._createInstance(c,h,L));return new Proxy(Object.create(null),{get(p,r){if(r in p)return p[r];let o=D.value,e=o[r];return typeof e!="function"||(e=e.bind(o),p[r]=e),e},set(p,r,o){return D.value[r]=o,!0}})}else return this._createInstance(c,h,L)}}t.InstantiationService=w;var E;(function(A){A[A.Creation=0]="Creation",A[A.Invocation=1]="Invocation",A[A.Branch=2]="Branch"})(E||(E={}));class b{constructor(c,h){this.type=c,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return f?new b(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(c){return f?new b(0,c.name):b._None}branch(c,h){let S=new b(2,c.toString());return this._dep.push([c,h,S]),S}stop(){let c=Date.now()-this._start;b._totals+=c;let h=!1;function S(D,p){let r=[],o=new Array(D+1).join("	");for(const[e,i,n]of p._dep)if(i&&n){h=!0,r.push(`${o}CREATES -> ${e}`);let s=S(D+1,n);s&&r.push(s)}else r.push(`${o}uses -> ${e}`);return r.join(`
`)}let L=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(c>2||h)&&console.log(L.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(J[53],Y([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=m.createDecorator("localizationsService");function O(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const R of I.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=O}),define(J[15],Y([0,1,11,2,14,10,28]),function($,t,m,O,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=m.createDecorator("logService"),t.ILoggerService=m.createDecorator("loggerService");function C(){return new Date().toISOString()}var f;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(f=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=f.Info;class g extends O.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class w extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(f.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=w;class E extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}debug(e,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}info(e,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}warn(e,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,e,...i):console.warn(`[main ${C()}]`,e,...i))}error(e,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}critical(e,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=E;class b extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=b;class A extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:T.toErrorMessage(e,this.getLevel()<=f.Trace)}dispose(){}flush(){}}t.AdapterLogger=A;class c extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class h extends O.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=h;class S extends O.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?f.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=S;class L{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return f.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=L;function D(o){if(o.verbose)return f.Trace;if(typeof o.logLevel=="string"){const e=p(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=D;function p(o){switch(o){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}t.parseLogLevel=p;function r(o){switch(o){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}t.LogLevelToString=r}),define(J[101],Y([0,1,9,2,18,23,21,7,17,24,15,29,39,14,4,12]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let L=class extends O.Disposable{constructor(p,r,o,e){super();this.fileService=r,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=C.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,r){await this.cleanUpPromise;const o=this.getName(p),e=f.joinPath(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const i=f.joinPath(this.extensionsDownloadDir,`.${E.generateUuid()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(p,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${h.getErrorMessage(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(p){}async rename(p,r,o){try{await m.Promises.rename(p.fsPath,r.fsPath)}catch(e){if(A.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${p} to ${r} with 'EPERM' error. Trying again...`),this.rename(p,r,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const r=[],o=[];for(const n of p.children){const s=this.parse(n.name);s&&o.push([s,n])}const e=g.groupByExtension(o,([n])=>n),i=[];for(const n of e)n.sort((s,u)=>b.rcompare(s[0].version,u[0].version)),r.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new g.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():E.generateUuid()}parse(p){const r=S.exec(p);return r&&r[1]&&r[2]?new g.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};L=ue([fe(0,T.INativeEnvironmentService),fe(1,I.IFileService),fe(2,R.IExtensionGalleryService),fe(3,w.ILogService)],L),t.ExtensionsDownloader=L}),define(J[102],Y([0,1,2,15,32,28,3,4,10,8,9,21]),function($,t,m,O,I,R,T,C,f,g,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let b=class extends m.Disposable{constructor(c,h){super();this.environmentService=c,this.logService=h,this.processesLimiter=new C.Limiter(5)}async postUninstall(c){const h=this.parseScript(c,"uninstall");return h&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${S}`)))),w.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(c,h){const S=`vscode:${h}`;if(c.location.scheme===g.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[S]=="string"){const L=c.manifest.scripts[S].split(" ");return L.length<2||L[0]!=="node"||!L[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${S} should be a node script`),null):{script:T.join(c.location.fsPath,L[1]),args:L.slice(2)||[]}}return null}runLifecycleHook(c,h,S,L,D){return new Promise((p,r)=>{const o=this.start(c,h,S,D);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):p(void 0)};o.on("error",n=>{i(R.toErrorMessage(n)||"Unknown")}),o.on("exit",(n,s)=>{i(n?`post-${h} process exited with code ${n}`:void 0)}),L&&(e=setTimeout(()=>{e=null,o.kill(),r("timed out")},5e3))})}start(c,h,S,L){const D={silent:!0,execArgv:void 0},p=I.fork(c,[`--type=extension-post-${h}`,...S],D);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const r=f.Event.fromNodeEventEmitter(p.stdout,"data"),o=f.Event.fromNodeEventEmitter(p.stderr,"data");r(n=>this.logService.info(L.identifier.id,L.manifest.version,`post-${h}`,n)),o(n=>this.logService.error(L.identifier.id,L.manifest.version,`post-${h}`,n));const e=f.Event.any(f.Event.map(r,n=>({data:`%c${n}`,format:[""]})),f.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]})));return f.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(L.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),p}getExtensionStoragePath(c){return T.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};b=ue([fe(0,E.IEnvironmentService),fe(1,O.ILogService)],b),t.ExtensionsLifecycle=b}),define(J[103],Y([0,1,2,21,10,18,7,24,17,15]),function($,t,m,O,I,R,T,C,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let w=class extends m.Disposable{constructor(b,A,c,h){super();this.extensionsManagementService=b,this.logService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(b.onInstallExtension(D=>this.onInstallExtension(D))),this._register(b.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(b.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const S=T.URI.file(c.extensionsPath),L=new f.ExtUri(D=>!A.hasCapability(D,1024));this._register(A.watch(S)),this._register(I.Event.filter(A.onDidChangeFilesRaw,D=>D.changes.some(p=>this.doesChangeAffects(p,S,L)))(()=>this.onDidChange()))}doesChangeAffects(b,A,c){return c.isEqual(c.dirname(b.resource),A)?c.isEqual(b.resource,c.joinPath(A,".obsolete"))?!0:!(b.type!==1&&b.type!==2||c.basename(b.resource).startsWith(".")):!1}onInstallExtension(b){this.addInstallingExtension(b.identifier)}onDidInstallExtension(b){this.removeInstallingExtension(b.identifier),b.error||this.addInstalledExtension(b.identifier)}onDidUninstallExtension(b){b.error||this.removeInstalledExtension(b.identifier)}addInstallingExtension(b){this.removeInstallingExtension(b),this.installingExtensions.push(b)}removeInstallingExtension(b){this.installingExtensions=this.installingExtensions.filter(A=>!C.areSameExtensions(A,b))}addInstalledExtension(b){this.installedExtensions&&(this.removeInstalledExtension(b),this.installedExtensions.push(b))}removeInstalledExtension(b){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(A=>!C.areSameExtensions(A,b)))}async onDidChange(){if(this.installedExtensions){const b=await this.extensionsManagementService.getInstalled(1),A=b.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(S=>C.areSameExtensions(S,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),c=this.installedExtensions.filter(h=>this.installingExtensions.some(S=>C.areSameExtensions(S,h))?!1:b.every(S=>!C.areSameExtensions(S.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=b.map(h=>h.identifier),(A.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:A,removed:c})}}};w=ue([fe(1,R.IFileService),fe(2,O.INativeEnvironmentService),fe(3,g.ILogService)],w),t.ExtensionsWatcher=w}),define(J[104],Y([0,1,9,127,23,2,21,4,24,15,53,22,10,8,3]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let h=class extends R.Disposable{constructor(D,p,r){super();this.extensionManagementService=D,this.logService=r,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(p,r)),this._register(D.onDidInstallExtension(({local:o})=>this.onDidInstallExtension(o))),this._register(D.onDidUninstallExtension(({identifier:o})=>this.onDidUninstallExtension(o)))}getLanguageIds(){return this.cache.getLanguagePacks().then(D=>{const p=["en",...Object.keys(D)];return E.distinct(p)})}onDidInstallExtension(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",D.identifier.id),this.update().then(p=>{p&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(D){this.cache.getLanguagePacks().then(p=>{Object.keys(p).some(r=>p[r]&&p[r].extensions.some(o=>f.areSameExtensions(o.extensionIdentifier,D)))&&(this.logService.debug("Removing language packs from the extension",D.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[D,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(p);return!E.equals(Object.keys(D),Object.keys(r))}};h=ue([fe(0,I.IExtensionManagementService),fe(1,T.INativeEnvironmentService),fe(2,g.ILogService)],h),t.LocalizationsService=h;let S=class extends R.Disposable{constructor(D,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=c.join(D.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(D){return this.withLanguagePacks(p=>{Object.keys(p).forEach(r=>delete p[r]),this.createLanguagePacksFromExtensions(p,...D)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(D,...p){for(const r of p)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(D,r);Object.keys(D).forEach(r=>this.updateHash(D[r]))}createLanguagePacksFromExtension(D,p){const r=p.identifier,o=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const e of o)if(p.location.scheme===A.Schemas.file&&w.isValidLocalization(e)){let i=D[e.languageId];i||(i={hash:"",extensions:[],translations:{}},D[e.languageId]=i);let n=i.extensions.filter(s=>f.areSameExtensions(s.extensionIdentifier,r))[0];n?n.version=p.manifest.version:i.extensions.push({extensionIdentifier:r,version:p.manifest.version});for(const s of e.translations)i.translations[s.id]=c.join(p.location.fsPath,s.path)}}updateHash(D){if(D){const p=O.createHash("md5");for(const r of D.extensions)p.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);D.hash=p.digest("hex")}}withLanguagePacks(D=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(o){return{}}}).then(r=>(p=D(r),r)).then(r=>{for(const e of Object.keys(r))r[e]||delete r[e];this.languagePacks=r,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>p,r=>this.logService.error(r))})}};S=ue([fe(0,T.INativeEnvironmentService),fe(1,g.ILogService)],S)}),define(J[105],Y([0,1,15,18]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(f,g,w,E){try{const b=await new Promise((A,c)=>{$(["spdlog"],A,c)});return b.setFlushOn(m.LogLevel.Trace),b.createAsyncRotatingLogger(f,g,w,E)}catch(b){console.error(b)}return null}function R(f,g,w,E){const b=$.__$__nodeRequire("spdlog");return b.setFlushOn(m.LogLevel.Trace),b.createRotatingLogger(f,g,w,E)}t.createRotatingLogger=R;function T(f,g,w){switch(g){case m.LogLevel.Trace:f.trace(w);break;case m.LogLevel.Debug:f.debug(w);break;case m.LogLevel.Info:f.info(w);break;case m.LogLevel.Warning:f.warn(w);break;case m.LogLevel.Error:f.error(w);break;case m.LogLevel.Critical:f.critical(w);break;default:throw new Error("Invalid log level")}}class C extends m.AbstractMessageLogger{constructor(g,w,E,b){super();this.name=g,this.filepath=w,this.rotating=E,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(A=>{this._logger&&this._logger.setLevel(A)}))}_createSpdLogLogger(){const g=this.rotating?6:1,w=30/g*O.ByteSize.MB;return I(this.name,this.filepath,w,g).then(E=>{if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:b,message:A}of this.buffer)T(this._logger,b,A);this.buffer=[]}})}log(g,w){this._logger?T(this._logger,g,w):this.getLevel()<=g&&this.buffer.push({level:g,message:w})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=C}),define(J[54],Y([0,1,81,16,18,12,40]),function($,t,m,O,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(E,b,A,c,h,S){let L;try{await f(E,b,A,c,h,S)}catch(D){L=D}finally{L&&h.errorTransformer&&(L=h.errorTransformer(L)),typeof L!="undefined"&&A.error(L),A.end()}}t.readFileIntoStream=C;async function f(E,b,A,c,h,S){g(S);const L=await E.open(b,{create:!1});try{g(S);let D=0,p=0,r=h&&typeof h.length=="number"?h.length:void 0,o=O.VSBuffer.alloc(Math.min(h.bufferSize,typeof r=="number"?r:h.bufferSize)),e=h&&typeof h.position=="number"?h.position:0,i=0;do p=await E.read(L,e,o.buffer,i,o.byteLength-i),e+=p,i+=p,D+=p,typeof r=="number"&&(r-=p),i===o.byteLength&&(await A.write(c(o)),o=O.VSBuffer.alloc(Math.min(h.bufferSize,typeof r=="number"?r:h.bufferSize)),i=0);while(p>0&&(typeof r!="number"||r>0)&&g(S)&&w(D,h));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),A.write(c(o.slice(0,n)))}}catch(D){throw I.ensureFileSystemProviderError(D)}finally{await E.close(L)}}function g(E){if(E.isCancellationRequested)throw R.canceled();return!0}function w(E,b){if(b?.limits){if(typeof b.limits.memory=="number"&&E>b.limits.memory)throw I.createFileSystemProviderError(m.localize(0,null,T.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&E>b.limits.size)throw I.createFileSystemProviderError(m.localize(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[106],Y([0,1,80,128,2,18,10,17,45,22,15,16,34,4,26,8,54,129]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let D=class Ne extends I.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new R.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new R.FileChangesEvent(o,!0)))),this.watchedResources=f.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(r,o){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);O.mark(`code/registerFilesystem/${r}`),this.provider.set(r,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:o});const e=new I.DisposableStore;return e.add(o.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:r}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),I.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:o}),this.provider.delete(r),I.dispose(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){o.push(e)}}),!this.provider.has(r)&&await A.Promises.settled(o)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,o){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return L.Iterable.map(this.provider,([r,o])=>({scheme:r,capabilities:o.capabilities}))}async withProvider(r){if(!C.isAbsolutePath(r))throw new R.FileOperationError(m.localize(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const o=this.provider.get(r.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=m.localize(1,null,r.toString()),e}return o}async withReadProvider(r){const o=await this.withProvider(r);if(R.hasOpenReadWriteCloseCapability(o)||R.hasReadWriteCapability(o)||R.hasFileReadStreamCapability(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const o=await this.withProvider(r);if(R.hasOpenReadWriteCloseCapability(o)||R.hasReadWriteCapability(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,o){try{return await this.doResolveFile(r,o)}catch(e){throw R.toFileSystemProviderErrorCode(e)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError(m.localize(2,null,this.resourceForError(r)),1):R.ensureFileSystemProviderError(e)}}async doResolveFile(r,o){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=o?.resolveTo,s=o?.resolveSingleChildDescendants,u=o?.resolveMetadata,v=await e.stat(r);let P;return this.toFileStat(e,r,v,void 0,!!u,(z,F)=>(P||(P=f.TernarySearchTree.forUris(()=>!i),P.set(r,!0),g.isNonEmptyArray(n)&&n.forEach(M=>P.set(M,!0))),Boolean(P.findSuperstr(z.resource)||P.get(z.resource))?!0:z.isDirectory&&s?F===1:!1))}async toFileStat(r,o,e,i,n,s){const{providerExtUri:u}=this.getExtUri(r),v={resource:o,name:u.basename(o),isFile:(e.type&R.FileType.File)!=0,isDirectory:(e.type&R.FileType.Directory)!=0,isSymbolicLink:(e.type&R.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&R.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:R.etag({mtime:e.mtime,size:e.size})};if(v.isDirectory&&s(v,i)){try{const P=await r.readdir(o),z=await A.Promises.settled(P.map(async([F,M])=>{try{const j=u.joinPath(o,F),q=n?await r.stat(j):{type:M};return await this.toFileStat(r,j,q,P.length,n,s)}catch(j){return this.logService.trace(j),null}}));v.children=g.coalesce(z)}catch(P){this.logService.trace(P),v.children=[]}return v}return v}async resolveAll(r){return A.Promises.settled(r.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const o=await this.withProvider(r);try{return!!await o.stat(r)}catch(e){return!1}}async canCreateFile(r,o){try{await this.doValidateCreateFile(r,o)}catch(e){return e}return!0}async doValidateCreateFile(r,o){if(!o?.overwrite&&await this.exists(r))throw new R.FileOperationError(m.localize(3,null,this.resourceForError(r)),3,o)}async createFile(r,o=E.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,o);return this._onDidRunOperation.fire(new R.FileOperationEvent(r,0,i)),i}async writeFile(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let u;if(R.hasReadWriteCapability(i)&&!(o instanceof E.VSBuffer))if(b.isReadableStream(o)){const v=await b.peekStream(o,3);v.ended?u=E.VSBuffer.concat(v.buffer):u=v}else u=b.peekReadable(o,v=>E.VSBuffer.concat(v),3);else u=o;!R.hasOpenReadWriteCloseCapability(i)||R.hasReadWriteCapability(i)&&u instanceof E.VSBuffer?await this.doWriteUnbuffered(i,r,e,u):await this.doWriteBuffered(i,r,e,u instanceof E.VSBuffer?E.bufferToReadable(u):u)}catch(s){throw new R.FileOperationError(m.localize(4,null,this.resourceForError(r),R.ensureFileSystemProviderError(s).toString()),R.toFileOperationResult(s),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,o,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch(s){return}if((n.type&R.FileType.Directory)!=0)throw new R.FileOperationError(m.localize(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==R.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==R.etag({mtime:e.mtime,size:n.size}))throw new R.FileOperationError(m.localize(7,null),3,e);return n}async readFile(r,o){const e=await this.withReadProvider(r);return o?.atomic?this.doReadFileAtomic(e,r,o):this.doReadFile(e,r,o)}async doReadFileAtomic(r,o,e){return new Promise((i,n)=>{this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(r,o,e);i(s)}catch(s){n(s)}})})}async doReadFile(r,o,e){const i=await this.doReadFileStream(r,o,{...e,preferUnbuffered:!0});return{...i,value:await E.streamToBuffer(i.value)}}async readFileStream(r,o){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,o)}async doReadFileStream(r,o,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(o,e).then(u=>u,u=>{throw i.cancel(),u});let s;try{return e&&typeof e.etag=="string"&&e.etag!==R.ETAG_DISABLED&&await n,!(R.hasOpenReadWriteCloseCapability(r)||R.hasFileReadStreamCapability(r))||R.hasReadWriteCapability(r)&&e?.preferUnbuffered?s=this.readFileUnbuffered(r,o,e):R.hasFileReadStreamCapability(r)?s=this.readFileStreamed(r,o,i.token,e):s=this.readFileBuffered(r,o,i.token,e),{...await n,value:s}}catch(u){s&&await b.consumeStream(s);const v=m.localize(8,null,this.resourceForError(o),R.ensureFileSystemProviderError(u).toString());throw u instanceof R.NotModifiedSinceFileOperationError?new R.NotModifiedSinceFileOperationError(v,u.stat,e):new R.FileOperationError(v,R.toFileOperationResult(u),e)}}readFileStreamed(r,o,e,i=Object.create(null)){const n=r.readFileStream(o,i,e);return b.transform(n,{data:s=>s instanceof E.VSBuffer?s:E.VSBuffer.wrap(s),error:s=>new R.FileOperationError(m.localize(9,null,this.resourceForError(o),R.ensureFileSystemProviderError(s).toString()),R.toFileOperationResult(s),i)},s=>E.VSBuffer.concat(s))}readFileBuffered(r,o,e,i=Object.create(null)){const n=E.newWriteableBufferStream();return S.readFileIntoStream(r,o,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new R.FileOperationError(m.localize(10,null,this.resourceForError(o),R.ensureFileSystemProviderError(s).toString()),R.toFileOperationResult(s),i)},e),n}readFileUnbuffered(r,o,e){const i=b.newWriteableStream(n=>E.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(o);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(o,n.byteLength,e),i.end(E.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,o){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new R.FileOperationError(m.localize(11,null,this.resourceForError(r)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==R.ETAG_DISABLED&&o.etag===e.etag)throw new R.NotModifiedSinceFileOperationError(m.localize(12,null),e,o);return this.validateReadFileLimits(r,e.size,o),e}validateReadFileLimits(r,o,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&o>e.limits.size&&(i=7),typeof i=="number")throw new R.FileOperationError(m.localize(13,null,this.resourceForError(r)),i)}}async canMove(r,o,e){return this.doCanMoveCopy(r,o,"move",e)}async canCopy(r,o,e){return this.doCanMoveCopy(r,o,"copy",e)}async doCanMoveCopy(r,o,e,i){if(r.toString()!==o.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,r,s,o,e,i)}catch(n){return n}return!0}async move(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"move",!!e),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(r,s==="move"?2:3,u)),u}async copy(r,o,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"copy",!!e),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(r,s==="copy"?3:2,u)),u}async doMoveCopy(r,o,e,i,n,s){if(o.toString()===i.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:v}=await this.doValidateMoveCopy(r,o,e,i,n,s);if(u&&!v&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&R.hasFileFolderCopyCapability(r))await r.copy(o,i,{overwrite:s});else{const P=await this.resolve(o);P.isDirectory?await this.doCopyFolder(r,P,e,i):await this.doCopyFile(r,o,e,i)}return n}else return r===e?(await r.rename(o,i,{overwrite:s}),n):(await this.doMoveCopy(r,o,e,i,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(r,o,e,i){if(R.hasOpenReadWriteCloseCapability(r)&&R.hasOpenReadWriteCloseCapability(e))return this.doPipeBuffered(r,o,e,i);if(R.hasOpenReadWriteCloseCapability(r)&&R.hasReadWriteCapability(e))return this.doPipeBufferedToUnbuffered(r,o,e,i);if(R.hasReadWriteCapability(r)&&R.hasOpenReadWriteCloseCapability(e))return this.doPipeUnbufferedToBuffered(r,o,e,i);if(R.hasReadWriteCapability(r)&&R.hasReadWriteCapability(e))return this.doPipeUnbuffered(r,o,e,i)}async doCopyFolder(r,o,e,i){await e.mkdir(i),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,s):this.doCopyFile(r,n.resource,e,s)}))}async doValidateMoveCopy(r,o,e,i,n,s){let u=!1;if(r===e){const{providerExtUri:P,isPathCaseSensitive:z}=this.getExtUri(r);if(z||(u=P.isEqual(o,i)),u&&n==="copy")throw new Error(m.localize(14,null,this.resourceForError(o),this.resourceForError(i)));if(!u&&P.isEqualOrParent(i,o))throw new Error(m.localize(15,null,this.resourceForError(o),this.resourceForError(i)))}const v=await this.exists(i);if(v&&!u){if(!s)throw new R.FileOperationError(m.localize(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(r===e){const{providerExtUri:P}=this.getExtUri(r);if(P.isEqualOrParent(o,i))throw new Error(m.localize(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:v,isSameResourceWithDifferentPathCase:u}}getExtUri(r){const o=this.isPathCaseSensitive(r);return{providerExtUri:o?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(o,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(r,0,e)),e}async mkdirp(r,o){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(o,i.dirname(o));)try{if(((await r.stat(o)).type&R.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(o)));break}catch(n){if(R.toFileSystemProviderErrorCode(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(o)),o=i.dirname(o)}for(let n=e.length-1;n>=0;n--){o=i.joinPath(o,e[n]);try{await r.mkdir(o)}catch(s){if(R.toFileSystemProviderErrorCode(s)!==R.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(r,o){try{await this.doValidateDelete(r,o)}catch(e){return e}return!0}async doValidateDelete(r,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(u){}if(n)this.throwIfFileIsReadonly(r,n);else throw new R.FileOperationError(m.localize(20,null,this.resourceForError(r)),1);if(!!!o?.recursive){const u=await this.resolve(r);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(r)))}return e}async del(r,o){const e=await this.doValidateDelete(r,o),i=!!o?.useTrash,n=!!o?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new R.FileOperationEvent(r,1))}onDidChangeFile(r,o){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new R.FileChangesEvent(e,!o))}if(i){const n=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,o={recursive:!1,excludes:[]}){const e=new I.DisposableStore;{let i=!1,n=()=>{i=!0};e.add(I.toDisposable(()=>n())),this.doWatch(r,o).then(s=>{i?I.dispose(s):n=()=>I.dispose(s)},s=>this.logService.error(s))}return o.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add(I.toDisposable(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,o){const e=await this.withProvider(r),i=this.toWatchKey(e,r,o),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,o)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,I.toDisposable(()=>{n.count--,n.count===0&&(I.dispose(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,o,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>I.dispose(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(o,{create:!0,unlock:e?.unlock??!1});try{b.isReadableStream(i)||b.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(s){throw R.ensureFileSystemProviderError(s)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,o,e){let i=0,n;if(b.isReadableBufferedStream(e)){if(e.buffer.length>0){const s=E.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,o,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,u)=>{b.listenStream(n,{onData:async v=>{n.pause();try{await this.doWriteBuffer(r,o,v,v.byteLength,i,0)}catch(P){return u(P)}i+=v.byteLength,setTimeout(()=>n.resume())},onError:v=>u(v),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(r,o,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,o,e,i,n,s){let u=0;for(;u<i;)u+=await r.write(o,n+u,e.buffer,s+u,i-u)}async doWriteUnbuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,o,e,i))}async doWriteUnbufferedQueued(r,o,e,i){let n;i instanceof E.VSBuffer?n=i:b.isReadableStream(i)?n=await E.streamToBuffer(i):b.isReadableBufferedStream(i)?n=await E.bufferedStreamToBuffer(i):n=E.readableToBuffer(i),await r.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,o,e,i))}async doPipeBufferedQueued(r,o,e,i){let n,s;try{n=await r.open(o,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const u=E.VSBuffer.alloc(this.BUFFER_SIZE);let v=0,P=0,z=0;do z=await r.read(n,v,u.buffer,P,u.byteLength-P),await this.doWriteBuffer(e,s,u,z,v,P),v+=z,P+=z,P===u.byteLength&&(P=0);while(z>0)}catch(u){throw R.ensureFileSystemProviderError(u)}finally{await A.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,o,e,i))}async doPipeUnbufferedQueued(r,o,e,i){return e.writeFile(i,await r.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,o,e,i))}async doPipeUnbufferedToBufferedQueued(r,o,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await r.readFile(o);await this.doWriteBuffer(e,n,E.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw R.ensureFileSystemProviderError(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,o,e,i){const n=await E.streamToBuffer(this.readFileBuffered(r,o,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,o){if(r.capabilities&2048)throw new R.FileOperationError(m.localize(22,null,this.resourceForError(o)),6);return r}throwIfFileIsReadonly(r,o){if((o.permissions??0)&R.FilePermission.Readonly)throw new R.FileOperationError(m.localize(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===h.Schemas.file?r.fsPath:r.toString(!0)}};D.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},D=ue([fe(0,w.ILogService)],D),t.FileService=D}),define(J[107],Y([0,1,2,18,10,14,9,3,17,35,4,15,82,51,91,93,90,99,34,54,22,16]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h,S,L,D,p,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends m.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new w.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:u}=await T.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await T.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async v=>{try{let P;v.isSymbolicLink()?P=(await this.stat(f.joinPath(n,v.name))).type:P=this.toType(v),u.push([v.name,P])}catch(P){this.logService.trace(P)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let u;return s?.dangling?u=O.FileType.Unknown:n.isFile()?u=O.FileType.File:n.isDirectory()?u=O.FileType.Directory:u=O.FileType.Unknown,s&&(u|=O.FileType.SymbolicLink),u}async readFile(n){try{const s=this.toFilePath(n);return await T.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,u){const v=D.newWriteableStream(P=>o.VSBuffer.concat(P.map(z=>o.VSBuffer.wrap(z))).buffer);return p.readFileIntoStream(this,n,v,P=>P.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),v}async writeFile(n,s,u){let v;try{const P=this.toFilePath(n);if(!u.create||!u.overwrite){if(await T.Promises.exists(P)){if(!u.overwrite)throw O.createFileSystemProviderError(b.localize(0,null),O.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw O.createFileSystemProviderError(b.localize(1,null),O.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(v,0,s,0,s.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(n,P)}finally{typeof v=="number"&&await this.close(v)}}async open(n,s){try{const u=this.toFilePath(n);if(O.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:z}=await T.SymlinkSupport.stat(u);z.mode&128||await T.Promises.chmod(u,z.mode|128)}catch(z){this.logService.trace(z)}let v;if(O.isFileOpenForWriteOptions(s)){if(R.isWindows)try{await T.Promises.truncate(u,0),v="r+"}catch(z){z.code!=="ENOENT"&&this.logService.trace(z)}v||(v="w")}else v="r";const P=await T.Promises.open(u,v);return this.mapHandleToPos.set(P,0),O.isFileOpenForWriteOptions(s)&&this.writeHandles.set(P,n),P}catch(u){throw O.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await T.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await T.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,u,v,P){const z=this.normalizePos(n,s);let F=null;try{const M=await T.Promises.read(n,u,v,P,z);return typeof M=="number"?F=M:F=M.bytesRead,F}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(n,z,F)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,u){const v=this.mapHandleToPos.get(n);typeof v=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,v+u):this.mapHandleToPos.delete(n)))}async write(n,s,u,v,P){return w.retry(()=>this.doWrite(n,s,u,v,P),100,3)}async doWrite(n,s,u,v,P){const z=this.normalizePos(n,s);let F=null;try{const M=await T.Promises.write(n,u,v,P,z);return typeof M=="number"?F=M:F=M.bytesWritten,F}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),M)}finally{this.updatePos(n,z,F)}}async mkdir(n){try{await T.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const u=this.toFilePath(n);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,s){s.recursive?await T.Promises.rm(n,T.RimRafMode.MOVE):await T.Promises.unlink(n)}async rename(n,s,u){const v=this.toFilePath(n),P=this.toFilePath(s);if(v!==P)try{await this.validateTargetDeleted(n,s,"move",u.overwrite),await T.Promises.move(v,P)}catch(z){throw(z.code==="EINVAL"||z.code==="EBUSY"||z.code==="ENAMETOOLONG")&&(z=new Error(b.localize(2,null,C.basename(v),C.basename(C.dirname(P)),z.toString()))),this.toFileSystemProviderError(z)}}async copy(n,s,u){const v=this.toFilePath(n),P=this.toFilePath(s);if(v!==P)try{await this.validateTargetDeleted(n,s,"copy",u.overwrite),await T.Promises.copy(v,P,{preserveSymlinks:!0})}catch(z){throw(z.code==="EINVAL"||z.code==="EBUSY"||z.code==="ENAMETOOLONG")&&(z=new Error(b.localize(3,null,C.basename(v),C.basename(C.dirname(P)),z.toString()))),this.toFileSystemProviderError(z)}}async validateTargetDeleted(n,s,u,v){const P=this.toFilePath(n),z=this.toFilePath(s);let F=!1;if(!!(this.capabilities&1024)||(F=g.isEqual(P,z,!0)),F&&u==="copy")throw O.createFileSystemProviderError(b.localize(4,null),O.FileSystemProviderErrorCode.FileExists);if(!F&&await T.Promises.exists(z)){if(!v)throw O.createFileSystemProviderError(b.localize(5,null),O.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const u={path:this.toFilePath(n),excludes:s},v=r.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{v(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=c.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?n=h.FileWatcher:n=c.FileWatcher:n=S.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire(A.toFileChanges(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===E.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new L.FileWatcher(this.toFilePath(n),v=>this._onDidChangeFile.fire(A.toFileChanges(v)),v=>{v.type==="error"&&this._onDidWatchErrorOccur.fire(v.message),this.logService[v.type](v.message)},this.logService.getLevel()===E.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)});return m.combinedDisposable(s,u)}toFilePath(n){return C.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof O.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=O.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=O.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=O.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=O.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=O.FileSystemProviderErrorCode.NoPermissions;break;default:s=O.FileSystemProviderErrorCode.Unknown}return O.createFileSystemProviderError(n,s)}async toFileSystemProviderWriteError(n,s){let u=this.toFileSystemProviderError(s);if(n&&u.code===O.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await T.SymlinkSupport.stat(this.toFilePath(n));v.mode&128||(u=O.createFileSystemProviderError(s,O.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.logService.trace(v)}return u}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(J[41],Y([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=m.createDecorator("productService")}),define(J[25],Y([0,1,13,57]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(T,C){O.ok(m.isString(T)),O.ok(m.isObject(C)),O.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,C)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new I}),define(J[108],Y([0,1,25,10]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,g){this.schemasById[I(f)]=g,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;m.Registry.add(t.Extensions.JSONContribution,T)}),define(J[30],Y([0,1,73,10,25,13,108]),function($,t,m,O,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=I.Registry.as(T.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(L,D=!0){this.registerConfigurations([L],D)}registerConfigurations(L,D=!0){const p=[];L.forEach(r=>{p.push(...this.validateAndRegisterProperties(r,D,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(L){const D=[],p=r=>{if(r.properties)for(const o in r.properties)D.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o]);r.allOf&&r.allOf.forEach(o=>p(o))};for(const r of L){p(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(L){const D=[],p=[];for(const r of L)for(const o in r)if(D.push(o),t.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]={...this.defaultValues[o]||{},...r[o]};const e={type:"object",default:this.defaultValues[o],description:m.localize(1,null,o),$ref:t.resourceLanguageSettingsSchemaId};p.push(E(o)),this.configurationProperties[o]=e,this.defaultLanguageConfigurationOverridesNode.properties[o]=e}else{this.defaultValues[o]=r[o];const e=this.configurationProperties[o];e&&(this.updatePropertyDefaultValue(o,e),this.updateSchema(o,e))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(L){const D=[];for(const p of L)for(const r in p)if(D.push(r),delete this.defaultValues[r],t.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...L){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(L){for(const D of L)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(L,D=!0,p,r=3){r=R.isUndefinedOrNull(L.scope)?r:L.scope;let o=[],e=L.properties;if(e)for(let n in e){if(D&&c(n)){delete e[n];continue}const s=e[n];if(this.updatePropertyDefaultValue(n,s),t.OVERRIDE_PROPERTY_PATTERN.test(n)?s.scope=void 0:(s.scope=R.isUndefinedOrNull(s.scope)?r:s.scope,s.restricted=R.isUndefinedOrNull(s.restricted)?!!p?.restrictedConfigurations?.includes(n):s.restricted),e[n].hasOwnProperty("included")&&!e[n].included){this.excludedConfigurationProperties[n]=e[n],delete e[n];continue}else this.configurationProperties[n]=e[n];!e[n].deprecationMessage&&e[n].markdownDeprecationMessage&&(e[n].deprecationMessage=e[n].markdownDeprecationMessage),o.push(n)}let i=L.allOf;if(i)for(let n of i)o.push(...this.validateAndRegisterProperties(n,D,p,r));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(L){const D=p=>{let r=p.properties;if(r)for(const e in r)this.updateSchema(e,r[e]);let o=p.allOf;o&&o.forEach(D)};D(L)}updateSchema(L,D){switch(t.allSettings.properties[L]=D,D.scope){case 1:t.applicationSettings.properties[L]=D;break;case 2:t.machineSettings.properties[L]=D;break;case 6:t.machineOverridableSettings.properties[L]=D;break;case 3:t.windowSettings.properties[L]=D;break;case 4:t.resourceSettings.properties[L]=D;break;case 5:t.resourceSettings.properties[L]=D,this.resourceLanguageSettingsSchema.properties[L]=D;break}}removeFromSchema(L,D){switch(delete t.allSettings.properties[L],D.scope){case 1:delete t.applicationSettings.properties[L];break;case 2:delete t.machineSettings.properties[L];break;case 6:delete t.machineOverridableSettings.properties[L];break;case 3:delete t.windowSettings.properties[L];break;case 4:case 5:delete t.resourceSettings.properties[L];break}}updateOverridePropertyPatternKey(){for(const L of this.overrideIdentifiers.values()){const D=`[${L}]`,p={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,p),t.allSettings.properties[D]=p,t.applicationSettings.properties[D]=p,t.machineSettings.properties[D]=p,t.machineOverridableSettings.properties[D]=p,t.windowSettings.properties[D]=p,t.resourceSettings.properties[D]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(L,D){let p=this.defaultValues[L];R.isUndefined(p)&&(p=D.default),R.isUndefined(p)&&(p=b(D.type)),D.default=p}}const w="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(w);function E(S){return S.substring(1,S.length-1)}t.overrideIdentifierFromKey=E;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=b;const A=new g;I.Registry.add(t.Extensions.Configuration,A);function c(S){return S.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(S)?m.localize(5,null,S):A.getConfigurationProperties()[S]!==void 0?m.localize(6,null,S):null:m.localize(4,null)}t.validateProperty=c;function h(){const S=[],L=A.getConfigurationProperties();for(const D of Object.keys(L))S.push([D,L[D].scope]);return S.push(["launch",4]),S.push(["task",4]),S}t.getScopes=h}),define(J[27],Y([0,1,20,13,7,25,11,30]),function($,t,m,O,I,R,T,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=T.createDecorator("configurationService");function f(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}t.isConfigurationOverrides=f;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function w(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=w;function E(i,n){const s=n?i?n.keys.filter(j=>i.keys.indexOf(j)===-1):[...n.keys]:[],u=i?n?i.keys.filter(j=>n.keys.indexOf(j)===-1):[...i.keys]:[],v=[];if(n&&i){for(const j of i.keys)if(n.keys.indexOf(j)!==-1){const q=L(i.contents,j),X=L(n.contents,j);m.equals(q,X)||v.push(j)}}const P=[],z=j=>{const q={};for(const X of j)for(const ee of X.identifiers)q[o(ee)]=X;return q},F=n?z(n.overrides):{},M=i?z(i.overrides):{};if(Object.keys(F).length)for(const j of s){const q=F[j];q&&P.push([C.overrideIdentifierFromKey(j),q.keys])}if(Object.keys(M).length)for(const j of u){const q=M[j];q&&P.push([C.overrideIdentifierFromKey(j),q.keys])}if(Object.keys(F).length&&Object.keys(M).length)for(const j of v){const q=M[j],X=F[j];if(q&&X){const ee=E({contents:q.contents,keys:q.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});P.push([C.overrideIdentifierFromKey(j),[...ee.added,...ee.removed,...ee.updated]])}}return{added:s,removed:u,updated:v,overrides:P}}t.compare=E;function b(i,n){const s=[];for(const u of Object.keys(i))if(C.OVERRIDE_PROPERTY_PATTERN.test(u)){const v={};for(const P in i[u])v[P]=i[u][P];s.push({identifiers:[C.overrideIdentifierFromKey(u).trim()],keys:Object.keys(v),contents:A(v,n)})}return s}t.toOverrides=b;function A(i,n){const s=Object.create(null);for(let u in i)c(s,u,i[u],n);return s}t.toValuesTree=A;function c(i,n,s,u){const v=n.split("."),P=v.pop();let z=i;for(let F=0;F<v.length;F++){let M=v[F],j=z[M];switch(typeof j){case"undefined":j=z[M]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${v.slice(0,F+1).join(".")} is ${JSON.stringify(j)}`);return}z=j}if(typeof z=="object"&&z!==null)try{z[P]=s}catch(F){u(`Ignoring ${n} as ${v.join(".")} is ${JSON.stringify(z)}`)}else u(`Ignoring ${n} as ${v.join(".")} is ${JSON.stringify(z)}`)}t.addToValueTree=c;function h(i,n){const s=n.split(".");S(i,s)}t.removeFromValueTree=h;function S(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const u=i[s];typeof u=="object"&&!Array.isArray(u)&&(S(u,n),Object.keys(u).length===0&&delete i[s])}}function L(i,n,s){function u(z,F){let M=z;for(const j of F){if(typeof M!="object"||M===null)return;M=M[j]}return M}const v=n.split("."),P=u(i,v);return typeof P=="undefined"?s:P}t.getConfigurationValue=L;function D(i,n,s){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in i?O.isObject(i[u])&&O.isObject(n[u])?D(i[u],n[u],s):s&&(i[u]=n[u]):i[u]=n[u])})}t.merge=D;function p(){const i=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=p;function r(){const i=Object.create(null),n=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let s in n){let u=n[s].default;c(i,s,u,v=>console.error(`Conflict in default settings: ${v}`))}return i}t.getDefaultValues=r;function o(i){return`[${i}]`}t.keyFromOverrideIdentifier=o;function e(i,n,s){const u=i.inspect(n),v=i.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:u.defaultValue}t.getMigratedSettingValue=e}),define(J[109],Y([0,1,58,45,22,13,20,7,30,27,25,2,10]),function($,t,m,O,I,R,T,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class A{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?g.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?g.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[s],v=i[s];v&&(typeof u=="object"&&typeof v=="object"?(u=T.deepClone(u),this.mergeContents(u,v)):u=v),n[s]=u}return new A(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),s=[...this.keys];for(const u of e){this.mergeContents(i,u.contents);for(const v of u.overrides){const[P]=n.filter(z=>I.equals(z.identifiers,v.identifiers));P?this.mergeContents(P.contents,v.contents):n.push(T.deepClone(v))}for(const v of u.keys)s.indexOf(v)===-1&&s.push(v)}return new A(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&R.isObject(e[n])&&R.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),g.addToValueTree(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&g.removeFromValueTree(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=A;class c extends A{constructor(){const e=g.getDefaultValues(),i=g.getConfigurationKeys(),n=[];for(const s of Object.keys(e))f.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[f.overrideIdentifierFromKey(s).trim()],keys:Object.keys(e[s]),contents:g.toValuesTree(e[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new A}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!R.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:u,restricted:v}=this.doParseRaw(e,i);this._configurationModel=new A(n,s,u),this._restrictedConfigurations=v||[]}doParseContent(e){let i={},n=null,s=[],u=[],v=[];function P(F){Array.isArray(s)?s.push(F):n&&(s[n]=F)}let z={onObjectBegin:()=>{let F={};P(F),u.push(s),s=F,n=null},onObjectProperty:F=>{n=F},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let F=[];P(F),u.push(s),s=F,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:P,onError:(F,M,j)=>{v.push({error:F,offset:M,length:j})}};if(e)try{m.visit(e,z),i=s[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(e,i){const n=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const u=g.toValuesTree(e,z=>console.error(`Conflict in settings file ${this._name}: ${z}`)),v=Object.keys(e),P=g.toOverrides(e,z=>console.error(`Conflict in settings file ${this._name}: ${z}`));return{contents:u,keys:v,overrides:P,restricted:s.restricted}}filter(e,i,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:e,restricted:[]};const u={},v=[];for(let P in e)if(f.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const z=this.filter(e[P],i,!1,s);u[P]=z.raw,v.push(...z.restricted)}else{const z=i[P],F=z?typeof z.scope!="undefined"?z.scope:3:void 0;z?.restricted&&v.push(P),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&(s.skipRestricted&&z?.restricted||(u[P]=e[P]))}return{raw:u,restricted:v}}}t.ConfigurationModelParser=h;class S extends E.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new A}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=S;class L{constructor(e,i,n=new A,s=new A,u=new O.ResourceMap,v=new A,P=new O.ResourceMap,z=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=v,this._memoryConfigurationByResource=P,this._freeze=z,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new A,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),u=this.getFolderConfigurationModelForResource(i.resource,n),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),z=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),j=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,q=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,X=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(e):v.getValue(e),ee=s.getValue(e),ie=I.distinct(I.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(e,Q)!==void 0);return{defaultValue:P,userValue:z,userLocalValue:F,userRemoteValue:M,workspaceValue:j,workspaceFolderValue:q,memoryValue:X,value:ee,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:z!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:u?.freeze().getValue(e),override:i.overrideIdentifier?u?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:v.getValue(e),override:i.overrideIdentifier?v.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ie.length?ie:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>f.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=f.overrideIdentifierFromKey(s),v=this._defaultConfiguration.getKeysForOverrideIdentifier(u),P=e.getKeysForOverrideIdentifier(u),z=[...P.filter(F=>v.indexOf(F)===-1),...v.filter(F=>P.indexOf(F)===-1),...v.filter(F=>!T.equals(this._defaultConfiguration.override(u).getValue(F),e.override(u).getValue(F)))];return[u,z]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:u}=g.compare(this.localUserConfiguration,e),v=[...i,...n,...s];return v.length&&this.updateLocalUserConfiguration(e),{keys:v,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:u}=g.compare(this.remoteUserConfiguration,e);let v=[...i,...n,...s];return v.length&&this.updateRemoteUserConfiguration(e),{keys:v,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:u}=g.compare(this.workspaceConfiguration,e);let v=[...i,...n,...s];return v.length&&this.updateWorkspaceConfiguration(e),{keys:v,overrides:u}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:u,removed:v,overrides:P}=g.compare(n,i);let z=[...s,...u,...v];return(z.length||!n)&&this.updateFolderConfiguration(e,i),{keys:z,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:u,overrides:v}=g.compare(i,void 0);return{keys:[...n,...s,...u],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const u=this._memoryConfigurationByResource.get(e);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:u}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((v,P)=>(v.set(C.URI.revive(P[0]),this.parseConfigurationModel(P[1])),v),new O.ResourceMap);return new L(i,n,new A,s,u,new A,new O.ResourceMap,!1)}static parseConfigurationModel(e){return new A(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=L;function D(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const s of o)s.keys.forEach(u=>e.add(u)),s.overrides.forEach(([u,v])=>{const P=O.getOrSet(i,u,new Set);v.forEach(z=>P.add(z))});const n=[];return i.forEach((s,u)=>n.push([u,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=D;class p{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(P=>u.add(P)),e.overrides.forEach(([,P])=>P.forEach(z=>u.add(z))),this.affectedKeys=[...u.values()];const v=new A;this.affectedKeys.forEach(P=>v.setValue(P,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=L.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=g.toValuesTree({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=p;class r extends p{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=r}),define(J[110],Y([0,1,25,30,2,27,109,10,4,17]),function($,t,m,O,I,R,T,C,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class w extends I.Disposable{constructor(b,A){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,A)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(O.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,A){const c=typeof b=="string"?b:void 0,h=R.isConfigurationOverrides(b)?b:R.isConfigurationOverrides(A)?A:{};return this.configuration.getValue(c,h,void 0)}updateValue(b,A,c,h){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const A=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(c,A,1)}onDidDefaultConfigurationChange(b){const A=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,b);this.trigger(c,A,6)}trigger(b,A,c){const h=new T.ConfigurationChangeEvent(b,{data:A},this.configuration);h.source=c,h.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=w}),define(J[55],Y([0,1,83,11,30,25,16]),function($,t,m,O,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=O.createDecorator("requestService");function C(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=C;function f(c){return c.res.statusCode===204}async function g(c){if(!C(c))throw new Error("Server returned "+c.res.statusCode);return f(c)?null:(await T.streamToBuffer(c.stream)).toString()}t.asText=g;async function w(c){if(!C(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const S=(await T.streamToBuffer(c.stream)).toString();try{return JSON.parse(S)}catch(L){throw L.message+=`:
`+S,L}}t.asJson=w;function E(c){A(c)}t.updateProxyConfigurationsScope=E;let b;function A(c){const h=R.Registry.as(I.Extensions.Configuration);b&&h.deregisterConfigurations([b]),b={id:"http",order:15,title:m.localize(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},h.registerConfiguration(b)}A(2)}),define(J[111],Y([0,1,112,13]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(T,C){return T.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:T.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function R(T,C,f={}){const g=m.parse(T),w=f.proxyUrl||I(g,C);if(!w)return null;const E=m.parse(w);if(!/^https?:$/.test(E.protocol||""))return null;const b={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:O.isBoolean(f.strictSSL)?f.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((A,c)=>{$(["http-proxy-agent"],A,c)}))(b):new(await new Promise((A,c)=>{$(["https-proxy-agent"],A,c)}))(b)}t.getProxyAgent=R}),define(J[113],Y([0,1,29,16]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(R,T,C){let f=C&&C.get("storage.serviceMachineId",0)||null;if(f)return f;try{const w=(await T.readFile(R.serviceMachineIdResource)).value.toString();f=m.isUUID(w)?w:null}catch(g){f=null}if(!f){f=m.generateUuid();try{await T.writeFile(R.serviceMachineIdResource,O.VSBuffer.fromString(f))}catch(g){}}return C&&C.store("storage.serviceMachineId",f,0,1),f}t.getServiceMachineId=I}),define(J[114],Y([0,1,11,10,2,13,66,4]),function($,t,m,O,I,R,T,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";t.IStorageService=m.createDecorator("storageService");var g;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var w;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(w=t.StorageScope||(t.StorageScope={}));var E;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(E=t.StorageTarget||(t.StorageTarget={}));class b extends I.Disposable{constructor(S={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=C.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){I.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,L){L===f?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:L,target:this.getKeyTargets(S)[L]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,L,D){return this.getStorage(L)?.get(S,D)}getBoolean(S,L,D){return this.getStorage(L)?.getBoolean(S,D)}getNumber(S,L,D){return this.getStorage(L)?.getNumber(S,D)}store(S,L,D,p){if(R.isUndefinedOrNull(L)){this.remove(S,D);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,D,p),this.getStorage(D)?.set(S,L)})}remove(S,L){this.withPausedEmitters(()=>{this.updateKeyTarget(S,L,void 0),this.getStorage(L)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,L){const D=[],p=this.getKeyTargets(S);for(const r of Object.keys(p))p[r]===L&&D.push(r);return D}updateKeyTarget(S,L,D){const p=this.getKeyTargets(L);typeof D=="number"?p[S]!==D&&(p[S]=D,this.getStorage(L)?.set(f,JSON.stringify(p))):typeof p[S]=="number"&&(delete p[S],this.getStorage(L)?.set(f,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const L=this.get(f,S);if(L)try{return JSON.parse(L)}catch(D){}return Object.create(null)}isNew(S){return this.getBoolean(t.IS_NEW_KEY,S)===!0}async flush(){this._onWillSaveState.fire({reason:g.NONE}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const S=this.getStorage(0)?.items??new Map,L=this.getStorage(1)?.items??new Map;return c(S,L,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class A extends b{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}t.InMemoryStorageService=A;async function c(h,S,L,D){const p=u=>{try{return JSON.parse(u)}catch(v){return u}},r=new Map,o=new Map;h.forEach((u,v)=>{r.set(v,u),o.set(v,p(u))});const e=new Map,i=new Map;S.forEach((u,v)=>{e.set(v,u),i.set(v,p(u))}),console.group(`Storage: Global (path: ${L})`);let n=[];r.forEach((u,v)=>{n.push({key:v,value:u})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${D})`);let s=[];e.forEach((u,v)=>{s.push({key:v,value:u})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=c}),define(J[115],Y([0,1,14,33,29,7]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(g){if(m.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function C(g,w,E,b,A,c,h,S,L,D){const p=Object.create(null);p["common.machineId"]=h,p.sessionID=I.generateUuid()+Date.now(),p.commitHash=A,p.version=c,p["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=m.PlatformToString(m.platform),p["common.nodePlatform"]=O.platform,p["common.nodeArch"]=b,p["common.product"]=D||"desktop";const r=f(S||[]);r&&(p["common.msftInternal"]=r);let o=0;const e=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),m.isLinuxSnap&&(p["common.snap"]="true");const i=T(E);i&&(p["common.platformDetail"]=i);try{const n=await g.readFile(R.URI.file(L));p["common.source"]=n.value.toString().slice(0,30)}catch(n){}return p}t.resolveCommonProperties=C;function f(g){const w=O.env.USERDNSDOMAIN;if(!w)return!1;const E=w.toLowerCase();return g.some(b=>E===b)}t.verifyMicrosoftInternalDomain=f}),define(J[42],Y([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=m.createDecorator("telemetryService"),t.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(J[116],Y([0,1,12,23,24,20,42,55,49,21,26,15,18,7,41,114,113,11,17]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var p;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(p||(p={}));function r(...U){return String(U.reduce((l,a)=>l|a,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:p.None,criteria:[],assetTypes:[]};class u{constructor(l=s){this.state=l}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(l,a=this.state.pageSize){return new u({...this.state,pageNumber:l,pageSize:a})}withFilter(l,...a){const d=[...this.state.criteria,...a.length?a.map(y=>({filterType:l,value:y})):[{filterType:l}]];return new u({...this.state,criteria:d})}withSortBy(l){return new u({...this.state,sortBy:l})}withSortOrder(l){return new u({...this.state,sortOrder:l})}withFlags(...l){return new u({...this.state,flags:l.reduce((a,d)=>a|d,0)})}withAssetTypes(...l){return new u({...this.state,assetTypes:l})}get raw(){const{criteria:l,pageNumber:a,pageSize:d,sortBy:y,sortOrder:k,flags:N,assetTypes:x}=this.state;return{filters:[{criteria:l,pageNumber:a,pageSize:d,sortBy:y,sortOrder:k}],assetTypes:x,flags:N}}get searchText(){const l=this.state.criteria.filter(a=>a.filterType===o.SearchText)[0];return l&&l.value?l.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(l=>String(l.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function v(U,l){const a=(U||[]).filter(d=>d.statisticName===l)[0];return a?a.value:0}function P(U){const l="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(d=>d.assetType.indexOf(l)===0).reduce((d,y)=>{const k=j(U,y.assetType);return k&&d.push([y.assetType.substring(l.length),k]),d},[])}function z(U){if(U.properties){const l=U.properties.filter(y=>y.key===e.Repository),a=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),d=l.filter(y=>a.test(y.value))[0];return d?{uri:d.value,fallbackUri:d.value}:null}return j(U,e.Repository)}function F(U){return{uri:`${U.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${U.fallbackAssetUri}/${e.VSIX}`}}function M(U){const l=j(U,e.Icon);if(l)return l;const a=O.DefaultIconPath;return{uri:a,fallbackUri:a}}function j(U,l){return U.files.filter(d=>d.assetType===l)[0]?{uri:`${U.assetUri}/${l}`,fallbackUri:`${U.fallbackAssetUri}/${l}`}:null}function q(U,l){const a=U.properties?U.properties.filter(y=>y.key===l):[],d=a.length>0&&a[0].value;return d?d.split(",").map(y=>I.adoptToGalleryExtensionId(y)):[]}function X(U){const l=U.properties?U.properties.filter(a=>a.key===i.Engine):[];return l.length>0&&l[0].value||""}function ee(U){const l=U.properties?U.properties.filter(d=>d.key===i.LocalizedLanguages):[],a=l.length>0&&l[0].value||"";return a?a.split(","):[]}function ie(U){return U.indexOf("preview")!==-1}function Q(U){return U.files.some(l=>l.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?D.joinPath(A.URI.parse(U.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function oe(U,l,a,d,y){const k={manifest:j(l,e.Manifest),readme:j(l,e.Details),changelog:j(l,e.Changelog),license:j(l,e.License),repository:z(l),download:F(l),icon:M(l),coreTranslations:P(l)};return{identifier:{id:I.getGalleryExtensionId(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:l.version,date:l.lastUpdated,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:v(U.statistics,"install"),rating:v(U.statistics,"averagerating"),ratingCount:v(U.statistics,"ratingcount"),assetUri:A.URI.parse(l.assetUri),webExtension:!!U.tags?.includes(O.WEB_EXTENSION_TAG),webResource:Q(l),assetTypes:l.files.map(({assetType:N})=>N),assets:k,properties:{dependencies:q(l,i.Dependency),extensionPack:q(l,i.ExtensionPack),engine:X(l),localizedLanguages:ee(l)},telemetryData:{index:(d.pageNumber-1)*d.pageSize+a,querySource:y},preview:ie(U.flags)}}let se=class{constructor(l,a,d,y,k,N,x){this.requestService=l,this.logService=a,this.environmentService=d,this.telemetryService=y,this.fileService=k,this.productService=N;const B=N.extensionsGallery;this.extensionsGalleryUrl=B&&B.serviceUrl,this.extensionsControlUrl=B&&B.controlUrl,this.commonHeadersPromise=re(N.version,this.environmentService,this.fileService,x)}api(l=""){return`${this.extensionsGalleryUrl}${l}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(l,a){const d=[];let{total:y,firstPage:k,getPage:N}=await this.query({names:l,pageSize:l.length},a);d.push(...k);for(let x=1;d.length<y&&(k=await N(x,a),k.length);x++)d.push(...k);return d}async getCompatibleExtension(l,a){return this.getCompatibleExtensionByEngine(l,a)}async getCompatibleExtensionByEngine(l,a){const d=O.isIExtensionIdentifier(l)?null:l;if(d&&d.properties.engine&&f.isEngineValid(d.properties.engine,this.productService.version,this.productService.date))return d;const{id:y,uuid:k}=d?d.identifier:l;let N=new u().withFlags(p.IncludeAssetUri,p.IncludeStatistics,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");k?N=N.withFilter(o.ExtensionId,k):N=N.withFilter(o.ExtensionName,y);const{galleryExtensions:x}=await this.queryGallery(N,w.CancellationToken.None),[B]=x;if(!B||!B.versions.length)return null;if(a){const _=B.versions.filter(K=>K.version===a)[0];if(_){const K=oe(B,_,0,N);if(K.properties.engine&&f.isEngineValid(K.properties.engine,this.productService.version,this.productService.date))return K}return null}const W=await this.getLastValidExtensionVersion(B,B.versions);return W?oe(B,W,0,N):null}async query(l,a){const d=w.CancellationToken.isCancellationToken(l)?{}:l,y=w.CancellationToken.isCancellationToken(l)?l:a;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let k=d.text||"";const N=R.getOrDefault(d,Z=>Z.pageSize,50);let x=new u().withFlags(p.IncludeLatestVersionOnly,p.IncludeAssetUri,p.IncludeStatistics,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,N).withFilter(o.Target,"Microsoft.VisualStudio.Code");k?(k=k.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Z,te,ae)=>(x=x.withFilter(o.Category,ae||te),"")),k=k.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Z,te,ae)=>(x=x.withFilter(o.Tag,ae||te),"")),k=k.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(o.Featured),"")),k=k.trim(),k&&(k=k.length<200?k:k.substring(0,200),x=x.withFilter(o.SearchText,k)),x=x.withSortBy(0)):d.ids?x=x.withFilter(o.ExtensionId,...d.ids):d.names?x=x.withFilter(o.ExtensionName,...d.names):x=x.withSortBy(4),typeof d.sortBy=="number"&&(x=x.withSortBy(d.sortBy)),typeof d.sortOrder=="number"&&(x=x.withSortOrder(d.sortOrder));const{galleryExtensions:B,total:W}=await this.queryGallery(x,y),_=B.map((Z,te)=>oe(Z,Z.versions[0],te,x,d.source)),K=async(Z,te)=>{if(te.isCancellationRequested)throw m.canceled();const ae=x.withPage(Z+1),{galleryExtensions:me}=await this.queryGallery(ae,te);return me.map((ve,Oe)=>oe(ve,ve.versions[0],Oe,ae,d.source))};return{firstPage:_,total:W,pageSize:x.pageSize,getPage:K}}async queryGallery(l,a){if(!this.isEnabled())throw new Error("No extension gallery service configured.");l=l.withFlags(l.flags,p.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,r(p.Unpublished));const d=await this.commonHeadersPromise,y=JSON.stringify(l.raw),k={...d,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(y.length)},N=new Date().getTime();let x,B,W=0;try{if(x=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:y,headers:k},a),x.res.statusCode&&x.res.statusCode>=400&&x.res.statusCode<500)return{galleryExtensions:[],total:W};const _=await C.asJson(x);if(_){const K=_.results[0],Z=K.extensions,te=K.resultMetadata&&K.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return W=te&&te.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Z,total:W}}return{galleryExtensions:[],total:W}}catch(_){throw B=_,_}finally{this.telemetryService.publicLog2("galleryService:query",{...l.telemetryData,requestBodySize:String(y.length),duration:new Date().getTime()-N,success:!!x&&C.isSuccess(x),responseBodySize:x?.res.headers["Content-Length"],statusCode:x?String(x.res.statusCode):void 0,errorCode:B?m.isPromiseCanceledError(B)?"canceled":m.getErrorMessage(B).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(W)})}}async reportStatistic(l,a,d,y){if(!this.isEnabled())return;const N={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${l}/extensions/${a}/${d}/stats?statType=${y}`),headers:N},w.CancellationToken.None)}catch(x){}}async download(l,a,d){this.logService.trace("ExtensionGalleryService#download",l.identifier.id);const y=I.getGalleryExtensionTelemetryData(l),k=new Date().getTime(),N=_=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...y,duration:_}),x=d===1?"install":d===2?"update":"",B=x?{uri:`${l.assets.download.uri}&${x}=true`,fallbackUri:`${l.assets.download.fallbackUri}?${x}=true`}:l.assets.download,W=await this.getAsset(B);await this.fileService.writeFile(a,W.stream),N(new Date().getTime()-k)}async getReadme(l,a){if(l.assets.readme){const d=await this.getAsset(l.assets.readme,{},a);return await C.asText(d)||""}return""}async getManifest(l,a){if(l.assets.manifest){const d=await this.getAsset(l.assets.manifest,{},a),y=await C.asText(d);return y?JSON.parse(y):null}return null}async getCoreTranslation(l,a){const d=l.assets.coreTranslations.filter(y=>y[0]===a.toUpperCase())[0];if(d){const y=await this.getAsset(d[1]),k=await C.asText(y);return k?JSON.parse(k):null}return null}async getChangelog(l,a){if(l.assets.changelog){const d=await this.getAsset(l.assets.changelog,{},a);return await C.asText(d)||""}return""}async getAllVersions(l,a){let d=new u().withFlags(p.IncludeVersions,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");l.identifier.uuid?d=d.withFilter(o.ExtensionId,l.identifier.uuid):d=d.withFilter(o.ExtensionName,l.identifier.id);const y=[],{galleryExtensions:k}=await this.queryGallery(d,w.CancellationToken.None);return k.length&&(a?await Promise.all(k[0].versions.map(async N=>{let x;try{x=await this.getEngine(N)}catch(B){}x&&f.isEngineValid(x,this.productService.version,this.productService.date)&&y.push({version:N.version,date:N.lastUpdated})})):y.push(...k[0].versions.map(N=>({version:N.version,date:N.lastUpdated})))),y}async getAsset(l,a={},d=w.CancellationToken.None){const y=await this.commonHeadersPromise,k={type:"GET"},N={...y,...a.headers||{}};a={...a,...k,headers:N};const x=l.uri,B=l.fallbackUri,W={...a,url:x};try{const _=await this.requestService.request(W,d);if(_.res.statusCode===200)return _;const K=await C.asText(_);throw new Error(`Expected 200, got back ${_.res.statusCode} instead.

${K}`)}catch(_){if(m.isPromiseCanceledError(_))throw _;const K=m.getErrorMessage(_);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:x,message:K});const Z={...a,url:B};return this.requestService.request(Z,d)}}async getLastValidExtensionVersion(l,a){const d=this.getLastValidExtensionVersionFromProperties(l,a);return d||this.getLastValidExtensionVersionRecursively(l,a)}getLastValidExtensionVersionFromProperties(l,a){for(const d of a){const y=X(d);if(!y)return null;if(f.isEngineValid(y,this.productService.version,this.productService.date))return d}return null}async getEngine(l){const a=X(l);if(a)return a;const d=j(l,e.Manifest);if(!d)throw new Error("Manifest was not found");const y={"Accept-Encoding":"gzip"},k=await this.getAsset(d,{headers:y}),N=await C.asJson(k);if(N)return N.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(l,a){if(!a.length)return null;const d=a[0],y=await this.getEngine(d);return f.isEngineValid(y,this.productService.version,this.productService.date)?{...d,properties:[...d.properties||[],{key:i.Engine,value:y}]}:this.getLastValidExtensionVersionRecursively(l,a.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const l=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},w.CancellationToken.None);if(l.res.statusCode!==200)throw new Error("Could not get extensions report.");const a=await C.asJson(l),d=new Map;if(a)for(const y of a.malicious){const k=d.get(y)||{id:{id:y},malicious:!0,slow:!1};k.malicious=!0,d.set(y,k)}return[...d.values()]}};se=ue([fe(0,C.IRequestService),fe(1,E.ILogService),fe(2,g.IEnvironmentService),fe(3,T.ITelemetryService),fe(4,b.IFileService),fe(5,c.IProductService),fe(6,L.optional(h.IStorageService))],se),t.ExtensionGalleryService=se;async function re(U,l,a,d){const y={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},k=await S.getServiceMachineId(l,a,d);return y["X-Market-User-Id"]=k,y}t.resolveMarketplaceHeaders=re}),define(J[117],Y([0,1,40,84,19,11,27,30,2,20,25]),function($,t,m,O,I,R,T,C,f,g,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let E=class{constructor(c,h){this._configurationService=h,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(I.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const L=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!L})}))}setExperimentProperty(c,h){this._experimentProperties[c]=h}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(b);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let h=c.sessionID,S=c["common.instanceId"],L=c["common.machineId"],D=c["common.firstSessionDate"],p=c["common.msftInternal"];return{sessionId:h,instanceId:S,machineId:L,firstSessionDate:D,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(c,h,S){return this.isOptedIn?this._commonProperties.then(L=>{h=g.mixin(h,L),h=g.mixin(h,this._experimentProperties),h=g.cloneAndChange(h,D=>{if(typeof D=="string")return this._cleanupInfo(D,S)}),this._appender.log(c,h)},L=>{console.error(L)}):Promise.resolve(void 0)}publicLog2(c,h,S){return this.publicLog(c,h,S)}publicLogError(c,h){return this.sendErrorTelemetry?this.publicLog(c,h,!0):Promise.resolve(void 0)}publicLogError2(c,h){return this.publicLogError(c,h)}_cleanupInfo(c,h){let S=c;if(h){const L=[];for(let o of this._cleanupPatterns)for(;;){const e=o.exec(c);if(!e)break;L.push([e.index,o.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(S="";;){const o=p.exec(c);if(!o)break;!D.test(o[0])&&L.every(([e,i])=>o.index<e||o.index>=i)&&(S+=c.substring(r,o.index)+"<REDACTED: user-file-path>",r=p.lastIndex)}r<c.length&&(S+=c.substr(r))}for(let L of this._cleanupPatterns)S=S.replace(L,"");return S}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ue([fe(1,R.optional(T.IConfigurationService))],E),t.TelemetryService=E;const b="telemetry";w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:O.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?O.localize(2,null,m.default.privacyStatementUrl):O.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[56],Y([0,1,27,20,13,4]),function($,t,m,O,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,h){return Promise.resolve(void 0)}publicLog2(c,h){return this.publicLog(c,h)}publicLogError(c,h){return Promise.resolve(void 0)}publicLogError2(c,h){return this.publicLogError(c,h)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(h,S,L){}async publicLogError(h,S,L){}}t.NullEndpointTelemetryService=T;function C(...c){return{log:(h,S)=>c.forEach(L=>L.log(h,S)),flush:()=>R.Promises.settled(c.map(h=>h.flush()))}}t.combinedAppender=C,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(c,h){return h.onDidChangeConfiguration(S=>{S.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(S.source),configurationKeys:b(S.sourceConfig)})})}t.configurationTelemetry=f;function g(c){const h=Object.create(null),S=Object.create(null),L=Object.create(null);E(c,L);for(let D in L){D=D.length>150?D.substr(D.length-149):D;const p=L[D];typeof p=="number"?S[D]=p:typeof p=="boolean"?S[D]=p?1:0:typeof p=="string"?h[D]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(h[D]=p)}return{properties:h,measurements:S}}t.validateTelemetryData=g;function w(c){if(!c)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(L=>{c.indexOf(`${L}+`)===0&&(h=L)}),h}t.cleanRemoteAuthority=w;function E(c,h,S=0,L){if(!!c)for(let D of Object.getOwnPropertyNames(c)){const p=c[D],r=L?L+D:D;Array.isArray(p)?h[r]=O.safeStringify(p):p instanceof Date?h[r]=p.toISOString():I.isObject(p)?S<2?E(p,h,S+1,r+"."):h[r]=O.safeStringify(p):h[r]=p}}function b(c){if(!c)return[];const h=[];return A(h,"",c),h}function A(c,h,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(L=>A(c,h?`${h}.${L}`:L,S[L])):c.push(h)}}),define(J[118],Y([0,1,12,20,56]),function($,t,m,O,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(C){const f=await new Promise((w,E)=>{$(["applicationinsights"],w,E)});let g;return f.defaultClient?(g=new f.TelemetryClient(C),g.channel.setUseDiskRetryCaching(!0)):(f.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=f.defaultClient),C.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class T{constructor(f,g,w){this._eventPrefix=f,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof w=="function"?this._aiClient=w():this._aiClient=w,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(g=>{f(g)},g=>{m.onUnexpectedError(g),console.error(g)})}}log(f,g){!this._aiClient||(g=O.mixin(g,this._defaultData),g=I.validateTelemetryData(g),this._withAIClient(w=>w.trackEvent({name:this._eventPrefix+"/"+f,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(J[119],Y([0,1,9,3]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function I(R,T){const C=Object.create(null),f=(w,E)=>{const b=JSON.parse(w);C[E]=b};if(T){const w=[],E=await m.Promises.readdir(T);for(const A of E)try{(await m.Promises.stat(O.join(T,A))).isDirectory()&&w.push(A)}catch{}const b=[];for(const A of w)(await m.Promises.readdir(O.join(T,A))).filter(h=>h==="telemetry.json").length===1&&b.push(A);for(const A of b){const c=(await m.Promises.readFile(O.join(T,A,"telemetry.json"))).toString();f(c,A)}}let g=(await m.Promises.readFile(O.join(R,"telemetry-core.json"))).toString();return f(g,"vscode-core"),g=(await m.Promises.readFile(O.join(R,"telemetry-extensions.json"))).toString(),f(g,"vscode-extensions"),JSON.stringify(C,null,4)}t.buildTelemetryMessage=I}),define(J[43],Y([0,1,72,3,36,4,9,130,131,13]),function($,t,m,O,I,R,T,C,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class w extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=w;function E(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function b(o){if(o instanceof w)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new w(e,o)}function A(o,e,i,n,s,u){const v=O.dirname(e),P=O.join(n,v);if(!P.startsWith(n))return Promise.reject(new Error(m.localize(0,null,e)));const z=O.join(n,e);let F;return u.onCancellationRequested(()=>{F&&F.destroy()}),Promise.resolve(T.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((M,j)=>{if(!u.isCancellationRequested)try{F=I.createWriteStream(z,{mode:i}),F.once("close",()=>M()),F.once("error",j),o.once("error",j),o.pipe(F)}catch(q){j(q)}}))}function c(o,e,i,n){let s=R.createCancelablePromise(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{s.cancel(),o.close()}),new Promise((v,P)=>{const z=new R.Sequencer,F=M=>{M.isCancellationRequested||(u++,o.readEntry())};o.once("error",P),o.once("close",()=>s.then(()=>{n.isCancellationRequested||o.entryCount===u?v():P(new w("Incomplete",new Error(m.localize(1,null,u,o.entryCount))))},P)),o.readEntry(),o.on("entry",M=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(M.fileName)){F(n);return}const j=M.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const ee=O.join(e,j);s=R.createCancelablePromise(ie=>T.Promises.mkdir(ee,{recursive:!0}).then(()=>F(ie)).then(void 0,P));return}const q=S(o,M),X=E(M);s=R.createCancelablePromise(ee=>z.queue(()=>q.then(ie=>A(ie,j,X,e,i,ee).then(()=>F(ee)))).then(null,P))})})}function h(o,e=!1){return new Promise((i,n)=>{C.open(o,e?{lazyEntries:!0}:void 0,(s,u)=>{s?n(b(s)):i(g.assertIsDefined(u))})})}function S(o,e){return new Promise((i,n)=>{o.openReadStream(e,(s,u)=>{s?n(b(s)):i(g.assertIsDefined(u))})})}function L(o,e){return new Promise((i,n)=>{const s=new f.ZipFile;e.forEach(v=>{v.contents?s.addBuffer(typeof v.contents=="string"?Buffer.from(v.contents,"utf8"):v.contents,v.path):v.localPath&&s.addFile(v.localPath,v.path)}),s.end();const u=I.createWriteStream(o);s.outputStream.pipe(u),s.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>i(o))})}t.zip=L;function D(o,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let u=h(o,!0);return i.overwrite&&(u=u.then(v=>T.Promises.rm(e).then(()=>v))),u.then(v=>c(v,e,{sourcePathRegex:s},n))}t.extract=D;function p(o,e){return h(o).then(i=>new Promise((n,s)=>{i.on("entry",u=>{u.fileName===e&&S(i,u).then(v=>n(v),v=>s(v))}),i.once("close",()=>s(new Error(m.localize(2,null,e))))}))}function r(o,e){return p(o,e).then(i=>new Promise((n,s)=>{const u=[];i.once("error",s),i.on("data",v=>u.push(v)),i.on("end",()=>n(Buffer.concat(u)))}))}t.buffer=r}),define(J[120],Y([0,1,43,77]),function($,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(R){return m.buffer(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(C){throw new Error(O.localize(0,null))}})}t.getManifest=I}),define(J[121],Y([0,1,39,2,9,3,15,23,24,4,7,21,89,78,41,43,14,22,8,18,17,29,12]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h,S,L,D,p,r,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",u="deleting",v="renaming";let P=class extends O.Disposable{constructor(F,M,j,q,X){super();this.beforeRemovingExtension=F,this.fileService=M,this.logService=j,this.environmentService=q,this.productService=X,this._devSystemExtensionsPath=null,this.systemExtensionsPath=q.builtinExtensionsPath,this.extensionsPath=q.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new g.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(F){const M=[];(F===null||F===0)&&M.push(this.scanSystemExtensions().then(null,j=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(j).message,i)))),(F===null||F===1)&&M.push(this.scanUserExtensions(!0).then(null,j=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(j).message,n))));try{const j=await Promise.all(M);return L.flatten(j)}catch(j){throw this.joinErrors(j)}}async scanUserExtensions(F){this.logService.trace("Started scanning user extensions");let[M,j]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return j=j.filter(q=>!M[new f.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).key()]),F&&(j=f.groupByExtension(j,X=>X.identifier).map(X=>X.sort((ee,ie)=>m.rcompare(ee.manifest.version,ie.manifest.version))[0])),this.logService.trace("Scanned user extensions:",j.length),j}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(F,M,j){const q=F.key(),X=R.join(this.extensionsPath,`.${o.generateUuid()}`),ee=R.join(this.extensionsPath,q);try{await I.Promises.rm(ee)}catch(Q){try{await I.Promises.rm(ee)}catch(oe){}throw new C.ExtensionManagementError(A.localize(0,null,ee,F.id),u)}await this.extractAtLocation(F,M,X,j);let ie=await this.scanExtension(w.URI.file(X),1);if(!ie)throw new Error(A.localize(1,null,X));await this.storeMetadata(ie,{installedTimestamp:Date.now()});try{await this.rename(F,X,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(Q){try{await I.Promises.rm(X)}catch(oe){}if(Q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${e.getErrorMessage(Q)}. Deleted from extracted location`,X),Q}try{ie=await this.scanExtension(w.URI.file(ee),1)}catch(Q){}if(ie)return ie;throw new Error(A.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(F,M){return this.setMetadata(F,M),await this.storeMetadata(F,{...M,installedTimestamp:F.installedTimestamp}),F}async storeMetadata(F,M){M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0;const j=R.join(F.location.fsPath,"package.json"),q=await I.Promises.readFile(j,"utf8"),{manifest:X}=await this.parseManifest(q);return X.__metadata=M,await I.Promises.writeFile(j,JSON.stringify(X,null,"	")),F}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const M=F.map(j=>new f.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version));await this.withUninstalledExtensions(j=>{M.forEach(q=>j[q.key()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(q=>delete q[F.key()]);const j=(await this.scanExtensions(1)).find(q=>new f.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).equals(F))||null;return j?(await this.storeMetadata(j,{installedTimestamp:Date.now()}),this.scanExtension(j.location,1)):null}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let M;try{M=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let j={};if(M)try{j=JSON.parse(M)}catch(q){}return F&&(F(j),Object.keys(j).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(j)):await I.Promises.rm(this.uninstalledPath)),j})}async removeExtension(F,M){this.logService.trace(`Deleting ${M} extension from disk`,F.identifier.id,F.location.fsPath),await I.Promises.rm(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(M=>delete M[new f.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()])}async extractAtLocation(F,M,j,q){this.logService.trace(`Started extracting the extension from ${M} to ${j}`);try{await I.Promises.rm(j)}catch(X){throw new C.ExtensionManagementError(this.joinErrors(X).message,u)}try{await h.extract(M,j,{sourcePath:"extension",overwrite:!0},q),this.logService.info(`Extracted extension to ${j}:`,F.id)}catch(X){try{await I.Promises.rm(j)}catch(ee){}throw new C.ExtensionManagementError(X.message,X instanceof h.ExtractError&&X.type?X.type:s)}}async rename(F,M,j,q){try{await I.Promises.rename(M,j)}catch(X){if(S.isWindows&&X&&X.code==="EPERM"&&Date.now()<q)return this.logService.info(`Failed renaming ${M} to ${j} with 'EPERM' error. Trying again...`,F.id),this.rename(F,M,j,q);throw new C.ExtensionManagementError(X.message||A.localize(3,null,M,j),X.code||v)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const F=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return F;const M=this.scanDevSystemExtensions(),[j,q]=await Promise.all([F,M]);return[...j,...q]}async scanExtensionsInDir(F,M){const j=new g.Limiter(10),q=await this.fileService.resolve(w.URI.file(F));return q.children?(await Promise.all(q.children.filter(ee=>ee.isDirectory).map(ee=>j.queue(async()=>M===1&&r.basename(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,M))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(F,M){try{const j=await this.fileService.resolve(F);if(j.children){const{manifest:q,metadata:X}=await this.readManifest(F.fsPath),ee=j.children.find(({name:se})=>/^readme(\.txt|\.md|)$/i.test(se))?.resource,ie=j.children.find(({name:se})=>/^changelog(\.txt|\.md|)$/i.test(se))?.resource,Q={id:f.getGalleryExtensionId(q.publisher,q.name)},oe={type:M,identifier:Q,manifest:q,location:F,readmeUrl:ee,changelogUrl:ie,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:M===0};return X&&(this.setMetadata(oe,X),oe.installedTimestamp=X.installedTimestamp),oe}}catch(j){M!==0&&this.logService.trace(j)}return null}async scanDefaultSystemExtensions(){const F=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",F.length),F}async scanDevSystemExtensions(){const F=this.getDevSystemExtensionsList();if(F.length){const M=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",M.length),M.filter(j=>F.some(q=>f.areSameExtensions(j.identifier,{id:q})))}else return[]}setMetadata(F,M){F.publisherDisplayName=M.publisherDisplayName||null,F.publisherId=M.publisherId||null,F.identifier.uuid=M.id,F.isMachineScoped=!!M.isMachineScoped,F.isBuiltin=F.type===0||!!M.isBuiltin}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),M=await this.scanAllUserExtensions(),j=new Set;for(const ee of M)F[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||j.add(ee.identifier.id.toLowerCase());const q=f.groupByExtension(M,ee=>ee.identifier);await g.Promises.settled(q.map(async ee=>{const ie=ee.sort((Q,oe)=>m.rcompare(Q.manifest.version,oe.manifest.version))[0];j.has(ie.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ie)}));const X=M.filter(ee=>F[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await g.Promises.settled(X.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const F=await this.scanAllUserExtensions(),M=[],j=f.groupByExtension(F,q=>q.identifier);M.push(...L.flatten(j.map(q=>q.sort((X,ee)=>m.rcompare(X.manifest.version,ee.manifest.version)).slice(1)))),await g.Promises.settled(M.map(q=>this.removeExtension(q,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(F=>F.name)}joinErrors(F){const M=Array.isArray(F)?F:[F];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((j,q)=>new Error(`${j.message}${j.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(F){const M=[I.Promises.readFile(R.join(F,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),I.Promises.readFile(R.join(F,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:j,metadata:q},X]=await Promise.all(M);return{manifest:b.localizeManifest(j,X),metadata:q}}parseManifest(F){return new Promise((M,j)=>{try{const q=JSON.parse(F),X=q.__metadata||null;M({manifest:q,metadata:X})}catch(q){j(new Error(A.localize(4,null)))}})}};P=ue([fe(1,p.IFileService),fe(2,T.ILogService),fe(3,E.INativeEnvironmentService),fe(4,c.IProductService)],P),t.ExtensionsScanner=P}),define(J[122],Y([0,1,76,3,9,2,22,43,23,24,21,4,10,39,7,40,14,15,97,28,42,49,17,29,95,11,8,26,120,101,121,102,103,18]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h,S,L,D,p,r,o,e,i,n,s,u,v,P,z,F,M,j,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const X="unsetUninstalled",ee="downloading",ie="validating",Q="local",oe="cancelled",se="unknown";let re=class extends R.Disposable{constructor(l,a,d,y,k,N,x){super();this.environmentService=l,this.galleryService=a,this.logService=d,this.downloadService=y,this.telemetryService=k,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const B=this._register(N.createInstance(M.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(F.ExtensionsScanner,_=>B.postUninstall(_))),this.manifestCache=this._register(new D.ExtensionsManifestCache(l,this)),this.extensionsDownloader=this._register(N.createInstance(z.ExtensionsDownloader));const W=this._register(new j.ExtensionsWatcher(this,x,l,d));this._register(W.onDidChangeExtensionsByAnotherSource(({added:_,removed:K})=>{_.forEach(Z=>this._onDidInstallExtension.fire({identifier:Z.identifier,operation:0,local:Z})),K.forEach(Z=>this._onDidUninstallExtension.fire({identifier:Z}))})),this._register(R.toDisposable(()=>{this.installingExtensions.forEach(_=>_.cancel()),this.uninstallingExtensions.forEach(_=>_.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(l){this.logService.trace("ExtensionManagementService#zip",l.identifier.id);const a=await this.collectFiles(l),d=await C.zip(e.joinPath(this.environmentService.tmpDir,i.generateUuid()).fsPath,a);return c.URI.file(d)}async unzip(l){return this.logService.trace("ExtensionManagementService#unzip",l.toString()),(await this.install(l)).identifier}async getManifest(l){const a=await this.downloadVsix(l),d=O.resolve(a.fsPath);return P.getManifest(d)}async collectFiles(l){const a=async y=>{let k=await I.Promises.readdir(y);k=k.map(B=>O.join(y,B));const N=await Promise.all(k.map(B=>I.Promises.stat(B)));let x=Promise.resolve([]);return N.forEach((B,W)=>{const _=k[W];B.isFile()&&(x=x.then(K=>[...K,_])),B.isDirectory()&&(x=x.then(K=>a(_).then(Z=>[...K,...Z])))}),x};return(await a(l.location.fsPath)).map(y=>({path:`extension/${O.relative(l.location.fsPath,y)}`,localPath:y}))}async install(l,a={}){return this.logService.trace("ExtensionManagementService#install",l.toString()),E.createCancelablePromise(async d=>{const y=await this.downloadVsix(l),k=O.resolve(y.fsPath),N=await P.getManifest(k),x={id:g.getGalleryExtensionId(N.publisher,N.name)};let B=1;if(N.engines&&N.engines.vscode&&!o.isEngineValid(N.engines.vscode,h.default.version,h.default.date))throw new Error(m.localize(0,null,x.id,h.default.version));const W=new g.ExtensionIdentifierWithVersion(x,N.version),K=(await this.getInstalled(1)).find(te=>g.areSameExtensions(x,te.identifier));if(K)if(a.isMachineScoped=a.isMachineScoped||K.isMachineScoped,a.isBuiltin=a.isBuiltin||K.isBuiltin,B=2,W.equals(new g.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version)))try{await this.extensionsScanner.removeExtension(K,"existing")}catch(te){throw new Error(m.localize(1,null,N.displayName||N.name))}else A.gt(K.manifest.version,N.version)&&await this.uninstallExtension(K);else{const te=await this.unsetUninstalledAndGetLocal(W);if(te)try{await this.extensionsScanner.removeExtension(te,"existing")}catch(ae){throw new Error(m.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",x.id),this._onInstallExtension.fire({identifier:x,zipPath:k});let Z;try{Z=await this.getGalleryMetadata(g.getGalleryExtensionId(N.publisher,N.name))}catch(te){}try{const te=await this.installFromZipPath(W,k,a.installOnlyNewlyAddedFromExtensionPack?K:void 0,{...Z||{},...a},a,B,d);return this.logService.info("Successfully installed the extension:",x.id),te}catch(te){throw this.logService.error("Failed to install the extension:",x.id,te.message),te}})}async downloadVsix(l){if(l.scheme===u.Schemas.file)return l;if(!this.downloadService)throw new Error("Download service is not available");const a=e.joinPath(this.environmentService.tmpDir,i.generateUuid());return await this.downloadService.download(l,a),a}async installFromZipPath(l,a,d,y,k,N,x){try{const B=await this.installExtension({zipPath:a,identifierWithVersion:l,metadata:y},x);try{k.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(B,d,k)}catch(W){T.isNonEmptyArray(B.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",B.identifier.id,W.message),T.isNonEmptyArray(B.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",B.identifier.id,W.message)}return this._onDidInstallExtension.fire({identifier:l,zipPath:a,local:B,operation:N}),B}catch(B){throw this._onDidInstallExtension.fire({identifier:l,zipPath:a,operation:N,error:B}),B}}async canInstall(l){return!0}async installFromGallery(l,a={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(3,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(y){const k=y&&y.code?y.code:se;throw this.logService.error("Failed to install extension:",l.identifier.id,y?y.message:k),this.reportTelemetry(this.getTelemetryEvent(1),g.getGalleryExtensionTelemetryData(l),void 0,y),y instanceof Error&&(y.name=k),y}let d=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(l.identifier,l.version).key());return d?(this.logService.info("Extensions is already requested to install",l.identifier.id),(await d.resultPromise).local):(d=this.createInstallFromGalleryExtensionTask(l,a),(await this.runInstallGalleryExtensionTask(d,a)).local)}createInstallFromGalleryExtensionTask(l,a){const d=new g.ExtensionIdentifierWithVersion(l.identifier,l.version).key();this._onInstallExtension.fire({identifier:l.identifier,gallery:l}),this.logService.info("Installing extension:",l.identifier.id);let y;const k=new E.Barrier,N={extension:l,get resultPromise(){return k.wait().then(()=>y)},run:async()=>(y||(y=E.createCancelablePromise(async x=>{try{const B=await this.installGalleryExtension(l,a,x);return this.logService.info("Extensions installed successfully:",l.identifier.id),this._onDidInstallExtension.fire({identifier:l.identifier,gallery:B.gallery,local:B.local,operation:B.operation}),B}catch(B){const W=B&&B.code?B.code:se;throw this.logService.error("Failed to install extension:",l.identifier.id,B?B.message:W),this._onDidInstallExtension.fire({identifier:l.identifier,gallery:l,operation:1,error:W}),B instanceof Error&&(B.name=W),B}})),k.open(),y.finally(()=>this.installingExtensions.delete(d)),y),cancel:()=>{y?y.cancel():this._onDidInstallExtension.fire({identifier:l.identifier,gallery:l,operation:1,error:oe})}};return this.installingExtensions.set(d,N),N}async runInstallGalleryExtensionTask(l,a){if(a.donotIncludePackAndDependencies)return this.logService.info("Installing the extension without checking dependencies and pack",l.extension.identifier.id),l.run();const d=new Map,y=[];try{const k=await this.galleryService.getManifest(l.extension,v.CancellationToken.None);if(k===null){const W=new f.ExtensionManagementError(`Missing manifest for extension ${l.extension.identifier.id}`,ie);throw this.logService.error("Failed to install extension:",l.extension.identifier.id,W.message),W}d.set(l.extension.identifier.id.toLowerCase(),{task:l,manifest:k});const N=await this.getAllDepsAndPackExtensionsToInstall(l.extension.identifier,k,v.CancellationToken.None);let x=!1;for(const{gallery:W,manifest:_}of N)if(x=x||!!_.extensionDependencies?.some(K=>g.areSameExtensions({id:K},l.extension.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(W.identifier,W.version).key()))this.logService.info("Extension is already requested to install",W.identifier.id);else{const K=this.createInstallFromGalleryExtensionTask(W,{...a,donotIncludePackAndDependencies:!0});d.set(W.identifier.id.toLowerCase(),{task:K,manifest:_})}for(;d.size;){const W=[...d.values()].filter(({manifest:K})=>!K.extensionDependencies?.some(Z=>d.has(Z.toLowerCase())));let _;W.length?_=d.size===1?W:W.filter(({task:K})=>!(K===l&&!x)):(this.logService.info("Found extensions with circular dependencies",W.map(({task:K})=>K.extension.identifier.id)),_=[...d.values()]),await Promise.all(_.map(async({task:K})=>{y.push(await K.run()),d.delete(K.extension.identifier.id.toLowerCase())}))}const B=y.find(({local:W})=>g.areSameExtensions(W.identifier,l.extension.identifier));if(B)return B;throw new Error("Extension is not installed")}catch(k){throw d.size?d.forEach(({task:N})=>N.cancel()):l.cancel(),k}}async installGalleryExtension(l,a,d){const y=new Date().getTime();let k=1;try{const x=(await this.getInstalled()).find(_=>g.areSameExtensions(_.identifier,l.identifier));x&&(k=2);const B=await this.downloadInstallableExtension(l,k);B.metadata.isMachineScoped=a.isMachineScoped||x?.isMachineScoped,B.metadata.isBuiltin=a.isBuiltin||x?.isBuiltin;const W=await this.installExtension(B,d);x&&A.neq(x.manifest.version,l.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(c.URI.file(B.zipPath))}catch(_){}return this.reportTelemetry(this.getTelemetryEvent(k),g.getGalleryExtensionTelemetryData(l),new Date().getTime()-y,void 0),{local:W,operation:k,gallery:l}}catch(N){throw this.reportTelemetry(this.getTelemetryEvent(k),g.getGalleryExtensionTelemetryData(l),new Date().getTime()-y,N),N}}async getAllDepsAndPackExtensionsToInstall(l,a,d){let y=await this.getInstalled();const k=[l,...y.map(B=>B.identifier)],N=[],x=async(B,W)=>{const _=W.extensionDependencies||[];if(W.extensionPack){const K=y.find(Z=>g.areSameExtensions(Z.identifier,B));for(const Z of W.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(te=>g.areSameExtensions({id:te},{id:Z}))||_.every(te=>!g.areSameExtensions({id:te},{id:Z}))&&_.push(Z)}if(_.length){const K=[...k,...N.map(te=>te.gallery.identifier)],Z=_.filter(te=>K.every(ae=>!g.areSameExtensions(ae,{id:te})));if(Z.length){const te=await this.galleryService.query({names:Z,pageSize:_.length},v.CancellationToken.None);for(const ae of te.firstPage){if(K.find(Oe=>g.areSameExtensions(Oe,ae.identifier)))continue;const me=await this.checkAndGetCompatibleVersion(ae),ve=await this.galleryService.getManifest(me,v.CancellationToken.None);if(ve===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${me.identifier.id}`,ie);N.push({gallery:me,manifest:ve}),await x(me.identifier,ve)}}}};return await x(l,a),y=await this.getInstalled(),N.filter(B=>!y.some(W=>g.areSameExtensions(W.identifier,B.gallery.identifier)))}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new f.ExtensionManagementError(m.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const a=await this.galleryService.getCompatibleExtension(l);if(!a)throw new f.ExtensionManagementError(m.localize(5,null,l.identifier.id,h.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return a}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(6,null));const a=await this.findGalleryExtension(l);if(!a)throw new Error(m.localize(7,null));await this.extensionsScanner.setUninstalled(l);try{await this.extensionsScanner.removeUninstalledExtension(l)}catch(d){throw new Error(m.localize(8,null,p.toErrorMessage(d)))}await this.installFromGallery(a)}getTelemetryEvent(l){return l===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(l){const a=await this.getExtensionsReport();return g.getMaliciousExtensionsSet(a).has(l.identifier.id)}async downloadInstallableExtension(l,a){const d={id:l.identifier.uuid,publisherId:l.publisherId,publisherDisplayName:l.publisherDisplayName};let y;try{this.logService.trace("Started downloading extension:",l.identifier.id),y=(await this.extensionsDownloader.downloadExtension(l,a)).fsPath,this.logService.info("Downloaded extension:",l.identifier.id,y)}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,ee)}try{const k=await P.getManifest(y);return{zipPath:y,identifierWithVersion:new g.ExtensionIdentifierWithVersion(l.identifier,k.version),metadata:d}}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,ie)}}async installExtension(l,a){try{const d=await this.unsetUninstalledAndGetLocal(l.identifierWithVersion);if(d)return l.metadata?this.extensionsScanner.saveMetadataForLocalExtension(d,l.metadata):d}catch(d){throw S.isMacintosh?new f.ExtensionManagementError(m.localize(9,null),X):new f.ExtensionManagementError(m.localize(10,null),X)}return this.extractAndInstall(l,a)}async unsetUninstalledAndGetLocal(l){if(!await this.isUninstalled(l))return null;this.logService.trace("Removing the extension from uninstalled list:",l.id);const d=await this.extensionsScanner.setInstalled(l);return this.logService.info("Removed the extension from uninstalled list:",l.id),d}async extractAndInstall({zipPath:l,identifierWithVersion:a,metadata:d},y){let k=await this.extensionsScanner.extractUserExtension(a,l,y);return this.logService.info("Installation completed.",a.id),d&&(k=await this.extensionsScanner.saveMetadataForLocalExtension(k,d)),k}async installDependenciesAndPackExtensions(l,a,d){if(!this.galleryService.isEnabled())return;const y=l.manifest.extensionDependencies||[];if(l.manifest.extensionPack)for(const k of l.manifest.extensionPack)a&&a.manifest.extensionPack&&a.manifest.extensionPack.some(N=>g.areSameExtensions({id:N},{id:k}))||y.every(N=>!g.areSameExtensions({id:N},{id:k}))&&y.push(k);if(y.length){const k=await this.getInstalled(),N=y.filter(x=>k.every(({identifier:B})=>!g.areSameExtensions(B,{id:x})));if(N.length){const B=(await this.galleryService.query({names:N,pageSize:y.length},v.CancellationToken.None)).firstPage;try{await E.Promises.settled(B.map(W=>this.installFromGallery(W,d)))}catch(W){try{await this.rollback(B)}catch(_){}throw W}}}}async rollback(l){const d=(await this.getInstalled(1)).filter(y=>l.some(k=>new g.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(new g.ExtensionIdentifierWithVersion(k.identifier,k.version))));await E.Promises.settled(d.map(y=>this.uninstall(y)))}async uninstall(l,a={}){this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id);const d=await this.getInstalled(1),y=d.find(k=>g.areSameExtensions(k.identifier,l.identifier));if(!y)throw new Error(m.localize(11,null,l.manifest.displayName||l.manifest.name));try{await this.checkForDependenciesAndUninstall(y,d,a)}catch(k){throw this.joinErrors(k)}}async updateMetadata(l,a){return this.logService.trace("ExtensionManagementService#updateMetadata",l.identifier.id),l=await this.extensionsScanner.saveMetadataForLocalExtension(l,{...l.manifest.__metadata||{},...a}),this.manifestCache.invalidate(),l}async updateExtensionScope(l,a){return this.logService.trace("ExtensionManagementService#updateExtensionScope",l.identifier.id),l=await this.extensionsScanner.saveMetadataForLocalExtension(l,{...l.manifest.__metadata||{},isMachineScoped:a}),this.manifestCache.invalidate(),l}async getGalleryMetadata(l){const a=await this.findGalleryExtensionByName(l);return a?{id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId}:void 0}async findGalleryExtension(l){if(l.identifier.uuid){const a=await this.findGalleryExtensionById(l.identifier.uuid);return a||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},v.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},v.CancellationToken.None)).firstPage[0]}joinErrors(l){const a=Array.isArray(l)?l:[l];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((d,y)=>new Error(`${d.message}${d.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}async checkForDependenciesAndUninstall(l,a,d){try{await this.preUninstallExtension(l);const y=d.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(l,a);await this.uninstallExtensions(l,y,a,d)}catch(y){throw await this.postUninstallExtension(l,new f.ExtensionManagementError(y instanceof Error?y.message:y,Q)),y}await this.postUninstallExtension(l)}async uninstallExtensions(l,a,d,y){const k=[l,...a];if(!y.donotCheckDependents)for(const N of k)this.checkForDependents(N,k,d,l);await E.Promises.settled([this.uninstallExtension(l),...a.map(N=>this.doUninstall(N))])}checkForDependents(l,a,d,y){const k=this.getDependents(l,d);if(k.length){const N=k.filter(x=>a.indexOf(x)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(l,N,y))}}getDependentsErrorMessage(l,a,d){return d===l?a.length===1?m.localize(12,null,d.manifest.displayName||d.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?m.localize(13,null,d.manifest.displayName||d.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):m.localize(14,null,d.manifest.displayName||d.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?m.localize(15,null,d.manifest.displayName||d.manifest.name,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?m.localize(16,null,d.manifest.displayName||d.manifest.name,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):m.localize(17,null,d.manifest.displayName||d.manifest.name,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(l,a,d=[]){if(d.indexOf(l)!==-1)return[];d.push(l);const y=l.manifest.extensionPack?l.manifest.extensionPack:[];if(y.length){const k=a.filter(x=>!x.isBuiltin&&y.some(B=>g.areSameExtensions({id:B},x.identifier))),N=[];for(const x of k)N.push(...this.getAllPackExtensionsToUninstall(x,a,d));return[...k,...N]}return[]}getDependents(l,a){return a.filter(d=>d.manifest.extensionDependencies&&d.manifest.extensionDependencies.some(y=>g.areSameExtensions({id:y},l.identifier)))}async doUninstall(l){try{await this.preUninstallExtension(l),await this.uninstallExtension(l)}catch(a){throw await this.postUninstallExtension(l,new f.ExtensionManagementError(a instanceof Error?a.message:a,Q)),a}await this.postUninstallExtension(l)}async preUninstallExtension(l){if(!await I.Promises.exists(l.location.fsPath))throw new Error(m.localize(18,null));this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier)}async uninstallExtension(l){let a=this.uninstallingExtensions.get(l.identifier.id);return a||(a=E.createCancelablePromise(async()=>{const d=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...d.filter(y=>g.areSameExtensions(y.identifier,l.identifier)))}),this.uninstallingExtensions.set(l.identifier.id,a),a.finally(()=>this.uninstallingExtensions.delete(l.identifier.id))),a}async postUninstallExtension(l,a){if(a)this.logService.error("Failed to uninstall extension:",l.identifier.id,a.message);else if(this.logService.info("Successfully uninstalled extension:",l.identifier.id),l.identifier.uuid)try{await this.galleryService.reportStatistic(l.manifest.publisher,l.manifest.name,l.manifest.version,"uninstall")}catch(y){}this.reportTelemetry("extensionGallery:uninstall",g.getLocalExtensionTelemetryData(l),void 0,a);const d=a?a instanceof f.ExtensionManagementError?a.code:se:void 0;this._onDidUninstallExtension.fire({identifier:l.identifier,error:d})}getInstalled(l=null){return this.extensionsScanner.scanExtensions(l)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(l){return(await this.filterUninstalled(l)).length===1}async filterUninstalled(...l){const a=[],d=await this.extensionsScanner.getUninstalledExtensions();for(const y of l)d[y.key()]&&a.push(y.key());return a}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(l,a,d,y){const k=y?y instanceof f.ExtensionManagementError?y.code:se:void 0;this.telemetryService.publicLogError(l,{...a,success:!y,duration:d,errorcode:k})}};re=ue([fe(0,w.INativeEnvironmentService),fe(1,f.IExtensionGalleryService),fe(2,L.ILogService),fe(3,s.optional(n.IDownloadService)),fe(4,r.ITelemetryService),fe(5,s.IInstantiationService),fe(6,q.IFileService)],re),t.ExtensionManagementService=re}),define(J[123],Y([0,1,132,112,2,13,12,111,27,15,16,21,98]),function($,t,m,O,I,R,T,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let A=class extends I.Disposable{constructor(h,S,L){super();this.environmentService=S,this.logService=L,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,S){this.logService.trace("RequestService#request",h.url);const{proxyUrl:L,strictSSL:D}=this,p={...process.env,...await b.resolveShellEnv(this.logService,this.environmentService.args,process.env)},r=h.agent?h.agent:await C.getProxyAgent(h.url||"",p,{proxyUrl:L,strictSSL:D});return h.agent=r,h.strictSSL=D,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this._request(h,S)}async getNodeRequest(h){return(O.parse(h.url).protocol==="https:"?await new Promise((D,p)=>{$(["https"],D,p)}):await new Promise((D,p)=>{$(["http"],D,p)})).request}_request(h,S){return new Promise(async(L,D)=>{let p;const r=O.parse(h.url),o=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:R.isBoolean(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(e.auth=h.user+":"+h.password),p=o(e,i=>{const n=R.isNumber(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...h,url:i.headers.location,followRedirects:n-1},S).then(L,D);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe(m.createGunzip())),L({res:i,stream:w.streamToBufferReadableStream(s)})}}),p.on("error",D),h.timeout&&p.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&p.write(h.data),p.end(),S.onCancellationRequested(()=>{p.abort(),D(T.canceled())})})}async resolveProxy(h){}};A=ue([fe(0,f.IConfigurationService),fe(1,E.INativeEnvironmentService),fe(2,g.ILogService)],A),t.RequestService=A}),define(J[133],Y([0,1,31,36,134,9,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,27,110,118,15,8,105,119,106,18,107,2,41,96,7,104,53,12,28,16,33]),function($,t,m,O,I,R,T,C,f,g,w,E,b,A,c,h,S,L,D,p,r,o,e,i,n,s,u,v,P,z,F,M,j,q,X,ee,ie,Q,oe,se,re,U,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class a extends q.Disposable{constructor(k){super();this.argv=k,I.gracefulify(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[k,N]=await this.initServices();return k.invokeFunction(async x=>{const B=x.get(u.ILogService),W=x.get(M.IFileService),_=x.get(b.INativeEnvironmentService),K=x.get(c.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(_,K,W),C.raceTimeout(D.combinedAppender(...N).flush(),1e3)})}async initServices(){const k=new g.ServiceCollection,N={_serviceBrand:void 0,...f.default};k.set(X.IProductService,N);const x=new A.NativeEnvironmentService(this.argv,N);k.set(b.INativeEnvironmentService,x),await Promise.all([x.appSettingsHome.fsPath,x.extensionsPath].map(me=>me?R.Promises.mkdir(me,{recursive:!0}):void 0));const B=u.getLogLevel(x),W=[];W.push(new P.SpdLogLogger("cli",T.join(x.logsPath,"cli.log"),!0,B)),B===u.LogLevel.Trace&&W.push(new u.ConsoleLogger(B));const _=this._register(new u.MultiplexLogService(W));k.set(u.ILogService,_);const K=this._register(new F.FileService(_));k.set(M.IFileService,K);const Z=this._register(new j.DiskFileSystemProvider(_));K.registerProvider(v.Schemas.file,Z);const te=this._register(new n.ConfigurationService(x.settingsResource,K));k.set(i.IConfigurationService,te),await te.initialize(),k.set(o.IRequestService,new w.SyncDescriptor(e.RequestService)),k.set(c.IExtensionManagementService,new w.SyncDescriptor(h.ExtensionManagementService)),k.set(c.IExtensionGalleryService,new w.SyncDescriptor(S.ExtensionGalleryService)),k.set(c.IExtensionManagementCLIService,new w.SyncDescriptor(ee.ExtensionManagementCLIService)),k.set(oe.ILocalizationsService,new w.SyncDescriptor(Q.LocalizationsService));const ae=[];if(x.isBuilt&&!x.isExtensionDevelopment&&!x.disableTelemetry&&N.enableTelemetry){N.aiConfig&&N.aiConfig.asimovKey&&ae.push(new s.AppInsightsAppender("monacoworkbench",null,N.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ve,installSourcePath:Oe}=x,Te={appender:D.combinedAppender(...ae),sendErrorTelemetry:!1,commonProperties:(async()=>{let Se;try{const Ae=await R.Promises.readFile(T.join(x.userDataPath,"storage.json"));Se=JSON.parse(Ae.toString())[L.machineIdKey]}catch(Ae){Ae.code!=="ENOENT"&&_.error(Ae)}return r.resolveCommonProperties(K,m.release(),m.hostname(),process.arch,N.commit,N.version,Se,N.msftInternalDomains,Oe)})(),piiPaths:[me,ve]};k.set(L.ITelemetryService,new w.SyncDescriptor(p.TelemetryService,[Te]))}else k.set(L.ITelemetryService,D.NullTelemetryService);return[new E.InstantiationService(k),ae]}registerErrorHandler(k){se.setUnexpectedErrorHandler(N=>{const x=re.toErrorMessage(N,!0);!x||k.error(`[uncaught exception in CLI]: ${x}`)})}async doRun(k,N,x){if(this.argv["install-source"])return this.setInstallSource(k,x,this.argv["install-source"]);if(this.argv["list-extensions"])return N.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return N.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return N.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return N.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await z.buildTelemetryMessage(k.appRoot,k.extensionsPath))}asExtensionIdOrVSIX(k){return k.map(N=>/\.vsix$/i.test(N)?ie.URI.file(T.isAbsolute(N)?N:T.join(l.cwd(),N)):N)}async setInstallSource(k,N,x){await N.writeFile(ie.URI.file(k.installSourcePath),U.VSBuffer.fromString(x.slice(0,30)))}}async function d(y){const k=new a(y);try{await k.run()}finally{k.dispose()}}t.main=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bfac07cd0e374c433c2c06d6999dabf9cf9d5d29/core/vs/code/node/cliProcessMain.js.map
