/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/editor/common/core/position","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/common/editor","vs/workbench/common/editor/editorInput","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(X){for(var e=[],p=0,R=X.length;p<R;p++)e[p]=fe[X[p]];return e};define(fe[51],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=p}),define(fe[68],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function R(n){const P=[];for(let d in n)p.call(n,d)&&P.push(n[d]);return P}e.values=R;function k(n,P){for(let d in n)if(p.call(n,d)&&P({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=k;function y(n,P){const d=Object.create(null);for(const f of n){const l=P(f);let c=d[l];c||(c=d[l]=[]),c.push(f)}return d}e.groupBy=y;function A(n){const P=Object.create(null);return n&&n.forEach((d,f)=>{P[f]=d}),P}e.fromMap=A;function I(n,P){const d=[],f=[];for(let l of n)P.has(l)||d.push(l);for(let l of P)n.has(l)||f.push(l);return{removed:d,added:f}}e.diffSets=I;function E(n,P){const d=[],f=[];for(let[l,c]of n)P.has(l)||d.push(c);for(let[l,c]of P)n.has(l)||f.push(c);return{removed:d,added:f}}e.diffMaps=E;class C{constructor(){this.map=new Map}add(P,d){let f=this.map.get(P);f||(f=new Set,this.map.set(P,f)),f.add(d)}delete(P,d){const f=this.map.get(P);!f||(f.delete(d),f.size===0&&this.map.delete(P))}forEach(P,d){const f=this.map.get(P);!f||f.forEach(d)}}e.SetMap=C}),define(fe[52],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(I,E,C)=>{let n=null,P=null;if(typeof C.value=="function"?(n="value",P=C.value):typeof C.get=="function"&&(n="get",P=C.get),!P)throw new Error("not supported");C[n]=A(P,E)}}e.createDecorator=p;function R(A,I,E){let C=null,n=null;if(typeof E.value=="function"?(C="value",n=E.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",n=E.get),!n)throw new Error("not supported");const P=`$memoize$${I}`;E[C]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[P]}}e.memoize=R;function k(A,I,E){return p((C,n)=>{const P=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...f){this[d]||(this[d]=E?E():void 0),clearTimeout(this[P]),I&&(this[d]=I(this[d],...f),f=[this[d]]),this[P]=setTimeout(()=>{C.apply(this,f),this[d]=E?E():void 0},A)}})}e.debounce=k;function y(A,I,E){return p((C,n)=>{const P=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...c){if(this[d]||(this[d]=E?E():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...c)),this[l])return;const S=this[f]+A;S<=Date.now()?(this[f]=Date.now(),C.apply(this,[this[d]]),this[d]=E?E():void 0):(this[l]=!0,this[P]=setTimeout(()=>{this[l]=!1,this[f]=Date.now(),C.apply(this,[this[d]]),this[d]=E?E():void 0},S-Date.now()))}})}e.throttle=y}),define(fe[15],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=R;function k(m){E(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function y(m){E(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=y;function A(m){if(m instanceof Error){let{name:t,message:s}=m;const r=m.stacktrace||m.stack;return{$isError:!0,name:t,message:s,stack:r}}return m}e.transformErrorForSerialization=A;const I="Canceled";function E(m){return m instanceof Error&&m.name===I&&m.message===I}e.isPromiseCanceledError=E;class C extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=C;function n(){const m=new Error(I);return m.name=m.message,m}e.canceled=n;function P(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=P;function d(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=d;function f(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function l(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function c(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=c;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function h(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function u(m,t=Object.create(null)){const s=new Error(m);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=u}),define(fe[17],me([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(x,O=0){return x[x.length-(1+O)]}e.tail=R;function k(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=k;function y(x,O,M=(B,V)=>B===V){if(x===O)return!0;if(!x||!O||x.length!==O.length)return!1;for(let B=0,V=x.length;B<V;B++)if(!M(x[B],O[B]))return!1;return!0}e.equals=y;function A(x,O,M){let B=0,V=x.length-1;for(;B<=V;){const ee=(B+V)/2|0,de=M(x[ee],O);if(de<0)B=ee+1;else if(de>0)V=ee-1;else return ee}return-(B+1)}e.binarySearch=A;function I(x,O){let M=0,B=x.length;if(B===0)return 0;for(;M<B;){const V=Math.floor((M+B)/2);O(x[V])?B=V:M=V+1}return M}e.findFirstInSorted=I;function E(x,O,M){if(x=x|0,x>=O.length)throw new TypeError("invalid index");let B=O[Math.floor(O.length*Math.random())],V=[],ee=[],de=[];for(let ye of O){const Fe=M(ye,B);Fe<0?V.push(ye):Fe>0?ee.push(ye):de.push(ye)}return x<V.length?E(x,V,M):x<V.length+de.length?de[0]:E(x-(V.length+de.length),ee,M)}e.quickSelect=E;function C(x,O){const M=[];let B;for(const V of x.slice(0).sort(O))!B||O(B[0],V)!==0?(B=[V],M.push(B)):B.push(V);return M}e.groupBy=C;function n(x,O,M){const B=[];function V(ye,Fe,Re){if(Fe===0&&Re.length===0)return;const Ne=B[B.length-1];Ne&&Ne.start+Ne.deleteCount===ye?(Ne.deleteCount+=Fe,Ne.toInsert.push(...Re)):B.push({start:ye,deleteCount:Fe,toInsert:Re})}let ee=0,de=0;for(;;){if(ee===x.length){V(ee,0,O.slice(de));break}if(de===O.length){V(ee,x.length-ee,[]);break}const ye=x[ee],Fe=O[de],Re=M(ye,Fe);Re===0?(ee+=1,de+=1):Re<0?(V(ee,1,[]),ee+=1):Re>0&&(V(ee,0,[Fe]),de+=1)}return B}e.sortedDiff=n;function P(x,O,M){const B=n(x,O,M),V=[],ee=[];for(const de of B)V.push(...x.slice(de.start,de.start+de.deleteCount)),ee.push(...de.toInsert);return{removed:V,added:ee}}e.delta=P;function d(x,O,M){if(M===0)return[];const B=x.slice(0,M).sort(O);return l(x,O,B,M,x.length),B}e.top=d;function f(x,O,M,B,V){return M===0?Promise.resolve([]):new Promise((ee,de)=>{(async()=>{const ye=x.length,Fe=x.slice(0,M).sort(O);for(let Re=M,Ne=Math.min(M+B,ye);Re<ye;Re=Ne,Ne=Math.min(Ne+B,ye)){if(Re>M&&await new Promise(Ge=>setTimeout(Ge)),V&&V.isCancellationRequested)throw p.canceled();l(x,O,Fe,Re,Ne)}return Fe})().then(ee,de)})}e.topAsync=f;function l(x,O,M,B,V){for(const ee=M.length;B<V;B++){const de=x[B];if(O(de,M[ee-1])<0){M.pop();const ye=I(M,Fe=>O(de,Fe)<0);M.splice(ye,0,de)}}}function c(x){return x.filter(O=>!!O)}e.coalesce=c;function S(x){let O=0;for(let M=0;M<x.length;M++)x[M]&&(x[O]=x[M],O+=1);x.length=O}e.coalesceInPlace=S;function w(x,O,M){x.splice(M,0,x.splice(O,1)[0])}e.move=w;function b(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=b;function h(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=h;function u(x,O){if(!O)return x.filter((B,V)=>x.indexOf(B)===V);const M=Object.create(null);return x.filter(B=>{const V=O(B);return M[V]?!1:(M[V]=!0,!0)})}e.distinct=u;function m(x){const O=new Set;return x.filter(M=>O.has(M)?!1:(O.add(M),!0))}e.distinctES6=m;function t(x){const O=Object.create(null);return M=>{const B=x(M);return O[B]?!1:(O[B]=!0,!0)}}e.uniqueFilter=t;function s(x,O){for(let M=x.length-1;M>=0;M--){const B=x[M];if(O(B))return M}return-1}e.lastIndex=s;function r(x,O){return x.length>0?x[0]:O}e.firstOrDefault=r;function i(x,O,M=(B,V)=>B===V){let B=0;for(let V=0,ee=Math.min(x.length,O.length);V<ee&&M(x[V],O[V]);V++)B++;return B}e.commonPrefixLength=i;function a(x){return[].concat(...x)}e.flatten=a;function v(x,O){let M=typeof O=="number"?x:0;typeof O=="number"?M=x:(M=0,O=x);const B=[];if(M<=O)for(let V=M;V<O;V++)B.push(V);else for(let V=M;V>O;V--)B.push(V);return B}e.range=v;function g(x,O,M){return x.reduce((B,V)=>(B[O(V)]=M?M(V):V,B),Object.create(null))}e.index=g;function _(x,O){return x.push(O),()=>D(x,O)}e.insert=_;function D(x,O){const M=x.indexOf(O);if(M>-1)return x.splice(M,1),O}e.remove=D;function o(x,O,M){const B=x.slice(0,O),V=x.slice(O);return B.concat(M,V)}e.arrayInsert=o;function T(x,O){let M;if(typeof O=="number"){let B=O;M=()=>{const V=Math.sin(B++)*179426549;return V-Math.floor(V)}}else M=Math.random;for(let B=x.length-1;B>0;B-=1){const V=Math.floor(M()*(B+1)),ee=x[B];x[B]=x[V],x[V]=ee}}e.shuffle=T;function L(x,O){const M=x.indexOf(O);M>-1&&(x.splice(M,1),x.unshift(O))}e.pushToStart=L;function $(x,O){const M=x.indexOf(O);M>-1&&(x.splice(M,1),x.push(O))}e.pushToEnd=$;function W(x,O){return Array.isArray(x)?x.map(O):O(x)}e.mapArrayOrNot=W;function Q(x){return Array.isArray(x)?x:[x]}e.asArray=Q;function z(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=z;function N(x,O){for(const M of x){const B=O(M);if(B!==void 0)return B}}e.mapFind=N;function H(x,O){let M=Number.MAX_SAFE_INTEGER,B=0;return x.forEach((V,ee)=>{const de=O(V);de<M&&(M=de,B=ee)}),B}e.minIndex=H;function F(x,O){let M=Number.MIN_SAFE_INTEGER,B=0;return x.forEach((V,ee)=>{const de=O(V);de>M&&(M=de,B=ee)}),B}e.maxIndex=F}),define(fe[69],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const k=this;let y=!1,A;return function(){return y||(y=!0,A=R.apply(k,arguments)),A}}e.once=p}),define(fe[70],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(fe[53],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function k(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}R.is=k;const y=Object.freeze([]);function A(){return y}R.empty=A;function*I(m){yield m}R.single=I;function E(m){return m||y}R.from=E;function C(m){return!m||m[Symbol.iterator]().next().done===!0}R.isEmpty=C;function n(m){return m[Symbol.iterator]().next().value}R.first=n;function P(m,t){for(const s of m)if(t(s))return!0;return!1}R.some=P;function d(m,t){for(const s of m)if(t(s))return s}R.find=d;function*f(m,t){for(const s of m)t(s)&&(yield s)}R.filter=f;function*l(m,t){let s=0;for(const r of m)yield t(r,s++)}R.map=l;function*c(...m){for(const t of m)for(const s of t)yield s}R.concat=c;function*S(m){for(const t of m)for(const s of t)yield s}R.concatNested=S;function w(m,t,s){let r=s;for(const i of m)r=t(r,i);return r}R.reduce=w;function*b(m,t,s=m.length){for(t<0&&(t+=m.length),s<0?s+=m.length:s>m.length&&(s=m.length);t<s;t++)yield m[t]}R.slice=b;function h(m,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,m];const r=m[Symbol.iterator]();for(let i=0;i<t;i++){const a=r.next();if(a.done)return[s,R.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}R.consume=h;function u(m,t,s=(r,i)=>r===i){const r=m[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=r.next(),v=i.next();if(a.done!==v.done)return!1;if(a.done)return!0;if(!s(a.value,v.value))return!1}}R.equals=u})(p=e.Iterable||(e.Iterable={}))}),define(fe[54],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,s=!1){let r=0,i=t.length,a="",v=0,g=16,_=0;function D(z){let N=0,H=0;for(;N<z;){const F=t.charCodeAt(r);if(F>=48&&F<=57)H=H*16+F-48;else if(F>=65&&F<=70)H=H*16+F-65+10;else if(F>=97&&F<=102)H=H*16+F-97+10;else break;r++,N++}return N<z&&(H=-1),H}function o(z){r=z,a="",v=0,g=16,_=0}function T(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&C(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&C(t.charCodeAt(r)))for(r++;r<t.length&&C(t.charCodeAt(r));)r++;else return _=3,t.substring(z,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&C(t.charCodeAt(r))){for(r++;r<t.length&&C(t.charCodeAt(r));)r++;N=r}else _=3;return t.substring(z,N)}function L(){let z="",N=r;for(;;){if(r>=i){z+=t.substring(N,r),_=2;break}const H=t.charCodeAt(r);if(H===34){z+=t.substring(N,r),r++;break}if(H===92){if(z+=t.substring(N,r),r++,r>=i){_=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const x=D(4);x>=0?z+=String.fromCharCode(x):_=4;break;default:_=5}N=r;continue}if(H>=0&&H<=31)if(E(H)){z+=t.substring(N,r),_=2;break}else _=6;r++}return z}function $(){if(a="",_=0,v=r,r>=i)return v=i,g=17;let z=t.charCodeAt(r);if(I(z)){do r++,a+=String.fromCharCode(z),z=t.charCodeAt(r);while(I(z));return g=15}if(E(z))return r++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),g=14;switch(z){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,a=L(),g=10;case 47:const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!E(t.charCodeAt(r));)r++;return a=t.substring(N,r),g=12}if(t.charCodeAt(r+1)===42){r+=2;const H=i-1;let F=!1;for(;r<H;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,_=1),a=t.substring(N,r),g=13}return a+=String.fromCharCode(z),r++,g=16;case 45:if(a+=String.fromCharCode(z),r++,r===i||!C(t.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=T(),g=11;default:for(;r<i&&W(z);)r++,z=t.charCodeAt(r);if(v!==r){switch(a=t.substring(v,r),a){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return a+=String.fromCharCode(z),r++,g=16}}function W(z){if(I(z)||E(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let z;do z=$();while(z>=12&&z<=15);return z}return{setPosition:o,getPosition:()=>r,scan:s?Q:$,getToken:()=>g,getTokenValue:()=>a,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>_}}e.createScanner=A;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,s){const r=[],i=new Object;let a;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function _(D,o,T,L){v.value=D,v.offset=o,v.length=T,v.type=L,v.colonOffset=void 0,a=v}try{h(t,{onObjectBegin:(D,o)=>{if(s<=D)throw i;a=void 0,g=s>D,r.push("")},onObjectProperty:(D,o,T)=>{if(s<o||(_(D,o,T,"property"),r[r.length-1]=D,s<=o+T))throw i},onObjectEnd:(D,o)=>{if(s<=D)throw i;a=void 0,r.pop()},onArrayBegin:(D,o)=>{if(s<=D)throw i;a=void 0,r.push(0)},onArrayEnd:(D,o)=>{if(s<=D)throw i;a=void 0,r.pop()},onLiteralValue:(D,o,T)=>{if(s<o||(_(D,o,T,m(D)),s<=o+T))throw i},onSeparator:(D,o,T)=>{if(s<=o)throw i;if(D===":"&&a&&a.type==="property")a.colonOffset=o,g=!1,a=void 0;else if(D===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(g=!0,r[r.length-1]=""),a=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:a,isAtPropertyKey:g,matches:D=>{let o=0;for(let T=0;o<D.length&&T<r.length;T++)if(D[o]===r[T]||D[o]==="*")o++;else if(D[o]!=="**")return!1;return o===D.length}}}e.getLocation=P;function d(t,s=[],r=y.DEFAULT){let i=null,a=[];const v=[];function g(D){Array.isArray(a)?a.push(D):i!==null&&(a[i]=D)}return h(t,{onObjectBegin:()=>{const D={};g(D),v.push(a),a=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{a=v.pop()},onArrayBegin:()=>{const D=[];g(D),v.push(a),a=D,i=null},onArrayEnd:()=>{a=v.pop()},onLiteralValue:g,onError:(D,o,T)=>{s.push({error:D,offset:o,length:T})}},r),a[0]}e.parse=d;function f(t,s=[],r=y.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function v(D){return i.children.push(D),D}h(t,{onObjectBegin:D=>{i=v({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,o,T)=>{i=v({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:o,length:T,parent:i})},onObjectEnd:(D,o)=>{i.length=D+o-i.offset,i=i.parent,a(D+o)},onArrayBegin:(D,o)=>{i=v({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,o)=>{i.length=D+o-i.offset,i=i.parent,a(D+o)},onLiteralValue:(D,o,T)=>{v({type:m(D),offset:o,length:T,parent:i,value:D}),a(o+T)},onSeparator:(D,o,T)=>{i.type==="property"&&(D===":"?i.colonOffset=o:D===","&&a(o))},onError:(D,o,T)=>{s.push({error:D,offset:o,length:T})}},r);const _=i.children[0];return _&&delete _.parent,_}e.parseTree=f;function l(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===i){r=v.children[1],a=!0;break}if(!a)return}else{const a=i;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=l;function c(t){if(!t.parent||!t.parent.children)return[];const s=c(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=c;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=S(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=w;function b(t,s,r=!1){if(w(t,s,r)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=s;a++){const v=b(i[a],s,r);if(v)return v}return t}}e.findNodeAtOffset=b;function h(t,s,r=y.DEFAULT){const i=A(t,!1);function a(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function v(de){return de?ye=>de(ye,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=a(s.onObjectBegin),_=v(s.onObjectProperty),D=a(s.onObjectEnd),o=a(s.onArrayBegin),T=a(s.onArrayEnd),L=v(s.onLiteralValue),$=v(s.onSeparator),W=a(s.onComment),Q=v(s.onError),z=r&&r.disallowComments,N=r&&r.allowTrailingComma;function H(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:z||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(de){case 12:case 13:z?F(10):W();break;case 16:F(1);break;case 15:case 14:break;default:return de}}}function F(de,ye=[],Fe=[]){if(Q(de),ye.length+Fe.length>0){let Re=i.getToken();for(;Re!==17;){if(ye.indexOf(Re)!==-1){H();break}else if(Fe.indexOf(Re)!==-1)break;Re=H()}}}function x(de){const ye=i.getTokenValue();return de?L(ye):_(ye),H(),!0}function O(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(F(2),de=0)}catch(ye){F(2)}L(de);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return H(),!0}function M(){return i.getToken()!==10?(F(3,[],[2,5]),!1):(x(!1),i.getToken()===6?($(":"),H(),ee()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function B(){g(),H();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||F(4,[],[]),$(","),H(),i.getToken()===2&&N)break}else de&&F(6,[],[]);M()||F(4,[],[2,5]),de=!0}return D(),i.getToken()!==2?F(7,[2],[]):H(),!0}function V(){o(),H();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||F(4,[],[]),$(","),H(),i.getToken()===4&&N)break}else de&&F(6,[],[]);ee()||F(4,[],[4,5]),de=!0}return T(),i.getToken()!==4?F(8,[4],[]):H(),!0}function ee(){switch(i.getToken()){case 3:return V();case 1:return B();case 10:return x(!0);default:return O()}}return H(),i.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):ee()?(i.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=h;function u(t,s){let r=A(t),i=[],a,v=0,g;do switch(g=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:v!==g&&i.push(t.substring(v,g)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),v=r.getPosition();break}while(a!==17);return i.join("")}e.stripComments=u;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(fe[133],me([0,1,54]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(E,C,n){let P,d,f,l,c;if(C){for(l=C.offset,c=l+C.length,f=l;f>0&&!I(E,f-1);)f--;let v=c;for(;v<E.length&&!I(E,v);)v++;d=E.substring(f,v),P=y(d,n)}else d=E,P=0,f=0,l=0,c=E.length;const S=A(n,E);let w=!1,b=0,h;n.insertSpaces?h=k(" ",n.tabSize||4):h="	";const u=p.createScanner(d,!1);let m=!1;function t(){return S+k(h,P+b)}function s(){let v=u.scan();for(w=!1;v===15||v===14;)w=w||v===14,v=u.scan();return m=v===16||u.getTokenError()!==0,v}const r=[];function i(v,g,_){!m&&g<c&&_>l&&E.substring(g,_)!==v&&r.push({offset:g,length:_-g,content:v})}let a=s();if(a!==17){const v=u.getTokenOffset()+f,g=k(h,P);i(g,f,v)}for(;a!==17;){let v=u.getTokenOffset()+u.getTokenLength()+f,g=s(),_="";for(;!w&&(g===12||g===13);){const o=u.getTokenOffset()+f;i(" ",v,o),v=u.getTokenOffset()+u.getTokenLength()+f,_=g===12?t():"",g=s()}if(g===2)a!==1&&(b--,_=t());else if(g===4)a!==3&&(b--,_=t());else{switch(a){case 3:case 1:b++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(g===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?_=" ":g!==5&&g!==17&&(m=!0);break;case 16:m=!0;break}w&&(g===12||g===13)&&(_=t())}const D=u.getTokenOffset()+f;i(_,v,D),a=g}return r}e.format=R;function k(E,C){let n="";for(let P=0;P<C;P++)n+=E;return n}function y(E,C){let n=0,P=0;const d=C.tabSize||4;for(;n<E.length;){const f=E.charAt(n);if(f===" ")P++;else if(f==="	")P+=d;else break;n++}return Math.floor(P/d)}function A(E,C){for(let n=0;n<C.length;n++){const P=C.charAt(n);if(P==="\r")return n+1<C.length&&C.charAt(n+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=A;function I(E,C){return`\r
`.indexOf(E.charAt(C))!==-1}e.isEOL=I}),define(fe[134],me([0,1,54,133]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(C,n,P){return y(C,n,void 0,P)}e.removeProperty=k;function y(C,n,P,d,f){const l=n.slice(),c=[],S=p.parseTree(C,c);let w,b;for(;l.length>0&&(b=l.pop(),w=p.findNodeAtLocation(S,l),w===void 0&&P!==void 0);)typeof b=="string"?P={[b]:P}:P=[P];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const h=p.findNodeAtLocation(w,[b]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const u=w.children.indexOf(h.parent);let m,t=h.parent.offset+h.parent.length;if(u>0){const s=w.children[u-1];m=s.offset+s.length}else m=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(C,{offset:m,length:t-m,content:""},d)}else return A(C,{offset:h.offset,length:h.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(P)}`,m=f?f(w.children.map(s=>s.children[0].value)):w.children.length;let t;if(m>0){const s=w.children[m-1];t={offset:s.offset+s.length,length:0,content:","+u}}else w.children.length===0?t={offset:w.offset+1,length:0,content:u}:t={offset:w.offset+1,length:0,content:u+","};return A(C,t,d)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let u;if(w.children.length===0||b===0)u={offset:w.offset+1,length:0,content:w.children.length===0?h:h+","};else{const m=b===-1||b>w.children.length?w.children.length:b,t=w.children[m-1];u={offset:t.offset+t.length,length:0,content:","+h}}return A(C,u,d)}else{const h=b,u=w.children[h];let m;if(w.children.length===1)m={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===h){const t=w.children[h-1],s=t.offset+t.length,r=w.offset+w.length;m={offset:s,length:r-2-s,content:""}}else m={offset:u.offset,length:w.children[h+1].offset-u.offset,content:""};return A(C,m,d)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(P)},d)}}e.setProperty=y;function A(C,n,P){let d=I(C,n),f=n.offset,l=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;f>0&&!R.isEOL(d,f-1);)f--;for(;l<d.length&&!R.isEOL(d,l);)l++}const c=R.format(d,{offset:f,length:l-f},P);for(let w=c.length-1;w>=0;w--){const b=c[w];d=I(d,b),f=Math.min(f,b.offset),l=Math.max(l,b.offset+b.length),l+=b.content.length-b.length}const S=C.length-(d.length-l)-f;return[{offset:f,length:S,content:d.substring(f,l)}]}e.withFormatting=A;function I(C,n){return C.substring(0,n.offset)+n.content+C.substring(n.offset+n.length)}e.applyEdit=I;function E(C,n){let P=n.slice(0).sort((f,l)=>{const c=f.offset-l.offset;return c===0?f.length-l.length:c}),d=C.length;for(let f=P.length-1;f>=0;f--){let l=P[f];if(l.offset+l.length<=d)C=I(C,l);else throw new Error("Overlapping edit");d=l.offset}return C}e.applyEdits=E}),define(fe[135],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new p(()=>k(this.getValue()))}}e.Lazy=p}),define(fe[6],me([0,1,69,53]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let y=null;function A(u){y=u}if(e.setDisposableTracker=A,k){const u="__is_disposable_tracked__";y=new class{trackDisposable(m){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[u]||console.log(t)},3e3)}markTracked(m){if(m&&m!==c.None)try{m[u]=!0}catch{}}}}function I(u){!y||y.markTracked(u)}function E(u){return y&&y.trackDisposable(u),u}e.trackDisposable=E;class C extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}e.MultiDisposeError=C;function n(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=n;function P(u){if(R.Iterable.is(u)){let m=[];for(const t of u)if(t){I(t);try{t.dispose()}catch(s){m.push(s)}}if(m.length===1)throw m[0];if(m.length>1)throw new C(m);return Array.isArray(u)?[]:u}else if(u)return I(u),u.dispose(),u}e.dispose=P;function d(...u){return u.forEach(I),f(()=>P(u))}e.combinedDisposable=d;function f(u){const m=E({dispose:()=>{I(m),u()}});return m}e.toDisposable=f;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return I(m),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new l,E(this)}dispose(){I(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&I(m),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(m,...t){let s=this.references.get(m);s||(s={counter:0,object:this.createReferencedObject(m,...t)},this.references.set(m,s));const{object:r}=s,i=p.once(()=>{--s.counter==0&&(this.destroyReferencedObject(m,s.object),this.references.delete(m))});return s.counter++,{object:r,dispose:i}}}e.ReferenceCollection=w;class b{constructor(m){this.referenceCollection=m}async acquire(m,...t){const s=this.referenceCollection.acquire(m,...t);try{return{object:await s.object,dispose:()=>s.dispose()}}catch(r){throw s.dispose(),r}}}e.AsyncReferenceCollection=b;class h{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=h}),define(fe[90],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(y){this.element=y,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let y=this._first;for(;y!==p.Undefined;){const A=y.next;y.prev=p.Undefined,y.next=p.Undefined,y=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const I=new p(y);if(this._first===p.Undefined)this._first=I,this._last=I;else if(A){const C=this._last;this._last=I,I.prev=C,C.next=I}else{const C=this._first;this._first=I,I.next=C,C.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==p.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==p.Undefined&&y.next!==p.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===p.Undefined&&y.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):y.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):y.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==p.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(ke,Ce){for(var Pe=0;Pe<Ce.length;Pe++){var oe=Ce[Pe];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ke,oe.key,oe)}}function e(ke,Ce,Pe){return Ce&&X(ke.prototype,Ce),Pe&&X(ke,Pe),ke}function p(ke,Ce){if(!!ke){if(typeof ke=="string")return R(ke,Ce);var Pe=Object.prototype.toString.call(ke).slice(8,-1);if(Pe==="Object"&&ke.constructor&&(Pe=ke.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(ke);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(ke,Ce)}}function R(ke,Ce){(Ce==null||Ce>ke.length)&&(Ce=ke.length);for(var Pe=0,oe=new Array(Ce);Pe<Ce;Pe++)oe[Pe]=ke[Pe];return oe}function k(ke,Ce){var Pe;if(typeof Symbol=="undefined"||ke[Symbol.iterator]==null){if(Array.isArray(ke)||(Pe=p(ke))||Ce&&ke&&typeof ke.length=="number"){Pe&&(ke=Pe);var oe=0;return function(){return oe>=ke.length?{done:!0}:{done:!1,value:ke[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=ke[Symbol.iterator](),Pe.next.bind(Pe)}function y(ke){var Ce={exports:{}};return ke(Ce,Ce.exports),Ce.exports}var A=y(function(ke){function Ce(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(oe){ke.exports.defaults=oe}ke.exports={defaults:Ce(),getDefaults:Ce,changeDefaults:Pe}}),I=/[&<>"']/,E=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Ce){return P[Ce]};function f(ke,Ce){if(Ce){if(I.test(ke))return ke.replace(E,d)}else if(C.test(ke))return ke.replace(n,d);return ke}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(ke){return ke.replace(l,function(Ce,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(ke,Ce){ke=ke.source||ke,Ce=Ce||"";var Pe={replace:function(ce,ge){return ge=ge.source||ge,ge=ge.replace(S,"$1"),ke=ke.replace(ce,ge),Pe},getRegex:function(){return new RegExp(ke,Ce)}};return Pe}var b=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ke,Ce,Pe){if(ke){var oe;try{oe=decodeURIComponent(c(Pe)).replace(b,"").toLowerCase()}catch(ce){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Ce&&!h.test(Pe)&&(Pe=i(Ce,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ce){return null}return Pe}var m={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(ke,Ce){m[" "+ke]||(t.test(ke)?m[" "+ke]=ke+"/":m[" "+ke]=_(ke,"/",!0)),ke=m[" "+ke];var Pe=ke.indexOf(":")===-1;return Ce.substring(0,2)==="//"?Pe?Ce:ke.replace(s,"$1")+Ce:Ce.charAt(0)==="/"?Pe?Ce:ke.replace(r,"$1")+Ce:ke+Ce}var a={exec:function(){}};function v(ke){for(var Ce=1,Pe,oe;Ce<arguments.length;Ce++){Pe=arguments[Ce];for(oe in Pe)Object.prototype.hasOwnProperty.call(Pe,oe)&&(ke[oe]=Pe[oe])}return ke}function g(ke,Ce){var Pe=ke.replace(/\|/g,function(ge,we,G){for(var pe=!1,_e=we;--_e>=0&&G[_e]==="\\";)pe=!pe;return pe?"|":" |"}),oe=Pe.split(/ \|/),ce=0;if(oe.length>Ce)oe.splice(Ce);else for(;oe.length<Ce;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function _(ke,Ce,Pe){var oe=ke.length;if(oe===0)return"";for(var ce=0;ce<oe;){var ge=ke.charAt(oe-ce-1);if(ge===Ce&&!Pe)ce++;else if(ge!==Ce&&Pe)ce++;else break}return ke.substr(0,oe-ce)}function D(ke,Ce){if(ke.indexOf(Ce[1])===-1)return-1;for(var Pe=ke.length,oe=0,ce=0;ce<Pe;ce++)if(ke[ce]==="\\")ce++;else if(ke[ce]===Ce[0])oe++;else if(ke[ce]===Ce[1]&&(oe--,oe<0))return ce;return-1}function o(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(ke,Ce){if(Ce<1)return"";for(var Pe="";Ce>1;)Ce&1&&(Pe+=ke),Ce>>=1,ke+=ke;return Pe+ke}var L={escape:f,unescape:c,edit:w,cleanUrl:u,resolveUrl:i,noopTest:a,merge:v,splitCells:g,rtrim:_,findClosingBracket:D,checkSanitizeDeprecation:o,repeatString:T},$=A.defaults,W=L.rtrim,Q=L.splitCells,z=L.escape,N=L.findClosingBracket;function H(ke,Ce,Pe){var oe=Ce.href,ce=Ce.title?z(Ce.title):null,ge=ke[1].replace(/\\([\[\]])/g,"$1");return ke[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:oe,title:ce,text:ge}:{type:"image",raw:Pe,href:oe,title:ce,text:z(ge)}}function F(ke,Ce){var Pe=ke.match(/^(\s+)(?:```)/);if(Pe===null)return Ce;var oe=Pe[1];return Ce.split(`
`).map(function(ce){var ge=ce.match(/^\s+/);if(ge===null)return ce;var we=ge[0];return we.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var x=function(){function ke(Pe){this.options=Pe||$}var Ce=ke.prototype;return Ce.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},Ce.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var ge=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:W(ge,`
`)}}},Ce.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var ge=ce[0],we=F(ge,ce[3]||"");return{type:"code",raw:ge,lang:ce[2]?ce[2].trim():ce[2],text:we}}},Ce.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var ge=ce[2].trim();if(/#$/.test(ge)){var we=W(ge,"#");(this.options.pedantic||!we||/ $/.test(we))&&(ge=we.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ge}}},Ce.nptable=function(oe){var ce=this.rules.block.nptable.exec(oe);if(ce){var ge={type:"table",header:Q(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[],raw:ce[0]};if(ge.header.length===ge.align.length){var we=ge.align.length,G;for(G=0;G<we;G++)/^ *-+: *$/.test(ge.align[G])?ge.align[G]="right":/^ *:-+: *$/.test(ge.align[G])?ge.align[G]="center":/^ *:-+ *$/.test(ge.align[G])?ge.align[G]="left":ge.align[G]=null;for(we=ge.cells.length,G=0;G<we;G++)ge.cells[G]=Q(ge.cells[G],ge.header.length);return ge}}},Ce.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},Ce.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var ge=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],text:ge}}},Ce.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var ge=ce[0],we=ce[2],G=we.length>1,pe={type:"list",raw:ge,ordered:G,start:G?+we.slice(0,-1):"",loose:!1,items:[]},_e=ce[0].match(this.rules.block.item),Ae=!1,Me,je,tt,Xe,Ye,lt,ut,Ee,Se=_e.length;tt=this.rules.block.listItemStart.exec(_e[0]);for(var le=0;le<Se;le++){if(Me=_e[le],ge=Me,le!==Se-1){if(Xe=this.rules.block.listItemStart.exec(_e[le+1]),this.options.pedantic?Xe[1].length>tt[1].length:Xe[1].length>tt[0].length||Xe[1].length>3){_e.splice(le,2,_e[le]+`
`+_e[le+1]),le--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?Xe[2][Xe[2].length-1]!==we[we.length-1]:G===(Xe[2].length===1))&&(Ye=_e.slice(le+1).join(`
`),pe.raw=pe.raw.substring(0,pe.raw.length-Ye.length),le=Se-1);tt=Xe}je=Me.length,Me=Me.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Me.indexOf(`
 `)&&(je-=Me.length,Me=this.options.pedantic?Me.replace(/^ {1,4}/gm,""):Me.replace(new RegExp("^ {1,"+je+"}","gm"),"")),lt=Ae||/\n\n(?!\s*$)/.test(Me),le!==Se-1&&(Ae=Me.charAt(Me.length-1)===`
`,lt||(lt=Ae)),lt&&(pe.loose=!0),this.options.gfm&&(ut=/^\[[ xX]\] /.test(Me),Ee=void 0,ut&&(Ee=Me[1]!==" ",Me=Me.replace(/^\[[ xX]\] +/,""))),pe.items.push({type:"list_item",raw:ge,task:ut,checked:Ee,loose:lt,text:Me})}return pe}},Ce.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce)return{type:this.options.sanitize?"paragraph":"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):z(ce[0]):ce[0]}},Ce.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ge=ce[1].toLowerCase().replace(/\s+/g," ");return{tag:ge,raw:ce[0],href:ce[2],title:ce[3]}}},Ce.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var ge={type:"table",header:Q(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ce[0];var we=ge.align.length,G;for(G=0;G<we;G++)/^ *-+: *$/.test(ge.align[G])?ge.align[G]="right":/^ *:-+: *$/.test(ge.align[G])?ge.align[G]="center":/^ *:-+ *$/.test(ge.align[G])?ge.align[G]="left":ge.align[G]=null;for(we=ge.cells.length,G=0;G<we;G++)ge.cells[G]=Q(ge.cells[G].replace(/^ *\| *| *\| *$/g,""),ge.header.length);return ge}}},Ce.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1]}},Ce.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce)return{type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1]}},Ce.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0]}},Ce.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:z(ce[1])}},Ce.tag=function(oe,ce,ge){var we=this.rules.inline.tag.exec(oe);if(we)return!ce&&/^<a /i.test(we[0])?ce=!0:ce&&/^<\/a>/i.test(we[0])&&(ce=!1),!ge&&/^<(pre|code|kbd|script)(\s|>)/i.test(we[0])?ge=!0:ge&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(we[0])&&(ge=!1),{type:this.options.sanitize?"text":"html",raw:we[0],inLink:ce,inRawBlock:ge,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):z(we[0]):we[0]}},Ce.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var ge=ce[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var we=W(ge.slice(0,-1),"\\");if((ge.length-we.length)%2==0)return}else{var G=N(ce[2],"()");if(G>-1){var pe=ce[0].indexOf("!")===0?5:4,_e=pe+ce[1].length+G;ce[2]=ce[2].substring(0,G),ce[0]=ce[0].substring(0,_e).trim(),ce[3]=""}}var Ae=ce[2],Me="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);je&&(Ae=je[1],Me=je[3])}else Me=ce[3]?ce[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ge)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),H(ce,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},ce[0])}},Ce.reflink=function(oe,ce){var ge;if((ge=this.rules.inline.reflink.exec(oe))||(ge=this.rules.inline.nolink.exec(oe))){var we=(ge[2]||ge[1]).replace(/\s+/g," ");if(we=ce[we.toLowerCase()],!we||!we.href){var G=ge[0].charAt(0);return{type:"text",raw:G,text:G}}return H(ge,we,ge[0])}},Ce.emStrong=function(oe,ce,ge){ge===void 0&&(ge="");var we=this.rules.inline.emStrong.lDelim.exec(oe);if(!!we&&!(we[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var G=we[1]||we[2]||"";if(!G||G&&(ge===""||this.rules.inline.punctuation.exec(ge))){var pe=we[0].length-1,_e,Ae,Me=pe,je=0,tt=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(tt.lastIndex=0,ce=ce.slice(-1*oe.length+pe);(we=tt.exec(ce))!=null;)if(_e=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!_e){if(Ae=_e.length,we[3]||we[4]){Me+=Ae;continue}else if((we[5]||we[6])&&pe%3&&!((pe+Ae)%3)){je+=Ae;continue}if(Me-=Ae,!(Me>0)){if(Me+je-Ae<=0&&!ce.slice(tt.lastIndex).match(tt)&&(Ae=Math.min(Ae,Ae+Me+je)),Math.min(pe,Ae)%2)return{type:"em",raw:oe.slice(0,pe+we.index+Ae+1),text:oe.slice(1,pe+we.index+Ae)};if(Math.min(pe,Ae)%2==0)return{type:"strong",raw:oe.slice(0,pe+we.index+Ae+1),text:oe.slice(2,pe+we.index+Ae-1)}}}}}},Ce.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var ge=ce[2].replace(/\n/g," "),we=/[^ ]/.test(ge),G=/^ /.test(ge)&&/ $/.test(ge);return we&&G&&(ge=ge.substring(1,ge.length-1)),ge=z(ge,!0),{type:"codespan",raw:ce[0],text:ge}}},Ce.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},Ce.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2]}},Ce.autolink=function(oe,ce){var ge=this.rules.inline.autolink.exec(oe);if(ge){var we,G;return ge[2]==="@"?(we=z(this.options.mangle?ce(ge[1]):ge[1]),G="mailto:"+we):(we=z(ge[1]),G=we),{type:"link",raw:ge[0],text:we,href:G,tokens:[{type:"text",raw:we,text:we}]}}},Ce.url=function(oe,ce){var ge;if(ge=this.rules.inline.url.exec(oe)){var we,G;if(ge[2]==="@")we=z(this.options.mangle?ce(ge[0]):ge[0]),G="mailto:"+we;else{var pe;do pe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(pe!==ge[0]);we=z(ge[0]),ge[1]==="www."?G="http://"+we:G=we}return{type:"link",raw:ge[0],text:we,href:G,tokens:[{type:"text",raw:we,text:we}]}}},Ce.inlineText=function(oe,ce,ge){var we=this.rules.inline.text.exec(oe);if(we){var G;return ce?G=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):z(we[0]):we[0]:G=z(this.options.smartypants?ge(we[0]):we[0]),{type:"text",raw:we[0],text:G}}},ke}(),O=L.noopTest,M=L.edit,B=L.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=M(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,V.item=M(V.item,"gm").replace(/bull/g,V.bullet).getRegex(),V.listItemStart=M(/^( *)(bull)/).replace("bull",V.bullet).getRegex(),V.list=M(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=M(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=M(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.blockquote=M(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=B({},V),V.gfm=B({},V.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.nptable=M(V.gfm.nptable).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.gfm.table=M(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.pedantic=B({},V.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:M(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=M(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=M(V._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=M(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=M(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=M(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=M(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=M(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=M(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=M(ee.reflink).replace("label",ee._label).getRegex(),ee.reflinkSearch=M(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=B({},ee),ee.pedantic=B({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=B({},ee.normal,{escape:M(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ee.gfm.url=M(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=B({},ee.gfm,{br:M(ee.br).replace("{2,}","*").getRegex(),text:M(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:V,inline:ee},ye=A.defaults,Fe=de.block,Re=de.inline,Ne=L.repeatString;function Ge(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ve(ke){var Ce="",Pe,oe,ce=ke.length;for(Pe=0;Pe<ce;Pe++)oe=ke.charCodeAt(Pe),Math.random()>.5&&(oe="x"+oe.toString(16)),Ce+="&#"+oe+";";return Ce}var qe=function(){function ke(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Fe.normal,inline:Re.normal};this.options.pedantic?(oe.block=Fe.pedantic,oe.inline=Re.pedantic):this.options.gfm&&(oe.block=Fe.gfm,this.options.breaks?oe.inline=Re.breaks:oe.inline=Re.gfm),this.tokenizer.rules=oe}ke.lex=function(oe,ce){var ge=new ke(ce);return ge.lex(oe)},ke.lexInline=function(oe,ce){var ge=new ke(ce);return ge.inlineTokens(oe)};var Ce=ke.prototype;return Ce.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},Ce.blockTokens=function(oe,ce,ge){ce===void 0&&(ce=[]),ge===void 0&&(ge=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var we,G,pe,_e;oe;){if(we=this.tokenizer.space(oe)){oe=oe.substring(we.raw.length),we.type&&ce.push(we);continue}if(we=this.tokenizer.code(oe)){oe=oe.substring(we.raw.length),_e=ce[ce.length-1],_e&&_e.type==="paragraph"?(_e.raw+=`
`+we.raw,_e.text+=`
`+we.text):ce.push(we);continue}if(we=this.tokenizer.fences(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.heading(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.nptable(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.hr(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.blockquote(oe)){oe=oe.substring(we.raw.length),we.tokens=this.blockTokens(we.text,[],ge),ce.push(we);continue}if(we=this.tokenizer.list(oe)){for(oe=oe.substring(we.raw.length),pe=we.items.length,G=0;G<pe;G++)we.items[G].tokens=this.blockTokens(we.items[G].text,[],!1);ce.push(we);continue}if(we=this.tokenizer.html(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(ge&&(we=this.tokenizer.def(oe))){oe=oe.substring(we.raw.length),this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.lheading(oe)){oe=oe.substring(we.raw.length),ce.push(we);continue}if(ge&&(we=this.tokenizer.paragraph(oe))){oe=oe.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.text(oe)){oe=oe.substring(we.raw.length),_e=ce[ce.length-1],_e&&_e.type==="text"?(_e.raw+=`
`+we.raw,_e.text+=`
`+we.text):ce.push(we);continue}if(oe){var Ae="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ce},Ce.inline=function(oe){var ce,ge,we,G,pe,_e,Ae=oe.length;for(ce=0;ce<Ae;ce++)switch(_e=oe[ce],_e.type){case"paragraph":case"text":case"heading":{_e.tokens=[],this.inlineTokens(_e.text,_e.tokens);break}case"table":{for(_e.tokens={header:[],cells:[]},G=_e.header.length,ge=0;ge<G;ge++)_e.tokens.header[ge]=[],this.inlineTokens(_e.header[ge],_e.tokens.header[ge]);for(G=_e.cells.length,ge=0;ge<G;ge++)for(pe=_e.cells[ge],_e.tokens.cells[ge]=[],we=0;we<pe.length;we++)_e.tokens.cells[ge][we]=[],this.inlineTokens(pe[we],_e.tokens.cells[ge][we]);break}case"blockquote":{this.inline(_e.tokens);break}case"list":{for(G=_e.items.length,ge=0;ge<G;ge++)this.inline(_e.items[ge].tokens);break}}return oe},Ce.inlineTokens=function(oe,ce,ge,we){ce===void 0&&(ce=[]),ge===void 0&&(ge=!1),we===void 0&&(we=!1);var G,pe,_e=oe,Ae,Me,je;if(this.tokens.links){var tt=Object.keys(this.tokens.links);if(tt.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)tt.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Ae.index)+"["+Ne("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"["+Ne("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if(Me||(je=""),Me=!1,G=this.tokenizer.escape(oe)){oe=oe.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.tag(oe,ge,we)){oe=oe.substring(G.raw.length),ge=G.inLink,we=G.inRawBlock;var Xe=ce[ce.length-1];Xe&&G.type==="text"&&Xe.type==="text"?(Xe.raw+=G.raw,Xe.text+=G.text):ce.push(G);continue}if(G=this.tokenizer.link(oe)){oe=oe.substring(G.raw.length),G.type==="link"&&(G.tokens=this.inlineTokens(G.text,[],!0,we)),ce.push(G);continue}if(G=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(G.raw.length);var Ye=ce[ce.length-1];G.type==="link"?(G.tokens=this.inlineTokens(G.text,[],!0,we),ce.push(G)):Ye&&G.type==="text"&&Ye.type==="text"?(Ye.raw+=G.raw,Ye.text+=G.text):ce.push(G);continue}if(G=this.tokenizer.emStrong(oe,_e,je)){oe=oe.substring(G.raw.length),G.tokens=this.inlineTokens(G.text,[],ge,we),ce.push(G);continue}if(G=this.tokenizer.codespan(oe)){oe=oe.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.br(oe)){oe=oe.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.del(oe)){oe=oe.substring(G.raw.length),G.tokens=this.inlineTokens(G.text,[],ge,we),ce.push(G);continue}if(G=this.tokenizer.autolink(oe,Ve)){oe=oe.substring(G.raw.length),ce.push(G);continue}if(!ge&&(G=this.tokenizer.url(oe,Ve))){oe=oe.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.inlineText(oe,we,Ge)){oe=oe.substring(G.raw.length),G.raw.slice(-1)!=="_"&&(je=G.raw.slice(-1)),Me=!0,pe=ce[ce.length-1],pe&&pe.type==="text"?(pe.raw+=G.raw,pe.text+=G.text):ce.push(G);continue}if(oe){var lt="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ce},e(ke,null,[{key:"rules",get:function(){return{block:Fe,inline:Re}}}]),ke}(),q=A.defaults,Z=L.cleanUrl,re=L.escape,ae=function(){function ke(Pe){this.options=Pe||q}var Ce=ke.prototype;return Ce.code=function(oe,ce,ge){var we=(ce||"").match(/\S*/)[0];if(this.options.highlight){var G=this.options.highlight(oe,we);G!=null&&G!==oe&&(ge=!0,oe=G)}return oe=oe.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+re(we,!0)+'">'+(ge?oe:re(oe,!0))+`</code></pre>
`:"<pre><code>"+(ge?oe:re(oe,!0))+`</code></pre>
`},Ce.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Ce.html=function(oe){return oe},Ce.heading=function(oe,ce,ge,we){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+we.slug(ge)+'">'+oe+"</h"+ce+`>
`:"<h"+ce+">"+oe+"</h"+ce+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(oe,ce,ge){var we=ce?"ol":"ul",G=ce&&ge!==1?' start="'+ge+'"':"";return"<"+we+G+`>
`+oe+"</"+we+`>
`},Ce.listitem=function(oe){return"<li>"+oe+`</li>
`},Ce.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(oe){return"<p>"+oe+`</p>
`},Ce.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},Ce.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Ce.tablecell=function(oe,ce){var ge=ce.header?"th":"td",we=ce.align?"<"+ge+' align="'+ce.align+'">':"<"+ge+">";return we+oe+"</"+ge+`>
`},Ce.strong=function(oe){return"<strong>"+oe+"</strong>"},Ce.em=function(oe){return"<em>"+oe+"</em>"},Ce.codespan=function(oe){return"<code>"+oe+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(oe){return"<del>"+oe+"</del>"},Ce.link=function(oe,ce,ge){if(oe=Z(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ge;var we='<a href="'+re(oe)+'"';return ce&&(we+=' title="'+ce+'"'),we+=">"+ge+"</a>",we},Ce.image=function(oe,ce,ge){if(oe=Z(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ge;var we='<img src="'+oe+'" alt="'+ge+'"';return ce&&(we+=' title="'+ce+'"'),we+=this.options.xhtml?"/>":">",we},Ce.text=function(oe){return oe},ke}(),J=function(){function ke(){}var Ce=ke.prototype;return Ce.strong=function(oe){return oe},Ce.em=function(oe){return oe},Ce.codespan=function(oe){return oe},Ce.del=function(oe){return oe},Ce.html=function(oe){return oe},Ce.text=function(oe){return oe},Ce.link=function(oe,ce,ge){return""+ge},Ce.image=function(oe,ce,ge){return""+ge},Ce.br=function(){return""},ke}(),se=function(){function ke(){this.seen={}}var Ce=ke.prototype;return Ce.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(oe,ce){var ge=oe,we=0;if(this.seen.hasOwnProperty(ge)){we=this.seen[oe];do we++,ge=oe+"-"+we;while(this.seen.hasOwnProperty(ge))}return ce||(this.seen[oe]=we,this.seen[ge]=0),ge},Ce.slug=function(oe,ce){ce===void 0&&(ce={});var ge=this.serialize(oe);return this.getNextSafeSlug(ge,ce.dryrun)},ke}(),ve=A.defaults,Le=L.unescape,He=function(){function ke(Pe){this.options=Pe||ve,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new se}ke.parse=function(oe,ce){var ge=new ke(ce);return ge.parse(oe)},ke.parseInline=function(oe,ce){var ge=new ke(ce);return ge.parseInline(oe)};var Ce=ke.prototype;return Ce.parse=function(oe,ce){ce===void 0&&(ce=!0);var ge="",we,G,pe,_e,Ae,Me,je,tt,Xe,Ye,lt,ut,Ee,Se,le,Y,Be,De,Ze=oe.length;for(we=0;we<Ze;we++)switch(Ye=oe[we],Ye.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Le(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(tt="",je="",_e=Ye.header.length,G=0;G<_e;G++)je+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[G]),{header:!0,align:Ye.align[G]});for(tt+=this.renderer.tablerow(je),Xe="",_e=Ye.cells.length,G=0;G<_e;G++){for(Me=Ye.tokens.cells[G],je="",Ae=Me.length,pe=0;pe<Ae;pe++)je+=this.renderer.tablecell(this.parseInline(Me[pe]),{header:!1,align:Ye.align[pe]});Xe+=this.renderer.tablerow(je)}ge+=this.renderer.table(tt,Xe);continue}case"blockquote":{Xe=this.parse(Ye.tokens),ge+=this.renderer.blockquote(Xe);continue}case"list":{for(lt=Ye.ordered,ut=Ye.start,Ee=Ye.loose,_e=Ye.items.length,Xe="",G=0;G<_e;G++)le=Ye.items[G],Y=le.checked,Be=le.task,Se="",le.task&&(De=this.renderer.checkbox(Y),Ee?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=De+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=De+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:De}):Se+=De),Se+=this.parse(le.tokens,Ee),Xe+=this.renderer.listitem(Se,Be,Y);ge+=this.renderer.list(Xe,lt,ut);continue}case"html":{ge+=this.renderer.html(Ye.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(Xe=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;we+1<Ze&&oe[we+1].type==="text";)Ye=oe[++we],Xe+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);ge+=ce?this.renderer.paragraph(Xe):Xe;continue}default:{var Ke='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}return ge},Ce.parseInline=function(oe,ce){ce=ce||this.renderer;var ge="",we,G,pe=oe.length;for(we=0;we<pe;we++)switch(G=oe[we],G.type){case"escape":{ge+=ce.text(G.text);break}case"html":{ge+=ce.html(G.text);break}case"link":{ge+=ce.link(G.href,G.title,this.parseInline(G.tokens,ce));break}case"image":{ge+=ce.image(G.href,G.title,G.text);break}case"strong":{ge+=ce.strong(this.parseInline(G.tokens,ce));break}case"em":{ge+=ce.em(this.parseInline(G.tokens,ce));break}case"codespan":{ge+=ce.codespan(G.text);break}case"br":{ge+=ce.br();break}case"del":{ge+=ce.del(this.parseInline(G.tokens,ce));break}case"text":{ge+=ce.text(G.text);break}default:{var _e='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}return ge},ke}(),be=L.merge,Je=L.checkSanitizeDeprecation,K=L.escape,ie=A.getDefaults,he=A.changeDefaults,xe=A.defaults;function $e(ke,Ce,Pe){if(typeof ke=="undefined"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof Ce=="function"&&(Pe=Ce,Ce=null),Ce=be({},$e.defaults,Ce||{}),Je(Ce),Pe){var oe=Ce.highlight,ce;try{ce=qe.lex(ke,Ce)}catch(pe){return Pe(pe)}var ge=function(_e){var Ae;if(!_e)try{Ae=He.parse(ce,Ce)}catch(Me){_e=Me}return Ce.highlight=oe,_e?Pe(_e):Pe(null,Ae)};if(!oe||oe.length<3||(delete Ce.highlight,!ce.length))return ge();var we=0;$e.walkTokens(ce,function(pe){pe.type==="code"&&(we++,setTimeout(function(){oe(pe.text,pe.lang,function(_e,Ae){if(_e)return ge(_e);Ae!=null&&Ae!==pe.text&&(pe.text=Ae,pe.escaped=!0),we--,we===0&&ge()})},0))}),we===0&&ge();return}try{var G=qe.lex(ke,Ce);return Ce.walkTokens&&$e.walkTokens(G,Ce.walkTokens),He.parse(G,Ce)}catch(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+K(pe.message+"",!0)+"</pre>";throw pe}}$e.options=$e.setOptions=function(ke){return be($e.defaults,ke),he($e.defaults),$e},$e.getDefaults=ie,$e.defaults=xe,$e.use=function(ke){var Ce=be({},ke);if(ke.renderer&&function(){var oe=$e.defaults.renderer||new ae,ce=function(G){var pe=oe[G];oe[G]=function(){for(var _e=arguments.length,Ae=new Array(_e),Me=0;Me<_e;Me++)Ae[Me]=arguments[Me];var je=ke.renderer[G].apply(oe,Ae);return je===!1&&(je=pe.apply(oe,Ae)),je}};for(var ge in ke.renderer)ce(ge);Ce.renderer=oe}(),ke.tokenizer&&function(){var oe=$e.defaults.tokenizer||new x,ce=function(G){var pe=oe[G];oe[G]=function(){for(var _e=arguments.length,Ae=new Array(_e),Me=0;Me<_e;Me++)Ae[Me]=arguments[Me];var je=ke.tokenizer[G].apply(oe,Ae);return je===!1&&(je=pe.apply(oe,Ae)),je}};for(var ge in ke.tokenizer)ce(ge);Ce.tokenizer=oe}(),ke.walkTokens){var Pe=$e.defaults.walkTokens;Ce.walkTokens=function(oe){ke.walkTokens(oe),Pe&&Pe(oe)}}$e.setOptions(Ce)},$e.walkTokens=function(ke,Ce){for(var Pe=k(ke),oe;!(oe=Pe()).done;){var ce=oe.value;switch(Ce(ce),ce.type){case"table":{for(var ge=k(ce.tokens.header),we;!(we=ge()).done;){var G=we.value;$e.walkTokens(G,Ce)}for(var pe=k(ce.tokens.cells),_e;!(_e=pe()).done;)for(var Ae=_e.value,Me=k(Ae),je;!(je=Me()).done;){var tt=je.value;$e.walkTokens(tt,Ce)}break}case"list":{$e.walkTokens(ce.items,Ce);break}default:ce.tokens&&$e.walkTokens(ce.tokens,Ce)}}},$e.parseInline=function(ke,Ce){if(typeof ke=="undefined"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");Ce=be({},$e.defaults,Ce||{}),Je(Ce);try{var Pe=qe.lexInline(ke,Ce);return Ce.walkTokens&&$e.walkTokens(Pe,Ce.walkTokens),He.parseInline(Pe,Ce)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+K(oe.message+"",!0)+"</pre>";throw oe}},$e.Parser=He,$e.parser=He.parse,$e.Renderer=ae,$e.TextRenderer=J,$e.Lexer=qe,$e.lexer=qe.lex,$e.Tokenizer=x,$e.Slugger=se,$e.parse=$e;var et=$e;return et}),define(fe[71],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(A,I,E){return Math.min(Math.max(A,I),E)}e.clamp=p;function R(A,I){return(I+A%I)%I}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class y{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function A(E){y.push(E,Date.now())}function I(){const E=[];for(let C=0;C<y.length;C+=2)E.push({name:y[C],startTime:y[C+1]});return E}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(k+A.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(fe[11],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const p="en";let R=!1,k=!1,y=!1,A=!1,I=!1,E=!1,C=!1,n,P=p,d,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const c=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=c&&l?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=l?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!c)f=navigator.userAgent,R=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=f.indexOf("Linux")>=0,E=!0,n=navigator.language,P=n;else if(typeof l=="object"){R=l.platform==="win32",k=l.platform==="darwin",y=l.platform==="linux",A=y&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,n=p,P=p;const r=l.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),a=i.availableLanguages["*"];n=i.locale,P=a||p,d=i._translationsConfigFile}catch(i){}I=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function w(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let b=0;k?b=1:R?b=3:y&&(b=2),e.isWindows=R,e.isMacintosh=k,e.isLinux=y,e.isLinuxSnap=A,e.isNative=I,e.isWeb=E,e.isIOS=C,e.platform=b,e.userAgent=f,e.language=P;var h;(function(r){function i(){return e.language}r.value=i;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function v(){return e.language==="en"}r.isDefault=v})(h=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeSetImmediateId)for(let _=0,D=a.length;_<D;_++){const o=a[_];if(o.id===g.data.vscodeSetImmediateId){a.splice(_,1),o.callback();return}}});let v=0;return g=>{const _=++v;a.push({id:_,callback:g}),e.globals.postMessage({vscodeSetImmediateId:_},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const i=Promise.resolve();return a=>i.then(a)}();var u;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||C?2:R?1:3;let m=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,m=new Uint16Array(r.buffer)[0]===(2<<8)+1}return m}e.isLittleEndian=s}),define(fe[37],me([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const k=p.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return p.setImmediate(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(k){return p.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(fe[9],me([0,1,37]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,y=90,A=122,I=46,E=47,C=92,n=58,P=63;class d extends Error{constructor(u,m,t){let s;typeof m=="string"&&m.indexOf("not ")===0?(s="must not be",m=m.replace(/^not /,"")):s="must be";const r=u.indexOf(".")!==-1?"property":"argument";let i=`The "${u}" ${r} ${s} of type ${m}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(h,u){if(typeof h!="string")throw new d(u,"string",h)}function l(h){return h===E||h===C}function c(h){return h===E}function S(h){return h>=R&&h<=y||h>=k&&h<=A}function w(h,u,m,t){let s="",r=0,i=-1,a=0,v=0;for(let g=0;g<=h.length;++g){if(g<h.length)v=h.charCodeAt(g);else{if(t(v))break;v=E}if(t(v)){if(!(i===g-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const _=s.lastIndexOf(m);_===-1?(s="",r=0):(s=s.slice(0,_),r=s.length-1-s.lastIndexOf(m)),i=g,a=0;continue}else if(s.length!==0){s="",r=0,i=g,a=0;continue}}u&&(s+=s.length>0?`${m}..`:"..",r=2)}else s.length>0?s+=`${m}${h.slice(i+1,g)}`:s=h.slice(i+1,g),r=g-i-1;i=g,a=0}else v===I&&a!==-1?++a:a=-1}return s}function b(h,u){if(u===null||typeof u!="object")throw new d("pathObject","Object",u);const m=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return m?m===u.root?`${m}${t}`:`${m}${h}${t}`:t}e.win32={resolve(...h){let u="",m="",t=!1;for(let s=h.length-1;s>=-1;s--){let r;if(s>=0){if(r=h[s],f(r,"path"),r.length===0)continue}else u.length===0?r=p.cwd():(r=p.env[`=${u}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==u.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${u}\\`));const i=r.length;let a=0,v="",g=!1;const _=r.charCodeAt(0);if(i===1)l(_)&&(a=1,g=!0);else if(l(_))if(g=!0,l(r.charCodeAt(1))){let D=2,o=D;for(;D<i&&!l(r.charCodeAt(D));)D++;if(D<i&&D!==o){const T=r.slice(o,D);for(o=D;D<i&&l(r.charCodeAt(D));)D++;if(D<i&&D!==o){for(o=D;D<i&&!l(r.charCodeAt(D));)D++;(D===i||D!==o)&&(v=`\\\\${T}\\${r.slice(o,D)}`,a=D)}}}else a=1;else S(_)&&r.charCodeAt(1)===n&&(v=r.slice(0,2),a=2,i>2&&l(r.charCodeAt(2))&&(g=!0,a=3));if(v.length>0)if(u.length>0){if(v.toLowerCase()!==u.toLowerCase())continue}else u=v;if(t){if(u.length>0)break}else if(m=`${r.slice(a)}\\${m}`,t=g,g&&u.length>0)break}return m=w(m,!t,"\\",l),t?`${u}\\${m}`:`${u}${m}`||"."},normalize(h){f(h,"path");const u=h.length;if(u===0)return".";let m=0,t,s=!1;const r=h.charCodeAt(0);if(u===1)return c(r)?"\\":h;if(l(r))if(s=!0,l(h.charCodeAt(1))){let a=2,v=a;for(;a<u&&!l(h.charCodeAt(a));)a++;if(a<u&&a!==v){const g=h.slice(v,a);for(v=a;a<u&&l(h.charCodeAt(a));)a++;if(a<u&&a!==v){for(v=a;a<u&&!l(h.charCodeAt(a));)a++;if(a===u)return`\\\\${g}\\${h.slice(v)}\\`;a!==v&&(t=`\\\\${g}\\${h.slice(v,a)}`,m=a)}}}else m=1;else S(r)&&h.charCodeAt(1)===n&&(t=h.slice(0,2),m=2,u>2&&l(h.charCodeAt(2))&&(s=!0,m=3));let i=m<u?w(h.slice(m),!s,"\\",l):"";return i.length===0&&!s&&(i="."),i.length>0&&l(h.charCodeAt(u-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(h){f(h,"path");const u=h.length;if(u===0)return!1;const m=h.charCodeAt(0);return l(m)||u>2&&S(m)&&h.charCodeAt(1)===n&&l(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let u,m;for(let r=0;r<h.length;++r){const i=h[r];f(i,"path"),i.length>0&&(u===void 0?u=m=i:u+=`\\${i}`)}if(u===void 0)return".";let t=!0,s=0;if(typeof m=="string"&&l(m.charCodeAt(0))){++s;const r=m.length;r>1&&l(m.charCodeAt(1))&&(++s,r>2&&(l(m.charCodeAt(2))?++s:t=!1))}if(t){for(;s<u.length&&l(u.charCodeAt(s));)s++;s>=2&&(u=`\\${u.slice(s)}`)}return e.win32.normalize(u)},relative(h,u){if(f(h,"from"),f(u,"to"),h===u)return"";const m=e.win32.resolve(h),t=e.win32.resolve(u);if(m===t||(h=m.toLowerCase(),u=t.toLowerCase(),h===u))return"";let s=0;for(;s<h.length&&h.charCodeAt(s)===C;)s++;let r=h.length;for(;r-1>s&&h.charCodeAt(r-1)===C;)r--;const i=r-s;let a=0;for(;a<u.length&&u.charCodeAt(a)===C;)a++;let v=u.length;for(;v-1>a&&u.charCodeAt(v-1)===C;)v--;const g=v-a,_=i<g?i:g;let D=-1,o=0;for(;o<_;o++){const L=h.charCodeAt(s+o);if(L!==u.charCodeAt(a+o))break;L===C&&(D=o)}if(o!==_){if(D===-1)return t}else{if(g>_){if(u.charCodeAt(a+o)===C)return t.slice(a+o+1);if(o===2)return t.slice(a+o)}i>_&&(h.charCodeAt(s+o)===C?D=o:o===2&&(D=3)),D===-1&&(D=0)}let T="";for(o=s+D+1;o<=r;++o)(o===r||h.charCodeAt(o)===C)&&(T+=T.length===0?"..":"\\..");return a+=D,T.length>0?`${T}${t.slice(a,v)}`:(t.charCodeAt(a)===C&&++a,t.slice(a,v))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const u=e.win32.resolve(h);if(u.length<=2)return h;if(u.charCodeAt(0)===C){if(u.charCodeAt(1)===C){const m=u.charCodeAt(2);if(m!==P&&m!==I)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===n&&u.charCodeAt(2)===C)return`\\\\?\\${u}`;return h},dirname(h){f(h,"path");const u=h.length;if(u===0)return".";let m=-1,t=0;const s=h.charCodeAt(0);if(u===1)return l(s)?h:".";if(l(s)){if(m=t=1,l(h.charCodeAt(1))){let a=2,v=a;for(;a<u&&!l(h.charCodeAt(a));)a++;if(a<u&&a!==v){for(v=a;a<u&&l(h.charCodeAt(a));)a++;if(a<u&&a!==v){for(v=a;a<u&&!l(h.charCodeAt(a));)a++;if(a===u)return h;a!==v&&(m=t=a+1)}}}}else S(s)&&h.charCodeAt(1)===n&&(m=u>2&&l(h.charCodeAt(2))?3:2,t=m);let r=-1,i=!0;for(let a=u-1;a>=t;--a)if(l(h.charCodeAt(a))){if(!i){r=a;break}}else i=!1;if(r===-1){if(m===-1)return".";r=m}return h.slice(0,r)},basename(h,u){u!==void 0&&f(u,"ext"),f(h,"path");let m=0,t=-1,s=!0,r;if(h.length>=2&&S(h.charCodeAt(0))&&h.charCodeAt(1)===n&&(m=2),u!==void 0&&u.length>0&&u.length<=h.length){if(u===h)return"";let i=u.length-1,a=-1;for(r=h.length-1;r>=m;--r){const v=h.charCodeAt(r);if(l(v)){if(!s){m=r+1;break}}else a===-1&&(s=!1,a=r+1),i>=0&&(v===u.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=a))}return m===t?t=a:t===-1&&(t=h.length),h.slice(m,t)}for(r=h.length-1;r>=m;--r)if(l(h.charCodeAt(r))){if(!s){m=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(m,t)},extname(h){f(h,"path");let u=0,m=-1,t=0,s=-1,r=!0,i=0;h.length>=2&&h.charCodeAt(1)===n&&S(h.charCodeAt(0))&&(u=t=2);for(let a=h.length-1;a>=u;--a){const v=h.charCodeAt(a);if(l(v)){if(!r){t=a+1;break}continue}s===-1&&(r=!1,s=a+1),v===I?m===-1?m=a:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||s===-1||i===0||i===1&&m===s-1&&m===t+1?"":h.slice(m,s)},format:b.bind(null,"\\"),parse(h){f(h,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return u;const m=h.length;let t=0,s=h.charCodeAt(0);if(m===1)return l(s)?(u.root=u.dir=h,u):(u.base=u.name=h,u);if(l(s)){if(t=1,l(h.charCodeAt(1))){let D=2,o=D;for(;D<m&&!l(h.charCodeAt(D));)D++;if(D<m&&D!==o){for(o=D;D<m&&l(h.charCodeAt(D));)D++;if(D<m&&D!==o){for(o=D;D<m&&!l(h.charCodeAt(D));)D++;D===m?t=D:D!==o&&(t=D+1)}}}}else if(S(s)&&h.charCodeAt(1)===n){if(m<=2)return u.root=u.dir=h,u;if(t=2,l(h.charCodeAt(2))){if(m===3)return u.root=u.dir=h,u;t=3}}t>0&&(u.root=h.slice(0,t));let r=-1,i=t,a=-1,v=!0,g=h.length-1,_=0;for(;g>=t;--g){if(s=h.charCodeAt(g),l(s)){if(!v){i=g+1;break}continue}a===-1&&(v=!1,a=g+1),s===I?r===-1?r=g:_!==1&&(_=1):r!==-1&&(_=-1)}return a!==-1&&(r===-1||_===0||_===1&&r===a-1&&r===i+1?u.base=u.name=h.slice(i,a):(u.name=h.slice(i,r),u.base=h.slice(i,a),u.ext=h.slice(r,a))),i>0&&i!==t?u.dir=h.slice(0,i-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let u="",m=!1;for(let t=h.length-1;t>=-1&&!m;t--){const s=t>=0?h[t]:p.cwd();f(s,"path"),s.length!==0&&(u=`${s}/${u}`,m=s.charCodeAt(0)===E)}return u=w(u,!m,"/",c),m?`/${u}`:u.length>0?u:"."},normalize(h){if(f(h,"path"),h.length===0)return".";const u=h.charCodeAt(0)===E,m=h.charCodeAt(h.length-1)===E;return h=w(h,!u,"/",c),h.length===0?u?"/":m?"./":".":(m&&(h+="/"),u?`/${h}`:h)},isAbsolute(h){return f(h,"path"),h.length>0&&h.charCodeAt(0)===E},join(...h){if(h.length===0)return".";let u;for(let m=0;m<h.length;++m){const t=h[m];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(h,u){if(f(h,"from"),f(u,"to"),h===u||(h=e.posix.resolve(h),u=e.posix.resolve(u),h===u))return"";const m=1,t=h.length,s=t-m,r=1,i=u.length-r,a=s<i?s:i;let v=-1,g=0;for(;g<a;g++){const D=h.charCodeAt(m+g);if(D!==u.charCodeAt(r+g))break;D===E&&(v=g)}if(g===a)if(i>a){if(u.charCodeAt(r+g)===E)return u.slice(r+g+1);if(g===0)return u.slice(r+g)}else s>a&&(h.charCodeAt(m+g)===E?v=g:g===0&&(v=0));let _="";for(g=m+v+1;g<=t;++g)(g===t||h.charCodeAt(g)===E)&&(_+=_.length===0?"..":"/..");return`${_}${u.slice(r+v)}`},toNamespacedPath(h){return h},dirname(h){if(f(h,"path"),h.length===0)return".";const u=h.charCodeAt(0)===E;let m=-1,t=!0;for(let s=h.length-1;s>=1;--s)if(h.charCodeAt(s)===E){if(!t){m=s;break}}else t=!1;return m===-1?u?"/":".":u&&m===1?"//":h.slice(0,m)},basename(h,u){u!==void 0&&f(u,"ext"),f(h,"path");let m=0,t=-1,s=!0,r;if(u!==void 0&&u.length>0&&u.length<=h.length){if(u===h)return"";let i=u.length-1,a=-1;for(r=h.length-1;r>=0;--r){const v=h.charCodeAt(r);if(v===E){if(!s){m=r+1;break}}else a===-1&&(s=!1,a=r+1),i>=0&&(v===u.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=a))}return m===t?t=a:t===-1&&(t=h.length),h.slice(m,t)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===E){if(!s){m=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(m,t)},extname(h){f(h,"path");let u=-1,m=0,t=-1,s=!0,r=0;for(let i=h.length-1;i>=0;--i){const a=h.charCodeAt(i);if(a===E){if(!s){m=i+1;break}continue}t===-1&&(s=!1,t=i+1),a===I?u===-1?u=i:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||t===-1||r===0||r===1&&u===t-1&&u===m+1?"":h.slice(u,t)},format:b.bind(null,"/"),parse(h){f(h,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return u;const m=h.charCodeAt(0)===E;let t;m?(u.root="/",t=1):t=0;let s=-1,r=0,i=-1,a=!0,v=h.length-1,g=0;for(;v>=t;--v){const _=h.charCodeAt(v);if(_===E){if(!a){r=v+1;break}continue}i===-1&&(a=!1,i=v+1),_===I?s===-1?s=v:g!==1&&(g=1):s!==-1&&(g=-1)}if(i!==-1){const _=r===0&&m?1:r;s===-1||g===0||g===1&&s===i-1&&s===r+1?u.base=u.name=h.slice(_,i):(u.name=h.slice(_,s),u.base=h.slice(_,i),u.ext=h.slice(s,i))}return r>0?u.dir=h.slice(0,r-1):m&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[136],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...A){const I=A.reduce((n,P)=>(n[P]=!0,n),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(n=>!I[n]).forEach(n=>{for(let P=0;P<E.length;P++)if(n.search(E[P])!==-1){delete y[n];break}})}e.sanitizeProcessEnvironment=k}),define(fe[43],me([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class k{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=k}),define(fe[3],me([0,1,15,69,6,90,43]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(h){h.None=()=>k.Disposable.None;function u(z){return(N,H=null,F)=>{let x=!1,O;return O=z(M=>{if(!x)return O?O.dispose():x=!0,N.call(H,M)},null,F),x&&O.dispose(),O}}h.once=u;function m(z,N){return v((H,F=null,x)=>z(O=>H.call(F,N(O)),null,x))}h.map=m;function t(z,N){return v((H,F=null,x)=>z(O=>{N(O),H.call(F,O)},null,x))}h.forEach=t;function s(z,N){return v((H,F=null,x)=>z(O=>N(O)&&H.call(F,O),null,x))}h.filter=s;function r(z){return z}h.signal=r;function i(...z){return(N,H=null,F)=>k.combinedDisposable(...z.map(x=>x(O=>N.call(H,O),null,F)))}h.any=i;function a(z,N,H){let F=H;return m(z,x=>(F=N(F,x),F))}h.reduce=a;function v(z){let N;const H=new d({onFirstListenerAdd(){N=z(H.fire,H)},onLastListenerRemove(){N.dispose()}});return H.event}function g(z,N,H=100,F=!1,x){let O,M,B,V=0;const ee=new d({leakWarningThreshold:x,onFirstListenerAdd(){O=z(de=>{V++,M=N(M,de),F&&!B&&(ee.fire(M),M=void 0),clearTimeout(B),B=setTimeout(()=>{const ye=M;M=void 0,B=void 0,(!F||V>1)&&ee.fire(ye),V=0},H)})},onLastListenerRemove(){O.dispose()}});return ee.event}h.debounce=g;function _(z,N=(H,F)=>H===F){let H=!0,F;return s(z,x=>{const O=H||!N(x,F);return H=!1,F=x,O})}h.latch=_;function D(z,N){return[h.filter(z,N),h.filter(z,H=>!N(H))]}h.split=D;function o(z,N=!1,H=[]){let F=H.slice(),x=z(B=>{F?F.push(B):M.fire(B)});const O=()=>{F&&F.forEach(B=>M.fire(B)),F=null},M=new d({onFirstListenerAdd(){x||(x=z(B=>M.fire(B)))},onFirstListenerDidAdd(){F&&(N?setTimeout(O):O())},onLastListenerRemove(){x&&x.dispose(),x=null}});return M.event}h.buffer=o;class T{constructor(N){this.event=N}map(N){return new T(m(this.event,N))}forEach(N){return new T(t(this.event,N))}filter(N){return new T(s(this.event,N))}reduce(N,H){return new T(a(this.event,N,H))}latch(){return new T(_(this.event))}debounce(N,H=100,F=!1,x){return new T(g(this.event,N,H,F,x))}on(N,H,F){return this.event(N,H,F)}once(N,H,F){return u(this.event)(N,H,F)}}function L(z){return new T(z)}h.chain=L;function $(z,N,H=F=>F){const F=(...B)=>M.fire(H(...B)),x=()=>z.on(N,F),O=()=>z.removeListener(N,F),M=new d({onFirstListenerAdd:x,onLastListenerRemove:O});return M.event}h.fromNodeEventEmitter=$;function W(z,N,H=F=>F){const F=(...B)=>M.fire(H(...B)),x=()=>z.addEventListener(N,F),O=()=>z.removeEventListener(N,F),M=new d({onFirstListenerAdd:x,onLastListenerRemove:O});return M.event}h.fromDOMEventEmitter=W;function Q(z){return new Promise(N=>u(z)(N))}h.toPromise=Q})(I=e.Event||(e.Event={}));class E{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${E._idPool++}`}start(u){this._stopWatch=new A.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let C=-1;function n(h){const u=C;return C=h,{dispose(){C=u}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(u,m=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let m=C;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),m<=0||u<m)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let r,i=0;for(const[a,v]of this._stacks)(!r||i<v)&&(r=a,i=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class d{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=C>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(u,m,t)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(m?[u,m]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,m);const i=this._leakageMon?.check(this._listeners.size);let a;return a={dispose:()=>{i&&i(),a.dispose=d._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},t instanceof k.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,t]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,t):m[0].call(m[1],t)}catch(s){p.onUnexpectedError(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d,d._noop=function(){};class f extends d{async fireAsync(u,m,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),i=[],a={...r,waitUntil:v=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(v=t(v,typeof s=="function"?s:s[0])),i.push(v)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(v){p.onUnexpectedError(v);continue}Object.freeze(i),await Promise.allSettled(i).then(v=>{for(const g of v)g.status==="rejected"&&p.onUnexpectedError(g.reason)})}}}}e.AsyncEmitter=f;class l extends d{constructor(u){super(u);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=l;class c extends l{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=c;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const m={event:u,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const t=()=>{this.hasListeners&&this.unhook(m);const s=this.events.indexOf(m);this.events.splice(s,1)};return k.toDisposable(R.once(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(m=>this.emitter.fire(m))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class w{constructor(){this.buffers=[]}wrapEvent(u){return(m,t,s)=>u(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>m.call(t,r)):m.call(t,r)},void 0,s)}bufferEvents(u){const m=[];this.buffers.push(m);const t=u();return this.buffers.pop(),m.forEach(s=>s()),t}}e.EventBufferer=w;class b{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(fe[21],me([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,E){const C=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(C)}}});var k;(function(I){function E(C){return C===I.None||C===I.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(fe[91],me([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function y(n,P){return new I(n,P)}e.registerCodicon=y;function A(n){return n?n.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=A;class I{constructor(P,d,f){this.id=P,this.definition=d,this.description=f,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function E(n,P){const d=["codicon","codicon-"+n];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=E;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(c){if(c instanceof I)return["codicon","codicon-"+c.id];const S=P.exec(c.id);if(!S)return d(I.error);let[,w,b]=S;const h=["codicon","codicon-"+w];return b&&h.push("codicon-modifier-"+b.substr(1)),h}n.asClassNameArray=d;function f(c){return d(c).join(" ")}n.asClassName=f;function l(c){return"."+d(c).join(".")}n.asCSSSelector=l})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(fe[92],me([0,1,15,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const u=h;return u?[u.on,u.pause,u.resume,u.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=k;function y(h){const u=h;return u?k(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(h,u){return new I(h,u)}e.newWriteableStream=A;class I{constructor(u,m){this.reducer=u,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(m=>m(u))}emitError(u){this.listeners.error.length===0?p.onUnexpectedError(u):this.listeners.error.slice(0).forEach(m=>m(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,m){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(u,m){if(this.state.destroyed)return;let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(m);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(h,u){const m=[];let t;for(;(t=h.read())!==null;)m.push(t);return u(m)}e.consumeReadable=E;function C(h,u,m){const t=[];let s;for(;(s=h.read())!==null&&t.length<m;)t.push(s);return s===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return h.read()}}}e.peekReadable=C;function n(h,u){return new Promise((m,t)=>{const s=[];P(h,{onData:r=>{u&&s.push(r)},onError:r=>{u?t(r):m(void 0)},onEnd:()=>{m(u?u(s):void 0)}})})}e.consumeStream=n;function P(h,u){h.on("error",m=>u.onError(m)),h.on("end",()=>u.onEnd()),h.on("data",m=>u.onData(m))}e.listenStream=P;function d(h,u){return new Promise((m,t)=>{const s=new R.DisposableStore,r=[],i=g=>{if(r.push(g),r.length>u)return s.dispose(),h.pause(),m({stream:h,buffer:r,ended:!1})},a=g=>t(g),v=()=>m({stream:h,buffer:r,ended:!0});s.add(R.toDisposable(()=>h.removeListener("error",a))),h.on("error",a),s.add(R.toDisposable(()=>h.removeListener("end",v))),h.on("end",v),s.add(R.toDisposable(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=d;function f(h,u){const m=A(u);return m.end(h),m}e.toStream=f;function l(){const h=A(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=l;function c(h){let u=!1;return{read:()=>u?null:(u=!0,h)}}e.toReadable=c;function S(h,u,m){const t=A(m);return P(h,{onData:s=>t.write(u.data(s)),onError:s=>t.error(u.error?u.error(s):s),onEnd:()=>t.end()}),t}e.transform=S;function w(h,u,m){let t=!1;return{read:()=>{const s=u.read();return t?s:(t=!0,s!==null?m([h,s]):h)}}}e.prefixedReadable=w;function b(h,u,m){let t=!1;const s=A(m);return P(u,{onData:r=>t?s.write(r):(t=!0,s.write(m([h,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(h)),s.end()}}),s}e.prefixedStream=b}),define(fe[8],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function k(G,...pe){return pe.length===0?G:G.replace(R,function(_e,Ae){const Me=parseInt(Ae,10);return isNaN(Me)||Me<0||Me>=pe.length?_e:pe[Me]})}e.format=k;const y=/{([^}]+)}/g;function A(G,pe){return G.replace(y,(_e,Ae)=>pe[Ae]??_e)}e.format2=A;function I(G){return G.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=I;function E(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function C(G,pe){let _e=0;const Ae=pe.charCodeAt(0);for(let Me=G.length-1;Me>=0;Me--)G.charCodeAt(Me)===Ae&&_e++;return _e}e.count=C;function n(G,pe,_e="\u2026"){return G.length<=pe?G:`${G.substr(0,pe)}${_e}`}e.truncate=n;function P(G,pe=" "){const _e=d(G,pe);return f(_e,pe)}e.trim=P;function d(G,pe){if(!G||!pe)return G;const _e=pe.length;if(_e===0||G.length===0)return G;let Ae=0;for(;G.indexOf(pe,Ae)===Ae;)Ae=Ae+_e;return G.substring(Ae)}e.ltrim=d;function f(G,pe){if(!G||!pe)return G;const _e=pe.length,Ae=G.length;if(_e===0||Ae===0)return G;let Me=Ae,je=-1;for(;je=G.lastIndexOf(pe,Me-1),!(je===-1||je+_e!==Me);){if(je===0)return"";Me=je}return G.substring(0,Me)}e.rtrim=f;function l(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function c(G){return G.replace(/\*/g,"")}e.stripWildcards=c;function S(G,pe,_e={}){if(!G)throw new Error("Cannot create regex from empty string");pe||(G=E(G)),_e.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Ae="";return _e.global&&(Ae+="g"),_e.matchCase||(Ae+="i"),_e.multiline&&(Ae+="m"),_e.unicode&&(Ae+="u"),new RegExp(G,Ae)}e.createRegExp=S;function w(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function b(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function h(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=h;function u(G){return G.split(/\r\n|\r|\n/)}e.splitLines=u;function m(G){for(let pe=0,_e=G.length;pe<_e;pe++){const Ae=G.charCodeAt(pe);if(Ae!==32&&Ae!==9)return pe}return-1}e.firstNonWhitespaceIndex=m;function t(G,pe=0,_e=G.length){for(let Ae=pe;Ae<_e;Ae++){const Me=G.charCodeAt(Ae);if(Me!==32&&Me!==9)return G.substring(pe,Ae)}return G.substring(pe,_e)}e.getLeadingWhitespace=t;function s(G,pe=G.length-1){for(let _e=pe;_e>=0;_e--){const Ae=G.charCodeAt(_e);if(Ae!==32&&Ae!==9)return _e}return-1}e.lastNonWhitespaceIndex=s;function r(G,pe){return G<pe?-1:G>pe?1:0}e.compare=r;function i(G,pe,_e=0,Ae=G.length,Me=0,je=pe.length){for(;_e<Ae&&Me<je;_e++,Me++){let Ye=G.charCodeAt(_e),lt=pe.charCodeAt(Me);if(Ye<lt)return-1;if(Ye>lt)return 1}const tt=Ae-_e,Xe=je-Me;return tt<Xe?-1:tt>Xe?1:0}e.compareSubstring=i;function a(G,pe){return v(G,pe,0,G.length,0,pe.length)}e.compareIgnoreCase=a;function v(G,pe,_e=0,Ae=G.length,Me=0,je=pe.length){for(;_e<Ae&&Me<je;_e++,Me++){let Ye=G.charCodeAt(_e),lt=pe.charCodeAt(Me);if(Ye===lt)continue;const ut=Ye-lt;if(!(ut===32&&_(lt))&&!(ut===-32&&_(Ye)))return g(Ye)&&g(lt)?ut:i(G.toLowerCase(),pe.toLowerCase(),_e,Ae,Me,je)}const tt=Ae-_e,Xe=je-Me;return tt<Xe?-1:tt>Xe?1:0}e.compareSubstringIgnoreCase=v;function g(G){return G>=97&&G<=122}e.isLowerAsciiLetter=g;function _(G){return G>=65&&G<=90}e.isUpperAsciiLetter=_;function D(G){return g(G)||_(G)}function o(G,pe){return G.length===pe.length&&T(G,pe)}e.equalsIgnoreCase=o;function T(G,pe,_e=G.length){for(let Ae=0;Ae<_e;Ae++){const Me=G.charCodeAt(Ae),je=pe.charCodeAt(Ae);if(Me!==je){if(D(Me)&&D(je)){const tt=Math.abs(Me-je);if(tt!==0&&tt!==32)return!1}else if(String.fromCharCode(Me).toLowerCase()!==String.fromCharCode(je).toLowerCase())return!1}}return!0}function L(G,pe){const _e=pe.length;return pe.length>G.length?!1:T(G,pe,_e)}e.startsWithIgnoreCase=L;function $(G,pe){let _e,Ae=Math.min(G.length,pe.length);for(_e=0;_e<Ae;_e++)if(G.charCodeAt(_e)!==pe.charCodeAt(_e))return _e;return Ae}e.commonPrefixLength=$;function W(G,pe){let _e,Ae=Math.min(G.length,pe.length);const Me=G.length-1,je=pe.length-1;for(_e=0;_e<Ae;_e++)if(G.charCodeAt(Me-_e)!==pe.charCodeAt(je-_e))return _e;return Ae}e.commonSuffixLength=W;function Q(G){return 55296<=G&&G<=56319}e.isHighSurrogate=Q;function z(G){return 56320<=G&&G<=57343}e.isLowSurrogate=z;function N(G,pe){return(G-55296<<10)+(pe-56320)+65536}e.computeCodePoint=N;function H(G,pe,_e){const Ae=G.charCodeAt(_e);if(Q(Ae)&&_e+1<pe){const Me=G.charCodeAt(_e+1);if(z(Me))return N(Ae,Me)}return Ae}e.getNextCodePoint=H;function F(G,pe){const _e=G.charCodeAt(pe-1);if(z(_e)&&pe>1){const Ae=G.charCodeAt(pe-2);if(Q(Ae))return N(Ae,_e)}return _e}function x(G,pe){const _e=ke.getInstance(),Ae=pe,Me=G.length,je=H(G,Me,pe);pe+=je>=65536?2:1;let tt=_e.getGraphemeBreakType(je);for(;pe<Me;){const Xe=H(G,Me,pe),Ye=_e.getGraphemeBreakType(Xe);if($e(tt,Ye))break;pe+=Xe>=65536?2:1,tt=Ye}return pe-Ae}e.nextCharLength=x;function O(G,pe){const _e=ke.getInstance(),Ae=pe,Me=F(G,pe);pe-=Me>=65536?2:1;let je=_e.getGraphemeBreakType(Me);for(;pe>0;){const tt=F(G,pe),Xe=_e.getGraphemeBreakType(tt);if($e(Xe,je))break;pe-=tt>=65536?2:1,je=Xe}return Ae-pe}e.prevCharLength=O;function M(G,pe){const _e=ke.getInstance(),Ae=G.length,Me=pe,je=H(G,Ae,pe),tt=_e.getGraphemeBreakType(je);pe+=je>=65536?2:1;let Xe=tt;for(;pe<Ae;){const lt=H(G,Ae,pe),ut=_e.getGraphemeBreakType(lt);if($e(Xe,ut))break;pe+=lt>=65536?2:1,Xe=ut}const Ye=pe;for(pe=Me,Xe=tt;pe>0;){const lt=F(G,pe),ut=_e.getGraphemeBreakType(lt);if($e(ut,Xe))break;pe-=lt>=65536?2:1,Xe=ut}return[pe,Ye]}function B(G,pe){return pe>0&&z(G.charCodeAt(pe))?M(G,pe-1):M(G,pe)}e.getCharContainingOffset=B;function V(G){const pe=G.length;let _e=0,Ae=0;for(;Ae<pe;){const tt=H(G,pe,Ae);Ae+=tt>=65536?2:1,tt<128?_e+=1:tt<2048?_e+=2:tt<65536?_e+=3:_e+=4}const Me=new Uint8Array(_e);Ae=0;let je=0;for(;Ae<pe;){const tt=H(G,pe,Ae);Ae+=tt>=65536?2:1,tt<128?Me[je++]=tt:tt<2048?(Me[je++]=192|(tt&1984)>>>6,Me[je++]=128|(tt&63)>>>0):tt<65536?(Me[je++]=224|(tt&61440)>>>12,Me[je++]=128|(tt&4032)>>>6,Me[je++]=128|(tt&63)>>>0):(Me[je++]=240|(tt&1835008)>>>18,Me[je++]=128|(tt&258048)>>>12,Me[je++]=128|(tt&4032)>>>6,Me[je++]=128|(tt&63)>>>0)}return Me}e.encodeUTF8=V;function ee(G){const pe=G.byteLength,_e=[];let Ae=0;for(;Ae<pe;){const Me=G[Ae];let je;if(Me>=240&&Ae+3<pe?je=(G[Ae++]&7)<<18>>>0|(G[Ae++]&63)<<12>>>0|(G[Ae++]&63)<<6>>>0|(G[Ae++]&63)<<0>>>0:Me>=224&&Ae+2<pe?je=(G[Ae++]&15)<<12>>>0|(G[Ae++]&63)<<6>>>0|(G[Ae++]&63)<<0>>>0:Me>=192&&Ae+1<pe?je=(G[Ae++]&31)<<6>>>0|(G[Ae++]&63)<<0>>>0:je=G[Ae++],je>=0&&je<=55295||je>=57344&&je<=65535)_e.push(String.fromCharCode(je));else if(je>=65536&&je<=1114111){const tt=je-65536,Xe=55296+((tt&1047552)>>>10),Ye=56320+((tt&1023)>>>0);_e.push(String.fromCharCode(Xe)),_e.push(String.fromCharCode(Ye))}else _e.push(String.fromCharCode(65533))}return _e.join("")}e.decodeUTF8=ee;const de=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(G){return de.test(G)}e.containsRTL=ye;const Fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Re(G){return Fe.test(G)}e.containsEmoji=Re;const Ne=/^[\t\n\r\x20-\x7E]*$/;function Ge(G){return Ne.test(G)}e.isBasicASCII=Ge,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ve(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Ve;function qe(G){for(let pe=0,_e=G.length;pe<_e;pe++)if(q(G.charCodeAt(pe)))return!0;return!1}e.containsFullWidthCharacter=qe;function q(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=q;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=Z;function re(G,pe){if(G.length<pe)return G;const _e=/\b/g;let Ae=0;for(;_e.test(G)&&!(G.length-_e.lastIndex<pe);)Ae=_e.lastIndex,_e.lastIndex+=1;return G.substring(Ae).replace(/^\s/,"")}e.lcut=re;const ae=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,se=/\x1b\[0?m/g;function ve(G){return G&&(G=G.replace(ae,""),G=G.replace(J,""),G=G.replace(se,"")),G}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function He(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=He;function be(G,pe){if(!G||!pe||G.length<pe.length)return!1;const _e=pe.length,Ae=G.toLowerCase();let Me=0,je=-1;for(;Me<_e;){const tt=Ae.indexOf(pe[Me],je+1);if(tt<0)return!1;je=tt,Me++}return!0}e.fuzzyContains=be;function Je(G,pe=!1){return G?(pe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Je;function K(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=K;function ie(G,pe=1){if(pe===0)return"";let _e=-1;do _e=G.indexOf(`
`,_e+1),pe--;while(pe>0&&_e>=0);return _e===-1?G:(G[_e-1]==="\r"&&_e--,G.substr(0,_e))}e.getNLines=ie;function he(G){const pe=90-65+1;return G=G%(2*pe),G<pe?String.fromCharCode(97+G):String.fromCharCode(65+G-pe)}e.singleLetterHash=he;function xe(G){return ke.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=xe;function $e(G,pe){return G===0?pe!==5&&pe!==7:G===2&&pe===3?!1:G===4||G===2||G===3||pe===4||pe===2||pe===3?!0:!(G===8&&(pe===8||pe===9||pe===11||pe===12)||(G===11||G===9)&&(pe===9||pe===10)||(G===12||G===10)&&pe===10||pe===5||pe===13||pe===7||G===1||G===13&&pe===14||G===6&&pe===6)}e.breakBetweenGraphemeBreakType=$e;var et;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ke{constructor(){this._data=Ce()}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const _e=this._data,Ae=_e.length/3;let Me=1;for(;Me<=Ae;)if(pe<_e[3*Me])Me=2*Me;else if(pe>_e[3*Me+1])Me=2*Me+1;else return _e[3*Me+2];return 0}}ke._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(G,pe){if(G===0)return 0;const _e=oe(G,pe);if(_e!==void 0)return _e;const Ae=F(pe,G);return G-=ce(Ae),G}e.getLeftDeleteOffset=Pe;function oe(G,pe){let _e=F(pe,G);for(G-=ce(_e);ge(_e)||_e===65039||_e===8419;){if(G===0)return;_e=F(pe,G),G-=ce(_e)}if(!!Z(_e)){if(G>=0){const Ae=F(pe,G);Ae===8205&&(G-=ce(Ae))}return G}}function ce(G){return G>=65536?2:1}function ge(G){return 127995<=G&&G<=127999}var we;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(we||(we={}))}),define(fe[23],me([0,1,8,92]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let I,E;class C{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return k?new C(Buffer.allocUnsafe(g)):new C(new Uint8Array(g))}static wrap(g){return k&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new C(g)}static fromString(g,_){return!(_?.dontUseNodeBuffer||!1)&&k?new C(Buffer.from(g)):y?(I||(I=new TextEncoder),new C(I.encode(g))):new C(p.encodeUTF8(g))}static concat(g,_){if(typeof _=="undefined"){_=0;for(let T=0,L=g.length;T<L;T++)_+=g[T].byteLength}const D=C.alloc(_);let o=0;for(let T=0,L=g.length;T<L;T++){const $=g[T];D.set($,o),o+=$.byteLength}return D}toString(){return k?this.buffer.toString():A?(E||(E=new TextDecoder),E.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(g,_){return new C(this.buffer.subarray(g,_))}set(g,_){g instanceof C?this.buffer.set(g.buffer,_):this.buffer.set(g,_)}readUInt32BE(g){return d(this.buffer,g)}writeUInt32BE(g,_){f(this.buffer,g,_)}readUInt32LE(g){return l(this.buffer,g)}writeUInt32LE(g,_){c(this.buffer,g,_)}readUInt8(g){return S(this.buffer,g)}writeUInt8(g,_){w(this.buffer,g,_)}}e.VSBuffer=C;function n(v,g){return v[g+0]<<0>>>0|v[g+1]<<8>>>0}e.readUInt16LE=n;function P(v,g,_){v[_+0]=g&255,g=g>>>8,v[_+1]=g&255}e.writeUInt16LE=P;function d(v,g){return v[g]*2**24+v[g+1]*2**16+v[g+2]*2**8+v[g+3]}e.readUInt32BE=d;function f(v,g,_){v[_+3]=g,g=g>>>8,v[_+2]=g,g=g>>>8,v[_+1]=g,g=g>>>8,v[_]=g}e.writeUInt32BE=f;function l(v,g){return v[g+0]<<0>>>0|v[g+1]<<8>>>0|v[g+2]<<16>>>0|v[g+3]<<24>>>0}e.readUInt32LE=l;function c(v,g,_){v[_+0]=g&255,g=g>>>8,v[_+1]=g&255,g=g>>>8,v[_+2]=g&255,g=g>>>8,v[_+3]=g&255}e.writeUInt32LE=c;function S(v,g){return v[g]}e.readUInt8=S;function w(v,g,_){v[_]=g}e.writeUInt8=w;function b(v){return R.consumeReadable(v,g=>C.concat(g))}e.readableToBuffer=b;function h(v){return R.toReadable(v)}e.bufferToReadable=h;function u(v){return R.consumeStream(v,g=>C.concat(g))}e.streamToBuffer=u;async function m(v){return v.ended?C.concat(v.buffer):C.concat([...v.buffer,await u(v.stream)])}e.bufferedStreamToBuffer=m;function t(v){return R.toStream(v,g=>C.concat(g))}e.bufferToStream=t;function s(v){return R.transform(v,{data:g=>typeof g=="string"?C.fromString(g):C.wrap(g)},g=>C.concat(g))}e.streamToBufferReadableStream=s;function r(v){return R.newWriteableStream(g=>C.concat(g),v)}e.newWriteableBufferStream=r;function i(v,g){return R.prefixedReadable(v,g,_=>C.concat(_))}e.prefixedBufferReadable=i;function a(v,g){return R.prefixedStream(v,g,_=>C.concat(_))}e.prefixedBufferStream=a}),define(fe[72],me([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return k(w,0)}e.hash=R;function k(w,b){switch(typeof w){case"object":return w===null?y(349,b):Array.isArray(w)?E(w,b):C(w,b);case"string":return I(w,b);case"boolean":return A(w,b);case"number":return y(w,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=k;function y(w,b){return(b<<5)-b+w|0}function A(w,b){return y(w?433:863,b)}function I(w,b){b=y(149417,b);for(let h=0,u=w.length;h<u;h++)b=y(w.charCodeAt(h),b);return b}e.stringHash=I;function E(w,b){return b=y(104579,b),w.reduce((h,u)=>k(u,h),b)}function C(w,b){return b=y(181387,b),Object.keys(w).sort().reduce((h,u)=>(h=I(u,h),k(w[u],h)),b)}class n{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=k(b,this._value),this._value}}e.Hasher=n;var P;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(w,b,h=32){const u=h-b,m=~((1<<u)-1);return(w<<b|(m&w)>>>u)>>>0}function f(w,b=0,h=w.byteLength,u=0){for(let m=0;m<h;m++)w[b+m]=u}function l(w,b,h="0"){for(;w.length<b;)w=h+w;return w}function c(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(h=>h.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),b/4)}e.toHexString=c;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const h=b.length;if(h===0)return;const u=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=b.charCodeAt(0),r=0);;){let i=s;if(p.isHighSurrogate(s))if(r+1<h){const a=b.charCodeAt(r+1);p.isLowSurrogate(a)?(r++,i=p.computeCodePoint(s,a)):i=65533}else{t=s;break}else p.isLowSurrogate(s)&&(i=65533);if(m=this._push(u,m,i),r++,r<h)s=b.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=t}_push(b,h,u){return u<128?b[h++]=u:u<2048?(b[h++]=192|(u&1984)>>>6,b[h++]=128|(u&63)>>>0):u<65536?(b[h++]=224|(u&61440)>>>12,b[h++]=128|(u&4032)>>>6,b[h++]=128|(u&63)>>>0):(b[h++]=240|(u&1835008)>>>18,b[h++]=128|(u&258048)>>>12,b[h++]=128|(u&4032)>>>6,b[h++]=128|(u&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,h=this._buffDV;for(let g=0;g<64;g+=4)b.setUint32(g,h.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)b.setUint32(g,d(b.getUint32(g-12,!1)^b.getUint32(g-32,!1)^b.getUint32(g-56,!1)^b.getUint32(g-64,!1),1),!1);let u=this._h0,m=this._h1,t=this._h2,s=this._h3,r=this._h4,i,a,v;for(let g=0;g<80;g++)g<20?(i=m&t|~m&s,a=1518500249):g<40?(i=m^t^s,a=1859775393):g<60?(i=m&t|m&s|t&s,a=2400959708):(i=m^t^s,a=3395469782),v=d(u,5)+i+r+a+b.getUint32(g*4,!1)&4294967295,r=s,s=t,t=d(m,30),m=u,u=v;this._h0=this._h0+u&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[55],me([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const y="error",A="warning",I="warn",E="info",C="ignore";function n(d){return d?p.equalsIgnoreCase(y,d)?k.Error:p.equalsIgnoreCase(A,d)||p.equalsIgnoreCase(I,d)?k.Warning:p.equalsIgnoreCase(E,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=n;function P(d){switch(d){case k.Error:return y;case k.Warning:return A;case k.Info:return E;default:return C}}k.toString=P}(R||(R={})),e.default=R}),define(fe[14],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(g){return Array.isArray(g)}e.isArray=p;function R(g){return typeof g=="string"}e.isString=R;function k(g){return Array.isArray(g)&&g.every(_=>R(_))}e.isStringArray=k;function y(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=y;function A(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=A;function I(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=I;function E(g){return g===!0||g===!1}e.isBoolean=E;function C(g){return typeof g=="undefined"}e.isUndefined=C;function n(g){return!P(g)}e.isDefined=n;function P(g){return C(g)||g===null}e.isUndefinedOrNull=P;function d(g,_){if(!g)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=d;function f(g){if(P(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=f;function l(...g){const _=[];for(let D=0;D<g.length;D++){const o=g[D];if(P(o))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);_.push(o)}return _}e.assertAllDefined=l;const c=Object.prototype.hasOwnProperty;function S(g){if(!y(g))return!1;for(let _ in g)if(c.call(g,_))return!1;return!0}e.isEmptyObject=S;function w(g){return typeof g=="function"}e.isFunction=w;function b(...g){return g.length>0&&g.every(w)}e.areFunctions=b;function h(g,_){const D=Math.min(g.length,_.length);for(let o=0;o<D;o++)u(g[o],_[o])}e.validateConstraints=h;function u(g,_){if(R(_)){if(typeof g!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(g instanceof _)return}catch{}if(!P(g)&&g.constructor===_||_.length===1&&_.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function m(g){let _=[],D=Object.getPrototypeOf(g);for(;Object.prototype!==D;)_=_.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return _}e.getAllPropertyNames=m;function t(g){const _=[];for(const D of m(g))typeof g[D]=="function"&&_.push(D);return _}e.getAllMethodNames=t;function s(g,_){const D=T=>function(){const L=Array.prototype.slice.call(arguments,0);return _(T,L)};let o={};for(const T of g)o[T]=D(T);return o}e.createProxyObject=s;function r(g){return g===null?void 0:g}e.withNullAsUndefined=r;function i(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=i;function a(g){return class{constructor(){return new Proxy({},{get(_,D){if(_[D])return _[D];throw new Error(`Not Implemented: ${g}->${String(D)}`)}})}}}e.NotImplementedProxy=a;function v(g){throw new Error("Unreachable")}e.assertNever=v}),define(fe[29],me([0,1,11,8,9,14]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function I(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=I;function E(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function C(r,i=k.posix.sep){if(!r)return"";const a=r.length,v=r.charCodeAt(0);if(A(v)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let _=3;const D=_;for(;_<a&&!A(r.charCodeAt(_));_++);if(D!==_&&!A(r.charCodeAt(_+1))){for(_+=1;_<a;_++)if(A(r.charCodeAt(_)))return r.slice(0,_+1).replace(/[\\/]/g,i)}}return i}else if(w(v)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(A(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=C;function n(r){if(!p.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let a=2;const v=a;for(;a<r.length&&(i=r.charCodeAt(a),i!==92);a++);return!(v===a||(i=r.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=n;const P=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,i=p.isWindows){const a=i?P:d;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=l;function c(r,i,a){const v=r===i;return!a||v?v:!r||!i?!1:R.equalsIgnoreCase(r,i)}e.isEqual=c;function S(r,i,a,v=k.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(a){if(!R.startsWithIgnoreCase(r,i))return!1;if(i.length===r.length)return!0;let _=i.length;return i.charAt(i.length-1)===v&&_--,r.charAt(_)===v}return i.charAt(i.length-1)!==v&&(i+=v),r.indexOf(i)===0}e.isEqualOrParent=S;function w(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=w;function b(r,i){return p.isWindows&&r.endsWith(":")&&(r+=k.sep),k.isAbsolute(r)||(r=k.join(i,r)),r=k.normalize(r),p.isWindows?(r=R.rtrim(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=R.rtrim(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=b;function h(r){const i=k.normalize(r);return p.isWindows?r.length>3?!1:u(i)&&(r.length===2||i.charCodeAt(2)===92):i===k.posix.sep}e.isRootOrDriveLetter=h;function u(r){return p.isWindows?w(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function m(r){return u(r)?r[0]:void 0}e.getDriveLetter=m;function t(r,i,a){return i.length>r.length?-1:r===i?0:(a&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let a,v,g;if(i.forEach(_=>{const D=Number(_);y.isNumber(D)?v===void 0?v=D:g===void 0&&(g=D):a=a?[a,_].join(":"):_}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:v!==void 0?v:void 0,column:g!==void 0?g:v!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(fe[25],me([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const S=Array.isArray(c)?[]:{};return Object.keys(c).forEach(w=>{c[w]&&typeof c[w]=="object"?S[w]=R(c[w]):S[w]=c[w]}),S}e.deepClone=R;function k(c){if(!c||typeof c!="object")return c;const S=[c];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const b in w)if(y.call(w,b)){const h=w[b];typeof h=="object"&&!Object.isFrozen(h)&&S.push(h)}}return c}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function A(c,S){return I(c,S,new Set)}e.cloneAndChange=A;function I(c,S,w){if(p.isUndefinedOrNull(c))return c;const b=S(c);if(typeof b!="undefined")return b;if(p.isArray(c)){const h=[];for(const u of c)h.push(I(u,S,w));return h}if(p.isObject(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const h={};for(let u in c)y.call(c,u)&&(h[u]=I(c[u],S,w));return w.delete(c),h}return c}function E(c,S,w=!0){return p.isObject(c)?(p.isObject(S)&&Object.keys(S).forEach(b=>{b in c?w&&(p.isObject(c[b])&&p.isObject(S[b])?E(c[b],S[b],w):c[b]=S[b]):c[b]=S[b]}),c):S}e.mixin=E;function C(c,S){if(c===S)return!0;if(c==null||S===null||S===void 0||typeof c!=typeof S||typeof c!="object"||Array.isArray(c)!==Array.isArray(S))return!1;let w,b;if(Array.isArray(c)){if(c.length!==S.length)return!1;for(w=0;w<c.length;w++)if(!C(c[w],S[w]))return!1}else{const h=[];for(b in c)h.push(b);h.sort();const u=[];for(b in S)u.push(b);if(u.sort(),!C(h,u))return!1;for(w=0;w<h.length;w++)if(!C(c[h[w]],S[h[w]]))return!1}return!0}e.equals=C;function n(c){const S=new Set;return JSON.stringify(c,(w,b)=>{if(p.isObject(b)||Array.isArray(b)){if(S.has(b))return"[Circular]";S.add(b)}return b})}e.safeStringify=n;function P(c,S,w){const b=S(c);return typeof b=="undefined"?w:b}e.getOrDefault=P;function d(c,S){const w=Object.create(null);return!c||!S||Object.keys(S).forEach(h=>{const u=c[h],m=S[h];C(u,m)||(w[h]=m)}),w}e.distinct=d;function f(c,S){const w=S.toLowerCase(),b=Object.keys(c).find(h=>h.toLowerCase()===w);return b?c[b]:c[S]}e.getCaseInsensitive=f;function l(c,S){const w=Object.create(null);for(const b of Object.keys(c))S(b,c[b])&&(w[b]=c[b]);return w}e.filter=l}),define(fe[93],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function k(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=k}),define(fe[2],me([0,1,11,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function I(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!y.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,i){return!r&&!i?"file":r}function C(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const n="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,a,v,g,_,D=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=E(i,D),this.authority=a||n,this.path=C(this.scheme,v||n),this.query=g||n,this.fragment=_||n,I(this,D))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:v,path:g,query:_,fragment:D}=i;return a===void 0?a=this.scheme:a===null&&(a=n),v===void 0?v=this.authority:v===null&&(v=n),g===void 0?g=this.path:g===null&&(g=n),_===void 0?_=this.query:_===null&&(_=n),D===void 0?D=this.fragment:D===null&&(D=n),a===this.scheme&&v===this.authority&&g===this.path&&_===this.query&&D===this.fragment?this:new c(a,v,g,_,D)}static parse(i,a=!1){const v=d.exec(i);return v?new c(v[2]||n,s(v[4]||n),s(v[5]||n),s(v[7]||n),s(v[9]||n),a):new c(n,n,n,n,n)}static file(i){let a=n;if(p.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const v=i.indexOf(P,2);v===-1?(a=i.substring(2),i=P):(a=i.substring(2,v),i=i.substring(v)||P)}return new c("file",a,i,n,n)}static from(i){const a=new c(i.scheme,i.authority,i.path,i.query,i.fragment);return I(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return p.isWindows&&i.scheme==="file"?v=f.file(R.win32.join(h(i,!0),...a)).path:v=R.posix.join(i.path,...a),i.with({path:v})}toString(i=!1){return u(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const a=new c(i);return a._formatted=i.external,a._fsPath=i._sep===l?i.fsPath:null,a}}else return i}}e.URI=f;const l=p.isWindows?1:void 0;class c extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=l),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,i){let a,v=-1;for(let g=0;g<r.length;g++){const _=r.charCodeAt(g);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||i&&_===47)v!==-1&&(a+=encodeURIComponent(r.substring(v,g)),v=-1),a!==void 0&&(a+=r.charAt(g));else{a===void 0&&(a=r.substr(0,g));const D=S[_];D!==void 0?(v!==-1&&(a+=encodeURIComponent(r.substring(v,g)),v=-1),a+=D):v===-1&&(v=g)}}return v!==-1&&(a+=encodeURIComponent(r.substring(v))),a!==void 0?a:r}function b(r){let i;for(let a=0;a<r.length;a++){const v=r.charCodeAt(a);v===35||v===63?(i===void 0&&(i=r.substr(0,a)),i+=S[v]):i!==void 0&&(i+=r[a])}return i!==void 0?i:r}function h(r,i){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,p.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=h;function u(r,i){const a=i?b:w;let v="",{scheme:g,authority:_,path:D,query:o,fragment:T}=r;if(g&&(v+=g,v+=":"),(_||g==="file")&&(v+=P,v+=P),_){let L=_.indexOf("@");if(L!==-1){const $=_.substr(0,L);_=_.substr(L+1),L=$.indexOf(":"),L===-1?v+=a($,!1):(v+=a($.substr(0,L),!1),v+=":",v+=a($.substr(L+1),!1)),v+="@"}_=_.toLowerCase(),L=_.indexOf(":"),L===-1?v+=a(_,!1):(v+=a(_.substr(0,L),!1),v+=_.substr(L))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const L=D.charCodeAt(1);L>=65&&L<=90&&(D=`/${String.fromCharCode(L+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const L=D.charCodeAt(0);L>=65&&L<=90&&(D=`${String.fromCharCode(L+32)}:${D.substr(2)}`)}v+=a(D,!0)}return o&&(v+="?",v+=a(o,!1)),T&&(v+="#",v+=i?T:w(T,!1)),v}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>m(i)):r}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[24],me([0,1,2,8]),function(X,e,p,R){"use strict";var k,y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,s,r){let i=t.get(s);return i===void 0&&(i=r,t.set(s,i)),i}e.getOrSet=I;function E(t){const s=[];return t.forEach((r,i)=>{s.push(`${i} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=E;function C(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=n;class P{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?R.compareSubstring(s,this._value,0,s.length,this._from,this._to):R.compareSubstringIgnoreCase(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?R.compareSubstring(s,this._value,0,s.length,this._from,this._to):R.compareSubstringIgnoreCase(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class l{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(s,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return R.compare(s,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class c{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(s){this._iter=s}static forUris(s=()=>!1){return new S(new l(s))}static forPaths(){return new S(new d)}static forStrings(){return new S(new n)}static forConfigKeys(){return new S(new P)}clear(){this._root=void 0}set(s,r){const i=this._iter.reset(s);let a;for(this._root||(this._root=new c,this._root.segment=i.value()),a=this._root;;){const g=i.cmp(a.segment);if(g>0)a.left||(a.left=new c,a.left.segment=i.value()),a=a.left;else if(g<0)a.right||(a.right=new c,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new c,a.mid.segment=i.value()),a=a.mid;else break}const v=a.value;return a.value=r,a.key=s,v}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let i=this._root;for(;i;){const a=r.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const i=this._iter.reset(s),a=[];let v=this._root;for(;v;){const g=i.cmp(v.segment);if(g>0)a.push([1,v]),v=v.left;else if(g<0)a.push([-1,v]),v=v.right;else if(i.hasNext())i.next(),a.push([0,v]),v=v.mid;else{for(r?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;a.length>0&&v.isEmpty();){let[_,D]=a.pop();switch(_){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}v=D}break}}}findSubstr(s){const r=this._iter.reset(s);let i=this._root,a;for(;i;){const v=r.cmp(i.segment);if(v>0)i=i.left;else if(v<0)i=i.right;else if(r.hasNext())r.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(s){const r=this._iter.reset(s);let i=this._root;for(;i;){const a=r.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(s){for(const[r,i]of this)s(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const i=r.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&r.push(i.left),i.mid&&r.push(i.mid),i.right&&r.push(i.right))}}}e.TernarySearchTree=S;class w{constructor(s,r){this[k]="ResourceMap",s instanceof w?(this.map=new Map(s.map),this.toKey=r??w.defaultToKey):(this.map=new Map,this.toKey=s??w.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[i,a]of this.map)s(a,p.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield p.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[p.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[p.URI.parse(s[0]),s[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class h{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const i=this._map.get(s);if(!!i)return r!==0&&this.touch(i,r),i.value}set(s,r,i=0){let a=this._map.get(s);if(a)a.value=r,i!==0&&this.touch(a,i);else{switch(a={key:s,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(s,a),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const i=this._state;let a=this._head;for(;a;){if(r?s.bind(r)(a.value,a.key,this):s(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const s=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:i.key,done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return a}values(){const s=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:i.value,done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return a}entries(){const s=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:[i.key,i.value],done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return a}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>s;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,i=s.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const i=s.next,a=s.previous;s===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const i=s.next,a=s.previous;s===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,i)=>{s.push([i,r])}),s}fromJSON(s){this.clear();for(const[r,i]of s)this.set(r,i)}}e.LinkedMap=h;class u extends h{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class m{constructor(s){A.set(this,void 0),it(this,A,s,"f")}get size(){return Ue(this,A,"f").size}forEach(s,r){Ue(this,A,"f").forEach(s,r)}get(s){return Ue(this,A,"f").get(s)}has(s){return Ue(this,A,"f").has(s)}entries(){return Ue(this,A,"f").entries()}keys(){return Ue(this,A,"f").keys()}values(){return Ue(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ue(this,A,"f").entries()}}e.ReadonlyMapView=m}),define(fe[94],me([0,1,24,8]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...J){return function(se,ve){for(let Le=0,He=J.length;Le<He;Le++){const be=J[Le](se,ve);if(be)return be}return null}}e.or=k,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(J,se,ve){if(!ve||ve.length<se.length)return null;let Le;return J?Le=R.startsWithIgnoreCase(ve,se):Le=ve.indexOf(se)===0,Le?se.length>0?[{start:0,end:se.length}]:[]:null}function A(J,se){const ve=se.toLowerCase().indexOf(J.toLowerCase());return ve===-1?null:[{start:ve,end:ve+J.length}]}e.matchesContiguousSubString=A;function I(J,se){return E(J.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=I;function E(J,se,ve,Le){if(ve===J.length)return[];if(Le===se.length)return null;if(J[ve]===se[Le]){let He=null;return(He=E(J,se,ve+1,Le+1))?w({start:Le,end:Le+1},He):null}return E(J,se,ve,Le+1)}function C(J){return 97<=J&&J<=122}function n(J){return 65<=J&&J<=90}e.isUpper=n;function P(J){return 48<=J&&J<=57}function d(J){return J===32||J===9||J===10||J===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>f.add(J.charCodeAt(0)));function l(J){return d(J)||f.has(J)}function c(J,se){return J===se||l(J)&&l(se)}function S(J){return C(J)||n(J)||P(J)}function w(J,se){return se.length===0?se=[J]:J.end===se[0].start?se[0].start=J.start:se.unshift(J),se}function b(J,se){for(let ve=se;ve<J.length;ve++){const Le=J.charCodeAt(ve);if(n(Le)||P(Le)||ve>0&&!S(J.charCodeAt(ve-1)))return ve}return J.length}function h(J,se,ve,Le){if(ve===J.length)return[];if(Le===se.length)return null;if(J[ve]!==se[Le].toLowerCase())return null;{let He=null,be=Le+1;for(He=h(J,se,ve+1,Le+1);!He&&(be=b(se,be))<se.length;)He=h(J,se,ve+1,be),be++;return He===null?null:w({start:Le,end:Le+1},He)}}function u(J){let se=0,ve=0,Le=0,He=0,be=0;for(let xe=0;xe<J.length;xe++)be=J.charCodeAt(xe),n(be)&&se++,C(be)&&ve++,S(be)&&Le++,P(be)&&He++;const Je=se/J.length,K=ve/J.length,ie=Le/J.length,he=He/J.length;return{upperPercent:Je,lowerPercent:K,alphaPercent:ie,numericPercent:he}}function m(J){const{upperPercent:se,lowerPercent:ve}=J;return ve===0&&se>.6}function t(J){const{upperPercent:se,lowerPercent:ve,alphaPercent:Le,numericPercent:He}=J;return ve>.2&&se<.8&&Le>.6&&He<.2}function s(J){let se=0,ve=0,Le=0,He=0;for(let be=0;be<J.length;be++)Le=J.charCodeAt(be),n(Le)&&se++,C(Le)&&ve++,d(Le)&&He++;return(se===0||ve===0)&&He===0?J.length<=30:se<=5}function r(J,se){if(!se||(se=se.trim(),se.length===0)||!s(J)||se.length>60)return null;const ve=u(se);if(!t(ve)){if(!m(ve))return null;se=se.toLowerCase()}let Le=null,He=0;for(J=J.toLowerCase();He<se.length&&(Le=h(J,se,0,He))===null;)He=b(se,He+1);return Le}e.matchesCamelCase=r;function i(J,se,ve=!1){if(!se||se.length===0)return null;let Le=null,He=0;for(J=J.toLowerCase(),se=se.toLowerCase();He<se.length&&(Le=a(J,se,0,He,ve))===null;)He=v(se,He+1);return Le}e.matchesWords=i;function a(J,se,ve,Le,He){if(ve===J.length)return[];if(Le===se.length)return null;if(c(J.charCodeAt(ve),se.charCodeAt(Le))){let be=null,Je=Le+1;if(be=a(J,se,ve+1,Le+1,He),!He)for(;!be&&(Je=v(se,Je))<se.length;)be=a(J,se,ve+1,Je,He),Je++;return be===null?null:w({start:Le,end:Le+1},be)}else return null}function v(J,se){for(let ve=se;ve<J.length;ve++)if(l(J.charCodeAt(ve))||ve>0&&l(J.charCodeAt(ve-1)))return ve;return J.length}const g=k(e.matchesPrefix,r,A),_=k(e.matchesPrefix,r,I),D=new p.LRUCache(1e4);function o(J,se,ve=!1){if(typeof J!="string"||typeof se!="string")return null;let Le=D.get(J);Le||(Le=new RegExp(R.convertSimple2RegExpPattern(J),"i"),D.set(J,Le));const He=Le.exec(se);return He?[{start:He.index,end:He.index+He[0].length}]:ve?_(J,se):g(J,se)}e.matchesFuzzy=o;function T(J,se){const ve=Ge(J,J.toLowerCase(),0,se,se.toLowerCase(),0,!0);return ve?$(ve):null}e.matchesFuzzy2=T;function L(J,se,ve,Le,He,be){const Je=Math.min(13,J.length);for(;ve<Je;ve++){const K=Ge(J,se,ve,Le,He,be,!1);if(K)return K}return[0,be]}e.anyScore=L;function $(J){if(typeof J=="undefined")return[];const se=[],ve=J[1];for(let Le=J.length-1;Le>1;Le--){const He=J[Le]+ve,be=se[se.length-1];be&&be.end===He?be.end=He+1:se.push({start:He,end:He+1})}return se}e.createMatches=$;const W=128;function Q(){const J=[],se=[];for(let ve=0;ve<=W;ve++)se[ve]=0;for(let ve=0;ve<=W;ve++)J.push(se.slice(0));return J}function z(J){const se=[];for(let ve=0;ve<=J;ve++)se[ve]=0;return se}const N=z(2*W),H=z(2*W),F=Q(),x=Q(),O=Q(),M=!1;function B(J,se,ve,Le,He){function be(K,ie,he=" "){for(;K.length<ie;)K=he+K;return K}let Je=` |   |${Le.split("").map(K=>be(K,3)).join("|")}
`;for(let K=0;K<=ve;K++)K===0?Je+=" |":Je+=`${se[K-1]}|`,Je+=J[K].slice(0,He+1).map(ie=>be(ie.toString(),3)).join("|")+`
`;return Je}function V(J,se,ve,Le){J=J.substr(se),ve=ve.substr(Le),console.log(B(x,J,J.length,ve,ve.length)),console.log(B(O,J,J.length,ve,ve.length)),console.log(B(F,J,J.length,ve,ve.length))}function ee(J,se){if(se<0||se>=J.length)return!1;const ve=J.codePointAt(se);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ve)}}function de(J,se){if(se<0||se>=J.length)return!1;switch(J.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ye(J,se,ve){return se[J]!==ve[J]}function Fe(J,se,ve,Le,He,be,Je=!1){for(;se<ve&&He<be;)J[se]===Le[He]&&(Je&&(N[se]=He),se+=1),He+=1;return se===ve}e.isPatternInWord=Fe;var Re;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Ne;(function(J){J.Default=[-100,0];function se(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}J.isDefault=se})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Ge(J,se,ve,Le,He,be,Je){const K=J.length>W?W:J.length,ie=Le.length>W?W:Le.length;if(ve>=K||be>=ie||K-ve>ie-be||!Fe(se,ve,K,He,be,ie,!0))return;Ve(K,ie,ve,be,se,He);let he=1,xe=1,$e=ve,et=be;const ke=[!1];for(he=1,$e=ve;$e<K;he++,$e++){const ge=N[$e],we=H[$e],G=$e+1<K?H[$e+1]:ie;for(xe=ge-be+1,et=ge;et<G;xe++,et++){let pe=Number.MIN_SAFE_INTEGER,_e=!1;et<=we&&(pe=qe(J,se,$e,ve,Le,He,et,ie,be,F[he-1][xe-1]===0,ke));let Ae=0;pe!==Number.MAX_SAFE_INTEGER&&(_e=!0,Ae=pe+x[he-1][xe-1]);const Me=et>ge,je=Me?x[he][xe-1]+(F[he][xe-1]>0?-5:0):0,tt=et>ge+1&&F[he][xe-1]>0,Xe=tt?x[he][xe-2]+(F[he][xe-2]>0?-5:0):0;if(tt&&(!Me||Xe>=je)&&(!_e||Xe>=Ae))x[he][xe]=Xe,O[he][xe]=3,F[he][xe]=0;else if(Me&&(!_e||je>=Ae))x[he][xe]=je,O[he][xe]=2,F[he][xe]=0;else if(_e)x[he][xe]=Ae,O[he][xe]=1,F[he][xe]=F[he-1][xe-1]+1;else throw new Error("not possible")}}if(M&&V(J,ve,Le,be),!ke[0]&&!Je)return;he--,xe--;const Ce=[x[he][xe],be];let Pe=0,oe=0;for(;he>=1;){let ge=xe;do{const we=O[he][ge];if(we===3)ge=ge-2;else if(we===2)ge=ge-1;else break}while(ge>=1);Pe>1&&se[ve+he-1]===He[be+xe-1]&&!ye(ge+be-1,Le,He)&&Pe+1>F[he][ge]&&(ge=xe),ge===xe?Pe++:Pe=1,oe||(oe=ge),he--,xe=ge-1,Ce.push(xe)}ie===K&&(Ce[0]+=2);const ce=oe-K;return Ce[0]-=ce,Ce}e.fuzzyScore=Ge;function Ve(J,se,ve,Le,He,be){let Je=J-1,K=se-1;for(;Je>=ve&&K>=Le;)He[Je]===be[K]&&(H[Je]=K,Je--),K--}function qe(J,se,ve,Le,He,be,Je,K,ie,he,xe){if(se[ve]!==be[Je])return Number.MIN_SAFE_INTEGER;let $e=1,et=!1;return Je===ve-Le?$e=J[ve]===He[Je]?7:5:ye(Je,He,be)&&(Je===0||!ye(Je-1,He,be))?($e=J[ve]===He[Je]?7:5,et=!0):ee(be,Je)&&(Je===0||!ee(be,Je-1))?$e=5:(ee(be,Je-1)||de(be,Je-1))&&($e=5,et=!0),$e>1&&ve===Le&&(xe[0]=!0),et||(et=ye(Je,He,be)||ee(be,Je-1)||de(be,Je-1)),ve===Le?Je>ie&&($e-=et?3:5):he?$e+=et?2:0:$e+=et?0:1,Je+1===K&&($e-=et?3:5),$e}function q(J,se,ve,Le,He,be,Je){return re(J,se,ve,Le,He,be,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function Z(J,se,ve,Le,He,be,Je){return re(J,se,ve,Le,He,be,!1,Je)}e.fuzzyScoreGraceful=Z;function re(J,se,ve,Le,He,be,Je,K){let ie=Ge(J,se,ve,Le,He,be,K);if(ie&&!Je)return ie;if(J.length>=3){const he=Math.min(7,J.length-1);for(let xe=ve+1;xe<he;xe++){const $e=ae(J,xe);if($e){const et=Ge($e,$e.toLowerCase(),ve,Le,He,be,K);et&&(et[0]-=3,(!ie||et[0]>ie[0])&&(ie=et))}}}return ie}function ae(J,se){if(se+1>=J.length)return;const ve=J[se],Le=J[se+1];if(ve!==Le)return J.slice(0,se)+Le+ve+J.slice(se+2)}}),define(fe[137],me([0,1,91,94,8]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function I(c){return c.replace(A,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=I;const E=new RegExp(`\\\\${y.source}`,"g");function C(c){return c.replace(E,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function P(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(n,(S,w,b,h)=>b?S:w||h||"")}e.stripIcons=P;function d(c){const S=c.indexOf(e.iconStartMarker);return S===-1?{text:c}:f(c,S)}e.parseLabelWithIcons=d;function f(c,S){const w=[];let b="";function h(v){if(v){b+=v;for(const g of v)w.push(t)}}let u=-1,m="",t=0,s,r,i=S;const a=c.length;for(h(c.substr(0,S));i<a;)s=c[i],r=c[i+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(u=i,h(m),m=e.iconStartMarker,i++):s===")"&&u!==-1?(t+=i-u+1,u=-1,m=""):u!==-1?/^[a-z0-9\-]$/i.test(s)?m+=s:(h(m),u=-1,m=""):h(s),i++;return h(m),{text:b,iconOffsets:w}}function l(c,S,w=!1){const{text:b,iconOffsets:h}=S;if(!h||h.length===0)return R.matchesFuzzy(c,b,w);const u=k.ltrim(b," "),m=b.length-u.length,t=R.matchesFuzzy(c,u,w);if(t)for(const s of t){const r=h[s.start+m]+m;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=l}),define(fe[95],me([0,1,137,15]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",l=!1){if(this.value=f,typeof this.value!="string")throw R.illegalArgument("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1)}appendText(f,l=0){return this.value+=C(this.supportThemeIcons?p.escapeIcons(f):f).replace(/([ \t]+)/g,(c,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,l){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=y;function A(d){return I(d)?!d.value:Array.isArray(d)?d.every(A):!0}e.isEmptyMarkdownString=A;function I(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function E(d,f){return d===f?!0:!d||!f?!1:d.value===f.value&&d.isTrusted===f.isTrusted&&d.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=E;function C(d){return d.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function P(d){const f=[],l=d.split("|").map(S=>S.trim());d=l[0];const c=l[1];if(c){const S=/height=(\d+)/.exec(c),w=/width=(\d+)/.exec(c),b=S?S[1]:"",h=w?w[1]:"",u=isFinite(parseInt(h)),m=isFinite(parseInt(b));u&&f.push(`width="${h}"`),m&&f.push(`height="${b}"`)}return{href:d,dimensions:f}}e.parseHrefAndDimensions=P}),define(fe[56],me([0,1,23,8,2]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,E)}e.stringify=y;function A(n){let P=JSON.parse(n);return P=C(P),P}e.parse=A;var I;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function E(n,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:R.regExpFlags(P)}:P}function C(n,P=0){if(!n||P>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof p.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=C(n[d],P+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=C(n[d],P+1))}return n}e.revive=C}),define(fe[10],me([0,1,2,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,C,n){this._hosts[E]=C,this._ports[E]=n}setConnectionToken(E,C){this._connectionTokens[E]=C}rewrite(E){if(this._delegate)return this._delegate(E);const C=E.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[C],d=this._connectionTokens[C];let f=`path=${encodeURIComponent(E.path)}`;return typeof d=="string"&&(f+=`&tkn=${encodeURIComponent(d)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,C,n){const P=this.toUri(E,C);if(P.scheme===k.vscodeRemote)return e.RemoteAuthorities.rewrite(P);let d=!1;return R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&P.scheme===k.file&&(d=!0),P.scheme===k.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(d=!0),d?P.with({scheme:k.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(E,C){const n=this.toUri(E,C);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(E,C){return p.URI.isUri(E)?E:p.URI.parse(C.toUrl(E))}}e.FileAccess=new A}),define(fe[73],me([0,1,24]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new p.LRUCache(1e4);function k(C){return E(C,"NFC",R)}e.normalizeNFC=k;const y=new p.LRUCache(1e4);function A(C){return E(C,"NFD",y)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function E(C,n,P){if(!e.canNormalize||!C)return C;const d=P.get(C);if(d)return d;let f;return I.test(C)?f=C.normalize(n):f=C,P.set(C,f),f}e.removeAccents=function(){if(e.canNormalize){const C=/[\u0300-\u036f]/g;return function(n){return A(n).replace(C,"")}}else return function(C){return C}}()}),define(fe[22],me([0,1,29,9,2,8,10,11]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(f){return k.uriToFsPath(f,!0)}e.originalFSPath=E;class C{constructor(l){this._ignorePathCasing=l}compare(l,c,S=!1){return l===c?0:y.compare(this.getComparisonKey(l,S),this.getComparisonKey(c,S))}isEqual(l,c,S=!1){return l===c?!0:!l||!c?!1:this.getComparisonKey(l,S)===this.getComparisonKey(c,S)}getComparisonKey(l,c=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,c,S=!1){if(l.scheme===c.scheme){if(l.scheme===A.Schemas.file)return p.isEqualOrParent(E(l),E(c),this._ignorePathCasing(l))&&l.query===c.query&&(S||l.fragment===c.fragment);if(e.isEqualAuthority(l.authority,c.authority))return p.isEqualOrParent(l.path,c.path,this._ignorePathCasing(l),"/")&&l.query===c.query&&(S||l.fragment===c.fragment)}return!1}joinPath(l,...c){return k.URI.joinPath(l,...c)}basenameOrAuthority(l){return e.basename(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){return R.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let c;return l.scheme===A.Schemas.file?c=k.URI.file(R.dirname(E(l))).path:(c=R.posix.dirname(l.path),l.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),c="/")),l.with({path:c})}normalizePath(l){if(!l.path.length)return l;let c;return l.scheme===A.Schemas.file?c=k.URI.file(R.normalize(E(l))).path:c=R.posix.normalize(l.path),l.with({path:c})}relativePath(l,c){if(l.scheme!==c.scheme||!e.isEqualAuthority(l.authority,c.authority))return;if(l.scheme===A.Schemas.file){const b=R.relative(E(l),E(c));return I.isWindows?p.toSlashes(b):b}let S=l.path||"/",w=c.path||"/";if(this._ignorePathCasing(l)){let b=0;for(const h=Math.min(S.length,w.length);b<h&&!(S.charCodeAt(b)!==w.charCodeAt(b)&&S.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);S=w.substr(0,b)+S.substr(b)}return R.posix.relative(S,w)}resolvePath(l,c){if(l.scheme===A.Schemas.file){const S=k.URI.file(R.resolve(E(l),c));return l.with({authority:S.authority,path:S.path})}return c=p.toPosixPath(c),l.with({path:R.posix.resolve(l.path,c)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,c){return l===c||y.equalsIgnoreCase(l,c)}hasTrailingPathSeparator(l,c=R.sep){if(l.scheme===A.Schemas.file){const S=E(l);return S.length>p.getRoot(S).length&&S[S.length-1]===c}else{const S=l.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,c=R.sep){return e.hasTrailingPathSeparator(l,c)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,c=R.sep){let S=!1;if(l.scheme===A.Schemas.file){const w=E(l);S=w!==void 0&&w.length===p.getRoot(w).length&&w[w.length-1]===c}else{c="/";const w=l.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(l,c)?l.with({path:l.path+"/"}):l}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(f=>f.scheme===A.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new C(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,l){const c=[];for(let S=0;S<f.length;S++){const w=l(f[S]);f.some((b,h)=>h===S?!1:e.isEqualOrParent(w,l(b)))||c.push(f[S])}return c}e.distinctParents=n;var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function l(c){const S=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(h=>{const[u,m]=h.split(":");u&&m&&S.set(u,m)});const b=c.path.substring(0,c.path.indexOf(";"));return b&&S.set(f.META_DATA_MIME,b),S}f.parseMetaData=l})(P=e.DataUri||(e.DataUri={}));function d(f,l,c){if(l){let S=f.path;return S&&S[0]!==R.posix.sep&&(S=R.posix.sep+S),f.with({scheme:c,authority:l,path:S})}return f.with({scheme:c})}e.toLocalResource=d}),define(fe[18],me([0,1,21,15,3,6,22]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(F){return!!F&&typeof F.then=="function"}e.isThenable=I;function E(F){const x=new p.CancellationTokenSource,O=F(x.token),M=new Promise((B,V)=>{x.token.onCancellationRequested(()=>{V(R.canceled())}),Promise.resolve(O).then(ee=>{x.dispose(),B(ee)},ee=>{x.dispose(),V(ee)})});return new class{cancel(){x.cancel()}then(B,V){return M.then(B,V)}catch(B){return this.then(void 0,B)}finally(B){return M.finally(B)}}}e.createCancelablePromise=E;function C(F,x,O){return Promise.race([F,new Promise(M=>x.onCancellationRequested(()=>M(O)))])}e.raceCancellation=C;async function n(F){let x=-1;const O=F.map((B,V)=>B.then(ee=>(x=V,ee))),M=await Promise.race(O);return F.forEach((B,V)=>{V!==x&&B.cancel()}),M}e.raceCancellablePromises=n;function P(F,x,O){let M;const B=setTimeout(()=>{M?.(void 0),O?.()},x);return Promise.race([F.finally(()=>clearTimeout(B)),new Promise(V=>M=V)])}e.raceTimeout=P;function d(F){return new Promise((x,O)=>{const M=F();I(M)?M.then(x,O):x(M)})}e.asPromise=d;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(O,O).then(M)})}return new Promise((O,M)=>{this.queuedPromise.then(O,M)})}return this.activePromise=x(),new Promise((O,M)=>{this.activePromise.then(B=>{this.activePromise=null,O(B)},B=>{this.activePromise=null,M(B)})})}}e.Throttler=f;class l{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=l;class c{constructor(){this.promiseMap=new Map}queue(x,O){const B=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(x)===B&&this.promiseMap.delete(x)});return this.promiseMap.set(x,B),B}}e.SequencerByKey=c;class S{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,O=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,B)=>{this.doResolve=M,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class w{constructor(x){this.delayer=new S(x),this.throttler=new f}trigger(x,O){return this.delayer.trigger(()=>this.throttler.queue(x),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,O)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class h extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function u(F,x){return x?new Promise((O,M)=>{const B=setTimeout(O,F);x.onCancellationRequested(()=>{clearTimeout(B),M(R.canceled())})}):E(O=>u(F,O))}e.timeout=u;function m(F,x=0){const O=setTimeout(F,x);return y.toDisposable(()=>clearTimeout(O))}e.disposableTimeout=m;function t(F){return F.then(void 0,x=>{})}e.ignoreErrors=t;function s(F){const x=[];let O=0;const M=F.length;function B(){return O<M?F[O++]():null}function V(ee){ee!=null&&x.push(ee);const de=B();return de?de.then(V):Promise.resolve(x)}return Promise.resolve(null).then(V)}e.sequence=s;function r(F,x=M=>!!M,O=null){let M=0;const B=F.length,V=()=>{if(M>=B)return Promise.resolve(O);const ee=F[M++];return Promise.resolve(ee()).then(ye=>x(ye)?Promise.resolve(ye):V())};return V()}e.first=r;function i(F,x=M=>!!M,O=null){if(F.length===0)return Promise.resolve(O);let M=F.length;const B=()=>{M=-1;for(const V of F)V.cancel?.()};return new Promise((V,ee)=>{for(const de of F)de.then(ye=>{--M>=0&&x(ye)?(B(),V(ye)):M===0&&V(O)}).catch(ye=>{--M>=0&&(B(),ee(ye))})})}e.firstParallel=i;class a{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((O,M)=>{this.outstandingPromises.push({factory:x,c:O,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const O=x.factory();O.then(x.c,x.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class v extends a{constructor(){super(1)}}e.Queue=v;class g{constructor(){this.queues=new Map}queueFor(x,O=A.extUri){const M=O.getComparisonKey(x);let B=this.queues.get(M);return B||(B=new v,k.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete(M)}),this.queues.set(M,B)),B}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=g;class _{constructor(x,O){this._token=-1,typeof x=="function"&&typeof O=="number"&&this.setIfNotSet(x,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},O)}setIfNotSet(x,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},O))}}e.TimeoutTimer=_;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,O){this.cancel(),this._token=setInterval(()=>{x()},O)}}e.IntervalTimer=D;class o{constructor(x,O){this.timeoutToken=-1,this.runner=x,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=o;class T extends o{constructor(x,O){super(x,O);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class L extends y.Disposable{constructor(x,O,M,B){super();this.maxWorkChunkSize=x,this.maxPendingWork=O,this.throttleDelay=M,this.handler=B,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new o(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const O=setTimeout(()=>x(F));let M=!1;return{dispose(){M||(M=!0,clearTimeout(O))}}}}else e.runWhenIdle=(F,x)=>{const O=requestIdleCallback(F,typeof x=="number"?{timeout:x}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(O))}}}}();class ${constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function W(F,x,O){let M;for(let B=0;B<O;B++)try{return await F()}catch(V){M=V,await u(x)}throw M}e.retry=W;class Q{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,O,M){return this._pending={taskId:x,cancel:()=>M?.(),promise:O},O.then(()=>this.donePending(x),()=>this.donePending(x)),O}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let O,M;const B=new Promise((V,ee)=>{O=V,M=ee});this._next={run:x,promise:B,promiseResolve:O,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=Q;class z{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,O)=>{this.completeCallback=x,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(O=>{this.completeCallback(x),this.resolved=!0,O()})}error(x){return new Promise(O=>{this.errorCallback(x),this.rejected=!0,O()})}cancel(){new Promise(x=>{this.errorCallback(R.canceled()),this.rejected=!0,x()})}}e.DeferredPromise=N;var H;(function(F){async function x(O){let M;const B=await Promise.all(O.map(V=>V.then(ee=>ee,ee=>{M||(M=ee)})));if(typeof M!="undefined")throw M;return B}F.settled=x})(H=e.Promises||(e.Promises={}))}),define(fe[96],me([0,1,9,18]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(D,o,T=!1){const L=D||"",$=o||"",W=k.value.collator.compare(L,$);return k.value.collatorIsNumeric&&W===0&&L!==$?L<$?-1:1:W}e.compareFileNames=I;function E(D,o){const T=y.value.collator;return D=D||"",o=o||"",m(T,D,o)}e.compareFileNamesDefault=E;function C(D,o){const T=y.value.collator;return D=D||"",o=o||"",i(D,o)||m(T,D,o)}e.compareFileNamesUpper=C;function n(D,o){const T=y.value.collator;return D=D||"",o=o||"",r(D,o)||m(T,D,o)}e.compareFileNamesLower=n;function P(D,o){return D=D||"",o=o||"",D===o?0:D<o?-1:1}e.compareFileNamesUnicode=P;function d(D,o,T=!1){T||(D=D&&D.toLowerCase(),o=o&&o.toLowerCase());const[L,$]=h(D),[W,Q]=h(o);return L!==W?L<W?-1:1:$===Q?0:$<Q?-1:1}e.noIntlCompareFileNames=d;function f(D,o){const[T,L]=h(D),[$,W]=h(o);let Q=k.value.collator.compare(L,W);if(Q===0){if(k.value.collatorIsNumeric&&L!==W)return L<W?-1:1;if(Q=k.value.collator.compare(T,$),k.value.collatorIsNumeric&&Q===0&&T!==$)return T<$?-1:1}return Q}e.compareFileExtensions=f;function l(D,o){D=D||"",o=o||"";const T=u(D),L=u(o),$=y.value.collator,W=A.value.collator;return m(W,T,L)||m($,D,o)}e.compareFileExtensionsDefault=l;function c(D,o){D=D||"",o=o||"";const T=u(D),L=u(o),$=y.value.collator,W=A.value.collator;return m(W,T,L)||i(D,o)||m($,D,o)}e.compareFileExtensionsUpper=c;function S(D,o){D=D||"",o=o||"";const T=u(D),L=u(o),$=y.value.collator,W=A.value.collator;return m(W,T,L)||r(D,o)||m($,D,o)}e.compareFileExtensionsLower=S;function w(D,o){D=D||"",o=o||"";const T=u(D).toLowerCase(),L=u(o).toLowerCase();return T!==L?T<L?-1:1:D!==o?D<o?-1:1:0}e.compareFileExtensionsUnicode=w;const b=/^(.*?)(\.([^.]*))?$/;function h(D,o=!1){const T=D?b.exec(D):[];let L=[T&&T[1]||"",T&&T[3]||""];return o&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function u(D){const o=D?b.exec(D):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function m(D,o,T){let L=D.compare(o,T);return L!==0?L:o.length!==T.length?o.length<T.length?-1:1:0}function t(D){const o=D.charAt(0);return o.toLocaleUpperCase()!==o}function s(D){const o=D.charAt(0);return o.toLocaleLowerCase()!==o}function r(D,o){return t(D)&&s(o)?-1:s(D)&&t(o)?1:0}function i(D,o){return s(D)&&t(o)?-1:t(D)&&s(o)?1:0}function a(D,o,T=!1){return T||(D=D&&D.toLowerCase(),o=o&&o.toLowerCase()),D===o?0:D<o?-1:1}function v(D,o,T=!1){const L=D.split(p.sep),$=o.split(p.sep),W=L.length-1,Q=$.length-1;let z,N;for(let H=0;;H++){if(z=W===H,N=Q===H,z&&N)return I(L[H],$[H],T);if(z)return-1;if(N)return 1;const F=a(L[H],$[H],T);if(F!==0)return F}}e.comparePaths=v;function g(D,o,T){const L=D.toLowerCase(),$=o.toLowerCase(),W=_(D,o,T);if(W)return W;const Q=L.endsWith(T),z=$.endsWith(T);if(Q!==z)return Q?-1:1;const N=I(L,$);return N!==0?N:L.localeCompare($)}e.compareAnything=g;function _(D,o,T){const L=D.toLowerCase(),$=o.toLowerCase(),W=L.startsWith(T),Q=$.startsWith(T);if(W!==Q)return W?-1:1;if(W&&Q){if(L.length<$.length)return-1;if(L.length>$.length)return 1}return 0}e.compareByPrefix=_}),define(fe[97],me([0,1,96,94,9,11,8]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const I=0,E=[I,[]];function C(z,N,H,F){if(!z||!N)return E;const x=z.length,O=N.length;if(x<O)return E;const M=z.toLowerCase();return!F&&!M.includes(H)?E:n(N,H,O,z,M,x)}e.scoreFuzzy=C;function n(z,N,H,F,x,O){const M=[],B=[];for(let ye=0;ye<H;ye++){const Fe=ye*O,Re=Fe-O,Ne=ye>0,Ge=z[ye],Ve=N[ye];for(let qe=0;qe<O;qe++){const q=qe>0,Z=Fe+qe,re=Z-1,ae=Re+qe-1,J=q?M[re]:0,se=Ne&&q?M[ae]:0,ve=Ne&&q?B[ae]:0;let Le;!se&&Ne?Le=0:Le=P(Ge,Ve,F,x,qe,ve),Le&&se+Le>=J?(B[Z]=ve+1,M[Z]=se+Le):(B[Z]=I,M[Z]=J)}}const V=[];let ee=H-1,de=O-1;for(;ee>=0&&de>=0;){const ye=ee*O+de;B[ye]===I||(V.push(de),ee--),de--}return[M[H*O-1],V.reverse()]}function P(z,N,H,F,x,O){let M=0;if(!d(N,F[x]))return M;if(M+=1,O>0&&(M+=O*5),z===H[x]&&(M+=1),x===0)M+=8;else{const B=f(H.charCodeAt(x-1));B?M+=B:R.isUpper(H.charCodeAt(x))&&(M+=2)}return M}function d(z,N){return z===N?!0:z==="/"||z==="\\"?N==="/"||N==="\\":!1}function f(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function c(z,N,H=0,F=0){const x=N;return x.values&&x.values.length>1?S(z,x.values,H,F):w(z,N,H,F)}e.scoreFuzzy2=c;function S(z,N,H,F){let x=0;const O=[];for(const M of N){const[B,V]=w(z,M,H,F);if(typeof B!="number")return l;x+=B,O.push(...V)}return[x,v(O)]}function w(z,N,H,F){const x=R.fuzzyScore(N.original,N.originalLowercase,H,z,z.toLowerCase(),F,!0);return x?[x[0],R.createMatches(x)]:l}const b=Object.freeze({score:0}),h=1<<18,u=1<<17,m=1<<16;function t(z,N,H,F,x){if(!z||!N.normalized)return b;const O=F.getItemLabel(z);if(!O)return b;const M=F.getItemDescription(z);let B;M?B=`${O}${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${H}`:B=`${O}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${H}`;const V=x[B];if(V)return V;const ee=s(O,M,F.getItemPath(z),N,H);return x[B]=ee,ee}e.scoreItemFuzzy=t;function s(z,N,H,F,x){const O=!H||!F.containsPathSeparator;return H&&(y.isLinux?F.pathNormalized===H:A.equalsIgnoreCase(F.pathNormalized,H))?{score:h,labelMatch:[{start:0,end:z.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:F.values&&F.values.length>1?r(z,N,H,F.values,O,x):i(z,N,H,F,O,x)}function r(z,N,H,F,x,O){let M=0;const B=[],V=[];for(const ee of F){const{score:de,labelMatch:ye,descriptionMatch:Fe}=i(z,N,H,ee,x,O);if(de===I)return b;M+=de,ye&&B.push(...ye),Fe&&V.push(...Fe)}return{score:M,labelMatch:v(B),descriptionMatch:v(V)}}function i(z,N,H,F,x,O){if(x||!N){const[M,B]=C(z,F.normalized,F.normalizedLowercase,O);if(M){const V=R.matchesPrefix(F.normalized,z);let ee;return V?(ee=u,ee+=Math.round(F.normalized.length/z.length*100)):ee=m,{score:ee+M,labelMatch:V||a(B)}}}if(N){let M=N;H&&(M=`${N}${k.sep}`);const B=M.length,V=`${M}${z}`,[ee,de]=C(V,F.normalized,F.normalizedLowercase,O);if(ee){const ye=a(de),Fe=[],Re=[];return ye.forEach(Ne=>{Ne.start<B&&Ne.end>B?(Fe.push({start:0,end:Ne.end-B}),Re.push({start:Ne.start,end:B})):Ne.start>=B?Fe.push({start:Ne.start-B,end:Ne.end-B}):Re.push(Ne)}),{score:ee,labelMatch:Fe,descriptionMatch:Re}}}return b}function a(z){const N=[];if(!z)return N;let H;for(const F of z)H&&H.end===F?H.end+=1:(H={start:F,end:F+1},N.push(H));return N}function v(z){const N=z.sort((x,O)=>x.start-O.start),H=[];let F;for(const x of N)!F||!g(F,x)?(F=x,H.push(x)):(F.start=Math.min(F.start,x.start),F.end=Math.max(F.end,x.end));return H}function g(z,N){return!(z.end<N.start||N.end<z.start)}function _(z,N,H,F,x,O){const M=t(z,H,F,x,O),B=t(N,H,F,x,O),V=M.score,ee=B.score;if((V===h||ee===h)&&V!==ee)return V===h?-1:1;if(V>m||ee>m){if(V!==ee)return V>ee?-1:1;if(V<u&&ee<u){const Ve=o(M.labelMatch,B.labelMatch);if(Ve!==0)return Ve}const Ne=x.getItemLabel(z)||"",Ge=x.getItemLabel(N)||"";if(Ne.length!==Ge.length)return Ne.length-Ge.length}if(V!==ee)return V>ee?-1:1;const de=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,ye=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(de&&!ye)return-1;if(ye&&!de)return 1;const Fe=D(z,M,x),Re=D(N,B,x);return Fe&&Re&&Fe!==Re?Re>Fe?-1:1:T(z,N,H,x)}e.compareItemsByFuzzyScore=_;function D(z,N,H){let F=-1,x=-1;if(N.descriptionMatch&&N.descriptionMatch.length?F=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(F=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(x=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const O=H.getItemDescription(z);O&&(x+=O.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(x=N.descriptionMatch[N.descriptionMatch.length-1].end);return x-F}function o(z,N){if(!z&&!N||(!z||!z.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!z||!z.length)return 1;const H=z[0].start,x=z[z.length-1].end-H,O=N[0].start,B=N[N.length-1].end-O;return x===B?0:B<x?1:-1}function T(z,N,H,F){const x=F.getItemLabel(z)||"",O=F.getItemLabel(N)||"",M=F.getItemDescription(z),B=F.getItemDescription(N),V=x.length+(M?M.length:0),ee=O.length+(B?B.length:0);if(V!==ee)return V-ee;const de=F.getItemPath(z),ye=F.getItemPath(N);return de&&ye&&de.length!==ye.length?de.length-ye.length:x!==O?p.compareAnything(x,O,H.normalized):M&&B&&M!==B?p.compareAnything(M,B,H.normalized):de&&ye&&de!==ye?p.compareAnything(de,ye,H.normalized):0}const L=" ";function $(z){typeof z!="string"&&(z="");const N=z.toLowerCase(),{pathNormalized:H,normalized:F,normalizedLowercase:x}=W(z),O=H.indexOf(k.sep)>=0;let M;const B=z.split(L);if(B.length>1)for(const V of B){const{pathNormalized:ee,normalized:de,normalizedLowercase:ye}=W(V);de&&(M||(M=[]),M.push({original:V,originalLowercase:V.toLowerCase(),pathNormalized:ee,normalized:de,normalizedLowercase:ye}))}return{original:z,originalLowercase:N,pathNormalized:H,normalized:F,normalizedLowercase:x,values:M,containsPathSeparator:O}}e.prepareQuery=$;function W(z){let N;y.isWindows?N=z.replace(/\//g,k.sep):N=z.replace(/\\/g,k.sep);const H=A.stripWildcards(N).replace(/\s/g,"");return{pathNormalized:N,normalized:H,normalizedLowercase:H.toLowerCase()}}function Q(z){return Array.isArray(z)?$(z.map(N=>N.original).join(L)):$(z.original)}e.pieceToQuery=Q}),define(fe[30],me([0,1,8,29,9,24,18]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const E="**",C="/",n="[/\\\\]",P="[^/\\\\]",d=/\//g;function f(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function l(M,B){if(!M)return[];const V=[];let ee=!1,de=!1,ye="";for(const Fe of M){switch(Fe){case B:if(!ee&&!de){V.push(ye),ye="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":de=!0;break;case"]":de=!1;break}ye+=Fe}return ye&&V.push(ye),V}e.splitGlobAware=l;function c(M){if(!M)return"";let B="";const V=l(M,C);if(V.every(ee=>ee===E))B=".*";else{let ee=!1;V.forEach((de,ye)=>{if(de===E){ee||(B+=f(2),ee=!0);return}let Fe=!1,Re="",Ne=!1,Ge="";for(const Ve of de){if(Ve!=="}"&&Fe){Re+=Ve;continue}if(Ne&&(Ve!=="]"||!Ge)){let qe;Ve==="-"?qe=Ve:(Ve==="^"||Ve==="!")&&!Ge?qe="^":Ve===C?qe="":qe=p.escapeRegExpCharacters(Ve),Ge+=qe;continue}switch(Ve){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":B+=`(?:${l(Re,",").map(Z=>c(Z)).join("|")})`,Fe=!1,Re="";break;case"]":B+="["+Ge+"]",Ne=!1,Ge="";break;case"?":B+=P;continue;case"*":B+=f(1);continue;default:B+=p.escapeRegExpCharacters(Ve)}}ye<V.length-1&&(V[ye+1]!==E||ye+2<V.length)&&(B+=n),ee=!1})}return B}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i(M,B){if(!M)return r;let V;typeof M!="string"?V=M.pattern:V=M,V=V.trim();const ee=`${V}_${!!B.trimForExclusions}`;let de=t.get(ee);if(de)return a(de,M);let ye;if(S.test(V)){const Fe=V.substr(4);de=function(Re,Ne){return typeof Re=="string"&&Re.endsWith(Fe)?V:null}}else(ye=w.exec(v(V,B)))?de=g(ye[1],V):(B.trimForExclusions?h:b).test(V)?de=_(V,B):(ye=u.exec(v(V,B)))?de=D(ye[1].substr(1),V,!0):(ye=m.exec(v(V,B)))?de=D(ye[1],V,!1):de=o(V);return t.set(ee,de),a(de,M)}function a(M,B){return typeof B=="string"?M:function(V,ee){return R.isEqualOrParent(V,B.base)?M(k.relative(B.base,V),ee):null}}function v(M,B){return B.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function g(M,B){const V=`/${M}`,ee=`\\${M}`,de=function(Fe,Re){return typeof Fe!="string"?null:Re?Re===M?B:null:Fe===M||Fe.endsWith(V)||Fe.endsWith(ee)?B:null},ye=[M];return de.basenames=ye,de.patterns=[B],de.allBasenames=ye,de}function _(M,B){const V=O(M.slice(1,-1).split(",").map(Re=>i(Re,B)).filter(Re=>Re!==r),M),ee=V.length;if(!ee)return r;if(ee===1)return V[0];const de=function(Re,Ne){for(let Ge=0,Ve=V.length;Ge<Ve;Ge++)if(V[Ge](Re,Ne))return M;return null},ye=V.find(Re=>!!Re.allBasenames);ye&&(de.allBasenames=ye.allBasenames);const Fe=V.reduce((Re,Ne)=>Ne.allPaths?Re.concat(Ne.allPaths):Re,[]);return Fe.length&&(de.allPaths=Fe),de}function D(M,B,V){const ee=k.sep===k.posix.sep,de=ee?M:M.replace(d,k.sep),ye=k.sep+de,Fe=k.posix.sep+M,Re=V?function(Ne,Ge){return typeof Ne=="string"&&(Ne===de||Ne.endsWith(ye)||!ee&&(Ne===M||Ne.endsWith(Fe)))?B:null}:function(Ne,Ge){return typeof Ne=="string"&&(Ne===de||!ee&&Ne===M)?B:null};return Re.allPaths=[(V?"*/":"./")+M],Re}function o(M){try{const B=new RegExp(`^${c(M)}$`);return function(V){return B.lastIndex=0,typeof V=="string"&&B.test(V)?M:null}}catch(B){return r}}function T(M,B,V){return!M||typeof B!="string"?!1:L(M)(B,void 0,V)}e.match=T;function L(M,B={}){if(!M)return s;if(typeof M=="string"||z(M)){const V=i(M,B);if(V===r)return s;const ee=function(de,ye){return!!V(de,ye)};return V.allBasenames&&(ee.allBasenames=V.allBasenames),V.allPaths&&(ee.allPaths=V.allPaths),ee}return F(M,B)}e.parse=L;function $(M){if(!M)return;let B;return V=>(B||(B=(M()||Promise.resolve([])).then(ee=>ee?Q(ee):{})),B.then(ee=>!!ee[V]))}e.hasSiblingPromiseFn=$;function W(M){if(!M)return;let B;return V=>{if(!B){const ee=M();B=ee?Q(ee):{}}return!!B[V]}}e.hasSiblingFn=W;function Q(M){const B={};for(const V of M)B[V]=!0;return B}function z(M){const B=M;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=z;function N(M){return M.allBasenames||[]}e.getBasenameTerms=N;function H(M){return M.allPaths||[]}e.getPathTerms=H;function F(M,B){const V=O(Object.getOwnPropertyNames(M).map(Re=>x(Re,M[Re],B)).filter(Re=>Re!==r)),ee=V.length;if(!ee)return r;if(!V.some(Re=>!!Re.requiresSiblings)){if(ee===1)return V[0];const Re=function(Ve,qe){for(let q=0,Z=V.length;q<Z;q++){const re=V[q](Ve,qe);if(re)return re}return null},Ne=V.find(Ve=>!!Ve.allBasenames);Ne&&(Re.allBasenames=Ne.allBasenames);const Ge=V.reduce((Ve,qe)=>qe.allPaths?Ve.concat(qe.allPaths):Ve,[]);return Ge.length&&(Re.allPaths=Ge),Re}const de=function(Re,Ne,Ge){let Ve;for(let qe=0,q=V.length;qe<q;qe++){const Z=V[qe];Z.requiresSiblings&&Ge&&(Ne||(Ne=k.basename(Re)),Ve||(Ve=Ne.substr(0,Ne.length-k.extname(Re).length)));const re=Z(Re,Ne,Ve,Ge);if(re)return re}return null},ye=V.find(Re=>!!Re.allBasenames);ye&&(de.allBasenames=ye.allBasenames);const Fe=V.reduce((Re,Ne)=>Ne.allPaths?Re.concat(Ne.allPaths):Re,[]);return Fe.length&&(de.allPaths=Fe),de}function x(M,B,V){if(B===!1)return r;const ee=i(M,V);if(ee===r)return r;if(typeof B=="boolean")return ee;if(B){const de=B.when;if(typeof de=="string"){const ye=(Fe,Re,Ne,Ge)=>{if(!Ge||!ee(Fe,Re))return null;const Ve=de.replace("$(basename)",Ne),qe=Ge(Ve);return A.isThenable(qe)?qe.then(q=>q?M:null):qe?M:null};return ye.requiresSiblings=!0,ye}}return ee}function O(M,B){const V=M.filter(Re=>!!Re.basenames);if(V.length<2)return M;const ee=V.reduce((Re,Ne)=>{const Ge=Ne.basenames;return Ge?Re.concat(Ge):Re},[]);let de;if(B){de=[];for(let Re=0,Ne=ee.length;Re<Ne;Re++)de.push(B)}else de=V.reduce((Re,Ne)=>{const Ge=Ne.patterns;return Ge?Re.concat(Ge):Re},[]);const ye=function(Re,Ne){if(typeof Re!="string")return null;if(!Ne){let Ve;for(Ve=Re.length;Ve>0;Ve--){const qe=Re.charCodeAt(Ve-1);if(qe===47||qe===92)break}Ne=Re.substr(Ve)}const Ge=ee.indexOf(Ne);return Ge!==-1?de[Ge]:null};ye.basenames=ee,ye.patterns=de,ye.allBasenames=ee;const Fe=M.filter(Re=>!Re.basenames);return Fe.push(ye),Fe}}),define(fe[74],me([0,1,2,9,8,10,11,22,29]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,a,v){if(typeof i=="string"&&(i=p.URI.file(i)),v){const _=v.getWorkspaceFolder(i);if(_){const D=v.getWorkspace().folders.length>1;let o;if(I.isEqual(_.uri,i)?o="":o=I.relativePath(_.uri,i),D){const T=_.name?_.name:I.basename(_.uri);o=o?T+" \u2022 "+o:T}return o}}if(i.scheme!==y.Schemas.file&&i.scheme!==y.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if(E.hasDriveLetter(i.fsPath))return R.normalize(P(i.fsPath));let g=R.normalize(i.fsPath);return!A.isWindows&&a?.userHome&&(g=f(g,a.userHome.fsPath)),g}e.getPathLabel=C;function n(i){if(!i)return;typeof i=="string"&&(i=p.URI.file(i));const a=I.basename(i)||(i.scheme===y.Schemas.file?i.fsPath:i.path);return A.isWindows&&E.isRootOrDriveLetter(a)?P(a):a}e.getBaseLabel=n;function P(i){return E.hasDriveLetter(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let d=Object.create(null);function f(i,a){if(A.isWindows||!i||!a)return i;let v=d.original===a?d.normalized:void 0;return v||(v=`${k.rtrim(a,R.posix.sep)}${R.posix.sep}`,d={original:a,normalized:v}),(A.isLinux?i.startsWith(v):k.startsWithIgnoreCase(i,v))&&(i=`~/${i.substr(v.length)}`),i}e.tildify=f;function l(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=l;const c="\u2026",S="\\\\",w="~";function b(i,a=R.sep){const v=new Array(i.length);let g=!1;for(let _=0;_<i.length;_++){let D=i[_];if(D===""){v[_]=`.${a}`;continue}if(!D){v[_]=D;continue}g=!0;let o="";D.indexOf(S)===0?(o=D.substr(0,D.indexOf(S)+S.length),D=D.substr(D.indexOf(S)+S.length)):D.indexOf(a)===0?(o=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length)):D.indexOf(w)===0&&(o=D.substr(0,D.indexOf(w)+w.length),D=D.substr(D.indexOf(w)+w.length));const T=D.split(a);for(let L=1;g&&L<=T.length;L++)for(let $=T.length-L;g&&$>=0;$--){g=!1;let W=T.slice($,$+L).join(a);for(let Q=0;!g&&Q<i.length;Q++)if(Q!==_&&i[Q]&&i[Q].indexOf(W)>-1){const z=$+L===T.length,N=$>0&&i[Q].indexOf(a)>-1?a+W:W,H=i[Q].endsWith(N);g=!z||H}if(!g){let Q="";(T[0].endsWith(":")||o!=="")&&($===1&&($=0,L++,W=T[0]+a+W),$>0&&(Q=T[0]+a),Q=o+Q),$>0&&(Q=Q+c+a),Q=Q+W,$+L<T.length&&(Q=Q+a+c),v[_]=Q}}g&&(v[_]=D)}return v}e.shorten=b;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function u(i,a=Object.create(null)){const v=[];let g=!1,_="";for(const D of i)if(D==="$"||g&&D==="{")_&&v.push({value:_,type:h.TEXT}),_="",g=!0;else if(D==="}"&&g){const o=a[_];if(typeof o=="string")o.length&&v.push({value:o,type:h.VARIABLE});else if(o){const T=v[v.length-1];(!T||T.type!==h.SEPARATOR)&&v.push({value:o.label,type:h.SEPARATOR})}_="",g=!1}else _+=D;return _&&!g&&v.push({value:_,type:h.TEXT}),v.filter((D,o)=>{if(D.type===h.SEPARATOR){const T=v[o-1],L=v[o+1];return[T,L].every($=>$&&($.type===h.VARIABLE||$.type===h.TEXT)&&$.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=u;function m(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,v=>v==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const a=i.indexOf("/")!==-1?R.posix:R.win32,v=a.basename(i),g=a.dirname(i);return v.length?{name:v,parentPath:g}:{name:g,parentPath:""}}e.splitName=r}),define(fe[98],me([0,1,9,8,30,10,22]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let E=[],C=[],n=[];function P(s,r=!1){const i=d(s);E.push(i),i.userConfigured?n.push(i):C.push(i),r&&!i.userConfigured&&E.forEach(a=>{a.mime===i.mime||a.userConfigured||(i.extension&&a.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&a.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&a.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&a.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=P;function d(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(p.posix.sep)>=0:!1}}function f(s){s?(E=E.filter(r=>!r.userConfigured),n=[]):(E=[],C=[],n=[])}e.clearTextMimes=f;function l(s,r){let i;if(s)switch(s.scheme){case y.Schemas.file:i=s.fsPath;break;case y.Schemas.data:i=A.DataUri.parseMetaData(s).get(A.DataUri.META_DATA_LABEL);break;default:i=s.path}if(!i)return[I.unknown];i=i.toLowerCase();const a=p.basename(i),v=c(i,a,n);if(v)return[v,I.text];const g=c(i,a,C);if(g)return[g,I.text];if(r){const _=S(r);if(_)return[_,I.text]}return[I.unknown]}e.guessMimeTypes=l;function c(s,r,i){let a=null,v=null,g=null;for(let _=i.length-1;_>=0;_--){const D=i[_];if(r===D.filenameLowercase){a=D;break}if(D.filepattern&&(!v||D.filepattern.length>v.filepattern.length)){const o=D.filepatternOnPath?s:r;k.match(D.filepatternLowercase,o)&&(v=D)}D.extension&&(!g||D.extension.length>g.extension.length)&&r.endsWith(D.extensionLowercase)&&(g=D)}return a?a.mime:v?v.mime:g?g.mime:null}function S(s){if(R.startsWithUTF8BOM(s)&&(s=s.substr(1)),s.length>0)for(let r=E.length-1;r>=0;r--){const i=E[r];if(!i.firstline)continue;const a=s.match(i.firstline);if(a&&a.length>0)return i.mime}return null}function w(s){return s?typeof s=="string"?s===I.binary||s===I.text||s===I.unknown:s.length===1&&w(s[0]):!0}e.isUnspecific=w;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(s){const r=p.extname(s);return b[r.toLowerCase()]}e.getMediaMime=h;function u(s){for(const r in b)if(b[r]===s)return r}e.getExtensionForMimeType=u;const m=/^(.+)\/(.+?)(;.+)?$/;function t(s,r){const i=m.exec(s);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:r?void 0:s}e.normalizeMimeType=t}),define(fe[99],me([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class k{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:R(p.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:R(p.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:p.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,P,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof p.URI)return P.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const l=y(n[f],P,d+1);l!==null&&(n[f]=l)}}return null}function A(n,P){const d=y(n,P,0);return d===null?n:d}e.transformOutgoingURIs=A;function I(n,P,d,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?p.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let l in n)if(Object.hasOwnProperty.call(n,l)){const c=I(n[l],P,d,f+1);c!==null&&(n[l]=c)}}return null}function E(n,P){const d=I(n,P,!1,0);return d===null?n:d}e.transformIncomingURIs=E;function C(n,P){const d=I(n,P,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=C}),define(fe[32],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(E){return p.test(E)}e.isUUID=R;const k=new Uint8Array(16),y=[];for(let E=0;E<256;E++)y.push(E.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(E){for(let C=0;C<E.length;C++)E[C]=Math.floor(Math.random()*256);return E};function I(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let E=0,C="";return C+=y[k[E++]],C+=y[k[E++]],C+=y[k[E++]],C+=y[k[E++]],C+="-",C+=y[k[E++]],C+=y[k[E++]],C+="-",C+=y[k[E++]],C+=y[k[E++]],C+="-",C+=y[k[E++]],C+=y[k[E++]],C+="-",C+=y[k[E++]],C+=y[k[E++]],C+=y[k[E++]],C+=y[k[E++]],C+=y[k[E++]],C+=y[k[E++]],C}e.generateUuid=I}),define(fe[138],me([0,1,100]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new p.StringDecoder(y),this.remaining=null}write(y){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(I.length<1)return A;let E=0,C,n=E;for(;n<I.length;)if(C=I.charCodeAt(n),C===13||C===10){if(A.push(I.substring(E,n)),n++,n<I.length){const P=C;C=I.charCodeAt(n),(P===13&&C===10||P===10&&C===13)&&n++}E=n}else n++;return this.remaining=E<I.length?I.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(fe[28],me([0,1,57,101,281,9,18,11,29,32,73,22,2]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function l(N,H=f.UNLINK){if(E.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");return H===f.UNLINK?S(N):c(N)}async function c(N){try{const H=y.join(R.tmpdir(),C.generateUuid());try{await e.Promises.rename(N,H)}catch(F){return S(N)}S(H).catch(F=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function S(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function w(N){if(E.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(N,{recursive:!0})}e.rimrafSync=w;async function b(N,H){return m(await(H?h(N):k.promisify(p.readdir)(N)))}async function h(N){try{return await k.promisify(p.readdir)(N,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const H=[],F=await b(N);for(const x of F){let O=!1,M=!1,B=!1;try{const V=await e.Promises.lstat(y.join(N,x));O=V.isFile(),M=V.isDirectory(),B=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}H.push({name:x,isFile:()=>O,isDirectory:()=>M,isSymbolicLink:()=>B})}return H}function u(N){return m(p.readdirSync(N))}e.readdirSync=u;function m(N){return N.map(H=>typeof H=="string"?I.isMacintosh?n.normalizeNFC(H):H:(H.name=I.isMacintosh?n.normalizeNFC(H.name):H.name,H))}async function t(N){const H=await b(N),F=[];for(const x of H)await r.existsDirectory(y.join(N,x))&&F.push(x);return F}function s(N,H=1e3){return new Promise(F=>{let x=!1;const O=setInterval(()=>{x||(x=!0,p.access(N,M=>{x=!1,M&&(clearInterval(O),F(void 0))}))},H)})}e.whenDeleted=s;var r;(function(N){async function H(O){let M;try{if(M=await e.Promises.lstat(O),!M.isSymbolicLink())return{stat:M}}catch(B){}try{return{stat:await e.Promises.stat(O),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(I.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw V}throw B}}N.stat=H;async function F(O){try{const{stat:M,symbolicLink:B}=await N.stat(O);return M.isFile()&&B?.dangling!==!0}catch(M){}return!1}N.existsFile=F;async function x(O){try{const{stat:M,symbolicLink:B}=await N.stat(O);return M.isDirectory()&&B?.dangling!==!0}catch(M){}return!1}N.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function a(N,H,F){return i.queueFor(d.URI.file(N),P.extUriBiasedIgnorePathCase).queue(()=>{const x=D(F);return new Promise((O,M)=>g(N,H,x,B=>B?M(B):O()))})}let v=!0;function g(N,H,F,x){if(!v)return p.writeFile(N,H,{mode:F.mode,flag:F.flag},x);p.open(N,F.flag,F.mode,(O,M)=>{if(O)return x(O);p.writeFile(M,H,B=>{if(B)return p.close(M,()=>x(B));p.fdatasync(M,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),v=!1),p.close(M,ee=>x(ee))))})})}function _(N,H,F){const x=D(F);if(!v)return p.writeFileSync(N,H,{mode:x.mode,flag:x.flag});const O=p.openSync(N,x.flag,x.mode);try{p.writeFileSync(O,H);try{p.fdatasyncSync(O)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),v=!1}}finally{p.closeSync(O)}}e.writeFileSync=_;function D(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,H){if(N===H)return;async function F(x){try{const O=await e.Promises.lstat(x);if(O.isDirectory()||O.isSymbolicLink())return;await e.Promises.utimes(x,O.atime,new Date)}catch(O){}}try{await e.Promises.rename(N,H),await F(H)}catch(x){if(N.toLowerCase()!==H.toLowerCase()&&x.code==="EXDEV"||N.endsWith("."))await T(N,H,{preserveSymlinks:!1}),await l(N,f.MOVE),await F(H);else throw x}}async function T(N,H,F){return $(N,H,{root:{source:N,target:H},options:F,handledSourcePaths:new Set})}const L=511;async function $(N,H,F){if(F.handledSourcePaths.has(N))return;F.handledSourcePaths.add(N);const{stat:x,symbolicLink:O}=await r.stat(N);if(O){if(F.options.preserveSymlinks)try{return await z(N,H,F)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(O.dangling)return}return x.isDirectory()?W(N,H,x.mode&L,F):Q(N,H,x.mode&L)}async function W(N,H,F,x){await e.Promises.mkdir(H,{recursive:!0,mode:F});const O=await b(N);for(const M of O)await $(y.join(N,M),y.join(H,M),x)}async function Q(N,H,F){await e.Promises.copyFile(N,H),await e.Promises.chmod(H,F)}async function z(N,H,F){let x=await e.Promises.readlink(N);E.isEqualOrParent(x,F.root.source,!I.isLinux)&&(x=y.join(F.root.target,x.substr(F.root.source.length+1))),await e.Promises.symlink(x,H)}e.Promises=new class{get access(){return k.promisify(p.access)}get stat(){return k.promisify(p.stat)}get lstat(){return k.promisify(p.lstat)}get utimes(){return k.promisify(p.utimes)}get read(){return k.promisify(p.read)}get readFile(){return k.promisify(p.readFile)}get write(){return k.promisify(p.write)}get appendFile(){return k.promisify(p.appendFile)}get fdatasync(){return k.promisify(p.fdatasync)}get truncate(){return k.promisify(p.truncate)}get rename(){return k.promisify(p.rename)}get copyFile(){return k.promisify(p.copyFile)}get open(){return k.promisify(p.open)}get close(){return k.promisify(p.close)}get symlink(){return k.promisify(p.symlink)}get readlink(){return k.promisify(p.readlink)}get chmod(){return k.promisify(p.chmod)}get mkdir(){return k.promisify(p.mkdir)}get unlink(){return k.promisify(p.unlink)}get rmdir(){return k.promisify(p.rmdir)}get realpath(){return k.promisify(p.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return l}get move(){return o}get copy(){return T}}}),define(fe[102],me([0,1,57,8,9,28]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const P=k.dirname(n);if(n===P)return n;const d=(k.basename(n)||n).toLowerCase();try{const l=y.readdirSync(P).filter(c=>c.toLowerCase()===d);if(l.length===1){const c=A(P);if(c)return k.join(c,l[0])}else if(l.length>1){const c=l.indexOf(d);if(c>=0){const S=A(P);if(S)return k.join(S,l[c])}}}catch(f){}return null}e.realcaseSync=A;async function I(n){try{return await y.Promises.realpath(n)}catch(P){const d=C(n);return await y.Promises.access(d,p.constants.R_OK),d}}e.realpath=I;function E(n){try{return p.realpathSync(n)}catch(P){const d=C(n);return p.accessSync(d,p.constants.R_OK),d}}e.realpathSync=E;function C(n){return R.rtrim(k.normalize(n),k.sep)}});var ze=this&&this.__decorate||function(X,e,p,R){var k=arguments.length,y=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,p,R);else for(var I=X.length-1;I>=0;I--)(A=X[I])&&(y=(k<3?A(y):k>3?A(e,p,y):A(e,p))||y);return k>3&&y&&Object.defineProperty(e,p,y),y};define(fe[103],me([0,1,3,6,18,21,15,23,17,14,56,8,52]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function l(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function S(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(w||(w={}));class b{constructor(M){this.buffer=M,this.pos=0}read(M){const B=this.buffer.slice(this.pos,this.pos+M);return this.pos+=B.byteLength,B}}class h{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var u;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(u||(u={}));function m(O){const M=I.VSBuffer.alloc(4);return M.writeUInt32BE(O,0),M}function t(O){return O.read(4).readUInt32BE(0)}function s(O){const M=I.VSBuffer.alloc(1);return M.writeUInt8(O,0),M}const r={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object)},i=typeof Buffer!="undefined";function a(O,M){if(typeof M=="undefined")O.write(r.Undefined);else if(typeof M=="string"){const B=I.VSBuffer.fromString(M);O.write(r.String),O.write(m(B.byteLength)),O.write(B)}else if(i&&Buffer.isBuffer(M)){const B=I.VSBuffer.wrap(M);O.write(r.Buffer),O.write(m(B.byteLength)),O.write(B)}else if(M instanceof I.VSBuffer)O.write(r.VSBuffer),O.write(m(M.byteLength)),O.write(M);else if(Array.isArray(M)){O.write(r.Array),O.write(m(M.length));for(const B of M)a(O,B)}else{const B=I.VSBuffer.fromString(JSON.stringify(M));O.write(r.Object),O.write(m(B.byteLength)),O.write(B)}}function v(O){switch(O.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return O.read(t(O)).toString();case u.Buffer:return O.read(t(O)).buffer;case u.VSBuffer:return O.read(t(O));case u.Array:{const B=t(O),V=[];for(let ee=0;ee<B;ee++)V.push(v(O));return V}case u.Object:return JSON.parse(O.read(t(O)).toString())}}class g{constructor(M,B,V=null,ee=1e3){this.protocol=M,this.ctx=B,this.logger=V,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(de=>this.onRawMessage(de)),this.sendResponse({type:200})}registerChannel(M,B){this.channels.set(M,B),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const B=this.send([M.type]);this.logger&&this.logger.logOutgoing(B,0,1,S(M.type));return}case 201:case 202:case 204:case 203:{const B=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(B,M.id,1,S(M.type),M.data);return}}}send(M,B=void 0){const V=new h;return a(V,M),a(V,B),this.sendBuffer(V.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(B){return 0}}onRawMessage(M){const B=new b(M),V=v(B),ee=v(B),de=V[0];switch(de){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,V[1],1,`${l(de)}: ${V[2]}.${V[3]}`,ee),this.onPromise({type:de,id:V[1],channelName:V[2],name:V[3],arg:ee});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,V[1],1,`${l(de)}: ${V[2]}.${V[3]}`,ee),this.onEventListen({type:de,id:V[1],channelName:V[2],name:V[3],arg:ee});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,V[1],1,`${l(de)}`),this.disposeActiveRequest({type:de,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,V[1],1,`${l(de)}`),this.disposeActiveRequest({type:de,id:V[1]})}}onPromise(M){const B=this.channels.get(M.channelName);if(!B){this.collectPendingRequest(M);return}const V=new y.CancellationTokenSource;let ee;try{ee=B.call(this.ctx,M.name,M.arg,V.token)}catch(Fe){ee=Promise.reject(Fe)}const de=M.id;ee.then(Fe=>{this.sendResponse({id:de,data:Fe,type:201}),this.activeRequests.delete(M.id)},Fe=>{Fe instanceof Error?this.sendResponse({id:de,data:{message:Fe.message,name:Fe.name,stack:Fe.stack?Fe.stack.split?Fe.stack.split(`
`):Fe.stack:void 0},type:202}):this.sendResponse({id:de,data:Fe,type:203}),this.activeRequests.delete(M.id)});const ye=R.toDisposable(()=>V.cancel());this.activeRequests.set(M.id,ye)}onEventListen(M){const B=this.channels.get(M.channelName);if(!B){this.collectPendingRequest(M);return}const V=M.id,de=B.listen(this.ctx,M.name,M.arg)(ye=>this.sendResponse({id:V,data:ye,type:204}));this.activeRequests.set(M.id,de)}disposeActiveRequest(M){const B=this.activeRequests.get(M.id);B&&(B.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let B=this.pendingRequests.get(M.channelName);B||(B=[],this.pendingRequests.set(M.channelName,B));const V=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:M,timeoutTimer:V})}flushPendingRequests(M){const B=this.pendingRequests.get(M);if(B){for(const V of B)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var _;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(M,B=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=B}getChannel(M){const B=this;return{call(V,ee,de){return B.isDisposed?Promise.reject(A.canceled()):B.requestPromise(M,V,ee,de)},listen(V,ee){return B.isDisposed?Promise.reject(A.canceled()):B.requestEvent(M,V,ee)}}}requestPromise(M,B,V,ee=y.CancellationToken.None){const de=this.lastRequestId++,Fe={id:de,type:100,channelName:M,name:B,arg:V};if(ee.isCancellationRequested)return Promise.reject(A.canceled());let Re;return new Promise((Ge,Ve)=>{if(ee.isCancellationRequested)return Ve(A.canceled());const qe=()=>{const ae=J=>{switch(J.type){case 201:this.handlers.delete(de),Ge(J.data);break;case 202:this.handlers.delete(de);const se=new Error(J.data.message);se.stack=J.data.stack,se.name=J.data.name,Ve(se);break;case 203:this.handlers.delete(de),Ve(J.data);break}};this.handlers.set(de,ae),this.sendRequest(Fe)};let q=null;this.state===w.Idle?qe():(q=k.createCancelablePromise(ae=>this.whenInitialized()),q.then(()=>{q=null,qe()}));const Z=()=>{q?(q.cancel(),q=null):this.sendRequest({id:de,type:101}),Ve(A.canceled())},re=ee.onCancellationRequested(Z);Re=R.combinedDisposable(R.toDisposable(Z),re),this.activeRequests.add(Re)}).finally(()=>{this.activeRequests.delete(Re)})}requestEvent(M,B,V){const ee=this.lastRequestId++,ye={id:ee,type:102,channelName:M,name:B,arg:V};let Fe=null;const Re=new p.Emitter({onFirstListenerAdd:()=>{Fe=k.createCancelablePromise(Ge=>this.whenInitialized()),Fe.then(()=>{Fe=null,this.activeRequests.add(Re),this.sendRequest(ye)})},onLastListenerRemove:()=>{Fe?(Fe.cancel(),Fe=null):(this.activeRequests.delete(Re),this.sendRequest({id:ee,type:103}))}}),Ne=Ge=>Re.fire(Ge.data);return this.handlers.set(ee,Ne),Re.event}sendRequest(M){switch(M.type){case 100:case 102:{const B=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(B,M.id,0,`${l(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const B=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(B,M.id,0,l(M.type));return}}}send(M,B=void 0){const V=new h;return a(V,M),a(V,B),this.sendBuffer(V.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(B){return 0}}onBuffer(M){const B=new b(M),V=v(B),ee=v(B),de=V[0];switch(de){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,S(de)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,V[1],0,S(de),ee),this.onResponse({type:V[0],id:V[1],data:ee})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const B=this.handlers.get(M.id);B&&B(M)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}ze([d.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class o{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:B,onDidClientDisconnect:V})=>{p.Event.once(B.onMessage)(de=>{const ye=new b(de),Fe=v(ye),Re=new g(B,Fe),Ne=new D(B);this.channels.forEach((Ve,qe)=>Re.registerChannel(qe,Ve));const Ge={channelServer:Re,channelClient:Ne,ctx:Fe};this._connections.add(Ge),this._onDidAddConnection.fire(Ge),V(()=>{Re.dispose(),Ne.dispose(),this._connections.delete(Ge),this._onDidRemoveConnection.fire(Ge)})})})}get connections(){const M=[];return this._connections.forEach(B=>M.push(B)),M}getChannel(M,B){const V=this;return{call(ee,de,ye){let Fe;if(C.isFunction(B)){let Ne=E.getRandomElement(V.connections.filter(B));Fe=Ne?Promise.resolve(Ne):p.Event.toPromise(p.Event.filter(V.onDidAddConnection,B))}else Fe=B.routeCall(V,ee,de);const Re=Fe.then(Ne=>Ne.channelClient.getChannel(M));return L(Re).call(ee,de,ye)},listen(ee,de){if(C.isFunction(B))return V.getMulticastEvent(M,B,ee,de);const ye=B.routeEvent(V,ee,de).then(Fe=>Fe.channelClient.getChannel(M));return L(ye).listen(ee,de)}}}getMulticastEvent(M,B,V,ee){const de=this;let ye=new R.DisposableStore;const Fe=new p.Emitter({onFirstListenerAdd:()=>{ye=new R.DisposableStore;const Re=new p.EventMultiplexer,Ne=new Map,Ge=qe=>{const Z=qe.channelClient.getChannel(M).listen(V,ee),re=Re.add(Z);Ne.set(qe,re)},Ve=qe=>{const q=Ne.get(qe);!q||(q.dispose(),Ne.delete(qe))};de.connections.filter(B).forEach(Ge),p.Event.filter(de.onDidAddConnection,B)(Ge,void 0,ye),de.onDidRemoveConnection(Ve,void 0,ye),Re.event(Fe.fire,Fe,ye),ye.add(Re)},onLastListenerRemove:()=>{ye.dispose()}});return Fe.event}registerChannel(M,B){this.channels.set(M,B),this._connections.forEach(V=>{V.channelServer.registerChannel(M,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class T{constructor(M,B,V=null){const ee=new h;a(ee,B),M.send(ee.buffer),this.channelClient=new D(M,V),this.channelServer=new g(M,B,V)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,B){this.channelServer.registerChannel(M,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(O){return{call(M,B,V){return O.then(ee=>ee.call(M,B,V))},listen(M,B){const V=new p.Relay;return O.then(ee=>V.input=ee.listen(M,B)),V.event}}}e.getDelayedChannel=L;function $(O){let M=!1;return{call(B,V,ee){return M?O.call(B,V,ee):k.timeout(0).then(()=>M=!0).then(()=>O.call(B,V,ee))},listen(B,V){if(M)return O.listen(B,V);const ee=new p.Relay;return k.timeout(0).then(()=>M=!0).then(()=>ee.input=O.listen(B,V)),ee.event}}}e.getNextTickChannel=$;class W{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const B of M.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await p.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=W;var Q;(function(O){function M(ee,de){const ye=ee,Fe=de&&de.disableMarshalling,Re=new Map;for(const Ne in ye)V(Ne)&&Re.set(Ne,p.Event.buffer(ye[Ne],!0));return new class{listen(Ne,Ge){const Ve=Re.get(Ge);if(Ve)return Ve;throw new Error(`Event not found: ${Ge}`)}call(Ne,Ge,Ve){const qe=ye[Ge];if(typeof qe=="function"){if(!Fe&&Array.isArray(Ve))for(let q=0;q<Ve.length;q++)Ve[q]=n.revive(Ve[q]);return qe.apply(ye,Ve)}throw new Error(`Method not found: ${Ge}`)}}}O.fromService=M;function B(ee,de){const ye=de&&de.disableMarshalling;return new Proxy({},{get(Fe,Re){if(typeof Re=="string")return de?.properties?.has(Re)?de.properties.get(Re):V(Re)?ee.listen(Re):async function(...Ne){let Ge;de&&!C.isUndefinedOrNull(de.context)?Ge=[de.context,...Ne]:Ge=Ne;const Ve=await ee.call(Re,Ge);return ye?Ve:n.revive(Ve)};throw new Error(`Property not found: ${String(Re)}`)}})}O.toService=B;function V(ee){return ee[0]==="o"&&ee[1]==="n"&&P.isUpperAsciiLetter(ee.charCodeAt(2))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let M=O.toString();if(M!=="[object Object]")return M}return O}function H(O){return Array.isArray(O)?O.map(N):N(O)}function F(O,M,B,V,ee,de,ye){ye=H(ye);const Fe=z[ee],Re=Fe[V%Fe.length];let Ne=[`%c[${O}]%c[${String(M).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${de}`,"color: darkgreen","color: grey","color: grey",`color: ${Re}`];/\($/.test(de)?(Ne=Ne.concat(ye),Ne.push(")")):Ne.push(ye),console.log.apply(console,Ne)}e.logWithColors=F;class x{constructor(M,B){this._outgoingPrefix=M,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,B,V,ee,de){this._totalOutgoing+=M,F(this._outgoingPrefix,this._totalOutgoing,M,B,V,ee,de)}logIncoming(M,B,V,ee,de){this._totalIncoming+=M,F(this._incomingPrefix,this._totalIncoming,M,B,V,ee,de)}}e.IPCLogger=x}),define(fe[104],me([0,1,3,103,6,23,11,37]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var E;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function n(){return C||(C=y.VSBuffer.alloc(0)),C}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,a){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const D=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=i),D}if(this._chunks[0].byteLength>i){const D=this._chunks[0].slice(0,i);return a&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),D}let v=y.VSBuffer.alloc(i),g=0,_=0;for(;i>0;){const D=this._chunks[_];if(D.byteLength>i){const o=D.slice(0,i);v.set(o,g),g+=i,a&&(this._chunks[_]=D.slice(i),this._totalLength-=i),i-=i}else v.set(D,g),g+=D.byteLength,a?(this._chunks.shift(),this._totalLength-=D.byteLength):_++,i-=D.byteLength}return v}}e.ChunkStream=P;var d;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(i,a,v,g){this.type=i,this.id=a,this.ack=v,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends k.Disposable{constructor(i){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const v=this._state.messageType,g=this._state.id,_=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new l(v,g,_,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.VSBuffer.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this._writeSoon(a,i.data)}_bufferAdd(i,a){const v=this._totalLength===0;return this._data.push(i,a),this._totalLength+=i.byteLength+a.byteLength,v}_bufferTake(){const i=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,a){this._bufferAdd(i,a)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends k.Disposable{constructor(i){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new l(1,0,0,i))}}e.Protocol=w;class b extends R.IPCClient{constructor(i,a,v=null){super(i,a,v);this.protocol=i}static fromSocket(i,a){return new b(new w(i),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=b;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class u{constructor(i){this.data=i,this.next=null}}class m{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],a=0,v=this._first;for(;v;)i[a++]=v.data,v=v.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const a=new u(i);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=i-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let g=0;g<t._HISTORY_LENGTH;g++)i-this.lastRuns[g]<=a&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(i,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new m,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=k.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new l(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const a=new l(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,a){this._isReconnecting=!0,this._socketDisposables=k.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let a=0,v=i.length;a<v;a++)this._socketWriter.write(i[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new l(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const a=this._outgoingUnackMsg.toArray();for(let v=0,g=a.length;v<g;v++)this._socketWriter.write(a[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new l(1,a,this._incomingAckId,i);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(i){const a=new l(2,0,0,i);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),a=Date.now()-i.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new l(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(fe[105],me([0,1,93]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(I){let E=p.toUint8(I);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(I){let E=new Uint8Array(256);for(let C=0;C<256;C++)E[C]=I;return E}set(I,E){let C=p.toUint8(E);I>=0&&I<256?this._asciiMap[I]=C:this._map.set(I,C)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class y{constructor(){this._actual=new R(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=y}),define(fe[139],me([0,1,105]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends p.CharacterClassifier{constructor(I){super(0);for(let E=0,C=I.length;E<C;E++)this.set(I.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function y(A){let I={};return E=>(I.hasOwnProperty(E)||(I[E]=A(E)),I[E])}e.getMapForWordSeparators=y(A=>new k(A))}),define(fe[44],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(k,y){this.lineNumber=k,this.column=y}with(k=this.lineNumber,y=this.column){return k===this.lineNumber&&y===this.column?this:new p(k,y)}delta(k=0,y=0){return this.with(this.lineNumber+k,this.column+y)}equals(k){return p.equals(this,k)}static equals(k,y){return!k&&!y?!0:!!k&&!!y&&k.lineNumber===y.lineNumber&&k.column===y.column}isBefore(k){return p.isBefore(this,k)}static isBefore(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<y.column}isBeforeOrEqual(k){return p.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<=y.column}static compare(k,y){let A=k.lineNumber|0,I=y.lineNumber|0;if(A===I){let E=k.column|0,C=y.column|0;return E-C}return A-I}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new p(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=p}),define(fe[40],me([0,1,44]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,A,I,E){y>I||y===I&&A>E?(this.startLineNumber=I,this.startColumn=E,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=I,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,A){let I,E,C,n;return A.startLineNumber<y.startLineNumber?(I=A.startLineNumber,E=A.startColumn):A.startLineNumber===y.startLineNumber?(I=A.startLineNumber,E=Math.min(A.startColumn,y.startColumn)):(I=y.startLineNumber,E=y.startColumn),A.endLineNumber>y.endLineNumber?(C=A.endLineNumber,n=A.endColumn):A.endLineNumber===y.endLineNumber?(C=A.endLineNumber,n=Math.max(A.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new R(I,E,C,n)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,A){let I=y.startLineNumber,E=y.startColumn,C=y.endLineNumber,n=y.endColumn,P=A.startLineNumber,d=A.startColumn,f=A.endLineNumber,l=A.endColumn;return I<P?(I=P,E=d):I===P&&(E=Math.max(E,d)),C>f?(C=f,n=l):C===f&&(n=Math.min(n,l)),I>C||I===C&&E>n?null:new R(I,E,C,n)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new p.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new p.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new R(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new R(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new R(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const C=y.startLineNumber|0,n=A.startLineNumber|0;if(C===n){const P=y.startColumn|0,d=A.startColumn|0;if(P===d){const f=y.endLineNumber|0,l=A.endLineNumber|0;if(f===l){const c=y.endColumn|0,S=A.endColumn|0;return c-S}return f-l}return P-d}return C-n}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(fe[140],me([0,1,44,40]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(I,E,C,n){super(I,E,C,n);this.selectionStartLineNumber=I,this.selectionStartColumn=E,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return y.selectionsEqual(this,I)}static selectionsEqual(I,E){return I.selectionStartLineNumber===E.selectionStartLineNumber&&I.selectionStartColumn===E.selectionStartColumn&&I.positionLineNumber===E.positionLineNumber&&I.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,E){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,I,E):new y(I,E,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,E){return this.getDirection()===0?new y(I,E,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,I,E)}static fromPositions(I,E=I){return new y(I.lineNumber,I.column,E.lineNumber,E.column)}static liftSelection(I){return new y(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,E){if(I&&!E||!I&&E)return!1;if(!I&&!E)return!0;if(I.length!==E.length)return!1;for(let C=0,n=I.length;C<n;C++)if(!this.selectionsEqual(I[C],E[C]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,E,C,n,P){return P===0?new y(I,E,C,n):new y(C,n,I,E)}}e.Selection=y}),define(fe[106],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(c){this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace)}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class E{constructor(c,S){this.range=c,this.matches=S}}e.FindMatch=E;var C;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class d{constructor(c,S,w,b,h,u){this.identifier=c,this.range=S,this.text=w,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=h,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class f{constructor(c,S,w){this.reverseEdits=c,this.changes=S,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=f}),define(fe[141],me([0,1,8,139,44,40,106]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class E{constructor(h,u,m,t){this.searchString=h,this.isRegex=u,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=C(this.searchString):h=this.searchString.indexOf(`
`)>=0;let u=null;try{u=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let m=!this.isRegex&&!h;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new n(u,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=E;function C(b){if(!b||b.length===0)return!1;for(let h=0,u=b.length;h<u;h++)if(b.charCodeAt(h)===92){if(h++,h>=u)break;const t=b.charCodeAt(h);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(h,u,m){this.regex=h,this.wordSeparators=u,this.simpleSearch=m}}e.SearchData=n;function P(b,h,u){if(!u)return new A.FindMatch(b,null);let m=[];for(let t=0,s=h.length;t<s;t++)m[t]=h[t];return new A.FindMatch(b,m)}e.createFindMatch=P;class d{constructor(h){let u=[],m=0;for(let t=0,s=h.length;t<s;t++)h.charCodeAt(t)===10&&(u[m++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(h){const u=this._lineFeedsOffsets;let m=0,t=u.length-1;if(t===-1||h<=u[0])return 0;for(;m<t;){const s=m+((t-m)/2>>0);u[s]>=h?t=s-1:u[s+1]>=h?(m=s,t=s):m=s+1}return m+1}}class f{static findMatches(h,u,m,t,s){const r=u.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(h,m,new w(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(h,m,r,t,s):[]}static _getMultilineMatchRange(h,u,m,t,s,r){let i,a=0;t?(a=t.findLineFeedCountBeforeOffset(s),i=u+s+a):i=u+s;let v;if(t){let o=t.findLineFeedCountBeforeOffset(s+r.length)-a;v=i+r.length+o}else v=i+r.length;const g=h.getPositionAt(i),_=h.getPositionAt(v);return new y.Range(g.lineNumber,g.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(h,u,m,t,s){const r=h.getOffsetAt(u.getStartPosition()),i=h.getValueInRange(u,1),a=h.getEOL()===`\r
`?new d(i):null,v=[];let g=0,_;for(m.reset(0);_=m.next(i);)if(v[g++]=P(this._getMultilineMatchRange(h,r,i,a,_.index,_[0]),_,t),g>=s)return v;return v}static _doFindMatchesLineByLine(h,u,m,t,s){const r=[];let i=0;if(u.startLineNumber===u.endLineNumber){const v=h.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return i=this._findMatchesInLine(m,v,u.startLineNumber,u.startColumn-1,i,r,t,s),r}const a=h.getLineContent(u.startLineNumber).substring(u.startColumn-1);i=this._findMatchesInLine(m,a,u.startLineNumber,u.startColumn-1,i,r,t,s);for(let v=u.startLineNumber+1;v<u.endLineNumber&&i<s;v++)i=this._findMatchesInLine(m,h.getLineContent(v),v,0,i,r,t,s);if(i<s){const v=h.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);i=this._findMatchesInLine(m,v,u.endLineNumber,0,i,r,t,s)}return r}static _findMatchesInLine(h,u,m,t,s,r,i,a){const v=h.wordSeparators;if(!i&&h.simpleSearch){const D=h.simpleSearch,o=D.length,T=u.length;let L=-o;for(;(L=u.indexOf(D,L+o))!==-1;)if((!v||S(v,u,T,L,o))&&(r[s++]=new A.FindMatch(new y.Range(m,L+1+t,m,L+1+o+t),null),s>=a))return s;return s}const g=new w(h.wordSeparators,h.regex);let _;g.reset(0);do if(_=g.next(u),_&&(r[s++]=P(new y.Range(m,_.index+1+t,m,_.index+1+_[0].length+t),_,i),s>=a))return s;while(_);return s}static findNextMatch(h,u,m,t){const s=u.parseSearchRequest();if(!s)return null;const r=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(h,m,r,t):this._doFindNextMatchLineByLine(h,m,r,t)}static _doFindNextMatchMultiline(h,u,m,t){const s=new k.Position(u.lineNumber,1),r=h.getOffsetAt(s),i=h.getLineCount(),a=h.getValueInRange(new y.Range(s.lineNumber,s.column,i,h.getLineMaxColumn(i)),1),v=h.getEOL()===`\r
`?new d(a):null;m.reset(u.column-1);let g=m.next(a);return g?P(this._getMultilineMatchRange(h,r,a,v,g.index,g[0]),g,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(h,new k.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(h,u,m,t){const s=h.getLineCount(),r=u.lineNumber,i=h.getLineContent(r),a=this._findFirstMatchInLine(m,i,r,u.column,t);if(a)return a;for(let v=1;v<=s;v++){const g=(r+v-1)%s,_=h.getLineContent(g+1),D=this._findFirstMatchInLine(m,_,g+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(h,u,m,t,s){h.reset(t-1);const r=h.next(u);return r?P(new y.Range(m,r.index+1,m,r.index+1+r[0].length),r,s):null}static findPreviousMatch(h,u,m,t){const s=u.parseSearchRequest();if(!s)return null;const r=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(h,m,r,t):this._doFindPreviousMatchLineByLine(h,m,r,t)}static _doFindPreviousMatchMultiline(h,u,m,t){const s=this._doFindMatchesMultiline(h,new y.Range(1,1,u.lineNumber,u.column),m,t,10*I);if(s.length>0)return s[s.length-1];const r=h.getLineCount();return u.lineNumber!==r||u.column!==h.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(h,new k.Position(r,h.getLineMaxColumn(r)),m,t):null}static _doFindPreviousMatchLineByLine(h,u,m,t){const s=h.getLineCount(),r=u.lineNumber,i=h.getLineContent(r).substring(0,u.column-1),a=this._findLastMatchInLine(m,i,r,t);if(a)return a;for(let v=1;v<=s;v++){const g=(s+r-v-1)%s,_=h.getLineContent(g+1),D=this._findLastMatchInLine(m,_,g+1,t);if(D)return D}return null}static _findLastMatchInLine(h,u,m,t){let s=null,r;for(h.reset(0);r=h.next(u);)s=P(new y.Range(m,r.index+1,m,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=f;function l(b,h,u,m,t){if(m===0)return!0;const s=h.charCodeAt(m-1);if(b.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=h.charCodeAt(m);if(b.get(r)!==0)return!0}return!1}function c(b,h,u,m,t){if(m+t===u)return!0;const s=h.charCodeAt(m+t);if(b.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=h.charCodeAt(m+t-1);if(b.get(r)!==0)return!0}return!1}function S(b,h,u,m,t){return l(b,h,u,m,t)&&c(b,h,u,m,t)}e.isValidMatch=S;class w{constructor(h,u){this._wordSeparators=h,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const u=h.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(m=this._searchRegex.exec(h),!m))return null;const t=m.index,s=m[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){p.getNextCodePoint(h,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||S(this._wordSeparators,h,u,t,s))return m}while(m);return null}}e.Searcher=w}),define(fe[107],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(I=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)I.indexOf(C)>=0||(E+="\\"+C);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=p();function R(I){let E=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)E=I;else{let C="g";I.ignoreCase&&(C+="i"),I.multiline&&(C+="m"),I.unicode&&(C+="u"),E=new RegExp(I.source,C)}return E.lastIndex=0,E}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function y(I,E,C,n,P=k){if(C.length>P.maxLen){let S=I-P.maxLen/2;return S<0?S=0:n+=S,C=C.substring(S,I+P.maxLen/2),y(I,E,C,n,P)}const d=Date.now(),f=I-1-n;let l=-1,c=null;for(let S=1;!(Date.now()-d>=P.timeBudget);S++){const w=f-P.windowSize*S;E.lastIndex=Math.max(0,w);const b=A(E,C,f,l);if(!b&&c||(c=b,w<=0))break;l=w}if(c){let S={word:c[0],startColumn:n+1+c.index,endColumn:n+1+c.index+c[0].length};return E.lastIndex=0,S}return null}e.getWordAtText=y;function A(I,E,C,n){let P;for(;P=I.exec(E);){const d=P.index||0;if(d<=C&&I.lastIndex>=C)return P;if(n>0&&d>n)return null}return null}}),define(fe[142],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class R{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let E=0,C=I.notIn.length;E<C;E++)switch(I.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of I)y(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),y(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),y(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),y(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&y(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=k;function y(A,I,E){A.has(I)?A.get(I).push(E):A.set(I,[E])}}),define(fe[75],me([0,1,30,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(y,A,I,E){if(Array.isArray(y)){let C=0;for(const n of y){const P=k(n,A,I,E);if(P===10)return P;P>C&&(C=P)}return C}else{if(typeof y=="string")return E?y==="*"?5:y===I?10:0:0;if(y){const{language:C,pattern:n,scheme:P,hasAccessToAllModels:d}=y;if(!E&&!d)return 0;let f=0;if(P)if(P===A.scheme)f=10;else if(P==="*")f=5;else return 0;if(C)if(C===I)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(n){let l;if(typeof n=="string"?l=n:l={...n,base:R.normalize(n.base)},l===A.fsPath||p.match(l,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=k}),define(fe[143],me([0,1,105]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(l,c,S){const w=new Uint8Array(l*c);for(let b=0,h=l*c;b<h;b++)w[b]=S;this._data=w,this.rows=l,this.cols=c}get(l,c){return this._data[l*this.cols+c]}set(l,c,S){this._data[l*this.cols+c]=S}}e.Uint8Matrix=k;class y{constructor(l){let c=0,S=0;for(let b=0,h=l.length;b<h;b++){let[u,m,t]=l[b];m>c&&(c=m),u>S&&(S=u),t>S&&(S=t)}c++,S++;let w=new k(S,c,0);for(let b=0,h=l.length;b<h;b++){let[u,m,t]=l[b];w.set(u,m,t)}this._states=w,this._maxCharCode=c}nextState(l,c){return c<0||c>=this._maxCharCode?0:this._states.get(l,c)}}e.StateMachine=y;let A=null;function I(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let C=null;function n(){if(C===null){C=new p.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<f.length;c++)C.set(f.charCodeAt(c),1);const l=".,;";for(let c=0;c<l.length;c++)C.set(l.charCodeAt(c),2)}return C}class P{static _createLink(l,c,S,w,b){let h=b-1;do{const u=c.charCodeAt(h);if(l.get(u)!==2)break;h--}while(h>w);if(w>0){const u=c.charCodeAt(w-1),m=c.charCodeAt(h);(u===40&&m===41||u===91&&m===93||u===123&&m===125)&&h--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:h+2},url:c.substring(w,h+1)}}static computeLinks(l,c=I()){const S=n();let w=[];for(let b=1,h=l.getLineCount();b<=h;b++){const u=l.getLineContent(b),m=u.length;let t=0,s=0,r=0,i=1,a=!1,v=!1,g=!1,_=!1;for(;t<m;){let D=!1;const o=u.charCodeAt(t);if(i===13){let T;switch(o){case 40:a=!0,T=0;break;case 41:T=a?0:1;break;case 91:g=!0,v=!0,T=0;break;case 93:g=!1,T=v?0:1;break;case 123:_=!0,T=0;break;case 125:T=_?0:1;break;case 39:T=r===34||r===96?0:1;break;case 34:T=r===39||r===96?0:1;break;case 96:T=r===39||r===34?0:1;break;case 42:T=r===42?1:0;break;case 124:T=r===124?1:0;break;case 32:T=g?0:1;break;default:T=S.get(o)}T===1&&(w.push(P._createLink(S,u,b,s,t)),D=!0)}else if(i===12){let T;o===91?(v=!0,T=0):T=S.get(o),T===1?D=!0:i=13}else i=c.nextState(i,o),i===0&&(D=!0);D&&(i=1,a=!1,v=!1,_=!1,s=t+1,r=o),t++}i===13&&w.push(P._createLink(S,u,b,s,m))}return w}}e.LinkComputer=P;function d(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:P.computeLinks(f)}e.computeLinks=d}),define(fe[144],me([0,1,3,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,I){return this._map.set(A,I),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===I&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,I){let E=null,C=!1;return this._promises.set(A,I.then(n=>{this._promises.delete(A),!(C||!n)&&(E=this.register(A,n))})),R.toDisposable(()=>{C=!0,E&&E.dispose()})}getPromise(A){const I=this.get(A);if(I)return Promise.resolve(I);const E=this._promises.get(A);return E?E.then(C=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(fe[108],me([0,1,23,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function y(P){for(let d=0,f=P.length;d<f;d+=4){const l=P[d+0],c=P[d+1],S=P[d+2],w=P[d+3];P[d+0]=w,P[d+1]=S,P[d+2]=c,P[d+3]=l}}function A(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||y(d),p.VSBuffer.wrap(d)}function I(P){const d=P.buffer;if(R.isLittleEndian()||y(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const f=new Uint8Array(d.byteLength);return f.set(d),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function E(P){const d=new Uint32Array(C(P));let f=0;if(d[f++]=P.id,P.type==="full")d[f++]=1,d[f++]=P.data.length,d.set(P.data,f),f+=P.data.length;else{d[f++]=2,d[f++]=P.deltas.length;for(const l of P.deltas)d[f++]=l.start,d[f++]=l.deleteCount,l.data?(d[f++]=l.data.length,d.set(l.data,f),f+=l.data.length):d[f++]=0}return A(d)}e.encodeSemanticTokensDto=E;function C(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const f of P.deltas)f.data&&(d+=f.data.length)}return d}function n(P){const d=I(P);let f=0;const l=d[f++];if(d[f++]===1){const b=d[f++],h=d.subarray(f,f+b);return f+=b,{id:l,type:"full",data:h}}const S=d[f++];let w=[];for(let b=0;b<S;b++){const h=d[f++],u=d[f++],m=d[f++];let t;m>0&&(t=d.subarray(f,f+m),f+=m),w[b]={start:h,deleteCount:u,data:t}}return{id:l,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(fe[109],me([0,1,93]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,I){this.index=A,this.remainder=I}}e.PrefixSumIndexOfResult=R;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,I){A=p.toUint32(A);const E=this.values,C=this.prefixSum,n=I.length;return n===0?!1:(this.values=new Uint32Array(E.length+n),this.values.set(E.subarray(0,A),0),this.values.set(E.subarray(A),A+n),this.values.set(I,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,I){return A=p.toUint32(A),I=p.toUint32(I),this.values[A]===I?!1:(this.values[A]=I,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,I){A=p.toUint32(A),I=p.toUint32(I);const E=this.values,C=this.prefixSum;if(A>=E.length)return!1;let n=E.length-A;return I>=n&&(I=n),I===0?!1:(this.values=new Uint32Array(E.length-I),this.values.set(E.subarray(0,A),0),this.values.set(E.subarray(A+I),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=p.toUint32(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),A>=this.values.length&&(A=this.values.length-1);for(let E=I;E<=A;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let I=0,E=this.values.length-1,C=0,n=0,P=0;for(;I<=E;)if(C=I+(E-I)/2|0,n=this.prefixSum[C],P=n-this.values[C],A<P)E=C-1;else if(A>=n)I=C+1;else break;return new R(C,A-P)}}e.PrefixSumComputer=k}),define(fe[145],me([0,1,8,44,109]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(I,E,C,n){this._uri=I,this._lines=E,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const E=I.changes;for(const C of E)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,E=this._lines.length,C=new Uint32Array(E);for(let n=0;n<E;n++)C[n]=this._lines[n].length+I;this._lineStarts=new k.PrefixSumComputer(C)}}_setLineText(I,E){this._lines[I]=E,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,E){if(E.length===0)return;let C=p.splitLines(E);if(C.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+C[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}C[C.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this._lines.splice(I.lineNumber+P-1,0,C[P]),n[P-1]=C[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,n)}}e.MirrorTextModel=y}),define(fe[146],me([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(fe[147],me([0,1,146]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,y=k*24,A=y*7,I=y*30,E=y*365;function C(P,d){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return p.localize(0,null,C(new Date().getTime()+f*1e3,!1));if(f<30)return p.localize(1,null);let l;return f<R?(l=f,d?l===1?p.localize(2,null,l):p.localize(3,null,l):l===1?p.localize(4,null,l):p.localize(5,null,l)):f<k?(l=Math.floor(f/R),d?l===1?p.localize(6,null,l):p.localize(7,null,l):l===1?p.localize(8,null,l):p.localize(9,null,l)):f<y?(l=Math.floor(f/k),d?l===1?p.localize(10,null,l):p.localize(11,null,l):l===1?p.localize(12,null,l):p.localize(13,null,l)):f<A?(l=Math.floor(f/y),d?l===1?p.localize(14,null,l):p.localize(15,null,l):l===1?p.localize(16,null,l):p.localize(17,null,l)):f<I?(l=Math.floor(f/A),d?l===1?p.localize(18,null,l):p.localize(19,null,l):l===1?p.localize(20,null,l):p.localize(21,null,l)):f<E?(l=Math.floor(f/I),d?l===1?p.localize(22,null,l):p.localize(23,null,l):l===1?p.localize(24,null,l):p.localize(25,null,l)):(l=Math.floor(f/E),d?l===1?p.localize(26,null,l):p.localize(27,null,l):l===1?p.localize(28,null,l):p.localize(29,null,l))}e.fromNow=C;function n(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(fe[148],me([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(fe[58],me([0,1,148,14,17]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?p.localize(0,null,I(C),A(C.stack)||A(C.stacktrace)):I(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function I(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?p.localize(1,null,C.message):C.message||p.localize(2,null)}function E(C=null,n=!1){if(!C)return p.localize(3,null);if(Array.isArray(C)){const P=k.coalesce(C),d=E(P[0],n);return P.length>1?p.localize(4,null,d,P.length):d}if(R.isString(C))return C;if(C.detail){const P=C.detail;if(P.error)return y(P.error,n);if(P.exception)return y(P.exception,n)}return C.stack?y(C,n):C.message?C.message:p.localize(5,null)}e.toErrorMessage=E}),define(fe[149],me([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(fe[110],me([0,1,9,28,38,149,37,14,25,29,11,138,10]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(u,m){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};m&&(t.cwd=m);const s=k.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],t);return new Promise(r=>{s.once("error",i=>{r({success:!1,error:i})}),s.once("exit",(i,a)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(s=>{k.execFile(t,[u.pid.toString()],{encoding:"utf8",shell:!0},(r,i,a)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function c(u=A.env){return u.comspec||"cmd.exe"}e.getWindowsShell=c;class S{constructor(m,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=m,this.args=t,this.shell=s,this.options=r;else{const i=m;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(A.env).forEach(a=>{i[a]=A.env[a]}),Object.keys(this.options.env).forEach(a=>{i[a]=this.options.env[a]}),this.options.env=i}}getSanitizedCommand(){let m=this.cmd.toLowerCase();const t=m.lastIndexOf(p.sep);return t!==-1&&(m=m.substring(t+1)),S.WellKnowCommands[m]?m:"other"}start(m){return n.isWindows&&(this.options&&this.options.cwd&&C.isUNC(this.options.cwd)||!this.options&&C.isUNC(A.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let s,r;const i=new Promise((a,v)=>{s=a,r=v});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(v,g,_)=>{this.childProcess=null;const D=v;D&&D.killed?r({killed:this.terminateRequested,stdout:g.toString(),stderr:_.toString()}):this.handleExec(s,m,v,g,_)})}else{let a=null;const v=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,s,m,r);const _={terminated:this.terminateRequested};I.isNumber(g)&&(_.cmdCode=g),s(_)};if(this.shell&&n.isWindows){const g=E.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let _=!1,D=!1;const o=[];let T=this.ensureQuotes(this.cmd);o.push(T.value),_=T.quoted,this.args&&this.args.forEach($=>{T=this.ensureQuotes($),o.push(T.value),D=D&&T.quoted});const L=["/s","/c"];_?D?L.push('"'+o.join(" ")+'"'):o.length>1?L.push('"'+o[0]+'" '+o.slice(1).join(" ")):L.push('"'+o[0]+'"'):L.push(o.join(" ")),a=k.spawn(c(),L,g)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(I.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",g=>{this.childProcess=null,r({terminated:this.terminateRequested,error:g})}),a.pid&&(this.childProcess.on("close",v),this.handleSpawn(a,s,m,r,!0)))}return i})}handleClose(m,t,s,r){}ensureQuotes(m){return S.regexp.test(m)?{value:'"'+m+'"',quoted:!0}:{value:m,quoted:m.length>0&&m[0]==='"'&&m[m.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(m=>m.pid,m=>-1):new Promise(m=>{this.pidResolve=m})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(m=>(this.terminateRequested=!0,l(m,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),m=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(m=>{if(!this.shell||!n.isWindows)return m(!1);const t=k.spawn(c(),["/s","/c"]);t.on("error",s=>m(!0)),t.on("exit",s=>m(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(m,t,s,r){super(m,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(m,t,s,r,i){[r,i].forEach((a,v)=>{const g=new P.LineDecoder;g.write(a).forEach(o=>{t({line:o,source:v===0?0:1})});const D=g.end();D&&t({line:D,source:v===0?0:1})}),m({terminated:this.terminateRequested,error:s})}handleSpawn(m,t,s,r,i){const a=new P.LineDecoder,v=new P.LineDecoder;m.stdout.on("data",g=>{a.write(g).forEach(D=>s({line:D,source:0}))}),m.stderr.on("data",g=>{v.write(g).forEach(D=>s({line:D,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=v}handleClose(m,t,s,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&s({line:i,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&s({line:a,source:1})}}e.LineProcess=w;function b(u){let m=[],t=!1;const s=function(r){if(t){m.push(r);return}(!u.send(r,a=>{if(a&&console.error(a),t=!1,m.length>0){const v=m.slice(0);m=[],v.forEach(g=>s(g))}})||n.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=b;var h;(function(u){async function m(t,s,r){if(p.isAbsolute(t))return t;if(s===void 0&&(s=A.cwd()),p.dirname(t)!=="."||(r===void 0&&I.isString(A.env.PATH)&&(r=A.env.PATH.split(p.delimiter)),r===void 0||r.length===0))return p.join(s,t);async function a(v){return await R.Promises.exists(v)?!(await R.Promises.stat(v)).isDirectory():!1}for(let v of r){let g;if(p.isAbsolute(v)?g=p.join(v,t):g=p.join(s,v,t),await a(g))return g;let _=g+".com";if(await a(_)||(_=g+".exe",await a(_)))return _}return p.join(s,t)}u.findExecutable=m})(h=e.win32||(e.win32={}))}),define(fe[150],me([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(fe[151],me([0,1,150,11,107]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=A;class I{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,he){this._values[ie]=he}}e.ValidatedEditorOptions=I;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class C{constructor(ie,he,xe,$e){this.id=ie,this.name=he,this.defaultValue=xe,this.schema=$e}compute(ie,he,xe){return xe}}class n{constructor(ie,he=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(ie){return this.defaultValue}}class P{constructor(ie,he,xe,$e){this.id=ie,this.name=he,this.defaultValue=xe,this.schema=$e}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,he,xe){return xe}}function d(K,ie){return typeof K=="undefined"?ie:K==="false"?!1:Boolean(K)}e.boolean=d;class f extends P{constructor(ie,he,xe,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=xe),super(ie,he,xe,$e)}validate(ie){return d(ie,this.defaultValue)}}class l extends P{constructor(ie,he,xe,$e,et,ke=void 0){typeof ke!="undefined"&&(ke.type="integer",ke.default=xe,ke.minimum=$e,ke.maximum=et),super(ie,he,xe,ke),this.minimum=$e,this.maximum=et}static clampedInt(ie,he,xe,$e){if(typeof ie=="undefined")return he;let et=parseInt(ie,10);return isNaN(et)?he:(et=Math.max(xe,et),et=Math.min($e,et),et|0)}validate(ie){return l.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class c extends P{constructor(ie,he,xe,$e,et){typeof et!="undefined"&&(et.type="number",et.default=xe),super(ie,he,xe,et),this.validationFn=$e}static clamp(ie,he,xe){return ie<he?he:ie>xe?xe:ie}static float(ie,he){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return he;const xe=parseFloat(ie);return isNaN(xe)?he:xe}validate(ie){return this.validationFn(c.float(ie,this.defaultValue))}}class S extends P{static string(ie,he){return typeof ie!="string"?he:ie}constructor(ie,he,xe,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=xe),super(ie,he,xe,$e)}validate(ie){return S.string(ie,this.defaultValue)}}function w(K,ie,he){return typeof K!="string"||he.indexOf(K)===-1?ie:K}e.stringSet=w;class b extends P{constructor(ie,he,xe,$e,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=$e,et.default=xe),super(ie,he,xe,et),this._allowedValues=$e}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class h extends C{constructor(ie,he,xe,$e,et,ke,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.enum=et,Ce.default=$e),super(ie,he,xe,Ce),this._allowedValues=et,this._convert=ke}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function u(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,he,xe){return xe===0?ie.accessibilitySupport:xe}}class t extends C{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{insertSpace:d(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(K){switch(K){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function v(K){switch(K){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class g extends n{constructor(){super(125,[63,31])}compute(ie,he,xe){const $e=["monaco-editor"];return he.get(31)&&$e.push(he.get(31)),ie.extraEditorClassName&&$e.push(ie.extraEditorClassName),he.get(63)==="default"?$e.push("mouse-default"):he.get(63)==="copy"&&$e.push("mouse-copy"),he.get(98)&&$e.push("showUnused"),he.get(123)&&$e.push("showDeprecated"),$e.join(" ")}}class _ extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ie,he,xe){return xe&&ie.emptySelectionClipboard}}class D extends C{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:p.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:p.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{cursorMoveOnType:d(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(he.loop,this.defaultValue.loop)}}}class o extends C{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?o.OFF:ie==="true"?o.ON:ie:Boolean(ie)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class T extends n{constructor(){super(40)}compute(ie,he,xe){return ie.fontInfo}}class L extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(ie){let he=c.float(ie,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(he,6,100)}compute(ie,he,xe){return ie.fontInfo.fontSize}}class $ extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(l.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class W extends C{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(26,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(27,null),...he},"editor.gotoLocation.multipleDeclarations":{description:p.localize(28,null),...he},"editor.gotoLocation.multipleImplementations":{description:p.localize(29,null),...he},"editor.gotoLocation.multipleReferences":{description:p.localize(30,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:xe,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:xe,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:xe,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:xe,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:xe,description:p.localize(35,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{multiple:w(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??w(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??w(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??w(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??w(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??w(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends C{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:p.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{enabled:d(he.enabled,this.defaultValue.enabled),delay:l.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:d(he.sticky,this.defaultValue.sticky)}}}var z;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class N extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ie,he,xe){return N.computeLayout(he,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const he=ie.height/ie.lineHeight,xe=ie.scrollBeyondLastLine?he-1:0,$e=(ie.viewLineCount+xe)/(ie.pixelRatio*ie.height),et=Math.floor(ie.viewLineCount/$e);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:xe,desiredRatio:$e,minimapLineCount:et}}static _computeMinimapLayout(ie,he){const xe=ie.outerWidth,$e=ie.outerHeight,et=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const ke=he.stableMinimapLayoutInput,Ce=ke&&ie.outerHeight===ke.outerHeight&&ie.lineHeight===ke.lineHeight&&ie.typicalHalfwidthCharacterWidth===ke.typicalHalfwidthCharacterWidth&&ie.pixelRatio===ke.pixelRatio&&ie.scrollBeyondLastLine===ke.scrollBeyondLastLine&&ie.minimap.enabled===ke.minimap.enabled&&ie.minimap.side===ke.minimap.side&&ie.minimap.size===ke.minimap.size&&ie.minimap.showSlider===ke.minimap.showSlider&&ie.minimap.renderCharacters===ke.minimap.renderCharacters&&ie.minimap.maxColumn===ke.minimap.maxColumn&&ie.minimap.scale===ke.minimap.scale&&ie.verticalScrollbarWidth===ke.verticalScrollbarWidth&&ie.isViewportWrapping===ke.isViewportWrapping,Pe=ie.lineHeight,oe=ie.typicalHalfwidthCharacterWidth,ce=ie.scrollBeyondLastLine,ge=ie.minimap.renderCharacters;let we=et>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const G=ie.minimap.maxColumn,pe=ie.minimap.size,_e=ie.minimap.side,Ae=ie.verticalScrollbarWidth,Me=ie.viewLineCount,je=ie.remainingWidth,tt=ie.isViewportWrapping,Xe=ge?2:3;let Ye=Math.floor(et*$e);const lt=Ye/et;let ut=!1,Ee=!1,Se=Xe*we,le=we/et,Y=1;if(pe==="fill"||pe==="fit"){const{typicalViewportLineCount:wt,extraLinesBeyondLastLine:bt,desiredRatio:Et,minimapLineCount:yt}=N.computeContainedMinimapLineCount({viewLineCount:Me,scrollBeyondLastLine:ce,height:$e,lineHeight:Pe,pixelRatio:et});if(Me/yt>1)ut=!0,Ee=!0,we=1,Se=1,le=we/et;else{let _t=!1,dt=we+1;if(pe==="fit"){const vt=Math.ceil((Me+bt)*Se);tt&&Ce&&je<=he.stableFitRemainingWidth?(_t=!0,dt=he.stableFitMaxMinimapScale):_t=vt>Ye}if(pe==="fill"||_t){ut=!0;const vt=we;Se=Math.min(Pe*et,Math.max(1,Math.floor(1/Et))),tt&&Ce&&je<=he.stableFitRemainingWidth&&(dt=he.stableFitMaxMinimapScale),we=Math.min(dt,Math.max(1,Math.floor(Se/Xe))),we>vt&&(Y=Math.min(2,we/vt)),le=we/et/Y,Ye=Math.ceil(Math.max(wt,Me+bt)*Se),tt?(he.stableMinimapLayoutInput=ie,he.stableFitRemainingWidth=je,he.stableFitMaxMinimapScale=we):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Be=Math.floor(G*le),De=Math.min(Be,Math.max(0,Math.floor((je-Ae-2)*le/(oe+le)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(et*De);const Ke=Ze/et;Ze=Math.floor(Ze*Y);const rt=ge?1:2,ft=_e==="left"?0:xe-De-Ae;return{renderMinimap:rt,minimapLeft:ft,minimapWidth:De,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ee,minimapScale:we,minimapLineHeight:Se,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:Ye,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:lt}}static computeLayout(ie,he){const xe=he.outerWidth|0,$e=he.outerHeight|0,et=he.lineHeight|0,ke=he.lineNumbersDigitCount|0,Ce=he.typicalHalfwidthCharacterWidth,Pe=he.maxDigitWidth,oe=he.pixelRatio,ce=he.viewLineCount,ge=ie.get(120),we=ge==="inherit"?ie.get(119):ge,G=we==="inherit"?ie.get(115):we,pe=ie.get(118),_e=ie.get(2),Ae=he.isDominatedByLongLines,Me=ie.get(46),je=ie.get(57).renderType!==0,tt=ie.get(58),Xe=ie.get(92),Ye=ie.get(62),lt=ie.get(90),ut=lt.verticalScrollbarSize,Ee=lt.verticalHasArrows,Se=lt.arrowSize,le=lt.horizontalScrollbarSize,Y=ie.get(55),Be=ie.get(35);let De;if(typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)){const Pt=parseFloat(Y.substr(0,Y.length-2));De=l.clampedInt(Pt*Ce,0,0,1e3)}else De=l.clampedInt(Y,0,0,1e3);Be&&(De+=16);let Ze=0;if(je){const Pt=Math.max(ke,tt);Ze=Math.round(Pt*Pe)}let Ke=0;Me&&(Ke=et);let rt=0,ft=rt+Ke,wt=ft+Ze,bt=wt+De;const Et=xe-Ke-Ze-De;let yt=!1,kt=!1,_t=-1;_e!==2&&(we==="inherit"&&Ae?(yt=!0,kt=!0):G==="on"||G==="bounded"?kt=!0:G==="wordWrapColumn"&&(_t=pe));const dt=N._computeMinimapLayout({outerWidth:xe,outerHeight:$e,lineHeight:et,typicalHalfwidthCharacterWidth:Ce,pixelRatio:oe,scrollBeyondLastLine:Xe,minimap:Ye,verticalScrollbarWidth:ut,viewLineCount:ce,remainingWidth:Et,isViewportWrapping:kt},he.memory||new E);dt.renderMinimap!==0&&dt.minimapLeft===0&&(rt+=dt.minimapWidth,ft+=dt.minimapWidth,wt+=dt.minimapWidth,bt+=dt.minimapWidth);const vt=Et-dt.minimapWidth,ht=Math.max(1,Math.floor((vt-ut-2)/Ce)),xt=Ee?Se:0;return kt&&(_t=Math.max(1,ht),G==="bounded"&&(_t=Math.min(_t,pe))),{width:xe,height:$e,glyphMarginLeft:rt,glyphMarginWidth:Ke,lineNumbersLeft:ft,lineNumbersWidth:Ze,decorationsLeft:wt,decorationsWidth:De,contentLeft:bt,contentWidth:vt,minimap:dt,viewportColumn:ht,isWordWrapMinified:yt,isViewportWrapping:kt,wrappingColumn:_t,verticalScrollbarWidth:ut,horizontalScrollbarHeight:le,overviewRuler:{top:xt,width:ut,height:$e-2*xt,right:0}}}}e.EditorLayoutInfoComputer=N;class H extends C{constructor(){const ie={enabled:!0};super(54,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:p.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:d(ie.enabled,this.defaultValue.enabled)}}}class F extends C{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:p.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{enabled:d(he.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(he.fontFamily,this.defaultValue.fontFamily)}}}class x extends c{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>c.clamp(ie,0,150),{markdownDescription:p.localize(43,null)})}compute(ie,he,xe){return ie.fontInfo.lineHeight}}class O extends C{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:ie.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:p.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{enabled:d(he.enabled,this.defaultValue.enabled),size:w(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(he.side,this.defaultValue.side,["right","left"]),showSlider:w(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(he.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(he.scale,1,1,3),maxColumn:l.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(K){return K==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{top:l.clampedInt(he.top,0,0,1e3),bottom:l.clampedInt(he.bottom,0,0,1e3)}}}class V extends C{constructor(){const ie={enabled:!0,cycle:!1};super(73,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:p.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{enabled:d(he.enabled,this.defaultValue.enabled),cycle:d(he.cycle,this.defaultValue.cycle)}}}class ee extends n{constructor(){super(126)}compute(ie,he,xe){return ie.pixelRatio}}class de extends C{constructor(){const ie={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:p.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:p.localize(59,null)},other:{type:"boolean",default:ie.other,description:p.localize(60,null)}}}],default:ie,description:p.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const he=ie,xe={other:d(he.other,this.defaultValue.other),comments:d(he.comments,this.defaultValue.comments),strings:d(he.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ye;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(ie){let he=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(he=4,xe=ie):ie==="interval"?he=3:ie==="relative"?he=2:ie==="on"?he=1:he=0),{renderType:he,renderFn:xe}}}function Re(K){const ie=K.get(85);return ie==="editable"?K.get(78):ie!=="on"}e.filterValidationDecorations=Re;class Ne extends C{constructor(){const ie=[],he={type:"number",description:p.localize(67,null)};super(89,"rulers",ie,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:ie,description:p.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let he=[];for(let xe of ie)if(typeof xe=="number")he.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const $e=xe;he.push({column:l.clampedInt($e.column,0,0,1e4),color:$e.color})}return he.sort((xe,$e)=>xe.column-$e.column),he}return this.defaultValue}}function Ge(K,ie){if(typeof K!="string")return ie;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie,xe=l.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=l.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ge(he.vertical,this.defaultValue.vertical),horizontal:Ge(he.horizontal,this.defaultValue.horizontal),useShadows:d(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(he.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:l.clampedInt(he.verticalSliderSize,$e,0,1e3),scrollByPage:d(he.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends C{constructor(){const ie={enabled:!1,mode:"prefix"};super(52,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:p.localize(70,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[p.localize(71,null),p.localize(72,null)],default:ie.mode,description:p.localize(73,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{enabled:d(he.enabled,this.defaultValue.enabled),mode:w(he.mode,this.defaultValue.mode,["prefix","subwordDiff"])}}}class q extends C{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordDiff",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(74,null),p.localize(75,null)],default:ie.insertMode,description:p.localize(76,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:p.localize(77,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:p.localize(78,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:p.localize(79,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:p.localize(80,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:p.localize(81,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:p.localize(82,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:p.localize(83,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[p.localize(84,null),p.localize(85,null)],default:ie.previewMode,description:p.localize(86,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:p.localize(87,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(88,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(89,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const he=ie;return{insertMode:w(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(he.showIcons,this.defaultValue.showIcons),showStatusBar:d(he.showStatusBar,this.defaultValue.showStatusBar),preview:d(he.preview,this.defaultValue.preview),previewMode:w(he.previewMode,this.defaultValue.previewMode,["prefix","subwordDiff"]),showInlineDetails:d(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(he.showMethods,this.defaultValue.showMethods),showFunctions:d(he.showFunctions,this.defaultValue.showFunctions),showConstructors:d(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(he.showDeprecated,this.defaultValue.showDeprecated),showFields:d(he.showFields,this.defaultValue.showFields),showVariables:d(he.showVariables,this.defaultValue.showVariables),showClasses:d(he.showClasses,this.defaultValue.showClasses),showStructs:d(he.showStructs,this.defaultValue.showStructs),showInterfaces:d(he.showInterfaces,this.defaultValue.showInterfaces),showModules:d(he.showModules,this.defaultValue.showModules),showProperties:d(he.showProperties,this.defaultValue.showProperties),showEvents:d(he.showEvents,this.defaultValue.showEvents),showOperators:d(he.showOperators,this.defaultValue.showOperators),showUnits:d(he.showUnits,this.defaultValue.showUnits),showValues:d(he.showValues,this.defaultValue.showValues),showConstants:d(he.showConstants,this.defaultValue.showConstants),showEnums:d(he.showEnums,this.defaultValue.showEnums),showEnumMembers:d(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(he.showKeywords,this.defaultValue.showKeywords),showWords:d(he.showWords,this.defaultValue.showWords),showColors:d(he.showColors,this.defaultValue.showColors),showFiles:d(he.showFiles,this.defaultValue.showFiles),showReferences:d(he.showReferences,this.defaultValue.showReferences),showFolders:d(he.showFolders,this.defaultValue.showFolders),showTypeParameters:d(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(he.showSnippets,this.defaultValue.showSnippets),showUsers:d(he.showUsers,this.defaultValue.showUsers),showIssues:d(he.showIssues,this.defaultValue.showIssues)}}}class Z extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(119,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class re extends n{constructor(){super(127,[78])}compute(ie,he,xe){return he.get(78)?!0:ie.tabFocusMode}}var ae;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function J(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class se extends n{constructor(){super(129,[128])}compute(ie,he,xe){const $e=he.get(128);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const ve="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Le:R.isLinux?He:ve,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(K){return e.editorOptionsRegistry[K.id]=K,K}var Je;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.inlineSuggest=52]="inlineSuggest",K[K.letterSpacing=53]="letterSpacing",K[K.lightbulb=54]="lightbulb",K[K.lineDecorationsWidth=55]="lineDecorationsWidth",K[K.lineHeight=56]="lineHeight",K[K.lineNumbers=57]="lineNumbers",K[K.lineNumbersMinChars=58]="lineNumbersMinChars",K[K.linkedEditing=59]="linkedEditing",K[K.links=60]="links",K[K.matchBrackets=61]="matchBrackets",K[K.minimap=62]="minimap",K[K.mouseStyle=63]="mouseStyle",K[K.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=65]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",K[K.multiCursorModifier=67]="multiCursorModifier",K[K.multiCursorPaste=68]="multiCursorPaste",K[K.occurrencesHighlight=69]="occurrencesHighlight",K[K.overviewRulerBorder=70]="overviewRulerBorder",K[K.overviewRulerLanes=71]="overviewRulerLanes",K[K.padding=72]="padding",K[K.parameterHints=73]="parameterHints",K[K.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",K[K.quickSuggestions=76]="quickSuggestions",K[K.quickSuggestionsDelay=77]="quickSuggestionsDelay",K[K.readOnly=78]="readOnly",K[K.renameOnType=79]="renameOnType",K[K.renderControlCharacters=80]="renderControlCharacters",K[K.renderIndentGuides=81]="renderIndentGuides",K[K.renderFinalNewline=82]="renderFinalNewline",K[K.renderLineHighlight=83]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=85]="renderValidationDecorations",K[K.renderWhitespace=86]="renderWhitespace",K[K.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",K[K.roundedSelection=88]="roundedSelection",K[K.rulers=89]="rulers",K[K.scrollbar=90]="scrollbar",K[K.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=92]="scrollBeyondLastLine",K[K.scrollPredominantAxis=93]="scrollPredominantAxis",K[K.selectionClipboard=94]="selectionClipboard",K[K.selectionHighlight=95]="selectionHighlight",K[K.selectOnLineNumbers=96]="selectOnLineNumbers",K[K.showFoldingControls=97]="showFoldingControls",K[K.showUnused=98]="showUnused",K[K.snippetSuggestions=99]="snippetSuggestions",K[K.smartSelect=100]="smartSelect",K[K.smoothScrolling=101]="smoothScrolling",K[K.stickyTabStops=102]="stickyTabStops",K[K.stopRenderingLineAfter=103]="stopRenderingLineAfter",K[K.suggest=104]="suggest",K[K.suggestFontSize=105]="suggestFontSize",K[K.suggestLineHeight=106]="suggestLineHeight",K[K.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",K[K.suggestSelection=108]="suggestSelection",K[K.tabCompletion=109]="tabCompletion",K[K.tabIndex=110]="tabIndex",K[K.unusualLineTerminators=111]="unusualLineTerminators",K[K.useShadowDOM=112]="useShadowDOM",K[K.useTabStops=113]="useTabStops",K[K.wordSeparators=114]="wordSeparators",K[K.wordWrap=115]="wordWrap",K[K.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=118]="wordWrapColumn",K[K.wordWrapOverride1=119]="wordWrapOverride1",K[K.wordWrapOverride2=120]="wordWrapOverride2",K[K.wrappingIndent=121]="wrappingIndent",K[K.wrappingStrategy=122]="wrappingStrategy",K[K.showDeprecated=123]="showDeprecated",K[K.inlayHints=124]="inlayHints",K[K.editorClassName=125]="editorClassName",K[K.pixelRatio=126]="pixelRatio",K[K.tabFocusMode=127]="tabFocusMode",K[K.layoutInfo=128]="layoutInfo",K[K.wrappingInfo=129]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(120,null)})),acceptSuggestionOnEnter:be(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(121,null),""],markdownDescription:p.localize(122,null)})),accessibilitySupport:be(new m),accessibilityPageSize:be(new l(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(123,null)})),ariaLabel:be(new S(4,"ariaLabel",p.localize(124,null))),autoClosingBrackets:be(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(125,null),p.localize(126,null),""],description:p.localize(127,null)})),autoClosingDelete:be(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(128,null),""],description:p.localize(129,null)})),autoClosingOvertype:be(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(130,null),""],description:p.localize(131,null)})),autoClosingQuotes:be(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(132,null),p.localize(133,null),""],description:p.localize(134,null)})),autoIndent:be(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null),p.localize(138,null),p.localize(139,null)],description:p.localize(140,null)})),automaticLayout:be(new f(10,"automaticLayout",!1)),autoSurround:be(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(141,null),p.localize(142,null),p.localize(143,null),""],description:p.localize(144,null)})),stickyTabStops:be(new f(102,"stickyTabStops",!1,{description:p.localize(145,null)})),codeLens:be(new f(12,"codeLens",!0,{description:p.localize(146,null)})),codeLensFontFamily:be(new S(13,"codeLensFontFamily","",{description:p.localize(147,null)})),codeLensFontSize:be(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(148,null)})),colorDecorators:be(new f(15,"colorDecorators",!0,{description:p.localize(149,null)})),columnSelection:be(new f(16,"columnSelection",!1,{description:p.localize(150,null)})),comments:be(new t),contextmenu:be(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(151,null)})),cursorBlinking:be(new h(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:p.localize(152,null)})),cursorSmoothCaretAnimation:be(new f(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(153,null)})),cursorStyle:be(new h(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:p.localize(154,null)})),cursorSurroundingLines:be(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(155,null)})),cursorSurroundingLinesStyle:be(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(156,null),p.localize(157,null)],description:p.localize(158,null)})),cursorWidth:be(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(159,null)})),disableLayerHinting:be(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new f(28,"domReadOnly",!1)),dragAndDrop:be(new f(29,"dragAndDrop",!0,{description:p.localize(160,null)})),emptySelectionClipboard:be(new _),extraEditorClassName:be(new S(31,"extraEditorClassName","")),fastScrollSensitivity:be(new c(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:p.localize(161,null)})),find:be(new D),fixedOverflowWidgets:be(new f(34,"fixedOverflowWidgets",!1)),folding:be(new f(35,"folding",!0,{description:p.localize(162,null)})),foldingStrategy:be(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(163,null),p.localize(164,null)],description:p.localize(165,null)})),foldingHighlight:be(new f(37,"foldingHighlight",!0,{description:p.localize(166,null)})),unfoldOnClickAfterEndOfLine:be(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(167,null)})),fontFamily:be(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(168,null)})),fontInfo:be(new T),fontLigatures2:be(new o),fontSize:be(new L),fontWeight:be(new $),formatOnPaste:be(new f(44,"formatOnPaste",!1,{description:p.localize(169,null)})),formatOnType:be(new f(45,"formatOnType",!1,{description:p.localize(170,null)})),glyphMargin:be(new f(46,"glyphMargin",!0,{description:p.localize(171,null)})),gotoLocation:be(new W),hideCursorInOverviewRuler:be(new f(48,"hideCursorInOverviewRuler",!1,{description:p.localize(172,null)})),highlightActiveIndentGuide:be(new f(49,"highlightActiveIndentGuide",!0,{description:p.localize(173,null)})),hover:be(new Q),inDiffEditor:be(new f(51,"inDiffEditor",!1)),letterSpacing:be(new c(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>c.clamp(K,-5,20),{description:p.localize(174,null)})),lightbulb:be(new H),lineDecorationsWidth:be(new P(55,"lineDecorationsWidth",10)),lineHeight:be(new x),lineNumbers:be(new Fe),lineNumbersMinChars:be(new l(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(59,"linkedEditing",!1,{description:p.localize(175,null)})),links:be(new f(60,"links",!0,{description:p.localize(176,null)})),matchBrackets:be(new b(61,"matchBrackets","always",["always","near","never"],{description:p.localize(177,null)})),minimap:be(new O),mouseStyle:be(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new c(64,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:p.localize(178,null)})),mouseWheelZoom:be(new f(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(179,null)})),multiCursorMergeOverlapping:be(new f(66,"multiCursorMergeOverlapping",!0,{description:p.localize(180,null)})),multiCursorModifier:be(new h(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[p.localize(181,null),p.localize(182,null)],markdownDescription:p.localize(183,null)})),multiCursorPaste:be(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(184,null),p.localize(185,null)],markdownDescription:p.localize(186,null)})),occurrencesHighlight:be(new f(69,"occurrencesHighlight",!0,{description:p.localize(187,null)})),overviewRulerBorder:be(new f(70,"overviewRulerBorder",!0,{description:p.localize(188,null)})),overviewRulerLanes:be(new l(71,"overviewRulerLanes",3,0,3)),padding:be(new B),parameterHints:be(new V),peekWidgetDefaultFocus:be(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(189,null),p.localize(190,null)],description:p.localize(191,null)})),definitionLinkOpensInPeek:be(new f(75,"definitionLinkOpensInPeek",!1,{description:p.localize(192,null)})),quickSuggestions:be(new de),quickSuggestionsDelay:be(new l(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(193,null)})),readOnly:be(new f(78,"readOnly",!1)),renameOnType:be(new f(79,"renameOnType",!1,{description:p.localize(194,null),markdownDeprecationMessage:p.localize(195,null)})),renderControlCharacters:be(new f(80,"renderControlCharacters",!1,{description:p.localize(196,null)})),renderIndentGuides:be(new f(81,"renderIndentGuides",!0,{description:p.localize(197,null)})),renderFinalNewline:be(new f(82,"renderFinalNewline",!0,{description:p.localize(198,null)})),renderLineHighlight:be(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(199,null)],description:p.localize(200,null)})),renderLineHighlightOnlyWhenFocus:be(new f(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(201,null)})),renderValidationDecorations:be(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(202,null),p.localize(203,null),p.localize(204,null),""],description:p.localize(205,null)})),revealHorizontalRightPadding:be(new l(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(88,"roundedSelection",!0,{description:p.localize(206,null)})),rulers:be(new Ne),scrollbar:be(new Ve),scrollBeyondLastColumn:be(new l(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(207,null)})),scrollBeyondLastLine:be(new f(92,"scrollBeyondLastLine",!0,{description:p.localize(208,null)})),scrollPredominantAxis:be(new f(93,"scrollPredominantAxis",!0,{description:p.localize(209,null)})),selectionClipboard:be(new f(94,"selectionClipboard",!0,{description:p.localize(210,null),included:R.isLinux})),selectionHighlight:be(new f(95,"selectionHighlight",!0,{description:p.localize(211,null)})),selectOnLineNumbers:be(new f(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(212,null),p.localize(213,null)],description:p.localize(214,null)})),showUnused:be(new f(98,"showUnused",!0,{description:p.localize(215,null)})),showDeprecated:be(new f(123,"showDeprecated",!0,{description:p.localize(216,null)})),inlayHints:be(new F),snippetSuggestions:be(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(217,null),p.localize(218,null),p.localize(219,null),p.localize(220,null)],description:p.localize(221,null)})),smartSelect:be(new Z),smoothScrolling:be(new f(101,"smoothScrolling",!1,{description:p.localize(222,null)})),stopRenderingLineAfter:be(new l(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new q),inlineSuggest:be(new qe),suggestFontSize:be(new l(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(223,null)})),suggestLineHeight:be(new l(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(224,null)})),suggestOnTriggerCharacters:be(new f(107,"suggestOnTriggerCharacters",!0,{description:p.localize(225,null)})),suggestSelection:be(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(226,null),p.localize(227,null),p.localize(228,null)],description:p.localize(229,null)})),tabCompletion:be(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null)],description:p.localize(233,null)})),tabIndex:be(new l(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null)],description:p.localize(237,null)})),useShadowDOM:be(new f(112,"useShadowDOM",!0)),useTabStops:be(new f(113,"useTabStops",!0,{description:p.localize(238,null)})),wordSeparators:be(new S(114,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:p.localize(239,null)})),wordWrap:be(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null),p.localize(243,null)],description:p.localize(244,null)})),wordWrapBreakAfterCharacters:be(new S(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new S(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new l(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(245,null)})),wordWrapOverride1:be(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new h(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],J,{enumDescriptions:[p.localize(246,null),p.localize(247,null),p.localize(248,null),p.localize(249,null)],description:p.localize(250,null)})),wrappingStrategy:be(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(251,null),p.localize(252,null)],description:p.localize(253,null)})),editorClassName:be(new g),pixelRatio:be(new ee),tabFocusMode:be(new re),layoutInfo:be(new N),wrappingInfo:be(new se)}}),define(fe[152],me([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[153],me([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[154],me([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[155],me([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[156],me([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(fe[157],me([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(fe[158],me([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[159],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[160],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[161],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[162],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[163],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[164],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[165],me([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[166],me([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[167],me([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(fe[168],me([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[169],me([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[170],me([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[171],me([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[172],me([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[173],me([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=e.isResourceEditorInput=void 0;function R(E){const C=E;return p.URI.isUri(C?.resource)}e.isResourceEditorInput=R;var k;(function(E){E[E.ACTIVATE=1]="ACTIVATE",E[E.RESTORE=2]="RESTORE",E[E.PRESERVE=3]="PRESERVE"})(k=e.EditorActivation||(e.EditorActivation={}));var y;(function(E){E[E.PICK=0]="PICK",E[E.DISABLED=1]="DISABLED",E[E.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(y=e.EditorOverride||(e.EditorOverride={}));var A;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[174],me([0,1,154]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||R.test(d)}e.isValidVersionStr=y;function A(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=d.match(R);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function I(d){if(!d)return null;let f=d.majorBase,l=d.majorMustEqual,c=d.minorBase,S=d.minorMustEqual,w=d.patchBase,b=d.patchMustEqual;d.hasCaret&&(f===0||(S=!1),b=!1);let h=0;if(d.preRelease){const u=k.exec(d.preRelease);if(u){const[,m,t,s]=u;h=Date.UTC(Number(m),Number(t)-1,Number(s))}}return{majorBase:f,majorMustEqual:l,minorBase:c,minorMustEqual:S,patchBase:w,patchMustEqual:b,isMinimum:d.hasGreaterEquals,notBefore:h}}e.normalizeVersion=I;function E(d,f,l){let c;typeof d=="string"?c=I(A(d)):c=d;let S;f instanceof Date?S=f.getTime():typeof f=="string"&&(S=new Date(f).getTime());let w;if(typeof l=="string"?w=I(A(l)):w=l,!c||!w)return!1;let b=c.majorBase,h=c.minorBase,u=c.patchBase,m=w.majorBase,t=w.minorBase,s=w.patchBase,r=w.notBefore,i=w.majorMustEqual,a=w.minorMustEqual,v=w.patchMustEqual;return w.isMinimum?b>m?!0:b<m?!1:h>t?!0:h<t||S&&S<r?!1:u>=s:(b===1&&m===0&&(!i||!a||!v)&&(m=1,t=0,s=0,i=!0,a=!1,v=!1),b<m?!1:b>m?!i:h<t?!1:h>t?!a:u<s?!1:u>s?!v:!(S&&S<r))}e.isValidVersion=E;function C(d,f,l,c){return l.isBuiltin||typeof l.main=="undefined"?!0:P(d,f,l.engines.vscode,c)}e.isValidExtensionVersion=C;function n(d,f,l){return d==="*"||P(f,l,d)}e.isEngineValid=n;function P(d,f,l,c=[]){let S=I(A(l));if(!S)return c.push(p.localize(0,null,l)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return c.push(p.localize(1,null,l)),!1}else if(!S.majorMustEqual)return c.push(p.localize(2,null,l)),!1;return E(d,f,S)?!0:(c.push(p.localize(3,null,d,l)),!1)}}),define(fe[111],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(y,A=[],I=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=p;const R=(k,...y)=>new p(k,y);e.createSyncDescriptor=R}),define(fe[76],me([0,1,111]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(A,I,E){I instanceof p.SyncDescriptor||(I=new p.SyncDescriptor(I,[],E)),R.push([A,I])}e.registerSingleton=k;function y(){return R}e.getSingletonServiceDescriptors=y}),define(fe[175],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=p;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const I=this.lookupOrInsertNode(y),E=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(y),I)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let I=this._nodes.get(A);return I||(I=new p(y),this._nodes.set(A,I)),I}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,I]of this._nodes)y.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const I=new Set([y]),E=this._findCycle(A,I);if(E)return E}}_findCycle(y,A){for(let[I,E]of y.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const C=this._findCycle(E,A);if(C)return C;A.delete(I)}}}e.Graph=R}),define(fe[4],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function E(C){return C[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(I,E,C,n){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:I,index:C,optional:n}):(E[p.DI_DEPENDENCIES]=[{id:I,index:C,optional:n}],E[p.DI_TARGET]=E)}function k(I){if(p.serviceIds.has(I))return p.serviceIds.get(I);const E=function(C,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,C,P,!1)};return E.toString=()=>I,p.serviceIds.set(I,E),E}e.createDecorator=k;function y(I){return I}e.refineServiceDecorator=y;function A(I){return function(E,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(I,E,n,!0)}}e.optional=A}),define(fe[176],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=p.createDecorator("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(fe[177],me([0,1,3,72,6,24,71,75,176]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(C):!!d.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(f,l){let c={selector:f,provider:l,_score:-1,_time:this._clock++};return this._entries.push(c),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),k.toDisposable(()=>{if(c){let S=this._entries.indexOf(c);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),c=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const l=[];for(let c of this._entries)c._score>0&&l.push(c.provider);return l}ordered(f){const l=[];return this._orderedForEach(f,c=>l.push(c.provider)),l}orderedGroups(f){const l=[];let c,S;return this._orderedForEach(f,w=>{c&&S===w._score?c.push(w.provider):(S=w._score,c=[w.provider],l.push(c))}),l}_orderedForEach(f,l){if(!!f){this._updateScores(f);for(const c of this._entries)c._score>0&&l(c)}}_updateScores(f){let l={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let c of this._entries)if(c._score=I.score(c.selector,f.uri,f.getLanguageIdentifier().language,E.shouldSynchronizeModel(f)),C(c.selector)&&c._score>0){for(let S of this._entries)S._score=0;c._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(f,l){return f._score<l._score?1:f._score>l._score?-1:f._time<l._time?1:f._time>l._time?-1:0}}e.LanguageFeatureRegistry=n;class P{constructor(f,l,c=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=l,this.max=c,this._cache=new y.LRUCache(50,.7)}_key(f){return f.id+R.hash(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const l=this._key(f),c=this._cache.get(l);return this._clamp(c?.value)}update(f,l){const c=this._key(f);let S=this._cache.get(c);return S||(S=new A.MovingAverage,this._cache.set(c,S)),S.update(l),this.get(f)}}e.LanguageFeatureRequestDelays=P}),define(fe[77],me([0,1,2,40,177,144,91]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class E{constructor(T,L){this.language=T,this.id=L}}e.LanguageIdentifier=E;var C;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let L=this.getForeground(T),$="mtk"+L,W=this.getFontStyle(T);return W&1&&($+=" mtki"),W&2&&($+=" mtkb"),W&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(T,L){const $=this.getForeground(T),W=this.getFontStyle(T);let Q=`color: ${L[$]};`;return W&1&&(Q+="font-style: italic;"),W&2&&(Q+="font-weight: bold;"),W&4&&(Q+="text-decoration: underline;"),Q}}e.TokenMetadata=f;var l;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(T){const L=o[T];let $=L&&A.iconRegistry.get(L);return $||(console.info("No codicon found for CompletionItemKind "+T),$=A.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(T,L){let $=o[T];return typeof $=="undefined"&&!L&&($=9),$}}();var c;(function(o){o[o.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&p.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var s;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(o){o[o.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function $(z){return T.get(z)}o.fromString=$;function W(z){return L.get(z)}o.toString=W;function Q(z,N){const H=L.get(z);let F=H&&A.iconRegistry.get("symbol-"+H);return F||(console.info("No codicon found for SymbolKind "+z),F=A.Codicon.symbolProperty),`${N?"inline":"block"} ${F.classNames}`}o.toCssClassName=Q})(i=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(T){this.value=T}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var v;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var _;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var D;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[78],me([0,1,8,4,11]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=k.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var E;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(o){return f.create(o)}static equals(o,T){return l.create(o,T)}static notEquals(o,T){return w.create(o,T)}static regex(o,T){return s.create(o,T)}static in(o,T){return c.create(o,T)}static not(o){return b.create(o)}static and(...o){return i.create(o)}static or(...o){return a.create(o)}static greater(o,T){return h.create(o,T)}static less(o,T){return m.create(o,T)}static deserialize(o,T=!1){if(!!o)return this._deserializeOrExpression(o,T)}static _deserializeOrExpression(o,T){let L=o.split("||");return a.create(L.map($=>this._deserializeAndExpression($,T)))}static _deserializeAndExpression(o,T){let L=o.split("&&");return i.create(L.map($=>this._deserializeOne($,T)))}static _deserializeOne(o,T){if(o=o.trim(),o.indexOf("!=")>=0){let L=o.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],T))}if(o.indexOf("==")>=0){let L=o.split("==");return l.create(L[0].trim(),this._deserializeValue(L[1],T))}if(o.indexOf("=~")>=0){let L=o.split("=~");return s.create(L[0].trim(),this._deserializeRegexValue(L[1],T))}if(o.indexOf(" in ")>=0){let L=o.split(" in ");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const L=o.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const L=o.split(">");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const L=o.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const L=o.split("<");return m.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(o)?b.create(o.substr(1).trim()):f.create(o)}static _deserializeValue(o,T){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let L=/^'([^']*)'$/.exec(o);return L?L[1].trim():o}static _deserializeRegexValue(o,T){if(p.isFalsyOrWhitespace(o)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=o.indexOf("/"),$=o.lastIndexOf("/");if(L===$||L<0){if(T)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let W=o.slice(L+1,$),Q=o[$+1]==="i"?"i":"";try{return new RegExp(W,Q)}catch(z){if(T)throw new Error(`bad regexp-value '${o}', parse error: ${z}`);return console.warn(`bad regexp-value '${o}', parse error: ${z}`),null}}}e.ContextKeyExpr=C;function n(D,o){return D.cmp(o)}class P{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class f{constructor(o){this.key=o,this.type=2}static create(o){const T=A.get(o);return typeof T=="boolean"?T?d.INSTANCE:P.INSTANCE:new f(o)}cmp(o){return o.type!==this.type?this.type-o.type:g(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class l{constructor(o,T){this.key=o,this.value=T,this.type=4}static create(o,T){if(typeof T=="boolean")return T?f.create(o):b.create(o);const L=A.get(o);return typeof L=="boolean"?T===(L?"true":"false")?d.INSTANCE:P.INSTANCE:new l(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class c{constructor(o,T){this.key=o,this.valueKey=T,this.type=10}static create(o,T){return new c(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const T=o.getValue(this.valueKey),L=o.getValue(this.key);return Array.isArray(T)?T.indexOf(L)>=0:typeof L=="string"&&typeof T=="object"&&T!==null?I.call(T,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=c;class S{constructor(o){this._actual=o,this.type=11}static create(o){return new S(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new S(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(o,T){this.key=o,this.value=T,this.type=5}static create(o,T){if(typeof T=="boolean")return T?b.create(o):f.create(o);const L=A.get(o);return typeof L=="boolean"?T===(L?"true":"false")?P.INSTANCE:d.INSTANCE:new w(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(o){this.key=o,this.type=3}static create(o){const T=A.get(o);return typeof T=="boolean"?T?P.INSTANCE:d.INSTANCE:new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:g(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class h{constructor(o,T){this.key=o,this.value=T,this.type=12}static create(o,T){return new h(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=h;class u{constructor(o,T){this.key=o,this.value=T,this.type=13}static create(o,T){return new u(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class m{constructor(o,T){this.key=o,this.value=T,this.type=14}static create(o,T){return new m(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(o,T){this.key=o,this.value=T,this.type=15}static create(o,T){return new t(o,T)}cmp(o){return o.type!==this.type?this.type-o.type:_(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(o,T){this.key=o,this.regexp=T,this.type=7}static create(o,T){return new s(o,T)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const T=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return T<L?-1:T>L?1:0}equals(o){if(o.type===this.type){const T=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return this.key===o.key&&T===L}return!1}evaluate(o){let T=o.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=s;class r{constructor(o){this._actual=o,this.type=8}static create(o){return new r(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new r(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const $=n(this.expr[T],o.expr[T]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(o.expr[T]))return!1;return!0}return!1}evaluate(o){for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].evaluate(o))return!1;return!0}static _normalizeArr(o){const T=[];let L=!1;for(const $ of o)if(!!$){if($.type===1){L=!0;continue}if($.type===0)return P.INSTANCE;if($.type===6){T.push(...$.expr);continue}T.push($)}if(T.length===0&&L)return d.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const $=T[T.length-1];if($.type!==9)break;T.pop();const W=T.pop(),Q=a.create($.expr.map(z=>i.create([z,W])));Q&&(T.push(Q),T.sort(n))}return T.length===1?T[0]:new i(T)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let T of this.expr)o.push(...T.keys());return o}map(o){return new i(this.expr.map(T=>T.map(o)))}negate(){let o=[];for(let T of this.expr)o.push(T.negate());return a.create(o)}}e.ContextKeyAndExpr=i;class a{constructor(o){this.expr=o,this.type=9}static create(o){const T=a._normalizeArr(o);if(T.length!==0)return T.length===1?T[0]:new a(T)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const $=n(this.expr[T],o.expr[T]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(o.expr[T]))return!1;return!0}return!1}evaluate(o){for(let T=0,L=this.expr.length;T<L;T++)if(this.expr[T].evaluate(o))return!0;return!1}static _normalizeArr(o){let T=[],L=!1;if(o){for(let $=0,W=o.length;$<W;$++){const Q=o[$];if(!!Q){if(Q.type===0){L=!0;continue}if(Q.type===1)return[d.INSTANCE];if(Q.type===9){T=T.concat(Q.expr);continue}T.push(Q)}}if(T.length===0&&L)return[P.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let T of this.expr)o.push(...T.keys());return o}map(o){return new a(this.expr.map(T=>T.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());const T=L=>L.type===9?L.expr:[L];for(;o.length>1;){const L=o.shift(),$=o.shift(),W=[];for(const Q of T(L))for(const z of T($))W.push(C.and(Q,z));o.unshift(C.or(...W))}return o[0]}}e.ContextKeyOrExpr=a;class v extends f{constructor(o,T,L){super(o);this._defaultValue=T,typeof L=="object"?v._info.push({...L,key:o}):L!==!0&&v._info.push({key:o,description:L,type:T!=null?typeof T:void 0})}static all(){return v._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(o){return C.equals(this.key,o)}notEqualsTo(o){return C.notEquals(this.key,o)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(D,o){return D<o?-1:D>o?1:0}function _(D,o,T,L){return D<T?-1:D>T?1:o<L?-1:o>L?1:0}}),define(fe[178],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=p.createDecorator("environmentService"),e.INativeEnvironmentService=p.refineServiceDecorator(e.IEnvironmentService)}),define(fe[179],me([0,1,153,4,10]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=y;var A;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var I;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var E;(function(P){P.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var C;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(d,f){super(d);this.code=f,this.name=f}}e.ExtensionManagementError=n,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=p.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=p.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(fe[26],me([0,1,8,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=k;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class I{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,d){if(typeof P=="undefined"||P===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof P=="string"||typeof d=="string"){let f=typeof P=="string"?P:P.value,l=typeof d=="string"?d:d.value;return p.equalsIgnoreCase(f,l)}return P._lower===d._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=I;function E(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(fe[180],me([0,1,8,26]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(l,c){return l.uuid&&c.uuid?l.uuid===c.uuid:l.id===c.id?!0:p.compareIgnoreCase(l.id,c.id)===0}e.areSameExtensions=k;class y{constructor(c,S){this.version=S,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(l,c){return`${l}.${c}`}e.getExtensionId=A;function I(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function E(l,c){return I(A(l,c))}e.getGalleryExtensionId=E;function C(l,c){const S=[],w=b=>{for(const h of S)if(h.some(u=>k(c(u),c(b))))return h;return null};for(const b of l){const h=w(b);h?h.push(b):S.push([b])}return S}e.groupByExtension=C;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(l){const c=new Set;for(const S of l)S.malicious&&c.add(S.id.id);return c}e.getMaliciousExtensionsSet=d;function f(l,c){const S=[],w=c.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const b=w.shift();if(b&&S.every(h=>!k(h.identifier,{id:b}))){const h=l.filter(u=>k(u.identifier,{id:b}));h.length===1&&(S.push(h[0]),w.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=f}),define(fe[181],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=p.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=p.createDecorator("externalTerminal")}),define(fe[182],me([0,1,38,9,110,155,28,11,181,10,136]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class d{async getDefaultTerminalForPlatforms(){const u=await c.getDefaultTerminalLinuxReady();return{windows:f.getDefaultTerminalWindows(),linux:u,osx:"xterm"}}}class f extends d{openTerminal(u,m){return this.spawnTerminal(p,u,k.getWindowsShell(),m)}spawnTerminal(u,m,t,s){const r=m.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const i=R.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return u.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return r.indexOf(" ")>=0&&a.push('""'),a.push(r),(i==="wt"||i==="wt.exe")&&a.push("-d ."),new Promise((v,g)=>{const _=S(process),D=u.spawn(t,a,{cwd:s,env:_});D.on("error",g),D.on("exit",()=>v())})}runInTerminal(u,m,t,s,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((a,v)=>{const g=`"${m} - ${P}"`,_=`""${t.join('" "')}" & pause"`,D=["/c","start",g,"/wait",i,"/c",_],o=Object.assign({},S(process),s);Object.keys(o).filter($=>o[$]===null).forEach($=>delete o[$]);const T={cwd:m,env:o,windowsVerbatimArguments:!0};p.spawn(f.CMD,D,T).on("error",$=>{v(w($))}),a(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class l extends d{openTerminal(u,m){return this.spawnTerminal(p,u,m)}runInTerminal(u,m,t,s,r){const i=r.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((a,v)=>{if(i===E.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const g=i===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`,X).fsPath,"-t",u||P,"-w",m];for(let L of t)D.push("-a"),D.push(L);if(s)for(let L in s){const $=s[L];$===null?(D.push("-u"),D.push(L)):(D.push("-e"),D.push(`${L}=${$}`))}let o="";const T=p.spawn(l.OSASCRIPT,D);T.on("error",L=>{v(w(L))}),T.stderr.on("data",L=>{o+=L.toString()}),T.on("exit",L=>{if(L===0)a(void 0);else if(o){const $=o.split(`
`,1);v(new Error($[0]))}else v(new Error(y.localize(1,null,g,L)))})}else v(new Error(y.localize(2,null,i)))})}spawnTerminal(u,m,t){const s=m.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const a=["-a",s];t&&a.push(t);const v=u.spawn("/usr/bin/open",a);v.on("error",i),v.on("exit",()=>r())})}}e.MacExternalTerminalService=l,l.OSASCRIPT="/usr/bin/osascript";class c extends d{openTerminal(u,m){return this.spawnTerminal(p,u,m)}runInTerminal(u,m,t,s,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):c.getDefaultTerminalLinuxReady();return new Promise((a,v)=>{let g=[];i.then(_=>{_.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const D=`${b(t)}; echo; read -p "${c.WAIT_MESSAGE}" -n1;`;g.push(`''${D}''`);const o=Object.assign({},process.env,s);Object.keys(o).filter(W=>o[W]===null).forEach(W=>delete o[W]);const T={cwd:m,env:o};let L="";const $=p.spawn(_,g,T);$.on("error",W=>{v(w(W))}),$.stderr.on("data",W=>{L+=W.toString()}),$.on("exit",W=>{if(W===0)a(void 0);else if(L){const Q=L.split(`
`,1);v(new Error(Q[0]))}else v(new Error(y.localize(4,null,_,W)))})})})}static async getDefaultTerminalLinuxReady(){return c._DEFAULT_TERMINAL_LINUX_READY||(c._DEFAULT_TERMINAL_LINUX_READY=new Promise(async u=>{I.isLinux?await A.Promises.exists("/etc/debian_version")?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm"):u("xterm")})),c._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,m,t){const s=m.linuxExec?Promise.resolve(m.linuxExec):c.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{s.then(a=>{const v=S(process),g=u.spawn(a,[],{cwd:t,env:v});g.on("error",i),g.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=c,c.WAIT_MESSAGE=y.localize(3,null);function S(h){const u=h.env;return n.sanitizeProcessEnvironment(u),u}function w(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(y.localize(5,null,h.path)):h}function b(h){let u="";for(let m of h)m.indexOf(" ")>=0?u+='"'+m+'"':u+=m,u+=" ";return u}}),define(fe[41],me([0,1,156,9,2,4,8,14,24]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function C(N){return N.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function(N){N[N.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var d;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function l(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=l;function c(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function S(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(H,F){super(H);this.code=F}}e.FileSystemProviderError=b;function h(N,H){const F=new b(N.toString(),H);return m(F,H),F}e.createFileSystemProviderError=h;function u(N){return N||h(p.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=u;function m(N,H){return N.name=H?`${H} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=m;function t(N){if(!N)return w.Unknown;if(N instanceof b)return N.code;const H=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!H)return w.Unknown;switch(H[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function s(N){if(N instanceof _)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(H,F,x){this.resource=H,this.operation=F,this.target=x}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var a;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class v{constructor(H,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of H)switch(x.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>F)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>F)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>F)),this.deleted.set(x.resource,x);break}}contains(H,...F){return this.doContains(H,{includeChildren:!1},...F)}affects(H,...F){return this.doContains(H,{includeChildren:!0},...F)}doContains(H,F,...x){if(!H)return!1;const O=x.length>0;return!!((!O||x.includes(1))&&(this.added?.get(H)||F.includeChildren&&this.added?.findSuperstr(H))||(!O||x.includes(0))&&(this.updated?.get(H)||F.includeChildren&&this.updated?.findSuperstr(H))||(!O||x.includes(2))&&(this.deleted?.findSubstr(H)||F.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function g(N,H,F){return!N||!H||N===H||H.length>N.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),F?A.startsWithIgnoreCase(N,H):N.indexOf(H)===0)}e.isParent=g;class _ extends Error{constructor(H,F,x){super(H);this.fileOperationResult=F,this.options=x}}e.FileOperationError=_;class D extends _{constructor(H,F,x){super(H,2,x);this.stat=F}}e.NotModifiedSinceFileOperationError=D;var o;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function $(N,H){if(!H.canHandleResource(k.URI.from({scheme:N.scheme})))return new Promise(F=>{const x=H.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===N.scheme&&O.added&&(x.dispose(),F())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(H){return I.isNumber(H)||(H=0),H<W.KB?p.localize(1,null,H.toFixed(0)):H<W.MB?p.localize(2,null,(H/W.KB).toFixed(2)):H<W.GB?p.localize(3,null,(H/W.MB).toFixed(2)):H<W.TB?p.localize(4,null,(H/W.GB).toFixed(2)):p.localize(5,null,(H/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var Q;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(Q=e.Arch||(e.Arch={}));function z(N){return{maxFileSize:N===0?300*W.MB:16*W.GB,maxHeapSize:N===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=z}),define(fe[79],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...k){this._entries=new Map;for(let[y,A]of k)this.set(y,A)}set(k,y){const A=this._entries.get(k);return this._entries.set(k,y),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=p}),define(fe[183],me([0,1,15,175,111,4,79,18]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class C extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class n{constructor(l=new A.ServiceCollection,c=!1,S){this._activeInstantiations=new Set,this._services=l,this._strict=c,this._parent=S,this._services.set(y.IInstantiationService,this)}createChild(l){return new n(l,this._strict,this)}invokeFunction(l,...c){let S=d.traceInvocation(l),w=!1;try{return l({get:(h,u)=>{if(w)throw p.illegalState("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(h,S);if(!m&&u!==y.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return m}},...c)}finally{w=!0,S.stop()}}createInstance(l,...c){let S,w;return l instanceof k.SyncDescriptor?(S=d.traceCreation(l.ctor),w=this._createInstance(l.ctor,l.staticArguments.concat(c),S)):(S=d.traceCreation(l),w=this._createInstance(l,c,S)),S.stop(),w}_createInstance(l,c=[],S){let w=y._util.getServiceDependencies(l).sort((u,m)=>u.index-m.index),b=[];for(const u of w){let m=this._getOrCreateServiceInstance(u.id,S);if(!m&&this._strict&&!u.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${u.id}.`);b.push(m)}let h=w.length>0?w[0].index:c.length;if(c.length!==h){console.warn(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${c.length} static arguments`);let u=h-c.length;u>0?c=c.concat(new Array(u)):c=c.slice(0,h)}return new l(...[...c,...b])}_setServiceInstance(l,c){if(this._services.get(l)instanceof k.SyncDescriptor)this._services.set(l,c);else if(this._parent)this._parent._setServiceInstance(l,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let c=this._services.get(l);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):c}_getOrCreateServiceInstance(l,c){let S=this._getServiceInstanceOrDescriptor(l);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,S,c.branch(l,!0)):(c.branch(l,!1),S)}_safeCreateAndCacheServiceInstance(l,c,S){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,c,S)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,c,S){const w=new R.Graph(u=>u.id.toString());let b=0;const h=[{id:l,desc:c,_trace:S}];for(;h.length;){const u=h.pop();if(w.lookupOrInsertNode(u),b++>1e3)throw new C(w);for(let m of y._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${l} depends on ${m.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const s={id:m.id,desc:t,_trace:u._trace.branch(m.id,!0)};w.insertEdge(u,s),h.push(s)}}}for(;;){const u=w.roots();if(u.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:m}of u){if(this._getServiceInstanceOrDescriptor(m.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,s)}w.removeNode(m)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,c,S=[],w,b){if(this._services.get(l)instanceof k.SyncDescriptor)return this._createServiceInstance(c,S,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,c,S,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(l,c=[],S,w){if(S){const b=new I.IdleValue(()=>this._createInstance(l,c,w));return new Proxy(Object.create(null),{get(h,u){if(u in h)return h[u];let m=b.value,t=m[u];return typeof t!="function"||(t=t.bind(m),h[u]=t),t},set(h,u,m){return b.value[u]=m,!0}})}else return this._createInstance(l,c,w)}}e.InstantiationService=n;var P;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(P||(P={}));class d{constructor(l,c){this.type=l,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return E?new d(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(l){return E?new d(0,l.name):d._None}branch(l,c){let S=new d(2,l.toString());return this._dep.push([l,c,S]),S}stop(){let l=Date.now()-this._start;d._totals+=l;let c=!1;function S(b,h){let u=[],m=new Array(b+1).join("	");for(const[t,s,r]of h._dep)if(s&&r){c=!0,u.push(`${m}CREATES -> ${t}`);let i=S(b+1,r);i&&u.push(i)}else u.push(`${m}uses -> ${t}`);return u.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(l>2||c)&&console.log(w.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(fe[12],me([0,1,4,6,11,3,58]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=p.createDecorator("logService"),e.ILoggerService=p.createDecorator("loggerService");function I(){return new Date().toISOString()}var E;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class C extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(E.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(E.Error,this.format(r))}else this.log(E.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class P extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}debug(t,...s){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}info(t,...s){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}warn(t,...s){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...s):console.warn(`[main ${I()}]`,t,...s))}error(t,...s){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}critical(t,...s){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=d;class f extends C{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class l extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class c extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=c;class S extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?E.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=w;function b(m){if(m.verbose)return E.Trace;if(typeof m.logLevel=="string"){const t=h(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function h(m){switch(m){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=h;function u(m){switch(m){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=u}),define(fe[112],me([0,1,12,41]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(E,C,n,P){try{const d=await new Promise((f,l)=>{X(["spdlog"],f,l)});return d.setFlushOn(p.LogLevel.Trace),d.createAsyncRotatingLogger(E,C,n,P)}catch(d){console.error(d)}return null}function y(E,C,n,P){const d=X.__$__nodeRequire("spdlog");return d.setFlushOn(p.LogLevel.Trace),d.createRotatingLogger(E,C,n,P)}e.createRotatingLogger=y;function A(E,C,n){switch(C){case p.LogLevel.Trace:E.trace(n);break;case p.LogLevel.Debug:E.debug(n);break;case p.LogLevel.Info:E.info(n);break;case p.LogLevel.Warning:E.warn(n);break;case p.LogLevel.Error:E.error(n);break;case p.LogLevel.Critical:E.critical(n);break;default:throw new Error("Invalid log level")}}class I extends p.AbstractMessageLogger{constructor(C,n,P,d){super();this.name=C,this.filepath=n,this.rotating=P,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const C=this.rotating?6:1,n=30/C*R.ByteSize.MB;return k(this.name,this.filepath,n,C).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:d,message:f}of this.buffer)A(this._logger,d,f);this.buffer=[]}})}log(C,n){this._logger?A(this._logger,C,n):this.getLevel()<=C&&this.buffer.push({level:C,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(fe[113],me([0,1,4,157,55]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function C(l,c){return c-l}E.compare=C;const n=Object.create(null);n[E.Error]=R.localize(0,null),n[E.Warning]=R.localize(1,null),n[E.Info]=R.localize(2,null);function P(l){return n[l]||""}E.toString=P;function d(l){switch(l){case k.default.Error:return E.Error;case k.default.Warning:return E.Warning;case k.default.Info:return E.Info;case k.default.Ignore:return E.Hint}}E.fromSeverity=d;function f(l){switch(l){case E.Error:return k.default.Error;case E.Warning:return k.default.Warning;case E.Info:return k.default.Info;case E.Hint:return k.default.Ignore}}E.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(E){const C="";function n(d){return P(d,!0)}E.makeKey=n;function P(d,f){let l=[C];return d.source?l.push(d.source.replace("\xA6","\\\xA6")):l.push(C),d.code?typeof d.code=="string"?l.push(d.code.replace("\xA6","\\\xA6")):l.push(d.code.value.replace("\xA6","\\\xA6")):l.push(C),d.severity!==void 0&&d.severity!==null?l.push(A.toString(d.severity)):l.push(C),d.message&&f?l.push(d.message.replace("\xA6","\\\xA6")):l.push(C),d.startLineNumber!==void 0&&d.startLineNumber!==null?l.push(d.startLineNumber.toString()):l.push(C),d.startColumn!==void 0&&d.startColumn!==null?l.push(d.startColumn.toString()):l.push(C),d.endLineNumber!==void 0&&d.endLineNumber!==null?l.push(d.endLineNumber.toString()):l.push(C),d.endColumn!==void 0&&d.endColumn!==null?l.push(d.endColumn.toString()):l.push(C),l.push(C),l.join("\xA6")}E.makeKeyOptionalMessage=P})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=p.createDecorator("markerService")}),define(fe[184],me([0,1,55,4,3]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=R.createDecorator("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new E,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=I;class E{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=E}),define(fe[185],me([0,1,6,8,2,4]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function A(I,E){return k.URI.isUri(I)?R.equalsIgnoreCase(I.scheme,E):R.startsWithIgnoreCase(I,E+":")}e.matchesScheme=A}),define(fe[186],me([0,1,10,11,37,22]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const I=y.dirname(p.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(y.joinPath(I,"product.json").fsPath);const E=X.__$__nodeRequire(y.joinPath(I,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.58.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var We=this&&this.__param||function(X,e){return function(p,R){e(p,R,X)}};define(fe[114],me([0,1,4,21,6,18]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=p.createDecorator("progressService");var A;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let E=class extends k.Disposable{constructor(P,d){super();this.deferred=new y.DeferredPromise,d.withProgress(P,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register(k.toDisposable(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};E=ze([We(1,e.IProgressService)],E),e.UnmanagedProgress=E;class C extends k.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,f=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add(k.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(k.toDisposable(()=>f.cancel())),this.currentOperationDisposables.add(k.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:f.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=p.createDecorator("editorProgressService")}),define(fe[45],me([0,1,14,51]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,I){R.ok(p.isString(A)),R.ok(p.isObject(I)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(fe[187],me([0,1,45,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[k(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;p.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[80],me([0,1,152,3,45,14,187]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=k.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const h=[];w.forEach(u=>{h.push(...this.validateAndRegisterProperties(u,b,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(w){const b=[],h=u=>{if(u.properties)for(const m in u.properties)b.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,u.properties[m]);u.allOf&&u.allOf.forEach(m=>h(m))};for(const u of w){h(u);const m=this.configurationContributors.indexOf(u);m!==-1&&this.configurationContributors.splice(m,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],h=[];for(const u of w)for(const m in u)if(b.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]={...this.defaultValues[m]||{},...u[m]};const t={type:"object",default:this.defaultValues[m],description:p.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};h.push(P(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=u[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const h of w)for(const u in h)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const m=this.configurationProperties[u];m&&(this.updatePropertyDefaultValue(u,m),this.updateSchema(u,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,h,u=3){u=y.isUndefinedOrNull(w.scope)?u:w.scope;let m=[],t=w.properties;if(t)for(let r in t){if(b&&l(r)){delete t[r];continue}const i=t[r];if(this.updatePropertyDefaultValue(r,i),e.OVERRIDE_PROPERTY_PATTERN.test(r)?i.scope=void 0:(i.scope=y.isUndefinedOrNull(i.scope)?u:i.scope,i.restricted=y.isUndefinedOrNull(i.restricted)?!!h?.restrictedConfigurations?.includes(r):i.restricted),t[r].hasOwnProperty("included")&&!t[r].included){this.excludedConfigurationProperties[r]=t[r],delete t[r];continue}else this.configurationProperties[r]=t[r];!t[r].deprecationMessage&&t[r].markdownDeprecationMessage&&(t[r].deprecationMessage=t[r].markdownDeprecationMessage),m.push(r)}let s=w.allOf;if(s)for(let r of s)m.push(...this.validateAndRegisterProperties(r,b,h,u));return m}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=h=>{let u=h.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let m=h.allOf;m&&m.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,h={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,h),e.allSettings.properties[b]=h,e.applicationSettings.properties[b]=h,e.machineSettings.properties[b]=h,e.machineOverridableSettings.properties[b]=h,e.windowSettings.properties[b]=h,e.resourceSettings.properties[b]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let h=this.defaultValues[w];y.isUndefined(h)&&(h=b.default),y.isUndefined(h)&&(h=d(b.type)),b.default=h}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function P(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=P;function d(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new C;k.Registry.add(e.Extensions.Configuration,f);function l(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?p.localize(5,null,S):f.getConfigurationProperties()[S]!==void 0?p.localize(6,null,S):null:p.localize(4,null)}e.validateProperty=l;function c(){const S=[],w=f.getConfigurationProperties();for(const b of Object.keys(w))S.push([b,w[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=c}),define(fe[115],me([0,1,25,14,2,45,4,80]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function E(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=E;var C;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(s,r){const i=r?s?r.keys.filter(T=>s.keys.indexOf(T)===-1):[...r.keys]:[],a=s?r?s.keys.filter(T=>r.keys.indexOf(T)===-1):[...s.keys]:[],v=[];if(r&&s){for(const T of s.keys)if(r.keys.indexOf(T)!==-1){const L=w(s.contents,T),$=w(r.contents,T);p.equals(L,$)||v.push(T)}}const g=[],_=T=>{const L={};for(const $ of T)for(const W of $.identifiers)L[m(W)]=$;return L},D=r?_(r.overrides):{},o=s?_(s.overrides):{};if(Object.keys(D).length)for(const T of i){const L=D[T];L&&g.push([I.overrideIdentifierFromKey(T),L.keys])}if(Object.keys(o).length)for(const T of a){const L=o[T];L&&g.push([I.overrideIdentifierFromKey(T),L.keys])}if(Object.keys(D).length&&Object.keys(o).length)for(const T of v){const L=o[T],$=D[T];if(L&&$){const W=P({contents:L.contents,keys:L.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});g.push([I.overrideIdentifierFromKey(T),[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:a,updated:v,overrides:g}}e.compare=P;function d(s,r){const i=[];for(const a of Object.keys(s))if(I.OVERRIDE_PROPERTY_PATTERN.test(a)){const v={};for(const g in s[a])v[g]=s[a][g];i.push({identifiers:[I.overrideIdentifierFromKey(a).trim()],keys:Object.keys(v),contents:f(v,r)})}return i}e.toOverrides=d;function f(s,r){const i=Object.create(null);for(let a in s)l(i,a,s[a],r);return i}e.toValuesTree=f;function l(s,r,i,a){const v=r.split("."),g=v.pop();let _=s;for(let D=0;D<v.length;D++){let o=v[D],T=_[o];switch(typeof T){case"undefined":T=_[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${v.slice(0,D+1).join(".")} is ${JSON.stringify(T)}`);return}_=T}if(typeof _=="object"&&_!==null)try{_[g]=i}catch(D){a(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(_)}`)}else a(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=l;function c(s,r){const i=r.split(".");S(s,i)}e.removeFromValueTree=c;function S(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(S(a,r),Object.keys(a).length===0&&delete s[i])}}function w(s,r,i){function a(_,D){let o=_;for(const T of D){if(typeof o!="object"||o===null)return;o=o[T]}return o}const v=r.split("."),g=a(s,v);return typeof g=="undefined"?i:g}e.getConfigurationValue=w;function b(s,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?R.isObject(s[a])&&R.isObject(r[a])?b(s[a],r[a],i):i&&(s[a]=r[a]):s[a]=r[a])})}e.merge=b;function h(){const s=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=h;function u(){const s=Object.create(null),r=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let i in r){let a=r[i].default;l(s,i,a,v=>console.error(`Conflict in default settings: ${v}`))}return s}e.getDefaultValues=u;function m(s){return`[${s}]`}e.keyFromOverrideIdentifier=m;function t(s,r,i){const a=s.inspect(r),v=s.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:a.defaultValue}e.getMigratedSettingValue=t}),define(fe[188],me([0,1,54,24,17,14,25,2,80,115,45,6,3]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?C.getConfigurationValue(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[i],v=s[i];v&&(typeof a=="object"&&typeof v=="object"?(a=A.deepClone(a),this.mergeContents(a,v)):a=v),r[i]=a}return new f(r,this.keys,this.overrides)}merge(...t){const s=A.deepClone(this.contents),r=A.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const v of a.overrides){const[g]=r.filter(_=>k.equals(_.identifiers,v.identifiers));g?this.mergeContents(g.contents,v.contents):r.push(A.deepClone(v))}for(const v of a.keys)i.indexOf(v)===-1&&i.push(v)}return new f(s,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&y.isObject(t[r])&&y.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=A.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),C.addToValueTree(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=f;class l extends f{constructor(){const t=C.getDefaultValues(),s=C.getConfigurationKeys(),r=[];for(const i of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[E.overrideIdentifierFromKey(i).trim()],keys:Object.keys(t[i]),contents:C.toValuesTree(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,r)}}e.DefaultConfigurationModel=l;class c{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:a,restricted:v}=this.doParseRaw(t,s);this._configurationModel=new f(r,i,a),this._restrictedConfigurations=v||[]}doParseContent(t){let s={},r=null,i=[],a=[],v=[];function g(D){Array.isArray(i)?i.push(D):r&&(i[r]=D)}let _={onObjectBegin:()=>{let D={};g(D),a.push(i),i=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let D=[];g(D),a.push(i),i=D,r=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:g,onError:(D,o,T)=>{v.push({error:D,offset:o,length:T})}};if(t)try{p.visit(t,_),s=i[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return s}doParseRaw(t,s){const r=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const a=C.toValuesTree(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),v=Object.keys(t),g=C.toOverrides(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:v,overrides:g,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const a={},v=[];for(let g in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(g)&&r){const _=this.filter(t[g],s,!1,i);a[g]=_.raw,v.push(..._.restricted)}else{const _=s[g],D=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&v.push(g),(D===void 0||i.scopes===void 0||i.scopes.includes(D))&&(i.skipRestricted&&_?.restricted||(a[g]=t[g]))}return{raw:a,restricted:v}}}e.ConfigurationModelParser=c;class S extends P.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,s,r=new f,i=new f,a=new R.ResourceMap,v=new f,g=new R.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=v,this._memoryConfigurationByResource=g,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new f,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),v=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,g=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,$=s.overrideIdentifier?v.override(s.overrideIdentifier).getValue(t):v.getValue(t),W=i.getValue(t),Q=k.distinct(k.flatten(i.overrides.map(z=>z.identifiers))).filter(z=>i.getOverrideValue(t,z)!==void 0);return{defaultValue:g,userValue:_,userLocalValue:D,userRemoteValue:o,workspaceValue:T,workspaceFolderValue:L,memoryValue:$,value:W,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:v.getValue(t),override:s.overrideIdentifier?v.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>E.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=E.overrideIdentifierFromKey(i),v=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=t.getKeysForOverrideIdentifier(a),_=[...g.filter(D=>v.indexOf(D)===-1),...v.filter(D=>g.indexOf(D)===-1),...v.filter(D=>!A.equals(this._defaultConfiguration.override(a).getValue(D),t.override(a).getValue(D)))];return[a,_]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=C.compare(this.localUserConfiguration,t),v=[...s,...r,...i];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=C.compare(this.remoteUserConfiguration,t);let v=[...s,...r,...i];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=C.compare(this.workspaceConfiguration,t);let v=[...s,...r,...i];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:a,removed:v,overrides:g}=C.compare(r,s);let _=[...i,...a,...v];return(_.length||!r)&&this.updateFolderConfiguration(t,s),{keys:_,overrides:g}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:a,overrides:v}=C.compare(s,void 0);return{keys:[...r,...i,...a],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const a=this._memoryConfigurationByResource.get(t);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((v,g)=>(v.set(I.URI.revive(g[0]),this.parseConfigurationModel(g[1])),v),new R.ResourceMap);return new w(s,r,new f,i,a,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,s=new Map;for(const i of m)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,v])=>{const g=R.getOrSet(s,a,new Set);v.forEach(_=>g.add(_))});const r=[];return s.forEach((i,a)=>r.push([a,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=b;class h{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(g=>a.add(g)),t.overrides.forEach(([,g])=>g.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const v=new f;this.affectedKeys.forEach(g=>v.setValue(g,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!A.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=C.toValuesTree({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=h;class u extends h{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=u}),define(fe[116],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=p.createDecorator("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,I=R.Unknown,E){super(A);this._message=A,this._code=I,this._detail=E,this.isHandled=I===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(fe[81],me([0,1,10]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===p.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function k(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=k;function y(C){return C.scheme!==p.Schemas.file&&C.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=y;function A(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=A;function I(C){return A(C)?.scheme}e.getVirtualWorkspaceScheme=I;function E(C){return A(C)!==void 0}e.isVirtualWorkspace=E}),define(fe[189],me([0,1,3,11,4,12]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=k.createDecorator("tunnelService");var A;(function(f){f.Http="http",f.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=n;function P(f,l){return l?l!==1&&f<1024:!R.isWindows&&f<1024}e.isPortPrivileged=P;let d=class{constructor(l){this.logService=l,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,c){return this._tunnelProvider=l,l?(this._canElevate=c.elevation,this._canMakePublic=c.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async l=>{const c=[],S=Array.from(this._tunnels.values());for(let w of S){const b=Array.from(w.values());for(let h of b){const u=await h.value;u&&c.push(u)}}l(c)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:c}of l.values())await c.then(S=>S?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,c,S,w,b=!1,h=!1,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${S} on local port ${w}.`),!l)return;c||(c="localhost");const m=this.retainOrCreateTunnel(l,c,S,w,b,h,u);return m?m.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==c||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,public:l.public,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this._tunnels.get(l.tunnelRemoteHost);if(c){const S=c.get(l.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,S))}}}}async tryDisposeTunnel(l,c,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const w=S.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(c),w}}async closeTunnel(l,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const S=this._tunnels.get(l);if(S&&S.has(c)){const w=S.get(c);w.refcount=0,await this.tryDisposeTunnel(l,c,w)}}addTunnelToMap(l,c,S){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(c,{refcount:1,value:S})}async removeEmptyTunnelFromMap(l,c){const S=this._tunnels.get(l);S&&(await S.get(c)||S.delete(c),S.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,c){let S=[l];C(l)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):n(l)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const w=S.map(b=>this._tunnels.get(b));for(const b of w){const h=b?.get(c);if(h)return h}}canTunnel(l){return!!E(l)}createWithProvider(l,c,S,w,b,h,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${S} on local port ${w}.`);const t={elevationRequired:b?P(w===void 0?S:w):!1},s={remoteAddress:{host:c,port:S},localAddressPort:w,public:h,protocol:u},r=l.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(c,S,r),r}};d=ze([We(0,y.ILogService)],d),e.AbstractTunnelService=d}),define(fe[190],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((k,y)=>X(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(k)}catch(y){}return k}}e.SignService=p}),define(fe[191],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,y,A=5){let I;return I=y(E=>{const C=typeof E=="string"?E:E.data;let n=this._terminalBufferMap.get(k);if(n){n.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(k),A);n={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),I.dispose()}},this._terminalBufferMap.set(k,n)}),I}stopBuffering(k){const y=this._terminalBufferMap.get(k);y&&y.dispose()}flushBuffer(k){const y=this._terminalBufferMap.get(k);y&&(this._terminalBufferMap.delete(k),this._callback(k,y.data.join("")))}}e.TerminalDataBufferer=p}),define(fe[46],me([0,1,2,22,4,24]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=k.createDecorator("contextService");var A;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function I(d){const f=d;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=I;function E(d){const f=d;return!!(f&&typeof f=="object"&&p.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=E;class C{constructor(f,l,c,S){this._id=f,this._configuration=c,this._ignorePathCasing=S,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(f,l){this.raw=l,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return R.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(d){return new n({uri:d,index:0,name:R.basenameOrAuthority(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(fe[192],me([0,1,4,158,46,2,11,9,22,134,54,10,74,29,81]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const c=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(N){return(typeof N=="string"?I.extname(N):E.extname(N))===c}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=p.createDecorator("workspacesService");function w(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function h(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=h;function u(N){const H=N;return typeof H?.id=="string"&&y.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=u;function m(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=m;function t(N){const H=N;return typeof H?.id=="string"&&y.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=t;function s(N){const H=N;if(H?.uri)return{id:H.id,uri:y.URI.revive(H.uri)};const F=N;if(F?.configPath)return{id:F.id,configPath:y.URI.revive(F.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=s;function r(N,H){return E.extUriBiasedIgnorePathCase.isEqualOrParent(N,H.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(N){return a(N)||v(N)}e.isStoredWorkspaceFolder=i;function a(N){const H=N;return typeof H?.path=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=a;function v(N){const H=N;return typeof H?.uri=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=v;function g(N,H,F,x,O=!A.isWindows,M){if(N.scheme!==x.scheme)return{name:F,uri:N.toString(!0)};let B=H?void 0:M.relativePath(x,N);if(B!==void 0)B.length===0?B=".":A.isWindows&&N.scheme===P.Schemas.file&&!O&&(B=B.replace(/\//g,"\\"));else if(N.scheme===P.Schemas.file)B=N.fsPath,A.isWindows&&(B=d.normalizeDriveLetter(B),O&&(B=f.toSlashes(B)));else{if(!M.isEqualAuthority(N.authority,x.authority))return{name:F,uri:N.toString(!0)};B=N.path}return{name:F,path:B}}e.getStoredWorkspaceFolder=g;function _(N,H,F){let x=[],O=new Set;const M=F.dirname(H);for(let B of N){let V;if(a(B))B.path&&(V=F.resolvePath(M,B.path));else if(v(B))try{V=y.URI.parse(B.uri),V.path[0]!=="/"&&(V=V.with({path:"/"+V.path}))}catch(ee){console.warn(ee)}if(V){let ee=F.getComparisonKey(V);if(!O.has(ee)){O.add(ee);const de=B.name||F.basenameOrAuthority(V);x.push(new k.WorkspaceFolder({uri:V,name:de,index:x.length},B))}}}return x}e.toWorkspaceFolders=_;function D(N,H,F,x,O){let M=o(H,N);const B=O.dirname(H),V=O.dirname(x),ee=[],de=T(M.folders);for(const Ne of M.folders){const Ge=a(Ne)?O.resolvePath(B,Ne.path):y.URI.parse(Ne.uri);let Ve;F?Ve=!1:Ve=!a(Ne)||I.isAbsolute(Ne.path),ee.push(g(Ge,Ve,Ne.name,V,de,O))}const ye={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Fe=C.setProperty(N,["folders"],ee,ye);let Re=C.applyEdits(N,Fe);return M.remoteAuthority===l.getRemoteAuthority(x)&&(Re=C.applyEdits(Re,C.removeProperty(Re,["remoteAuthority"],ye))),Re}e.rewriteWorkspaceFileForNewLocation=D;function o(N,H){let F=n.parse(H);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(x=>i(x));else throw new Error(`${N} looks like an invalid workspace file.`);return F}function T(N){return A.isWindows?N.some(H=>a(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function $(N){return typeof N.folderUri=="string"}function W(N){return typeof N.fileUri=="string"}function Q(N,H){const F={workspaces:[],files:[]};if(N){const x=function(M,B){for(let V=0;V<M.length;V++)try{B(M[V],V)}catch(ee){H.warn(`Error restoring recent entry ${JSON.stringify(M[V])}: ${ee.toString()}. Skip entry.`)}},O=N;if(Array.isArray(O.entries))x(O.entries,M=>{const B=M.label,V=M.remoteAuthority;L(M)?F.workspaces.push({label:B,remoteAuthority:V,workspace:{id:M.workspace.id,configPath:y.URI.parse(M.workspace.configPath)}}):$(M)?F.workspaces.push({label:B,remoteAuthority:V,folderUri:y.URI.parse(M.folderUri)}):W(M)&&F.files.push({label:B,remoteAuthority:V,fileUri:y.URI.parse(M.fileUri)})});else{const M=N;Array.isArray(M.workspaces3)&&x(M.workspaces3,(B,V)=>{const ee=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[V]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?F.workspaces.push({label:ee,workspace:{id:B.id,configPath:y.URI.parse(B.configURIPath)}}):typeof B=="string"&&F.workspaces.push({label:ee,folderUri:y.URI.parse(B)})}),Array.isArray(M.files2)&&x(M.files2,(B,V)=>{const ee=Array.isArray(M.fileLabels)&&M.fileLabels[V]||void 0;typeof B=="string"&&F.files.push({label:ee,fileUri:y.URI.parse(B)})})}}return F}e.restoreRecentlyOpened=Q;function z(N){const H={entries:[]};for(const F of N.workspaces)b(F)?H.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):H.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of N.files)H.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return H}e.toStoreData=z}),define(fe[82],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const y=this._idPool++;return this._data.set(y,k),this.logDebugInfo(),y}get(k,y){return this._data.has(k)?this._data.get(k)[y]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(fe[47],me([0,1,2,3,4]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=k.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(E=>({name:E.name,group:E.group,resource:p.URI.revive(E.resource),isActive:E.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(fe[59],me([0,1,10,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,I){I===null?this._providerInfo.delete(A):this._providerInfo.set(A,I)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(fe[27],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=p.createDecorator("IExtHostInitDataService")}),define(fe[193],me([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class R{constructor(y,A,I){this._extHostNotebooks=A,this._textDocumentsAndEditors=I}$willAddInteractiveDocument(y,A,I,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],modeId:I,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(p.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=R}),define(fe[194],me([0,1,18]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,I,E){this._deferredPromises=new Map,this._id=A,this._shared=I,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const P of C.values())P.error(n)}})()},0)}get keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,I){let E=this._value[A];return typeof E=="undefined"&&(E=I),E}update(A,I){this._value[A]=I;let E=this._deferredPromises.get(A);if(E!==void 0)return E.p;const C=new p.DeferredPromise;return this._deferredPromises.set(A,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(A,I){super(A.identifier.value,!0,I);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(fe[195],me([0,1,3,2,12]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(I,E){this._logService=I,this._notebooksAndEditors=E,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,E,C){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I)).acceptModelChanged(E,C)}$acceptDirtyStateChanged(I,E){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I)).acceptDirty(E)}$acceptModelSaved(I){const E=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}$acceptDocumentPropertiesChanged(I,E){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,E);const C=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I));C.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=ze([We(0,k.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(fe[13],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=p.createDecorator("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[196],me([0,1,26,3]),function(X,e,p,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(I,E){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(I.identifier),it(this,k,E,"f"),Ue(this,k,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(I){return Ue(this,k,"f").get(this._id,I)}store(I,E){return Ue(this,k,"f").store(this._id,I,E)}delete(I){return Ue(this,k,"f").delete(this._id,I)}}e.ExtensionSecrets=y,k=new WeakMap}),define(fe[117],me([0,1,4,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=p.createDecorator("IExtHostTelemetry")}),define(fe[118],me([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,y=A=>{let I=k.get(A);return I||(I={children:new Map,bus:new p.Emitter},k.set(A,I)),I};e.getPrivateApiFor=y}),define(fe[48],me([0,1,4,3,13]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(I){function E(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}I.fromApiTunnel=E;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}I.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=p.createDecorator("IExtHostTunnelService");let A=class{constructor(E){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,C){return{dispose:()=>{}}}async $providePortAttributes(E,C,n,P,d){return[]}async $forwardPort(E,C){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([We(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[7],me([0,1,17,15,95,24,98,14,2,32,41,116,118]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";var f,l,c,S,w,b,h,u,m,t,s,r,i,a,v,g,_,D,o,T;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(j){function U(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(U,j),Object.setPrototypeOf(U.prototype,j.prototype),U}let $=w=class{constructor(U){f.set(this,void 0),it(this,f,U,"f")}static from(...U){let ne=U;return new w(function(){if(ne){for(const Ie of ne)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();ne=void 0}})}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),it(this,f,void 0,"f"))}};f=new WeakMap,$=w=ze([L],$),e.Disposable=$;let W=b=class{constructor(U,ne){if(U<0)throw R.illegalArgument("line must be non-negative");if(ne<0)throw R.illegalArgument("character must be non-negative");this._line=U,this._character=ne}static Min(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let Ie=1;Ie<U.length;Ie++){const Qe=U[Ie];Qe.isBefore(ne)&&(ne=Qe)}return ne}static Max(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let Ie=1;Ie<U.length;Ie++){const Qe=U[Ie];Qe.isAfter(ne)&&(ne=Qe)}return ne}static isPosition(U){if(!U)return!1;if(U instanceof b)return!0;let{line:ne,character:Ie}=U;return typeof ne=="number"&&typeof Ie=="number"}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ne=0){if(U===null||ne===null)throw R.illegalArgument();let Ie;return typeof U=="undefined"?Ie=0:typeof U=="number"?Ie=U:(Ie=typeof U.lineDelta=="number"?U.lineDelta:0,ne=typeof U.characterDelta=="number"?U.characterDelta:0),Ie===0&&ne===0?this:new b(this.line+Ie,this.character+ne)}with(U,ne=this.character){if(U===null||ne===null)throw R.illegalArgument();let Ie;return typeof U=="undefined"?Ie=this.line:typeof U=="number"?Ie=U:(Ie=typeof U.line=="number"?U.line:this.line,ne=typeof U.character=="number"?U.character:this.character),Ie===this.line&&ne===this.character?this:new b(Ie,ne)}toJSON(){return{line:this.line,character:this.character}}};W=b=ze([L],W),e.Position=W;let Q=h=class{constructor(U,ne,Ie,Qe){let nt,st;if(typeof U=="number"&&typeof ne=="number"&&typeof Ie=="number"&&typeof Qe=="number"?(nt=new W(U,ne),st=new W(Ie,Qe)):U instanceof W&&ne instanceof W&&(nt=U,st=ne),!nt||!st)throw new Error("Invalid arguments");nt.isBefore(st)?(this._start=nt,this._end=st):(this._start=st,this._end=nt)}static isRange(U){return U instanceof h?!0:U?W.isPosition(U.start)&&W.isPosition(U.end):!1}get start(){return this._start}get end(){return this._end}contains(U){return U instanceof h?this.contains(U._start)&&this.contains(U._end):U instanceof W?!(U.isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ne=W.Max(U.start,this._start),Ie=W.Min(U.end,this._end);if(!ne.isAfter(Ie))return new h(ne,Ie)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ne=W.Min(U.start,this._start),Ie=W.Max(U.end,this.end);return new h(ne,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ne=this.end){if(U===null||ne===null)throw R.illegalArgument();let Ie;return U?W.isPosition(U)?Ie=U:(Ie=U.start||this.start,ne=U.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&ne.isEqual(this.end)?this:new h(Ie,ne)}toJSON(){return[this.start,this.end]}};Q=h=ze([L],Q),e.Range=Q;let z=u=class extends Q{constructor(U,ne,Ie,Qe){let nt,st;if(typeof U=="number"&&typeof ne=="number"&&typeof Ie=="number"&&typeof Qe=="number"?(nt=new W(U,ne),st=new W(Ie,Qe)):U instanceof W&&ne instanceof W&&(nt=U,st=ne),!nt||!st)throw new Error("Invalid arguments");super(nt,st);this._anchor=nt,this._active=st}static isSelection(U){return U instanceof u?!0:U?Q.isRange(U)&&W.isPosition(U.anchor)&&W.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=u=ze([L],z),e.Selection=z;class N{constructor(U,ne,Ie){if(typeof U!="string"||U.length===0)throw R.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw R.illegalArgument("port");if(typeof Ie!="undefined"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw R.illegalArgument("connectionToken");this.host=U,this.port=Math.round(ne),this.connectionToken=Ie}}e.ResolvedAuthority=N;class H extends Error{constructor(U,ne=P.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(U);this._message=U,this._code=ne,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(U,ne){return new H(U,P.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(U){return new H(U,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var F;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(F=e.EndOfLine||(e.EndOfLine={}));var x;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let O=m=class{constructor(U,ne){this._range=U,this._newText=ne}static isTextEdit(U){return U instanceof m?!0:U?Q.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ne){return new m(U,ne)}static insert(U,ne){return m.replace(new Q(U,U),ne)}static delete(U){return m.replace(U,"")}static setEndOfLine(U){const ne=new m(new Q(new W(0,0),new W(0,0)),"");return ne.newEol=U,ne}get range(){return this._range}set range(U){if(U&&!Q.isRange(U))throw R.illegalArgument("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw R.illegalArgument("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw R.illegalArgument("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};O=m=ze([L],O),e.TextEdit=O;var M;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let B=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ne,Ie,Qe){this._edits.push({_type:1,from:U,to:ne,options:Ie,metadata:Qe})}createFile(U,ne,Ie){this._edits.push({_type:1,from:void 0,to:U,options:ne,metadata:Ie})}deleteFile(U,ne,Ie){this._edits.push({_type:1,from:U,to:void 0,options:ne,metadata:Ie})}replaceNotebookMetadata(U,ne,Ie){this._edits.push({_type:3,metadata:Ie,uri:U,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(U,ne,Ie,Qe,nt){let st,ot,St=[],It;if(Wt.isNotebookRange(ne)&&Ot.isNotebookCellDataArray(Ie)&&!Ot.isNotebookCellDataArray(Qe)?(st=ne.start,ot=ne.end,St=Ie,It=Qe):typeof ne=="number"&&typeof Ie=="number"&&Ot.isNotebookCellDataArray(Qe)&&(st=ne,ot=Ie,St=Qe,It=nt),st===void 0||ot===void 0)throw new Error("Invalid arguments");(st!==ot||St.length>0)&&this._edits.push({_type:5,uri:U,index:st,count:ot-st,cells:St,metadata:It})}replaceNotebookCellMetadata(U,ne,Ie,Qe){this._edits.push({_type:3,metadata:Qe,uri:U,edit:{editType:8,index:ne,metadata:Ie}})}replace(U,ne,Ie,Qe){this._edits.push({_type:2,uri:U,edit:new O(ne,Ie),metadata:Qe})}insert(U,ne,Ie,Qe){this.replace(U,new Q(ne,ne),Ie,Qe)}delete(U,ne,Ie){this.replace(U,ne,"",Ie)}has(U){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===U.toString())}set(U,ne){if(ne)for(const Ie of ne)Ie&&this._edits.push({_type:2,uri:U,edit:Ie});else{for(let Ie=0;Ie<this._edits.length;Ie++){const Qe=this._edits[Ie];Qe._type===2&&Qe.uri.toString()===U.toString()&&(this._edits[Ie]=void 0)}p.coalesceInPlace(this._edits)}}get(U){const ne=[];for(let Ie of this._edits)Ie._type===2&&Ie.uri.toString()===U.toString()&&ne.push(Ie.edit);return ne}entries(){const U=new y.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Ie=U.get(ne.uri);Ie||(Ie=[ne.uri,[]],U.set(ne.uri,Ie)),Ie[1].push(ne.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};B=ze([L],B),e.WorkspaceEdit=B;let V=t=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=t._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ne=this._tabstop++){if(typeof U=="function"){const Ie=new t;Ie._tabstop=this._tabstop,U(Ie),this._tabstop=Ie._tabstop,U=Ie.value}else U=t._escape(U);return this.value+="${",this.value+=ne,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ne=this._tabstop++){const Ie=U.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(U,ne){if(typeof ne=="function"){const Ie=new t;Ie._tabstop=this._tabstop,ne(Ie),this._tabstop=Ie._tabstop,ne=Ie.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};V=t=ze([L],V),e.SnippetString=V;var ee;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ee=e.DiagnosticTag||(e.DiagnosticTag={}));var de;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(de=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ye=s=class{constructor(U,ne){if(this.uri=U,ne)if(ne instanceof Q)this.range=ne;else if(ne instanceof W)this.range=new Q(ne,ne);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof s?!0:U?Q.isRange(U.range)&&E.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ye=s=ze([L],ye),e.Location=ye;let Fe=class{constructor(U,ne){this.location=U,this.message=ne}static is(U){return U?typeof U.message=="string"&&U.location&&Q.isRange(U.location.range)&&E.URI.isUri(U.location.uri):!1}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.location.range.isEqual(ne.location.range)&&U.location.uri.toString()===ne.location.uri.toString()}};Fe=ze([L],Fe),e.DiagnosticRelatedInformation=Fe;let Re=class{constructor(U,ne,Ie=de.Error){if(!Q.isRange(U))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=U,this.message=ne,this.severity=Ie}toJSON(){return{severity:de[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.severity===ne.severity&&U.code===ne.code&&U.severity===ne.severity&&U.source===ne.source&&U.range.isEqual(ne.range)&&p.equals(U.tags,ne.tags)&&p.equals(U.relatedInformation,ne.relatedInformation,Fe.isEqual)}};Re=ze([L],Re),e.Diagnostic=Re;let Ne=class{constructor(U,ne){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ne}};Ne=ze([L],Ne),e.Hover=Ne;var Ge;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(U,ne=Ge.Text){this.range=U,this.kind=ne}toJSON(){return{range:this.range,kind:Ge[this.kind]}}};Ve=ze([L],Ve),e.DocumentHighlight=Ve;var qe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var q;(function(j){j[j.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let Z=r=class{constructor(U,ne,Ie,Qe,nt){this.name=U,this.kind=ne,this.containerName=nt,typeof Ie=="string"&&(this.containerName=Ie),Qe instanceof ye?this.location=Qe:Ie instanceof Q&&(this.location=new ye(Qe,Ie)),r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};Z=r=ze([L],Z),e.SymbolInformation=Z;let re=i=class{constructor(U,ne,Ie,Qe,nt){this.name=U,this.detail=ne,this.kind=Ie,this.range=Qe,this.selectionRange=nt,this.children=[],i.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(i.validate)}};re=i=ze([L],re),e.DocumentSymbol=re;var ae;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let J=class{constructor(U,ne){this.title=U,this.kind=ne}};J=ze([L],J),e.CodeAction=J;let se=a=class{constructor(U){this.value=U}append(U){return new a(this.value?this.value+a.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+a.sep)}};se.sep=".",se=a=ze([L],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let ve=class{constructor(U,ne){if(this.range=U,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ve=ze([L],ve),e.SelectionRange=ve;class Le{constructor(U,ne,Ie,Qe,nt,st){this.kind=U,this.name=ne,this.detail=Ie,this.uri=Qe,this.range=nt,this.selectionRange=st}}e.CallHierarchyItem=Le;class He{constructor(U,ne){this.fromRanges=ne,this.from=U}}e.CallHierarchyIncomingCall=He;class be{constructor(U,ne){this.fromRanges=ne,this.to=U}}e.CallHierarchyOutgoingCall=be;let Je=class{constructor(U,ne){this.range=U,this.command=ne}get isResolved(){return!!this.command}};Je=ze([L],Je),e.CodeLens=Je;let K=v=class{constructor(U,ne=!1){l.set(this,void 0),it(this,l,new k.MarkdownString(U,{supportThemeIcons:ne}),"f")}static isMarkdownString(U){return U instanceof v?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return Ue(this,l,"f").value}set value(U){Ue(this,l,"f").value=U}get isTrusted(){return Ue(this,l,"f").isTrusted}set isTrusted(U){Ue(this,l,"f").isTrusted=U}get supportThemeIcons(){return Ue(this,l,"f").supportThemeIcons}set supportThemeIcons(U){Ue(this,l,"f").supportThemeIcons=U}appendText(U){return Ue(this,l,"f").appendText(U),this}appendMarkdown(U){return Ue(this,l,"f").appendMarkdown(U),this}appendCodeblock(U,ne){return Ue(this,l,"f").appendCodeblock(ne??"",U),this}};l=new WeakMap,K=v=ze([L],K),e.MarkdownString=K;let ie=class{constructor(U,ne){this.label=U,this.documentation=ne}};ie=ze([L],ie),e.ParameterInformation=ie;let he=class{constructor(U,ne){this.label=U,this.documentation=ne,this.parameters=[]}};he=ze([L],he),e.SignatureInformation=he;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=ze([L],xe),e.SignatureHelp=xe;var $e;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})($e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor(U,ne,Ie){this.text=U,this.position=ne,this.kind=Ie}};ke=ze([L],ke),e.InlayHint=ke;var Ce;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Pe=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe=e.CompletionItemTag||(e.CompletionItemTag={}));let ce=class{constructor(U,ne){this.label=U,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ce=ze([L],ce),e.CompletionItem=ce;let ge=class{constructor(U=[],ne=!1){this.items=U,this.isIncomplete=ne}};ge=ze([L],ge),e.CompletionList=ge;let we=class{constructor(U,ne,Ie){this.text=U,this.range=ne,this.command=Ie}};we=ze([L],we),e.InlineSuggestion=we;let G=class{constructor(U){this.items=U}};G=ze([L],G),e.InlineSuggestions=G;var pe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(pe=e.ViewColumn||(e.ViewColumn={}));var _e;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(_e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Me;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Me=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var je;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(je=e.TextEditorRevealType||(e.TextEditorRevealType={}));var tt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Xe;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function U(ne){switch(ne){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ye=class{constructor(U,ne){if(ne&&!E.URI.isUri(ne))throw R.illegalArgument("target");if(!Q.isRange(U)||U.isEmpty)throw R.illegalArgument("range");this.range=U,this.target=ne}};Ye=ze([L],Ye),e.DocumentLink=Ye;let lt=class{constructor(U,ne,Ie,Qe){this.red=U,this.green=ne,this.blue=Ie,this.alpha=Qe}};lt=ze([L],lt),e.Color=lt;let ut=class{constructor(U,ne){if(ne&&!(ne instanceof lt))throw R.illegalArgument("color");if(!Q.isRange(U)||U.isEmpty)throw R.illegalArgument("range");this.range=U,this.color=ne}};ut=ze([L],ut),e.ColorInformation=ut;let Ee=class{constructor(U){if(!U||typeof U!="string")throw R.illegalArgument("label");this.label=U}};Ee=ze([L],Ee),e.ColorPresentation=Ee;var Se;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var le;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(le=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Y{constructor(U,ne,Ie){if(this.startIndex=U,this.length=ne,this.tooltip=Ie,typeof U!="number"||U<0)throw R.illegalArgument("startIndex");if(typeof ne!="number"||ne<1)throw R.illegalArgument("length");if(Ie!==void 0&&typeof Ie!="string")throw R.illegalArgument("tooltip")}}e.TerminalLink=Y;class Be{constructor(U){this.options=U,typeof U!="object"&&R.illegalArgument("options")}}e.TerminalProfile=Be;var De;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(De=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let Ke=g=class{constructor(U,ne){if(typeof U!="string"||typeof ne!="string")throw R.illegalArgument("name");this._id=U}static from(U){switch(U){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}get id(){return this._id}};Ke.Clean=new g("clean","Clean"),Ke.Build=new g("build","Build"),Ke.Rebuild=new g("rebuild","Rebuild"),Ke.Test=new g("test","Test"),Ke=g=ze([L],Ke),e.TaskGroup=Ke;function rt(j){let U="";for(let ne=0;ne<j.length;ne++)U+=j[ne].replace(/,/g,",,")+",";return U}let ft=class{constructor(U,ne,Ie){if(typeof U!="string")throw R.illegalArgument("process");this._args=[],this._process=U,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ie):this._options=ne)}get process(){return this._process}set process(U){if(typeof U!="string")throw R.illegalArgument("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)U.push(ne);return rt(U)}};ft=ze([L],ft),e.ProcessExecution=ft;let wt=class{constructor(U,ne,Ie){if(this._args=[],Array.isArray(ne)){if(!U)throw R.illegalArgument("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw R.illegalArgument("command");this._command=U,this._args=ne,this._options=Ie}else{if(typeof U!="string")throw R.illegalArgument("commandLine");this._commandLine=U,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw R.illegalArgument("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw R.illegalArgument("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)U.push(typeof ne=="string"?ne:ne.value);return rt(U)}};wt=ze([L],wt),e.ShellExecution=wt;var bt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class yt{constructor(U){this._callback=U}computeId(){return"customExecution"+C.generateUuid()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=yt;let kt=_=class{constructor(U,ne,Ie,Qe,nt,st){this.__deprecated=!1,this._definition=this.definition=U;let ot;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ie,this.execution=Qe,ot=nt,this.__deprecated=!0):ne===Et.Global||ne===Et.Workspace?(this.target=ne,this._name=this.name=Ie,this._source=this.source=Qe,this.execution=nt,ot=st):(this.target=ne,this._name=this.name=Ie,this._source=this.source=Qe,this.execution=nt,ot=st),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ft?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(U){if(U==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw R.illegalArgument("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ne=this._definition.type;(_.EmptyType===ne||_.ProcessType===ne||_.ShellType===ne||_.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};kt.ExtensionCallbackType="customExecution",kt.ProcessType="process",kt.ShellType="shell",kt.EmptyType="$empty",kt=_=ze([L],kt),e.Task=kt;var _t;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(U,ne=vt.None){this.collapsibleState=ne,E.URI.isUri(U)?this.resourceUri=U:this.label=U}};dt=ze([L],dt),e.TreeItem=dt;var vt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ht=class{constructor(U,ne){this.id=U,this.color=ne}};ht=ze([L],ht),e.ThemeIcon=ht,ht.File=new ht("file"),ht.Folder=new ht("folder");let xt=class{constructor(U){this.id=U}};xt=ze([L],xt),e.ThemeColor=xt;var Pt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Xt=class{constructor(U,ne){if(typeof U!="string"&&(!U||!E.URI.isUri(U)&&!E.URI.isUri(U.uri)))throw R.illegalArgument("base");if(typeof ne!="string")throw R.illegalArgument("pattern");typeof U=="string"?(this.baseFolder=E.URI.file(U),this.base=U):E.URI.isUri(U)?(this.baseFolder=U,this.base=U.fsPath):(this.baseFolder=U.uri,this.base=U.uri.fsPath),this.pattern=ne}};Xt=ze([L],Xt),e.RelativePattern=Xt;let Bt=class{constructor(U,ne,Ie,Qe){this.enabled=typeof U=="boolean"?U:!0,typeof ne=="string"&&(this.condition=ne),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};Bt=ze([L],Bt),e.Breakpoint=Bt;let Ct=class extends Bt{constructor(U,ne,Ie,Qe,nt){super(ne,Ie,Qe,nt);if(U===null)throw R.illegalArgument("location");this.location=U}};Ct=ze([L],Ct),e.SourceBreakpoint=Ct;let Yt=class extends Bt{constructor(U,ne,Ie,Qe,nt){super(ne,Ie,Qe,nt);this.functionName=U}};Yt=ze([L],Yt),e.FunctionBreakpoint=Yt;let Jt=class extends Bt{constructor(U,ne,Ie,Qe,nt,st,ot){super(Qe,nt,st,ot);if(!ne)throw R.illegalArgument("dataId");this.label=U,this.dataId=ne,this.canPersist=Ie}};Jt=ze([L],Jt),e.DataBreakpoint=Jt;let mt=class{constructor(U,ne,Ie){this.command=U,this.args=ne||[],this.options=Ie}};mt=ze([L],mt),e.DebugAdapterExecutable=mt;let Kt=class{constructor(U,ne){this.port=U,this.host=ne}};Kt=ze([L],Kt),e.DebugAdapterServer=Kt;let qt=class{constructor(U){this.path=U}};qt=ze([L],qt),e.DebugAdapterNamedPipeServer=qt;let Zt=class{constructor(U){this.implementation=U}};Zt=ze([L],Zt),e.DebugAdapterInlineImplementation=Zt;let en=class{constructor(U,ne){this.range=U,this.expression=ne}};en=ze([L],en),e.EvaluatableExpression=en;var At;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Qt=class{constructor(U,ne){this.range=U,this.text=ne}};Qt=ze([L],Qt),e.InlineValueText=Qt;let tn=class{constructor(U,ne,Ie=!0){this.range=U,this.variableName=ne,this.caseSensitiveLookup=Ie}};tn=ze([L],tn),e.InlineValueVariableLookup=tn;let jt=class{constructor(U,ne){this.range=U,this.expression=ne}};jt=ze([L],jt),e.InlineValueEvaluatableExpression=jt;let ct=class{constructor(U,ne){this.frameId=U,this.stoppedLocation=ne}};ct=ze([L],ct),e.InlineValueContext=ct;var _n;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(_n=e.FileChangeType||(e.FileChangeType={}));let Rt=D=class extends Error{constructor(U,ne=n.FileSystemProviderErrorCode.Unknown,Ie){super(E.URI.isUri(U)?U.toString(!0):U);this.code=Ie?.name??"Unknown",n.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}static FileExists(U){return new D(U,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(U){return new D(U,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(U){return new D(U,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(U){return new D(U,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(U){return new D(U,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(U){return new D(U,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Rt=D=ze([L],Rt),e.FileSystemError=Rt;let $t=class{constructor(U,ne,Ie){this.start=U,this.end=ne,this.kind=Ie}};$t=ze([L],$t),e.FoldingRange=$t;var dn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(dn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Sn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Sn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(hn=e.CommentMode||(e.CommentMode={}));class yn{constructor(U,ne=[]){this.tokenTypes=U,this.tokenModifiers=ne}}e.SemanticTokensLegend=yn;function fn(j){return typeof j=="undefined"||I.isStringArray(j)}class Ft{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ne=0,Ie=U.tokenTypes.length;ne<Ie;ne++)this._tokenTypeStrToInt.set(U.tokenTypes[ne],ne);for(let ne=0,Ie=U.tokenModifiers.length;ne<Ie;ne++)this._tokenModifierStrToInt.set(U.tokenModifiers[ne],ne)}}push(U,ne,Ie,Qe,nt){if(typeof U=="number"&&typeof ne=="number"&&typeof Ie=="number"&&typeof Qe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(U,ne,Ie,Qe,nt);if(Q.isRange(U)&&typeof ne=="string"&&fn(Ie))return this._push(U,ne,Ie);throw R.illegalArgument()}_push(U,ne,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Qe=U.start.line,nt=U.start.character,st=U.end.character-U.start.character,ot=this._tokenTypeStrToInt.get(ne);let St=0;if(Ie)for(const It of Ie){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(It);St|=1<<Lt>>>0}this._pushEncoded(Qe,nt,st,ot,St)}_pushEncoded(U,ne,Ie,Qe,nt){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Lt=0;for(let Ut=0;Ut<St;Ut++){let zt=this._data[5*Ut],cn=this._data[5*Ut+1];zt===0?(zt=It,cn+=Lt):zt+=It,this._data[5*Ut]=zt,this._data[5*Ut+1]=cn,It=zt,Lt=cn}}let st=U,ot=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=nt,this._prevLine=U,this._prevChar=ne}static _sortAndDeltaEncode(U){let ne=[];const Ie=U.length/5|0;for(let ot=0;ot<Ie;ot++)ne[ot]=ot;ne.sort((ot,St)=>{const It=U[5*ot],Lt=U[5*St];if(It===Lt){const Ut=U[5*ot+1],zt=U[5*St+1];return Ut-zt}return It-Lt});const Qe=new Uint32Array(U.length);let nt=0,st=0;for(let ot=0;ot<Ie;ot++){const St=5*ne[ot],It=U[St+0],Lt=U[St+1],Ut=U[St+2],zt=U[St+3],cn=U[St+4],Bn=It-nt,Gn=Bn===0?Lt-st:Lt,un=5*ot;Qe[un+0]=Bn,Qe[un+1]=Gn,Qe[un+2]=Ut,Qe[un+3]=zt,Qe[un+4]=cn,nt=It,st=Lt}return Qe}build(U){return this._dataIsSortedAndDeltaEncoded?new nn(new Uint32Array(this._data),U):new nn(Ft._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Ft;class nn{constructor(U,ne){this.resultId=ne,this.data=U}}e.SemanticTokens=nn;class rn{constructor(U,ne,Ie){this.start=U,this.deleteCount=ne,this.data=Ie}}e.SemanticTokensEdit=rn;class sn{constructor(U,ne){this.resultId=ne,this.edits=U}}e.SemanticTokensEdits=sn;var Dn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Cn;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Cn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Mt=class{constructor(){}};Mt.Back={iconPath:new ht("arrow-left")},Mt=ze([L],Mt),e.QuickInputButtons=Mt;var kn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(kn=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(U,ne,Ie){this.badge=U,this.tooltip=ne,this.color=Ie}static validate(U){if(U.badge&&U.badge.length!==1&&U.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=In;let on=class{constructor(U){this.kind=U}};on=ze([L],on),e.ColorTheme=on;var Pn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(U,ne){if(U<0)throw R.illegalArgument("start must be positive");if(ne<0)throw R.illegalArgument("end must be positive");U<=ne?(this._start=U,this._end=ne):(this._start=ne,this._end=U)}static isNotebookRange(U){return U instanceof Wt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let ne=this._start,Ie=this._end;return U.start!==void 0&&(ne=U.start),U.end!==void 0&&(Ie=U.end),ne===this._start&&Ie===this._end?this:new Wt(ne,Ie)}}e.NotebookRange=Wt;class Ot{constructor(U,ne,Ie,Qe,nt,st,ot){this.kind=U,this.value=ne,this.languageId=Ie,this.mime=Qe,this.outputs=nt??[],this.metadata=st,this.executionSummary=ot,Ot.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ne=>Ot.isNotebookCellData(ne))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Ot;class mn{constructor(U){this.cells=U}}e.NotebookData=mn;class Tt{constructor(U,ne){this.data=U,this.mime=ne;const Ie=A.normalizeMimeType(ne,!0);if(!Ie)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=Ie}static isNotebookCellOutputItem(U){return U instanceof Tt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ne={name:U.name,message:U.message,stack:U.stack};return Tt.json(ne,"application/vnd.code.notebook.error")}static stdout(U){return Tt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Tt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ne="application/octet-stream"){return new Tt(U,ne)}static text(U,ne=A.Mimes.text){const Ie=Ue(Tt,c,"f",S).encode(String(U));return new Tt(Ie,ne)}static json(U,ne="application/json"){const Ie=JSON.stringify(U,void 0,"	");return Tt.text(Ie,ne)}}e.NotebookCellOutputItem=Tt,c=Tt,S={value:new TextEncoder};class Oe{constructor(U,ne,Ie){this.items=Oe.ensureUniqueMimeTypes(U,!0),typeof ne=="string"?(this.id=ne,this.metadata=Ie):(this.id=C.generateUuid(),this.metadata=ne??Ie)}static isNotebookCellOutput(U){return U instanceof Oe?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&I.isArray(U.items)}static ensureUniqueMimeTypes(U,ne=!1){const Ie=new Set,Qe=new Set;for(let nt=0;nt<U.length;nt++){const st=U[nt],ot=A.normalizeMimeType(st.mime);if(!Ie.has(ot)){Ie.add(ot);continue}Qe.add(nt),ne&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Qe.size===0?U:U.filter((nt,st)=>!Qe.has(st))}}e.NotebookCellOutput=Oe;var an;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(an=e.NotebookCellKind||(e.NotebookCellKind={}));var gn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(gn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(gt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var An;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(An=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Tn{constructor(U,ne){this.text=U,this.alignment=ne}}e.NotebookCellStatusBarItem=Tn;var pn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class vn{constructor(U,ne=[]){this.uri=U,this.provides=p.asArray(ne)}}e.NotebookRendererScript=vn;let ln=class{constructor(U,ne){this.label=U,this.timestamp=ne}};ln=ze([L],ln),e.TimelineItem=ln;var Rn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Rn=e.ExtensionMode||(e.ExtensionMode={}));var Ln;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Ln=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class wn{constructor(U,ne){this.ranges=U,this.wordPattern=ne}}e.LinkedEditingRanges=wn;class Mn{constructor(U,ne){this._port=U,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var On;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var bn;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));const Nt=(j,U,ne,Ie)=>{let Qe=ne;return{enumerable:!0,configurable:!1,get(){return Qe},set(nt){Ie(Qe,nt)||(Qe=nt,j.bus.fire([3,U,nt]))}}},Ht=(j,U)=>j===U,te=(j,U)=>j===U?!0:!j||!U?!1:j.isEqual(U);class ue{constructor(U,ne,Ie=!1){this.tests=U,this.exclude=ne,this.debug=Ie}}e.TestRunRequest=ue;class Te{constructor(U,ne,Ie,Qe,nt){this.data=Qe;const st=d.getPrivateApiFor(this);if(Object.defineProperties(this,{id:{value:U,enumerable:!0,writable:!1},uri:{value:Ie,enumerable:!0,writable:!1},parent:{enumerable:!1,value:nt,writable:!1},children:{value:new y.ReadonlyMapView(st.children),enumerable:!0,writable:!1},range:Nt(st,"range",void 0,te),label:Nt(st,"label",ne,Ht),description:Nt(st,"description",void 0,Ht),runnable:Nt(st,"runnable",!0,Ht),debuggable:Nt(st,"debuggable",!1,Ht),canResolveChildren:Nt(st,"canResolveChildren",!1,Ht),busy:Nt(st,"busy",!1,Ht),error:Nt(st,"error",void 0,Ht)}),nt){if(!(nt instanceof Te))throw new Error(`The "parent" passed in for TestItem ${U} is invalid`);const ot=d.getPrivateApiFor(nt);if(ot.children.has(U))throw new Error(`Attempted to insert a duplicate test item ID ${U}`);ot.children.set(U,this),ot.bus.fire([0,this])}}invalidate(){return this.invalidateResults()}invalidateResults(){d.getPrivateApiFor(this).bus.fire([2])}dispose(){this.parent&&d.getPrivateApiFor(this.parent).children.delete(this.id),d.getPrivateApiFor(this).bus.fire([1])}}e.TestItemImpl=Te;let at=o=class{constructor(U){this.message=U,this.severity=bn.Error}static diff(U,ne,Ie){const Qe=new o(U);return Qe.expectedOutput=ne,Qe.actualOutput=Ie,Qe}};at=o=ze([L],at),e.TestMessage=at;let pt=class{constructor(U,ne){this.covered=U,this.total=ne}};pt=ze([L],pt),e.CoveredCount=pt;let Dt=T=class{constructor(U,ne,Ie,Qe){this.uri=U,this.statementCoverage=ne,this.branchCoverage=Ie,this.functionCoverage=Qe}static fromDetails(U,ne){const Ie=new pt(0,0),Qe=new pt(0,0),nt=new pt(0,0);for(const ot of ne)if("branches"in ot){Ie.total+=1,Ie.covered+=ot.executionCount>0?1:0;for(const St of ot.branches)Qe.total+=1,Qe.covered+=St.executionCount>0?1:0}else nt.total+=1,nt.covered+=ot.executionCount>0?1:0;const st=new T(U,Ie,Qe.total>0?Qe:void 0,nt.total>0?nt:void 0);return st.detailedCoverage=ne,st}};Dt=T=ze([L],Dt),e.FileCoverage=Dt;let Nn=class{constructor(U,ne,Ie=[]){this.executionCount=U,this.location=ne,this.branches=Ie}};Nn=ze([L],Nn),e.StatementCoverage=Nn;let Un=class{constructor(U,ne){this.executionCount=U,this.location=ne}};Un=ze([L],Un),e.BranchCoverage=Un;let xn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};xn=ze([L],xn),e.FunctionCoverage=xn;var Vn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(fe[119],me([0,1,51,10,8,145,107,7,17]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(l,c){c?C.set(l,c):C.delete(l)}e.setWordDefinitionFor=n;function P(l){return C.get(l)}e.getWordDefinitionFor=P;class d extends y.MirrorTextModel{constructor(c,S,w,b,h,u,m,t){super(S,w,b,h);this._proxy=c,this._languageId=u,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){p.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return E.equals(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===R.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(S){return S?c._getTextInRange(S):c.getText()},get eol(){return c._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(S){return c._lineAt(S)},offsetAt(S){return c._offsetAt(S)},positionAt(S){return c._positionAt(S)},validateRange(S){return c._validateRange(S)},validatePosition(S){return c._validatePosition(S)},getWordRangeAtPosition(S,w){return c._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(c){p.ok(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){p.ok(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const S=this._validateRange(c);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,b=S.start.line,h=S.end.line,u=[];u.push(this._lines[b].substring(S.start.character));for(let m=b+1;m<h;m++)u.push(this._lines[m]);return u.push(this._lines[h].substring(0,S.end.character)),u.join(w)}_lineAt(c){let S;if(c instanceof I.Position?S=c.line:typeof c=="number"&&(S=c),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new f(S,this._lines[S],S===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(c),w=this._lines[S.index].length;return new I.Position(S.index,Math.min(S.remainder,w))}_validateRange(c){if(!(c instanceof I.Range))throw new Error("Invalid argument");const S=this._validatePosition(c.start),w=this._validatePosition(c.end);return S===c.start&&w===c.end?c:new I.Range(S.line,S.character,w.line,w.character)}_validatePosition(c){if(!(c instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:S,character:w}=c,b=!1;if(S<0)S=0,w=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,b=!0;else{const h=this._lines[S].length;w<0?(w=0,b=!0):w>h&&(w=h,b=!0)}return b?new I.Position(S,w):c}_getWordRangeAtPosition(c,S){const w=this._validatePosition(c);if(!S)S=P(this._languageId);else if(k.regExpLeadsToEndlessLoop(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(S),this._lines[w.line],0);if(b)return new I.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=d;class f{constructor(c,S,w){this._line=c,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(fe[197],me([0,1,7,3,109,6,75,24,2,32]),function(X,e,p,R,k,y,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,f,l,c){this._notebook=l,this._selector=c,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(f.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const d=[],f=[];for(const l of this._notebook.getCells())l.kind===p.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),d.push(l.document.getText().length+1),f.push(l.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(d){if(!d){let w="";for(const b of this._cells)w+=b.document.getText()+`
`;return w=w.slice(0,-1),w}if(d.isEmpty)return"";const f=this.locationAt(d.start),l=this.locationAt(d.end),c=this._cells[this._cellUris.get(f.uri)??-1],S=this._cells[this._cellUris.get(l.uri)??-1];if(!c||!S)return"";if(c===S)return c.document.getText(new p.Range(f.range.start,l.range.end));{const w=c.document.getText(new p.Range(f.range.start,new p.Position(c.document.lineCount,0))),b=S.document.getText(new p.Range(new p.Position(0,0),l.range.end));return w+`
`+b}}offsetAt(d){const f=this._cellLines.getIndexOf(d.line),l=this._cellLengths.getPrefixSum(f.index-1),c=this._cells[f.index].document.offsetAt(d.with(f.remainder));return l+c}positionAt(d){if(typeof d=="number"){const l=this._cellLengths.getIndexOf(d),c=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(c)}const f=this._cellUris.get(d.uri);if(f!==void 0){const l=this._cellLines.getPrefixSum(f-1);return new p.Position(l+d.range.start.line,d.range.start.character)}return new p.Position(0,0)}locationAt(d){p.Range.isRange(d)||(d=new p.Range(d,d));const f=this._cellLines.getIndexOf(d.start.line);let l=f;d.isEmpty||(l=this._cellLines.getIndexOf(d.end.line));const c=new p.Position(f.remainder,d.start.character),S=new p.Position(l.remainder,d.end.character),w=new p.Range(c,S),b=this._cells[f.index];return new p.Location(b.document.uri,b.document.validateRange(w))}contains(d){return this._cellUris.has(d)}validateRange(d){const f=this.validatePosition(d.start),l=this.validatePosition(d.end);return d.with(f,l)}validatePosition(d){const f=this._cellLines.getIndexOf(d.line),l=new p.Position(f.remainder,d.character),c=this._cells[f.index].document.validatePosition(l),S=this._cellLines.getPrefixSum(f.index-1);return new p.Position(S+c.line,c.character)}}e.ExtHostNotebookConcatDocument=n}),define(fe[198],me([0,1,7,13,3]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(I){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let E=I==="light"?p.ColorThemeKind.Light:I==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=ze([We(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(fe[60],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=p.createDecorator("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(fe[199],me([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(E){let C=this.buffers.indexOf(E);return C<0&&(C=this.buffers.length,this.buffers.push(E)),C}}function k(I,E){if(E.serializeBuffersForPostMessage){const C=new R,n=(f,l)=>{if(l instanceof ArrayBuffer){const c=C.add(l);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(l)){const c=y(l);if(c){const S=C.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:c,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},P=JSON.stringify(I,n),d=C.buffers.map(f=>{const l=new Uint8Array(f);return p.VSBuffer.wrap(l)});return{message:P,buffers:d}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=k;function y(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(I,E){const C=E.map(d=>{const f=new ArrayBuffer(d.byteLength);return new Uint8Array(f).set(d.buffer),f}),n=E.length?(d,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const l=f,{index:c}=l,S=C[c];if(l.view)switch(l.view.type){case 1:return new Int8Array(S,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return f}:void 0;return{message:JSON.parse(I,n),arrayBuffers:C}}e.deserializeWebviewMessage=A}),define(fe[83],me([0,1,10,2]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,A){return y.scheme===p.Schemas.http||y.scheme===p.Schemas.https?y:(A&&A.authority&&A.isRemote&&y.scheme===p.Schemas.file&&(y=R.URI.from({scheme:p.Schemas.vscodeRemote,authority:A.authority,path:y.path})),R.URI.from({scheme:p.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k}),define(fe[200],me([0,1,3,6,83]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(I,E,C){this._proxy=I,this._editors=E,this._initData=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const n=E.getVisibleTextEditors();for(const P of this._insets.values())n.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,E,C,n,P){let d;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===I){d=h;break}if(!d)throw new Error("not a visible editor");const f=this,l=this._handlePool++,c=new p.Emitter,S=new p.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return k.asWebviewUri(h,f._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(h){this._options=h,f._proxy.$setOptions(l,h)}get options(){return this._options}set html(h){this._html=h,f._proxy.$setHtml(l,h)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(h){return f._proxy.$postMessage(l,h)}},b=new class{constructor(){this.editor=I,this.line=E,this.height=C,this.webview=w,this.onDidDispose=S.event}dispose(){f._insets.has(l)&&(f._insets.delete(l),f._proxy.$disposeEditorInset(l),S.fire(),S.dispose(),c.dispose())}};return this._proxy.$createEditorInset(l,d.id,d.value.document.uri,E+1,C,n||{},P.identifier,P.extensionLocation),this._insets.set(l,{editor:I,inset:b,onDidReceiveMessage:c}),b}$onDidDispose(I){const E=this._insets.get(I);E&&E.inset.dispose()}$onDidReceiveMessage(I,E){const C=this._insets.get(I);C&&C.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=y}),define(fe[120],me([0,1,3,18,168]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,E,C,n){const P={command:I};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.internalSend("request",P),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const f=this.pendingRequests.get(P.seq);if(f){this.pendingRequests.delete(P.seq);const l={type:"response",seq:0,request_seq:P.seq,success:!1,command:I,message:k.localize(0,null,n,I)};f(l)}},n)}return C&&this.pendingRequests.set(P.seq,C),P.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,E){return I.type!=="event"||E.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await R.timeout(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const E=I,C=this.pendingRequests.get(E.request_seq);C&&(this.pendingRequests.delete(E.request_seq),C(E));break}}}internalSend(I,E){E.type=I,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((E,C)=>I.set(C,E)),await R.timeout(500),I.forEach((E,C)=>{E({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(fe[201],me([0,1,8,2,9,25,10]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function E(s,r,i){return s.replace(I,function(a,v){return r&&v.length>0&&v[0]!=="_"?a:i&&i.hasOwnProperty(v)?i[v]:a})}e.formatPII=E;function C(s){const r={};for(const i of Object.keys(s))i.startsWith("!")||(r[i]=s[i]);return r}e.filterExceptionsFromTelemetry=C;function n(s){return s.configuration.request==="attach"&&!P(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function P(s){let r=s.configuration.type;if(!!r)return r==="vslsShare"&&(r=s.configuration.adapterProxy.configuration.type),p.equalsIgnoreCase(r,"extensionhost")||p.equalsIgnoreCase(r,"pwa-extensionhost")?s:s.parentSession?P(s.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=d;function f(s,r,i){let a,v=0,g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=g.exec(s);){let D=_.index+1,o=D+_[0].length;if(D<=r&&o>=i){a=_[0],v=D;break}}if(a){let D=/\w+/g,o=null;for(;(o=D.exec(a))&&!(o.index+1+v+o[0].length>=i););o&&(a=a.substring(0,D.lastIndex))}return a?{start:v,end:v+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(s){return!!(s&&s.match(l))}e.isUri=c;function S(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(c(s.path))return R.URI.parse(s.path);if(k.isAbsolute(s.path))return R.URI.file(s.path)}return s.path}function w(s){if(typeof s.path=="object"){const r=R.URI.revive(s.path);if(r)return r.scheme===A.Schemas.file?r.fsPath:r.toString()}return s.path}function b(s,r){const i=r?S:w,a=y.deepClone(s);return u(a,(v,g)=>{v&&g&&(g.path=i(g))}),a}e.convertToDAPaths=b;function h(s,r){const i=r?S:w,a=y.deepClone(s);return u(a,(v,g)=>{!v&&g&&(g.path=i(g))}),a}e.convertToVSCPaths=h;function u(s,r){switch(s.type){case"event":const i=s;switch(i.event){case"output":r(!1,i.body.source);break;case"loadedSource":r(!1,i.body.source);break;case"breakpoint":r(!1,i.body.breakpoint.source);break;default:break}break;case"request":const a=s;switch(a.command){case"setBreakpoints":r(!0,a.arguments.source);break;case"breakpointLocations":r(!0,a.arguments.source);break;case"source":r(!0,a.arguments.source);break;case"gotoTargets":r(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(g=>r(!1,g));break;default:break}break;case"response":const v=s;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(g=>r(!1,g.source));break;case"loadedSources":v.body.sources.forEach(g=>r(!1,g));break;case"scopes":v.body.scopes.forEach(g=>r(!1,g.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(g=>r(!1,g.source));break;case"setBreakpoints":v.body.breakpoints.forEach(g=>r(!1,g.source));break;default:break}break}}function m(s){return s.filter(r=>!r.presentation?.hidden).sort((r,i)=>r.presentation?i.presentation?r.presentation.group?i.presentation.group?r.presentation.group!==i.presentation.group?r.presentation.group.localeCompare(i.presentation.group):t(r.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(r.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function t(s,r){return typeof s!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:s-r}}),define(fe[202],me([0,1,28,38,169,121,9,8,25,11,179,120]),function(X,e,p,R,k,y,A,I,E,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class d extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",u=>this.handleData(u))}sendMessage(b){if(this.outputStream){const h=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${d.TWO_CRLF}${h}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+h))}continue}}else{const h=this.rawData.indexOf(d.TWO_CRLF);if(h!==-1){const m=this.rawData.toString("utf8",0,h).split(d.HEADER_LINESEPARATOR);for(const t of m){const s=t.split(d.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(h+d.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=d,d.TWO_CRLF=`\r
\r
`,d.HEADER_LINESEPARATOR=/\r?\n/,d.HEADER_FIELDSEPARATOR=/: */;class f extends d{startSession(){return new Promise((b,h)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",m=>{u?this._onError.fire(m):h(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class l extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=l;class c extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=c;class S extends d{constructor(b,h,u){super();this.adapterExecutable=b,this.debugType=h,this.outputService=u}async startSession(){const b=this.adapterExecutable.command,h=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await p.Promises.exists(b))throw new Error(k.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let m=process.env;if(u.env&&Object.keys(u.env).length>0&&(m=E.mixin(E.deepClone(process.env),u.env)),b==="node")if(Array.isArray(h)&&h.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(r.cwd=u.cwd);const i=R.fork(h[0],h.slice(1),r);if(!i.pid)throw new Error(k.localize(2,null,h[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const s={env:m};u.cwd&&(s.cwd=u.cwd),this.serverProcess=R.spawn(b,h,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,r)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(s(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((b,h)=>{const u=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,t,s){if(m)return h(m)});u.on("exit",b),u.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,h){if(!b)return;const u=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?u.runtime=A.join(h,b.runtime):u.runtime=b.runtime),b.runtimeArgs&&(u.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?u.program=b.program:u.program=A.join(h,b.program)),b.args&&(u.args=b.args);const m=b;return m.win&&(u.win=S.extract(m.win,h)),m.winx86&&(u.winx86=S.extract(m.winx86,h)),m.windows&&(u.windows=S.extract(m.windows,h)),m.osx&&(u.osx=S.extract(m.osx,h)),m.linux&&(u.linux=S.extract(m.linux,h)),u}static platformAdapterExecutable(b,h){let u=Object.create(null);h=h.toLowerCase();for(const a of b)if(a.contributes){const v=a.contributes.debuggers;v&&v.length>0&&v.filter(g=>typeof g.type=="string"&&I.equalsIgnoreCase(g.type,h)).forEach(g=>{const _=S.extract(g,a.extensionLocation.fsPath);u=E.mixin(u,_,a.isBuiltin)})}let m;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=u.winx86||u.win||u.windows:C.isWindows?m=u.win||u.windows:C.isMacintosh?m=u.osx:C.isLinux&&(m=u.linux),m=m||u;let t=m.program||u.program;const s=m.args||u.args;let r=m.runtime||u.runtime;const i=m.runtimeArgs||u.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=S}),define(fe[203],me([0,1,38,11,29,182]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(d,f){return new Promise((l,c)=>{let S="";const w=p.spawn(d,f);w.pid&&w.stdout.on("data",b=>{S+=b.toString()}),w.on("error",b=>{c(b)}),w.on("close",b=>{l(S)})})}let I;function E(d,f){if(!I)if(R.isWindows)I=new y.WindowsExternalTerminalService;else if(R.isMacintosh)I=new y.MacExternalTerminalService;else if(R.isLinux)I=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=f.getConfiguration("terminal");return I.runInTerminal(d.title,d.cwd,d.args,d.env||{},l.external||{})}e.runInExternalTerminal=E;function C(d){return d?R.isWindows?new Promise(async f=>{(await new Promise((c,S)=>{X(["windows-process-tree"],c,S)})).getProcessTree(d,c=>{f(c.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(d)]).then(f=>{const l=f.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=C;var n;(function(d){d[d.cmd=0]="cmd",d[d.powershell=1]="powershell",d[d.bash=2]="bash"})(n||(n={}));function P(d,f,l,c){d=d.trim().toLowerCase();let S;d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0?S=1:d.indexOf("cmd.exe")>=0?S=0:d.indexOf("bash")>=0?S=2:R.isWindows?S=0:S=2;let w,b=" ";switch(S){case 1:if(w=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),l){const u=k.getDriveLetter(l);u&&(b+=`${u}:; `),b+=`cd ${w(l)}; `}if(c)for(let u in c){const m=c[u];m===null?b+=`Remove-Item env:${u}; `:b+=`\${env:${u}}='${m}'; `}if(f.length>0){const u=w(f.shift());b+=u[0]==="'"?`& ${u} `:`${u} `;for(let m of f)b+=`${w(m)} `}break;case 0:if(w=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),l){const u=k.getDriveLetter(l);u&&(b+=`${u}: && `),b+=`cd ${w(l)} && `}if(c){b+='cmd /C "';for(let u in c){let m=c[u];m===null?b+=`set "${u}=" && `:(m=m.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${u}=${m}" && `)}}for(let u of f)b+=`${w(u)} `;c&&(b+='"');break;case 2:w=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const h=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(l&&(b+=`cd ${w(l)} ; `),c){b+="/usr/bin/env";for(let u in c){const m=c[u];m===null?b+=` -u ${h(u)}`:b+=` ${h(`${u}=${m}`)}`}b+=" "}for(let u of f)b+=`${w(u)} `;break}return b}e.prepareCommand=P}),define(fe[84],me([0,1,30,98,10,9,11,78]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var E;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(E=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var S;(function(o){o.scheme=k.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function L(N,H){return N.with({scheme:o.scheme,fragment:`ch${H.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generate=L;function $(N){if(N.scheme!==o.scheme)return;const H=T.exec(N.fragment);return H?{handle:Number(H[1]),notebook:N.with({scheme:N.fragment.substr(H[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parse=$;function W(N){if(N.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const H=T.exec(N.fragment);return H?{handle:Number(H[1]),notebook:N.with({scheme:N.fragment.substr(H[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=W;function Q(N,H,F){return N.with({scheme:F,fragment:`ch${H.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generateCellUri=Q;function z(N,H){if(N.scheme!==H)return;const F=T.exec(N.fragment);return F?{handle:Number(F[1]),notebook:N.with({scheme:N.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellUri=z})(S=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(o){return w.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function h(o){return w.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=h;function u(o){return w.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=u;function m(o,T){return A.isWindows&&(o=o.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),p.match(o,T)}function t(o,T,L){let $=0;for(let W=0;W<T.length;W++){if(m(T[W],o))return $;$++}for(let W=0;W<L.length;W++){if(m(L[W],o))return $;$++}return $}function s(o,T,L){return o.sort(($,W)=>t($,T,L)-t(W,T,L))}e.sortMimeTypes=s;function r(o,T,L,$=(W,Q)=>W===Q){const W=[];function Q(H,F,x){if(F===0&&x.length===0)return;const O=W[W.length-1];O&&O.start+O.deleteCount===H?(O.deleteCount+=F,O.toInsert.push(...x)):W.push({start:H,deleteCount:F,toInsert:x})}let z=0,N=0;for(;;){if(z===o.length){Q(z,0,T.slice(N));break}if(N===T.length){Q(z,o.length-z,[]);break}const H=o[z],F=T[N];if($(H,F)){z+=1,N+=1;continue}L(F)?(Q(z,1,[]),z+=1):(Q(z,0,[F]),N+=1)}return W}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(o){const T=o;return!!((typeof T.include=="string"||p.isRelativePattern(T.include))&&(typeof T.exclude=="string"||p.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=a;function v(o,T,L){if(Array.isArray(o.viewType)&&o.viewType.indexOf(T)>=0||o.viewType===T)return!0;if(o.filenamePattern){let $=a(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,W=a(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(p.match($,y.basename(L.fsPath).toLowerCase()))return!(W&&p.match(W,y.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class g{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)T[L]=this.textModel.cells[L].getHashValue();return T}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var _;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(_=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class D{static create(T){return`${D._prefix}${T}`}static parse(T){if(T.startsWith(D._prefix))return T.substr(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/"}),define(fe[204],me([0,1,171,4,78]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[205],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=p;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(fe[122],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const p=C=>({testId:C.item.extId,controllerId:C.controllerId});e.identifyTest=p;var R;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(C,n)=>{n.expand!==void 0&&(C.expand=n.expand),n.item!==void 0&&(C.item=C.item?Object.assign(C.item,n.item):n.item)};e.applyTestItemUpdate=k;var y;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var A;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(n){}update(n){}remove(n,P){}complete(){}}e.IncrementalChangeCollector=I;class E{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(n){const P=this.createChangeCollector();for(const d of n)switch(d[0]){case 0:{const f=d[1];if(f.parent){if(this.items.has(f.parent)){const l=this.items.get(f.parent);l.children.add(f.item.extId);const c=this.createItem(f,l);this.items.set(f.item.extId,c),P.add(c)}}else{const l=this.createItem(f);this.roots.add(l),this.items.set(f.item.extId,l),P.add(l)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=d[1],l=this.items.get(f.extId);if(!l)break;f.expand!==void 0&&(l.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(l,f),P.update(l);break}case 2:{const f=this.items.get(d[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const l=[[d[1]]];for(;l.length;)for(const c of l.pop()){const S=this.items.get(c);S&&(l.push(S.children),this.items.delete(c),P.remove(S,S!==f),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d[1]);break;case 3:this.updatePendingRoots(d[1]);break}P.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=E}),define(fe[206],me([0,1,9,37,14,25,11,74,172]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(P,d,f){this._contributedVariables=new Map,this._context=P,this._labelService=d,f&&(this._envVariablesPromise=f.then(l=>this.prepareEnv(l)))}prepareEnv(P){if(A.isWindows){const d=Object.create(null);return Object.keys(P).forEach(f=>{d[f.toLowerCase()]=P[f]}),d}return P}resolveWithEnvironment(P,d,f){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,f)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,f,l){const c=y.deepClone(d);return A.isWindows&&c.windows?Object.keys(c.windows).forEach(S=>c[S]=c.windows[S]):A.isMacintosh&&c.osx?Object.keys(c.osx).forEach(S=>c[S]=c.osx[S]):A.isLinux&&c.linux&&Object.keys(c.linux).forEach(S=>c[S]=c.linux[S]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c,f,l)}async resolveAnyAsync(P,d,f){return this.resolveAnyBase(P,d,f)}async resolveAnyMap(P,d,f){const l=new Map;return{newConfig:await this.resolveAnyBase(P,d,f,l),resolvedVariables:l}}resolveWithInteractionReplace(P,d,f,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,f,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,f,l,c){if(k.isString(f))return this.resolveString(P,d,f,l,c);if(k.isArray(f))return f.map(S=>this.recursiveResolve(P,d,S,l,c));if(k.isObject(f)){let S=Object.create(null);return Object.keys(f).forEach(w=>{const b=this.resolveString(P,d,w,l,c);S[b]=this.recursiveResolve(P,d,f[w],l,c)}),S}return f}resolveString(P,d,f,l,c){return f.replace(C.VARIABLE_REGEXP,(w,b)=>{if(b.includes(C.VARIABLE_LHS))return w;let h=this.evaluateSingleVariable(P,w,b,d,l);return c&&c.set(b,h),h!==w&&k.isString(h)&&h.match(C.VARIABLE_REGEXP)&&(h=this.resolveString(P,d,h,l,c)),h})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,f,l,c){let S;const w=f.split(":");w.length>1&&(f=w[0],S=w[1]);const b=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error(E.localize(0,null,d))},h=()=>{const m=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(E.localize(1,null,d,p.basename(m)))},u=()=>{if(S){const m=this._context.getFolderUri(S);if(m)return m;throw new Error(E.localize(2,null,d,S))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error(E.localize(3,null,d)):new Error(E.localize(4,null,d))};switch(f){case"env":if(S){if(P){const m=P[A.isWindows?S.toLowerCase():S];if(k.isString(m))return m}return""}throw new Error(E.localize(5,null,d));case"config":if(S){const m=this._context.getConfigurationValue(l,S);if(k.isUndefinedOrNull(m))throw new Error(E.localize(6,null,d,S));if(k.isObject(m))throw new Error(E.localize(7,null,d,S));return m}throw new Error(E.localize(8,null,d));case"command":return this.resolveFromMap(d,S,c,"command");case"input":return this.resolveFromMap(d,S,c,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return I.normalizeDriveLetter(this.fsPath(u()));case"cwd":return l||S?I.normalizeDriveLetter(this.fsPath(u())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(u()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error(E.localize(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(E.localize(10,null,d));case"file":return b();case"fileWorkspaceFolder":return h();case"relativeFile":return l||S?p.relative(this.fsPath(u()),b()):b();case"relativeFileDirname":const s=p.dirname(b());if(l||S){const v=p.relative(this.fsPath(u()),s);return v.length===0?".":v}return s;case"fileDirname":return p.dirname(b());case"fileExtname":return p.extname(b());case"fileBasename":return p.basename(b());case"fileBasenameNoExtension":const r=p.basename(b());return r.slice(0,r.length-p.extname(r).length);case"fileDirnameBasename":return p.basename(p.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||d;case"execInstallFolder":const a=this._context.getAppRoot();return a||d;case"pathSeparator":return p.sep;default:try{const v=S?`${f}:${S}`:f;return this.resolveFromMap(d,v,c,void 0)}catch(v){return d}}}}resolveFromMap(P,d,f,l){if(d&&f){const c=l===void 0?f[d]:f[l+":"+d];if(typeof c=="string")return c;throw new Error(E.localize(11,null,P))}return P}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[123],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=p.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(fe[16],me([0,1,17,95,282,56,25,14,2,40,77,173,113,84,123,7]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(Ee){function Se(Y){const{selectionStartLineNumber:Be,selectionStartColumn:De,positionLineNumber:Ze,positionColumn:Ke}=Y,rt=new c.Position(Be-1,De-1),ft=new c.Position(Ze-1,Ke-1);return new c.Selection(rt,ft)}Ee.to=Se;function le(Y){const{anchor:Be,active:De}=Y;return{selectionStartLineNumber:Be.line+1,selectionStartColumn:Be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}Ee.from=le})(S=e.Selection||(e.Selection={}));var w;(function(Ee){function Se(Y){if(!Y)return;const{start:Be,end:De}=Y;return{startLineNumber:Be.line+1,startColumn:Be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}Ee.from=Se;function le(Y){if(!Y)return;const{startLineNumber:Be,startColumn:De,endLineNumber:Ze,endColumn:Ke}=Y;return new c.Range(Be-1,De-1,Ze-1,Ke-1)}Ee.to=le})(w=e.Range||(e.Range={}));var b;(function(Ee){function Se(le){switch(le){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 4:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Ee.to=Se})(b=e.TokenType||(e.TokenType={}));var h;(function(Ee){function Se(Y){return new c.Position(Y.lineNumber-1,Y.column-1)}Ee.to=Se;function le(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ee.from=le})(h=e.Position||(e.Position={}));var u;(function(Ee){function Se(Y){switch(Y){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Ee.from=Se;function le(Y){switch(Y){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Ee.to=le})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Ee){function Se(Y){let Be;return Y.code&&(I.isString(Y.code)||I.isNumber(Y.code)?Be=String(Y.code):Be={value:String(Y.code.value),target:Y.code.target}),{...w.from(Y.range),message:Y.message,source:Y.source,code:Be,severity:s.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?p.coalesce(Y.tags.map(u.from)):void 0}}Ee.from=Se;function le(Y){const Be=new c.Diagnostic(w.to(Y),Y.message,s.to(Y.severity));return Be.source=Y.source,Be.code=I.isString(Y.code)?Y.code:Y.code?.value,Be.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Be.tags=Y.tags&&p.coalesce(Y.tags.map(u.to)),Be}Ee.to=le})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function Se(Y){return{...w.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ee.from=Se;function le(Y){return new c.DiagnosticRelatedInformation(new c.Location(Y.resource,w.to(Y)),Y.message)}Ee.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(Ee){function Se(Y){switch(Y){case c.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Ee.from=Se;function le(Y){switch(Y){case d.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Ee.to=le})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(Ee){function Se(Y){return typeof Y=="number"&&Y>=c.ViewColumn.One?Y-1:Y===c.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}Ee.from=Se;function le(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=le})(r=e.ViewColumn||(e.ViewColumn={}));function i(Ee){return typeof Ee.range!="undefined"}function a(Ee){return Ee.length===0?!0:!!i(Ee[0])}e.isDecorationOptionsArr=a;var v;(function(Ee){function Se(Ke){return Ke.map(Ee.from)}Ee.fromMany=Se;function le(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let rt;if(le(Ke)){const{language:Et,value:yt}=Ke;rt={value:"```"+Et+`
`+yt+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ke)?rt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?rt={value:Ke}:rt={value:""};const ft=Object.create(null);rt.uris=ft;const wt=Et=>{try{let yt=E.URI.parse(Et,!0);yt=yt.with({query:Be(yt.query,ft)}),ft[Et]=yt}catch(yt){}return""},bt=new k.Renderer;return bt.link=wt,bt.image=Et=>wt(R.parseHrefAndDimensions(Et).href),k(rt.value,{renderer:bt}),rt}Ee.from=Y;function Be(Ke,rt){if(!Ke)return Ke;let ft;try{ft=y.parse(Ke)}catch(bt){}if(!ft)return Ke;let wt=!1;return ft=A.cloneAndChange(ft,bt=>{if(E.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Et]=bt,wt=!0,Et}else return}),wt?JSON.stringify(ft):Ke}function De(Ke){const rt=new c.MarkdownString(Ke.value,Ke.supportThemeIcons);return rt.isTrusted=Ke.isTrusted,rt}Ee.to=De;function Ze(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Ee.from(Ke)}Ee.fromStrict=Ze})(v=e.MarkdownString||(e.MarkdownString={}));function g(Ee){return a(Ee)?Ee.map(Se=>({range:w.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?v.fromMany(Se.hoverMessage):Se.hoverMessage?v.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):Ee.map(Se=>({range:w.from(Se)}))}e.fromRangeOrRangeWithMessage=g;function _(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?E.URI.file(Ee):Ee}e.pathOrURIToURI=_;var D;(function(Ee){function Se(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?_(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}Ee.from=Se})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var o;(function(Ee){function Se(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?_(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?D.from(le.before):void 0,after:le.after?D.from(le.after):void 0}}Ee.from=Se})(o=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(Ee){function Se(le){if(typeof le=="undefined")return le;switch(le){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Se})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Ee){function Se(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?T.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?o.from(le.light):void 0,dark:le.dark?o.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?_(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?D.from(le.before):void 0,after:le.after?D.from(le.after):void 0}}Ee.from=Se})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Ee){function Se(Y){return{text:Y.newText,eol:Y.newEol&&K.from(Y.newEol),range:w.from(Y.range)}}Ee.from=Se;function le(Y){const Be=new c.TextEdit(w.to(Y.range),Y.text);return Be.newEol=typeof Y.eol=="undefined"?void 0:K.to(Y.eol),Be}Ee.to=le})($=e.TextEdit||(e.TextEdit={}));var W;(function(Ee){function Se(Y,Be,De){const Ze={edits:[]};if(Y instanceof c.WorkspaceEdit)for(let Ke of Y._allEntries())if(Ke._type===1)Ze.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const rt=Be?.getDocument(Ke.uri);Ze.edits.push({_type:2,resource:Ke.uri,edit:$.from(Ke.edit),modelVersionId:rt?.version,metadata:Ke.metadata})}else Ke._type===3?Ze.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:De?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&Ze.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:De?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(ge.from)}});return Ze}Ee.from=Se;function le(Y){const Be=new c.WorkspaceEdit;for(const De of Y.edits)De.edit?Be.replace(E.URI.revive(De.resource),w.to(De.edit.range),De.edit.text):Be.renameFile(E.URI.revive(De.oldUri),E.URI.revive(De.newUri),De.options);return Be}Ee.to=le})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Ee){const Se=Object.create(null);Se[c.SymbolKind.File]=0,Se[c.SymbolKind.Module]=1,Se[c.SymbolKind.Namespace]=2,Se[c.SymbolKind.Package]=3,Se[c.SymbolKind.Class]=4,Se[c.SymbolKind.Method]=5,Se[c.SymbolKind.Property]=6,Se[c.SymbolKind.Field]=7,Se[c.SymbolKind.Constructor]=8,Se[c.SymbolKind.Enum]=9,Se[c.SymbolKind.Interface]=10,Se[c.SymbolKind.Function]=11,Se[c.SymbolKind.Variable]=12,Se[c.SymbolKind.Constant]=13,Se[c.SymbolKind.String]=14,Se[c.SymbolKind.Number]=15,Se[c.SymbolKind.Boolean]=16,Se[c.SymbolKind.Array]=17,Se[c.SymbolKind.Object]=18,Se[c.SymbolKind.Key]=19,Se[c.SymbolKind.Null]=20,Se[c.SymbolKind.EnumMember]=21,Se[c.SymbolKind.Struct]=22,Se[c.SymbolKind.Event]=23,Se[c.SymbolKind.Operator]=24,Se[c.SymbolKind.TypeParameter]=25;function le(Be){return typeof Se[Be]=="number"?Se[Be]:6}Ee.from=le;function Y(Be){for(const De in Se)if(Se[De]===Be)return Number(De);return c.SymbolKind.Property}Ee.to=Y})(Q=e.SymbolKind||(e.SymbolKind={}));var z;(function(Ee){function Se(Y){switch(Y){case c.SymbolTag.Deprecated:return 1}}Ee.from=Se;function le(Y){switch(Y){case 1:return c.SymbolTag.Deprecated}}Ee.to=le})(z=e.SymbolTag||(e.SymbolTag={}));var N;(function(Ee){function Se(Y){return{name:Y.name,kind:Q.from(Y.kind),tags:Y.tags&&Y.tags.map(z.from),containerName:Y.containerName,location:M.from(Y.location)}}Ee.from=Se;function le(Y){const Be=new c.SymbolInformation(Y.name,Q.to(Y.kind),Y.containerName,M.to(Y.location));return Be.tags=Y.tags&&Y.tags.map(z.to),Be}Ee.to=le})(N=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(Ee){function Se(Y){const Be={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:w.from(Y.range),selectionRange:w.from(Y.selectionRange),kind:Q.from(Y.kind),tags:Y.tags?.map(z.from)??[]};return Y.children&&(Be.children=Y.children.map(Se)),Be}Ee.from=Se;function le(Y){const Be=new c.DocumentSymbol(Y.name,Y.detail,Q.to(Y.kind),w.to(Y.range),w.to(Y.selectionRange));return p.isNonEmptyArray(Y.tags)&&(Be.tags=Y.tags.map(z.to)),Y.children&&(Be.children=Y.children.map(le)),Be}Ee.to=le})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(Ee){function Se(le){const Y=new c.CallHierarchyItem(Q.to(le.kind),le.name,le.detail||"",E.URI.revive(le.uri),w.to(le.range),w.to(le.selectionRange));return Y._sessionId=le._sessionId,Y._itemId=le._itemId,Y}Ee.to=Se})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(Ee){function Se(le){return new c.CallHierarchyIncomingCall(F.to(le.from),le.fromRanges.map(Y=>w.to(Y)))}Ee.to=Se})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(Ee){function Se(le){return new c.CallHierarchyOutgoingCall(F.to(le.to),le.fromRanges.map(Y=>w.to(Y)))}Ee.to=Se})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Ee){function Se(Y){return{range:Y.range&&w.from(Y.range),uri:Y.uri}}Ee.from=Se;function le(Y){return new c.Location(E.URI.revive(Y.uri),w.to(Y.range))}Ee.to=le})(M=e.location||(e.location={}));var B;(function(Ee){function Se(Y){const Be=Y,De=Y;return{originSelectionRange:Be.originSelectionRange?w.from(Be.originSelectionRange):void 0,uri:Be.targetUri?Be.targetUri:De.uri,range:w.from(Be.targetRange?Be.targetRange:De.range),targetSelectionRange:Be.targetSelectionRange?w.from(Be.targetSelectionRange):void 0}}Ee.from=Se;function le(Y){return{targetUri:E.URI.revive(Y.uri),targetRange:w.to(Y.range),targetSelectionRange:Y.targetSelectionRange?w.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?w.to(Y.originSelectionRange):void 0}}Ee.to=le})(B=e.DefinitionLink||(e.DefinitionLink={}));var V;(function(Ee){function Se(Y){return{range:w.from(Y.range),contents:v.fromMany(Y.contents)}}Ee.from=Se;function le(Y){return new c.Hover(Y.contents.map(v.to),w.to(Y.range))}Ee.to=le})(V=e.Hover||(e.Hover={}));var ee;(function(Ee){function Se(Y){return{range:w.from(Y.range),expression:Y.expression}}Ee.from=Se;function le(Y){return new c.EvaluatableExpression(w.to(Y.range),Y.expression)}Ee.to=le})(ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(Ee){function Se(Y){if(Y instanceof c.InlineValueText)return{type:"text",range:w.from(Y.range),text:Y.text};if(Y instanceof c.InlineValueVariableLookup)return{type:"variable",range:w.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Se;function le(Y){switch(Y.type){case"text":return{range:w.to(Y.range),text:Y.text};case"variable":return{range:w.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:w.to(Y.range),expression:Y.expression}}}Ee.to=le})(de=e.InlineValue||(e.InlineValue={}));var ye;(function(Ee){function Se(Y){return{frameId:Y.frameId,stoppedLocation:w.from(Y.stoppedLocation)}}Ee.from=Se;function le(Y){return new c.InlineValueContext(Y.frameId,w.to(Y.stoppedLocation))}Ee.to=le})(ye=e.InlineValueContext||(e.InlineValueContext={}));var Fe;(function(Ee){function Se(Y){return{range:w.from(Y.range),kind:Y.kind}}Ee.from=Se;function le(Y){return new c.DocumentHighlight(w.to(Y.range),Y.kind)}Ee.to=le})(Fe=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(Ee){function Se(le){switch(le){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Ee.to=Se})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(Ee){function Se(le){return{triggerKind:Re.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}Ee.to=Se})(Ne=e.CompletionContext||(e.CompletionContext={}));var Ge;(function(Ee){function Se(Y){switch(Y){case c.CompletionItemTag.Deprecated:return 1}}Ee.from=Se;function le(Y){switch(Y){case 1:return c.CompletionItemTag.Deprecated}}Ee.to=le})(Ge=e.CompletionItemTag||(e.CompletionItemTag={}));var Ve;(function(Ee){const Se=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function le(De){return Se.get(De)??9}Ee.from=le;const Y=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Be(De){return Y.get(De)??c.CompletionItemKind.Property}Ee.to=Be})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var qe;(function(Ee){function Se(le,Y){const Be=new c.CompletionItem(le.label);return Be.insertText=le.insertText,Be.kind=Ve.to(le.kind),Be.tags=le.tags?.map(Ge.to),Be.detail=le.detail,Be.documentation=R.isMarkdownString(le.documentation)?v.to(le.documentation):le.documentation,Be.sortText=le.sortText,Be.filterText=le.filterText,Be.preselect=le.preselect,Be.commitCharacters=le.commitCharacters,C.Range.isIRange(le.range)?Be.range=w.to(le.range):typeof le.range=="object"&&(Be.range={inserting:w.to(le.range.insert),replacing:w.to(le.range.replace)}),Be.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Be.insertText=new c.SnippetString(le.insertText):(Be.insertText=le.insertText,Be.textEdit=Be.range instanceof c.Range?new c.TextEdit(Be.range,Be.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Be.additionalTextEdits=le.additionalTextEdits.map(De=>$.to(De))),Be.command=Y&&le.command?Y.fromInternal(le.command):void 0,Be}Ee.to=Se})(qe=e.CompletionItem||(e.CompletionItem={}));var q;(function(Ee){function Se(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0}}Ee.from=Se;function le(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation}}Ee.to=le})(q=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(Ee){function Se(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(q.from):[],activeParameter:Y.activeParameter}}Ee.from=Se;function le(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(q.to):[],activeParameter:Y.activeParameter}}Ee.to=le})(Z=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(Ee){function Se(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(Z.from):[]}}Ee.from=Se;function le(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(Z.to):[]}}Ee.to=le})(re=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(Ee){function Se(Y){return{text:Y.text,position:h.from(Y.position),kind:J.from(Y.kind??c.InlayHintKind.Other),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}Ee.from=Se;function le(Y){const Be=new c.InlayHint(Y.text,h.to(Y.position),J.to(Y.kind));return Be.whitespaceAfter=Y.whitespaceAfter,Be.whitespaceBefore=Y.whitespaceBefore,Be}Ee.to=le})(ae=e.InlayHint||(e.InlayHint={}));var J;(function(Ee){function Se(Y){return Y}Ee.from=Se;function le(Y){return Y}Ee.to=le})(J=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(Ee){function Se(Y){return{range:w.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ee.from=Se;function le(Y){let Be;if(Y.url)try{Be=typeof Y.url=="string"?E.URI.parse(Y.url,!0):E.URI.revive(Y.url)}catch(De){}return new c.DocumentLink(w.to(Y.range),Be)}Ee.to=le})(se=e.DocumentLink||(e.DocumentLink={}));var ve;(function(Ee){function Se(Y){const Be=new c.ColorPresentation(Y.label);return Y.textEdit&&(Be.textEdit=$.to(Y.textEdit)),Y.additionalTextEdits&&(Be.additionalTextEdits=Y.additionalTextEdits.map(De=>$.to(De))),Be}Ee.to=Se;function le(Y){return{label:Y.label,textEdit:Y.textEdit?$.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Be=>$.from(Be)):void 0}}Ee.from=le})(ve=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(Ee){function Se(Y){return new c.Color(Y[0],Y[1],Y[2],Y[3])}Ee.to=Se;function le(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ee.from=le})(Le=e.Color||(e.Color={}));var He;(function(Ee){function Se(Y){return{range:w.from(Y.range)}}Ee.from=Se;function le(Y){return new c.SelectionRange(w.to(Y.range))}Ee.to=le})(He=e.SelectionRange||(e.SelectionRange={}));var be;(function(Ee){function Se(le){switch(le){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Ee.to=Se})(be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Ee){function Se(Y){switch(Y){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Se;function le(Y){switch(Y){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Ee.to=le})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var K;(function(Ee){function Se(Y){if(Y===c.EndOfLine.CRLF)return 1;if(Y===c.EndOfLine.LF)return 0}Ee.from=Se;function le(Y){if(Y===1)return c.EndOfLine.CRLF;if(Y===0)return c.EndOfLine.LF}Ee.to=le})(K=e.EndOfLine||(e.EndOfLine={}));var ie;(function(Ee){function Se(le){if(typeof le=="object")return le.viewId;switch(le){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Se})(ie=e.ProgressLocation||(e.ProgressLocation={}));var he;(function(Ee){function Se(le){const Y={start:le.start+1,end:le.end+1};return le.kind&&(Y.kind=xe.from(le.kind)),Y}Ee.from=Se})(he=e.FoldingRange||(e.FoldingRange={}));var xe;(function(Ee){function Se(le){if(le)switch(le){case c.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}Ee.from=Se})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(Ee){function Se(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?w.from(le.selection):void 0,override:typeof le.override=="boolean"?P.EditorOverride.DISABLED:void 0}}Ee.from=Se})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(Ee){function Se(Y){return Y instanceof c.RelativePattern||typeof Y=="string"?Y:le(Y)?new c.RelativePattern(Y.base,Y.pattern):Y}Ee.from=Se;function le(Y){const Be=Y;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var ke;(function(Ee){function Se(le){if(le){if(Array.isArray(le))return le.map(Se);if(typeof le=="string")return le;{const Y=le;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:et.from(Y.pattern),exclusive:Y.exclusive}}}else return}Ee.from=Se})(ke=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Ee){function Se(Y){return{start:Y.start,end:Y.end}}Ee.from=Se;function le(Y){return new c.NotebookRange(Y.start,Y.end)}Ee.to=le})(Ce=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(Ee){function Se(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ee.to=Se;function le(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ee.from=le})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var oe;(function(Ee){function Se(Y){switch(Y){case c.NotebookCellKind.Markup:return f.CellKind.Markup;case c.NotebookCellKind.Code:default:return f.CellKind.Code}}Ee.from=Se;function le(Y){switch(Y){case f.CellKind.Markup:return c.NotebookCellKind.Markup;case f.CellKind.Code:default:return c.NotebookCellKind.Code}}Ee.to=le})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var ce;(function(Ee){function Se(Y){const Be={metadata:Y.metadata??Object.create(null),cells:[]};for(let De of Y.cells)c.NotebookCellData.validate(De),Be.cells.push(ge.from(De));return Be}Ee.from=Se;function le(Y){const Be=new c.NotebookData(Y.cells.map(ge.to));return I.isEmptyObject(Y.metadata)||(Be.metadata=Y.metadata),Be}Ee.to=le})(ce=e.NotebookData||(e.NotebookData={}));var ge;(function(Ee){function Se(Y){return{cellKind:oe.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Pe.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(G.from):[]}}Ee.from=Se;function le(Y){return new c.NotebookCellData(oe.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(G.to):void 0,Y.metadata,Y.internalMetadata?Pe.to(Y.internalMetadata):void 0)}Ee.to=le})(ge=e.NotebookCellData||(e.NotebookCellData={}));var we;(function(Ee){function Se(Y){return{mime:Y.mime,valueBytes:Array.from(Y.data)}}Ee.from=Se;function le(Y){return new c.NotebookCellOutputItem(new Uint8Array(Y.valueBytes),Y.mime)}Ee.to=le})(we=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var G;(function(Ee){function Se(Y){return{outputId:Y.id,items:Y.items.map(we.from),metadata:Y.metadata}}Ee.from=Se;function le(Y){const Be=Y.items.map(we.to);return new c.NotebookCellOutput(Be,Y.outputId,Y.metadata)}Ee.to=le})(G=e.NotebookCellOutput||(e.NotebookCellOutput={}));var pe;(function(Ee){function Se(De){if(De!=null){if(De instanceof c.RelativePattern||typeof De=="string")return De;if(Be(De))return new c.RelativePattern(De.base,De.pattern);if(Y(De))return{include:et.from(De.include)||void 0,exclude:et.from(De.exclude)||void 0}}}Ee.from=Se;function le(De){return typeof De=="string"?De:Be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}Ee.to=le;function Y(De){const Ze=De,Ke=et.from(Ze.include);if(!(Ke&&Ke instanceof c.RelativePattern||typeof Ke=="string"))return!1;const rt=et.from(Ze.exclude);return!!(rt&&rt instanceof c.RelativePattern||typeof rt=="string")}function Be(De){const Ze=De;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _e;(function(Ee){function Se(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?D.from(le.top):void 0}}Ee.from=Se})(_e=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ae;(function(Ee){function Se(le,Y,Be){const De=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(De,Be),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}Ee.from=Se})(Ae=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Me;(function(Ee){function Se(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}Ee.from=Se})(Me=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var je;(function(Ee){function Se(Y){return{uri:Y.uri,provides:Y.provides}}Ee.from=Se;function le(Y){return new c.NotebookRendererScript(E.URI.revive(Y.uri),Y.provides)}Ee.to=le})(je=e.NotebookRendererScript||(e.NotebookRendererScript={}));var tt;(function(Ee){function Se(Y){return{message:v.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?M.from(Y.location):void 0}}Ee.from=Se;function le(Y){const Be=new c.TestMessage(typeof Y.message=="string"?Y.message:v.to(Y.message));return Be.severity=Y.severity,Be.actualOutput=Y.actualOutput,Be.expectedOutput=Y.expectedOutput,Be}Ee.to=le})(tt=e.TestMessage||(e.TestMessage={}));var Xe;(function(Ee){function Se(Ze){return{extId:Ze.id,label:Ze.label,uri:Ze.uri,range:w.from(Ze.range)||null,debuggable:Ze.debuggable??!1,description:Ze.description||null,runnable:Ze.runnable??!0,error:Ze.error&&v.fromStrict(Ze.error)||null}}Ee.from=Se;function le(Ze){return{extId:Ze.id,label:Ze.label,uri:Ze.uri,range:w.from(Ze.range)||null,debuggable:!1,description:Ze.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=le;function Y(Ze){return{id:Ze.extId,label:Ze.label,uri:E.URI.revive(Ze.uri),range:w.to(Ze.range||void 0),dispose:()=>{},invalidateResults:()=>{},canResolveChildren:!1,busy:!1,debuggable:Ze.debuggable,description:Ze.description||void 0,runnable:Ze.runnable}}Ee.toPlain=Y;function Be(Ze,Ke){const rt=new c.TestItemImpl(Ze.extId,Ze.label,E.URI.revive(Ze.uri),void 0,Ke);return rt.range=w.to(Ze.range||void 0),rt.debuggable=Ze.debuggable,rt.description=Ze.description||void 0,rt.runnable=Ze.runnable,rt}Ee.to=Be;function De(Ze){let Ke;for(const rt of Ze.tests)Ke=Be(rt.item,Ke);return Ke}Ee.toItemFromContext=De})(Xe=e.TestItem||(e.TestItem={}));var Ye;(function(Ee){const Se=(Y,Be)=>({...Xe.toPlain(Y.item),taskStates:Y.tasks.map(De=>({state:De.state,duration:De.duration,messages:De.messages.map(tt.to)})),children:Y.children.map(De=>Be.get(De)).filter(I.isDefined).map(De=>Se(De,Be))});function le(Y){const Be=[],De=new Map;for(const Ze of Y.items)De.set(Ze.item.extId,Ze),Ze.direct&&Be.push(Ze);return{completedAt:Y.completedAt,results:Be.map(Ze=>Se(Ze,De))}}Ee.to=le})(Ye=e.TestResults||(e.TestResults={}));var lt;(function(Ee){function Se(De){return{covered:De.covered,total:De.covered}}function le(De){return"line"in De?h.from(De):w.from(De)}function Y(De){return"branches"in De?{count:De.executionCount,location:le(De.location),type:1,branches:De.branches.length?De.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&le(Ze.location)})):void 0}:{type:0,count:De.executionCount,location:le(De.location)}}Ee.fromDetailed=Y;function Be(De){return{uri:De.uri,statement:Se(De.statementCoverage),branch:De.branchCoverage&&Se(De.branchCoverage),function:De.functionCoverage&&Se(De.functionCoverage),details:De.detailedCoverage?.map(Y)}}Ee.fromFile=Be})(lt=e.TestCoverage||(e.TestCoverage={}));var ut;(function(Ee){function Se(le){switch(le){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Ee.to=Se})(ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(fe[207],me([0,1,2,15,7,16,90]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(C,n,P,d={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,P,d)=>{const l={dispose:this._callbacks.push([n,P,C])};return Array.isArray(d)&&d.push(l),l}}async $participateInSave(C,n){const P=p.URI.revive(C);let d=!1;const f=setTimeout(()=>d=!0,this._thresholds.timeout),l=[];try{for(let c of[...this._callbacks]){if(d)break;const S=this._documents.getDocument(P),w=await this._deliverEventAsyncAndBlameBadListeners(c,{document:S,reason:y.TextDocumentSaveReason.to(n)});l.push(w)}}finally{clearTimeout(f)}return l}_deliverEventAsyncAndBlameBadListeners([C,n,P],d){const f=this._badListeners.get(C);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,C,n,d).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const c=this._badListeners.get(C);this._badListeners.set(C,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,P,d){const f=[],l=Date.now(),{document:c,reason:S}=d,{version:w}=c,b=Object.freeze({document:c,reason:S,waitUntil(h){if(Object.isFrozen(f))throw R.illegalState("waitUntil can not be called async");f.push(Promise.resolve(h))}});try{n.apply(P,[b])}catch(h){return Promise.reject(h)}return Object.freeze(f),new Promise((h,u)=>{const m=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(m),h(t)}).catch(t=>{clearTimeout(m),u(t)})}).then(h=>{const u={edits:[]};for(const m of h)if(Array.isArray(m)&&m.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:s,range:r}of m)u.edits.push({_type:2,resource:c.uri,edit:{range:r&&y.Range.from(r),text:t,eol:s&&y.EndOfLine.from(s)}});if(u.edits.length!==0)return w===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(fe[208],me([0,1,3,30,2,16,7]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(n,P,d,f,l){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,d&&(this._config+=1),f&&(this._config+=2),l&&(this._config+=4);const c=R.parse(P),S=n(w=>{if(!d)for(let b of w.created){const h=k.URI.revive(b);c(h.fsPath)&&this._onDidCreate.fire(h)}if(!f)for(let b of w.changed){const h=k.URI.revive(b);c(h.fsPath)&&this._onDidChange.fire(h)}if(!l)for(let b of w.deleted){const h=k.URI.revive(b);c(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class E{constructor(n,P,d){this._logService=P,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new p.AsyncEmitter,this._onWillCreateFile=new p.AsyncEmitter,this._onWillDeleteFile=new p.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,P,d,f){return new I(this._onFileSystemEvent.event,n,P,d,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,P){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(d=>k.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(d=>k.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,P){return(d,f,l)=>{const c=function(w){d.call(f,w)};return c.extension=n,P.event(c,void 0,l)}}async $onWillRunFileOperation(n,P,d,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(l=>({oldUri:k.URI.revive(l.source),newUri:k.URI.revive(l.target)}))},d,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(l=>k.URI.revive(l.target))},d,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(l=>k.URI.revive(l.target))},d,f)}}async _fireWillEvent(n,P,d,f){const l=new Set,c=[];if(await n.fireAsync(P,f,async(w,b)=>{const h=Date.now(),u=await Promise.resolve(w);u instanceof A.WorkspaceEdit&&(c.push(u),l.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-h>d&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||c.length===0)return;const S={edits:[]};for(let w of c){let{edits:b}=y.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(b)}return{edit:S,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=E}),define(fe[209],me([0,1,10,25,2,16,7,84]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(d,f,l,c){this.start=d,this.deletedCount=f,this.deletedItems=l,this.items=c}static asApiEvents(d){return d.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(l=>l.apiCell)}))}}class C{constructor(d,f,l){this.notebook=d,this._extHostDocument=f,this._cellData=l,this.handle=l.handle,this.uri=k.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=l.metadata??{},this._previousResult=y.NotebookCellExecutionSummary.to(l.internalMetadata??{})}static asModelAddData(d,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return d._mime},set mime(l){d._mime=l},get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(y.NotebookCellOutput.to)}setOutputItems(d,f,l){const c=l.map(y.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===d);S&&(f||(S.items.length=0),S.items.push(...c))}setMetadata(d){this._metadata=d}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=y.NotebookCellExecutionSummary.to(d)}setMime(d){}}e.ExtHostCell=C;class n{constructor(d,f,l,c,S,w){this._proxy=d,this._textDocumentsAndEditors=f,this._textDocuments=l,this._emitter=c,this.uri=S,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=w.metadata??Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get notebookType(){return d._notebookType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===p.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(f){return f=d._validateIndex(f),d._cells[f].apiCell},getCells(f){return(f?d._getCells(f):d._cells).map(c=>c.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata={...this._metadata,...d.metadata})}acceptDirty(d){this._isDirty=d}acceptModelChanged(d,f){this._versionId=d.versionId,this._isDirty=f;for(const l of d.rawEvents)l.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===I.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let f=d.start|0,l=d.end|0;return f<0&&(f=0),l>this._cells.length&&(l=this._cells.length),d.with({start:f,end:l})}_getCells(d){d=this._validateRange(d);const f=[];for(let l=d.start;l<d.end;l++)f.push(this._cells[l]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,f){if(this._disposed)return;const l=[],c=[],S=[];d.reverse().forEach(w=>{const h=w[2].map(t=>{const s=new C(this,this._textDocumentsAndEditors,t);return f||c.push(C.asModelAddData(this.apiNotebook,t)),s}),u=new E(w[0],w[1],[],h),m=this._cells.splice(w[0],w[1],...h);for(const t of m)S.push(t.uri),u.deletedItems.push(t.apiCell);l.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:S}),f||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:E.asApiEvents(l)}))}_moveCell(d,f){const l=this._cells.splice(d,1);this._cells.splice(f,0,...l);const c=[new E(d,1,l.map(S=>S.apiCell),[]),new E(f,0,[],l)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:E.asApiEvents(c)}))}_setCellOutputs(d,f){const l=this._cells[d];l.setOutputs(f),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(d,f,l,c){const S=this._cells[d];S.setOutputItems(f,l,c),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(d,f){const l=this._cells[d];l.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(l.uri,f)}_changeCellMime(d,f){const l=this._cells[d];l.apiCell.mime=f}_changeCellMetadata(d,f){const l=this._cells[d],c=l.apiCell.metadata;l.setMetadata(f);const S=l.apiCell.metadata;R.equals(c,S)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(d,f){const l=this._cells[d],c=l.internalMetadata;if(l.setInternalMetadata(f),c.runState!==f.runState){const S=f.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:l.apiCell,state:S}))}}getCellFromApiCell(d){return this._cells.find(f=>f.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(f=>f.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(fe[124],me([0,1,7,16,15]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:C})}replaceCells(E,C,n){this._throwIfFinalized(),!(E===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:E,count:C-E,cells:n.map(R.NotebookCellData.from)})}}class A{constructor(E,C,n,P,d,f){this.id=E,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._visibleRanges=P,this._viewColumn=f}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get selections(){return E._selections},set selections(C){if(!Array.isArray(C)||!C.every(p.NotebookRange.isNotebookRange))throw k.illegalArgument("selections");E._selections=C,E._trySetSelections(C)},get visibleRanges(){return E._visibleRanges},revealRange(C,n){E._proxy.$tryRevealRange(E.id,R.NotebookRange.from(C),n??p.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(C){const n=new y(this.document.version);return C(n),E._applyEdit(n.finalize())},setDecorations(C,n){return E.setDecorations(C,n)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(R.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let P=0;P<E.cellEdits.length;P++){if(n<0){C.push(E.cellEdits[P]),n++;continue}const f=C[n],l=E.cellEdits[P];if(f.editType===1&&l.editType===1&&f.index===l.index){f.cells.push(...E.cellEdits[P].cells),f.count+=E.cellEdits[P].count;continue}C.push(E.cellEdits[P]),n++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,C)}setDecorations(E,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return C.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(C),E.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[210],me([0,1,16,114,161,21,52]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,f){const l=this._handles++,{title:c,location:S,cancellable:w}=d,b={label:k.localize(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(l,{location:p.ProgressLocation.from(S),title:c,source:b,cancellable:w},P),this._withProgress(l,f,!!w)}_withProgress(P,d,f){let l;f&&(l=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,l));const c=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),l&&l.dispose()};let S;try{S=d(new C(this._proxy,P),f&&l?l.token:y.CancellationToken.None)}catch(w){throw c(P),w}return S.then(w=>c(P),w=>c(P)),S}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=I;function E(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class C extends R.Progress{constructor(P,d){super(f=>this.throttledReport(f));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}ze([A.throttle(100,(n,P)=>E(n,P),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(fe[125],me([0,1,51,15,70,16,7]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(d,f,l){const c=I._Keys.nextId();d.$registerTextEditorDecorationType(f.identifier,c,y.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:c,dispose(){d.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=I,I._Keys=new k.IdGenerator("TextEditorDecorationType");class E{constructor(d,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,f){this._throwIfFinalized();let l=null;if(d instanceof A.Position)l=new A.Range(d,d);else if(d instanceof A.Range)l=d;else throw new Error("Unrecognized location");this._pushEdit(l,f,!1)}insert(d,f){this._throwIfFinalized(),this._pushEdit(new A.Range(d,d),f,!0)}delete(d){this._throwIfFinalized();let f=null;if(d instanceof A.Range)f=d;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(d,f,l){const c=this._document.validateRange(d);this._collectedEdits.push({range:c,text:f,forceMoveMarkers:l})}setEndOfLine(d){if(this._throwIfFinalized(),d!==A.EndOfLine.LF&&d!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=E;class C{constructor(d,f,l,c){this._proxy=d,this._id=f,this._accept(l),this._logService=c;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const f=Math.floor(d);return f>0?f:null}if(typeof d=="string"){const f=parseInt(d,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(d){const f=this._validateTabSize(d);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const f=this._validateInsertSpaces(d);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(d)})))}assign(d){const f={};let l=!1;if(typeof d.tabSize!="undefined"){const c=this._validateTabSize(d.tabSize);c==="auto"?(l=!0,f.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,l=!0,f.tabSize=c)}if(typeof d.insertSpaces!="undefined"){const c=this._validateInsertSpaces(d.insertSpaces);c==="auto"?(l=!0,f.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,l=!0,f.insertSpaces=c)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,l=!0,f.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,l=!0,f.lineNumbers=y.TextEditorLineNumbersStyle.from(d.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(d){d.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=C;class n{constructor(d,f,l,c,S,w,b,h){this.id=d,this._proxy=f,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new C(this._proxy,this.id,w,l),this._visibleRanges=b,this._viewColumn=h;const u=this;this.value=Object.freeze({get document(){return c.getValue()},set document(m){throw R.readonly("document")},get selection(){return u._selections&&u._selections[0]},set selection(m){if(!(m instanceof A.Selection))throw R.illegalArgument("selection");u._selections=[m],u._trySetSelection()},get selections(){return u._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");u._selections=m,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(m){throw R.readonly("visibleRanges")},get options(){return u._options.value},set options(m){u._disposed||u._options.assign(m)},get viewColumn(){return u._viewColumn},set viewColumn(m){throw R.readonly("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(c.getValue(),t);return m(s),u._applyEdit(s)},insertSnippet(m,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=u._selections.map(i=>y.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:a}=y.Position.from(t);r=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.Range)r=[y.Range.from(t)];else{r=[];for(const i of t)if(i instanceof A.Range)r.push(y.Range.from(i));else{const{lineNumber:a,column:v}=y.Position.from(i);r.push({startLineNumber:a,startColumn:v,endLineNumber:a,endColumn:v})}}return f.$tryInsertSnippet(d,m.value,r,s)},setDecorations(m,t){const s=t.length===0;s&&!u._hasDecorationsForKey.has(m.key)||(s?u._hasDecorationsForKey.delete(m.key):u._hasDecorationsForKey.add(m.key),u._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return f.$trySetDecorations(d,m.key,y.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const v=t[i];r[4*i]=v.start.line+1,r[4*i+1]=v.start.character+1,r[4*i+2]=v.end.line+1,r[4*i+3]=v.end.character+1}return f.$trySetDecorationsFast(d,m.key,r)}}))},revealRange(m,t){u._runOnProxy(()=>f.$tryRevealRange(d,y.Range.from(m),t||A.TextEditorRevealType.Default))},show(m){f.$tryShowEditor(d,y.ViewColumn.from(m))},hide(){f.$tryHideEditor(d)}})}dispose(){p.ok(!this._disposed),this._disposed=!0}_acceptOptions(d){p.ok(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){p.ok(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){p.ok(!this._disposed),this._viewColumn=d}_acceptSelections(d){p.ok(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const f=d.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const l=f.edits.map(S=>S.range);l.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=l.length-1;S<w;S++){const b=l[S].end;if(l[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=f.edits.map(S=>({range:y.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,c,{setEndOfLine:typeof f.setEndOfLine=="number"?y.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(fe[211],me([0,1,164,22,2,3,6,18,7,14,17,16,21]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(S,w){if(C.isString(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let b;return Array.isArray(S.highlights)&&(b=S.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),b=b.length?b:void 0),{label:S.label,highlights:b}}}class l{constructor(w,b,h){this._proxy=w,this.commands=b,this.logService=h,this.treeViews=new Map;function u(m){return m&&m.$treeViewId&&m.$treeItemHandle}b.registerArgumentProcessor({processArgument:m=>u(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>u(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(w,b,h){const u=this.createTreeView(w,{treeDataProvider:b},h);return{dispose:()=>u.dispose()}}createTreeView(w,b,h){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=b.dragAndDropController!==void 0,m=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:u}),t=this.createExtHostTreeView(w,b,h);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,r)=>t.reveal(s,r),dispose:async()=>{await m,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,b){const h=this.treeViews.get(w);return h?h.getChildren(b):Promise.reject(new Error(p.localize(0,null,w)))}$onDrop(w,b,h){const u=this.treeViews.get(w);return u?u.onDrop(b,h):Promise.reject(new Error(p.localize(1,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error(p.localize(2,null,w));return b.hasResolve}$resolve(w,b,h){const u=this.treeViews.get(w);if(!u)throw new Error(p.localize(3,null,w));return u.resolveTreeItem(b,h)}$setExpanded(w,b,h){const u=this.treeViews.get(w);if(!u)throw new Error(p.localize(4,null,w));u.setExpanded(b,h)}$setSelection(w,b){const h=this.treeViews.get(w);if(!h)throw new Error(p.localize(5,null,w));h.setSelection(b)}$setVisible(w,b){const h=this.treeViews.get(w);if(!h)throw new Error(p.localize(6,null,w));h.setVisible(b)}createExtHostTreeView(w,b,h){const u=new c(w,b,this._proxy,this.commands.converter,this.logService,h);return this.treeViews.set(w,u),u}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=l;class c extends A.Disposable{constructor(w,b,h,u,m,t){super();if(this.viewId=w,this.proxy=h,this.commands=u,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const a of t.contributes.views[i])a.id===w&&(this._title=a.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(i=>this._onDidChangeData.fire({message:!1,element:i}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let s,r;this._register(y.Event.debounce(this._onDidChangeData.event,(i,a)=>(i||(i={message:!1,elements:[]}),a.element!==!1&&(s||(s=new Promise(v=>r=v),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(a.element)?i.elements.push(...a.element):i.elements.push(a.element)),a.message&&(i.message=!0),i),200,!0)(({message:i,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=r;return s=null,this.refresh(a).then(()=>v())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!C.isUndefinedOrNull(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const h=this.getChildrenNodes(w);return(h?Promise.resolve(h):this.fetchChildrenNodes(b)).then(u=>u.map(m=>m.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const h=C.isUndefinedOrNull(b.select)?!0:b.select,u=C.isUndefinedOrNull(b.focus)?!1:b.focus,m=C.isUndefinedOrNull(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(r=>r.item)},{select:h,focus:u,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:u,expand:m})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const h=this.getExtensionElement(w);h&&(b?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelection(w){n.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,b){const h=w.map(m=>this.getExtensionElement(m)).filter(m=>!C.isUndefinedOrNull(m)),u=this.getExtensionElement(b);return h&&u?I.asPromise(()=>this.dndController?.onDrop(h,u)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(w);if(h){const u=this.nodes.get(h);if(u){const m=await this.dataProvider.resolveTreeItem(u.extensionItem,h,b)??u.extensionItem;return u.item.tooltip=this.getTooltip(m.tooltip),u.item.command=this.getCommand(u.disposableStore,m.command),u.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(h=>this.resolveTreeNode(b,h[h.length-1]).then(u=>(h.push(u),h))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):I.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const h=this.nodes.get(w);return h?Promise.resolve(h):I.asPromise(()=>this.dataProvider.getTreeItem(w)).then(u=>this.createHandle(w,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const m=this.getExtensionElement(u);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const h=this.getExtensionElement(w);b=h?this.nodes.get(h):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=w?this.nodes.get(w):void 0,u=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const m=await Promise.all(n.coalesce(u||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,h):null}));return b.token.isCancellationRequested?[]:n.coalesce(m)}finally{b.dispose()}}refresh(w){if(w.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(w);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,h=w.map(m=>this.nodes.get(m));for(const m of h)if(m&&!b.has(m.item.handle)){let t=m;for(;t&&t.parent&&h.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&b.add(m.item.handle)}const u=[];return b.forEach(m=>{const t=this.elements.get(m);if(t){const s=this.nodes.get(t);s&&(!s.parent||!b.has(s.parent.item.handle))&&u.push(m)}}),u}refreshHandles(w){const b={};return Promise.all(w.map(h=>this.refreshNode(h).then(u=>{u&&(b[h]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const h=this.nodes.get(b);if(h)return this.clearChildren(b),I.asPromise(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const m=this.createTreeNode(b,u,h.parent);return this.updateNodeCache(b,m,h,h.parent),h.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,h){const u=this.createTreeNode(w,b,h);if(b.id&&this.elements.has(u.item.handle))throw new Error(p.localize(7,null,b.id));return this.addNodeToCache(w,u),this.addNodeToParentCache(u,h),u}getTooltip(w){return E.MarkdownString.isMarkdownString(w)?P.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,h){const u=new A.DisposableStore,m=this.createHandle(w,b,h),t=this.getLightIconPath(b);return{item:{handle:m,parentHandle:h?h.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:C.isUndefinedOrNull(b.collapsibleState)?E.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:h,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(w){return w.iconPath instanceof E.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:h,resourceUri:u},m,t){if(b)return`${c.ID_HANDLE_PREFIX}/${b}`;const s=f(h,this.extension),r=m?m.item.handle:c.LABEL_HANDLE_PREFIX;let i=s?s.label:u?R.basename(u):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const a=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,v=this.getChildrenNodes(m)||[];let g,_=0;do{if(g=`${r}/${_}:${i}`,t||!this.elements.has(g)||a===g)break;_++}while(_<=v.length);return g}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof E.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof E.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,h,u){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(w,b);const m=this.getChildrenNodes(u)||[],t=m.filter(s=>s.item.handle===h.item.handle)[0];t&&m.splice(m.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const h of b.children){const u=this.elements.get(h.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const h of b.children){const u=this.elements.get(h.item.handle);u&&this.clear(u)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}c.LABEL_HANDLE_PREFIX="0",c.ID_HANDLE_PREFIX="1"}),define(fe[212],me([0,1,167,14,2,6,4,78,45,17,123,10]),function(X,e,p,R,k,y,A,I,E,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptions=e.isEditorInputWithPreferredResource=e.UntypedEditorContext=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={Editors:"workbench.contributions.editors",Associations:"workbench.editors.associations",EditorInputFactories:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:p.localize(0,null),providerDisplayName:p.localize(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,p.localize(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,p.localize(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,p.localize(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,p.localize(5,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:p.localize(6,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",p.localize(7,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,p.localize(8,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,p.localize(9,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,p.localize(10,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,p.localize(11,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,p.localize(12,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,p.localize(13,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,p.localize(14,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,p.localize(15,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,p.localize(16,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,p.localize(17,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,p.localize(18,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,p.localize(19,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function d(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=d;function f(o){const T=o;return T.originalInput!==void 0&&T.modifiedInput!==void 0}e.isResourceDiffEditorInput=f;function l(o){const T=o;return T.resource===void 0||T.resource.scheme===P.Schemas.untitled}e.isUntitledResourceEditorInput=l;var c;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var S;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var w;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));var b;(function(o){o[o.Default=0]="Default",o[o.Full=1]="Full"})(b=e.UntypedEditorContext||(e.UntypedEditorContext={}));function h(o){const T=o;return T?k.URI.isUri(T.preferredResource):!1}e.isEditorInputWithPreferredResource=h;function u(o){const T=o;return T?!!T.primary&&!!T.secondary:!1}function m(o){const T=o;return!!T&&!!T.editor}e.isEditorInputWithOptions=m;function t(o){const T=o;return T?typeof T.groupId=="number"&&!R.isUndefinedOrNull(T.editor):!1}e.isEditorIdentifier=t;var s;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(s=e.SideBySideEditor||(e.SideBySideEditor={}));class r{getOriginalUri(T,L){if(!T)return;const $=u(T)?T.primary:f(T)?T.modifiedInput:void 0,W=u(T)?T.secondary:f(T)?T.originalInput:void 0;if(L?.supportSideBySide&&$&&W){if(L?.supportSideBySide===s.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:L.filterByScheme})};T=L.supportSideBySide===s.PRIMARY?$:W}if(f(T))return;const Q=h(T)?T.preferredResource:T.resource;return!Q||!L||!L.filterByScheme?Q:this.filterUri(Q,L.filterByScheme)}getCanonicalUri(T,L){if(!T)return;const $=u(T)?T.primary:f(T)?T.modifiedInput:void 0,W=u(T)?T.secondary:f(T)?T.originalInput:void 0;if(L?.supportSideBySide&&$&&W){if(L?.supportSideBySide===s.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:L.filterByScheme})};T=L.supportSideBySide===s.PRIMARY?$:W}if(f(T))return;const Q=T.resource;return!Q||!L||!L.filterByScheme?Q:this.filterUri(Q,L.filterByScheme)}filterUri(T,L){if(Array.isArray(L)){if(L.some($=>T.scheme===$))return T}else if(L===T.scheme)return T}}e.EditorResourceAccessor=new r;var i;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(i=e.CloseDirection||(e.CloseDirection={}));class a{constructor(){this.editorInputSerializerConstructors=new Map,this.editorInputSerializerInstances=new Map}start(T){const L=this.instantiationService=T.get(A.IInstantiationService);for(const[$,W]of this.editorInputSerializerConstructors)this.createEditorInputSerializer($,W,L);this.editorInputSerializerConstructors.clear()}createEditorInputSerializer(T,L,$){const W=$.createInstance(L);this.editorInputSerializerInstances.set(T,W)}registerFileEditorInputFactory(T){if(this.fileEditorInputFactory)throw new Error("Can only register one file editor input factory.");this.fileEditorInputFactory=T}getFileEditorInputFactory(){return R.assertIsDefined(this.fileEditorInputFactory)}registerEditorInputSerializer(T,L){if(this.editorInputSerializerConstructors.has(T)||this.editorInputSerializerInstances.has(T))throw new Error(`A editor input serializer with type ID '${T}' was already registered.`);return this.instantiationService?this.createEditorInputSerializer(T,L,this.instantiationService):this.editorInputSerializerConstructors.set(T,L),y.toDisposable(()=>{this.editorInputSerializerConstructors.delete(T),this.editorInputSerializerInstances.delete(T)})}getEditorInputSerializer(T){return this.editorInputSerializerInstances.get(typeof T=="string"?T:T.typeId)}}E.Registry.add(e.EditorExtensions.EditorInputFactories,new a);async function v(o,T){if(!o||!o.length)return[];const L=await Promise.all(o.map(async $=>{const W=k.URI.revive($.fileUri);if(!W||!T.canHandleResource(W))return;const Q=typeof $.exists=="boolean"?$.exists:await T.exists(W);if(!Q&&$.openOnlyIfExists)return;const z=Q&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let N;return Q?N={resource:W,options:z,forceFile:!0}:N={resource:W,options:z,forceUntitled:!0},N}));return C.coalesce(L)}e.pathsToEditors=v;var g;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(g=e.EditorsOrder||(e.EditorsOrder={}));function _(o,T){if(typeof T!="number"||T===n.ACTIVE_GROUP)return n.ACTIVE_GROUP;const L=o.getGroups(2);let $=L[T];if($)return $.id;let W=L[0];return L.length===1&&W.count===0?W.id:n.SIDE_GROUP}e.viewColumnToEditorGroup=_;function D(o,T){let L=typeof T=="number"?o.getGroup(T):T;return L=L??o.activeGroup,o.getGroups(2).indexOf(L)}e.editorGroupToViewColumn=D}),define(fe[213],me([0,1,3,6,17,212,22]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEditorInput=e.EditorInput=void 0;class I extends R.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new p.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new p.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDidChangeCapabilities=this._register(new p.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._onWillDispose=this._register(new p.Emitter),this.onWillDispose=this._onWillDispose.event,this.disposed=!1}get editorId(){}get capabilities(){return 2}hasCapability(n){return n===0?this.capabilities===0:(this.capabilities&n)!=0}getName(){return`Editor ${this.typeId}`}getLabelExtraClasses(){return[]}getDescription(n){}getTitle(n){return this.getName()}getAriaLabel(){return this.getTitle(0)}getTelemetryDescriptor(){return{typeId:this.typeId}}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(n,P){return this}async saveAs(n,P){return this}async revert(n,P){}rename(n,P){}copy(){return this}matches(n){if(E(n))return this===n;const P=n.options?.override;return this.editorId===void 0||this.editorId!==P?!1:A.isEqual(this.resource,y.EditorResourceAccessor.getCanonicalUri(n))}prefersEditor(n){return k.firstOrDefault(n)}toUntyped(n,P){}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onWillDispose.fire()),super.dispose()}}e.EditorInput=I;function E(C){return C instanceof I}e.isEditorInput=E}),define(fe[214],me([0,1,18,3,53,6,14,118,16,7,122]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var P;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));class d{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(c){if(this.map.has(c.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${c.item.extId}`);this.map.set(c.item.extId,c),c.parent||this._roots.add(c)}has(c){return this.map.has(c)}delete(c){const S=this.map.get(c);return S?(this.map.delete(c),this._roots.delete(S),!0):!1}get(c){return this.map.get(c)}comparePositions(c,S){const w=typeof c=="string"?this.map.get(c):c,b=typeof S=="string"?this.map.get(S):S;if(!w||!b)return 0;if(w===b)return 3;for(let h=this.map.get(b.parent);h;h=this.map.get(h.parent))if(h===w)return 1;for(let h=this.map.get(w.parent);h;h=this.map.get(h.parent))if(h===b)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=d;class f extends y.Disposable{constructor(c){super();this.controllerId=c,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new C.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new d,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(c){this._resolveHandler=c;for(const S of this.testItemToInternal.values())this.updateExpandability(S)}get roots(){return k.Iterable.filter(this.testItemToInternal.values(),c=>c.parent===null)}getTestByReference(c){return this.testItemToInternal.get(c)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const S=this.diff[this.diff.length-1];if(S&&c[0]===1){if(S[0]===1&&S[1].extId===c[1].extId){n.applyTestItemUpdate(S[1],c[1]);return}if(S[0]===0&&S[1].item.extId===c[1].extId){n.applyTestItemUpdate(S[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,S){const w=this.tree.get(c);if(!!w){if((w.expandLevels===void 0||S>w.expandLevels)&&(w.expandLevels=S),w.expand===1){const b=this.resolveChildren(w);return b.isOpen()?this.expandChildren(w,S-1):b.wait().then(()=>this.expandChildren(w,S-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.expandChildren(w,S-1)):this.expandChildren(w,S-1)}}dispose(){for(const c of this.testItemToInternal.values())I.getPrivateApiFor(c.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(c,S){const w=c?.actual.id;switch(S[0]){case 2:this.pushDiff([4,w]);break;case 1:this.removeItem(c);break;case 0:this.addItemInner(S[1],c);break;case 3:const[b,h,u]=S;switch(h){case"canResolveChildren":this.updateExpandability(c);break;case"range":this.pushDiff([1,{extId:w,item:{range:E.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:w,item:{error:E.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:w,item:{[h]:u??null}}]);break}break;default:A.assertNever(S[0])}}addItemInner(c,S){if(!(c instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);if(this.testItemToInternal.has(c))throw new Error(`Attempted to add a single TestItem ${c.id} multiple times to the tree`);if(this.tree.has(c.id))throw new Error(`Attempted to insert a duplicate test item ID ${c.id}`);const w=S?S.item.extId:null,b=S?S.expandLevels:1,h={actual:c,parent:w,item:E.TestItem.from(c),expandLevels:b?b-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(h),this.testItemToInternal.set(c,h),this.pushDiff([0,{parent:w,controllerId:this.controllerId,expand:h.expand,item:h.item}]);const u=I.getPrivateApiFor(c);u.bus.event(this.onTestItemEvent.bind(this,h)),this.updateExpandability(h);for(const m of u.children.values())this.testItemToInternal.has(m)||this.addItemInner(m,h)}updateExpandability(c){let S;this._resolveHandler?c.resolveBarrier?S=c.resolveBarrier.isOpen()?3:2:S=c.actual.canResolveChildren?1:0:S=0,S!==c.expand&&(c.expand=S,this.pushDiff([1,{extId:c.actual.id,expand:S}]),S===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,S){if(S<0)return;const w=[...c.actual.children.values()].map(b=>this.expand(b.id,S)).filter(p.isThenable);if(w.length)return Promise.all(w).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const b=new p.Barrier;return b.open(),b}c.expand=2,this.pushExpandStateUpdate(c);const S=c.resolveBarrier=new p.Barrier;let w;try{w=this._resolveHandler(c.actual)}catch(b){c.actual.error=b.stack||b.message}return p.isThenable(w)?w.catch(b=>c.actual.error=b.stack||b.message).then(()=>{S.open(),this.updateExpandability(c)}):(S.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.actual.id,expand:c.expand}])}removeItem(c){this.pushDiff([2,c.actual.id]);const S=[c];for(;S.length;){const w=S.pop();if(!!w){this.tree.delete(w.item.extId),this.testItemToInternal.delete(w.actual);for(const b of w.actual.children.values())S.push(this.tree.get(b.id))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=f}),define(fe[215],me([0,1,4,213]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=p.createDecorator("editorGroupsService");var k;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var y;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var I;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function C(c){const S=c;return!!S&&R.isEditorInput(S.editor)&&R.isEditorInput(S.replacement)}e.isEditorReplacement=C;var n;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.EDITOR_OPEN=2]="EDITOR_OPEN",c[c.EDITOR_CLOSE=3]="EDITOR_CLOSE",c[c.EDITOR_MOVE=4]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=6]="EDITOR_LABEL",c[c.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",c[c.EDITOR_PIN=8]="EDITOR_PIN",c[c.EDITOR_STICKY=9]="EDITOR_STICKY",c[c.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var d;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(d=e.OpenEditorContext||(e.OpenEditorContext={}));function f(c){const S=c;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=f;function l(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(fe[216],me([0,1,4,178]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=p.refineServiceDecorator(R.IEnvironmentService)}),define(fe[217],me([0,1,26,3,9]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class A{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${p.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(d=>P.add(p.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(p.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=A._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(f=>f.identifier)),P.length>0){const f=new Set;P.forEach(l=>f.add(p.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!f.has(p.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(d)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const b=P.getArcs(S);for(let h=0;h<b.length;h++)if(!w.has(b[h]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let S of n){const w=p.ExtensionIdentifier.toKey(S.identifier);if(d.set(w,S),S.extensionDependencies)for(let b of S.extensionDependencies){const h=p.ExtensionIdentifier.toKey(b);P.addArc(w,h)}}let f=new Set;P.getNodes().filter(S=>P.getArcs(S).length===0).forEach(S=>f.add(S));let l=P.getNodes().filter(S=>!f.has(S)),c;do{c=!1;for(let S=0;S<l.length;S++){const w=l[S];P.hasOnlyGoodArcs(w,f)&&(l.splice(S,1),S--,f.add(w),c=!0)}}while(c);return l.map(S=>d.get(S))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(p.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=A;var I;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(I||(I={}));function E(C,n){const P=C.isBuiltin?0:C.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==d)return P-d;const f=k.posix.basename(C.extensionLocation.path),l=k.posix.basename(n.extensionLocation.path);return f<l?-1:f>l?1:0}}),define(fe[218],me([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function y(I){const E=p.VSBuffer.alloc(1);switch(I){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=y;function A(I,E){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=A}),define(fe[34],me([0,1,3,2,4,26,180]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=k.createDecorator("extensionService");class I{constructor(b){this.dependency=b}}e.MissingExtensionDependency=I;var E;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(b,h,u,m){this.codeLoadingTime=b,this.activateCallTime=h,this.activateResolvedTime=u,this.activationReason=m}}e.ActivationTimes=C;class n{constructor(b,h){this.description=b,this.value=h}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var P;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(w){w.enableProposedApi||f(w)}e.checkProposedApiEnabled=d;function f(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=f;function l(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=l;function c(w,b){return{identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!b,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=c;class S{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,h){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,h,u,m,t){}_onDidActivateExtensionError(b,h){}_onExtensionRuntimeError(b,h){}_onExtensionHostExit(b){}}e.NullExtensionService=S}),define(fe[219],me([0,1,26,34,12]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(l,c,S,w){this.startup=l,this.codeLoadingTime=c,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class I{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,c){return l===-1||c===-1?-1:c-l}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class E{constructor(l,c,S,w,b,h){this.activationFailed=l,this.activationFailedError=c,this.activationTimes=S,this.module=w,this.exports=b,this.subscriptions=h}}e.ActivatedExtension=E;class C extends E{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends E{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class P extends E{constructor(l){super(!0,l,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let d=class{constructor(l,c,S,w,b){this._logService=b,this._registry=l,this._resolvedExtensionsSet=new Set,c.forEach(h=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(h))),this._hostExtensionsMap=new Map,S.forEach(h=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(h),h)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const c=p.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(c)}getActivatedExtension(l){const c=p.ExtensionIdentifier.toKey(l),S=this._activatedExtensions.get(c);if(!S)throw new Error("Extension `"+l.value+"` is not known or not activated");return S}activateByEvent(l,c){if(this._alreadyActivatedEvents[l])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:c,extensionId:w.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,c){const S=this._registry.getExtensionDescription(l);if(!S)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:S.identifier,reason:c}])}_handleActivateRequest(l,c,S){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(l.id))){c[p.ExtensionIdentifier.toKey(l.id)]=l;return}const w=this._registry.getExtensionDescription(l.id);if(!w){const u=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,u,new R.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(l.id),new P(u));return}const b=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let h=!0;for(let u=0,m=b.length;u<m;u++){const t=b[u];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const v=w.displayName||w.identifier.value,g=this._registry.getExtensionDescription(t),_=g&&g.displayName||t,D=new Error(`Cannot activate the '${v}' extension because its dependency '${_}' failed to activate`);D.detail=s.activationFailedError,this._host.onExtensionActivationError(w.identifier,D,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new P(D));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){h=!1,c[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){h=!1,c[p.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:l.reason};continue}const i=w.displayName||w.identifier.value,a=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new P(a));return}h?c[p.ExtensionIdentifier.toKey(w.identifier)]=l:S.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(b=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(b.id))),l.length===0))return Promise.resolve(void 0);const c=Object.create(null),S=[];for(let b=0,h=l.length;b<h;b++)this._handleActivateRequest(l[b],c,S);for(let b=0,h=S.length;b<h;b++){const u=p.ExtensionIdentifier.toKey(S[b].id);c[u]&&delete c[u]}const w=Object.keys(c).map(b=>c[b]);return S.length===0?Promise.all(w.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(w).then(b=>this._activateExtensions(S))}_activateExtension(l,c){const S=p.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const w=this._activatingExtensions.get(S);if(w)return w;const b=this._host.actualActivateExtension(l,c).then(void 0,h=>{const u=new Error;return h&&h.name&&(u.name=h.name),h&&h.message?u.message=`Activating extension '${l.value}' failed: ${h.message}.`:u.message=`Activating extension '${l.value}' failed: ${h}.`,h&&h.stack&&(u.stack=h.stack),this._host.onExtensionActivationError(l,u,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(h),new P(h)}).then(h=>{this._activatedExtensions.set(S,h),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,b),b}};d=ze([We(4,k.ILogService)],d),e.ExtensionsActivator=d}),define(fe[220],me([0,1,12,34,27,10,112]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends p.LogService{constructor(C){if(C.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,C.logFile.fsPath,!0,C.logLevel))}$setLevel(C){this.setLevel(C)}};I=ze([We(0,k.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(fe[221],me([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):p.onUnexpectedError(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(fe[126],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(E,C){this.isMain=E,this.sid=C,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const R=[];function k(I){const E=new p(!0,I);return R[E.nid]=E,E}e.createMainContextProxyIdentifier=k;function y(I){const E=new p(!1,I);return R[E.nid]=E,E}e.createExtHostContextProxyIdentifier=y;function A(I){return R[I].sid}e.getStringIdentifierForProxy=A}),define(fe[5],me([0,1,56,2,126]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(h){h.name="$ident";function u(t,s){return Object.defineProperty(t,h.name,{value:s,enumerable:!0}),t}h.mixin=u;function m(t){return t[h.name]}h.of=m})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(u){return u._id=f._n++,u}}e.IdObject=f,f._n=0;var l;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(h){if(h&&h.edits)for(const u of h.edits)typeof u.resource=="object"?u.resource=R.URI.revive(u.resource):(u.newUri=R.URI.revive(u.newUri),u.oldUri=R.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=p.revive(u.metadata));return h}e.reviveWorkspaceEditDto=w;var b;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:k.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:k.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:k.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:k.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadInteractive:k.createMainContextProxyIdentifier("MainThreadInteractive"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:k.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:k.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:k.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:k.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostInteractive:k.createMainContextProxyIdentifier("ExtHostInteractive"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:k.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(fe[85],me([0,1,5,3,4]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(I){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,E){return this._proxy.$getPassword(I,E)}store(I,E,C){return this._proxy.$setPassword(I,E,C)}delete(I,E){return this._proxy.$deletePassword(I,E)}}e.ExtHostSecretState=y,e.IExtHostSecretState=k.createDecorator("IExtHostSecretState")}),define(fe[61],me([0,1,4,12,5,13]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=p.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(E,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(k.MainContext.MainThreadTelemetry)}report(E,C,n){const P=this.getUsageKey(E,C);this._reportedUsages.has(P)||(this._reportedUsages.add(P),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:E}))}getUsageKey(E,C){return`${E}-${C.identifier.value}`}};A=ze([We(0,y.IExtHostRpcService),We(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(I,E,C){}})}),define(fe[222],me([0,1,3,5,7,26]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(E,C,n,P={}){const d=y.ExtensionIdentifier.toKey(E.identifier),f=this._inFlightRequests.get(d)||[],l=[...n].sort().join(" ");let c=f.find(S=>S.scopes===l);if(c)return c.result;{const S=this._getSession(E,d,C,n,P);c={scopes:l,result:S},f.push(c),this._inFlightRequests.set(d,f);try{await S}finally{const w=f.findIndex(b=>b.scopes===l);w>-1&&(f.splice(w),this._inFlightRequests.set(d,f))}return S}}async _getSession(E,C,n,P,d={}){await this._proxy.$ensureProvider(n);const f=E.displayName||E.name;return this._proxy.$getSession(n,P,C,f,d)}async removeSession(E,C){const n=this._authenticationProviders.get(E);return n?n.provider.removeSession(C):this._proxy.$removeSession(E,C)}registerAuthenticationProvider(E,C,n,P){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:C,provider:n,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===E)||this._providers.push({id:E,label:C});const d=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(E,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,C,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(E);const f=this._providers.findIndex(l=>l.id===E);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,C){const n=this._authenticationProviders.get(E);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,C){const n=this._authenticationProviders.get(E);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,C){const n=this._authenticationProviders.get(E);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,C){return this._onDidChangeSessions.fire({provider:{id:E,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(E,C){return E.forEach(n=>{this._providers.some(P=>P.id===n.id)||this._providers.push(n)}),C.forEach(n=>{const P=this._providers.findIndex(d=>d.id===n.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:E,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[223],me([0,1,5,13,16]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(I,E){this._extHostDocumentsAndEditors=E,this._proxy=I.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const E=k.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};y=ze([We(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(fe[224],me([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const A=y.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(I){return A.$writeText(I)}})}}e.ExtHostClipboard=R}),define(fe[49],me([0,1,14,7,16,25,5,17,12,56,40,44,2,6,4,13]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=s,this.converter=new w(this,r=>{const i=this._apiCommands.get(r);return i?.result===h.Void?i:void 0},s),this._argumentProcessors=[{processArgument(r){return C.revive(r)}},{processArgument(r){return y.cloneAndChange(r,function(i){if(n.Range.isIRange(i))return k.Range.to(i);if(P.Position.isIPosition(i))return k.Position.to(i);if(n.Range.isIRange(i.range)&&d.URI.isUri(i.uri))return k.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...r)=>{const i=t.args.map((v,g)=>{if(!v.validate(r[g]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${r[g]}`);return v.convert(r[g])}),a=await this.executeCommand(t.internalId,...i);return t.result.convert(a,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,r,i,a){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:r,thisArg:i,description:a}),t&&this._proxy.$registerCommand(s),new R.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,r){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const i=y.cloneAndChange(s,function(a){if(a instanceof R.Position)return k.Position.from(a);if(a instanceof R.Range)return k.Range.from(a);if(a instanceof R.Location)return k.location.from(a);if(R.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,i,r);return C.revive(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw a}}}async _executeContributedCommand(t,s){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:i,thisArg:a,description:v}=r;if(v)for(let g=0;g<v.args.length;g++)try{p.validateConstraint(s[g],v.args[g].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[g].name}' - ${v.args[g].description}`)}try{return await i.apply(a,s)}catch(g){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...s);_&&(t=_.command)}throw this._logService.error(g,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(r=>this._argumentProcessors.reduce((i,a)=>a.processArgument(i),r)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(r=>r[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,r]of this._commands){let{description:i}=r;i&&(t[s]=i)}return Promise.resolve(t)}};S=ze([We(0,c.IExtHostRpcService),We(1,E.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=l.createDecorator("IExtHostCommands");class w{constructor(t,s,r){this._commands=t,this._lookupApiCommand=s,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const i=this._lookupApiCommand(t.command);if(i)r.id=i.internalId,r.arguments=i.args.map((a,v)=>a.convert(t.arguments&&t.arguments[v]));else if(I.isNonEmptyArray(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),s.add(f.toDisposable(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),r.$ident=a,r.id=this.delegatingCommandId,r.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return r}fromInternal(t){const s=A.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,s,r,i){this.name=t,this.description=s,this.validate=r,this.convert=i}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new b(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",m=>d.URI.isUri(m),m=>m),b.Position=new b("position","A position in a text document",m=>R.Position.isPosition(m),k.Position.from),b.Range=new b("range","A range in a text document",m=>R.Range.isRange(m),k.Range.from),b.Selection=new b("selection","A selection in a text document",m=>R.Selection.isSelection(m),k.Selection.from),b.Number=new b("number","",m=>typeof m=="number",m=>m),b.String=new b("string","",m=>typeof m=="string",m=>m),b.CallHierarchyItem=new b("item","A call hierarchy item",m=>m instanceof R.CallHierarchyItem,k.CallHierarchyItem.to);class h{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=h,h.Void=new h("no result",m=>m);class u{constructor(t,s,r,i,a){this.id=t,this.internalId=s,this.description=r,this.args=i,this.result=a}}e.ApiCommand=u}),define(fe[225],me([0,1,16,7,77,49,17,108]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,f)=>{if(A.isFalsyOrEmpty(d))return;class l extends R.SymbolInformation{static to(S){const w=new l(S.name,p.SymbolKind.to(S.kind),S.containerName||"",new R.Location(f[0],p.Range.to(S.range)));return w.detail=S.detail,w.range=w.location.range,w.selectionRange=p.Range.to(S.selectionRange),w.children=S.children?S.children.map(l.to):[],w}}return d.map(l.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new y.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(f=>R.Position.isPosition(f)),d=>d.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(f=>{let l;for(const c of f.reverse())l=new R.SelectionRange(p.Range.to(c),l);return l}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>{const f=[];if(Array.isArray(d))for(let l of d)f.push(...l[1].map(p.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return p.WorkspaceEdit.to(d)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new R.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=I.decodeSemanticTokensDto(d);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new R.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=I.decodeSemanticTokensDto(d);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,f,l)=>{if(!d)return new R.CompletionList([]);const c=d.suggestions.map(S=>p.CompletionItem.to(S,l));return new R.CompletionList(c,d.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return p.SignatureHelp.to(d)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,f,l)=>n(c=>new R.CodeLens(p.Range.to(c.range),c.command&&l.fromInternal(c.command)))(d))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>R.Range.isRange(d),d=>R.Selection.isSelection(d)?p.Selection.from(d):p.Range.from(d)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,f,l)=>n(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(c.command)}else{const S=new R.CodeAction(c.title,c.kind?new R.CodeActionKind(c.kind):void 0);return c.edit&&(S.edit=p.WorkspaceEdit.to(c.edit)),c.command&&(S.command=l.fromInternal(c.command)),S.isPreferred=c.isPreferred,S}})(d))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(f=>new R.ColorInformation(p.Range.to(f.range),p.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",d=>d instanceof R.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:p.Range.from(d.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",d=>d.map(p.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(f=>p.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[p.ViewColumn.from(d.viewColumn),p.TextEditorOpenOptions.from(d)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[p.ViewColumn.from(d.viewColumn),p.TextEditorOpenOptions.from(d)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[p.ViewColumn.from(d.viewColumn),p.TextEditorOpenOptions.from(d)]).optional()],y.ApiCommandResult.Void)];class C{static register(f){E.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=C;function n(d){return f=>{if(Array.isArray(f))return f.map(d)}}function P(d){if(!Array.isArray(d))return;const f=[];for(const l of d)k.isLocationLink(l)?f.push(p.DefinitionLink.to(l)):f.push(p.location.to(l));return f}}),define(fe[226],me([0,1,18,52,3,6,2,77,26,16,7,5]),function(X,e,p,R,k,y,A,I,E,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(u,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const r=this._commentControllers.get(s.handle);return r||s}else if(s&&s.$mid===7){const r=this._commentControllers.get(s.commentControlHandle);if(!r)return s;const i=r.getCommentThread(s.commentThreadHandle);return i||s}else if(s&&s.$mid===8){const r=this._commentControllers.get(s.thread.commentControlHandle);if(!r)return s;const i=r.getCommentThread(s.thread.commentThreadHandle);return i?{thread:i,text:s.text}:s}else if(s&&s.$mid===9){const r=this._commentControllers.get(s.thread.commentControlHandle);if(!r)return s;const i=r.getCommentThread(s.thread.commentThreadHandle);if(!i)return s;let a=s.commentUniqueId,v=i.getCommentByUniqueId(a);return v||s}else if(s&&s.$mid===10){const r=this._commentControllers.get(s.thread.commentControlHandle);if(!r)return s;const i=r.getCommentThread(s.thread.commentThreadHandle);if(!i)return s;let a=s.text,v=s.commentUniqueId,g=i.getCommentByUniqueId(v);return g?(g.body=a,g):s}return s}})}createCommentController(u,m,t){const s=d.handlePool++,r=new l(u,s,this._proxy,m,t);this._commentControllers.set(r.handle,r);const i=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(u.identifier))||[];return i.push(r),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(u.identifier),i),r}$createCommentThreadTemplate(u,m,t){const s=this._commentControllers.get(u);!s||s.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(u,m,t){const s=this._commentControllers.get(u);!s||s.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(u,m){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(u,m,t){const s=this._commentControllers.get(u);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const r=this._documents.getDocument(A.URI.revive(m));return p.asPromise(()=>s.commentingRangeProvider.provideCommentingRanges(r,t)).then(i=>i?i.map(a=>C.Range.from(a)):void 0)}$toggleReaction(u,m,t,s,r){const i=this._commentControllers.get(u);return!i||!i.reactionHandler?Promise.resolve(void 0):p.asPromise(()=>{const a=i.getCommentThread(m);if(a){const v=a.getCommentByUniqueId(s.uniqueIdInThread);if(i!==void 0&&v&&i.reactionHandler)return i.reactionHandler(v,w(r))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class f{constructor(u,m,t,s,r,i,a){this._proxy=u,this._commentController=m,this._id=t,this._uri=s,this._range=r,this._comments=i,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};u("range")&&(m.range=C.Range.from(this._range)),u("label")&&(m.label=this.label),u("contextValue")&&(m.contextValue=this.contextValue),u("comments")&&(m.comments=this._comments.map(t=>c(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(m.collapseState=b(this._collapseState)),u("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(u){for(let m of this._commentsMap){let t=m[0],s=m[1];if(u===s)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,ze([R.debounce(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class l{constructor(u,m,t,s,r){this._extension=u,this._handle=m,this._proxy=t,this._id=s,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,s,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,m,t,s){if(typeof u=="string"){const r=new f(this._proxy,this,u,m,t,s,this._extension.identifier);return this._threads.set(r.handle,r),r}else{const r=new f(this._proxy,this,void 0,u,m,t,this._extension.identifier);return this._threads.set(r.handle,r),r}}$createCommentThreadTemplate(u,m){const t=new f(this._proxy,this,void 0,A.URI.revive(u),C.Range.to(m),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,m){let t=this._threads.get(u);t&&(t.range=C.Range.to(m))}$deleteCommentThread(u){let m=this._threads.get(u);m&&m.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function c(h,u,m,t){let s=t.get(m);s||(s=++h.commentHandle,t.set(m,s));const r=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:s,body:C.MarkdownString.from(m.body),userName:m.author.name,userIconPath:r,label:m.label,commentReactions:m.reactions?m.reactions.map(i=>S(i)):void 0}}function S(h){return{label:h.label,iconPath:h.iconPath?C.pathOrURIToURI(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted}}function w(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?A.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1}}function b(h){if(h!==void 0)switch(h){case n.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(fe[127],me([0,1,2,5,7,4,13,12,17,8,9]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class En{constructor(f,l){this._logService=l,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,l){const c=En._handlePool++;this._provider.set(c,{provider:f,extensionId:l}),this._proxy.$registerDecorationProvider(c,l.value);const S=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(c,null);return}let b=E.asArray(w);if(b.length<=En._maxEventSize){this._proxy.$onDidChange(c,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,b.length);const h=b.map(t=>({uri:t,rank:C.count(t.path,"/")})),u=E.groupBy(h,(t,s)=>t.rank-s.rank||C.compare(t.uri.path,s.uri.path));let m=[];e:for(let t of u){let s;for(let r of t){let i=n.dirname(r.uri.path);if(s!==i&&(s=i,m.push(r.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(c,m)});return new k.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(f,l,c){if(!this._provider.has(f))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:b}=this._provider.get(f);return await Promise.all(l.map(async h=>{try{const{uri:u,id:m}=h,t=await Promise.resolve(w.provideFileDecoration(p.URI.revive(u),c));if(!t)return;try{k.FileDecoration.validate(t),S[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${b.value}': ${s}`)}}catch(u){this._logService.error(u)}})),S}};P._handlePool=0,P._maxEventSize=250,P=ze([We(0,A.IExtHostRpcService),We(1,I.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(fe[227],me([0,1,159,113,2,5,7,16,3,12,24]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(l,c,S,w,b){this._name=l,this._owner=c,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,c){if(!l){this.clear();return}this._checkDisposed();let S=[];if(k.URI.isUri(l)){if(!c){this.delete(l);return}this._data.set(l,c.slice()),S=[l]}else if(Array.isArray(l)){S=[];let b;l=[...l].sort(P._compareIndexedTuplesByUri);for(const h of l){const[u,m]=h;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,S.push(u),this._data.set(u,[])),m){const t=this._data.get(u);t&&t.push(...m)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!this._proxy)return;const w=[];for(let b of S){let h=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){h=[];const m=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of u)if(s.severity===m[t]&&h.push(I.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;h.push({severity:R.MarkerSeverity.Info,message:p.localize(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=u.map(m=>I.Diagnostic.from(m));w.push([b,h])}this._proxy.$changeMany(this._owner,w)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,c){this._checkDisposed();for(let S of this._data.keys())l.apply(c,[S,this.get(S),this])}get(l){this._checkDisposed();const c=this._data.get(l);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,c){return l[0].toString()<c[0].toString()?-1:l[0].toString()>c[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class Gt{constructor(l,c){this._logService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.Emitter,this.onDidChangeDiagnostics=E.Event.map(E.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=l.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(l,c){return l?l.concat(c):c}static _mapper(l){const c=new n.ResourceMap;for(const S of l)c.set(S,S);return{uris:Object.freeze(Array.from(c.values()))}}createDiagnosticCollection(l,c){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:b,_logService:h}=this,u=new class{$changeMany(s,r){w.$changeMany(s,r),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,s,r.length===0?"CLEARING":r)}$clear(s){w.$clear(s),h.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,s)}dispose(){w.dispose()}};let m;if(!c)c="_generated_diagnostic_collection_name_#"+Gt._idPool++,m=c;else if(!S.has(c))m=c;else{this._logService.warn(`DiagnosticCollection with name '${c}' does already exist.`);do m=c+Gt._idPool++;while(S.has(m))}return new class extends P{constructor(){super(c,m,Gt._maxDiagnosticsPerFile,u,b);S.set(m,this)}dispose(){super.dispose(),S.delete(m)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const c=new Map,S=[];for(const w of this._collections.values())w.forEach((b,h)=>{let u=c.get(b.toString());typeof u=="undefined"&&(u=S.length,c.set(b.toString(),u),S.push([b,[]])),S[u][1]=S[u][1].concat(...h)});return S}}_getDiagnostics(l){let c=[];for(let S of this._collections.values())S.has(l)&&(c=c.concat(S.get(l)));return c}$acceptMarkersChange(l){if(!this._mirrorCollection){const c="_generated_mirror",S=new P(c,c,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(c,S),this._mirrorCollection=S}for(const[c,S]of l)this._mirrorCollection.set(k.URI.revive(c),S.map(I.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([We(1,C.ILogService)],d),e.ExtHostDiagnostics=d}),define(fe[228],me([0,1,2,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(I=>I?I.map(E=>p.URI.revive(E)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(I=>I?p.URI.revive(I):void 0)}}e.ExtHostDialogs=k}),define(fe[229],me([0,1,15,2,7,5,10,21,8]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,d,f){this._documentsAndEditors=d,this._logService=f,this._documentContentProviders=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(A.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const f=C._handlePool++;this._documentContentProviders.set(f,d),this._proxy.$registerTextContentProvider(f,P);let l;return typeof d.onDidChange=="function"&&(l=d.onDidChange(c=>{if(c.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(f,c).then(S=>{if(!S&&typeof S!="string")return;const w=this._documentsAndEditors.getDocument(c);if(!w)return;const b=E.splitLines(S);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(c,S)},p.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(P,d){const f=this._documentContentProviders.get(P);return f?Promise.resolve(f.provideTextDocumentContent(R.URI.revive(d),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(fe[230],me([0,1,3,6,2,5,119,16,14,25]),function(X,e,p,R,k,y,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(d,f){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const c of l)this._onDidRemoveDocument.fire(c.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const c of l)this._onDidAddDocument.fire(c.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const f=this._documentsAndEditors.getDocument(d);if(f)return f}getDocument(d){const f=this.getDocumentData(d);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return f.document}ensureDocumentData(d){const f=this._documentsAndEditors.getDocument(d);if(f)return Promise.resolve(f);let l=this._documentLoader.get(d.toString());return l||(l=this._proxy.$tryOpenDocument(d).then(c=>{this._documentLoader.delete(d.toString());const S=k.URI.revive(c);return E.assertIsDefined(this._documentsAndEditors.getDocument(S))},c=>(this._documentLoader.delete(d.toString()),Promise.reject(c))),this._documentLoader.set(d.toString(),l)),l}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(f=>k.URI.revive(f))}$acceptModelModeChanged(d,f){const l=k.URI.revive(d),c=this._documentsAndEditors.getDocument(l);if(!c)throw new Error("unknown document");this._onDidRemoveDocument.fire(c.document),c._acceptLanguageId(f),this._onDidAddDocument.fire(c.document)}$acceptModelSaved(d){const f=k.URI.revive(d),l=this._documentsAndEditors.getDocument(f);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(d,f){const l=k.URI.revive(d),c=this._documentsAndEditors.getDocument(l);if(!c)throw new Error("unknown document");c._acceptIsDirty(f),this._onDidChangeDocument.fire({document:c.document,contentChanges:[]})}$acceptModelChanged(d,f,l){const c=k.URI.revive(d),S=this._documentsAndEditors.getDocument(c);if(!S)throw new Error("unknown document");S._acceptIsDirty(l),S.onEvents(f),this._onDidChangeDocument.fire(C.deepFreeze({document:S.document,contentChanges:f.changes.map(w=>({range:I.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(d,f){A.setWordDefinitionFor(d,f)}}e.ExtHostDocuments=n}),define(fe[42],me([0,1,51,3,6,2,4,5,119,13,125,16,12,24,10,53,135]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,m){this._extHostRpc=u,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const m=[],t=[],s=[];if(u.removedDocuments)for(const r of u.removedDocuments){const i=y.URI.revive(r),a=this._documents.get(i);a?.unref()&&(this._documents.delete(i),m.push(a.value))}if(u.addedDocuments)for(const r of u.addedDocuments){const i=y.URI.revive(r.uri);let a=this._documents.get(i);if(a&&i.scheme!==l.Schemas.vscodeNotebookCell&&i.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);a||(a=new w(new E.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,a),t.push(a.value)),a.ref()}if(u.removedEditors)for(const r of u.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&s.push(i)}if(u.addedEditors)for(const r of u.addedEditors){const i=y.URI.revive(r.documentUri);p.ok(this._documents.has(i),`document '${i}' does not exist`),p.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const a=this._documents.get(i).value,v=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>a.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(g=>P.Range.to(g)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,v)}u.newActiveEditor!==void 0&&(p.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),k.dispose(m),k.dispose(s),u.removedDocuments&&this._onDidRemoveDocuments.fire(m),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return u?m:m?.value}allEditors(){return[...this._editors.values()]}};b=ze([We(0,C.IExtHostRpcService),We(1,d.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(fe[231],me([0,1,2,5,6,7,16,143,8,23]),function(X,e,p,R,k,y,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const l=this._schemes.indexOf(f);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),l=[];let c,S,w=14,b=14;for(const h of f){let u=c?E.commonPrefixLength(c,h):0;for(u===0?S=1:S=b;u<h.length;u++)u+1===h.length?(w=b,b=9):b+=1,l.push([S,h.toUpperCase().charCodeAt(u),b]),l.push([S,h.toLowerCase().charCodeAt(u),b]),S=b;c=h,b=w}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new I.StateMachine(l)}}provideDocumentLinks(f){this._initStateMachine();const l=[],c=I.LinkComputer.computeLinks({getLineContent(S){return f.lineAt(S-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const S of c){const w=A.DocumentLink.to(S);w.target&&l.push(w)}return l}}class P{constructor(f,l){this._extHostLanguageFeatures=l,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,l,c,S={},w){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(b,c),this._enableProposedApi.set(b,w??!1);let h=2;S.isCaseSensitive&&(h+=1024),S.isReadonly&&(h+=2048),typeof c.copy=="function"&&(h+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&(h+=4),this._proxy.$registerFileSystemProvider(b,l,h).catch(m=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${l}`),console.error(m)});const u=c.onDidChangeFile(m=>{const t=[];for(const s of m){let{uri:r,type:i}=s;if(r.scheme!==l)continue;let a;switch(i){case y.FileChangeType.Changed:a=0;break;case y.FileChangeType.Created:a=1;break;case y.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:a})}this._proxy.$onFileSystemChange(b,t)});return k.toDisposable(()=>{u.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(f,l){const{type:c,ctime:S,mtime:w,size:b,permissions:h}=f;return l?{type:c,ctime:S,mtime:w,size:b,permissions:h}:{type:c,ctime:S,mtime:w,size:b}}$stat(f,l){return Promise.resolve(this._getFsProvider(f).stat(p.URI.revive(l))).then(c=>P._asIStat(c,this._enableProposedApi.get(f)??!1))}$readdir(f,l){return Promise.resolve(this._getFsProvider(f).readDirectory(p.URI.revive(l)))}$readFile(f,l){return Promise.resolve(this._getFsProvider(f).readFile(p.URI.revive(l))).then(c=>C.VSBuffer.wrap(c))}$writeFile(f,l,c,S){return Promise.resolve(this._getFsProvider(f).writeFile(p.URI.revive(l),c.buffer,S))}$delete(f,l,c){return Promise.resolve(this._getFsProvider(f).delete(p.URI.revive(l),c))}$rename(f,l,c,S){return Promise.resolve(this._getFsProvider(f).rename(p.URI.revive(l),p.URI.revive(c),S))}$copy(f,l,c,S){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(p.URI.revive(l),p.URI.revive(c),S))}$mkdir(f,l){return Promise.resolve(this._getFsProvider(f).createDirectory(p.URI.revive(l)))}$watch(f,l,c,S){const w=this._getFsProvider(f).watch(p.URI.revive(c),S);this._watches.set(l,w)}$unwatch(f,l){const c=this._watches.get(l);c&&(c.dispose(),this._watches.delete(l))}$open(f,l,c){const S=this._getFsProvider(f);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(p.URI.revive(l),c))}$close(f,l){const c=this._getFsProvider(f);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(l))}$read(f,l,c,S){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(S);return Promise.resolve(w.read(l,c,b.buffer,0,S)).then(h=>b.slice(0,h))}$write(f,l,c,S){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(l,c,S.buffer,0,S.byteLength))}_getFsProvider(f){const l=this._fsProvider.get(f);if(!l){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return l}}e.ExtHostFileSystem=P}),define(fe[86],me([0,1,5,41,7,23,4,13,59]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Vt{constructor(P,d){const f=P.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return f.$stat(l).catch(Vt._handleError)},readDirectory(l){return f.$readdir(l).catch(Vt._handleError)},createDirectory(l){return f.$mkdir(l).catch(Vt._handleError)},async readFile(l){return f.$readFile(l).then(c=>c.buffer).catch(Vt._handleError)},writeFile(l,c){return f.$writeFile(l,y.VSBuffer.wrap(c)).catch(Vt._handleError)},delete(l,c){return f.$delete(l,{recursive:!1,useTrash:!1,...c}).catch(Vt._handleError)},rename(l,c,S){return f.$rename(l,c,{overwrite:!1,...S}).catch(Vt._handleError)},copy(l,c,S){return f.$copy(l,c,{overwrite:!1,...S}).catch(Vt._handleError)},isWritableFileSystem(l){const c=d.getCapabilities(l);if(typeof c=="number")return!(c&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new k.FileSystemError(String(P));if(P.name==="ENOPRO")throw k.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(P.message);default:throw new k.FileSystemError(P.message,P.name)}}};C=ze([We(0,I.IExtHostRpcService),We(1,E.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(fe[232],me([0,1,6,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,A),p.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=k}),define(fe[233],me([0,1,2,25,16,7,18,5,8,40,17,14,140,6,108,70,82,43,15,3]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(q,Z){this._documents=q,this._provider=Z}provideDocumentSymbols(q,Z){const re=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentSymbols(re,Z)).then(ae=>{if(!n.isFalsyOrEmpty(ae))return ae[0]instanceof y.DocumentSymbol?ae.map(k.DocumentSymbol.from):u._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(q){q=q.slice(0).sort((ae,J)=>{let se=ae.location.range.start.compareTo(J.location.range.start);return se===0&&(se=J.location.range.end.compareTo(ae.location.range.end)),se});const Z=[],re=[];for(const ae of q){const J={name:ae.name||"!!MISSING: name!!",kind:k.SymbolKind.from(ae.kind),tags:ae.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:k.Range.from(ae.location.range),selectionRange:k.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(J),Z.push(J);break}const se=re[re.length-1];if(C.Range.containsRange(se.range,J.range)&&!C.Range.equalsRange(se.range,J.range)){se.children&&se.children.push(J),re.push(J);break}re.pop()}}return Z}}class m{constructor(q,Z,re){this._documents=q,this._commands=Z,this._provider=re,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,Z){const re=this._documents.getDocument(q),ae=await this._provider.provideCodeLenses(re,Z);if(!ae||Z.isCancellationRequested)return;const J=this._cache.add(ae),se=new f.DisposableStore;this._disposables.set(J,se);const ve={cacheId:J,lenses:[]};for(let Le=0;Le<ae.length;Le++)ve.lenses.push({cacheId:[J,Le],range:k.Range.from(ae[Le].range),command:this._commands.toInternal(ae[Le].command,se)});return ve}async resolveCodeLens(q,Z){const re=q.cacheId&&this._cache.get(...q.cacheId);if(!re)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this._provider.resolveCodeLens(re,Z),ae||(ae=re),Z.isCancellationRequested)return;const J=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!J)return q.command=this._commands.toInternal(ae.command??m._badCmd,J),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(qe){return Array.isArray(qe)?qe.map(k.DefinitionLink.from):qe?[k.DefinitionLink.from(qe)]:[]}class s{constructor(q,Z){this._documents=q,this._provider=Z}provideDefinition(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDefinition(ae,J,re)).then(t)}}class r{constructor(q,Z){this._documents=q,this._provider=Z}provideDeclaration(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDeclaration(ae,J,re)).then(t)}}class i{constructor(q,Z){this._documents=q,this._provider=Z}provideImplementation(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideImplementation(ae,J,re)).then(t)}}class a{constructor(q,Z){this._documents=q,this._provider=Z}provideTypeDefinition(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideTypeDefinition(ae,J,re)).then(t)}}class v{constructor(q,Z){this._documents=q,this._provider=Z}provideHover(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideHover(ae,J,re)).then(se=>{if(!(!se||n.isFalsyOrEmpty(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(J)),se.range||(se.range=new y.Range(J,J)),k.Hover.from(se)})}}class g{constructor(q,Z){this._documents=q,this._provider=Z}provideEvaluatableExpression(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideEvaluatableExpression(ae,J,re)).then(se=>{if(se)return k.EvaluatableExpression.from(se)})}}class _{constructor(q,Z){this._documents=q,this._provider=Z}provideInlineValues(q,Z,re,ae){const J=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideInlineValues(J,k.Range.to(Z),k.InlineValueContext.to(re),ae)).then(se=>{if(Array.isArray(se))return se.map(ve=>k.InlineValue.from(ve))})}}class D{constructor(q,Z){this._documents=q,this._provider=Z}provideDocumentHighlights(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDocumentHighlights(ae,J,re)).then(se=>{if(Array.isArray(se))return se.map(k.DocumentHighlight.from)})}}class o{constructor(q,Z){this._documents=q,this._provider=Z}provideLinkedEditingRanges(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(ae,J,re)).then(se=>{if(se&&Array.isArray(se.ranges))return{ranges:n.coalesce(se.ranges.map(k.Range.from)),wordPattern:se.wordPattern}})}}class T{constructor(q,Z){this._documents=q,this._provider=Z}provideReferences(q,Z,re,ae){const J=this._documents.getDocument(q),se=k.Position.to(Z);return A.asPromise(()=>this._provider.provideReferences(J,se,re,ae)).then(ve=>{if(Array.isArray(ve))return ve.map(k.location.from)})}}class L{constructor(q,Z,re,ae,J,se,ve){this._documents=q,this._commands=Z,this._diagnostics=re,this._provider=ae,this._logService=J,this._extension=se,this._apiDeprecation=ve,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(q,Z,re,ae){const J=this._documents.getDocument(q),se=d.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),ve=[];for(const He of this._diagnostics.getDiagnostics(q))if(se.intersection(He.range)&&ve.push(He)>L._maxCodeActionsPerFile)break;const Le={diagnostics:ve,only:re.only?new y.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(J,se,Le,ae)).then(He=>{if(!n.isNonEmptyArray(He)||ae.isCancellationRequested)return;const be=this._cache.add(He),Je=new f.DisposableStore;this._disposables.set(be,Je);const K=[];for(let ie=0;ie<He.length;ie++){const he=He[ie];!he||(L._isCommand(he)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),K.push({_isSynthetic:!0,title:he.title,command:this._commands.toInternal(he,Je)})):(Le.only&&(he.kind?Le.only.contains(he.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${he.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),K.push({cacheId:[be,ie],title:he.title,command:he.command&&this._commands.toInternal(he.command,Je),diagnostics:he.diagnostics&&he.diagnostics.map(k.Diagnostic.from),edit:he.edit&&k.WorkspaceEdit.from(he.edit),kind:he.kind&&he.kind.value,isPreferred:he.isPreferred,disabled:he.disabled?.reason})))}return{cacheId:be,actions:K}})}async resolveCodeAction(q,Z){const[re,ae]=q,J=this._cache.get(re,ae);if(!J||L._isCommand(J)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(J,Z)??J;return se?.edit?k.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}L._maxCodeActionsPerFile=1e3;class ${constructor(q,Z){this._documents=q,this._provider=Z}provideDocumentFormattingEdits(q,Z,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(ae,Z,re)).then(J=>{if(Array.isArray(J))return J.map(k.TextEdit.from)})}}class W{constructor(q,Z){this._documents=q,this._provider=Z}provideDocumentRangeFormattingEdits(q,Z,re,ae){const J=this._documents.getDocument(q),se=k.Range.to(Z);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(J,se,re,ae)).then(ve=>{if(Array.isArray(ve))return ve.map(k.TextEdit.from)})}}class Q{constructor(q,Z){this._documents=q,this._provider=Z,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(q,Z,re,ae,J){const se=this._documents.getDocument(q),ve=k.Position.to(Z);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(se,ve,re,ae,J)).then(Le=>{if(Array.isArray(Le))return Le.map(k.TextEdit.from)})}}class z{constructor(q,Z){this._provider=q,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(q,Z){const re=I.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(q,Z)).then(ae=>{if(n.isNonEmptyArray(ae))for(const J of ae){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const se=I.IdObject.mixin(k.WorkspaceSymbol.from(J));this._symbolCache.set(se._id,J),re.symbols.push(se)}}).then(()=>(re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re))}async resolveWorkspaceSymbol(q,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const ae=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(re,Z));return ae&&R.mixin(q,k.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(q){const Z=this._resultCache.get(q);if(Z){for(let[re,ae]=Z;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class N{constructor(q,Z,re){this._documents=q,this._provider=Z,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}provideRenameEdits(q,Z,re,ae){const J=this._documents.getDocument(q),se=k.Position.to(Z);return A.asPromise(()=>this._provider.provideRenameEdits(J,se,re,ae)).then(ve=>{if(!!ve)return k.WorkspaceEdit.from(ve)},ve=>{const Le=N._asMessage(ve);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ve)})}resolveRenameLocation(q,Z,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(q),J=k.Position.to(Z);return A.asPromise(()=>this._provider.prepareRename(ae,J,re)).then(se=>{let ve,Le;if(y.Range.isRange(se)?(ve=se,Le=ae.getText(se)):P.isObject(se)&&(ve=se.range,Le=se.placeholder),!!ve){if(ve.start.line>J.line||ve.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Le}}},se=>{const ve=N._asMessage(se);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(se)})}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class H{constructor(q,Z){this.resultId=q,this.tokens=Z}}class F{constructor(q,Z){this._documents=q,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(q,Z,re){const ae=this._documents.getDocument(q),J=Z!==0?this._previousResults.get(Z):null;return A.asPromise(()=>J&&typeof J.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,J.resultId,re):this._provider.provideDocumentSemanticTokens(ae,re)).then(se=>(J&&this._previousResults.delete(Z),se?(se=F._fixProvidedSemanticTokens(se),this._send(F._convertToEdits(J,se),se)):null))}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return F._isSemanticTokens(q)?F._isCorrectSemanticTokens(q)?q:new y.SemanticTokens(new Uint32Array(q.data),q.resultId):F._isSemanticTokensEdits(q)?F._isCorrectSemanticTokensEdits(q)?q:new y.SemanticTokensEdits(q.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const Z of q.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,Z){if(!F._isSemanticTokens(Z)||!q||!q.tokens)return Z;const re=q.tokens,ae=re.length,J=Z.data,se=J.length;let ve=0;const Le=Math.min(ae,se);for(;ve<Le&&re[ve]===J[ve];)ve++;if(ve===ae&&ve===se)return new y.SemanticTokensEdits([],Z.resultId);let He=0;const be=Le-ve;for(;He<be&&re[ae-He-1]===J[se-He-1];)He++;return new y.SemanticTokensEdits([{start:ve,deleteCount:ae-ve-He,data:J.subarray(ve,se-He)}],Z.resultId)}_send(q,Z){if(F._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new H(q.resultId,q.data)),l.encodeSemanticTokensDto({id:re,type:"full",data:q.data})}if(F._isSemanticTokensEdits(q)){const re=this._nextResultId++;return F._isSemanticTokens(Z)?this._previousResults.set(re,new H(Z.resultId,Z.data)):this._previousResults.set(re,new H(q.resultId)),l.encodeSemanticTokensDto({id:re,type:"delta",deltas:(q.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class x{constructor(q,Z){this._documents=q,this._provider=Z}provideDocumentRangeSemanticTokens(q,Z,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(ae,k.Range.to(Z),re)).then(J=>J?this._send(J):null)}_send(q){return l.encodeSemanticTokensDto({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=x;class O{constructor(q,Z,re,ae,J){this._documents=q,this._commands=Z,this._provider=re,this._apiDeprecation=ae,this._extension=J,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,Z,re,ae){const J=this._documents.getDocument(q),se=k.Position.to(Z),ve=J.getWordRangeAtPosition(se)||new y.Range(se,se),Le=ve.with({end:se}),He=new w.StopWatch(!0),be=await A.asPromise(()=>this._provider.provideCompletionItems(J,se,ae,k.CompletionContext.to(re)));if(!be||ae.isCancellationRequested)return;const Je=Array.isArray(be)?new y.CompletionList(be):be,K=O.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),ie=new f.DisposableStore;this._disposables.set(K,ie);const he=[],xe={x:K,b:he,a:{replace:k.Range.from(ve),insert:k.Range.from(Le)},c:Je.isIncomplete||void 0,d:He.elapsed()};for(let $e=0;$e<Je.items.length;$e++){const et=Je.items[$e],ke=this._convertCompletionItem(et,[K,$e],Le,ve);he.push(ke)}return xe}async resolveCompletionItem(q,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const ae=await A.asPromise(()=>this._provider.resolveCompletionItem(re,Z));if(!!ae)return this._convertCompletionItem(ae,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,Z,re,ae){const J=this._disposables.get(Z[0]);if(!J)throw Error("DisposableStore is missing...");const se={x:Z,a:q.label,b:q.kind!==void 0?k.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(k.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(q.command,J)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=q.textEdit.newText):typeof q.insertText=="string"?se.h=q.insertText:q.insertText instanceof y.SnippetString&&(se.h=q.insertText.value,se.i|=4);let ve;return q.textEdit?ve=q.textEdit.range:q.range&&(ve=q.range),y.Range.isRange(ve)?se.j=k.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!ae?.isEqual(ve.replacing))&&(se.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),se}}class M{constructor(q,Z,re){this._documents=q,this._provider=Z,this._commands=re,this._cache=new S.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,Z,re,ae){const J=this._documents.getDocument(q),se=k.Position.to(Z),ve=await A.asPromise(()=>this._provider.provideInlineCompletionItems(J,se,re,ae));if(!ve||ae.isCancellationRequested)return;const Le=P.isArray(ve)?{items:ve}:ve,He=this._cache.add(Le.items);let be;return{pid:He,items:Le.items.map((Je,K)=>{let ie;return Je.command&&(be||(be=new f.DisposableStore,this._disposables.set(He,be)),ie=this._commands.toInternal(Je.command,be)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:ie,idx:K}})}}disposeCompletions(q){this._cache.delete(q);const Z=this._disposables.get(q);Z&&Z.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,Z){const re=this._cache.get(q,Z);re&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new h.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let Z=B.map.get(q);return Z||(Z=new B,B.map.set(q,Z)),Z}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=B,B.map=new WeakMap;class V{constructor(q,Z){this._documents=q,this._provider=Z,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(q,Z,re,ae){const J=this._documents.getDocument(q),se=k.Position.to(Z),ve=this.reviveContext(re);return A.asPromise(()=>this._provider.provideSignatureHelp(J,se,ae,ve)).then(Le=>{if(Le){const He=this._cache.add([Le]);return{...k.SignatureHelp.from(Le),id:He}}})}reviveContext(q){let Z;if(q.activeSignatureHelp){const re=k.SignatureHelp.to(q.activeSignatureHelp),ae=this._cache.get(q.activeSignatureHelp.id,0);ae?(Z=ae,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...q,activeSignatureHelp:Z}}releaseSignatureHelp(q){this._cache.delete(q)}}class ee{constructor(q,Z){this._documents=q,this._provider=Z}provideInlayHints(q,Z,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideInlayHints(ae,k.Range.to(Z),re)).then(J=>J?{hints:J.map(k.InlayHint.from)}:void 0)}}class de{constructor(q,Z){this._documents=q,this._provider=Z,this._cache=new S.Cache("DocumentLink")}async provideLinks(q,Z){const re=this._documents.getDocument(q),ae=await A.asPromise(()=>this._provider.provideDocumentLinks(re,Z));if(!(!Array.isArray(ae)||ae.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(de._validateLink).map(k.DocumentLink.from)};{const J=this._cache.add(ae),se={links:[],id:J};for(let ve=0;ve<ae.length;ve++){if(!de._validateLink(ae[ve]))continue;const Le=k.DocumentLink.from(ae[ve]);Le.cacheId=[J,ve],se.links.push(Le)}return se}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...q);if(!re)return;const ae=await A.asPromise(()=>this._provider.resolveDocumentLink(re,Z));if(!(!ae||!de._validateLink(ae)))return k.DocumentLink.from(ae)}releaseLinks(q){this._cache.delete(q)}}class ye{constructor(q,Z){this._documents=q,this._provider=Z}provideColors(q,Z){const re=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentColors(re,Z)).then(ae=>Array.isArray(ae)?ae.map(se=>({color:k.Color.from(se.color),range:k.Range.from(se.range)})):[])}provideColorPresentations(q,Z,re){const ae=this._documents.getDocument(q),J=k.Range.to(Z.range),se=k.Color.to(Z.color);return A.asPromise(()=>this._provider.provideColorPresentations(se,{document:ae,range:J},re)).then(ve=>{if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)})}}class Fe{constructor(q,Z){this._documents=q,this._provider=Z}provideFoldingRanges(q,Z,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideFoldingRanges(ae,Z,re)).then(J=>{if(!!Array.isArray(J))return J.map(k.FoldingRange.from)})}}class Re{constructor(q,Z,re){this._documents=q,this._provider=Z,this._logService=re}provideSelectionRanges(q,Z,re){const ae=this._documents.getDocument(q),J=Z.map(k.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(ae,J,re)).then(se=>{if(!n.isNonEmptyArray(se))return[];if(se.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Le=0;Le<J.length;Le++){const He=[];ve.push(He);let be=J[Le],Je=se[Le];for(;;){if(!Je.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(He.push(k.SelectionRange.from(Je)),!Je.parent)break;be=Je.range,Je=Je.parent}}return ve})}}class Ne{constructor(q,Z){this._documents=q,this._provider=Z,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(q,Z,re){const ae=this._documents.getDocument(q),J=k.Position.to(Z),se=await this._provider.prepareCallHierarchy(ae,J,re);if(!se)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(se)?se.map(Le=>this._cacheAndConvertItem(ve,Le)):[this._cacheAndConvertItem(ve,se)]}async provideCallsTo(q,Z,re){const ae=this._itemFromCache(q,Z);if(!ae)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!J)return J.map(se=>({from:this._cacheAndConvertItem(q,se.from),fromRanges:se.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(q,Z,re){const ae=this._itemFromCache(q,Z);if(!ae)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!J)return J.map(se=>({to:this._cacheAndConvertItem(q,se.to),fromRanges:se.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,Z){const re=this._cache.get(q),ae={_sessionId:q,_itemId:re.size.toString(36),name:Z.name,detail:Z.detail,kind:k.SymbolKind.from(Z.kind),uri:Z.uri,range:k.Range.from(Z.range),selectionRange:k.Range.from(Z.selectionRange),tags:Z.tags?.map(k.SymbolTag.from)};return re.set(ae._itemId,Z),ae}_itemFromCache(q,Z){return this._cache.get(q)?.get(Z)}}class Ge{constructor(q,Z){this.adapter=q,this.extension=Z}}class Ve{constructor(q,Z,re,ae,J,se,ve){this._adapter=new Map,this._uriTransformer=Z,this._proxy=q.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=J,this._logService=se,this._apiDeprecation=ve}_transformDocumentSelector(q){return n.coalesce(n.asArray(q).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(q){if(typeof q=="string")return{$serialized:!0,language:q};if(q)return{$serialized:!0,language:q.language,scheme:this._transformScheme(q.scheme),pattern:typeof q.pattern=="undefined"?void 0:k.GlobPattern.from(q.pattern),exclusive:q.exclusive}}_transformScheme(q){return this._uriTransformer&&typeof q=="string"?this._uriTransformer.transformOutgoingScheme(q):q}_createDisposable(q){return new y.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Ve._handlePool++}_withAdapter(q,Z,re,ae,J=!1){const se=this._adapter.get(q);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Z){let ve;se.extension&&(ve=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Le=re(se.adapter,se.extension),He=se.extension;return He&&Promise.resolve(Le).then(()=>this._logService.trace(`[${He.identifier.value}] provider DONE after ${Date.now()-ve}ms`),be=>{J&&be instanceof b.CancellationError||(this._logService.error(`[${He.identifier.value}] provider FAILED`),this._logService.error(be))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,Z){const re=this._nextHandle();return this._adapter.set(re,new Ge(q,Z)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,Z,re,ae){const J=this._addNewAdapter(new u(this._documents,re),q),se=ae&&ae.label||Ve._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),se),this._createDisposable(J)}$provideDocumentSymbols(q,Z,re){return this._withAdapter(q,u,ae=>ae.provideDocumentSymbols(p.URI.revive(Z),re),void 0)}registerCodeLensProvider(q,Z,re){const ae=this._nextHandle(),J=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ge(new m(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Z),J);let se=this._createDisposable(ae);if(J!==void 0){const ve=re.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(J));se=y.Disposable.from(se,ve)}return se}$provideCodeLenses(q,Z,re){return this._withAdapter(q,m,ae=>ae.provideCodeLenses(p.URI.revive(Z),re),void 0)}$resolveCodeLens(q,Z,re){return this._withAdapter(q,m,ae=>ae.resolveCodeLens(Z,re),void 0)}$releaseCodeLenses(q,Z){this._withAdapter(q,m,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(q,Z,re){const ae=this._addNewAdapter(new s(this._documents,re),q);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDefinition(q,Z,re,ae){return this._withAdapter(q,s,J=>J.provideDefinition(p.URI.revive(Z),re,ae),[])}registerDeclarationProvider(q,Z,re){const ae=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDeclaration(q,Z,re,ae){return this._withAdapter(q,r,J=>J.provideDeclaration(p.URI.revive(Z),re,ae),[])}registerImplementationProvider(q,Z,re){const ae=this._addNewAdapter(new i(this._documents,re),q);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideImplementation(q,Z,re,ae){return this._withAdapter(q,i,J=>J.provideImplementation(p.URI.revive(Z),re,ae),[])}registerTypeDefinitionProvider(q,Z,re){const ae=this._addNewAdapter(new a(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideTypeDefinition(q,Z,re,ae){return this._withAdapter(q,a,J=>J.provideTypeDefinition(p.URI.revive(Z),re,ae),[])}registerHoverProvider(q,Z,re,ae){const J=this._addNewAdapter(new v(this._documents,re),q);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(q,Z,re,ae){return this._withAdapter(q,v,J=>J.provideHover(p.URI.revive(Z),re,ae),void 0)}registerEvaluatableExpressionProvider(q,Z,re,ae){const J=this._addNewAdapter(new g(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(q,Z,re,ae){return this._withAdapter(q,g,J=>J.provideEvaluatableExpression(p.URI.revive(Z),re,ae),void 0)}registerInlineValuesProvider(q,Z,re,ae){const J=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new _(this._documents,re),q);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Z),J);let ve=this._createDisposable(se);if(J!==void 0){const Le=re.onDidChangeInlineValues(He=>this._proxy.$emitInlineValuesEvent(J));ve=y.Disposable.from(ve,Le)}return ve}$provideInlineValues(q,Z,re,ae,J){return this._withAdapter(q,_,se=>se.provideInlineValues(p.URI.revive(Z),re,ae,J),void 0)}registerDocumentHighlightProvider(q,Z,re){const ae=this._addNewAdapter(new D(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentHighlights(q,Z,re,ae){return this._withAdapter(q,D,J=>J.provideDocumentHighlights(p.URI.revive(Z),re,ae),void 0)}registerLinkedEditingRangeProvider(q,Z,re){const ae=this._addNewAdapter(new o(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideLinkedEditingRanges(q,Z,re,ae){return this._withAdapter(q,o,async J=>{const se=await J.provideLinkedEditingRanges(p.URI.revive(Z),re,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ve._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(q,Z,re){const ae=this._addNewAdapter(new T(this._documents,re),q);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideReferences(q,Z,re,ae,J){return this._withAdapter(q,T,se=>se.provideReferences(p.URI.revive(Z),re,ae,J),void 0)}registerCodeActionProvider(q,Z,re,ae){const J=new f.DisposableStore,se=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Z),{providedKinds:ae?.providedCodeActionKinds?.map(ve=>ve.value),documentation:ae?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,J)}))},Ve._extLabel(q),Boolean(re.resolveCodeAction)),J.add(this._createDisposable(se)),J}$provideCodeActions(q,Z,re,ae,J){return this._withAdapter(q,L,se=>se.provideCodeActions(p.URI.revive(Z),re,ae,J),void 0)}$resolveCodeAction(q,Z,re){return this._withAdapter(q,L,ae=>ae.resolveCodeAction(Z,re),void 0)}$releaseCodeActions(q,Z){this._withAdapter(q,L,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(q,Z,re){const ae=this._addNewAdapter(new $(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Z),q.identifier,q.displayName||q.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(q,Z,re,ae){return this._withAdapter(q,$,J=>J.provideDocumentFormattingEdits(p.URI.revive(Z),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(q,Z,re){const ae=this._addNewAdapter(new W(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Z),q.identifier,q.displayName||q.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(q,Z,re,ae,J){return this._withAdapter(q,W,se=>se.provideDocumentRangeFormattingEdits(p.URI.revive(Z),re,ae,J),void 0)}registerOnTypeFormattingEditProvider(q,Z,re,ae){const J=this._addNewAdapter(new Q(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),ae,q.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(q,Z,re,ae,J,se){return this._withAdapter(q,Q,ve=>ve.provideOnTypeFormattingEdits(p.URI.revive(Z),re,ae,J,se),void 0)}registerWorkspaceSymbolProvider(q,Z){const re=this._addNewAdapter(new z(Z,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(q,Z,re){return this._withAdapter(q,z,ae=>ae.provideWorkspaceSymbols(Z,re),{symbols:[]})}$resolveWorkspaceSymbol(q,Z,re){return this._withAdapter(q,z,ae=>ae.resolveWorkspaceSymbol(Z,re),void 0)}$releaseWorkspaceSymbols(q,Z){this._withAdapter(q,z,re=>re.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(q,Z,re){const ae=this._addNewAdapter(new N(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Z),N.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(q,Z,re,ae,J){return this._withAdapter(q,N,se=>se.provideRenameEdits(p.URI.revive(Z),re,ae,J),void 0)}$resolveRenameLocation(q,Z,re,ae){return this._withAdapter(q,N,J=>J.resolveRenameLocation(p.URI.revive(Z),re,ae),void 0)}registerDocumentSemanticTokensProvider(q,Z,re,ae){const J=this._nextHandle(),se=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new Ge(new F(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),ae,se);let ve=this._createDisposable(J);if(se){const Le=re.onDidChangeSemanticTokens(He=>this._proxy.$emitDocumentSemanticTokensEvent(se));ve=y.Disposable.from(ve,Le)}return ve}$provideDocumentSemanticTokens(q,Z,re,ae){return this._withAdapter(q,F,J=>J.provideDocumentSemanticTokens(p.URI.revive(Z),re,ae),null,!0)}$releaseDocumentSemanticTokens(q,Z){this._withAdapter(q,F,re=>re.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(q,Z,re,ae){const J=this._addNewAdapter(new x(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),ae),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(q,Z,re,ae){return this._withAdapter(q,x,J=>J.provideDocumentRangeSemanticTokens(p.URI.revive(Z),re,ae),null,!0)}registerCompletionItemProvider(q,Z,re,ae){const J=this._addNewAdapter(new O(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),ae,O.supportsResolving(re),`${q.identifier.value}(${ae.join("")})`),this._createDisposable(J)}$provideCompletionItems(q,Z,re,ae,J){return this._withAdapter(q,O,se=>se.provideCompletionItems(p.URI.revive(Z),re,ae,J),void 0)}$resolveCompletionItem(q,Z,re){return this._withAdapter(q,O,ae=>ae.resolveCompletionItem(Z,re),void 0)}$releaseCompletionItems(q,Z){this._withAdapter(q,O,re=>re.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(q,Z,re){const ae=this._addNewAdapter(new M(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideInlineCompletions(q,Z,re,ae,J){return this._withAdapter(q,M,se=>se.provideInlineCompletions(p.URI.revive(Z),re,ae,J),void 0)}$handleInlineCompletionDidShow(q,Z,re){this._withAdapter(q,M,async ae=>{ae.handleDidShowCompletionItem(Z,re)},void 0)}$freeInlineCompletionsList(q,Z){this._withAdapter(q,M,async re=>{re.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(q,Z,re,ae){const J=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new V(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Z),J),this._createDisposable(se)}$provideSignatureHelp(q,Z,re,ae,J){return this._withAdapter(q,V,se=>se.provideSignatureHelp(p.URI.revive(Z),re,ae,J),void 0)}$releaseSignatureHelp(q,Z){this._withAdapter(q,V,re=>re.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(q,Z,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new ee(this._documents,re),q);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),ae);let se=this._createDisposable(J);if(ae!==void 0){const ve=re.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(ae));se=y.Disposable.from(se,ve)}return se}$provideInlayHints(q,Z,re,ae){return this._withAdapter(q,ee,J=>J.provideInlayHints(p.URI.revive(Z),re,ae),void 0)}registerDocumentLinkProvider(q,Z,re){const ae=this._addNewAdapter(new de(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Z),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(q,Z,re){return this._withAdapter(q,de,ae=>ae.provideLinks(p.URI.revive(Z),re),void 0)}$resolveDocumentLink(q,Z,re){return this._withAdapter(q,de,ae=>ae.resolveLink(Z,re),void 0)}$releaseDocumentLinks(q,Z){this._withAdapter(q,de,re=>re.releaseLinks(Z),void 0)}registerColorProvider(q,Z,re){const ae=this._addNewAdapter(new ye(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentColors(q,Z,re){return this._withAdapter(q,ye,ae=>ae.provideColors(p.URI.revive(Z),re),[])}$provideColorPresentations(q,Z,re,ae){return this._withAdapter(q,ye,J=>J.provideColorPresentations(p.URI.revive(Z),re,ae),void 0)}registerFoldingRangeProvider(q,Z,re){const ae=this._nextHandle(),J=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ge(new Fe(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Z),J);let se=this._createDisposable(ae);if(J!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));se=y.Disposable.from(se,ve)}return se}$provideFoldingRanges(q,Z,re,ae){return this._withAdapter(q,Fe,J=>J.provideFoldingRanges(p.URI.revive(Z),re,ae),void 0)}registerSelectionRangeProvider(q,Z,re){const ae=this._addNewAdapter(new Re(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideSelectionRanges(q,Z,re,ae){return this._withAdapter(q,Re,J=>J.provideSelectionRanges(p.URI.revive(Z),re,ae),[])}registerCallHierarchyProvider(q,Z,re){const ae=this._addNewAdapter(new Ne(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareCallHierarchy(q,Z,re,ae){return this._withAdapter(q,Ne,J=>Promise.resolve(J.prepareSession(p.URI.revive(Z),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(q,Z,re,ae){return this._withAdapter(q,Ne,J=>J.provideCallsTo(Z,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(q,Z,re,ae){return this._withAdapter(q,Ne,J=>J.provideCallsFrom(Z,re,ae),void 0)}$releaseCallHierarchy(q,Z){this._withAdapter(q,Ne,re=>Promise.resolve(re.releaseSession(Z)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:E.regExpFlags(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Ve._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ve._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ve._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Ve._serializeRegExp(q.beforeText),afterText:q.afterText?Ve._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Ve._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(q,Z,re){let{wordPattern:ae}=re;if(ae&&E.regExpLeadsToEndlessLoop(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Z,ae):this._documents.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const J=this._nextHandle(),se={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Ve._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Ve._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Ve._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,se),this._createDisposable(J)}$setWordDefinitions(q){for(const Z of q)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(fe[234],me([0,1,5,16,7]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(I,E){this._proxy=I.getProxy(p.MainContext.MainThreadLanguages),this._documents=E}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,E){await this._proxy.$changeLanguage(I,E);const C=this._documents.getDocumentData(I);if(!C)throw new Error(`document '${I.toString}' NOT found`);return C.document}async tokenAtPosition(I,E){const C=I.version,n=R.Position.from(E),P=await this._proxy.$tokensAtPosition(I.uri,n),d={type:k.StandardTokenType.Other,range:I.getWordRangeAtPosition(E)??new k.Range(E.line,E.character,E.line,E.character)};if(!P)return d;const f={range:R.Range.to(P.range),type:R.TokenType.to(P.type)};return!f.range.contains(E)||C!==I.version?d:f}}e.ExtHostLanguages=y}),define(fe[235],me([0,1,5,12,34]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(I){return I&&I.title}let A=class{constructor(E,C){this._logService=C,this._proxy=E.getProxy(p.MainContext.MainThreadMessageService)}showMessage(E,C,n,P,d){const f={extension:E};let l;typeof P=="string"||y(P)?l=[P,...d]:(f.modal=P?.modal,f.useCustom=P?.useCustom,f.detail=P?.detail,l=d),f.useCustom&&k.checkProposedApiEnabled(E);const c=[];for(let S=0;S<l.length;S++){const w=l[S];if(typeof w=="string")c.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:h}=w;c.push({title:b,isCloseAffordance:!!h,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,n,f,c).then(S=>{if(typeof S=="number")return l[S]})}};A=ze([We(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(fe[236],me([0,1,23,3,72,6,24,8,14,2,82,5,16,7,209,124]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(b,h,u,m,t){this._textDocumentsAndEditors=u,this._textDocuments=m,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const r=s.notebookEditor?.notebookUri,i=s.cell.handle,v=this._documents.get(r)?.getCell(i);if(v)return v.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const h=this._editors.get(b);if(!h)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(b){for(const[h,u]of this._editors)if(u.apiEditor===b)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,h){const u=this._documents.get(b);if(!u&&!h)throw new Error(`NO notebook document for '${b}'`);return u}_getProviderData(b){const h=this._notebookContentProviders.get(b);if(!h)throw new Error(`NO provider for '${b}'`);return h}registerNotebookContentProvider(b,h,u,m,t){if(I.isFalsyOrWhitespace(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:b,provider:u});let s;return u.onDidChangeNotebookContentOptions&&(s=u.onDidChangeNotebookContentOptions(()=>{const r=d.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(h,r)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},h,d.NotebookDocumentContentOptions.from(m),S._convertNotebookRegistrationData(b,t)),new f.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(b,h){if(!h)return;const u=h.filenamePattern.map(m=>d.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(h.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:h.displayName,filenamePattern:u,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,h,u){const m=S._notebookStatusBarItemProviderHandlePool++,t=typeof u.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(m,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(m,t,h);let s;return t!==void 0&&(s=u.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(m),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(m,t),s&&s.dispose()})}async createNotebookDocument(b){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&d.NotebookData.from(b.content)});return C.URI.revive(h)}async openNotebookDocument(b){const h=this._documents.get(b);if(h)return h.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(b),m=this._documents.get(C.URI.revive(u));return E.assertIsDefined(m?.apiNotebook)}async showNotebookDocument(b,h){C.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let u;typeof h=="object"?u={position:d.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(d.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:u={preserveFocus:!1};const m=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,u),t=m&&this._editors.get(m)?.apiEditor;if(t)return t;throw m?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,h,u,m){const t=this._notebookStatusBarItemProviders.get(b),s=C.URI.revive(h),r=this._documents.get(s);if(!r||!t)return;const i=r.getCellFromIndex(u);if(!i)return;const a=await t.provideCellStatusBarItems(i.apiCell,m);if(!a)return;const v=new y.DisposableStore,g=this._statusBarCache.add([v]),D=(Array.isArray(a)?a:[a]).map(o=>d.NotebookStatusBarItem.from(o,this._commandsConverter,v));return{cacheId:g,items:D}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,h,u,m,t){if(I.isFalsyOrWhitespace(h))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,u),this._notebookProxy.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},h,d.NotebookDocumentContentOptions.from(m),S._convertNotebookRegistrationData(b,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,h,u){const m=this._notebookSerializer.get(b);if(!m)throw new Error("NO serializer found");const t=await m.deserializeNotebook(h.buffer,u);return d.NotebookData.from(t)}async $notebookToData(b,h,u){const m=this._notebookSerializer.get(b);if(!m)throw new Error("NO serializer found");const t=await m.serializeNotebook(d.NotebookData.to(h),u);return p.VSBuffer.wrap(t)}async $openNotebook(b,h,u,m,t){const{provider:s}=this._getProviderData(b),r=await s.openNotebook(C.URI.revive(h),{backupId:u,untitledDocumentData:m?.buffer},t);return{metadata:r.metadata??Object.create(null),cells:r.cells.map(d.NotebookCellData.from)}}async $saveNotebook(b,h,u){const m=this.getNotebookDocument(C.URI.revive(h)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(m.apiNotebook,u),!0}async $saveNotebookAs(b,h,u,m){const t=this.getNotebookDocument(C.URI.revive(h)),{provider:s}=this._getProviderData(b);return await s.saveNotebookAs(C.URI.revive(u),t.apiNotebook,m),!0}async $backupNotebook(b,h,u){const m=this.getNotebookDocument(C.URI.revive(h)),t=this._getProviderData(b),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),r=String(k.hash([m.uri.toString(),this._backupIdPool++])),i=C.URI.joinPath(s,r),a=await t.provider.backupNotebook(m.apiNotebook,{destination:i},u);return m.updateBackup(a),a.id}_createExtHostEditor(b,h,u){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const m=new c.ExtHostNotebookEditor(h,this._notebookEditorsProxy,b,u.visibleRanges.map(d.NotebookRange.to),u.selections.map(d.NotebookRange.to),typeof u.viewColumn=="number"?d.ViewColumn.to(u.viewColumn):void 0);this._editors.set(h,m)}$acceptDocumentAndEditorsDelta(b){if(b.removedDocuments)for(const u of b.removedDocuments){const m=C.URI.revive(u),t=this._documents.get(m);t&&(t.dispose(),this._documents.delete(m),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===m.toString()&&this._editors.delete(s.id)}if(b.addedDocuments){const u=[];for(const m of b.addedDocuments){const t=C.URI.revive(m.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,r=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){s._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){s._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){s._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){s._onDidChangeCellExecutionState.fire(i)}},t,m);u.push(...m.cells.map(i=>l.ExtHostCell.asModelAddData(r.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(b.addedEditors)for(const u of b.addedEditors){if(this._editors.has(u.id))return;const m=C.URI.revive(u.documentUri),t=this._documents.get(m);t&&this._createExtHostEditor(t,u.id,u)}const h=[];if(b.removedEditors)for(const u of b.removedEditors){const m=this._editors.get(u);m&&(this._editors.delete(u),this._activeNotebookEditor?.id===m.id&&(this._activeNotebookEditor=void 0),h.push(m))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(m=>this._editors.get(m)).filter(m=>!!m);const u=new Set;this._visibleNotebookEditors.forEach(m=>u.add(m.id));for(const m of this._editors.values()){const t=u.has(m.id);m._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(m=>m).filter(m=>m.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(fe[237],me([0,1,3,70,12,5,13,16]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(P,d){const f=E._Keys.nextId();P.$registerNotebookEditorDecorationType(f,I.NotebookDecorationRenderOptions.from(d)),this.value={key:f,dispose(){P.$removeNotebookEditorDecorationType(f)}}}}E._Keys=new R.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(P,d,f){this._logService=P,this._extHostRpc=d,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new E(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,d){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,d);const f=this._notebooksAndEditors.getEditorById(P);d.visibleRanges&&f._acceptVisibleRanges(d.visibleRanges.ranges.map(I.NotebookRange.to)),d.selections&&f._acceptSelections(d.selections.selections.map(I.NotebookRange.to)),d.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),d.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const d in P)this._notebooksAndEditors.getEditorById(d)._acceptViewColumn(I.ViewColumn.to(P[d]))}};C=ze([We(0,k.ILogService),We(1,A.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(fe[238],me([0,1,3,6,5,26,2,16,83,24,18,84,21,17,12,7,34]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,s,r,i){this._initData=s,this._extHostNotebook=r,this._logService=i,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,r,i,a,v){for(let O of this._kernelData.values())if(O.controller.id===s&&y.ExtensionIdentifier.equals(t.identifier,O.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const g=this._handlePool++,_=this;this._logService.trace(`NotebookController[${g}], CREATED by ${t.identifier.value}, ${s}`);const D=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${t.identifier}'`);let o=!1;const T=new R.DisposableStore,L=new p.Emitter,$=new p.Emitter,W={id:`${t.identifier.value}/${s}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:v?v.map(I.NotebookRendererScript.from):[]};let Q=a??D,z;this._proxy.$addKernel(g,W).catch(O=>{console.log(O),o=!0});let N=0;const H=()=>{if(o)return;const O=++N;Promise.resolve().then(()=>{O===N&&this._proxy.$updateKernel(g,W)})},F=new C.ResourceMap,x={get id(){return s},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return W.label},set label(O){W.label=O??t.displayName??t.name,H()},get detail(){return W.detail??""},set detail(O){W.detail=O,H()},get description(){return W.description??""},set description(O){W.description=O,H()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(O){W.supportedLanguages=O,H()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(O){W.supportsExecutionOrder=O,H()},get rendererScripts(){return W.preloads?W.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(O){Q=O??D},get interruptHandler(){return z},set interruptHandler(O){z=O,W.supportsInterrupt=Boolean(O),H()},createNotebookCellExecution(O){if(o)throw new Error("notebook controller is DISPOSED");if(!F.has(O.notebook.uri))throw _._logService.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return _._createNotebookCellExecution(O)},dispose:()=>{o||(this._logService.trace(`NotebookController[${g}], DISPOSED`),o=!0,this._kernelData.delete(g),T.dispose(),L.dispose(),$.dispose(),this._proxy.$removeKernel(g))},updateNotebookAffinity(O,M){_._proxy.$updateNotebookPriority(g,O.uri,M)},onDidReceiveMessage:$.event,postMessage(O,M){return S.checkProposedApiEnabled(t),_._proxy.$postMessage(g,M&&_._extHostNotebook.getIdByEditor(M),O)},asWebviewUri(O){return S.checkProposedApiEnabled(t),E.asWebviewUri(O,_._initData.remote)}};return this._kernelData.set(g,{extensionId:t.identifier,controller:x,onDidReceiveMessage:$,onDidChangeSelection:L,associatedNotebooks:F}),x}$acceptNotebookAssociation(t,s,r){const i=this._kernelData.get(t);if(i){const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(s));r?i.associatedNotebooks.set(a.uri,!0):i.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),r),i.onDidChangeSelection.fire({selected:r,notebook:a.apiNotebook})}}async $executeCells(t,s,r){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(s)),v=[];for(let g of r){const _=a.getCell(g);_&&v.push(_.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),v.length),await i.controller.executeHandler.call(i.controller,v,a.apiNotebook,i.controller)}catch(g){this._logService.error(`NotebookController[${t}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(t,s,r){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(s));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,a.apiNotebook);else for(let v of r){const g=a.getCell(v);g&&this._activeExecutions.get(g.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,r){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getEditorById(s);i.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const i=new h(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,i);const a=i.onDidChangeState(()=>{i.state===b.Resolved&&(i.dispose(),a.dispose(),this._activeExecutions.delete(r.uri))});return i.asApiObject()}};w=ze([We(3,l.ILogService)],w),e.ExtHostNotebookKernels=w;var b;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(b||(b={}));class h extends R.Disposable{constructor(t,s,r){super();this._document=t,this._cell=s,this._proxy=r,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new u(10,i=>this.applyEdits(i)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const r=c.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return r===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:r,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,r){const i=this.cellIndexToHandle(s),a=this.validateAndConvertOutputs(f.asArray(t));return this.applyEditSoon({editType:2,handle:i,append:r,outputs:a})}async updateOutputItems(t,s,r){return t=c.NotebookCellOutput.ensureUniqueMimeTypes(f.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(I.NotebookCellOutputItem.from),outputId:s.id,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:r??null})},end(r,i){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:r??null,runEndTime:i??null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},appendOutput(r,i){return t.verifyStateForOutput(),t.updateOutputs(r,i,!0)},replaceOutput(r,i){return t.verifyStateForOutput(),t.updateOutputs(r,i,!1)},appendOutputItems(r,i){return t.verifyStateForOutput(),t.updateOutputItems(r,i,!0)},replaceOutputItems(r,i){return t.verifyStateForOutput(),t.updateOutputItems(r,i,!1)}})}}class u{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=n.timeout(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(fe[239],me([0,1,3,5,124]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(I,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,E,C){const n=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(E)?.fire({editor:n.apiEditor,message:C})}createRendererMessaging(I){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(I).event(...C),postMessage:(C,n)=>{const P=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,I,n)}}}getOrCreateEmitterFor(I){let E=this._rendererMessageEmitters.get(I);return E||(E=new p.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,E),E)}}e.ExtHostNotebookRenderers=y}),define(fe[62],me([0,1,5,3,6,23,4,13]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends k.Disposable{constructor(l,c,S,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=w,this._id=w.$register(this.name,c,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?y.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(c=>this._proxy.$clear(c,l))}show(l,c){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof l=="boolean"?l:c)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class C extends E{constructor(l,c){super(l,!1,void 0,c)}append(l){super.append(l),this._id.then(c=>this._proxy.$append(c,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends E{constructor(l,c,S){super(l,!0,c,S)}append(l){throw new Error("Not supported")}}class P{constructor(l,c){this.name=l,this._channel=c}append(l){this._channel.then(c=>c.append(l))}appendLine(l){this._channel.then(c=>c.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,c){this._channel.then(S=>S.show(l,c))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(l){this._proxy=l.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new C(l,this._proxy)}createOutputChannelFromLogFile(l,c){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!c)throw new Error("illegal argument `file`. must not be falsy");return new n(l,c,this._proxy)}};d=ze([We(0,I.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(fe[240],me([0,1,18,21,3,6,5,2,7,15,17,55]),function(X,e,p,R,k,y,A,I,E,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(f,l,c){const S=f.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(i,a){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=a}showQuickPick(i,a,v,g=R.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(i),D=++this._instances,o=S.$show(D,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},g),T={},L=o.then(()=>T);return Promise.race([L,_]).then($=>{if($!==T)return _.then(W=>{const Q=[];for(let z=0;z<W.length;z++){const N=W[z];let H,F,x,O,M;typeof N=="string"?H=N:(H=N.label,F=N.description,x=N.detail,O=N.picked,M=N.alwaysShow),Q.push({label:H,description:F,handle:z,detail:x,picked:O,alwaysShow:M})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{v.onDidSelectItem(W[z])}),S.$setItems(D,Q),o.then(z=>{if(typeof z=="number")return W[z];if(Array.isArray(z))return z.map(N=>W[N])})})}).then(void 0,$=>{if(!C.isPromiseCanceledError($))return S.$setError(D,$),Promise.reject($)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,a=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,S.$input(i,typeof this._validateInput=="function",a).then(void 0,v=>{if(!C.isPromiseCanceledError(v))return Promise.reject(v)})}$validateInput(i){return this._validateInput?p.asPromise(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,a=R.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!v)return;const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(_=>_.uri.toString()===v.uri.toString())}createQuickPick(i,a){const v=new t(i,a,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(i){const a=new s(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(i,a){const v=this._sessions.get(i);v&&v._fireDidChangeValue(a)}$onDidAccept(i){const a=this._sessions.get(i);a&&a._fireDidAccept()}$onDidChangeActive(i,a){const v=this._sessions.get(i);v instanceof t&&v._fireDidChangeActive(a)}$onDidChangeSelection(i,a){const v=this._sessions.get(i);v instanceof t&&v._fireDidChangeSelection(a)}$onDidTriggerButton(i,a){const v=this._sessions.get(i);v&&v._fireDidTriggerButton(a)}$onDidHide(i){const a=this._sessions.get(i);a&&a._fireDidHide()}}class b{constructor(i,a){this._extensionId=i,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((a,v)=>{const g=a===E.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(g,a)}),this.update({buttons:i.map((a,v)=>({iconPath:h(a.iconPath),tooltip:a.tooltip,handle:a===E.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const a=this._handlesToButtons.get(i);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(i){if(!this._disposed){for(const a of Object.keys(i)){const v=i[a];this._pendingUpdate[a]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function h(r){if(r instanceof E.ThemeIcon)return{id:r.id};const i=m(r),a=u(r);return{dark:typeof i=="string"?I.URI.file(i):i,light:typeof a=="string"?I.URI.file(a):a}}function u(r){return typeof r=="object"&&"light"in r?r.light:r}function m(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends b{constructor(i,a,v){super(i,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((a,v)=>{this._handlesToItems.set(v,a),this._itemsToHandles.set(a,v)}),this.update({items:i.map((a,v)=>({label:a.label,description:a.description,handle:v,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(i){const a=n.coalesce(i.map(v=>this._handlesToItems.get(v)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(i){const a=n.coalesce(i.map(v=>this._handlesToItems.get(v)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class s extends b{constructor(i,a){super(i,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?P.default.Error:P.default.Ignore})}}return new w(l,c)}e.createExtHostQuickOpen=d}),define(fe[241],me([0,1,2,3,52,6,18,5,17,96,12,26,34]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(i){if(i)return typeof i.iconPath=="string"?p.URI.file(i.iconPath):i.iconPath}function l(i,a){if(!i.iconPath&&!a.iconPath)return 0;if(i.iconPath){if(!a.iconPath)return 1}else return-1;const v=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,g=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return C.comparePaths(v,g)}function c(i,a){let v=0;if(i.strikeThrough!==a.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==a.faded)return i.faded?1:-1;if(i.tooltip!==a.tooltip)return(i.tooltip||"").localeCompare(a.tooltip||"");if(v=l(i,a),v!==0)return v;if(i.light&&a.light)v=l(i.light,a.light);else{if(i.light)return 1;if(a.light)return-1}if(v!==0)return v;if(i.dark&&a.dark)v=l(i.dark,a.dark);else{if(i.dark)return 1;if(a.dark)return-1}return v}function S(i,a){if(i.command!==a.command)return i.command<a.command?-1:1;if(i.title!==a.title)return i.title<a.title?-1:1;if(i.tooltip!==a.tooltip){if(i.tooltip!==void 0&&a.tooltip!==void 0)return i.tooltip<a.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(i.arguments===a.arguments)return 0;if(i.arguments)if(a.arguments){if(i.arguments.length!==a.arguments.length)return i.arguments.length-a.arguments.length}else return 1;else return-1;for(let v=0;v<i.arguments.length;v++){const g=i.arguments[v],_=a.arguments[v];if(g!==_)return g<_?-1:1}return 0}function w(i,a){let v=C.comparePaths(i.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(v!==0)return v;if(i.command&&a.command)v=S(i.command,a.command);else{if(i.command)return 1;if(a.command)return-1}if(v!==0)return v;if(i.decorations&&a.decorations)v=c(i.decorations,a.decorations);else{if(i.decorations)return 1;if(a.decorations)return-1}return v}function b(i,a){for(let v=0;v<i.length;v++)if(i[v]!==a[v])return!1;return!0}function h(i,a){return i.command===a.command&&i.title===a.title&&i.tooltip===a.tooltip&&(i.arguments&&a.arguments?b(i.arguments,a.arguments):i.arguments===a.arguments)}function u(i,a){return E.equals(i,a,h)}class m{constructor(a,v,g){this._extension=a,this._proxy=v,this._sourceControlHandle=g,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return d.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(a){if(d.checkProposedApiEnabled(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){d.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,v){d.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,v)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=m;class t{constructor(a,v,g,_,D){this._proxy=a,this._commands=v,this._sourceControlHandle=g,this._id=_,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,v){const g=this._resourceStatesCommandsMap.get(a);return g?A.asPromise(()=>this._commands.executeCommand(g.command,...g.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const a=[...this._resourceStates].sort(w),g=E.sortedDiff(this._resourceSnapshot,a,w).map(o=>{const T=o.toInsert.map(L=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,L);const W=L.resourceUri,Q=f(L.decorations),z=L.decorations&&f(L.decorations.light)||Q,N=L.decorations&&f(L.decorations.dark)||Q,H=[];let F;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const ee=new y.DisposableStore;F=this._commands.converter.toInternal(L.command,ee),this._resourceStatesDisposablesMap.set($,ee)}else this._resourceStatesCommandsMap.set($,L.command);z&&H.push(z),N&&N.toString()!==z?.toString()&&H.push(N);const x=L.decorations&&L.decorations.tooltip||"",O=L.decorations&&!!L.decorations.strikeThrough,M=L.decorations&&!!L.decorations.faded,B=L.contextValue||"";return{rawResource:[$,W,H,x,O,M,B,F],handle:$}});return{start:o.start,deleteCount:o.deleteCount,toInsert:T}}),_=g.map(({start:o,deleteCount:T,toInsert:L})=>[o,T,L.map($=>$.rawResource)]),D=g.reverse();for(const{start:o,deleteCount:T,toInsert:L}of D){const $=L.map(Q=>Q.handle),W=this._handlesSnapshot.splice(o,T,...$);for(const Q of W)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=a,_}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class s{constructor(a,v,g,_,D,o){this._proxy=v,this._commands=g,this._id=_,this._label=D,this._rootUri=o,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,D,o)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=a;const v=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(this._statusBarCommands&&a&&u(this._statusBarCommands,a))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=a;const v=(a||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(a,v){const g=new t(this._proxy,this._commands,this.handle,a,v),_=R.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,_),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const a=[],v=[];for(const[g,_]of this.createdResourceGroups){_.dispose();const D=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});R.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),D.dispose(),this._groups.delete(g.handle),this._proxy.$unregisterGroup(this.handle,g.handle)}),a.push([g.handle,g.id,g.label,g.features]);const o=g._takeResourceStateSnapshot();o.length>0&&v.push([g.handle,o]),this._groups.set(g.handle,g)}this._proxy.$registerGroups(this.handle,a,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(v=>{const g=v._takeResourceStateSnapshot();g.length!==0&&a.push([v.handle,g])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,ze([k.debounce(100)],s.prototype,"eventuallyAddResourceGroups",null),ze([k.debounce(100)],s.prototype,"eventuallyUpdateResourceStates",null);let r=class $n{constructor(a,v,g){this._commands=v,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=a.getProxy(I.MainContext.MainThreadSCM),this._telemetry=a.getProxy(I.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const D=this._sourceControls.get(_.sourceControlHandle);if(!D)return _;const o=D.getResourceGroup(_.groupHandle);return o?o.getResourceState(_.handle):_}else if(_&&_.$mid===4){const D=this._sourceControls.get(_.sourceControlHandle);return D?D.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const D=this._sourceControls.get(_.handle);return D||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,v,g,_){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,v,g,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const D=$n._handlePool++,o=new s(a,this._proxy,this._commands,v,g,_);this._sourceControls.set(D,o);const T=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier))||[];return T.push(o),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(a.identifier),T),o}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const v=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier)),g=v&&v[v.length-1];return g&&g.inputBox}$provideOriginalResource(a,v,g){const _=p.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,_.toString());const D=this._sourceControls.get(a);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>D.quickDiffProvider.provideOriginalResource(_,g)).then(o=>o||null)}$onInputBoxValueChange(a,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const g=this._sourceControls.get(a);return g&&g.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(a,v,g,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,v,g);const D=this._sourceControls.get(a);if(!D)return Promise.resolve(void 0);const o=D.getResourceGroup(v);return o?o.$executeResourceCommand(g,_):Promise.resolve(void 0)}$validateInput(a,v,g){this.logService.trace("ExtHostSCM#$validateInput",a);const _=this._sourceControls.get(a);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>_.inputBox.validateInput(v,g)).then(D=>D?Promise.resolve([D.message,D.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&this._sourceControls.get(a)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};r._handlePool=0,r=ze([We(2,n.ILogService)],r),e.ExtHostSCM=r});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[242],me([0,1,7,5,162,6,16]),function(X,e,p,R,k,y,A){"use strict";var I,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(f,l,c,S,w=p.StatusBarAlignment.Left,b){I.set(this,void 0),E.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,I,f,"f"),it(this,E,l,"f"),this._entryId=C.ID_GEN++,this._extension=c,this._id=S,this._alignment=w,this._priority=b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set tooltip2(f){this._tooltip2=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!C.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ue(this,E,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ue(this,E,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let l;this._name?l=this._name:l=k.localize(0,null,this._extension.displayName||this._extension.name);let c=this._color;this._backgroundColor&&(c=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip2!==void 0?A.MarkdownString.fromStrict(this._tooltip2):this.tooltip;Ue(this,I,"f").$setEntry(this._entryId,f,l,this._text,S,this._command?.internal,c,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,I=new WeakMap,E=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=k.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const l={message:f};return this._messages.unshift(l),this._update(),new p.Disposable(()=>{const c=this._messages.indexOf(l);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(f,l){this._proxy=f.getProxy(R.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new n(this)}createStatusBarEntry(f,l,c,S){return new C(this._proxy,this._commands,f,l,c,S)}setStatusBarMessage(f,l){const c=this._statusMessage.setMessage(f);let S;return typeof l=="number"?S=setTimeout(()=>c.dispose(),l):typeof l!="undefined"&&l.then(()=>c.dispose(),()=>c.dispose()),new p.Disposable(()=>{c.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=P}),define(fe[87],me([0,1,5,3,4]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(I){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,E){this._proxy.$registerExtensionStorageKeysToSync(I,E)}getValue(I,E,C){return this._proxy.$getValue(I,E).then(n=>n||C)}setValue(I,E,C){return this._proxy.$setValue(I,E,C)}$acceptValue(I,E,C){this._onDidChangeStorage.fire({shared:I,key:E,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=k.createDecorator("IExtHostStorage")}),define(fe[88],me([0,1,4,27,12,86,2]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=p.createDecorator("IExtensionStoragePaths");let I=class{constructor(C,n,P){this._logService=n,this._extHostFileSystem=P,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,n=A.URI.joinPath(this._environment.workspaceStorageHome,C);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this._value)return A.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return A.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};I=ze([We(0,R.IExtHostInitDataService),We(1,k.ILogService),We(2,y.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(fe[33],me([0,1,3,5,4,2,13,6,7,163,15,205,21,32,191,14]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=k.createDecorator("IExtHostTerminalService");class S{constructor(r,i,a,v){this._proxy=r,this._id=i,this._creationOptions=a,this._name=v,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const g=this;this.value={get name(){return g._name||""},get processId(){return g._pidPromise},get creationOptions(){return g._creationOptions},get exitStatus(){return g._exitStatus},sendText(_,D=!0){g._checkDisposed(),g._proxy.$sendText(g._id,_,D)},show(_){g._checkDisposed(),g._proxy.$show(g._id,_)},hide(){g._checkDisposed(),g._proxy.$hide(g._id)},dispose(){g._disposed||(g._disposed=!0,g._proxy.$dispose(g._id))},get dimensions(){if(!(g._cols===void 0||g._rows===void 0))return{columns:g._cols,rows:g._rows}}}}async create(r,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:c.withNullAsUndefined(r.shellPath),shellArgs:c.withNullAsUndefined(r.shellArgs),cwd:c.withNullAsUndefined(r.cwd),env:c.withNullAsUndefined(r.env),icon:c.withNullAsUndefined(t(r.iconPath)),initialText:c.withNullAsUndefined(r.message),strictEnv:c.withNullAsUndefined(r.strictEnv),hideFromUser:c.withNullAsUndefined(r.hideFromUser),isFeatureTerminal:c.withNullAsUndefined(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:c.withNullAsUndefined(i?.useShellEnvironment),isSplitTerminal:i?.isSplitTerminal,target:i?.target})}async createExtensionTerminal(r,i,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:a,isSplitTerminal:r,target:i}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,i){return r===this._cols&&i===this._rows||r===0||i===0?!1:(this._cols=r,this._rows=i,!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=S;class w{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,i){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:i})}async processBinary(r){}acknowledgeDataEvent(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let b=1,h=class extends I.Disposable{constructor(r,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[a,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,i){const a=new S(this._proxy,f.generateUuid(),r,r.name),v=new w(r.pty);return a.createExtensionTerminal(i?.isSplitTerminal,i?.target,t(r.iconPath)).then(g=>{const _=this._setupExtHostProcessListeners(g,v);this._terminalProcessDisposables[g]=_}),this._terminals.push(a),a.value}attachPtyToTerminal(r,i){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const v=new w(i),g=this._setupExtHostProcessListeners(r,v);this._terminalProcessDisposables[r]=g}async $acceptActiveTerminalChanged(r){const i=this._activeTerminal;if(r===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(r);a&&(this._activeTerminal=a,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,i){const a=this._getTerminalById(r);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:i})}async $acceptTerminalDimensions(r,i,a){const v=this._getTerminalById(r);v&&v.setDimensions(i,a)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(r,i,a){this._terminalProcesses.get(r)?.resize(i,a)}async $acceptTerminalTitleChange(r,i){const a=this._getTerminalById(r);a&&(a.name=i)}async $acceptTerminalClosed(r,i){const a=this._getTerminalObjectIndexById(this._terminals,r);if(a!==null){const v=this._terminals.splice(a,1)[0];v.setExitCode(i),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(r,i,a,v){if(i){const D=this._getTerminalObjectIndexById(this._terminals,i);if(D!==null){this._terminals[D]._id=r,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const g={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:y.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},_=new S(this._proxy,r,g,a);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(r,i){const a=this._getTerminalById(r);a&&a._setProcessId(i)}async $startExtensionTerminal(r,i){const a=this._getTerminalById(r);if(!a)return{message:C.localize(0,null,r)};a.isOpen||await new Promise(g=>{const _=this.onDidOpenTerminal(async D=>{D===a.value&&(_.dispose(),g())})});const v=this._terminalProcesses.get(r);v?v.startSendingEvents(i):this._extensionTerminalAwaitingStart[r]={initialDimensions:i}}_setupExtHostProcessListeners(r,i){const a=new I.DisposableStore;a.add(i.onProcessReady(g=>this._proxy.$sendProcessReady(r,g.pid,g.cwd))),a.add(i.onProcessTitleChanged(g=>this._proxy.$sendProcessTitle(r,g))),this._bufferer.startBuffering(r,i.onProcessData),a.add(i.onProcessExit(g=>this._onProcessExit(r,g))),i.onProcessOverrideDimensions&&a.add(i.onProcessOverrideDimensions(g=>this._proxy.$sendOverrideDimensions(r,g))),this._terminalProcesses.set(r,i);const v=this._extensionTerminalAwaitingStart[r];return v&&i instanceof w&&(i.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),a}$acceptProcessAckDataEvent(r,i){this._terminalProcesses.get(r)?.acknowledgeDataEvent(i)}$acceptProcessInput(r,i){this._terminalProcesses.get(r)?.input(i)}$acceptProcessResize(r,i,a){try{this._terminalProcesses.get(r)?.resize(i,a)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(r,i){this._terminalProcesses.get(r)?.shutdown(i)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(i=>this._proxy.$sendProcessInitialCwd(r,i))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(i=>this._proxy.$sendProcessCwd(r,i))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,i,a){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,a),this._proxy.$registerProfileProvider(i,r.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(r,i){const a=new d.CancellationTokenSource().token,v=await this._profileProviders.get(r)?.provideTerminalProfile(a);if(!a.isCancellationRequested){if(!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,i);return}this.createTerminalFromOptions(v.options,i)}}async $provideLinks(r,i){const a=this._getTerminalById(r);if(!a)return[];this._terminalLinkCache.delete(r);const v=this._terminalLinkCancellationSource.get(r);v&&v.dispose(!0);const g=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,g);const _=[],D={terminal:a.value,line:i},o=[];for(const $ of this._linkProviders)o.push(new Promise(async W=>{g.token.onCancellationRequested(()=>W({provider:$,links:[]}));const Q=await $.provideTerminalLinks(D,g.token)||[];g.token.isCancellationRequested||W({provider:$,links:Q})}));const T=await Promise.all(o);if(g.token.isCancellationRequested)return[];const L=new Map;for(const $ of T)$&&$.links.length>0&&_.push(...$.links.map(W=>{const Q={id:b++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return L.set(Q.id,{provider:$.provider,link:W}),Q}));return this._terminalLinkCache.set(r,L),_}$activateLink(r,i){const a=this._terminalLinkCache.get(r)?.get(i);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(r,i){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const a=this._terminalProcessDisposables[r];a&&(a.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,i)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,i){const a=this._getTerminalObjectIndexById(r,i);return a!==null?r[a]:null}_getTerminalObjectIndexById(r,i){let a=null;return r.some((v,g)=>v._id===i?(a=g,!0):!1),a}getEnvironmentVariableCollection(r){let i=this._environmentVariableCollections.get(r.identifier.value);return i||(i=new u,this._setEnvironmentVariableCollection(r.identifier.value,i)),i}_syncEnvironmentVariableCollection(r,i){const a=P.serializeEnvironmentVariableCollection(i.map);this._proxy.$setEnvironmentVariableCollection(r,i.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(r){r.forEach(i=>{const a=i[0],v=new u(i[1]);this._setEnvironmentVariableCollection(a,v)})}$acceptDefaultProfile(r,i){this._defaultProfile=r,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(r,i){this._environmentVariableCollections.set(r,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,i)})}};h=ze([We(1,A.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class u{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,i){this._setIfDiffers(r,{value:i,type:E.EnvironmentVariableMutatorType.Replace})}append(r,i){this._setIfDiffers(r,{value:i,type:E.EnvironmentVariableMutatorType.Append})}prepend(r,i){this._setIfDiffers(r,{value:i,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,i){const a=this.map.get(r);(!a||a.value!==i.value||a.type!==i.type)&&(this.map.set(r,i),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,i){this.map.forEach((a,v)=>r.call(i,v,a,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let m=class extends h{constructor(r){super(!1,r)}createTerminal(r,i,a){throw new n.NotSupportedError}createTerminalFromOptions(r,i){throw new n.NotSupportedError}};m=ze([We(0,A.IExtHostRpcService)],m),e.WorkerExtHostTerminalService=m;function t(s){if(!!s)return"id"in s?{id:s.id,color:s.color}:s}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[243],me([0,1,17,18,23,21,3,69,53,6,25,14,32,5,13,16,7,214,122]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b){"use strict";var h,u,m,t,s,r;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(W,Q){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=W.getProxy(f.MainContext.MainThreadTesting),this.observer=new L(this.proxy),this.runTracker=new v(this.proxy),Q.registerArgumentProcessor({processArgument:z=>z?.$mid===13?c.TestItem.toItemFromContext(z):z})}createTestController(W){const Q=new C.DisposableStore,z=Q.add(new w.SingleUseTestCollection(W)),N=Q.add(new R.RunOnceScheduler(()=>z.expand(z.root.id,0),0)),H={root:z.root,get id(){return W},createTestRun:(F,x,O=!0)=>this.runTracker.createTestRun(W,F,x,O),createTestItem(F,x,O,M,B){if(!(O instanceof S.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${F} is invalid`);return new S.TestItemImpl(F,x,M,B,O)},set resolveChildrenHandler(F){z.resolveHandler=F,F&&N.schedule()},get resolveChildrenHandler(){return z.resolveHandler},dispose:()=>{Q.dispose()}};return this.proxy.$registerTestController(W),Q.add(C.toDisposable(()=>this.proxy.$unregisterTestController(W))),this.controllers.set(W,{controller:H,collection:z}),Q.add(C.toDisposable(()=>this.controllers.delete(W))),Q.add(z.onDidGenerateDiff(F=>this.proxy.$publishDiff(W,F))),H}createTestObserver(){return this.observer.checkout()}async runTests(W,Q=y.CancellationToken.None){const z=N=>N.map(this.getInternalTestForReference,this).filter(P.isDefined).map(H=>({controllerId:H.controllerId,testId:H.item.extId}));await this.proxy.$runTests({exclude:W.exclude?z(W.exclude).map(N=>N.testId):void 0,tests:z(W.tests),debug:W.debug},Q)}$provideFileCoverage(W,Q,z){return E.Iterable.find(this.runTracker.trackers,N=>N.id===W)?.getCoverage(Q)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(W,Q,z,N){return E.Iterable.find(this.runTracker.trackers,H=>H.id===W)?.getCoverage(Q)?.resolveFileCoverage(z,N)??Promise.resolve([])}$publishTestResults(W){this.results=Object.freeze(W.map(Q=>n.deepFreeze(c.TestResults.to(Q))).concat(this.results).sort((Q,z)=>z.completedAt-Q.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:W,testId:Q},z){const N=this.controllers.get(W)?.collection;N&&(await N.expand(Q,z<0?Infinity:z),N.flushDiff())}$acceptDiff(W){this.observer.applyDiff(W)}async $runControllerTests(W,Q){const z=this.controllers.get(W.controllerId);if(!z)return;const{controller:N,collection:H}=z,F=W.testIds.map(B=>H.tree.get(B)).filter(P.isDefined),x=W.excludeExtIds.map(B=>z.collection.tree.get(B)).filter(P.isDefined).filter(B=>F.some(V=>H.tree.comparePositions(V,B)===1));if(!F.length)return;const O={tests:F.map(B=>B.actual),exclude:x.map(B=>B.actual),debug:W.debug},M=this.runTracker.prepareForMainThreadTestRun(O,g.fromInternal(W),Q);try{await N.runHandler?.(O,Q)}finally{M.isRunning&&!Q.isCancellationRequested&&await A.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(W.runId)}}$cancelExtensionTestRun(W){W===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(W)}getInternalTestForReference(W){return p.mapFind(this.controllers.values(),({collection:Q})=>Q.getTestByReference(W))??this.observer.getMirroredTestDataByReference(W)}};i=ze([We(0,l.IExtHostRpcService)],i),e.ExtHostTesting=i;class a extends C.Disposable{constructor(W,Q,z){super();this.dto=W,this.proxy=Q,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:N}of this.tasks.values())N.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(W){return this.tasks.get(W)?.coverage}createRun(W){const Q=d.generateUuid(),z=new _(this.proxy,this.dto.id,Q),N=new D(W,this.cts.token,Q,z,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(N.taskId),this.isRunning||this.dispose()});return this.tasks.set(N.taskId,{run:N,coverage:z}),N}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class v{constructor(W){this.proxy=W,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(W,Q,z){return this.getTracker(W,Q,z)}cancelRunById(W){for(const Q of this.tracked.values())if(Q.id===W){Q.dispose();return}}cancelAllRuns(){for(const W of this.tracked.values())W.dispose()}createTestRun(W,Q,z,N){const H=this.tracked.get(Q);if(H)return H.createRun(z);const F=g.fromPublic(W,Q);this.proxy.$startedExtensionTestRun({debug:Q.debug,exclude:Q.exclude?.map(O=>O.id)??[],id:F.id,tests:Q.tests.map(O=>O.id),persist:N});const x=this.getTracker(Q,F);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(F.id)),x.createRun(z)}getTracker(W,Q,z){const N=new a(Q,this.proxy,z);return this.tracked.set(W,N),N.onEnd(()=>this.tracked.delete(W)),N}}e.TestRunCoordinator=v;class g{constructor(W,Q,z,N){this.controllerId=W,this.id=Q,this.include=z,this.exclude=N}static fromPublic(W,Q){return new g(W,d.generateUuid(),new Set(Q.tests.map(z=>z.id)),new Set(Q.exclude?.map(z=>z.id)??E.Iterable.empty()))}static fromInternal(W){return new g(W.controllerId,W.runId,new Set(W.testIds),new Set(W.excludeExtIds))}isIncluded(W){for(let Q=W;Q;Q=Q.parent){if(this.include.has(Q.id))return!0;if(this.exclude.has(Q.id))return!1}return!1}}e.TestRunDto=g;class _{constructor(W,Q,z){this.proxy=W,this.runId=Q,this.taskId=z}set coverageProvider(W){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!W||(this._coverageProvider=W,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(W){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(W))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(Q){throw this.fileCoverage=void 0,Q}}async resolveFileCoverage(W,Q){const z=await this.fileCoverage;let N=z?.[W];return!this._coverageProvider||!z||!N?[]:(N.detailedCoverage||(N=z[W]=await this._coverageProvider.resolveFileCoverage?.(N,Q)??N),N.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class D{constructor(W,Q,z,N,H,F,x,O){this.name=W,this.token=Q,this.taskId=z,h.set(this,void 0),u.set(this,void 0),m.set(this,void 0),t.set(this,void 0),s.set(this,void 0),r.set(this,!1),it(this,t,O,"f"),it(this,h,x,"f"),it(this,u,H,"f"),it(this,s,N,"f"),it(this,m,F,"f"),x.$startedTestRunTask(H.id,{id:this.taskId,name:W,running:!0})}set coverageProvider(W){Ue(this,s,"f").coverageProvider=W}get coverageProvider(){return Ue(this,s,"f").coverageProvider}setState(W,Q,z){!Ue(this,r,"f")&&Ue(this,u,"f").isIncluded(W)&&(this.ensureTestIsKnown(W),Ue(this,h,"f").$updateTestStateInRun(Ue(this,u,"f").id,this.taskId,W.id,Q,z))}appendMessage(W,Q){!Ue(this,r,"f")&&Ue(this,u,"f").isIncluded(W)&&(this.ensureTestIsKnown(W),Ue(this,h,"f").$appendTestMessageInRun(Ue(this,u,"f").id,this.taskId,W.id,c.TestMessage.from(Q)))}appendOutput(W){Ue(this,r,"f")||Ue(this,h,"f").$appendOutputToRun(Ue(this,u,"f").id,this.taskId,k.VSBuffer.fromString(W))}end(){Ue(this,r,"f")||(it(this,r,!0,"f"),Ue(this,h,"f").$finishedTestRunTask(Ue(this,u,"f").id,this.taskId),Ue(this,t,"f").call(this))}ensureTestIsKnown(W){const Q=Ue(this,m,"f");if(Q.has(W.id))return;const z=[];for(;z.unshift(c.TestItem.from(W)),!(Q.has(W.id)||(Q.add(W.id),!W.parent));)W=W.parent;Ue(this,h,"f").$addTestsToRun(Ue(this,u,"f").controllerId,Ue(this,u,"f").id,z)}}h=new WeakMap,u=new WeakMap,m=new WeakMap,t=new WeakMap,s=new WeakMap,r=new WeakMap;class o extends b.IncrementalChangeCollector{constructor(W){super();this.emitter=W,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(W){this.added.add(W)}update(W){Object.assign(W.revived,c.TestItem.toPlain(W.item)),this.added.has(W)||this.updated.add(W)}remove(W){if(this.added.has(W)){this.added.delete(W);return}if(this.updated.delete(W),W.parent&&this.alreadyRemoved.has(W.parent)){this.alreadyRemoved.add(W.item.extId);return}this.removed.add(W)}getChangeEvent(){const{added:W,updated:Q,removed:z}=this;return{get added(){return[...W].map(N=>N.revived)},get updated(){return[...Q].map(N=>N.revived)},get removed(){return[...z].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class T extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(W){return this.items.get(W)}getMirroredTestDataByReference(W){return this.items.get(W.id)}createItem(W,Q){return{...W,revived:c.TestItem.toPlain(W.item),depth:Q?Q.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=T;class L{constructor(W){this.proxy=W}checkout(){this.current||(this.current=this.createObserverData());const W=this.current;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(Q=>Q.revived)},dispose:I.once(()=>{--W.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(W){return this.current?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.current?.tests.apply(W)}createObserverData(){const W=new T;return this.proxy.$subscribeToDiffs(),{observers:0,tests:W}}}}),define(fe[244],me([0,1,3,17,5,125,16,7]),function(X,e,p,R,k,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(d=>d.value)}async showTextDocument(n,P,d){let f;typeof P=="number"?f={position:A.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?f={position:A.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?A.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:f={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(n.uri,f),c=l&&this._extHostDocumentsAndEditors.getEditor(l);if(c)return c.value;throw l?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,P){return new y.TextEditorDecorationType(this._proxy,n,P).value}$acceptEditorPropertiesChanged(n,P){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const f=P.selections.selections.map(A.Selection.to);d._acceptSelections(f)}if(P.visibleRanges){const f=R.coalesce(P.visibleRanges.map(A.Range.to));d._acceptVisibleRanges(f)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:{...P.options,lineNumbers:A.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const f=I.TextEditorSelectionChangeKind.fromValue(P.selections.source),l=P.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:l,kind:f})}if(P.visibleRanges){const f=R.coalesce(P.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const P in n){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const f=A.ViewColumn.to(n[P]);d.value.viewColumn!==f&&(d._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=E}),define(fe[245],me([0,1,2,4,5,6,7]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class I{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===11){const f=d.uri===void 0?void 0:p.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(E(f))?.get(d.handle)}return d}})}async $getTimeline(n,P,d,f,l){return this._providers.get(n)?.provideTimeline(p.URI.revive(P),d,f,l)}registerTimelineProvider(n,P,d,f){const l=new y.DisposableStore,c=this.convertTimelineItem(P.id,f,l).bind(this);let S;P.onDidChange&&(S=P.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:P.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:n,onDidChange:void 0,async provideTimeline(b,h,u,m){m?.resetCache&&(l.clear(),w.get(P.id)?.clear());const t=await P.provideTimeline(b,h,u);if(t==null)return;const s=c(b,m);return{...t,source:P.id,items:t.items.map(s)}},dispose(){for(const b of w.values())b.get(P.id)?.clear();S?.dispose(),l.dispose()}})}convertTimelineItem(n,P,d){return(f,l)=>{let c;if(l?.cacheResults){let S=this._itemsBySourceAndUriMap.get(n);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(n,S));const w=E(f);c=S.get(w),c===void 0&&(c=new Map,S.set(w,c))}return S=>{const{iconPath:w,...b}=S,h=`${n}|${S.id??S.timestamp}`;c?.set(h,S);let u,m,t;return S.iconPath&&(w instanceof A.ThemeIcon?t={id:w.id}:p.URI.isUri(w)?(u=w,m=w):{light:u,dark:m}=w),{...b,id:b.id??void 0,handle:h,source:n,command:S.command?P.toInternal(S.command,d):void 0,icon:u,iconDark:m,themeIcon:t,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),y.toDisposable(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=I;function E(C){return C?.toString()}}),define(fe[246],me([0,1,6,10,2,5]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(E){this._openers=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,C,n,P){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const d=P.schemes.find(f=>!A.supportedSchemes.has(f));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,P.schemes,E,P.label),p.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(E,C,n){const P=this._openers.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const d=k.URI.revive(C);return P.canOpenExternalUri(d,n)}async $openUri(E,C,n){const P=this._openers.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(k.URI.revive(C.resolvedUri),{sourceUri:k.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(fe[247],me([0,1,5,2,6,15,26]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(A.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=I.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(C)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,C),k.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(C)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(C,n){const P=this.handlers.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(n))}catch(d){y.onUnexpectedError(d)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=I,I.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[63],me([0,1,3,2,174,199,83,5]),function(X,e,p,R,k,y,A,I){"use strict";var E,C,n,P,d,f,l,c,S,w,b,h;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(g,_,D,o,T,L,$){E.set(this,void 0),C.set(this,void 0),n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),f.set(this,void 0),l.set(this,""),c.set(this,void 0),S.set(this,!1),w.set(this,!1),b.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new p.Emitter),this._onDidDispose=Ue(this,h,"f").event,it(this,E,g,"f"),it(this,C,_,"f"),it(this,c,D,"f"),it(this,P,o,"f"),it(this,d,T,"f"),it(this,f,L,"f"),it(this,b,m(L),"f"),it(this,n,$,"f")}dispose(){it(this,S,!0,"f"),Ue(this,h,"f").fire(),Ue(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return it(this,w,!0,"f"),A.asWebviewUri(g,Ue(this,P,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,l,"f")}set html(g){this.assertNotDisposed(),Ue(this,l,"f")!==g&&(it(this,l,g,"f"),!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(it(this,w,!0,"f"),Ue(this,n,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,C,"f").$setHtml(Ue(this,E,"f"),g))}get options(){return this.assertNotDisposed(),Ue(this,c,"f")}set options(g){this.assertNotDisposed(),Ue(this,C,"f").$setOptions(Ue(this,E,"f"),r(Ue(this,f,"f"),Ue(this,d,"f"),g)),it(this,c,g,"f")}async postMessage(g){if(Ue(this,S,"f"))return!1;const _=y.serializeWebviewMessage(g,{serializeBuffersForPostMessage:Ue(this,b,"f")});return Ue(this,C,"f").$postMessage(Ue(this,E,"f"),_.message,..._.buffers)}assertNotDisposed(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,E=new WeakMap,C=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,f=new WeakMap,l=new WeakMap,c=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,h=new WeakMap;function m(v){try{const g=k.normalizeVersion(k.parseVersion(v.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=m;class t{constructor(g,_,D,o,T){this.initData=_,this.workspace=D,this._logService=o,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=g.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(g,_,...D){const o=this.getWebview(g);if(o){const{message:T}=y.deserializeWebviewMessage(_,D);o._onMessageEmitter.fire(T)}}$onMissingCsp(g,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,_,D){const o=new u(g,this._webviewProxy,i(_),this.initData,this.workspace,D,this._deprecationService);return this._webviews.set(g,o),o._onDidDispose(()=>{this._webviews.delete(g)}),o}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=t;function s(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=s;function r(v,g,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||a(v,g)}}e.serializeWebviewOptions=r;function i(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(g=>R.URI.from(g))}}e.reviveOptions=i;function a(v,g){return[...(g?.getWorkspaceFolders()||[]).map(_=>_.uri),v.extensionLocation]}}),define(fe[248],me([0,1,21,72,6,10,22,2,16,63,82,5,7]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class l{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const i=this.key(t,s.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const a=new f(s,r);return this._documents.set(i,a),a}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var c;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(c||(c={}));class S{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,i){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:i}),new d.Disposable(()=>this._providers.delete(s))}}class w{constructor(t,s,r,i,a){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=a,this._editorProviders=new S,this._documents=new l,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,i){const a=new k.DisposableStore;return b(r)?(a.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),s,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(a.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&a.add(r.onDidChangeCustomDocument(v=>{const g=this.getCustomDocumentEntry(s,v.document.uri);if(h(v)){const _=g.addEdit(v);this._proxy.$onDidEdit(v.document.uri,s,_,v.label)}else this._proxy.$onContentChange(v.document.uri,s)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),s,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),d.Disposable.from(a,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,i,a){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${s}'`);const g=I.URI.revive(t),_=await v.provider.openCustomDocument(g,{backupId:r,untitledDocumentData:i?.buffer},a);let D;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(D=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(s,_,D),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const i=I.URI.revive(t),{document:a}=this.getCustomDocumentEntry(s,i);this._documents.delete(s,a),a.dispose()}async $resolveWebviewEditor(t,s,r,i,a,v){const g=this._editorProviders.get(r);if(!g)throw new Error(`No provider found for '${r}'`);const _=E.ViewColumn.to(a),D=this._extHostWebview.createNewWebview(s,i.webviewOptions,g.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(s,r,i.title,_,i.panelOptions,D),T=I.URI.revive(t);switch(g.type){case 1:{const{document:L}=this.getCustomDocumentEntry(r,T);return g.provider.resolveCustomEditor(L,o,v)}case 0:{const L=this._extHostDocuments.getDocument(T);return g.provider.resolveCustomTextEditor(L,o,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const v=I.URI.revive(s),g=this._extHostDocuments.getDocument(v);await i.provider.moveCustomTextEditor(g,a,p.CancellationToken.None)}async $undo(t,s,r,i){return this.getCustomDocumentEntry(s,t).undo(r,i)}async $redo(t,s,r,i){return this.getCustomDocumentEntry(s,t).redo(r,i)}async $revert(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,s,r,i){const a=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(a.document,I.URI.revive(r),i)}async $backup(t,s,r){const i=this.getCustomDocumentEntry(s,t),v=await this.getCustomEditorProvider(s).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(v),v.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,I.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(m){return typeof m.resolveCustomTextEditor=="function"}function h(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function u(m){const t=m.scheme===y.Schemas.file||m.scheme===y.Schemas.untitled?m.fsPath:m.toString();return R.hash(t)+""}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[249],me([0,1,3,6,2,32,16,63,5,7]),function(X,e,p,R,k,y,A,I,E,C){"use strict";var n,P,d,f,l,c,S,w,b,h,u,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(v,g,_,D,o,T,L){super();n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),f.set(this,void 0),l.set(this,void 0),c.set(this,void 0),S.set(this,void 0),w.set(this,void 0),b.set(this,!0),h.set(this,!0),u.set(this,!1),m.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,m,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,n,v,"f"),it(this,P,g,"f"),it(this,d,_,"f"),it(this,l,T,"f"),it(this,w,o,"f"),it(this,c,D,"f"),it(this,f,L,"f")}dispose(){Ue(this,u,"f")||(it(this,u,!0,"f"),Ue(this,m,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,n,"f")),Ue(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,d,"f")}get title(){return this.assertNotDisposed(),Ue(this,c,"f")}set title(v){this.assertNotDisposed(),Ue(this,c,"f")!==v&&(it(this,c,v,"f"),Ue(this,P,"f").$setTitle(Ue(this,n,"f"),v))}get iconPath(){return this.assertNotDisposed(),Ue(this,S,"f")}set iconPath(v){this.assertNotDisposed(),Ue(this,S,"f")!==v&&(it(this,S,v,"f"),Ue(this,P,"f").$setIconPath(Ue(this,n,"f"),k.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Ue(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,h,"f")}get visible(){return this.assertNotDisposed(),Ue(this,b,"f")}_updateViewState(v){Ue(this,u,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(it(this,h,v.active,"f"),it(this,b,v.visible,"f"),it(this,w,v.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(v,g){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,n,"f"),{viewColumn:v?A.ViewColumn.from(v):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Ue(this,u,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,d=new WeakMap,f=new WeakMap,l=new WeakMap,c=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,h=new WeakMap,u=new WeakMap,m=new WeakMap,t=new WeakMap;class r{constructor(v,g,_){this.webviews=g,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(v,g,_,D,o={}){const T=typeof D=="object"?D.viewColumn:D,L={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof D=="object"&&!!D.preserveFocus},$=I.shouldSerializeBuffersForPostMessage(v),W=r.newHandle();this._proxy.$createWebviewPanel(I.toExtensionData(v),W,g,{title:_,panelOptions:i(o),webviewOptions:I.serializeWebviewOptions(v,this.workspace,o),serializeBuffersForPostMessage:$},L);const Q=this.webviews.createNewWebview(W,o,v);return this.createNewWebviewPanel(W,g,_,T,o,Q)}$onDidChangeWebviewPanelViewStates(v){const g=Object.keys(v);g.sort((_,D)=>{const o=v[_],T=v[D];return o.active?1:T.active?-1:+o.visible-+T.visible});for(const _ of g){const D=this.getWebviewPanel(_);if(!D)continue;const o=v[_];D._updateViewState({active:o.active,visible:o.visible,viewColumn:A.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,g,_){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:_,extension:v}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:I.shouldSerializeBuffersForPostMessage(v)}),new C.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(v,g,_,D){const o=this._serializers.get(g);if(!o)throw new Error(`No serializer found for '${g}'`);const{serializer:T,extension:L}=o,$=this.webviews.createNewWebview(v,_.webviewOptions,L),W=this.createNewWebviewPanel(v,g,_.title,D,_.panelOptions,$);await T.deserializeWebviewPanel(W,_.state)}createNewWebviewPanel(v,g,_,D,o,T){const L=new s(v,this._proxy,g,_,D,o,T);return this._webviewPanels.set(v,L),L}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=r;function i(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[250],me([0,1,3,6,63,5,7]),function(X,e,p,R,k,y,A){"use strict";var I,E,C,n,P,d,f,l,c,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(u,m,t,s,r,i){super();I.set(this,void 0),E.set(this,void 0),C.set(this,void 0),n.set(this,void 0),P.set(this,!1),d.set(this,void 0),f.set(this,void 0),l.set(this,void 0),c.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Ue(this,c,"f").event,S.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,S,"f").event,it(this,C,t,"f"),it(this,f,s,"f"),it(this,I,u,"f"),it(this,E,m,"f"),it(this,n,r,"f"),it(this,d,i,"f")}dispose(){Ue(this,P,"f")||(it(this,P,!0,"f"),Ue(this,S,"f").fire(),Ue(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,f,"f")}set title(u){this.assertNotDisposed(),Ue(this,f,"f")!==u&&(it(this,f,u,"f"),Ue(this,E,"f").$setWebviewViewTitle(Ue(this,I,"f"),u))}get description(){return this.assertNotDisposed(),Ue(this,l,"f")}set description(u){this.assertNotDisposed(),Ue(this,l,"f")!==u&&(it(this,l,u,"f"),Ue(this,E,"f").$setWebviewViewDescription(Ue(this,I,"f"),u))}get visible(){return Ue(this,d,"f")}get webview(){return Ue(this,n,"f")}get viewType(){return Ue(this,C,"f")}_setVisible(u){u===Ue(this,d,"f")||Ue(this,P,"f")||(it(this,d,u,"f"),Ue(this,c,"f").fire())}show(u){this.assertNotDisposed(),Ue(this,E,"f").$show(Ue(this,I,"f"),!!u)}assertNotDisposed(){if(Ue(this,P,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,E=new WeakMap,C=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,f=new WeakMap,l=new WeakMap,c=new WeakMap,S=new WeakMap;class b{constructor(u,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,m,t,s){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider(k.toExtensionData(u),m,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(u,m,t,s,r){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:a,extension:v}=i,g=this._extHostWebview.createNewWebview(u,{},v),_=new w(u,this._proxy,m,t,g,!0);this._webviewViews.set(u,_),await a.resolveWebviewView(_,{state:s},r)}async $onDidChangeWebviewViewVisibility(u,m){this.getWebviewView(u)._setVisible(m)}async $disposeWebviewView(u){const m=this.getWebviewView(u);this._webviewViews.delete(u),m.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const m=this._webviewViews.get(u);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=b}),define(fe[128],me([0,1,3,5,2,10,8,4,13]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Wn{constructor(P){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wn.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let f;if(typeof P=="string"){f=P;try{P=k.URI.parse(P)}catch(l){return Promise.reject(`Invalid uri - '${P}'`)}}return A.isFalsyOrWhitespace(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,f,d)}async asExternalUri(P,d){if(A.isFalsyOrWhitespace(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(P,d);return k.URI.from(f)}};C.InitialState={focused:!0},C=ze([We(0,E.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=I.createDecorator("IExtHostWindow")}),define(fe[251],me([0,1,9,101,32,49,6,5,2,13]),function(X,e,p,R,k,y,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends A.Disposable{constructor(d,f){super();const l=d.getProxy(I.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async c=>{const S=E.URI.file(p.join(R.tmpdir(),k.generateUuid()));return await l.$download(c,S),S})}};n=ze([We(0,C.IExtHostRpcService),We(1,y.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(fe[252],me([0,1,2,9,147,28,62,27,13,6,12,112,41]),function(X,e,p,R,k,y,A,I,E,C,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(w,b,h){this.name=w,this.file=b,this.appender=h}static async create(w,b){const h=await P.createRotatingLogger(w,b,30*d.ByteSize.MB,1);return h.clearFormatters(),new f(w,b,h)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class l extends A.AbstractExtHostOutputChannel{constructor(w,b,h){super(w,!1,p.URI.file(b.file),h);this._appender=b}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,b){this._appender.flush(),super.show(w,b)}clear(){this._appender.flush(),super.clear()}}let c=class extends A.ExtHostOutputService{constructor(w,b,h){super(w);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new C.MutableDisposable,this._logsLocation=h.logsLocation}$setVisibleChannel(w){if(w){const b=this._channels.get(w);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const b=this._doCreateOutChannel(w);return b.then(h=>h._id.then(u=>this._channels.set(u,h))),new A.LazyOutputChannel(w,b)}async _doCreateOutChannel(w){try{const b=R.join(this._logsLocation.fsPath,`output_logging_${k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(b)||await y.Promises.mkdir(b,{recursive:!0});const u=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,m=p.URI.file(R.join(b,`${u}.log`)),t=await f.create(u,m.fsPath);return new l(w,t,this._proxy)}catch(b){return this.logService.error(b),new A.ExtHostPushOutputChannel(w,this._proxy)}}};c=ze([We(0,E.IExtHostRpcService),We(1,n.ILogService),We(2,I.IExtHostInitDataService)],c),e.ExtHostOutputService2=c}),define(fe[253],me([0,1,32,13,33]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends k.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,E,C){return this.createTerminalFromOptions({name:I,shellPath:E,shellArgs:C})}createTerminalFromOptions(I,E){const C=new k.ExtHostTerminal(this._proxy,p.generateUuid(),I,I.name);return this._terminals.push(C),C.create(I,E),C.value}};y=ze([We(0,R.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(fe[254],me([0,1,5,13,6,27,2,38,22,28,7,11,48,3,189,71,12]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(g,_,D){this.remoteAddress=g,this.localAddress=_,this._dispose=D,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(v){const g=v.trim().split(`
`),_=[];return g.forEach(o=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);T&&T.length>=3&&_.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),_.reduce((o,T)=>(o[T.socket]=T,o),{})}e.getSockets=b;function h(...v){const g=[].concat(...v.map(m));return[...new Map(g.filter(_=>_.st==="0A").map(_=>{const D=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:u(D[0]),port:parseInt(D[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=h;function u(v){let g="";if(v.length===8)for(let _=v.length-2;_>=0;_-=2)g+=parseInt(v.substr(_,2),16),_!==0&&(g+=".");else for(let _=v.length-4;_>=0;_-=4)g+=parseInt(v.substr(_,4),16).toString(16),_!==0&&(g+=":");return g}e.parseIpAddress=u;function m(v){const g=v.trim().split(`
`),_=g.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return g.map(o=>o.trim().split(/\s+/).reduce((T,L,$)=>(T[_[$]||$]=L,T),{}))}e.loadConnectionTable=m;function t(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/vs/server/main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function s(v){const g=v.trim().split(`
`),_=[];return g.forEach(D=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);o&&o.length>=4&&_.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),_}e.getRootProcesses=s;async function r(v,g,_){const D=_.reduce((T,L)=>(T[L.pid]=L,T),{}),o=[];return v.forEach(({socket:T,ip:L,port:$})=>{const W=g[T]?g[T].pid:void 0,Q=W?D[W]?.cmd:void 0;W&&Q&&!t(Q)&&o.push({host:L,port:$,detail:Q,pid:W})}),o}e.findPorts=r;function i(v,g,_){const D=new Map,o=s(g);for(const T of v){const L=_.get(T.port);if(L){D.set(T.port,L);continue}const $=o.find(W=>W.cmd.includes(`${T.port}`));if($){let W=$,Q;do Q=o.find(z=>z.ppid===W.pid),Q&&(W=Q);while(Q);D.set(T.port,{host:T.ip,port:T.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else D.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=i;let a=class extends k.Disposable{constructor(g,_,D){super();this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(p.MainContext.MainThreadTunnelService),P.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(_,g.displayName);if(D){const o=new w(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,_){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:g,provider:_}),this._proxy.$registerPortsAttributesProvider(g,D),new n.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(g,_,D,o,T){const L=[];for(const W of g){const Q=this._portAttributesProviders.get(W);if(!Q)return[];L.push(...await Promise.all(_.map(async z=>Q.provider.providePortAttributes(z,D,o,T))))}const $=L.filter(W=>!!W);return $.length>0?$.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(g){if(g&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=g;let _=new c.MovingAverage,D;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),T=(await this.findCandidatePorts()).filter($=>l.isLocalhost($.host)||l.isAllInterfaces($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map($=>$.port).join(", ")}`);const L=new Date().getTime()-o;_.update(L),(!D||JSON.stringify(D)!==JSON.stringify(T))&&(D=T,await this._proxy.$onFoundNewCandidates(D)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(_.value)))}}async setTunnelExtensionFunctions(g){return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider(g.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,k.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,_){if(this._extensionTunnels.has(g.host)){const D=this._extensionTunnels.get(g.host);D.has(g.port)&&(_&&D.get(g.port).disposeListener.dispose(),await D.get(g.port).tunnel.dispose(),D.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(g,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const o=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const T=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:o,disposeListener:T}),d.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(D){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const _=await Promise.all(g.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),D=g.filter((o,T)=>_[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(o=>o.port).join(", ")} to ${D.map(o=>o.port).join(", ")}`),D}async findCandidatePorts(){let g="",_="";try{g=await C.Promises.readFile("/proc/net/tcp","utf8"),_=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch(H){}const D=h(g,_),o=await new Promise(H=>{I.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,x,O)=>{H(x)})}),T=b(o),L=await C.Promises.readdir("/proc"),$=[];for(let H of L)try{const F=Number(H),x=E.joinPath(A.URI.file("/proc"),H);if((await C.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(F)){const M=await C.Promises.readlink(E.joinPath(x,"cwd").fsPath),B=await C.Promises.readFile(E.joinPath(x,"cmdline").fsPath,"utf8");$.push({pid:F,cwd:M,cmd:B})}}catch(F){}const W=[],Q=D.filter(H=>{const F=T[H.socket];return F||W.push(H),F}),z=r(Q,T,$);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const H=await new Promise(F=>{I.exec("ps -F -A -l | grep root",(x,O,M)=>{F(O)})});this._foundRootPorts=i(W,H,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return z.then(H=>N?H.concat(N):H)}};a=ze([We(0,R.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,S.ILogService)],a),e.ExtHostTunnelService=a}),define(fe[255],me([0,1,18,21,15,3,6,99,221,126,23]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(i,a){try{return JSON.stringify(i,a)}catch(v){return"null"}}function f(i,a){return JSON.stringify(i,a)}function l(i){return i?(a,v)=>v&&v.$mid===1?i.transformOutgoing(v):v:null}var c;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class u extends A.Disposable{constructor(a,v=null,g=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=v,this._uriTransformer=g,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,D=C.ProxyIdentifier.count;_<D;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?I.transformIncomingURIs(a,this._uriTransformer):a}getProxy(a){const{nid:v,sid:g}=a;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,g)),this._proxies[v]}_createProxy(a,v){let g={get:(_,D)=>(typeof D=="string"&&!_[D]&&D.charCodeAt(0)===36&&(_[D]=(...o)=>this._remoteCall(a,D,o)),D===h?v:_[D])};return new Proxy(Object.create(null),g)}set(a,v){return this._locals[a.nid]=v,v}assertRegistered(a){for(let v=0,g=a.length;v<g;v++){const _=a[v];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const v=a.byteLength,g=m.read(a,0),_=g.readUInt8(),D=g.readUInt32();switch(_){case 1:case 2:{let{rpcId:o,method:T,args:L}=t.deserializeRequestJSONArgs(g);this._uriTransformer&&(L=I.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(v,D,o,T,L,_===2);break}case 3:case 4:{let{rpcId:o,method:T,args:L}=t.deserializeRequestMixedArgs(g);this._uriTransformer&&(L=I.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(v,D,o,T,L,_===4);break}case 5:{this._logger&&this._logger.logIncoming(v,D,0,"ack"),this._onDidReceiveAcknowledge(D);break}case 6:{this._receiveCancel(v,D);break}case 7:{this._receiveReply(v,D,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(g);this._uriTransformer&&(o=I.transformIncomingURIs(o,this._uriTransformer)),this._receiveReply(v,D,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(g);this._receiveReply(v,D,o);break}case 10:{let o=t.deserializeReplyErrError(g);this._uriTransformer&&(o=I.transformIncomingURIs(o,this._uriTransformer)),this._receiveReplyErr(v,D,o);break}case 11:{this._receiveReplyErr(v,D,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,v,g,_,D,o){this._logger&&this._logger.logIncoming(a,v,1,`receiveRequest ${C.getStringIdentifierForProxy(g)}.${_}(`,D);const T=String(v);let L,$;if(o){const Q=new R.CancellationTokenSource;D.push(Q.token),L=this._invokeHandler(g,_,D),$=()=>Q.cancel()}else L=this._invokeHandler(g,_,D),$=w;this._cancelInvokedHandlers[T]=$;const W=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(W.byteLength,v,1,"ack"),this._protocol.send(W),L.then(Q=>{delete this._cancelInvokedHandlers[T];const z=t.serializeReplyOK(v,Q,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,v,1,"reply:",Q),this._protocol.send(z)},Q=>{delete this._cancelInvokedHandlers[T];const z=t.serializeReplyErr(v,Q);this._logger&&this._logger.logOutgoing(z.byteLength,v,1,"replyErr:",Q),this._protocol.send(z)})}_receiveCancel(a,v){this._logger&&this._logger.logIncoming(a,v,1,"receiveCancel");const g=String(v);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(a,v,g){this._logger&&this._logger.logIncoming(a,v,0,"receiveReply:",g);const _=String(v);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const D=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],D.resolveOk(g)}_receiveReplyErr(a,v,g){this._logger&&this._logger.logIncoming(a,v,0,"receiveReplyErr:",g);const _=String(v);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const D=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let o;g&&(g.$isError?(o=new Error,o.name=g.name,o.message=g.message,o.stack=g.stack):o=g),D.resolveErr(o)}_invokeHandler(a,v,g){try{return Promise.resolve(this._doInvokeHandler(a,v,g))}catch(_){return Promise.reject(_)}}_doInvokeHandler(a,v,g){const _=this._locals[a];if(!_)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(a));let D=_[v];if(typeof D!="function")throw new Error("Unknown method "+v+" on actor "+C.getStringIdentifierForProxy(a));return D.apply(_,g)}_remoteCall(a,v,g){if(this._isDisposed)return Promise.reject(k.canceled());let _=null;if(g.length>0&&R.CancellationToken.isCancellationToken(g[g.length-1])&&(_=g.pop()),_&&_.isCancellationRequested)return Promise.reject(k.canceled());const D=t.serializeRequestArguments(g,this._uriReplacer),o=++this._lastMessageId,T=String(o),L=new E.LazyPromise;_&&_.onCancellationRequested(()=>{const W=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(W.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[T]=L,this._onWillSendRequest(o);const $=t.serializeRequest(o,a,v,D,!!_);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${C.getStringIdentifierForProxy(a)}.${v}(`,g),this._protocol.send($),L}}e.RPCProtocol=u,P=b,u.UNRESPONSIVE_TIME=3*1e3;class m{constructor(a,v){this._buff=a,this._offset=v}static alloc(a,v,g){let _=new m(n.VSBuffer.alloc(g+1+4),0);return _.writeUInt8(a),_.writeUInt32(v),_}static read(a,v){return new m(a,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,g}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,g}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,v}static sizeMixedArray(a,v){let g=0;g+=1;for(let _=0,D=a.length;_<D;_++){const o=a[_],T=v[_];switch(g+=1,T){case 1:g+=this.sizeLongString(o);break;case 2:g+=this.sizeVSBuffer(o);break;case 3:break}}return g}writeMixedArray(a,v){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let g=0,_=a.length;g<_;g++){const D=a[g];switch(v[g]){case 1:this.writeUInt8(1),this.writeLongString(D);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(a);for(let g=0;g<a;g++)switch(this.readUInt8()){case 1:v[g]=this.readLongString();break;case 2:v[g]=this.readVSBuffer();break;case 3:v[g]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(a){for(let v=0,g=a.length;v<g;v++)if(a[v]instanceof n.VSBuffer||typeof a[v]=="undefined")return!0;return!1}static serializeRequestArguments(a,v){if(this._arrayContainsBufferOrUndefined(a)){let g=[],_=[];for(let D=0,o=a.length;D<o;D++){const T=a[D];T instanceof n.VSBuffer?(g[D]=T,_[D]=2):typeof T=="undefined"?(g[D]=n.VSBuffer.alloc(0),_[D]=3):(g[D]=n.VSBuffer.fromString(f(T,v)),_[D]=1)}return{type:"mixed",args:g,argsType:_}}return{type:"simple",args:f(a,v)}}static serializeRequest(a,v,g,_,D){return _.type==="mixed"?this._requestMixedArgs(a,v,g,_.args,_.argsType,D):this._requestJSONArgs(a,v,g,_.args,D)}static _requestJSONArgs(a,v,g,_,D){const o=n.VSBuffer.fromString(g),T=n.VSBuffer.fromString(_);let L=0;L+=m.sizeUInt8(),L+=m.sizeShortString(o),L+=m.sizeLongString(T);let $=m.alloc(D?2:1,a,L);return $.writeUInt8(v),$.writeShortString(o),$.writeLongString(T),$.buffer}static deserializeRequestJSONArgs(a){const v=a.readUInt8(),g=a.readShortString(),_=a.readLongString();return{rpcId:v,method:g,args:JSON.parse(_)}}static _requestMixedArgs(a,v,g,_,D,o){const T=n.VSBuffer.fromString(g);let L=0;L+=m.sizeUInt8(),L+=m.sizeShortString(T),L+=m.sizeMixedArray(_,D);let $=m.alloc(o?4:3,a,L);return $.writeUInt8(v),$.writeShortString(T),$.writeMixedArray(_,D),$.buffer}static deserializeRequestMixedArgs(a){const v=a.readUInt8(),g=a.readShortString(),_=a.readMixedArray(),D=new Array(_.length);for(let o=0,T=_.length;o<T;o++){const L=_[o];typeof L=="string"?D[o]=JSON.parse(L):D[o]=L}return{rpcId:v,method:g,args:D}}static serializeAcknowledged(a){return m.alloc(5,a,0).buffer}static serializeCancel(a){return m.alloc(6,a,0).buffer}static serializeReplyOK(a,v,g){return typeof v=="undefined"?this._serializeReplyOKEmpty(a):v instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(a,v):this._serializeReplyOKJSON(a,d(v,g))}static _serializeReplyOKEmpty(a){return m.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,v){let g=0;g+=m.sizeVSBuffer(v);let _=m.alloc(8,a,g);return _.writeVSBuffer(v),_.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,v){const g=n.VSBuffer.fromString(v);let _=0;_+=m.sizeLongString(g);let D=m.alloc(9,a,_);return D.writeLongString(g),D.buffer}static deserializeReplyOKJSON(a){const v=a.readLongString();return JSON.parse(v)}static serializeReplyErr(a,v){return v?this._serializeReplyErrEror(a,v):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,v){const g=n.VSBuffer.fromString(d(k.transformErrorForSerialization(v),null));let _=0;_+=m.sizeLongString(g);let D=m.alloc(10,a,_);return D.writeLongString(g),D.buffer}static deserializeReplyErrError(a){const v=a.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(a){return m.alloc(11,a,0).buffer}}var s;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var r;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(r||(r={}))}),define(fe[256],me([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=p.createDecorator("remoteAgentService")}),define(fe[257],me([0,1,10,9,11,2,4,81,46,216,256]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let P=class Hn{constructor(f,l,c,S){this.localUserHome=f,this.remoteAgentService=l,this.environmentService=c,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||f})()}get defaultUriScheme(){return Hn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,l){if(f.remoteAuthority)return p.Schemas.vscodeRemote;const c=I.getVirtualWorkspaceScheme(l.getWorkspace());if(c)return c;const S=l.getWorkspace().folders[0];if(S)return S.uri.scheme;const w=l.getWorkspace().configuration;return w?w.scheme:p.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?R.win32:R.posix)}async fileURI(f){let l="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const S=f.indexOf("/",2);S===-1?(l=f.substring(2),f="/"):(l=f.substring(2,S),f=f.substring(S)||"/")}return y.URI.from({scheme:p.Schemas.file,authority:l,path:f,query:"",fragment:""})}};P=ze([We(1,n.IRemoteAgentService),We(2,C.IWorkbenchEnvironmentService),We(3,E.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(fe[64],me([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(A,I){this.line=A,this.character=I}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,I){return new p(0,0)}with(A){return new p(0,0)}}e.Position=p;class R{constructor(A,I,E,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(A,I),this.end=new p(E,C)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var k;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,17,30,25,29,8,4,9,15,64]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",f=(P.length+d.length+5)*2;e.ISearchService=I.createDecorator("searchService");var l;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function S(F){return!!F.preview}e.resultIsMatch=S;function w(F){return!!F.resource}e.isFileMatch=w;function b(F){return!!F.message}e.isProgressMessage=b;var h;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=u;class m{constructor(x,O,M){this.ranges=O;const B=Array.isArray(O)?O:[O];if(M&&M.matchLines===1&&t(B)){x=A.getNLines(x,M.matchLines);let V="",ee=0,de=0;const ye=Math.floor(M.charsPerLine/5),Fe=[];for(const Re of B){const Ne=Math.max(Re.startColumn-ye,0),Ge=Re.startColumn+M.charsPerLine;if(Ne>de+ye+f){const Ve=P+(Ne-de)+d;V+=Ve+x.slice(Ne,Ge),ee+=Ne-(de+Ve.length)}else V+=x.slice(de,Ge);Fe.push(new r(0,Re.startColumn-ee,Re.endColumn-ee)),de=Ge}this.preview={text:V,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const V=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:x,matches:p.mapArrayOrNot(O,ee=>new s(ee.startLineNumber-V,ee.startColumn,ee.endLineNumber-V,ee.endColumn))}}}}e.TextSearchMatch=m;function t(F){const x=F[0].startLineNumber;for(const O of F)if(O.startLineNumber!==x||O.endLineNumber!==x)return!1;return!0}class s{constructor(x,O,M,B){this.startLineNumber=x,this.startColumn=O,this.endLineNumber=M,this.endColumn=B}}e.SearchRange=s;class r extends s{constructor(x,O,M){super(x,O,x,M)}}e.OneLineRange=r;var i;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,x=!0){const O=F&&F.files&&F.files.exclude,M=x&&F&&F.search&&F.search.exclude;if(!O&&!M)return;if(!O||!M)return O||M;let B=Object.create(null);return B=k.mixin(B,k.deepClone(O)),B=k.mixin(B,k.deepClone(M),!0),B}e.getExcludes=a;function v(F,x){return F.excludePattern&&R.match(F.excludePattern,x)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&R.match(F.includePattern,x)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(O=>{const M=O.folder.fsPath;if(y.isEqualOrParent(x,M)){const B=E.relative(M,x);return!O.includePattern||!!R.match(O.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var g;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(x,O){super(x);this.code=O}}e.SearchError=_;function D(F){const x=F.message;if(C.isPromiseCanceledError(F))return new _(x,g.canceled);try{const O=JSON.parse(x);return new _(O.message,O.code)}catch(O){return new _(x,g.other)}}e.deserializeSearchError=D;function o(F){const x={message:F.message,code:F.code};return new Error(JSON.stringify(x))}e.serializeSearchError=o;function T(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=T;function L(F){return F.type==="success"}e.isSerializedSearchSuccess=L;function $(F){return!!F.path}e.isSerializedFileMatch=$;function W(F,x){const O=F.searchPath?F.searchPath:F.relativePath;return A.fuzzyContains(O,x)}e.isFilePatternMatch=W;class Q{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function z(F,x){const O={...F||{},...x||{}};return Object.keys(O).filter(M=>{const B=O[M];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=z;class N{constructor(x,O){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=x.includePattern;O.includePattern&&(M?M={...M,...O.includePattern}:M=O.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(x,O,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,O,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,O,M))}includedInQuery(x,O,M){return Promise.resolve(this._parsedExcludeExpression(x,O,M)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(x,O,M)).then(ee=>!!ee):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=N;function H(F){for(const x in F)if(typeof F[x]!="boolean")return!0;return!1}}),define(fe[35],me([0,1,17,18,21,3,24,10,71,22,8,14,2,165,4,12,184,46,59,27,13,7,31,5]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h,u,m,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(T,L,$){return new C.ExtUri(W=>g(W,$)).isEqual(T,L)}function i(T,L,$){return r(T.uri,L.uri,$)?0:n.compare(T.uri.toString(),L.uri.toString())}function a(T,L,$){return T.index!==L.index?T.index<L.index?-1:1:r(T.uri,L.uri,$)?n.compare(T.name,L.name):n.compare(T.uri.toString(),L.uri.toString())}function v(T,L,$,W){const Q=T.slice(0).sort((N,H)=>$(N,H,W)),z=L.slice(0).sort((N,H)=>$(N,H,W));return p.delta(Q,z,(N,H)=>$(N,H,W))}function g(T,L){const $=L.getCapabilities(T.scheme);return!($&&$&1024)}class _ extends w.Workspace{constructor(L,$,W,Q,z,N){super(L,W.map(H=>new w.WorkspaceFolder(H)),Q,N);this._name=$,this._isUntitled=z,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(N),W.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(L,$,W,Q){if(!L)return{workspace:null,added:[],removed:[]};const{id:z,name:N,folders:H,configuration:F,isUntitled:x}=L,O=[],M=$;$?H.forEach((de,ye)=>{const Fe=d.URI.revive(de.uri),Re=_._findFolder(W||$,Fe,Q);Re?(Re.name=de.name,Re.index=de.index,O.push(Re)):O.push({uri:Fe,name:de.name,index:ye})}):O.push(...H.map(({uri:de,name:ye,index:Fe})=>({uri:d.URI.revive(de),name:ye,index:Fe}))),O.sort((de,ye)=>de.index<ye.index?-1:1);const B=new _(z,N,O,F?d.URI.revive(F):null,!!x,de=>g(de,Q)),{added:V,removed:ee}=v(M?M.workspaceFolders:[],B.workspaceFolders,i,Q);return{workspace:B,added:V,removed:ee}}static _findFolder(L,$,W){for(let Q=0;Q<L.folders.length;Q++){const z=L.workspaceFolders[Q];if(r(z.uri,$,W))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,$){return $&&this._structure.get(L)&&(L=C.dirname(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let D=class{constructor(L,$,W,Q){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=Q,this._extHostFileSystemInfo=W,this._requestIdProvider=new E.Counter,this._barrier=new R.Barrier,this._proxy=L.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(s.MainContext.MainThreadMessageService);const z=$.workspace;this._confirmedWorkspace=z?new _(z.id,z.name,[],z.configuration?d.URI.revive(z.configuration):null,!!z.isUntitled,N=>g(N,W)):void 0}$initializeWorkspace(L,$){this._trusted=$,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:I.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,$,W,...Q){const z=[];if(Array.isArray(Q)&&Q.forEach(O=>{d.URI.isUri(O.uri)&&!z.some(M=>r(M.uri,O.uri,this._extHostFileSystemInfo))&&z.push({uri:O.uri,name:O.name||C.basenameOrAuthority(O.uri)})}),this._unconfirmedWorkspace||[$,W].some(O=>typeof O!="number"||O<0)||W===0&&z.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+W>N.length)return!1;const H=N.slice(0);H.splice($,W,...z.map(O=>({uri:O.uri,name:O.name||C.basenameOrAuthority(O.uri),index:void 0})));for(let O=0;O<H.length;O++){const M=H[O];if(H.some((B,V)=>V!==O&&r(M.uri,B.uri,this._extHostFileSystemInfo)))return!1}H.forEach((O,M)=>O.index=M);const{added:F,removed:x}=v(N,H,a,this._extHostFileSystemInfo);if(F.length===0&&x.length===0)return!1;if(this._proxy){const O=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(O,$,W,z).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,f.localize(0,null,O,M.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(L,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async getWorkspaceFolder2(L,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,$){let W,Q="";if(typeof L=="string"?(W=d.URI.file(L),Q=L):typeof L!="undefined"&&(W=L,Q=L.fsPath),!W)return Q;const z=this.getWorkspaceFolder(W,!0);if(!z)return Q;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let N=C.relativePath(z.uri,W);return $&&z.name&&(N=`${z.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:$,added:W,removed:Q}=_.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:W,removed:Q}))}findFiles(L,$,W,Q,z=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let N;if($===null?N=!1:$&&(typeof $=="string"?N=$:N=$.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:F}=o(L);return this._proxy.$startFileSearch(P.withUndefinedAsNull(H),P.withUndefinedAsNull(F),P.withUndefinedAsNull(N),P.withUndefinedAsNull(W),z).then(x=>Array.isArray(x)?x.map(O=>d.URI.revive(O)):[])}async findTextInFiles(L,$,W,Q,z=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),H=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:F,folder:x}=o($.include),O=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,M={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:H,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:F,excludePattern:O},B=!1;if(this._activeSearchCallbacks[N]=V=>{if(B)return;const ee=d.URI.revive(V.resource);V.results.forEach(de=>{t.resultIsMatch(de)?W({uri:ee,preview:{text:de.preview.text,matches:p.mapArrayOrNot(de.preview.matches,ye=>new m.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:p.mapArrayOrNot(de.ranges,ye=>new m.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):W({uri:ee,text:de.text,lineNumber:de.lineNumber})})},z.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(L,P.withUndefinedAsNull(x),M,N,z);return delete this._activeSearchCallbacks[N],V||{}}catch(V){throw delete this._activeSearchCallbacks[N],V}}$handleTextSearchResult(L,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=ze([We(0,u.IExtHostRpcService),We(1,h.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,c.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=l.createDecorator("IExtHostWorkspace");function o(T){let L,$;return T&&(typeof T=="string"?L=T:(L=T.pattern,$=T.baseFolder||d.URI.file(T.base))),{includePattern:L,folder:$}}}),define(fe[36],me([0,1,25,3,35,5,7,188,80,14,18,4,13,12,2]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(s,r){if(r){const i=r.split(".");let a=s;for(let v=0;a&&v<i.length;v++)a=a[i[v]];return a}}function S(s){return s instanceof l.URI}function w(s){return s&&s.uri instanceof l.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function h(s){return s&&s.uri instanceof l.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function u(s){if(S(s))return{resource:s};if(w(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(h(s))return{resource:s.uri};if(s===null)return{resource:null}}let m=class{constructor(r,i,a){this._proxy=r.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=a,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(r,i))}};m=ze([We(0,d.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,f.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(r,i,a,v){this._onDidChangeConfiguration=new R.Emitter,this._proxy=r,this._logService=v,this._extHostWorkspace=i,this._configuration=I.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,a))}getConfiguration(r,i,a){const v=u(i)||{},g=this._toReadonlyValue(r?c(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,v,a?.identifier);function _(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(o){return typeof c(g,o)!="undefined"},get:(o,T)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,v,a?.identifier);let L=c(g,o);if(typeof L=="undefined")L=T;else{let $;const W=(Q,z)=>{let N;const H=()=>{$=$||p.deepClone(g),N=N||c($,z)};return C.isObject(Q)?new Proxy(Q,{get:(F,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return H(),()=>N;if($)return N=N||c($,z),N[x];const O=F[x];return typeof x=="string"?W(O,`${z}.${x}`):O},set:(F,x,O)=>(H(),N&&(N[x]=O),!0),deleteProperty:(F,x)=>(H(),N&&delete N[x],!0),defineProperty:(F,x,O)=>(H(),N&&Object.defineProperty(N,x,O),!0)}):Q};L=W(L,o)}return L},update:(o,T,L,$)=>{o=r?`${r}.${o}`:o;const W=_(L);return T!==void 0?this._proxy.$updateConfigurationOption(W,o,T,v,$):this._proxy.$removeConfigurationOption(W,o,v,$)},inspect:o=>{o=r?`${r}.${o}`:o;const T=p.deepClone(this._configuration.inspect(o,v,this._extHostWorkspace.workspace));if(T)return{key:o,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof g=="object"&&p.mixin(D,g,!1),Object.freeze(D)}_toReadonlyValue(r){const i=a=>C.isObject(a)?new Proxy(a,{get:(v,g)=>i(v[g]),set:(v,g,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(v,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(v,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(r)}_validateConfigurationAccess(r,i,a){const v=E.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),g=a?`[${a.value}] `:"";if(v===4){typeof i?.resource=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){i?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const a=new I.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,g)=>a.affectsConfiguration(v,u(g))})}_toMap(r){return r.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=P.createDecorator("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[65],me([0,1,2,18,3,5,7,35,42,36,21,33,13,27,4,10,11,12,61,204,15]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(Q){function z(H){if(H!=null)return H}Q.from=z;function N(H){if(H!=null)return H}Q.to=N})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(Q){function z(H){if(H!=null)return H}Q.from=z;function N(H){if(H!=null)return H}Q.to=N})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(Q){function z(H){if(H!=null)return H}Q.from=z;function N(H){if(H!=null)return H}Q.to=N})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(Q){function z(F){if(F){const x=F;return x&&!!x.process}else return!1}Q.is=z;function N(F){if(F==null)return;const x={process:F.process,args:F.args};return F.options&&(x.options=r.from(F.options)),x}Q.from=N;function H(F){if(F!=null)return new A.ProcessExecution(F.process,F.args,F.options)}Q.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(Q){function z(H){if(H!=null)return H}Q.from=z;function N(H){if(H!=null)return H}Q.to=N})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(Q){function z(F){if(F){const x=F;return x&&(!!x.commandLine||!!x.command)}else return!1}Q.is=z;function N(F){if(F==null)return;const x={};return F.commandLine!==void 0?x.commandLine=F.commandLine:(x.command=F.command,x.args=F.args),F.options&&(x.options=a.from(F.options)),x}Q.from=N;function H(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.ShellExecution(F.commandLine,F.options):new A.ShellExecution(F.command,F.args?F.args:[],F.options)}Q.to=H})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(Q){function z(F){if(F){let x=F;return x&&x.customExecution==="customExecution"}else return!1}Q.is=z;function N(F){return{customExecution:"customExecution"}}Q.from=N;function H(F,x){return x.get(F)}Q.to=H})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(Q){function z(N,H){let F;return N.scope!==void 0&&typeof N.scope!="number"?F=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&H&&H.workspaceFile?F=H.workspaceFile:F=h.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:F}}Q.from=z})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var D;(function(Q){function z(F,x){if(F==null)return[];const O=[];for(let M of F){const B=N(M,x);B&&O.push(B)}return O}Q.fromMany=z;function N(F,x){if(F==null)return;let O;F.execution instanceof A.ProcessExecution?O=i.from(F.execution):F.execution instanceof A.ShellExecution?O=v.from(F.execution):F.execution&&F.execution instanceof A.CustomExecution&&(O=g.from(F.execution));const M=t.from(F.definition);let B;if(F.scope?typeof F.scope=="number"?B=F.scope:B=F.scope.uri:B=A.TaskScope.Workspace,!M||!B)return;const V=F.group?F.group.id:void 0;return{_id:F._id,definition:M,name:F.name,source:{extensionId:x.identifier.value,label:F.source,scope:B},execution:O,isBackground:F.isBackground,group:V,presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}Q.from=N;async function H(F,x,O){if(F==null)return;let M;i.is(F.execution)?M=i.to(F.execution):v.is(F.execution)?M=v.to(F.execution):g.is(F.execution)&&(M=g.to(F._id,O));const B=t.to(F.definition);let V;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?V=F.source.scope:V=await x.resolveWorkspaceFolder(p.URI.revive(F.source.scope)):V=A.TaskScope.Workspace),!B||!V)return;const ee=new A.Task(B,V,F.name,F.source.label,M,F.problemMatchers);return F.isBackground!==void 0&&(ee.isBackground=F.isBackground),F.group!==void 0&&(ee.group=A.TaskGroup.from(F.group)),F.presentationOptions&&(ee.presentationOptions=s.to(F.presentationOptions)),F._id&&(ee._id=F._id),F.detail&&(ee.detail=F.detail),ee}Q.to=H})(D=e.TaskDTO||(e.TaskDTO={}));var o;(function(Q){function z(H){return H}Q.from=z;function N(H){if(!!H)return Object.assign(Object.create(null),H)}Q.to=N})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(z,N,H){this._id=N,this._task=H,m.set(this,void 0),it(this,m,z,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}m=new WeakMap;var L;(function(Q){function z(N){return{id:N._id,task:void 0}}Q.from=z})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(z,N,H,F,x,O,M,B){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=z.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=F,this._configurationService=x,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,N,H){if(!H)return new A.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:N,provider:H,extension:z}),this._proxy.$registerTaskProvider(F,N),new A.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(z,N){this._proxy.$registerTaskSystem(z,N)}fetchTasks(z){return this._proxy.$fetchTasks(o.from(z)).then(async N=>{const H=[];for(let F of N){const x=await D.to(F,this._workspaceProvider,this._providedCustomExecutions2);x&&H.push(x)}return H})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(N=>z.push(N)),z}terminateTask(z){if(!(z instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,N,H){const F=this._providedCustomExecutions2.get(z.id);if(F){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,F),this._terminalService.attachPtyToTerminal(N,await F.callback(H))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const N=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:N,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:z.exitCode})}$provideTasks(z,N){const H=this._handlers.get(z);if(!H)return Promise.reject(new Error("no handler found"));const F=[],x=R.asPromise(()=>H.provider.provideTasks(n.CancellationToken.None)).then(O=>this.provideTasksInternal(N,F,H,O));return new Promise(O=>{x.then(M=>{Promise.all(F).then(()=>{O(M)})})})}async $resolveTask(z,N){const H=this._handlers.get(z);if(!H)return Promise.reject(new Error("no handler found"));if(N.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${H.type}].`);const F=await D.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const x=await H.provider.resolveTask(F,n.CancellationToken.None);if(!x)return;this.checkDeprecation(x,H);const O=D.from(x,H.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(O.execution)&&await this.addCustomExecution(O,x,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,N,H){const F=await this._proxy.$createTaskId(z);!H&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,N.execution)}async getTaskExecution(z,N){if(typeof z=="string"){const x=this._taskExecutionPromises.get(z);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let H=this._taskExecutionPromises.get(z.id);if(H)return H;const F=new Promise(async(x,O)=>{const M=N||await D.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);M?x(new T(this,z.id,M)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,F),F.then(x=>(this._taskExecutions.set(z.id,x),x),x=>Promise.reject(x))}checkDeprecation(z,N){z._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let H=this._notProvidedCustomExecutions.values(),F=H.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=H.next()}};$=ze([We(0,d.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,I.IExtHostWorkspace),We(3,E.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,w.ILogService),We(7,b.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let W=class extends ${constructor(z,N,H,F,x,O,M,B){super(z,N,H,F,x,O,M,B);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(z,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const H=D.from(N,z);if(H===void 0)throw new Error("Task is not valid");if(g.is(H.execution))await this.addCustomExecution(H,N,!1);else throw new u.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),N);return this._proxy.$executeTask(H).catch(x=>{throw new Error(x)}),F}provideTasksInternal(z,N,H,F){const x=[];if(F)for(let O of F){this.checkDeprecation(O,H),(!O.definition||!z[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const M=D.from(O,H.extension);M&&g.is(M.execution)?(x.push(M),N.push(this.addCustomExecution(M,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:H.extension}}async resolveTaskInternal(z){if(g.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,N,H){}};W=ze([We(0,d.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,I.IExtHostWorkspace),We(3,E.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,w.ILogService),We(7,b.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=l.createDecorator("IExtHostTask")}),define(fe[258],me([0,1,17,68,30,74,24,10,9,22,8,14,2,141,170,115,46,215,257,31]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(_,D,o,T){this.configurationService=_,this.workspaceContextService=D,this.editorGroupsService=o,this.pathService=T}text(_,D,o={}){_=this.getContentPattern(_,o);const T=this.configurationService.getValue(),L=D&&D.some(W=>!this.configurationService.getValue({resource:W}).search.useRipgrep);return{...this.commonQuery(D?.map(S.toWorkspaceFolder),o),type:2,contentPattern:_,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(_,D){const o=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const T={..._,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(_,D)&&(T.isCaseSensitive=!0),this.isMultiline(_)&&(T.isMultiline=!0),T}file(_,D={}){return{...this.commonQuery(_,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}handleIncludeExclude(_,D){return _?(_=Array.isArray(_)?_.map(i):i(_),D?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],D={}){const o=this.handleIncludeExclude(D.includePattern,D.expandPatterns),T=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),L=_.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,D,T)):_.map(z=>this.getFolderQueryForRoot(z,D,T,L))).filter(z=>!!z),W={_reason:D._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:T.pattern,includePattern:o.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const N=p.coalesce(p.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(x=>x.resource)))).filter(F=>h.pathIncludedInQuery(W,F.fsPath)),H=this.commonQueryFromFileList(N);return{...W,...H}}const Q=D.extraFileResources&&D.extraFileResources.filter(z=>h.pathIncludedInQuery(W,z.fsPath));return W.extraFileResources=Q&&Q.length?Q:void 0,W}commonQueryFromFileList(_){const D=[],o=new A.ResourceMap,T={};let L=!1;return _.forEach($=>{if($.scheme===I.Schemas.walkThrough)return;if(C.isAbsolutePath($)){const Q=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:E.dirname($.fsPath)});let z=o.get(Q);z||(L=!0,z={folder:Q,includePattern:{}},D.push(z),o.set(Q,z));const N=E.relative(Q.fsPath,$.fsPath);P.assertIsDefined(z.includePattern)[N.replace(/\\/g,"/")]=!0}else $.fsPath&&(L=!0,T[$.fsPath]=!0)}),{folderQueries:D,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(_,D){if(D.isSmartCase){if(_.isRegExp){if(n.containsUppercaseCharacter(_.pattern,!0))return!0}else if(n.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&f.isMultilineRegexSource(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const D=H=>E.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),T=(Array.isArray(_)?_:s(_)).map(H=>{const F=this.pathService.resolvedUserHome;return F?y.untildify(H,F.scheme===I.Schemas.file?F.fsPath:F.path):H}),L=R.groupBy(T,H=>D(H)?"searchPaths":"exprSegments"),$=(L.exprSegments||[]).map(H=>n.rtrim(H,"/")).map(H=>n.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),r(H))),W={},Q=this.expandSearchPathPatterns(L.searchPaths||[]);Q&&Q.length&&(W.searchPaths=Q);const z=p.flatten($),N=t(...z);return N&&(W.pattern=N),W}getExcludesForFolder(_,D){return D.disregardExcludeSettings?void 0:h.getExcludes(_,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const D=p.flatten(_.map(T=>{let{pathPortion:L,globPortion:$}=m(T);$&&($=a($));const W=this.expandOneSearchPath(L);return p.flatten(W.map(Q=>this.resolveOneSearchPathPattern(Q,$)))})),o=new Map;return D.forEach(T=>{const L=T.searchPath.toString(),$=o.get(L);$?T.pattern&&($.pattern=$.pattern||{},$.pattern[T.pattern]=!0):o.set(L,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(_){if(E.isAbsolute(_)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==I.Schemas.file?[{searchPath:D[0].uri.with({path:_})}]:[{searchPath:d.URI.file(E.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=i(_),_.startsWith("../")||_===".."){const T=E.posix.resolve(D.path,_);return[{searchPath:D.with({path:T})}]}const o=a(_);return[{searchPath:D,pattern:o}]}else{if(_==="./"||_===".\\")return[];{const D=_.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(L=>{const $=D.match(new RegExp(`^${n.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return $?{match:$,folder:L}:null}).filter(P.isDefined);if(T.length)return T.map(L=>{const $=L.match[1];return{searchPath:L.folder.uri,pattern:$&&a($)}});{const L=_.match(/\.[\/\\](.+)[\/\\]?/),$=L?L[1]:_,W=l.localize(0,null,$);throw new Error(W)}}}}resolveOneSearchPathPattern(_,D){const o=_.pattern&&D?`${_.pattern}/${D}`:_.pattern||D,T=[{searchPath:_.searchPath,pattern:o}];return o&&!o.endsWith("**")&&T.push({searchPath:_.searchPath,pattern:o+"/**"}),T}getFolderQueryForSearchPath(_,D,o){const T=this.getFolderQueryForRoot(S.toWorkspaceFolder(_.searchPath),D,o,!1);return T?{...T,includePattern:_.pattern}:null}getFolderQueryForRoot(_,D,o,T){let L;const $=d.URI.isUri(_)?_:_.uri;if(o.searchPaths){const H=o.searchPaths.filter(F=>C.isEqual(F.searchPath,$))[0];if(H&&!H.pattern)return null;H&&(L=H.pattern)}const W=this.configurationService.getValue({resource:$}),z={...this.getExcludesForFolder(W,D)||{},...L||{}},N=d.URI.isUri(_)?C.basename(_):_.name;return{folder:$,folderName:T?N:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!W.search.followSymlinks}}};u=ze([We(0,c.IConfigurationService),We(1,S.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,b.IPathService)],u),e.QueryBuilder=u;function m(g){const _=g.match(/[\*\{\}\(\)\[\]\?]/);if(_){const D=_.index,o=g.substr(0,D).match(/[/|\\][^/\\]*$/);if(o){let T=g.substr(0,o.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:g.substr((o.index||0)+1)}}}return{pathPortion:g}}function t(...g){return g.length?g.reduce((_,D)=>(_[D]=!0,_),Object.create(null)):void 0}function s(g){return k.splitGlobAware(g,",").map(_=>_.trim()).filter(_=>!!_.length)}function r(g){return[`**/${g}/**`,`**/${g}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function i(g){return g.replace(/\\/g,"/")}function a(g){return i(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(g,_){g=p.distinct(g,T=>T.toString());const D=[],o=_.getWorkspace();return g&&g.forEach(T=>{let L;if(_.getWorkbenchState()===2)L=C.relativePath(o.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const $=_.getWorkspaceFolder(T);if($){const W=$.name;if(o.folders.filter(z=>z.name===W).length===1){const z=C.relativePath($.uri,T);z===""?L=`./${$.name}`:L=`./${$.name}/${z}`}else L=T.fsPath}}L&&D.push(L)}),D}e.resolveResourcesForSearchIncludes=v}),define(fe[259],me([0,1,22,2,21,15,4,258,31,46]),function(X,e,p,R,k,y,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(c,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],h=[];for(const i of w)if(/^workspaceContains:/.test(i)){const a=i.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||c.forceUsingSearch?h.push(a):b.push(a)}if(b.length===0&&h.length===0)return Promise.resolve(void 0);let u;const m=new Promise((i,a)=>{u=i}),t=i=>u({activationEvent:i}),s=Promise.all(b.map(i=>d(c,i,t))).then(()=>{}),r=f(c,S.identifier,h,t);return Promise.all([s,r]).then(()=>{u(void 0)}),m}e.checkActivateWorkspaceContainsExtension=P;async function d(c,S,w){for(const b of c.folders)if(await c.exists(p.joinPath(R.URI.revive(b),S))){w(`workspaceContains:${S}`);return}}async function f(c,S,w,b){if(w.length===0)return Promise.resolve(void 0);const h=new k.CancellationTokenSource,u=c.checkExists(c.folders,w,h.token),m=setTimeout(async()=>{h.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await u}catch(s){y.isPromiseCanceledError(s)||y.onUnexpectedError(s)}h.dispose(),clearTimeout(m),t&&b(`workspaceContains:${w.join(",")}`)}function l(c,S,w,b){const h=c.get(A.IInstantiationService),u=c.get(E.ISearchService),t=h.createInstance(I.QueryBuilder).file(S.map(s=>C.toWorkspaceFolder(R.URI.revive(s))),{_reason:"checkExists",includePattern:w,exists:!0});return u.fileSearch(t,b).then(s=>!!s.limitHit,s=>y.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(fe[39],me([0,1,160,9,66,22,18,6,24,2,12,5,36,219,87,35,34,217,15,26,23,194,7,116,4,27,88,13,79,48,33,3,259,85,196]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h,u,m,t,s,r,i,a,v,g,_,D,o,T,L,$){"use strict";var W,Q,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=r.createDecorator("IHostUtils");let N=class zn extends I.Disposable{constructor(O,M,B,V,ee,de,ye,Fe,Re,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=B,this._initData=ye,this._extHostWorkspace=V,this._extHostConfiguration=ee,this._logService=de,this._extHostTunnelService=Re,this._extHostTerminalService=Ne,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=O.createChild(new g.ServiceCollection([l.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ge=new Set;this._initData.hostExtensions.forEach(Ve=>Ge.add(h.ExtensionIdentifier.toKey(Ve))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,qe,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,b.transformErrorForSerialization(qe),q)},actualActivateExtension:async(Ve,qe)=>{if(Ge.has(h.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,qe),new f.HostExtension;const q=this._registry.getExtensionDescription(Ve);return this._activateExtension(q,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this._deactivate(ee))}catch(M){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,M){return this._activator.activateByEvent(O,M)}_activateById(O,M){return this._activator.activateById(O,M)}activateByIdWithErrors(O,M){return this._activateById(O,M).then(()=>{const B=this._activator.getActivatedExtension(O);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=E.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then(V=>O.set(C.URI.file(V).fsPath,B))});this._extensionPathIndex=Promise.all(M).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return M;const B=this._activator.getActivatedExtension(O);if(!B)return M;try{typeof B.module.deactivate=="function"&&(M=Promise.resolve(B.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{I.dispose(B.subscriptions)}catch(V){this._logService.error(V)}return M}async _activateExtension(O,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,M).then(B=>{const V=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,M),this._logExtensionActivationTimes(O,M,"success",V),B},B=>{throw this._logExtensionActivationTimes(O,M,"failure"),B})}_logExtensionActivationTimes(O,M,B,V){const ee=H(O,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ee,...V||{},outcome:B})}_doActivateExtension(O,M){const B=H(O,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const V=this._getEntryPoint(O);if(!V)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const ee=new f.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(O.identifier,y.joinPath(O.extensionLocation,V),ee),this._loadExtensionContext(O)]).then(de=>(k.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),zn._callActivate(this._logService,O.identifier,de[0],de[1],ee))).then(de=>(k.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const M=new m.ExtensionGlobalMemento(O,this._storage),B=new m.ExtensionMemento(O.identifier.value,!1,this._storage),V=new $.ExtensionSecrets(O,this._secretState),ee=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([M.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Fe;return Object.freeze({globalState:M,workspaceState:B,secrets:V,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Re){return R.join(O.extensionLocation.fsPath,Re)},get storagePath(){return ye._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(O).fsPath},get logPath(){return R.join(ye._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return C.URI.joinPath(ye._initData.logsLocation,O.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(O)},get globalStorageUri(){return ye._storagePath.globalValue(O)},get extensionMode(){return ee},get extension(){return Fe===void 0&&(Fe=new F(ye,O.identifier,O,de)),Fe},get extensionRuntime(){return S.checkProposedApiEnabled(O),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,M,B,V,ee){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,M,B,V,ee).then(de=>new f.ActivatedExtension(!1,null,ee.build(),B,de,V.subscriptions))}static _callActivateOptional(O,M,B,V,ee){if(typeof B.activate=="function")try{ee.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${M.value}`);const de=typeof global=="object"?global:self,ye=B.activate.apply(de,[V]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(ye).then(Fe=>(ee.activateResolveStop(),Fe))}catch(de){return Promise.reject(de)}else return Promise.resolve(B)}_activateOneStartupFinished(O,M){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:M}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const M of O.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(O,M)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,ee=>{this._logService.error(ee)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ee=>this._handleWorkspaceContainsEagerExtensions(ee.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(M),V=Promise.all([O,B]).then(()=>{});return Promise.race([V,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(O,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,M){if(this.isActivated(M.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={folders:O.map(de=>de.uri),forceUsingSearch:B,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,ye,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(de,ye,Fe)},ee=await T.checkActivateWorkspaceContainsExtension(V,M);if(!!ee)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:ee.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:M}=this._initData.environment;if(!O||!M)throw new Error(p.localize(0,null));const B=await this._loadCommonJSModule(null,M,new f.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(p.localize(1,null,M.toString()));return new Promise((V,ee)=>{const de=(Re,Ne)=>{Re?ee(Re):V(typeof Ne=="number"&&Ne>0?1:0)},ye=y.originalFSPath(M),Fe=B.run(ye,de);Fe&&Fe.then&&Fe.then(()=>{V(0)}).catch(Re=>{ee(Re.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,M){return this._resolvers[O]=M,I.toDisposable(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const M=O.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const B=O.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(O,M){const{authorityPrefix:B,resolver:V}=await this._activateAndGetResolver(O);if(!V)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),k.mark(`code/extHost/willResolveAuthority/${B}`);const ee=await V.resolve(O,{resolveAttempt:M});k.mark(`code/extHost/didResolveAuthorityOK/${B}`);const de={authority:O,host:ee.host,port:ee.port,connectionToken:ee.connectionToken},ye={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted};return{type:"ok",value:{authority:de,options:ye,tunnelInformation:{environmentTunnels:ee.environmentTunnels}}}}catch(ee){if(k.mark(`code/extHost/didResolveAuthorityError/${B}`),ee instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee}}async $getCanonicalURI(O,M){const{authorityPrefix:B,resolver:V}=await this._activateAndGetResolver(O);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const ee=C.URI.revive(M);if(typeof V.getCanonicalURI=="undefined")return ee;const de=await A.asPromise(()=>V.getCanonicalURI(ee));return de||ee}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,M){return M===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(O,!1))}async $activate(O,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,M),!0):!1}async $deltaExtensions(O,M){O.forEach(V=>V.extensionLocation=C.URI.revive(V.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(M.map(async V=>{const ee=this._registry.getExtensionDescription(V);if(!ee)return;const de=await this._hostUtils.realpath(ee.extensionLocation.fsPath);B.delete(C.URI.file(de).fsPath)})),await Promise.all(O.map(async V=>{const ee=await this._hostUtils.realpath(V.extensionLocation.fsPath);B.set(C.URI.file(ee).fsPath,V)})),this._registry.deltaExtensions(O,M),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let M=u.VSBuffer.alloc(O),B=Math.random()%256;for(let V=0;V<O;V++)M.writeUInt8(B,V);return M}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};N=ze([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,v.IExtHostRpcService),We(3,c.IExtHostWorkspace),We(4,d.IExtHostConfiguration),We(5,n.ILogService),We(6,i.IExtHostInitDataService),We(7,a.IExtensionStoragePaths),We(8,_.IExtHostTunnelService),We(9,D.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function H(x,O){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=r.createDecorator("IExtHostExtensionService");class F{constructor(O,M,B,V){W.set(this,void 0),Q.set(this,void 0),z.set(this,void 0),it(this,W,O,"f"),it(this,Q,M,"f"),it(this,z,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=R.normalize(y.originalFSPath(B.extensionLocation)),this.packageJSON=B,this.extensionKind=V}get isActive(){return Ue(this,W,"f").isActivated(Ue(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,W,"f").getExtensionExports(Ue(this,z,"f"))}activate(){return Ue(this,W,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,Q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,W=new WeakMap,Q=new WeakMap,z=new WeakMap}),define(fe[50],me([0,1,9,2,3,18,5,7,120,35,39,42,206,36,201,13,4,14,37,47]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=S.createDecorator("IExtHostDebugService");let u=class{constructor(g,_,D,o,T,L){this._workspaceService=_,this._extensionService=D,this._editorsService=o,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=g.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(W=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,_){const D=g;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let o=`debug:${encodeURIComponent(D.path||"")}`,T="?";return _&&(o+=`${T}session=${encodeURIComponent(_.id)}`,T="&"),o+=`${T}ref=${D.sourceReference}`,R.URI.parse(o)}else{if(D.path)return R.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const _=[];for(const D of g.getAllExtensionDescriptions())if(D.contributes){const o=D.contributes.debuggers;if(o&&o.length>0)for(const T of o)l.isDebuggerMainContribution(T)&&_.push(T.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(_=>g.push(_)),g}addBreakpoints(g){this.startBreakpoints();const _=g.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(_,[],[]);const D=[],o=new Map;for(const T of _)if(T instanceof I.SourceBreakpoint){let L=o.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},o.set(T.location.uri.toString(),L),D.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof I.FunctionBreakpoint&&D.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(g){this.startBreakpoints();const _=g.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],_,[]);const D=_.filter(L=>L instanceof I.SourceBreakpoint).map(L=>L.id),o=_.filter(L=>L instanceof I.FunctionBreakpoint).map(L=>L.id),T=_.filter(L=>L instanceof I.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(D,o,T)}startDebugging(g,_,D){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,_,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,_,D){if(!_)return new I.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:o,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,D,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,o),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(g,_,D){if(!D)return new I.Disposable(()=>{});if(!this.definesDebugType(g,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:o,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,o),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(g,_){if(!_)return new I.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:D,factory:_}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==_)})}async $runInTerminal(g,_){return Promise.resolve(void 0)}async $substituteVariables(g,_){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let D;const o=await this.getFolder(g);return o&&(D={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,_)}createDebugAdapter(g,_){if(g.type==="implementation")return new i(g.implementation)}createSignService(){}async $startDASession(g,_){const D=this,o=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),$=this.createDebugAdapter(L,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const W=$;return this._debugAdapters.set(g,W),this.getDebugAdapterTrackers(o).then(Q=>(Q&&this._debugAdaptersTrackers.set(g,Q),W.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const N=z,H={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(N.arguments.value);H.body={signature:F},W.sendResponse(H)}else throw new Error("no signer")}catch(F){H.success=!1,H.message=F.message,W.sendResponse(H)}}else Q&&Q.onDidSendMessage&&Q.onDidSendMessage(z),z=l.convertToVSCPaths(z,!0),D._debugServiceProxy.$acceptDAMessage(g,z)}),W.onError(z=>{Q&&Q.onError&&Q.onError(z),this._debugServiceProxy.$acceptDAError(g,z.name,z.message,z.stack)}),W.onExit(z=>{Q&&Q.onExit&&Q.onExit(w.withNullAsUndefined(z),void 0),this._debugServiceProxy.$acceptDAExit(g,w.withNullAsUndefined(z),void 0)}),Q&&Q.onWillStartSession&&Q.onWillStartSession(),W.startSession()))})}$sendDAMessage(g,_){_=l.convertToDAPaths(_,!1);const D=this._debugAdaptersTrackers.get(g);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(_);const o=this._debugAdapters.get(g);o&&o.sendMessage(_)}$stopDASession(g){const _=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),_&&_.onWillStopSession&&_.onWillStopSession();const D=this._debugAdapters.get(g);return this._debugAdapters.delete(g),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const _=[],D=[],o=[];if(g.added)for(const T of g.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let $;if(T.type==="function")$=new I.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")$=new I.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const W=R.URI.revive(T.uri);$=new I.SourceBreakpoint(new I.Location(W,new I.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}$._id=L,this._breakpoints.set(L,$),_.push($)}}if(g.removed)for(const T of g.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),D.push(L))}if(g.changed){for(const T of g.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof I.FunctionBreakpoint&&T.type==="function"){const $=L;$.enabled=T.enabled,$.condition=T.condition,$.hitCondition=T.hitCondition,$.logMessage=T.logMessage,$.functionName=T.functionName}else if(L instanceof I.SourceBreakpoint&&T.type==="source"){const $=L;$.enabled=T.enabled,$.condition=T.condition,$.hitCondition=T.hitCondition,$.logMessage=T.logMessage,$.location=new I.Location(R.URI.revive(T.uri),new I.Position(T.line,T.character))}o.push(L)}}}this.fireBreakpointChanges(_,D,o)}$provideDebugConfigurations(g,_,D){return y.asPromise(async()=>{const o=this.getConfigProviderByHandle(g);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(_);return o.provideDebugConfigurations(T,D)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(g,_,D,o){return y.asPromise(async()=>{const T=this.getConfigProviderByHandle(g);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(_);return T.resolveDebugConfiguration(L,D,o)})}$resolveDebugConfigurationWithSubstitutedVariables(g,_,D,o){return y.asPromise(async()=>{const T=this.getConfigProviderByHandle(g);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(_);return T.resolveDebugConfigurationWithSubstitutedVariables(L,D,o)})}async $provideDebugAdapter(g,_){const D=this.getAdapterDescriptorFactoryByHandle(g);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(_);return this.getAdapterDescriptor(D,o).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(g){const _=await this.getSession(g);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(g){const _=await this.getSession(g);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,_){const D=await this.getSession(g);D&&D._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(g,_){const o={session:await this.getSession(g),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(g){if(g instanceof I.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const _=this._adapterFactories.filter(D=>D.type===g);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(g){const _=this._adapterFactories.filter(D=>D.handle===g);if(_.length>0)return _[0].factory}getConfigProviderByHandle(g){const _=this._configProviders.filter(D=>D.handle===g);if(_.length>0)return _[0].provider}definesDebugType(g,_){if(g.contributes){const D=g.contributes.debuggers;if(D&&D.length>0){for(const o of D)if(o.label&&o.type&&o.type===_)return!0}}return!1}getDebugAdapterTrackers(g){const D=g.configuration.type,o=this._trackerFactories.filter(T=>T.type===D||T.type==="*").map(T=>y.asPromise(()=>T.factory.createDebugAdapterTracker(g)).then(L=>L,L=>null));return Promise.race([Promise.all(o).then(T=>{const L=T.filter($=>!!$);if(L.length>0)return new r(L)}),new Promise((T,L)=>{const $=setTimeout(()=>{clearTimeout($),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(g,_){const D=_.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new I.DebugAdapterServer(D));if(g){const T=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>g.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,T))).then(L=>{if(L)return L})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,o))}daExecutableFromPackage(g,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,_,D){(g.length>0||_.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:_,changed:D}))}async getSession(g){if(g)if(typeof g=="string"){const _=this._debugSessions.get(g);if(_)return _}else{let _=this._debugSessions.get(g.id);if(!_){const D=await this.getFolder(g.folderUri),o=g.parent?this._debugSessions.get(g.parent):void 0;_=new m(this._debugServiceProxy,g.id,g.type,g.name,D,g.configuration,o),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(g){if(g){const _=R.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};u=ze([We(0,c.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,P.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,h.IExtHostEditorTabs)],u),e.ExtHostDebugServiceBase=u;class m{constructor(g,_,D,o,T,L,$){this._debugServiceProxy=g,this._id=_,this._type=D,this._name=o,this._workspaceFolder=T,this._configuration=L,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,_)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=m;class t{constructor(g){this.value=Object.freeze({append(_){g.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class s extends d.AbstractVariableResolverService{constructor(g,_,D,o,T){function L(){if(_){const $=_.activeEditor();if($)return $.document.uri;const W=o.tabs.filter(Q=>Q.isActive);if(W.length>0)return W[0].resource}}super({getFolderUri:$=>{const W=g.filter(Q=>Q.name===$);if(W&&W.length>0)return W[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:($,W)=>D.getConfiguration(void 0,$).get(W),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=L();if($)return p.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const $=L();if($){const W=T.getWorkspaceFolder($);if(W)return p.normalize(W.uri.fsPath)}}},getSelectedText:()=>{if(_){const $=_.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(_){const $=_.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=s;class r{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(_=>_.onError?_.onError(g):void 0)}onExit(g,_){this.trackers.forEach(D=>D.onExit?D.onExit(g,_):void 0)}}class i extends E.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends u{constructor(g,_,D,o,T,L){super(g,_,D,o,T,L)}createVariableResolver(g,_,D){return new s(g,_,D,this._editorTabs)}};a=ze([We(0,c.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,P.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,h.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(fe[260],me([0,1,66,2,5,36,34,26,13,27,4,39,37,12]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(h,u,m,t,s,r,i){this._apiFactory=h,this._extensionRegistry=u,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,u,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,u,this._initData.environment.appUriScheme))}register(h){if(Array.isArray(h.nodeModuleName))for(let u of h.nodeModuleName)this._factories.set(u,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(u=>h.alternativeModuleName(u))}};l=ze([We(2,n.IInstantiationService),We(3,y.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,C.IExtHostInitDataService),We(6,f.ILogService)],l),e.RequireInterceptor=l;class c{constructor(h,u,m,t,s){this._apiFactory=h,this._extensionPaths=u,this._extensionRegistry=m,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,u){const m=this._extensionPaths.findSubstr(u.fsPath);if(m){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(h,u){this.nodeModuleName="keytar";const{environment:m}=u,t=h.getProxy(k.MainContext.MainThreadKeytar);if(m.appRoot){let s=m.appRoot.fsPath;d.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,i)=>t.$setPassword(s,r,i),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(h,u){return this._impl}alternativeModuleName(h){const u=h.length;if(u<=7||!this.alternativeNames)return;const m=u-7;if((h.charAt(m)==="/"||h.charAt(m)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};S=ze([We(0,E.IExtHostRpcService),We(1,C.IExtHostInitDataService)],S);let w=class{constructor(h,u,m){this._extensionPaths=h,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(k.MainContext.MainThreadTelemetry);const t=m.getProxy(k.MainContext.MainThreadWindow);this._impl=(s,r)=>{const i=R.URI.parse(s);return r?this.callOriginal(s,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,s,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,s,{}):this.callOriginal(s,r)}}load(h,u,m){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(h),this._impl}callOriginal(h,u){return this.sendNoForwardTelemetry(),this._original(h,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([We(2,E.IExtHostRpcService)],w)}),define(fe[261],me([0,1,166,11,7,202,35,39,42,36,33,13,50,190,18,203,47]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends d.ExtHostDebugServiceBase{constructor(u,m,t,s,r,i,a){super(u,m,t,s,r,a);this._terminalService=i,this._integratedTerminalInstances=new b}createDebugAdapter(u,m){switch(u.type){case"server":return new y.SocketDebugAdapter(u);case"pipeServer":return new y.NamedPipeDebugAdapter(u);case"executable":return new y.ExecutableDebugAdapter(u,m.type)}return super.createDebugAdapter(u,m)}daExecutableFromPackage(u,m){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),u.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(u,m){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=u.title||p.localize(0,null),a=JSON.stringify({shell:s,shellArgs:r});let v=await this._integratedTerminalInstances.checkout(a,i),g,_=!1;if(v)g=u.cwd;else{const L={shellPath:s,shellArgs:r,cwd:u.cwd,name:i};_=!0,v=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(v,a)}v.show(!0);const D=await v.processId;_?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?v.sendText("cls"):s.indexOf("bash")>=0?v.sendText("clear"):R.isWindows?v.sendText("cls"):v.sendText("clear"));const o=c.prepareCommand(s,u.args,g,u.env);v.sendText(o);const T=this.onDidTerminateDebugSession(L=>{L.id===m&&(this._integratedTerminalInstances.free(v),T.dispose())});return D}else if(u.kind==="external")return c.runInExternalTerminal(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,m)}createVariableResolver(u,m,t){return new d.ExtHostVariableResolverService(u,m,t,this._editorTabs,this._workspaceService)}};w=ze([We(0,P.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,E.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,S.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class b{constructor(){this._terminalInstances=new Map}async checkout(u,m){const s=[...this._terminalInstances.entries()].map(([r,i])=>l.createCancelablePromise(async a=>{if(r.name!==m||i.lastUsedAt!==-1&&await c.hasChildProcesses(await r.processId))return null;const v=Date.now();return i.lastUsedAt+b.minUseDelay>v||a.isCancellationRequested||i.config!==u?null:(i.lastUsedAt=v,r)}));return await l.firstParallel(s,r=>!!r)}insert(u,m){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:m})}free(u){const m=this._terminalInstances.get(u);m&&(m.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}b.minUseDelay=1e3}),define(fe[262],me([0,1,9,2,110,35,50,42,36,33,13,27,65,10,12,61,47]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends d.ExtHostTaskBase{constructor(h,u,m,t,s,r,i,a,v){super(h,u,m,t,s,r,i,a);this.workspaceService=m,this.editorTabs=v,u.remote.isRemote&&u.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:u.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,u){const m=u;if(!u.execution&&m._id===void 0)throw new Error("Tasks to execute must include an execution");if(m._id!==void 0){const t=d.TaskHandleDTO.from(m,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(s,u);return this._proxy.$executeTask(t).catch(()=>{}),r}else{const t=d.TaskDTO.from(u,h);if(t===void 0)return Promise.reject(new Error("Task is not valid"));d.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,u,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),u);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(h,u,m,t){const s=[];if(t)for(let r of t){this.checkDeprecation(r,m),(!r.definition||!h[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const i=d.TaskDTO.from(r,m.extension);i&&(s.push(i),d.CustomExecutionDTO.is(i.execution)&&u.push(this.addCustomExecution(i,r,!0)))}return{tasks:s,extension:m.extension}}async resolveTaskInternal(h){return h}async getVariableResolver(h){if(this._variableResolver===void 0){const u=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(h,this._editorService,u,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(h,u){const m=R.URI.revive(h),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(m),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!s)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const i=await this.getVariableResolver(r),a={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}};for(let v of u.variables)t.variables[v]=await i.resolveAsync(a,v);if(u.process!==void 0){let v;if(u.process.path!==void 0){v=u.process.path.split(p.delimiter);for(let g=0;g<v.length;g++)v[g]=await i.resolveAsync(a,v[g])}t.process=await k.win32.findExecutable(await i.resolveAsync(a,u.process.name),u.process.cwd!==void 0?await i.resolveAsync(a,u.process.cwd):void 0,v)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(h,u,m){return k.win32.findExecutable(h,u,m)}};w=ze([We(0,n.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,y.IExtHostWorkspace),We(3,I.IExtHostDocumentsAndEditors),We(4,E.IExtHostConfiguration),We(5,C.IExtHostTerminalService),We(6,l.ILogService),We(7,c.IExtHostApiDeprecationService),We(8,S.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(fe[263],me([0,1,18,15,66,6,2,5,255,12,76,79,27,183,13,60,39,33]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,m,t,s){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new E.RPCProtocol(u,null,s),m=b._transform(m,this._rpcProtocol);const r=new P.ServiceCollection(...n.getSingletonServiceDescriptors());r.set(d.IExtHostInitDataService,{_serviceBrand:void 0,...m}),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),r.set(c.IURITransformerService,new c.URITransformerService(s)),r.set(S.IHostUtils,t);const i=new f.InstantiationService(r,!0),a=i.invokeFunction(D=>D.get(w.IExtHostTerminalService));this._disposables.add(a),this._logService=i.invokeFunction(D=>D.get(C.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=i.invokeFunction(D=>D.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(D=>{Error.prepareStackTrace=(o,T)=>{let L="",$,W;for(const Q of T)L+=`
	at ${Q.toString()}`,W=Q.getFileName(),!$&&W&&($=D.findSubstr(W));return v.set(o,$),`${o.name||"Error"}: ${o.message||""}${L}`}});const g=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),_=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(D=>{const o=R.transformErrorForSerialization(D),T=v.get(D);T?g.$onExtensionRuntimeError(T.identifier,o):_.$onUnexpectedError(o)})}terminate(u){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([p.timeout(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(u,m){u.extensions.forEach(s=>s.extensionLocation=A.URI.revive(m.transformIncomingURIs(s.extensionLocation))),u.environment.appRoot=A.URI.revive(m.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(s=>A.URI.revive(m.transformIncomingURIs(s)))),u.environment.extensionTestsLocationURI=A.URI.revive(m.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=A.URI.revive(m.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=A.URI.revive(m.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=A.URI.revive(m.transformIncomingURIs(u.logsLocation)),u.logFile=A.URI.revive(m.transformIncomingURIs(u.logFile)),u.workspace=m.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(fe[264],me([0,1,9,21,58,30,22,43,31]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(d,f,l){this.config=d,this.provider=f,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&y.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&y.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const f=this.config.folderQueries||[];return new Promise((l,c)=>{const S=w=>{this.resultCount++,d(w)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),h=p.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,h)||this.matchFile(S,{base:w,basename:h})}),Promise.all(f.map(w=>this.searchInFolder(w,S))).then(w=>{l({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{c(new Error(k.toErrorMessage(w)))})})}async searchInFolder(d,f){const l=new R.CancellationTokenSource,c=this.getSearchOptionsForFolder(d),S=this.initDirectoryTree(),w=new E.QueryGlobTester(this.config,d),b=!w.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(l),h=I.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,l.token),m=h.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(s=>{const r=p.posix.relative(d.folder.path,s.path);if(b){const i=p.basename(s.path);this.matchFile(f,{base:d.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(S,d.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,f),{providerTime:m,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(d){const f=E.resolvePatternsForProvider(this.config.includePattern,d.includePattern),l=E.resolvePatternsForProvider(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:l,includes:f,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},f,l,c){if(l===this.filePattern){const w=p.basename(this.filePattern);this.matchFile(c,{base:f,relativePath:this.filePattern,basename:w})}function S(w){const b=p.basename(w),h=p.dirname(w);let u=d[h];u||(u=d[h]=[],S(h)),u.push({base:f,relativePath:w,basename:b})}S(l)}matchDirectoryTree({rootEntries:d,pathToEntries:f},l,c){const S=this,w=this.filePattern;function b(h){const u=y.hasSiblingFn(()=>h.map(m=>m.basename));for(let m=0,t=h.length;m<t;m++){const s=h[m],{relativePath:r,basename:i}=s;if(!l.includedInQuerySync(r,i,w!==i?u:void 0))continue;const a=f[r];if(a)b(a);else{if(r===w)continue;S.matchFile(c,s)}if(S.isLimitHit)break}}b(d)}matchFile(d,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(f))}}class n{constructor(){this.sessions=new Map}fileSearch(d,f,l,c){const S=this.getSessionTokenSource(d.cacheKey),w=new C(d,f,S&&S.token);let b=0;const h=u=>{b+=u.length,l(u.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(w,n.BATCH_SIZE,h,c).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:u.stats}}))}clearCache(d){const f=this.getSessionTokenSource(d);f&&f.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new R.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:A.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,f,l,c){c.onCancellationRequested(()=>{d.cancel()});const S=b=>{b&&(w.push(b),f>0&&w.length>=f&&(l(w),w=[]))};let w=[];return d.search(S).then(b=>(w.length&&l(w),b),b=>(w.length&&l(w),Promise.reject(b)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(fe[129],me([0,1,9,17,21,58,22,30,2,31,10,14]),function(X,e,p,R,k,y,A,I,E,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(h,u,m){this.query=h,this.provider=u,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,u){const m=this.query.folderQueries||[],t=new k.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new l(h);let i=!1;const a=(v,g)=>{if(!i&&!this.isLimitHit){const _=this.resultSize(v);S(v)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const D=this.resultSize(v);this.resultCount+=D,(D>0||!S(v))&&this.collector.add(v,g)}};Promise.all(m.map((v,g)=>this.searchInFolder(v,_=>a(_,g),t.token))).then(v=>{t.dispose(),this.collector.flush();const g=v.some(_=>!!_&&!!_.limitHit);s({limitHit:this.isLimitHit||g,messages:R.flatten(v.map(_=>_?.message?P.isArray(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const g=y.toErrorMessage(v);r(new Error(g))})})}resultSize(h){return S(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,u){const m=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:m.slice(0,u),preview:{matches:t.slice(0,u),text:h.preview.text},uri:h.uri}}async searchInFolder(h,u,m){const t=new C.QueryGlobTester(this.query,h),s=[],r={report:v=>{if(!this.validateProviderResult(v))return;const g=h.folder.scheme===n.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(v.uri))):void 0,_=A.relativePath(h.folder,v.uri);_&&s.push(t.includedInQuery(_,p.basename(_),g).then(D=>{D&&u(v)}))}},i=this.getSearchOptionsForFolder(h),a=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,m);return await Promise.all(s),a}validateProviderResult(h){if(S(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const u=C.resolvePatternsForProvider(this.query.includePattern,h.includePattern),m=C.resolvePatternsForProvider(this.query.excludePattern,h.excludePattern),t={folder:E.URI.from(h.folder),excludes:m,includes:u,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class l{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,u=>this.sendItems(u))}add(h,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!A.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(c(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=l;function c(b){return S(b)?{preview:{matches:R.mapArrayOrNot(b.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:b.preview.text},ranges:R.mapArrayOrNot(b.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function S(b){return!!b.preview}e.extensionResultIsMatch=S;class w{constructor(h,u){this.maxBatchSize=h,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,u){!h||this.addItemToBatch(h,u)}addItems(h,u){!h||this.addItemsToBatch(h,u)}addItemToBatch(h,u){this.batch.push(h),this.batchSize+=u,this.onUpdate()}addItemsToBatch(h,u){this.batch=this.batch.concat(h),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(fe[67],me([0,1,6,5,4,264,13,60,12,2,129]),function(X,e,p,R,k,y,A,I,E,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=k.createDecorator("IExtHostSearch");let P=class{constructor(c,S,w){this.extHostRpc=c,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,S){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(c)),p.toDisposable(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(c,S){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(c)),p.toDisposable(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(c,S,w,b){const h=d(w),u=this._fileSearchProvider.get(c);if(u)return this._fileSearchManager.fileSearch(h,u,m=>{this._proxy.$handleFileMatch(c,S,m.map(t=>t.resource))},b);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,S,w,b){const h=this._textSearchProvider.get(c);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const u=d(w);return this.createTextSearchManager(u,h).search(t=>this._proxy.$handleTextMatch(c,S,t),b)}createTextSearchManager(c,S){return new n.TextSearchManager(c,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};P=ze([We(0,A.IExtHostRpcService),We(1,I.IURITransformerService),We(2,E.ILogService)],P),e.ExtHostSearch=P;function d(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(f),extraFileResources:l.extraFileResources&&l.extraFileResources.map(c=>C.URI.revive(c))}}e.reviveQuery=d;function f(l){return{...l,folder:C.URI.revive(l.folder)}}}),define(fe[265],me([0,1,21,15,3,55,2,151,106,142,75,41,5,225,224,49,226,36,227,228,229,207,230,42,39,231,208,233,234,235,62,210,240,241,242,87,33,244,211,16,7,247,63,128,35,34,68,200,232,81,127,65,50,67,12,60,13,27,236,198,48,61,222,245,197,88,86,250,248,249,223,59,243,246,85,47,117,238,64,239,10,185,237,195,193]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h,u,m,t,s,r,i,a,v,g,_,D,o,T,L,$,W,Q,z,N,H,F,x,O,M,B,V,ee,de,ye,Fe,Re,Ne,Ge,Ve,qe,q,Z,re,ae,J,se,ve,Le,He,be,Je,K,ie,he,xe,$e,et,ke,Ce,Pe,oe,ce,ge,we,G,pe,_e,Ae,Me,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function tt(Xe){const Ye=Xe.get(re.IExtHostInitDataService),lt=Xe.get(et.IExtHostFileSystemInfo),ut=Xe.get(K.IExtHostConsumerFileSystem),Ee=Xe.get(r.IExtHostExtensionService),Se=Xe.get(B.IExtHostWorkspace),le=Xe.get(ce.IExtHostTelemetry),Y=Xe.get(w.IExtHostConfiguration),Be=Xe.get(q.IURITransformerService),De=Xe.get(Z.IExtHostRpcService),Ze=Xe.get(W.IExtHostStorage),Ke=Xe.get(Je.IExtensionStoragePaths),rt=Xe.get(qe.ILogService),ft=Xe.get(se.IExtHostTunnelService),wt=Xe.get(ve.IExtHostApiDeprecationService),bt=Xe.get(M.IExtHostWindow),Et=Xe.get(Pe.IExtHostSecretState),yt=Xe.get(oe.IExtHostEditorTabs);De.set(d.ExtHostContext.ExtHostFileSystemInfo,lt),De.set(d.ExtHostContext.ExtHostLogService,rt),De.set(d.ExtHostContext.ExtHostWorkspace,Se),De.set(d.ExtHostContext.ExtHostConfiguration,Y),De.set(d.ExtHostContext.ExtHostExtensionService,Ee),De.set(d.ExtHostContext.ExtHostStorage,Ze),De.set(d.ExtHostContext.ExtHostTunnelService,ft),De.set(d.ExtHostContext.ExtHostWindow,bt),De.set(d.ExtHostContext.ExtHostSecretState,Et),De.set(d.ExtHostContext.ExtHostTelemetry,le),De.set(d.ExtHostContext.ExtHostEditorTabs,yt);const kt=De.set(d.ExtHostContext.ExtHostDecorations,Xe.get(Re.IExtHostDecorations)),_t=De.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Xe.get(s.IExtHostDocumentsAndEditors)),dt=De.set(d.ExtHostContext.ExtHostCommands,Xe.get(c.IExtHostCommands)),vt=De.set(d.ExtHostContext.ExtHostTerminalService,Xe.get(Q.IExtHostTerminalService)),ht=De.set(d.ExtHostContext.ExtHostDebugService,Xe.get(Ge.IExtHostDebugService)),xt=De.set(d.ExtHostContext.ExtHostSearch,Xe.get(Ve.IExtHostSearch)),Pt=De.set(d.ExtHostContext.ExtHostTask,Xe.get(Ne.IExtHostTask)),Xt=De.set(d.ExtHostContext.ExtHostOutputService,Xe.get(D.IExtHostOutputService)),Bt=De.set(d.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(De)),Ct=De.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(De,_t)),Yt=De.set(d.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(De,_t,rt)),Jt=De.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(rt,Ct,De.getProxy(d.MainContext.MainThreadBulkEdits))),mt=De.set(d.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(De,dt,_t,Ct,Ke)),Kt=De.set(d.ExtHostContext.ExtHostNotebookDocuments,new Me.ExtHostNotebookDocuments(rt,mt)),qt=De.set(d.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(rt,De,mt)),Zt=De.set(d.ExtHostContext.ExtHostNotebookKernels,new ge.ExtHostNotebookKernels(De,Ye,mt,rt)),en=De.set(d.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(De,mt)),At=De.set(d.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(De,_t)),Qt=De.set(d.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(De.getProxy(d.MainContext.MainThreadTreeViews),dt,rt)),tn=De.set(d.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(De.getProxy(d.MainContext.MainThreadEditorInsets),At,Ye)),jt=De.set(d.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(De,rt)),ct=De.set(d.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(De,Be,Ct,dt,jt,rt,wt)),_n=De.set(d.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(De,ct)),Rt=De.set(d.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(De,rt,_t)),$t=De.set(d.ExtHostContext.ExtHostQuickOpen,T.createExtHostQuickOpen(De,Se,dt)),dn=De.set(d.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(De,dt,rt)),Sn=De.set(d.ExtHostContext.ExtHostComments,new S.ExtHostComments(De,dt,Ct)),hn=De.set(d.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(De.getProxy(d.MainContext.MainThreadProgress))),yn=De.set(d.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(De)),fn=De.set(d.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(De)),Ft=De.set(d.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(De)),nn=De.set(d.ExtHostContext.ExtHostTimeline,new He.ExtHostTimeline(De,dt)),rn=De.set(d.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(De,{remote:Ye.remote},Se,rt,wt)),sn=De.set(d.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(De,rn,Se)),Dn=De.set(d.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(De,Ct,Ke,rn,sn)),Cn=De.set(d.ExtHostContext.ExtHostWebviewViews,new ie.ExtHostWebviewViews(De,rn)),Mt=De.set(d.ExtHostContext.ExtHostTesting,new ke.ExtHostTesting(De,dt)),kn=De.set(d.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(De));De.set(d.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(De,mt,_t));const In=ee.values(d.ExtHostContext);De.assertRegistered(In);const on=new $e.ExtHostBulkEdits(De,_t),Pn=new l.ExtHostClipboard(De),Wt=new _.ExtHostMessageService(De,rt),Ot=new h.ExtHostDialogs(De),mn=new $.ExtHostStatusBar(De,dt.converter),Tt=new g.ExtHostLanguages(De,Ct);return f.ExtHostApiCommands.register(dt),function(Oe,an,gn){const gt=function(){let te=!Oe.isUnderDevelopment;function ue(Te){te||(rt.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(at){if(Array.isArray(at))at.forEach(Te);else if(typeof at=="string")ue(at);else{const pt=at;typeof pt.scheme=="undefined"&&ue(at),!Oe.enableProposedApi&&typeof pt.exclusive=="boolean"&&V.throwProposedApiError(Oe)}return at}}(),An={getSession(te,ue,Te){return Ft.getSession(Oe,te,ue,Te)},get onDidChangeSessions(){return Ft.onDidChangeSessions},registerAuthenticationProvider(te,ue,Te,at){return Ft.registerAuthenticationProvider(te,ue,Te,at)},get onDidChangeAuthenticationProviders(){return V.checkProposedApiEnabled(Oe),Ft.onDidChangeAuthenticationProviders},get providers(){return V.checkProposedApiEnabled(Oe),Ft.providers},logout(te,ue){return V.checkProposedApiEnabled(Oe),Ft.removeSession(te,ue)}},Tn={registerCommand(te,ue,Te){return dt.registerCommand(!0,te,ue,Te)},registerTextEditorCommand(te,ue,Te){return dt.registerCommand(!0,te,(...at)=>{const pt=At.getActiveTextEditor();if(!pt){rt.warn("Cannot execute "+te+" because there is no active text editor.");return}return pt.edit(Dt=>{ue.apply(Te,[pt,Dt,...at])}).then(Dt=>{Dt||rt.warn("Edits from command "+te+" were not applied.")},Dt=>{rt.warn("An error occurred while running command "+te,Dt)})})},registerDiffInformationCommand:(te,ue,Te)=>(V.checkProposedApiEnabled(Oe),dt.registerCommand(!0,te,async(...at)=>{const pt=_t.activeEditor(!0);if(!pt){rt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(pt.id);ue.apply(Te,[Dt,...at])})),executeCommand(te,...ue){return dt.executeCommand(te,...ue)},getCommands(te=!1){return dt.getCommands(te)}},pn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){return Ye.environment.appRoot?.fsPath??""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return Pn.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,ue){return bt.openUri(te,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Ye.environment.appUriScheme)return Bt.createAppUri(te);try{return await bt.asExternalUri(te,{allowTunneling:!!Ye.remote.authority})}catch(ue){if(_e.matchesScheme(te,pe.Schemas.http)||_e.matchesScheme(te,pe.Schemas.https))return te;throw ue}},get remoteName(){return Fe.getRemoteName(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=Ye.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,ln={createTestController(te){return V.checkProposedApiEnabled(Oe),Mt.createTestController(te)},createTestObserver(){return V.checkProposedApiEnabled(Oe),Mt.createTestObserver()},runTests(te){return V.checkProposedApiEnabled(Oe),Mt.runTests(te)},get onDidChangeTestResults(){return V.checkProposedApiEnabled(Oe),Mt.onResultsChanged},get testResults(){return V.checkProposedApiEnabled(Oe),Mt.results}},Rn={getExtension(te){const ue=an.getExtensionDescription(te);if(ue)return new r.Extension(Ee,Oe.identifier,ue,vn)},get all(){return an.getAllExtensionDescriptions().map(te=>new r.Extension(Ee,Oe.identifier,te,vn))},get onDidChange(){return an.onDidChange}},Ln={createDiagnosticCollection(te){return jt.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:te=>jt.getDiagnostics(te),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(te,ue){return Tt.changeLanguage(te.uri,ue)},match(te,ue){return n.score(H.LanguageSelector.from(te),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(te,ue,Te){return ct.registerCodeActionProvider(Oe,gt(te),ue,Te)},registerCodeLensProvider(te,ue){return ct.registerCodeLensProvider(Oe,gt(te),ue)},registerDefinitionProvider(te,ue){return ct.registerDefinitionProvider(Oe,gt(te),ue)},registerDeclarationProvider(te,ue){return ct.registerDeclarationProvider(Oe,gt(te),ue)},registerImplementationProvider(te,ue){return ct.registerImplementationProvider(Oe,gt(te),ue)},registerTypeDefinitionProvider(te,ue){return ct.registerTypeDefinitionProvider(Oe,gt(te),ue)},registerHoverProvider(te,ue){return ct.registerHoverProvider(Oe,gt(te),ue,Oe.identifier)},registerEvaluatableExpressionProvider(te,ue){return ct.registerEvaluatableExpressionProvider(Oe,gt(te),ue,Oe.identifier)},registerInlineValuesProvider(te,ue){return ct.registerInlineValuesProvider(Oe,gt(te),ue,Oe.identifier)},registerDocumentHighlightProvider(te,ue){return ct.registerDocumentHighlightProvider(Oe,gt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return ct.registerLinkedEditingRangeProvider(Oe,gt(te),ue)},registerReferenceProvider(te,ue){return ct.registerReferenceProvider(Oe,gt(te),ue)},registerRenameProvider(te,ue){return ct.registerRenameProvider(Oe,gt(te),ue)},registerDocumentSymbolProvider(te,ue,Te){return ct.registerDocumentSymbolProvider(Oe,gt(te),ue,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,ue){return ct.registerDocumentFormattingEditProvider(Oe,gt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return ct.registerDocumentRangeFormattingEditProvider(Oe,gt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Te,...at){return ct.registerOnTypeFormattingEditProvider(Oe,gt(te),ue,[Te].concat(at))},registerDocumentSemanticTokensProvider(te,ue,Te){return ct.registerDocumentSemanticTokensProvider(Oe,gt(te),ue,Te)},registerDocumentRangeSemanticTokensProvider(te,ue,Te){return ct.registerDocumentRangeSemanticTokensProvider(Oe,gt(te),ue,Te)},registerSignatureHelpProvider(te,ue,Te,...at){return typeof Te=="object"?ct.registerSignatureHelpProvider(Oe,gt(te),ue,Te):ct.registerSignatureHelpProvider(Oe,gt(te),ue,typeof Te=="undefined"?[]:[Te,...at])},registerCompletionItemProvider(te,ue,...Te){return ct.registerCompletionItemProvider(Oe,gt(te),ue,Te)},registerInlineCompletionItemProvider(te,ue){return V.checkProposedApiEnabled(Oe),ct.registerInlineCompletionsProvider(Oe,gt(te),ue)},registerDocumentLinkProvider(te,ue){return ct.registerDocumentLinkProvider(Oe,gt(te),ue)},registerColorProvider(te,ue){return ct.registerColorProvider(Oe,gt(te),ue)},registerFoldingRangeProvider(te,ue){return ct.registerFoldingRangeProvider(Oe,gt(te),ue)},registerSelectionRangeProvider(te,ue){return ct.registerSelectionRangeProvider(Oe,te,ue)},registerCallHierarchyProvider(te,ue){return ct.registerCallHierarchyProvider(Oe,te,ue)},setLanguageConfiguration:(te,ue)=>ct.setLanguageConfiguration(Oe,te,ue),getTokenInformationAtPosition(te,ue){return V.checkProposedApiEnabled(Oe),Tt.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return V.checkProposedApiEnabled(Oe),ct.registerInlayHintsProvider(Oe,te,ue)}},Fn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(te,ue,Te){const at=await(A.URI.isUri(te)?Promise.resolve(wn.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(at,ue,Te)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,ue,Te){return At.onDidChangeActiveTextEditor(te,ue,Te)},onDidChangeVisibleTextEditors(te,ue,Te){return At.onDidChangeVisibleTextEditors(te,ue,Te)},onDidChangeTextEditorSelection(te,ue,Te){return At.onDidChangeTextEditorSelection(te,ue,Te)},onDidChangeTextEditorOptions(te,ue,Te){return At.onDidChangeTextEditorOptions(te,ue,Te)},onDidChangeTextEditorVisibleRanges(te,ue,Te){return At.onDidChangeTextEditorVisibleRanges(te,ue,Te)},onDidChangeTextEditorViewColumn(te,ue,Te){return At.onDidChangeTextEditorViewColumn(te,ue,Te)},onDidCloseTerminal(te,ue,Te){return vt.onDidCloseTerminal(te,ue,Te)},onDidOpenTerminal(te,ue,Te){return vt.onDidOpenTerminal(te,ue,Te)},onDidChangeActiveTerminal(te,ue,Te){return vt.onDidChangeActiveTerminal(te,ue,Te)},onDidChangeTerminalDimensions(te,ue,Te){return V.checkProposedApiEnabled(Oe),vt.onDidChangeTerminalDimensions(te,ue,Te)},onDidWriteTerminalData(te,ue,Te){return V.checkProposedApiEnabled(Oe),vt.onDidWriteTerminalData(te,ue,Te)},get state(){return bt.state},onDidChangeWindowState(te,ue,Te){return bt.onDidChangeWindowState(te,ue,Te)},showInformationMessage(te,...ue){return Wt.showMessage(Oe,y.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Wt.showMessage(Oe,y.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Wt.showMessage(Oe,y.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Te){return $t.showQuickPick(te,!!Oe.enableProposedApi,ue,Te)},showWorkspaceFolderPick(te){return $t.showWorkspaceFolderPick(te)},showInputBox(te,ue){return $t.showInput(te,ue)},showOpenDialog(te){return Ot.showOpenDialog(te)},showSaveDialog(te){return Ot.showSaveDialog(te)},createStatusBarItem(te,ue,Te){let at,pt,Dt;return typeof te=="string"?(at=te,pt=ue,Dt=Te):(pt=te,Dt=ue),mn.createStatusBarEntry(Oe,at,pt,Dt)},setStatusBarMessage(te,ue){return mn.setStatusBarMessage(te,ue)},withScmProgress(te){return wt.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:F.ProgressLocation.SourceControl},(ue,Te)=>te({report(at){}}))},withProgress(te,ue){return hn.withProgress(Oe,te,ue)},createOutputChannel(te){return Xt.createOutputChannel(te)},createWebviewPanel(te,ue,Te,at){return sn.createWebviewPanel(Oe,te,ue,Te,at)},createWebviewTextEditorInset(te,ue,Te,at){return V.checkProposedApiEnabled(Oe),tn.createWebviewEditorInset(te,ue,Te,at,Oe)},createTerminal(te,ue,Te){return typeof te=="object"?"pty"in te?vt.createExtensionTerminal(te):vt.createTerminalFromOptions(te):vt.createTerminal(te,ue,Te)},registerTerminalLinkProvider(te){return vt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return vt.registerProfileProvider(Oe,te,ue)},registerTreeDataProvider(te,ue){return Qt.registerTreeDataProvider(te,ue,Oe)},createTreeView(te,ue){return Qt.createTreeView(te,ue,Oe)},registerWebviewPanelSerializer:(te,ue)=>sn.registerWebviewPanelSerializer(Oe,te,ue),registerCustomEditorProvider:(te,ue,Te={})=>Dn.registerCustomEditorProvider(Oe,te,ue,Te),registerFileDecorationProvider(te){return kt.registerFileDecorationProvider(te,Oe.identifier)},registerUriHandler(te){return Bt.registerUriHandler(Oe.identifier,te)},createQuickPick(){return $t.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return $t.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Te){return fn.onDidChangeActiveColorTheme(te,ue,Te)},registerWebviewViewProvider(te,ue,Te){return Cn.registerWebviewViewProvider(Oe,te,ue,Te?.webviewOptions)},get activeNotebookEditor(){return V.checkProposedApiEnabled(Oe),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Te){return V.checkProposedApiEnabled(Oe),mt.onDidChangeActiveNotebookEditor(te,ue,Te)},get visibleNotebookEditors(){return V.checkProposedApiEnabled(Oe),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return V.checkProposedApiEnabled(Oe),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ue,Te){return V.checkProposedApiEnabled(Oe),qt.onDidChangeNotebookEditorSelection(te,ue,Te)},onDidChangeNotebookEditorVisibleRanges(te,ue,Te){return V.checkProposedApiEnabled(Oe),qt.onDidChangeNotebookEditorVisibleRanges(te,ue,Te)},showNotebookDocument(te,ue){return V.checkProposedApiEnabled(Oe),mt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Te){return V.checkProposedApiEnabled(Oe),kn.registerExternalUriOpener(Oe.identifier,te,ue,Te)},get openEditors(){return V.checkProposedApiEnabled(Oe),yt.tabs},get onDidChangeOpenEditors(){return V.checkProposedApiEnabled(Oe),yt.onDidChangeTabs},getInlineCompletionItemController(te){return V.checkProposedApiEnabled(Oe),v.InlineCompletionController.get(te)}},wn={get rootPath(){return wt.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Se.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return Se.getWorkspaceFolder(te)},get workspaceFolders(){return Se.getWorkspaceFolders()},get name(){return Se.name},set name(te){throw R.readonly()},get workspaceFile(){return Se.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,ue,...Te)=>Se.updateWorkspaceFolders(Oe,te,ue||0,...Te),onDidChangeWorkspaceFolders:function(te,ue,Te){return Se.onDidChangeWorkspace(te,ue,Te)},asRelativePath:(te,ue)=>Se.getRelativePath(te,ue),findFiles:(te,ue,Te,at)=>Se.findFiles(H.GlobPattern.from(te),H.GlobPattern.from(ue),Te,Oe.identifier,at),findTextInFiles:(te,ue,Te,at)=>{let pt,Dt;return typeof ue=="object"?(pt=ue,Dt=Te):(pt={},Dt=ue,at=Te),Se.findTextInFiles(te,pt||{},Dt,Oe.identifier,at)},saveAll:te=>Se.saveAll(te),applyEdit(te){return on.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,ue,Te,at)=>Rt.createFileSystemWatcher(H.GlobPattern.from(te),ue,Te,at),get textDocuments(){return Ct.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let ue;const Te=te;if(typeof te=="string")ue=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))ue=Promise.resolve(te);else if(!Te||typeof Te=="object")ue=Ct.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>Ct.ensureDocumentData(at).then(pt=>pt.document))},onDidOpenTextDocument:(te,ue,Te)=>Ct.onDidAddDocument(te,ue,Te),onDidCloseTextDocument:(te,ue,Te)=>Ct.onDidRemoveDocument(te,ue,Te),onDidChangeTextDocument:(te,ue,Te)=>Ct.onDidChangeDocument(te,ue,Te),onDidSaveTextDocument:(te,ue,Te)=>Ct.onDidSaveDocument(te,ue,Te),onWillSaveTextDocument:(te,ue,Te)=>Jt.getOnWillSaveTextDocumentEvent(Oe)(te,ue,Te),get notebookDocuments(){return mt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Te;if(A.URI.isUri(te))Te=te,await mt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await mt.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(te,ue,Te,at){return mt.registerNotebookSerializer(Oe,te,ue,Te,Oe.enableProposedApi?at:void 0)},registerNotebookContentProvider:(te,ue,Te,at)=>(V.checkProposedApiEnabled(Oe),mt.registerNotebookContentProvider(Oe,te,ue,Te,Oe.enableProposedApi?at:void 0)),onDidChangeConfiguration:(te,ue,Te)=>gn.onDidChangeConfiguration(te,ue,Te),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,gn.getConfiguration(te,ue,Oe)},registerTextDocumentContentProvider(te,ue){return Yt.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(wt.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Oe,te,ue)),registerFileSystemProvider(te,ue,Te){return _n.registerFileSystemProvider(Oe.identifier,te,ue,Te,Oe.enableProposedApi)},get fs(){return ut.value},registerFileSearchProvider:(te,ue)=>(V.checkProposedApiEnabled(Oe),xt.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>(V.checkProposedApiEnabled(Oe),xt.registerTextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>(V.checkProposedApiEnabled(Oe),Ee.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>(V.checkProposedApiEnabled(Oe),yn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,ue,Te)=>Rt.onDidCreateFile(te,ue,Te),onDidDeleteFiles:(te,ue,Te)=>Rt.onDidDeleteFile(te,ue,Te),onDidRenameFiles:(te,ue,Te)=>Rt.onDidRenameFile(te,ue,Te),onWillCreateFiles:(te,ue,Te)=>Rt.getOnWillCreateFileEvent(Oe)(te,ue,Te),onWillDeleteFiles:(te,ue,Te)=>Rt.getOnWillDeleteFileEvent(Oe)(te,ue,Te),onWillRenameFiles:(te,ue,Te)=>Rt.getOnWillRenameFileEvent(Oe)(te,ue,Te),openTunnel:te=>(V.checkProposedApiEnabled(Oe),ft.openTunnel(Oe,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return V.checkProposedApiEnabled(Oe),ft.getTunnels()},onDidChangeTunnels:(te,ue,Te)=>(V.checkProposedApiEnabled(Oe),ft.onDidChangeTunnels(te,ue,Te)),registerPortAttributesProvider:(te,ue)=>(V.checkProposedApiEnabled(Oe),ft.registerPortsAttributesProvider(te,ue)),registerTimelineProvider:(te,ue)=>(V.checkProposedApiEnabled(Oe),nn.registerTimelineProvider(te,ue,Oe.identifier,dt.converter)),get isTrusted(){return Se.trusted},requestWorkspaceTrust:te=>(V.checkProposedApiEnabled(Oe),Se.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Te)=>Se.onDidGrantWorkspaceTrust(te,ue,Te)},Mn={get inputBox(){return wt.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Oe)},createSourceControl(te,ue,Te){return dn.createSourceControl(Oe,te,ue,Te)}},On={createCommentController(te,ue){return Sn.createCommentController(Oe,te,ue)}},bn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(te,ue,Te){return ht.onDidStartDebugSession(te,ue,Te)},onDidTerminateDebugSession(te,ue,Te){return ht.onDidTerminateDebugSession(te,ue,Te)},onDidChangeActiveDebugSession(te,ue,Te){return ht.onDidChangeActiveDebugSession(te,ue,Te)},onDidReceiveDebugSessionCustomEvent(te,ue,Te){return ht.onDidReceiveDebugSessionCustomEvent(te,ue,Te)},onDidChangeBreakpoints(te,ue,Te){return ht.onDidChangeBreakpoints(te,ue,Te)},registerDebugConfigurationProvider(te,ue,Te){return ht.registerDebugConfigurationProvider(te,ue,Te||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return ht.registerDebugAdapterDescriptorFactory(Oe,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return ht.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ht.startDebugging(te,ue,{parentSession:Te}):ht.startDebugging(te,ue,Te||{})},stopDebugging(te){return ht.stopDebugging(te)},addBreakpoints(te){return ht.addBreakpoints(te)},removeBreakpoints(te){return ht.removeBreakpoints(te)},asDebugSourceUri(te,ue){return ht.asDebugSourceUri(te,ue)}},Nt={registerTaskProvider:(te,ue)=>Pt.registerTaskProvider(Oe,te,ue),fetchTasks:te=>Pt.fetchTasks(te),executeTask:te=>Pt.executeTask(Oe,te),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(te,ue,Te)=>Pt.onDidStartTask(te,ue,Te),onDidEndTask:(te,ue,Te)=>Pt.onDidEndTask(te,ue,Te),onDidStartTaskProcess:(te,ue,Te)=>Pt.onDidStartTaskProcess(te,ue,Te),onDidEndTaskProcess:(te,ue,Te)=>Pt.onDidEndTaskProcess(te,ue,Te)},Ht={createNotebookController(te,ue,Te,at,pt){return Zt.createNotebookController(Oe,te,ue,Te,at,Oe.enableProposedApi?pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>mt.registerNotebookCellStatusBarItemProvider(Oe,te,ue),get onDidSaveNotebookDocument(){return V.checkProposedApiEnabled(Oe),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return V.checkProposedApiEnabled(Oe),qt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return V.checkProposedApiEnabled(Oe),en.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,ue,Te){return V.checkProposedApiEnabled(Oe),Kt.onDidChangeNotebookDocumentMetadata(te,ue,Te)},onDidChangeNotebookCells(te,ue,Te){return V.checkProposedApiEnabled(Oe),mt.onDidChangeNotebookCells(te,ue,Te)},onDidChangeNotebookCellExecutionState(te,ue,Te){return V.checkProposedApiEnabled(Oe),mt.onDidChangeNotebookCellExecutionState(te,ue,Te)},onDidChangeCellOutputs(te,ue,Te){return V.checkProposedApiEnabled(Oe),mt.onDidChangeCellOutputs(te,ue,Te)},onDidChangeCellMetadata(te,ue,Te){return V.checkProposedApiEnabled(Oe),mt.onDidChangeCellMetadata(te,ue,Te)},createConcatTextDocument(te,ue){return V.checkProposedApiEnabled(Oe),new be.ExtHostNotebookConcatDocument(mt,Ct,te,ue)}};return{version:Ye.version,authentication:An,commands:Tn,comments:On,debug:bn,env:pn,extensions:Rn,languages:Ln,notebooks:Ht,scm:Mn,tasks:Nt,test:ln,window:Fn,workspace:wn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:C.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:A.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TextSearchCompleteMessageType:we.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=tt}),define(fe[266],me([0,1,76,62,35,127,36,49,42,33,65,50,67,88,87,48,61,128,86,59,85,117,47]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b,h,u,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(f.IExtensionStoragePaths,f.ExtensionStoragePaths),p.registerSingleton(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),p.registerSingleton(I.IExtHostCommands,I.ExtHostCommands),p.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),p.registerSingleton(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),p.registerSingleton(P.IExtHostDebugService,P.WorkerExtHostDebugService),p.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),p.registerSingleton(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),p.registerSingleton(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo),p.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),p.registerSingleton(d.IExtHostSearch,d.ExtHostSearch),p.registerSingleton(l.IExtHostStorage,l.ExtHostStorage),p.registerSingleton(n.IExtHostTask,n.WorkerExtHostTask),p.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),p.registerSingleton(c.IExtHostTunnelService,c.ExtHostTunnelService),p.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),p.registerSingleton(k.IExtHostWorkspace,k.ExtHostWorkspace),p.registerSingleton(u.IExtHostSecretState,u.ExtHostSecretState),p.registerSingleton(m.IExtHostTelemetry,m.ExtHostTelemetry),p.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(fe[89],me([0,1,17,12,31,64]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=A;function I(P,d,f,l){const c=p.mapArrayOrNot(f,E),S=new k.TextSearchMatch(d,c,l),w=S.preview.matches;return{ranges:p.mapArrayOrNot(c,C),uri:P,preview:{text:S.preview.text,matches:p.mapArrayOrNot(w,C)}}}e.createTextSearchResult=I;function E(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function C(P){return new y.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let n=class{constructor(d,f){this.prefix=d,this.logService=f}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};n=ze([We(1,R.ILogService)],n),e.OutputChannel=n}),define(fe[267],me([0,1,92,23]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,I=512*8,E=512*128;class C{constructor(s){this.iconvLiteDecoder=s}static async create(s){let r;if(s!==e.UTF8)r=(await new Promise((a,v)=>{X(["iconv-lite-umd"],a,v)})).getDecoder(f(s));else{const i=new TextDecoder;r={write(a){return i.decode(a,{stream:!0})},end(){return i.decode()}}}return new C(r)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function n(t,s){const r=s.minBytesRequiredForDetection??s.guessEncoding?I:A;return new Promise((i,a)=>{const v=p.newWriteableStream(T=>T.join("")),g=[];let _=0,D;const o=async()=>{try{const T=await m({buffer:R.VSBuffer.concat(g),bytesRead:_},s.guessEncoding);T.encoding=await s.overwriteEncoding(T.encoding),D=await C.create(T.encoding);const L=D.write(R.VSBuffer.concat(g).buffer);v.write(L),g.length=0,_=0,i({stream:v,detected:T})}catch(T){a(T)}};p.listenStream(t,{onData:async T=>{D?v.write(D.write(T.buffer)):(g.push(T),_+=T.byteLength,_>=r&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:T=>v.error(T),onEnd:async()=>{D||await o(),v.end(D?.end())}})})}e.toDecodeStream=n;async function P(t,s,r){const a=(await new Promise((_,D)=>{X(["iconv-lite-umd"],_,D)})).getEncoder(f(s),r);let v=!1,g=!1;return{read(){if(g)return null;const _=t.read();if(typeof _!="string"){if(g=!0,!v&&r?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=a.end();return D&&D.length>0?(v=!0,R.VSBuffer.wrap(D)):null}return v=!0,R.VSBuffer.wrap(a.write(_))}}}e.toEncodeReadable=P;async function d(t){return(await new Promise((r,i)=>{X(["iconv-lite-umd"],r,i)})).encodingExists(f(t))}e.encodingExists=d;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function l(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const c=["ascii","utf-16","utf-32"];async function S(t){const s=await new Promise((g,_)=>{X(["jschardet"],g,_)}),r=t.slice(0,E),i=h(r.buffer),a=s.detect(i);if(!a||!a.encoding)return null;const v=a.encoding.toLowerCase();return 0<=c.indexOf(v)?null:b(a.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[s]||s}function h(t){let s="";for(let r=0;r<t.length;r++)s+=String.fromCharCode(t[r]);return s}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=u;function m({buffer:t,bytesRead:s},r){let i=l(t,s),a=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let v=!0,g=!0,_=!1;for(let D=0;D<s&&D<y;D++){const o=D%2==1,T=t.readUInt8(D)===0;if(T&&(_=!0),v&&(o&&!T||!o&&T)&&(v=!1),g&&(o&&T||!o&&!T)&&(g=!1),T&&!v&&!g)break}_&&(v?i=e.UTF16le:g?i=e.UTF16be:a=!0)}return r&&!a&&!i&&t?S(t.slice(0,s)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:a,encoding:i}}e.detectEncodingFromBuffer=m,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[130],me([0,1,267,28,129]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends k.TextSearchManager{constructor(I,E,C=R){super(I,E,{readdir:n=>C.Promises.readdir(n.fsPath),toCanonicalName:n=>p.toCanonicalName(n)})}}e.NativeTextSearchManager=y}),define(fe[268],me([0,1,269,283,284,2,285]),function(X,e,p,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(P,d,f,l,c,S){const w=S.environment.useHostProxy,b=typeof w=="boolean"?w:!S.remote.isRemote,h=A.createProxyResolver({resolveProxy:m=>P.resolveProxy(m),getHttpProxySetting:()=>d.getConfiguration("http").get("proxy"),log:(m,t,...s)=>{switch(m){case A.LogLevel.Trace:l.trace(t,...s);break;case A.LogLevel.Debug:l.debug(t,...s);break;case A.LogLevel.Info:l.info(t,...s);break;case A.LogLevel.Warning:l.warn(t,...s);break;case A.LogLevel.Error:l.error(t,...s);break;case A.LogLevel.Critical:l.critical(t,...s);break;case A.LogLevel.Off:break;default:r(m,t,s);break}function r(i,a,...v){l.error("Unknown log level",i),l.error(a,...v)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:m=>{c.$publicLog2("resolveProxy",m)},useHostProxy:b,env:process.env}),u=E(d,h);return n(f,u)}e.connectProxyResolver=I;function E(P,d){const f={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(c=>{f.config=P.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(c=>{l.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,A.createHttpPatch(p,d,{config:"off"},l,!0)),on:Object.assign({},p,A.createHttpPatch(p,d,{config:"on"},l,!0)),override:Object.assign({},p,A.createHttpPatch(p,d,{config:"override"},l,!0)),onRequest:Object.assign({},p,A.createHttpPatch(p,d,f,l,!0)),default:Object.assign(p,A.createHttpPatch(p,d,f,l,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,d,{config:"off"},l,!0)),on:Object.assign({},R,A.createHttpPatch(R,d,{config:"on"},l,!0)),override:Object.assign({},R,A.createHttpPatch(R,d,{config:"override"},l,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,d,f,l,!0)),default:Object.assign(R,A.createHttpPatch(R,d,f,l,!1))},tls:Object.assign(k,A.createTlsPatch(k))}}const C=new Map;function n(P,d){return P.getExtensionPathIndex().then(f=>{const l=X.__$__nodeRequire("module"),c=l._load;l._load=function(w,b,h){if(w==="tls")return d.tls;if(w!=="http"&&w!=="https")return c.apply(this,arguments);const u=d[w],m=f.findSubstr(y.URI.file(b.filename).fsPath);let t=C.get(m);if(t||C.set(m,t={}),!t[w]){let s=u.default;m&&m.enableProposedApi&&(s=u[m.proxySupport]||u.onRequest),t[w]={...s}}return t[w]}})}}),define(fe[270],me([0,1,38,9,73,29,11,8,89,271]),function(X,e,p,R,k,y,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(h,u,m,t){const s=d(h,u,m,t),r=u.folder.fsPath;return{cmd:p.spawn(n,s.args,{cwd:r}),rgDiskPath:n,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function d(h,u,m,t){const s=["--files","--hidden","--case-sensitive"];l([u],m,!1).forEach(i=>{const a=E.anchorGlob(i);if(s.push("-g",a),A.isMacintosh){const v=k.normalizeNFD(a);v!==a&&s.push("-g",v)}});const r=f([u],t,void 0,!1);return r.globArgs.forEach(i=>{const a=`!${E.anchorGlob(i)}`;if(s.push("-g",a),A.isMacintosh){const v=k.normalizeNFD(a);v!==a&&s.push("-g",v)}}),u.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),u.ignoreSymlinks||s.push("--follow"),h.exists&&s.push("--quiet"),s.push("--no-config"),u.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function f(h,u,m,t=!0){const s=[];let r={};return h.forEach(i=>{const a=Object.assign({},i.excludePattern||{},u||{}),v=c(a,t?i.folder.fsPath:void 0,m);s.push(...v.globArgs),v.siblingClauses&&(r=Object.assign(r,v.siblingClauses))}),{globArgs:s,siblingClauses:r}}e.foldersToRgExcludeGlobs=f;function l(h,u,m=!0){const t=[];return h.forEach(s=>{const r=Object.assign({},u||{},s.includePattern||{}),i=c(r,m?s.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=l;function c(h,u,m){const t=[],s={};return Object.keys(h).forEach(r=>{if(m&&m.has(r)||!r)return;const i=h[r];r=w(u?S(u,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(b(r))):i&&i.when&&(s[r]=i)}),{globArgs:t,siblingClauses:s}}function S(h,u){return R.isAbsolute(u)?u:R.join(h,u)}e.getAbsoluteGlob=S;function w(h){return h=I.rtrim(h,"\\"),I.rtrim(h,"/")}function b(h){return y.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=b}),define(fe[272],me([0,1,38,57,9,100,17,58,30,73,29,11,43,8,14,28,31,270,97]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(r=>r())});class u{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&E.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=b.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&E.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(a=>{const v=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),g=a.folder.fsPath;i.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==g).forEach(_=>{n.isEqualOrParent(_,g)&&(v[k.relative(g,_)]=!0)}),this.folderExcludePatterns.set(g,new t(v,g))})}cancel(){this.isCanceled=!0}walk(i,a,v,g,_){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);a.forEach(D=>{const o=k.basename(D.fsPath);this.globalExcludePattern&&this.globalExcludePattern(D.fsPath,o)||this.matchFile(v,{relativePath:D.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(i,(D,o)=>{this.call(this.cmdTraversal,this,D,v,g,T=>{if(T){const L=I.toErrorMessage(T);console.error(L),this.errors.push(L),o(T,void 0)}else o(null,void 0)})},(D,o)=>{this.fileWalkSW.stop();const T=D?A.coalesce(D)[0]:null;_(T,this.isLimitHit)})}parallel(i,a,v){const g=new Array(i.length),_=new Array(i.length);let D=!1,o=0;if(i.length===0)return v(null,[]);i.forEach((T,L)=>{a(T,($,W)=>{if($?(D=!0,g[L]=null,_[L]=$):(g[L]=W,_[L]=null),++o===i.length)return v(D?_:null,g)})})}call(i,a,...v){try{i.apply(a,v)}catch(g){v[v.length-1](g)}}cmdTraversal(i,a,v,g){const _=i.folder.fsPath,D=P.isMacintosh;let o;const T=()=>o&&o.kill();h.add(T);let L=F=>{h.delete(T),L=()=>{},g(F)},$="";const W=this.initDirectoryTree();let Q;const z=w.spawnRipgrepCmd(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);o=z.cmd,Q=!Object.keys(z.siblingClauses).length;const N=z.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let H=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),v({message:H}),this.cmdResultCount=0,this.collectStdout(o,"utf8",v,(F,x,O)=>{if(F){L(F);return}if(this.isLimitHit){L();return}const B=($+(D?C.normalizeNFC(x||""):x)).split(`
`);if(O){const V=B.length;B[V-1]=B[V-1].trim(),B[V-1]||B.pop()}else $=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,Q){for(const V of B)if(this.matchFile(a,{base:_,relativePath:V,searchPath:this.getSearchPath(i,V)}),this.isLimitHit){T();break}(O||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,W,_,B,a),O&&(this.matchDirectoryTree(W,_,a),L())})}spawnFindCmd(i){const a=this.folderExcludePatterns.get(i.folder.fsPath),v=a.getBasenameTerms(),g=a.getPathTerms(),_=["-L","."];if(v.length||g.length){_.push("-not","(","(");for(const D of v)_.push("-name",D),_.push("-o");for(const D of g)_.push("-path",D),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),p.spawn("find",_,{cwd:i.folder.fsPath})}readStdout(i,a,v){let g="";this.collectStdout(i,a,()=>{},(_,D,o)=>{if(_){v(_);return}g+=D,o&&v(null,g)})}collectStdout(i,a,v,g){let _=(T,L,$)=>{(T||$)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),g(T,L,$)},D=!1;i.stdout?(this.forwardData(i.stdout,a,_),i.stdout.once("data",()=>D=!0)):v({message:"stdout is null"});let o;i.stderr?o=this.collectData(i.stderr):v({message:"stderr is null"}),i.on("error",T=>{_(T)}),i.on("close",T=>{let L;!D&&(L=this.decodeData(o,a))&&s(L)?_(new Error(`command failed with error code ${T}: ${this.decodeData(o,a)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(i,a,v){const g=new y.StringDecoder(a);return i.on("data",_=>{v(null,g.write(_))}),g}collectData(i){const a=[];return i.on("data",v=>{a.push(v)}),a}decodeData(i,a){const v=new y.StringDecoder(a);return i.map(g=>v.write(g)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:a},v,g,_){g.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:v,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const D=o=>{const T=k.basename(o),L=k.dirname(o);let $=a[L];$||($=a[L]=[],D(L)),$.push({base:v,relativePath:o,basename:T,searchPath:this.getSearchPath(i,o)})};g.forEach(D)}matchDirectoryTree({rootEntries:i,pathToEntries:a},v,g){const _=this,D=this.folderExcludePatterns.get(v),o=this.filePattern;function T(L){_.directoriesWalked++;const $=E.hasSiblingFn(()=>L.map(W=>W.basename));for(let W=0,Q=L.length;W<Q;W++){const z=L[W],{relativePath:N,basename:H}=z;if(D.test(N,H,o!==H?$:void 0))continue;const F=a[N];if(F)T(F);else{if(_.filesWalked++,N===o)continue;_.matchFile(g,z)}if(_.isLimitHit)break}}T(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,a,v,g,_){const D=i.folder,o=E.hasSiblingFn(()=>v);this.parallel(v,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const $=a?[a,T].join(k.sep):T;if(this.folderExcludePatterns.get(i.folder.fsPath).test($,T,this.config.filePattern!==T?o:void 0))return L(null);const W=[D.fsPath,$].join(k.sep);R.lstat(W,(Q,z)=>{if(Q||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(W,z,(N,H)=>N||this.isCanceled||this.isLimitHit?L(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(W,z,(F,x)=>F||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?L(null):(this.walkedPaths[x]=!0,c.Promises.readdir(W).then(O=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,$,O,g,M=>L(M||null))},O=>{L(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&l.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(g,{base:D.fsPath,relativePath:$,searchPath:this.getSearchPath(i,$)}),L(null,void 0)))})},T=>{const L=T&&A.coalesce(T);return _(L&&L.length>0?L[0]:void 0)})}matchFile(i,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(a))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return S.isFilePatternMatch(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,a,v){return a.isSymbolicLink()?R.stat(i,v):v(null,a)}realPathIfNeeded(i,a,v){return a.isSymbolicLink()?R.realpath(i,(g,_)=>g?v(g):v(null,_)):v(null,i)}getSearchPath(i,a){return i.folderName?k.join(i.folderName,a):a}}e.FileWalker=u;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new u(i)}search(i,a,v){this.walker.walk(this.folderQueries,this.extraFiles,i,a,(g,_)=>{v(g,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class t{constructor(i,a){this.expression=i,this.root=a,this.init(i)}init(i){let a,v;Object.keys(i).filter(g=>i[g]).forEach(g=>{k.isAbsolute(g)?(a=a||E.getEmptyExpression(),a[g]=i[g]):(v=v||E.getEmptyExpression(),v[g]=i[g])}),this.absoluteParsedExpr=a&&E.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=v&&E.parse(v,{trimForExclusions:!0})}test(i,a,v){return this.relativeParsedExpr&&this.relativeParsedExpr(i,a,v)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),a,v)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...E.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...E.getPathTerms(this.relativeParsedExpr)),i}}function s(r){const i=r.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return f.uppercaseFirstLetter(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=s}),define(fe[131],me([0,1,38,286,100,17,68,30,9,8,2,31,64,287,271,89]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(D){this.outputChannel=D}provideTextSearchResults(D,o,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise(($,W)=>{L.onCancellationRequested(()=>M());const Q=s(D,o),z=o.folder.fsPath,N=Q.map(ye=>ye.match(/^-/)?ye:`'${ye}'`).join(" ");this.outputChannel.appendLine(`${S} ${N}
 - cwd: ${z}`);let H=p.spawn(S,Q,{cwd:z});H.on("error",ye=>{console.error(ye),this.outputChannel.appendLine("Error: "+(ye&&ye.message)),W(P.serializeSearchError(new P.SearchError(ye&&ye.message,P.SearchErrorCode.rgProcessError)))});let F=!1;const x=new u(o.maxResults,z,o.previewOptions);x.on("result",ye=>{F=!0,V="",T.report(ye)});let O=!1;const M=()=>{O=!0,H&&H.kill(),x&&x.cancel()};let B=!1;x.on("hitLimit",()=>{B=!0,M()});let V="";H.stdout.on("data",ye=>{x.handleData(ye),F||(V+=ye)});let ee=!1;H.stdout.once("data",()=>ee=!0);let de="";H.stderr.on("data",ye=>{const Fe=ye.toString();this.outputChannel.appendLine(Fe),de+=Fe}),H.on("close",()=>{if(this.outputChannel.appendLine(ee?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),V&&this.outputChannel.appendLine(`Got data without result: ${V}`),this.outputChannel.appendLine(""),O)$({limitHit:B});else{x.flush(),H=null;let ye;de&&!ee&&(ye=b(de))?W(P.serializeSearchError(new P.SearchError(ye.message,ye.code))):$({limitHit:B})}})})}}e.RipgrepTextSearchEngine=w;function b(_){const D=_.split(`
`),o=D[0].trim();if(D.some(L=>L.startsWith("regex parse error")))return new P.SearchError(h(D),P.SearchErrorCode.regexParseError);const T=o.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(o,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function h(_){const D=["Regex parse error"],o=_.filter(T=>T.startsWith("PCRE2:"));if(o.length>=1){const T=o[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];D.push(":"+L)}}return D.join("")}e.buildRegexParseError=h;class u extends R.EventEmitter{constructor(D,o,T){super();this.maxResults=D,this.rootFolder=o,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(D,o){return super.on(D,o),this}handleData(D){if(this.isDone)return;const o=typeof D=="string"?D:this.stringDecoder.write(D);this.handleDecodedData(o)}handleDecodedData(D){let o=D.indexOf(`
`);const T=this.remainder+D;if(o>=0)o+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;o>=0;)this.handleLine(T.substring(L,o).trim()),L=o+1,o=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(D){if(this.isDone||!D)return;let o;try{o=JSON.parse(D)}catch(T){throw new Error(`malformed line from rg: ${D}`)}if(o.type==="match"){const T=m(o.data.path),L=n.URI.file(E.join(this.rootFolder,T)),$=this.createTextSearchMatch(o.data,L);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const T=m(o.data.path),L=n.URI.file(E.join(this.rootFolder,T));this.createTextSearchContext(o.data,L).forEach(W=>this.onResult(W))}}createTextSearchMatch(D,o){const T=D.line_number-1,L=m(D.lines),$=Buffer.from(L);let W=0,Q=0,z=T;D.submatches.length===0&&D.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=y.coalesce(D.submatches.map((H,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=m(H.match),O=$.slice(W,H.start).toString().length,M=Q+O,B=t(x),V=z,ee=B.numLines+V,de=B.numLines>0?B.lastLineLength:B.lastLineLength+M;return W=H.end,Q=de,z=ee,new d.Range(V,M,ee,de)}));return c.createTextSearchResult(o,L,N,this.previewOptions)}createTextSearchContext(D,o){const T=m(D.lines),L=D.line_number;return T.replace(/\r?\n$/,"").split(`
`).map(($,W)=>({text:$,uri:o,lineNumber:L+W}))}onResult(D){this.emit("result",D)}}e.RipgrepParser=u;function m(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const D=/\n/g;let o=0,T=-1,L;for(;L=D.exec(_);)o++,T=L.index;const $=T>=0?_.length-T-1:_.length;return{numLines:o,lastLineLength:$}}function s(_,D){const o=["--hidden"];o.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=A.groupBy(D.includes,W=>W.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const W=new Set;L.forEach(Q=>{W.add(Q)}),o.push("-g","!*"),W.forEach(Q=>{r(Q).map(c.anchorGlob).forEach(z=>{o.push("-g",z)})})}T&&T.length&&T.forEach(W=>{o.push("-g",W)}),D.excludes.map(c.anchorGlob).forEach(W=>o.push("-g",`!${W}`)),D.maxFileSize&&o.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),D.followSymlinks&&o.push("--follow"),D.encoding&&D.encoding!=="utf8"&&o.push("--encoding",D.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=C.escapeRegExpCharacters(_.pattern),_.isRegExp=!0),D.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),_.isRegExp&&(_.pattern=i(_.pattern),o.push("--auto-hybrid-regex"));let $;if(_.isWordMatch){const Q=C.createRegExp(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",Q)}else if(_.isRegExp){let W=v(_.pattern);W=g(W),o.push("--regexp",W)}else $=_.pattern,o.push("--fixed-strings");return o.push("--no-config"),D.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),_.isMultiline&&o.push("--multiline"),D.beforeContext&&o.push("--before-context",D.beforeContext+""),D.afterContext&&o.push("--after-context",D.afterContext+""),o.push("--"),$&&o.push($),o.push("."),o}function r(_){const D=I.splitGlobAware(_,"/");return D.map((o,T)=>D.slice(0,T+1).join("/"))}e.spreadGlobComponents=r;function i(_){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(D);)_=_.replace(D,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(o);)_=_.replace(o,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=i;const a=_=>_.type==="Assertion"&&_.kind==="lookbehind";function v(_){let D;try{D=new f.RegExpParser().parsePattern(_)}catch{return _}let o="",T=0;const L=(Q,z,N)=>{o+=_.slice(T,Q)+N,T=z},$=[];return new f.RegExpVisitor({onCharacterEnter(Q){if(Q.raw!=="\\n")return;const z=$[0];if(!z)L(Q.start,Q.end,"\\r?\\n");else if(!$.some(a))if(z.type==="CharacterClass")if(z.negate){const N=_.slice(z.start+2,Q.start)+_.slice(Q.end,z.end-1);L(z.start,z.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=_.slice(z.start+1,Q.start)+_.slice(Q.end,z.end-1);L(z.start,z.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else z.type==="Quantifier"&&L(Q.start,Q.end,"(?:\\r?\\n)")},onQuantifierEnter(Q){$.unshift(Q)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(Q){$.unshift(Q)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(Q){$.unshift(Q)},onCharacterClassLeave(){$.shift()},onAssertionEnter(Q){a(Q)&&$.push(Q)},onAssertionLeave(Q){$[0]===Q&&$.shift()}}).visit(D),o+=_.slice(T),o}e.fixRegexNewline=v;function g(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=g}),define(fe[273],me([0,1,21,131,114,10]),function(X,e,p,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,n,P,d){const f=new R.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===y.Schemas.userData){const l={...n,folder:n.folder.with({scheme:y.Schemas.file})},c=new k.Progress(S=>P.report({...S,uri:S.uri.with({scheme:n.folder.scheme})}));return this.withToken(d,S=>f.provideTextSearchResults(C,l,c,S))}else return this.withToken(d,l=>f.provideTextSearchResults(C,n,P,l))}async withToken(C,n){const P=I(C);this.inProgress.add(P);const d=await n(P.token);return this.inProgress.delete(P),d}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=A;function I(E){const C=new p.CancellationTokenSource;return E.onCancellationRequested(()=>C.cancel()),C}}),define(fe[274],me([0,1,28,131,130]),function(X,e,p,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(E){this.query=E}search(E,C,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(f){n({message:f})}},d=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(P),p);return new Promise((f,l)=>d.search(c=>{C(c.map(A))},E).then(c=>f({limitHit:c.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=y;function A(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((E,C)=>{if(C.ranges){const n=C;return E+(Array.isArray(n.ranges)?n.ranges.length:1)}else return E+1},0)}}}),define(fe[275],me([0,1,57,288,17,18,15,3,97,9,43,2,41,31,272,274]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(p);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let s;const r=h(t),i=new I.Emitter({onFirstListenerDidAdd:()=>{s=y.createCancelablePromise(a=>this.doFileSearchWithEngine(l.Engine,r,v=>i.fire(v),a)),s.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return i.event}textSearch(t){let s;const r=h(t),i=new I.Emitter({onFirstListenerDidAdd:()=>{s=y.createCancelablePromise(a=>this.ripgrepTextSearch(r,v=>i.fire(v),a)),s.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return i.event}ripgrepTextSearch(t,s,r){return t.maxFileSize=d.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new c.TextSearchEngineAdapter(t).search(r,s,s)}doFileSearch(t,s,r){return this.doFileSearchWithEngine(l.Engine,t,s,r)}doFileSearchWithEngine(t,s,r,i,a=S.BATCH_SIZE){let v=0;const g=D=>{Array.isArray(D)?(v+=D.length,r(D.map(o=>this.rawMatchToSearchItem(o)))):D.relativePath?(v++,r(this.rawMatchToSearchItem(D))):r(D)};if(s.sortByScore){let D=this.trySortedSearchFromCache(s,g,i);if(!D){const o=s.maxResults?Object.assign({},s,{maxResults:null}):s,T=new t(o);D=this.doSortedSearch(T,s,r,g,i)}return new Promise((o,T)=>{D.then(([L,$])=>{const W=$.map(Q=>this.rawMatchToSearchItem(Q));this.sendProgress(W,r,a),o(L)},T)})}const _=new t(s);return this.doSearch(_,g,a,i).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:"searchProcess",fromCache:!1,resultCount:v,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?C.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,r,i,a){const v=new I.Emitter;let g=y.createCancelablePromise(D=>{let o=[];const T=L=>{Array.isArray(L)?o=L:(i(L),v.fire(L))};return this.doSearch(t,T,-1,D).then(L=>[L,o])}),_;if(s.cacheKey){_=this.getOrCreateCache(s.cacheKey);const D={promise:g,event:v.event,resolved:!1};_.resultsToSearchCache[s.filePattern||""]=D,g.then(()=>{D.resolved=!0},o=>{delete _.resultsToSearchCache[s.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([D,o])=>{const T=_?_.scorerCache:Object.create(null),L=(typeof s.maxResults!="number"||s.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(s,o,T,a).then($=>{const W=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:W,fromCache:!1,type:"searchProcess",workspaceFolderCount:s.folderQueries.length,resultCount:$.length},messages:D.messages,limitHit:D.limitHit||typeof s.maxResults=="number"&&o.length>s.maxResults},$]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new w)}trySortedSearchFromCache(t,s,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const a=this.getResultsFromCache(i,t.filePattern||"",s,r);if(a)return a.then(([v,g,_])=>{const D=n.StopWatch.create(!1);return this.sortResults(t,g,i.scorerCache,r).then(o=>{const T=D.elapsed(),L={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:g.length,sortingTime:T};return[{type:"success",limitHit:v.limitHit||typeof t.maxResults=="number"&&g.length>t.maxResults,stats:L},o]})})}sortResults(t,s,r,i){const a=E.prepareQuery(t.filePattern||""),v=(_,D)=>E.compareItemsByFuzzyScore(_,D,a,!0,b,r),g=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(s,v,g,1e4,i)}sendProgress(t,s,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)s(t.slice(i,i+r));else s(t)}getResultsFromCache(t,s,r,i){const a=n.StopWatch.create(!1),v=s.indexOf(C.sep)>=0;let g;for(const T in t.resultsToSearchCache)if(s.startsWith(T)){if(v&&T.indexOf(C.sep)<0&&T!=="")continue;const L=t.resultsToSearchCache[T];g={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!g)return null;const _=a.elapsed(),D=n.StopWatch.create(!1),o=g.event(r);return i&&i.onCancellationRequested(()=>{o.dispose()}),g.promise.then(([T,L])=>{if(i&&i.isCancellationRequested)throw A.canceled();const $=[],W=E.prepareQuery(s).normalizedLowercase;for(const Q of L)!f.isFilePatternMatch(Q,W)||$.push(Q);return[T,$,{cacheWasResolved:g.resolved,cacheLookupTime:_,cacheFilterTime:D.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,s,r,i){return new Promise((a,v)=>{let g=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(r?(g.push(_),r>0&&g.length>=r&&(s(g),g=[])):s(_))},_=>{s(_)},(_,D)=>{g.length&&s(g),_?v(_):a(D)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,r){return t.then(s,r)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(m){return C.basename(m.relativePath)}getItemDescription(m){return C.dirname(m.relativePath)}getItemPath(m){return m.relativePath}};function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(u),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>P.URI.revive(t))}}function u(m){return{...m,folder:P.URI.revive(m.folder)}}}),define(fe[276],me([0,1,6,2,28,12,31,275,273,89,13,60,27,67,10,130]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends f.ExtHostSearch{constructor(b,h,u,m){super(b,u,m);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new E.RipgrepSearchProvider(t)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new E.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(l.Schemas.file,new I.SearchService)}registerInternalFileSearchProvider(b,h){const u=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(b)),p.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(b,h,u,m){const t=f.reviveQuery(u);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,h,t,m):super.$provideFileSearchResults(b,h,u,m)}doInternalFileSearch(b,h,u,m){const t=s=>{if(A.isSerializedFileMatch(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(b,h,s.map(r=>R.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,m)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,h){return new c.NativeTextSearchManager(b,h)}};S=ze([We(0,n.IExtHostRpcService),We(1,d.IExtHostInitDataService),We(2,P.IURITransformerService),We(3,y.ILogService)],S),e.NativeExtHostSearch=S}),define(fe[132],me([0,1,289,121,290,3,103,9,101,32,6,23,104,15,11]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class c{constructor(g){this.socket=g,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;f.onUnexpectedError(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const _=D=>g(P.VSBuffer.wrap(D));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(g){const _=D=>{g({type:0,hadError:D,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,_=>{if(_){if(_.code==="EPIPE")return;f.onUnexpectedError(_)}})}catch(_){if(_.code==="EPIPE")return;f.onUnexpectedError(_)}}end(){this.socket.end()}drain(){return new Promise((g,_)=>{if(this.socket.bufferSize===0){g();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),g()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=c;var S;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(w||(w={}));class b extends n.Disposable{constructor(g,_,D,o){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=o,_?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),f.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),f.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new d.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(P.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,_){let D=2;g.byteLength<126?D+=0:g.byteLength<2**16?D+=2:D+=8;const o=P.VSBuffer.alloc(D);if(_?o.writeUInt8(194,0):o.writeUInt8(130,0),g.byteLength<126)o.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){o.writeUInt8(126,1);let T=1;o.writeUInt8(g.byteLength>>>8&255,++T),o.writeUInt8(g.byteLength>>>0&255,++T)}else{o.writeUInt8(127,1);let T=1;o.writeUInt8(0,++T),o.writeUInt8(0,++T),o.writeUInt8(0,++T),o.writeUInt8(0,++T),o.writeUInt8(g.byteLength>>>24&255,++T),o.writeUInt8(g.byteLength>>>16&255,++T),o.writeUInt8(g.byteLength>>>8&255,++T),o.writeUInt8(g.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=o.byteLength+g.byteLength,this.socket.write(P.VSBuffer.concat([o,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),o=(_.readUInt8(0)&128)>>>7,T=_.readUInt8(1),L=(T&128)>>>7,$=T&127;this._state.state=2,this._state.readLen=2+(L?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),D=_.readUInt8(1),o=(D&128)>>>7;let T=D&127,L=1;T===126?T=_.readUInt8(++L)*2**8+_.readUInt8(++L):T===127&&(T=_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*2**24+_.readUInt8(++L)*2**16+_.readUInt8(++L)*2**8+_.readUInt8(++L));let $=0;o&&($=_.readUInt8(++L)*2**24+_.readUInt8(++L)*2**16+_.readUInt8(++L)*2**8+_.readUInt8(++L)),this._state.state=3,this._state.readLen=T,this._state.mask=$}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);h(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(P.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function h(v,g){if(g===0)return;let _=v.byteLength>>>2;for(let W=0;W<_;W++){const Q=v.readUInt32BE(W*4);v.writeUInt32BE(Q^g,W*4)}let D=_*4,o=v.byteLength-D;const T=g>>>24&255,L=g>>>16&255,$=g>>>8&255;o>=1&&v.writeUInt8(v.readUInt8(D)^T,D),o>=2&&v.writeUInt8(v.readUInt8(D+1)^L,D+1),o>=3&&v.writeUInt8(v.readUInt8(D+2)^$,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function m(){const v=C.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let g;return e.XDG_RUNTIME_DIR?g=I.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):g=I.join(E.tmpdir(),`vscode-ipc-${v}.sock`),s(g),g}e.createRandomIPCHandle=m;function t(v,g,_){const D=p.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${_}-${g}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=I.join(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${_}-${g}.sock`):o=I.join(v,`${_}-${g}.sock`),s(o),o}e.createStaticIPCHandle=t;function s(v){const g=u[l.platform];typeof g=="number"&&v.length>=g&&console.warn(`WARNING: IPC handle "${v}" is longer than ${g} chars, try a shorter --user-data-dir`)}class r extends A.IPCServer{constructor(g){super(r.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const _=y.Event.fromNodeEventEmitter(g,"connection");return y.Event.map(_,D=>({protocol:new d.Protocol(new c(D)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(v){return new Promise((g,_)=>{const D=R.createServer();D.on("error",_),D.listen(v,()=>{D.removeListener("error",_),g(new r(D))})})}e.serve=i;function a(v,g){return new Promise((_,D)=>{const o=R.createConnection(v,()=>{o.removeListener("error",D),_(d.Client.fromSocket(new c(o),g))});o.once("error",D)})}e.connect=a}),define(fe[277],me([0,1,132,269,57,49,2,192,12]),function(X,e,p,R,k,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(d,f,l){this._commands=d,this.logService=f,this._ipcHandlePath=l,this._server=R.createServer((c,S)=>this.onRequest(c,S)),this.setup().catch(c=>(f.error(c),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,f){const l=[];d.setEncoding("utf8"),d.on("data",c=>l.push(c)),d.on("end",()=>{const c=JSON.parse(l.join(""));switch(c.type){case"open":this.open(c,f);break;case"openExternal":this.openExternal(c,f);break;case"status":this.getStatus(c,f);break;case"extensionManagement":this.manageExtensions(c,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${c.type}`,S=>{S&&this.logService.error(S)}),f.end();break}})}open(d,f){let{fileURIs:l,folderURIs:c,forceNewWindow:S,diffMode:w,addMode:b,forceReuseWindow:h,gotoLineMode:u,waitMarkerFilePath:m}=d;const t=[];if(Array.isArray(c))for(const s of c)try{t.push({folderUri:A.URI.parse(s)})}catch(r){}if(Array.isArray(l))for(const s of l)try{I.hasWorkspaceFileExtension(s)?t.push({workspaceUri:A.URI.parse(s)}):t.push({fileUri:A.URI.parse(s)})}catch(r){}if(t.length){const s=m?A.URI.file(m):void 0,i={forceNewWindow:S,diffMode:w,addMode:b,gotoLineMode:u,forceReuseWindow:h,preferNewWindow:!h&&!s&&!b,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}f.writeHead(200),f.end()}async openExternal(d,f){for(const l of d.uris){const c=A.URI.parse(l),S=c.scheme==="file"?c:l;await this._commands.executeCommand("_remoteCLI.openExternal",S)}f.writeHead(200),f.end()}async manageExtensions(d,f){try{const l=w=>w?.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),c={list:d.list,install:l(d.install),uninstall:l(d.uninstall),force:d.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",c);f.writeHead(200),f.write(S)}catch(l){f.writeHead(500),f.write(String(l),c=>{c&&this.logService.error(c)})}f.end()}async getStatus(d,f){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(l),f.end()}catch(l){f.writeHead(500),f.write(String(l),c=>{c&&this.logService.error(c)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let n=class extends C{constructor(d,f){super(d,f,p.createRandomIPCHandle())}};n=ze([We(0,y.IExtHostCommands),We(1,E.ILogService)],n),e.CLIServer=n}),define(fe[278],me([0,1,66,265,260,5,268,39,251,2,10,7,277,102]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends k.RequireInterceptor{_installInterceptor(){const w=this,b=X.__$__nodeRequire("module"),h=b._load;b._load=function(m,t,s){for(let r of w._alternatives){let i=r(m);if(i){m=i;break}}return w._factories.has(m)?w._factories.get(m).load(m,C.URI.file(f.realpathSync(t.filename)),r=>h.apply(this,[r,t,s])):h.apply(this,arguments)}}}class c extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(d.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,w,this._registry).install(),p.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const u=process.send,m=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(m.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,h){if(b.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let u=null;h.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&p.mark(`code/extHost/willLoadExtensionCode/${w.value}`),u=X.__$__nodeRequire(b.fsPath)}catch(m){return Promise.reject(m)}finally{w&&p.mark(`code/extHost/didLoadExtensionCode/${w.value}`),h.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const h=w[b];h===null?delete process.env[b]:process.env[b]=h}}}e.ExtHostExtensionService=c}),define(fe[279],me([0,1,76,252,253,262,261,276,278,220,254,50,39,62,67,65,33,48,12]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(d.IExtHostExtensionService,E.ExtHostExtensionService),p.registerSingleton(b.ILogService,C.ExtHostLogService),p.registerSingleton(P.IExtHostDebugService,A.ExtHostDebugService),p.registerSingleton(f.IExtHostOutputService,R.ExtHostOutputService2),p.registerSingleton(l.IExtHostSearch,I.NativeExtHostSearch),p.registerSingleton(c.IExtHostTask,y.ExtHostTask),p.registerSingleton(S.IExtHostTerminalService,k.ExtHostTerminalService),p.registerSingleton(w.IExtHostTunnelService,n.ExtHostTunnelService)}),define(fe[280],me([0,1,121,291,66,15,104,132,186,218,263,23,99,28,102,18,266,279]),function(X,e,p,R,k,y,A,I,E,C,n,P,d,f,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const S=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const r=X.__$__nodeRequire("module"),i=r._load;r._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const w=process.exit.bind(process);function b(r){process.exit=function(i){if(r)w(i);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let h=function(r){w()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((r,i)=>{let a=null,v=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const g=108e5,_=3e5,D=new c.RunOnceScheduler(()=>h("renderer disconnected for too long (1)"),g),o=new c.RunOnceScheduler(()=>h("renderer disconnected for too long (2)"),_);process.on("message",(L,$)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const W=P.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let Q;if(L.skipWebSocketFrames)Q=new I.NodeSocket($);else{const z=P.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));Q=new I.WebSocketNodeSocket(new I.NodeSocket($),L.permessageDeflate,z,!1)}a?(D.cancel(),o.cancel(),a.beginAcceptReconnection(Q,W),a.endAcceptReconnection()):(clearTimeout(v),a=new A.PersistentProtocol(Q,W),a.onDidDispose(()=>h("renderer disconnected")),r(a),a.onSocketClose(()=>{D.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(o.isScheduled())return;D.isScheduled()&&o.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const r=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,a)=>{const v=p.createConnection(r,()=>{v.removeListener("error",a),i(new A.PersistentProtocol(new I.NodeSocket(v)))});v.once("error",a),v.on("close",()=>{h("renderer closed the socket")})})}}async function m(){const r=await u();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(i=>{C.isMessageOfType(i,2)?(this._terminating=!0,h("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||r.send(i)}drain(){return r.drain()}}}function t(r){return new Promise(i=>{const a=r.onMessage(v=>{a.dispose();const g=JSON.parse(v.toString()),_=g.commit,D=E.default.commit;_&&D&&_!==D&&w(55);const o=[];process.on("unhandledRejection",($,W)=>{o.push(W),setTimeout(()=>{const Q=o.indexOf(W);Q>=0&&W.catch(z=>{o.splice(Q,1),y.isPromiseCanceledError(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),y.onUnexpectedError($))})},1e3)}),process.on("rejectionHandled",$=>{const W=o.indexOf($);W>=0&&o.splice(W,1)}),process.on("uncaughtException",function($){y.onUnexpectedError($)});let T=0;setInterval(function(){try{process.kill(g.parentPid,0),T=0}catch($){$&&$.code==="EPERM"?(T++,T>=3&&h(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):h(`parent process ${g.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let L;try{L=X.__$__nodeRequire("native-watchdog"),L.start(g.parentPid)}catch($){y.onUnexpectedError($)}r.send(C.createMessageOfType(0)),i({protocol:r,initData:g})});r.send(C.createMessageOfType(1))})}async function s(){k.mark("code/extHost/willConnectToRenderer");const r=await m();k.mark("code/extHost/didConnectToRenderer");const i=await t(r);k.mark("code/extHost/didWaitForInitData");const{initData:a}=i;b(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const v=new class{exit(o){w(o)}exists(o){return f.Promises.exists(o)}realpath(o){return l.realpath(o)}};let g=null;if(a.remote.authority&&S.uriTransformerPath)try{const o=X.__$__nodeRequire(S.uriTransformerPath)(a.remote.authority);g=new d.URITransformer(o)}catch(D){console.error(D)}const _=new n.ExtensionHostMain(i.protocol,a,v,g);h=D=>_.terminate(D)}e.startExtensionHostProcess=s}),define(fe[292],me([0,1,280]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bfac07cd0e374c433c2c06d6999dabf9cf9d5d29/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
